pro Combine_Archive_TC4_steve_Gains_files_of_61bins_HorV
    ;this program reads in each small -
    ;2DS TC4 1Hz archived data, and make the big file to archive for Matlab program
    ; this program assume you have two data files to concatenate. if not,
    ;                       make a afke file first by copying.

    missing_data=[9.999*1E+30]
    missing_data3=[fltarr(3)+9.999*1E+30]
    missing_data10=[fltarr(10)+9.999*1E+30]
    ;select H or V channel.
    HorV =moqixu_textBox(title='Please type H or V to select your combined Channel"s',label='H or V')
    HorV= strtrim(HorV,2)

    ;get all smaller data files.
    if HorV eq 'H' then begin
        filenames = dialog_pickfile(title='pls pick a Dir & Click a file',filter='H_archive_2ds_PSD*M*.txt',Get_path=pathnm)
        filter_str='H_Archive_2DS_PSD*.txt'
        get_all_data_filenames,filter_str,pathnm,filenames,file_count
    endif

    if HorV eq 'V' then begin
        filenames = dialog_pickfile(title='pls pick a Dir & Click a file',filter='V_archive_2ds_PSD*M*.txt',Get_path=pathnm)
        filter_str='V_Archive_2DS_PSD*.txt'
        get_all_data_filenames,filter_str,pathnm,filenames,file_count
    endif

    ; open the first data file; for appending.
    filename=filenames(0)
    read_in_2ds_data_from_1Hz_archive_61bins,TDsData,pathnm,filename
    ;assign TDSdata.irregular to be adding 0.5 for first point and last point.
    ; which is done in the read_in_2ds_from_1Hz_archive file.

    last_second  =max(TDSdata.seconds); get the last seconds of the first file.
    first_time   =min(TDSdata.seconds)

    todays_date=strsplit(systime(),' ',/extract)
    archive_date=todays_date(1)+' '+todays_date(2)+' '+todays_date(4)
    if HorV eq 'H' then begin
        outfilename=pathnm+'TD2007mmddH_DC8_GainsF.txt'
        Logfilename=pathnm+'TD2007mmddH_DC8_GainsF_combine_log.txt'
    endif

    if HorV eq 'V' then begin
        outfilename=pathnm+'TD2007mmddV_DC8_GainsF.txt'
        Logfilename=pathnm+'TD2007mmddV_DC8_GainsF_combine_log.txt'
    endif

    openw,1,outfilename
    openw,9,Logfilename

    mmm=n_elements(TDSdata.seconds)
    ;*************************************************************************
    ; do the following according to Brad request ***********************
    ; 1) when file1 ends at 5, 6, file2 starts at 5,6. chop file1's tail and file2's head.
    ; 2) when flie1 end at 6 and file2 starts at 6. archive the values
    ;     of the one that has greater extinction [also add 0.5 to irregularities
    ;     variable for this second].
    ; 3) when file1 end at 6, file2 starts at 7 , then, fine. but add 0.5 to
    ;    irregularities variable for the edge seconds].
    ; 4) when there is a gap between the files, archive -999s for the gap
    ;    [also add 0.5 to irregularities variable for the edge seconds].
    ; 5)  Finally when there are  more overlap than expected (2 seconds)
    ;     then stop the program and tell the user to send the case to you
    ;     and Brad. and use manual truncation method to do teh concatenation.
    ; To summary it, it is like this:
    ;          if a(0) eq b(0) then case1to5=1;  overlap 2 seconds only. a=[5,6],b=[5,6]
    ;          if a(1) eq b(0) then case1to5=2;  overlap 1 second only.  a=[5,6],b=[6,7]
    ;          if a(1)+1 eq b(0) then case1to5=3; only touch each other. a=[5,6],b=[7,8]
    ;          if b(0) gt  a(1)+1 then case1to5=4; there is a gap        a=[5,6],b=[8,9]
    ;          if b(0) le a(0)-1 then case1to5=5;  overlap too much.     a=[5,6],b=[4,5]
    ; note the the first and last points irregualer can alwasy be adding 0.5,it does not matters
    ; to the written archive file. If it is use, it should be added 0.5.
    if file_count eq 1 then begin

        my_message=[[' This is a rare case with only one file'],$
            [' We just rewrite it to be the same as then input file !']]
        rrr=dialog_message(my_message,/information)

        index1=0LL;    don't Truncate the first second
        index2=mmm-1LL; don't truncate last second mmm-1 and wait until later to see waht to do with it.
        write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
        close,1
        print,'Done rewriting steve gaines file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        printf,9,'Done rewriting steve gaines file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        close,9
        return
    endif
    ;***************** do the first files writing ***********************
    index1=1LL;    Truncate the first second
    index2=mmm-2LL; truncate last second mmm-1 and wait until later to see waht to do with it.
    write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
    ;***************************************************************************************

    kkk=1
    while kkk lt file_count do begin

        FileNameNext=filenames(kkk)
        get_next_files_starttime_and_endTime,fileNameNext,pathnm,startTimeNext,EndTimeNext,$
            TDsdata,TDsdataNext,case1to5,last2S, First2S
        print,'file_',kkk-1,'"s endTime    last 2 seconds are:', last2S(0), '   ',last2S(1)
        print,'file_',kkk,  '"s startTime first 2 seconds are:', First2S(0), '   ',First2S(1)
        printf,9,'File_',kkk-1,'"s endTime    last 2 seconds are:', last2S(0), '   ',last2S(1)
        printf,9,'File_',kkk,'"s startTime first 2 seconds are:', First2S(0), '   ',First2S(1)

        ;*****************************************************************************
        if case1to5 eq 1 then begin;kkk=1; finishing writing the first file's data.and begin writing
            index1=1LL;                ;nextfile's data.
            mmm=n_elements(TDSdataNext.seconds)
            index2=mmm-2LL
            write_data_to_archive_file_from_index1_to_index2,TDSDataNext,index1,index2
            print,'File',Kkk,'"s data points are written.--------xxxxxxx--------------------',$
                TDSdataNext(index1).seconds,'--',TDSdataNext(index2).seconds
        endif
        ;**************************************************************************************
        if case1to5 eq 2 then begin; there is overlap of only 1 second's data. compare which one has
            extinctionA= TDSdata(mmm-1LL).Extn;  ;the biggest extinction.
            extinctionB= TDsdataNext(0).Extn
            if ExtinctionB ge ExtinctionA then begin
                ;write NextFiles first point to but last point.
                index1=0
                index2=n_elements(TDSdataNext.seconds)-2LL
                write_data_to_archive_file_from_index1_to_index2,TDSDataNext,index1,index2
                print, 'file',kkk,'"s data points are written------xxxxxxxxx-----------------',$
                    TDSdataNext(index1).seconds,'--',TDSdataNext(index2).seconds
            endif else begin
                ; write This files' last point.
                index1=n_elements(TDSdata.seconds)-1LL
                index2=index1
                write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
                print,'file',kkk-1,'"s last point is written: ',TDSdata(index1).seconds
                index1=1
                index2=n_elements(TDSdataNext.seconds)-2LL
                write_data_to_archive_file_from_index1_to_index2,TDSDataNext,index1,index2
                print,'file',kkk,'"s data  points are writen-------xxxxxxxxxxxxxx---------------',$
                    TDSdataNext(index1).seconds,'--',TDSdataNext(index2).seconds
            endelse
        endif
        ;**************************************************************************************

        if case1to5 eq 3 then begin;   two files just touch each other.
            ;write this files last point.
            index1=n_elements(TDSdata.seconds)-1LL
            index2=index1
            write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
            print,'file',kkk-1,'"s last point is written',TDSdata(index1).seconds
            index1=0
            index2=n_elements(TDSdataNext.seconds)-2LL
            write_data_to_archive_file_from_index1_to_index2,TDSDataNext,index1,index2
            print,'file',kkk,'"s data points are writen-----xxxxxxxxxxxxxxxxx--------------- ',$
                TDSdataNext(index1).seconds,'--',TDSdataNext(index2).seconds
        endif
        ;**************************************************************************************

        if case1to5 eq 4 then begin;  there is gap between two files.
            ;1. write this files last point.
            ;2. write missing data
            ;3  write next files point 0 to near last point.
            index1=n_elements(TDSdata.seconds)-1LL
            index2=index1
            write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
            print,'file',kkk-1,'"s last point is written',TDSdata.seconds
            time1=TDSdata(index1).secondsA+1LL
            time2=min(TDSdataNext.seconds)-1LL
            write_missing_data_from_time1_to_time2,time1,time2

            index1=0
            index2=n_elements(TDSdataNext.seconds)-2LL
            write_data_to_archive_file_from_index1_to_index2,TDSDataNext,index1,index2
            print,'file',kkk,'"s  data points are writen -------xxxxxxxxxxxxxxx---------------',$
                TDSdataNext(index1).seconds,'--',TDSdataNext(index2).seconds
        endif
        ;**************************************************************************************

        if case1to5 eq 5 then begin
            print, 'Two files overlap too much. Manually delete some parts on either file,'
            print, 'and start again, or report this to Qixu Mo and Brad Baker !!!!'
            printf,9, 'Two files overlap too much. Manually delete some parts on either file,'
            printf,9, 'and start again, or report this to Qixu Mo and Brad Baker !!!!'
            ;stop
        endif
        ;***************************************************************
        TDSdata=TDSdataNext;  update the data and start again
        kkk=kkk+1
    endwhile
    close,1
    print,'Done rewriting steve gaines file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    printf,9,'Done rewriting steve gaines file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    close,9
    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of combine_Rico_archive_files_of_61bins
;**********************************************************************************************

;*********************************************************************************************
pro write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2

    for i=index1,index2 do begin; Truncate the first second's data always. added on Otc 11, 2007.
        this_line_data=TDSdata(i);   and truncate last seconds data first. later to determine if it will be
        Seconds=This_line_data.seconds;  or not.
        Conc=    This_line_data.Hconc
        extn=    This_line_data.Hextn
        iwc =    This_line_data.HIWC
        line1=[This_line_data.Hbin1,This_line_data.Hbin2,This_line_data.Hbin3,This_line_data.Hbin4,This_line_data.Hbin5,$
            This_line_data.Hbin6,This_line_data.Hbin7,This_line_data.Hbin8,This_line_data.Hbin9,This_line_data.Hbin10]

        line2=[This_line_data.Hbin11,This_line_data.Hbin12,This_line_data.Hbin13,This_line_data.Hbin14,This_line_data.Hbin15,$
            This_line_data.Hbin16,This_line_data.Hbin17,This_line_data.Hbin18,This_line_data.Hbin19,This_line_data.Hbin20]

        line3=[This_line_data.Hbin21,This_line_data.Hbin22,This_line_data.Hbin23,This_line_data.Hbin24,This_line_data.Hbin25,$
            This_line_data.Hbin26,This_line_data.Hbin27,This_line_data.Hbin28,This_line_data.Hbin29,This_line_data.Hbin30]

        line4=[This_line_data.Hbin31,This_line_data.Hbin32,This_line_data.Hbin33,This_line_data.Hbin34,This_line_data.Hbin35,$
            This_line_data.Hbin36,This_line_data.Hbin37,This_line_data.Hbin38,This_line_data.Hbin39,This_line_data.Hbin40]

        line5=[This_line_data.Hbin41,This_line_data.Hbin42,This_line_data.Hbin43,This_line_data.Hbin44,This_line_data.Hbin45,$
            This_line_data.Hbin46,This_line_data.Hbin47,This_line_data.Hbin48,This_line_data.Hbin49,This_line_data.Hbin50]

        line6=[This_line_data.Hbin51,This_line_data.Hbin52,This_line_data.Hbin53,This_line_data.Hbin54,This_line_data.Hbin55,$
            This_line_data.Hbin56,This_line_data.Hbin57,This_line_data.Hbin58,This_line_data.Hbin59,This_line_data.Hbin60]

        line7=[This_line_data.Hbin61]

        ;******************************************************************************************************************
        Eline1=[This_line_data.Hebin1,This_line_data.Hebin2,This_line_data.Hebin3,This_line_data.Hebin4,This_line_data.Hebin5,$
            This_line_data.Hebin6,This_line_data.Hebin7,This_line_data.Hebin8,This_line_data.Hebin9,This_line_data.Hebin10]

        Eline2=[This_line_data.Hebin11,This_line_data.Hebin12,This_line_data.Hebin13,This_line_data.Hebin14,This_line_data.Hebin15,$
            This_line_data.Hebin16,This_line_data.Hebin17,This_line_data.Hebin18,This_line_data.Hebin19,This_line_data.Hebin20]

        Eline3=[This_line_data.Hebin21,This_line_data.Hebin22,This_line_data.Hebin23,This_line_data.Hebin24,This_line_data.Hebin25,$
            This_line_data.Hebin26,This_line_data.Hebin27,This_line_data.Hebin28,This_line_data.Hebin29,This_line_data.Hebin30]

        Eline4=[This_line_data.Hebin31,This_line_data.Hebin32,This_line_data.Hebin33,This_line_data.Hebin34,This_line_data.Hebin35,$
            This_line_data.Hebin36,This_line_data.Hebin37,This_line_data.Hebin38,This_line_data.Hebin39,This_line_data.Hebin40]

        Eline5=[This_line_data.Hebin41,This_line_data.Hebin42,This_line_data.Hebin43,This_line_data.Hebin44,This_line_data.Hebin45,$
            This_line_data.Hebin46,This_line_data.Hebin47,This_line_data.Hebin48,This_line_data.Hebin49,This_line_data.Hebin50]

        Eline6=[This_line_data.Hebin51,This_line_data.Hebin52,This_line_data.Hebin53,This_line_data.Hebin54,This_line_data.Hebin55,$
            This_line_data.Hebin56,This_line_data.Hebin57,This_line_data.Hebin58,This_line_data.Hebin59,This_line_data.Hebin60]

        Eline7=[This_line_data.Hebin61]

        ;*****************************************************************************************************************
        Mline1=[This_line_data.Hmbin1,This_line_data.Hmbin2,This_line_data.Hmbin3,This_line_data.Hmbin4,This_line_data.Hmbin5,$
            This_line_data.Hmbin6,This_line_data.Hmbin7,This_line_data.Hmbin8,This_line_data.Hmbin9,This_line_data.Hmbin10]

        Mline2=[This_line_data.Hmbin11,This_line_data.Hmbin12,This_line_data.Hmbin13,This_line_data.Hmbin14,This_line_data.Hmbin15,$
            This_line_data.Hmbin16,This_line_data.Hmbin17,This_line_data.Hmbin18,This_line_data.Hmbin19,This_line_data.Hmbin20]

        Mline3=[This_line_data.Hmbin21,This_line_data.Hmbin22,This_line_data.Hmbin23,This_line_data.Hmbin24,This_line_data.Hmbin25,$
            This_line_data.Hmbin26,This_line_data.Hmbin27,This_line_data.Hmbin28,This_line_data.Hmbin29,This_line_data.Hmbin30]

        Mline4=[This_line_data.Hmbin31,This_line_data.Hmbin32,This_line_data.Hmbin33,This_line_data.Hmbin34,This_line_data.Hmbin35,$
            This_line_data.Hmbin36,This_line_data.Hmbin37,This_line_data.Hmbin38,This_line_data.Hmbin39,This_line_data.Hmbin40]

        Mline5=[This_line_data.Hmbin41,This_line_data.Hmbin42,This_line_data.Hmbin43,This_line_data.Hmbin44,This_line_data.Hmbin45,$
            This_line_data.Hmbin46,This_line_data.Hmbin47,This_line_data.Hmbin48,This_line_data.Hmbin49,This_line_data.Hmbin50]

        Mline6=[This_line_data.Hmbin51,This_line_data.Hmbin52,This_line_data.Hmbin53,This_line_data.Hmbin54,This_line_data.Hmbin55,$
            This_line_data.Hmbin56,This_line_data.Hmbin57,This_line_data.Hmbin58,This_line_data.Hmbin59,This_line_data.Hmbin60]

        Mline7=[This_line_data.Hmbin61]

        ;******************************************************************************************************************


        printf,1,format='(I5,1x,3(E11.3,1x))',seconds,conc,extn,iwc
        printf,1,format='(10(E10.3,1x))',line1
        printf,1,format='(10(E10.3,1x))',line2
        printf,1,format='(10(E10.3,1x))',line3
        printf,1,format='(10(E10.3,1x))',line4
        printf,1,format='(10(E10.3,1x))',line5
        printf,1,format='(11(E10.3,1x))',line6,line7

        printf,1,format='(10(E10.3,1x))',Eline1
        printf,1,format='(10(E10.3,1x))',Eline2
        printf,1,format='(10(E10.3,1x))',Eline3
        printf,1,format='(10(E10.3,1x))',Eline4
        printf,1,format='(10(E10.3,1x))',Eline5
        printf,1,format='(11(E10.3,1x))',Eline6,Eline7

        printf,1,format='(10(E10.3,1x))',Mline1
        printf,1,format='(10(E10.3,1x))',Mline2
        printf,1,format='(10(E10.3,1x))',Mline3
        printf,1,format='(10(E10.3,1x))',Mline4
        printf,1,format='(10(E10.3,1x))',Mline5
        printf,1,format='(11(E10.3,1x))',Mline6,Mline7
    endfor

end;write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
;*********************************************************************************************

pro write_missing_data_from_time1_to_time2, time1,time2
    missing_data=[9.999*1E+30]
    missing_data3=[fltarr(3)+9.999*1E+30]
    missing_data10=[fltarr(10)+9.999*1E+30]
    for i=time1,time2 do begin
        This_seconds=i
        printf,1,format='(I5,1x,3(E11.3,1x))',This_second,missing_data3
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10;line4
        printf,1,format='(10(E10.3,1x))',missing_data10;line5
        printf,1,format='(11(E10.3,1x))',missing_data10,missing_data;line6, line7

        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10;line4
        printf,1,format='(10(E10.3,1x))',missing_data10;line5
        printf,1,format='(11(E10.3,1x))',missing_data10,missing_data;Eline6, Eline7

        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10
        printf,1,format='(10(E10.3,1x))',missing_data10;line4
        printf,1,format='(10(E10.3,1x))',missing_data10;line5
        printf,1,format='(11(E10.3,1x))',missing_data10,missing_data;Mline6, Mline7
    endfor

    print,  'Filling_start_end_time: ',time1,'------',time2
    printf,9,'Filling_start_end_time: ',time1,'------',time2
end;write_missing_data_from_time1_to_time2, time1,time2
;**********************************************************************************************
pro read_in_2ds_data_from_1Hz_archive_61bins,TDsData,pathnm,filename
    ;filename=dialog_pickfile(filter='Archive_2DS_*Ns.txt',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-2)
    junk=strarr(2)
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,HtotN:0,HirrN:0.0,Hconc:0.0,Hextn:0.0,HIWC:0.0,H0t50:0.0,H50t0250:0.0,Hgt250:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
        Hbin33:0.0,Hbin34:0.0,Hbin35:0.0,Hbin36:0.0,Hbin37:0.0,Hbin38:0.0,Hbin39:0.0,Hbin40:0.0,$
        Hbin41:0.0,Hbin42:0.0,Hbin43:0.0,Hbin44:0.0,Hbin45:0.0,Hbin46:0.0,Hbin47:0.0,Hbin48:0.0,$
        Hbin49:0.0,Hbin50:0.0,Hbin51:0.0,Hbin52:0.0,Hbin53:0.0,Hbin54:0.0,Hbin55:0.0,Hbin56:0.0,$
        Hbin57:0.0,Hbin58:0.0,Hbin59:0.0,Hbin60:0.0,Hbin61:0.0,$

        Hebin1:0.0,Hebin2:0.0,Hebin3:0.0,Hebin4:0.0,Hebin5:0.0,Hebin6:0.0,Hebin7:0.0,Hebin8:0.0,$
        Hebin9:0.0,Hebin10:0.0,Hebin11:0.0,Hebin12:0.0,Hebin13:0.0,Hebin14:0.0,Hebin15:0.0,Hebin16:0.0,$
        Hebin17:0.0,Hebin18:0.0,Hebin19:0.0,Hebin20:0.0,Hebin21:0.0,Hebin22:0.0,Hebin23:0.0,Hebin24:0.0,$
        Hebin25:0.0,Hebin26:0.0,Hebin27:0.0,Hebin28:0.0,Hebin29:0.0,Hebin30:0.0,Hebin31:0.0,Hebin32:0.0,$
        Hebin33:0.0,Hebin34:0.0,Hebin35:0.0,Hebin36:0.0,Hebin37:0.0,Hebin38:0.0,Hebin39:0.0,Hebin40:0.0,$
        Hebin41:0.0,Hebin42:0.0,Hebin43:0.0,Hebin44:0.0,Hebin45:0.0,Hebin46:0.0,Hebin47:0.0,Hebin48:0.0,$
        Hebin49:0.0,Hebin50:0.0,Hebin51:0.0,Hebin52:0.0,Hebin53:0.0,Hebin54:0.0,Hebin55:0.0,Hebin56:0.0,$
        Hebin57:0.0,Hebin58:0.0,Hebin59:0.0,Hebin60:0.0,Hebin61:0.0,$

        Hmbin1:0.0,Hmbin2:0.0,Hmbin3:0.0,Hmbin4:0.0,Hmbin5:0.0,Hmbin6:0.0,Hmbin7:0.0,Hmbin8:0.0,$
        Hmbin9:0.0,Hmbin10:0.0,Hmbin11:0.0,Hmbin12:0.0,Hmbin13:0.0,Hmbin14:0.0,Hmbin15:0.0,Hmbin16:0.0,$
        Hmbin17:0.0,Hmbin18:0.0,Hmbin19:0.0,Hmbin20:0.0,Hmbin21:0.0,Hmbin22:0.0,Hmbin23:0.0,Hmbin24:0.0,$
        Hmbin25:0.0,Hmbin26:0.0,Hmbin27:0.0,Hmbin28:0.0,Hmbin29:0.0,Hmbin30:0.0,Hmbin31:0.0,Hmbin32:0.0,$
        Hmbin33:0.0,Hmbin34:0.0,Hmbin35:0.0,Hmbin36:0.0,Hmbin37:0.0,Hmbin38:0.0,Hmbin39:0.0,Hmbin40:0.0,$
        Hmbin41:0.0,Hmbin42:0.0,Hmbin43:0.0,Hmbin44:0.0,Hmbin45:0.0,Hmbin46:0.0,Hmbin47:0.0,Hmbin48:0.0,$
        Hmbin49:0.0,Hmbin50:0.0,Hmbin51:0.0,Hmbin52:0.0,Hmbin53:0.0,Hmbin54:0.0,Hmbin55:0.0,Hmbin56:0.0,$
        Hmbin57:0.0,Hmbin58:0.0,Hmbin59:0.0,Hmbin60:0.0,Hmbin61:0.0,$
        HM1bin24:0.0,HM1bin25:0.0,HM1bin26:0.0,$
        HM2cnt265:0.0,VM1gt315:0.0 $
        }

    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2

    ;assign teh last bin to be zero.
    TDSdata.Hbin61=fltarr(nnnseconds)
    TDSdata.Hebin61=fltarr(nnnseconds)
    TDSdata.Hmbin61=fltarr(nnnseconds)

    substrs=strsplit(filename,'\',/extract)
    filename=substrs(n_elements(substrs)-1)

end; end of read_in_2ds_data_from_1Hz_archive_61bins.

pro read_in_2ds_data_from_1Hz_archive,TDsData,pathnm,filename
    ;filename=dialog_pickfile(filter='Archive_2DS_*Ns.txt',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-3)
    junk=strarr(3)
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,HtotN:0.0,HtotNp:0.0,NwarnH:0.0,HirrN:0.0,Hconc:0.0,Hextn:0.0,HIWC:0.0,Hmnsz:0.0,Hsv:0.0,$
        VtotN:0.0,VtotNp:0.0,NwarnV:0.0,VirrN:0.0,Vconc:0.0,Vextn:0.0,VIWC:0.0,Vmnsz:0.0,Vsv:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Vbin1:0.0,Vbin2:0.0,Vbin3:0.0,Vbin4:0.0,Vbin5:0.0,Vbin6:0.0,Vbin7:0.0,Vbin8:0.0,$
        Vbin9:0.0,Vbin10:0.0,Vbin11:0.0,Vbin12:0.0,Vbin13:0.0,Vbin14:0.0,Vbin15:0.0,Vbin16:0.0,$
        Vbin17:0.0,Vbin18:0.0,Vbin19:0.0,Vbin20:0.0,Vbin21:0.0,Vbin22:0.0,Vbin23:0.0,Vbin24:0.0, $
        Hbin1G:0.0,Hbin2G:0.0,Hbin3G:0.0,Hbin4G:0.0,Hbin5G:0.0,Hbin6G:0.0,Hbin7G:0.0,Hbin8G:0.0,$
        Hbin9G:0.0,Hbin10G:0.0,Hbin11G:0.0,Hbin12G:0.0,Hbin13G:0.0,Hbin14G:0.0,Hbin15G:0.0,Hbin16G:0.0,$
        Hbin17G:0.0,Hbin18G:0.0,Hbin19G:0.0,Hbin20G:0.0,Hbin21G:0.0,Hbin22G:0.0,Hbin23G:0.0,Hbin24G:0.0,$
        Hbin1Gp:0.0,Hbin2Gp:0.0,Hbin3Gp:0.0,Hbin4Gp:0.0,Hbin5Gp:0.0,Hbin6Gp:0.0,Hbin7Gp:0.0,Hbin8Gp:0.0,$
        Hbin9Gp:0.0,Hbin10Gp:0.0,Hbin11Gp:0.0,Hbin12Gp:0.0,Hbin13Gp:0.0,Hbin14Gp:0.0,Hbin15Gp:0.0,Hbin16Gp:0.0,$
        Hbin17Gp:0.0,Hbin18Gp:0.0,Hbin19Gp:0.0,Hbin20Gp:0.0,Hbin21Gp:0.0,Hbin22Gp:0.0,Hbin23Gp:0.0,Hbin24Gp:0.0,$
        Vbin1G:0.0,Vbin2G:0.0,Vbin3G:0.0,Vbin4G:0.0,Vbin5G:0.0,Vbin6G:0.0,Vbin7G:0.0,Vbin8G:0.0,$
        Vbin9G:0.0,Vbin10G:0.0,Vbin11G:0.0,Vbin12G:0.0,Vbin13G:0.0,Vbin14G:0.0,Vbin15G:0.0,Vbin16G:0.0,$
        Vbin17G:0.0,Vbin18G:0.0,Vbin19G:0.0,Vbin20G:0.0,Vbin21G:0.0,Vbin22G:0.0,Vbin23G:0.0,Vbin24G:0.0,$
        Vbin1Gp:0.0,Vbin2Gp:0.0,Vbin3Gp:0.0,Vbin4Gp:0.0,Vbin5Gp:0.0,Vbin6Gp:0.0,Vbin7Gp:0.0,Vbin8Gp:0.0,$
        Vbin9Gp:0.0,Vbin10Gp:0.0,Vbin11Gp:0.0,Vbin12Gp:0.0,Vbin13Gp:0.0,Vbin14Gp:0.0,Vbin15Gp:0.0,Vbin16Gp:0.0,$
        Vbin17Gp:0.0,Vbin18Gp:0.0,Vbin19Gp:0.0,Vbin20Gp:0.0,Vbin21Gp:0.0,Vbin22Gp:0.0,Vbin23Gp:0.0,Vbin24Gp:0.0 $
        }

    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2
    substrs=strsplit(filename,'\',/extract)
    filename=substrs(n_elements(substrs)-1)

end; end of read_in_2ds_data_from_1Hz_archive.

pro Get_2ds_time1totime2_TMS_mean_psd,startseconds,endseconds,TDsdata,$
    time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts

nseconds=(endseconds-startseconds)

hypts=fltarr(24)
vypts=fltarr(24)
;bins edges and widths
nbins=24
nedges=2*nbins
xpts=dblarr(2*nbins)
ptr = 0
for i =0, 8  DO BEGIN
    xpts[ptr] = double((i+1)*10)
    xpts[ptr + 1] = double((i+2) * 10)
    ptr += 2
endfor
xpts[18:47]=[10,12,12,15,15,20,20,25,25,32,32,40,40,50,50,60,60,70,70,80,80,90,90,100,100,120,120,140,140,1001]*10
widths=xpts(1:47)-xpts(0:46)
indexw=where(widths ne 0.0)
width_f=widths(indexw)*1.0


;original data.
seconds=Tdsdata.seconds
index=where(seconds ge startseconds and seconds lt endseconds,contG)
if contG gt 0 then begin
    time=seconds(index)
    Hconc=TDsData(index).Hconc
    Hextn=TDsdata(index).Hextn
    HIWC =TDsdata(index).Hiwc
    Hmnsz=TDsdata(index).Hmnsz
    Hsv  =TDsdata(index).Hsv;    sample volumes of each second.
    Vconc=TDsData(index).Vconc
    Vextn=TDsdata(index).Vextn
    VIWC =TDsdata(index).Viwc
    Vmnsz=TDsdata(index).Vmnsz
    Vsv  =TDsdata(index).Vsv;    sample volumes of each second.

    indexgt0=where(Hconc gt 0.0, contG)
    if contG gt 0 then  svH=total(Hsv(indexgt0)) else svH=total(Hsv)
    indexgt0=where(Vconc gt 0.0, contG)
    if contG gt 0 then  svV=total(Vsv(indexgt0)) else svV=total(Vsv)

    ; note that TDSdata.Bin is #/L/um

    Hypts(0)=total(Hsv*TDsdata(index).Hbin1)/svH
    Hypts(1)=total(Hsv*TDsdata(index).Hbin2)/svH
    Hypts(2)=total(Hsv*TDsdata(index).Hbin3)/svH
    Hypts(3)=total(Hsv*TDsdata(index).Hbin4)/svH
    Hypts(4)=total(Hsv*TDsdata(index).Hbin5)/svH
    Hypts(5)=total(Hsv*TDsdata(index).Hbin6)/svH
    Hypts(6)=total(Hsv*TDsdata(index).Hbin7)/svH
    Hypts(7)=total(Hsv*TDsdata(index).Hbin8)/svH
    Hypts(8)=total(Hsv*TDsdata(index).Hbin9)/svH
    Hypts(9)=total(Hsv*TDsdata(index).Hbin10)/svH
    Hypts(10)=total(Hsv*TDsdata(index).Hbin11)/svH
    Hypts(11)=total(Hsv*TDsdata(index).Hbin12)/svH
    Hypts(12)=total(Hsv*TDsdata(index).Hbin13)/svH
    Hypts(13)=total(Hsv*TDsdata(index).Hbin14)/svH
    Hypts(14)=total(Hsv*TDsdata(index).Hbin15)/svH
    Hypts(15)=total(Hsv*TDsdata(index).Hbin16)/svH
    Hypts(16)=total(Hsv*TDsdata(index).Hbin17)/svH
    Hypts(17)=total(Hsv*TDsdata(index).Hbin18)/svH
    Hypts(18)=total(Hsv*TDsdata(index).Hbin19)/svH
    Hypts(19)=total(Hsv*TDsdata(index).Hbin21)/svH
    Hypts(20)=total(Hsv*TDsdata(index).Hbin20)/svH
    Hypts(21)=total(Hsv*TDsdata(index).Hbin22)/svH
    Hypts(22)=total(Hsv*TDsdata(index).Hbin23)/svH
    Hypts(23)=total(Hsv*TDsdata(index).Hbin24)/svH
    Vypts(0)=total(Vsv*TDsdata(index).Vbin1)/svV
    Vypts(1)=total(Vsv*TDsdata(index).Vbin2)/svV
    Vypts(2)=total(Vsv*TDsdata(index).Vbin3)/svV
    Vypts(3)=total(Vsv*TDsdata(index).Vbin4)/svV
    Vypts(4)=total(Vsv*TDsdata(index).Vbin5)/svV
    Vypts(5)=total(Vsv*TDsdata(index).Vbin6)/svV
    Vypts(6)=total(Vsv*TDsdata(index).Vbin7)/svV
    Vypts(7)=total(Vsv*TDsdata(index).Vbin8)/svV
    Vypts(8)=total(Vsv*TDsdata(index).Vbin9)/svV
    Vypts(9)=total(Vsv*TDsdata(index).Vbin10)/svV
    Vypts(10)=total(Vsv*TDsdata(index).Vbin11)/svV
    Vypts(11)=total(Vsv*TDsdata(index).Vbin12)/svV
    Vypts(12)=total(Vsv*TDsdata(index).Vbin13)/svV
    Vypts(13)=total(Vsv*TDsdata(index).Vbin14)/svV
    Vypts(14)=total(Vsv*TDsdata(index).Vbin15)/svV
    Vypts(15)=total(Vsv*TDsdata(index).Vbin16)/svV
    Vypts(16)=total(Vsv*TDsdata(index).Vbin17)/svV
    Vypts(17)=total(Vsv*TDsdata(index).Vbin18)/svV
    Vypts(18)=total(Vsv*TDsdata(index).Vbin19)/svV
    Vypts(19)=total(Vsv*TDsdata(index).Vbin20)/svV
    Vypts(20)=total(Vsv*TDsdata(index).Vbin21)/svV
    Vypts(21)=total(Vsv*TDsdata(index).Vbin22)/svV
    Vypts(22)=total(Vsv*TDsdata(index).Vbin23)/svV
    Vypts(23)=total(Vsv*TDsdata(index).Vbin24)/svV
endif else begin
    time=0
    ;Hypts=0.0
    ;Vypts=0.0; all other values are zero.
    rrr=dialog_message(' No 2DS data from this time period', /information)
endelse

;make Hypts and Vypts into horizontal and verticals.
hyptsn=fltarr(48)
vyptsn=fltarr(48)
for i=0,23 do begin
    hyptsn(2*i:2*i+1)=hypts(i)
    vyptsn(2*i:2*i+1)=vypts(i)
endfor
hypts=hyptsn
vypts=vyptsn

end; end of get_2ds_time1totime2_total_psd_from_1Hz_archive,filename,time1,time2,xpts,ypts
;*********************************************************************

pro Secs_To_Times,secs,time

    temp=floor( long(secs)/(24l*3600l) )
    temp=long(secs)-temp*(24l*3600l)
    tempHH=floor( temp/3600l )
    temp=temp-tempHH*3600L
    tempMM=floor( temp/60l )
    tempSS=temp-tempMM*60L
    if tempHH lt 10 then HH='0'+strtrim(long(tempHH),2) else HH=strtrim(long(tempHH),2)
    if tempMM lt 10 then MM='0'+strtrim(long(tempMM),2) else MM=strtrim(long(tempMM),2)
    if tempSS lt 10 then SS='0'+strtrim(long(tempSS),2) else SS=strtrim(long(tempSS),2)
    time=HH+':'+MM+':'+SS
end;******************
;**********************************************************

pro find_string_pos,filename,search_string,pos
    ;search_string='PDs =';'WYSIWYG:'
    ;filename='abcdefg.ascii'
    ; Note: the input search_tsring can be someting like this: 'abcd egfhj hhhh'
    result=read_ascii(filename,count=n_lines);   ;find out how many lines in the file.

    for i=2,n_lines-1 do begin
        result=read_ascii(filename,data_start=i-1,header=readed_line,num_records=1)
        ;skip i-1 lines, read in readed_line as header, and read 1 records.
        aa=readed_line(*,0)
        nn=n_elements(aa)
        last_line=readed_line(nn-1,*)
        last_line=strtrim(last_line,2);   ; take teh leading and tailing balnks away.

        ;print,readed_line; ;print,'aaaaaaaaaaaaa';;print,last_line;print,'*************'

        find = STRCMP(last_line, search_String, strlen(search_string), /FOLD_CASE)
        if (find eq 1) then begin
            pos=i-1
            break;   ;breakout of the for loop.
        endif else begin
            pos=0
        endelse
    endfor

    if pos eq 0 then begin
        print, 'Data line with ',search_string,' not found in file: ',filename
        ;stop
    endif;  print, pos
end; ;end of function find_string_pos.

;*****************************************************
function SPEC_Nano2HMS, ns
    ; accepts ULL values of nanoseconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    orig_ns = ns

    NanosecondsPerMicro  = 1000ULL
    NanosecondsPerMilli  = 1000000ULL
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    hours=ns/NanosecondsPerHour
    if hours GT 0 then  ns = ns - (hours * NanosecondsPerHour)
    minutes=ns/NanosecondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * NanosecondsPerMinute)
    seconds=ns/NanosecondsPerSecond
    if seconds GT 0 then  ns = ns - (seconds * NanosecondsPerSecond)
    milli=ns/NanosecondsPerMilli
    if milli GT 0 then  ns = ns - (milli * NanosecondsPerMilli)
    micro=ns/NanosecondsPerMicro
    if micro GT 0 then  ns = ns - (micro * NanosecondsPerMicro)
    a = string(format = '(%"%2.2d:%2.2d:%2.2d.%3.3d.%3.3d.%3.3d")',hours,minutes,seconds,milli,micro,ns)

    ns = orig_ns
    return,a
end
;*****************************************************

pro  get_all_data_filenames,filter_str,pathnm,filenames,file_count
    ;input is filter_str, pathnm
    ;output is filenames,file_count
    substrs=strsplit(filter_str,'.',/extract)
    extension=substrs(1)

    do_loop=1
    WHILE (do_loop eq 1) do begin    ;repeatedly selecting files until
        ;user comfirms
        whole_filter_str=pathnm+filter_str
        filenames=findfile(whole_filter_str,COUNT=file_count)
        ;find all files with filter_str and counts the number of these files

        ; display the files in the screen for user to review
        print,'***********************************************************'
        print,'********  Here are data files with ',filter_str, '   ******'
        print,'*** found in current directory for input by this program ***'
        print,'************************************************************'

        for j=0, (file_count-1)  do begin
            print, filenames(j)
        endfor

        print,'*********************************************'

        ; print the message to ask user to confirm
        ; define answer to be a string
        answer=' '

        print,'Are you sure to read above files ? yes/no'

        print,'----if no, then enter a string with wildcat (* or ?)'
        print,'           to limit the files being selected for input.'
        print,'           for example:   *lear_1749*.',extension
        print,'----Or--stop now, delete those unwanted files from  '
        print,'           the current directory, then restart '
        print,'           this program'
        print, 'Enter y or n:'
        ;read,answer
        answer = 'y'

        if strcmp(answer,'y') then  do_loop=0
        if (strcmp(answer,'y') eq 0) then begin
            print,'  Enter the string(ie: *6*b?*.',extension,'):'
            read,answer    ; use this string for selecting input data files.
            filter_str=pathnm+answer   
        endif

    ENDWHILE           ; end of initial start up.
    print,'                            '
    print,' done,get the files,.....Processing,  please wait ! '
    print,'
end; endof get_all_data_filenames,filter_str,filenames,pathnm
;****************************************************************************



;get next file's starttiem and end time. this is used to determine when to stop writting the current
; files time.
pro get_next_files_starttime_and_endTime,fileNameNext,pathnm,startTimeNext,EndTimeNext,$
    TDsdata, TDsDataNext,Case1to5,A,B
read_in_2ds_data_from_1Hz_archive_61bins,TDsDataNext,pathnm,filenameNext
EndTimeNext     =max(TDSdataNext.seconds); get the last seconds of the first file.
StartTimeNext   =min(TDSdataNext.seconds)
seconds1=TDSdata.seconds
nnn1    =n_elements(seconds1)
if nnn1 lt 2 then begin
    print, 'This file has less than 2 seconds of data !!! We should ignore this file.'
    ;stop
endif
A   =seconds1(nnn1-2:nnn1-1)

seconds2=TDsdataNext.seconds
nnn2    =n_elements(seconds2)
if nnn2 lt 2 then begin
    print, 'This Next file has less than 2 seconds of data !!! We should ignore this file.'
    ;stop
endif
B =seconds2(0:1)

if a(0) eq b(0) then case1to5=1;  overlap 2 seconds only.
if a(1) eq b(0) then case1to5=2;  overlap 1 second only.
if a(1)+1 eq b(0) then case1to5=3; only touch each other.
if b(0) gt  a(1)+1 then case1to5=4; there is a gap
if b(0) le a(0)-1 then case1to5=5;  overlap too much.

end;get_next_files_starttime_and_endTime,fileName,startTimeBext,EndTimeNext
;**************************************************************************************
PRO TextBox_CenterTLB, tlb

    Device, Get_Screen_Size=screenSize
    IF screenSize[0] GT 2000 THEN screenSize[0] = screenSize[0]/2 ; Dual monitors.
    xCenter = screenSize(0) / 2
    yCenter = screenSize(1) / 2

    geom = Widget_Info(tlb, /Geometry)
    xHalfSize = geom.Scr_XSize / 2
    yHalfSize = geom.Scr_YSize / 2

    Widget_Control, tlb, XOffset = xCenter-xHalfSize, $
        YOffset = yCenter-yHalfSize

END ;-----------------------------------------------------



PRO moqixu_TextBox_Event, event

    Widget_Control, event.top, Get_UValue=info
    CASE event.ID OF
        info.cancelID: Widget_Control, event.top, /Destroy
        ELSE: BEGIN

            Widget_Control, info.textID, Get_Value=theText
            (*info.ptr).text = theText[0]
            (*info.ptr).cancel = 0
            Widget_Control, event.top, /Destroy
        ENDCASE
    ENDCASE
END ;-----------------------------------------------------



FUNCTION moqixu_TextBox, Title=title, Label=label, Cancel=cancel, $
    Group_Leader=groupleader, XSize=xsize, Value=value
Catch, theError
IF theError NE 0 THEN BEGIN
    Catch, /Cancel
    ok = Dialog_Message(!Error_State.Msg)
    IF destroy_groupleader THEN Widget_Control, groupleader, /Destroy
    cancel = 1
    RETURN, ""
ENDIF

IF N_Elements(title) EQ 0 THEN title='Provide input:'
IF N_Elements(label) EQ 0 THEN label = ""
IF N_Elements(value) EQ 0 THEN value = ""
IF N_Elements(xsize) EQ 0 THEN xsize = 600

IF N_Elements(groupleader) EQ 0 THEN BEGIN
    groupleader = Widget_Base(Map=0)
    Widget_Control, groupleader, /Realize
    destroy_groupleader = 1
ENDIF ELSE destroy_groupleader = 0
tlb = Widget_Base(Title='moqixu_textbox', /col, $
    /Base_Align_Center, Group_Leader=groupleader,xsize=800)
myinfo=title
myysize=n_elements(myinfo)
infobase=widget_text(tlb, value=myinfo,ysize=myysize,xsize=120,/Frame)

labelbase = Widget_Base(tlb, row=1)
IF label NE "" THEN label = Widget_Label(labelbase, Value=label)
textID = Widget_Text(labelbase, /Editable, Scr_XSize=xsize, Value=value)
buttonBase0 = Widget_Base(tlb, /col)
buttonBase1 = Widget_Base(buttonbase0, /row)
cancelID = 1; Widget_Button(buttonBase1, Value='Cancel')
acceptID = Widget_Button(buttonBase1, Value='Accept')

TextBox_CenterTLB, tlb
Widget_Control, tlb, /Realize

ptr = Ptr_New({text:"", cancel:1})

info = {ptr:ptr, textID:textID, cancelID:cancelID}
Widget_Control, tlb, Set_UValue=info, /No_Copy

XManager, 'moqixu_textbox', tlb

theText = (*ptr).text
cancel = (*ptr).cancel
Ptr_Free, ptr
IF destroy_groupleader THEN Widget_Control, groupleader, /Destroy

RETURN, theText
END ;-----------------------------------------------------


