;=============================================================================
FUNCTION ZOOM_MYXTICKS, axis, index, value

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV


    ; str = SPEC_Nano2HMS(FirstData.Nanoseconds)
    fullrange = 0ULL
    binwidth = 0ULL
    fullrange = LastData.Nanoseconds - FirstData.Nanoseconds
    binwidth = fullrange/7
    curbin = FirstData.Nanoseconds  + (index * binwidth)


    ; WIDGET_CONTROL ,strip_info.stripLabel ,TLB_GET_SIZE= a
    ; widget_info(drawID,/GEOMETRY)

    xlabel = strmid(SPEC_Nano2HMS(curbin),0,12)
    ;xoffset = (index * ((0.95-0.15)/7.0)) + 0.153
    xoffset = (index * ((0.95-0.15)/7.0)) + 0.172


    yoffset = 0.681
    charsize = !CHAR_SIZE  * 0.85 ; use the sizing we calculated from the last window resize
    bluecolor = GetColor("Navy", !D.Table_Size-2)
    XYOutS, xoffset, yoffset, xlabel, color = bluecolor, $
        Alignment=1.0, Orientation=0.0,size = charsize, /NORMAL

    ;print, "MYXTICKS",axis,index,value
    ;return , string(index)
    return, ""

end




PRO DrawTimeSeries_1Hz_Zoom, info, ave_info, OneHzStartBin, OneHzEndBin

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV

    forward_function SPEC_Nano2HMS


    device, decomposed=1

    Widget_Control, ave_info.ZoomWindowSeriesDrawID, Get_Value=wid

    bluecolor = GetColor("Navy", !D.Table_Size-2)
    redcolor = GetColor("Red", !D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size-2)


    num = (OneHzEndBin - OneHzStartBin) > 1 ; + 1   ; do +1 to include thru the end of the last bin

    StartingNanoseconds = FirstData.Nanoseconds + (OneHzStartBin * 1000000000ULL)
    EndingNanoseconds = StartingNanoseconds + (num * 1000000000ULL)

    BinWidth = 0.0
    NumBins = CalcNumBins(num,BinWidth)   ; figure out how many bins will be in the 1Hz zoomed time series graph
    local_ADataH = REPLICATE({_AverageHzData},NumBins)  ; prepare the 300 bin averaging array
    local_ADataV = REPLICATE({_AverageHzData},NumBins)  ; prepare the 300 bin averaging array

    ;---------------------------------------------------------------------
    ; Extract Horizontal data from 1Hz array
    ;---------------------------------------------------------------------
    BinIndex = OneHzStartBin
    for Index = 0,NumBins-2 DO BEGIN
        local_ADataH(Index).Concentration = mean(OneHzH[BinIndex:BinIndex+BinWidth -1].Concentration)
        local_ADataH(Index).Extinction = mean(OneHzH[BinIndex:BinIndex+BinWidth -1].Extinction)
        local_ADataH(Index).IWC = mean(OneHzH[BinIndex:BinIndex+BinWidth -1].IWC)
        local_ADataH(Index).FileOffset =  OneHzH[BinIndex].FileOffset
        local_ADataH(Index).NSOffset = OneHzH[BinIndex].NSOffset

        ; print, "from->to ",BinIndex,BinIndex+BinWidth -1,"  Offset=",ADataH(Index).FileOffset, ' for index=',Index
        local_ADataV(Index).Concentration = mean(OneHzV[BinIndex:BinIndex+BinWidth -1].Concentration)
        local_ADataV(Index).Extinction = mean(OneHzV[BinIndex:BinIndex+BinWidth -1].Extinction)
        local_ADataV(Index).IWC = mean(OneHzV[BinIndex:BinIndex+BinWidth -1].IWC)
        local_ADataV(Index).FileOffset =  OneHzV[BinIndex].FileOffset
        local_ADataV(Index).NSOffset = OneHzV[BinIndex].NSOffset

        BinIndex += BinWidth

    endfor

    ;--------------------------------------------------------
    ; Handle the last bin
    ;--------------------------------------------------------
    if n_elements(local_AdataH.concentration) eq 1 and index eq 1 then index=0; added by mo--Nov 2, 2005.

    if (BinIndex ne onehzstartbin + num) then begin
        local_ADataH(Index).Concentration = mean(OneHzH[BinIndex:onehzstartbin + num].Concentration)
        local_ADataH(Index).Extinction = mean(OneHzH[BinIndex:onehzstartbin + num].Extinction)
        local_ADataH(Index).IWC = mean(OneHzH[BinIndex:onehzstartbin + num].IWC)
        local_ADataH(Index).FileOffset =  OneHzH[BinIndex].FileOffset
        local_ADataH(Index).NSOffset = OneHzH[BinIndex].NSOffset

        local_ADataV(Index).Concentration = mean(OneHzV[BinIndex:onehzstartbin + num].Concentration)
        local_ADataV(Index).Extinction = mean(OneHzV[BinIndex:onehzstartbin + num].Extinction)
        local_ADataV(Index).IWC = mean(OneHzV[BinIndex:onehzstartbin + num].IWC)
        local_ADataV(Index).FileOffset =  OneHzV[BinIndex].FileOffset
        local_ADataV(Index).NSOffset = OneHzV[BinIndex].NSOffset
    endif





    chart1 =    [0.15, 0.700, 0.95, 0.925]
    chart2 =    [0.15, 0.700 - 0.33, 0.95, 0.925-0.33]
    chart3 =    [0.15, 0.700 - 0.66, 0.95, 0.925-0.66]

    axisColor = GetColor("Navy", !D.Table_Size-2)
    dataColor = GetColor("Navy", !D.Table_Size-2)
    backColor = GetColor("White", !D.Table_Size-2)

    ;axisColor = GetColor(info.axisColorName, !D.Table_Size-2)
    ;dataColor = GetColor(info.datacolorName, !D.Table_Size-3)
    ;backColor = GetColor(info.backColorName, !D.Table_Size-4)
    ; to generate the correct character size, point to the main window
    ;Widget_Control, info.drawID, Get_Value=wid
    ;WSet, wid
    thisCharsize = Str_Size('A Sample String', 0.25)


    strf = SPEC_Nano2HMS(StartingNanoseconds)
    strl = SPEC_Nano2HMS(EndingNanoseconds)



    plot_string =  !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING
    plot_string2 =  strtrim(string(total(OneHzH(OneHzStartBin:OneHzEndBin).N)),2) + ' H , ' + $
        strtrim(string(total(OneHzV(OneHzStartBin:OneHzEndBin).N)),2) +  ' V Data Points'


    message_string = 'Zoomed data from ' + !ZOOM_START_STRING +  $
        " to " + !ZOOM_END_STRING + ' , ' + plot_string2




    fullrange = 0ULL
    binwidth = 0ULL
    fullrange = EndingNanoseconds - StartingNanoseconds
    binwidth = fullrange/8
    curbin = StartingNanoseconds

    ;xlabel = SPEC_Nano2HMS(curbin)

    tnames = StrArr(9)
    FOR i=0,8 DO BEGIN
        if (!HI_LO_STATE eq 1) then begin  ;1=hires
            tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,12),2)
        endif else begin
            tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,8),2)  ; No milliseconds displayed for lo-res
        endelse
        ;tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,12),2)
        curbin += binwidth
    ENDFOR

    ;-------------------------------
    ;Set up X axis tick labels.
    ;-------------------------------
    !X.TICKNAME = tnames
    !X.TICKS = 8



    !P.Multi = [0,3,1,0,1]  ; Make sure we're plotting at the top position
    Xdata = local_ADataH.Concentration
    ; H_deadtime,V_deadtime

    ; H_dead = 'H= ' + strtrim(string(format = '(%"%15.3f Secs ")',total(OneHzH(OneHzStartBin:OneHzEndBin).Deadtime)),2)
    ; V_dead =  'V= ' + strtrim(string(format = '(%"%15.3f Secs")',total(OneHzV(OneHzStartBin:OneHzEndBin).Deadtime)),2)

    ;replace above with Mo's calculation of deadtime
    H_dead = 'H= ' + strtrim(string(format = '(%"%15.3f Secs")',ave_info.Hdeadtime),2)
    V_dead = ' V= '+ strtrim(string(format = '(%"%15.3f Secs")',ave_info.Vdeadtime),2)



    main_title = 'Particle Concentration (H=BLUE, V=RED) Deadtime '+ H_dead + V_dead
    y_title = 'Concentration(#/L)'
    ;----------------------------------------------------
    ; Make sure the window we're plotting to is selected
    ;----------------------------------------------------
    Widget_Control, ave_info.ZoomWindowSeriesDrawID, Get_Value=wid
    WSet, wid

    thisCharsize = 1.8

    if n_elements(Xdata) eq 1 then Xdata=[xdata,xdata]

    ymax=max([local_ADataV.Concentration,local_ADataH.Concentration])

    Plot, Xdata, Yrange=[0.0,1.1*ymax], $
        Background=backcolor, $           ; The background color of the display.
        Charsize=thisCharsize, $          ; The character size, as determined by Str_Size.
        Color=axiscolor, $                ; The color of the axes.
        XStyle=1, $                       ; Exact axis scaling. No autoscaled axes.
        ; XTickformat='(I6)', $
        Title = main_title, $
        XTitle = 'Bin' , $
        YTitle = y_title , $
        Position=chart1 ; , $
        ;XTICKFORMAT='MYXTICKS'


        Xdata = local_ADataV.Concentration
    if n_elements(Xdata) eq 1 then Xdata=[xdata,xdata]
    Oplot,Xdata, $
        color = redcolor

    Xdata = local_ADataH.Extinction
    main_title = 'Particle Extinction (H=BLUE, V=RED)'
    y_title = 'Extinction(1/km)'

    if n_elements(Xdata) eq 1 then Xdata=[xdata,xdata]

    Plot, Xdata, $
        Background=backcolor, $           ; The background color of the display.
        Charsize=thisCharsize, $          ; The character size, as determined by Str_Size.
        Color=axiscolor, $                ; The color of the axes.
        XStyle=1, $                       ; Exact axis scaling. No autoscaled axes.
        ; XTickformat='(I6)', $
        Title = main_title, $
        XTitle = 'Bin' , $
        YTitle = y_title , $
        Position=chart2 , $
        /NOERASE ;, $
        ; XTICKFORMAT='MYXTICKS'


        Xdata = local_ADataV.Extinction
    if n_elements(Xdata) eq 1 then Xdata=[xdata,xdata]
    Oplot,Xdata, $
        color = redcolor

    Xdata = local_ADataH.IWC
    main_title = 'Particle IWC (H=BLUE, V=RED)'
    y_title = 'ice Water Content(g/m^3)'

    if n_elements(Xdata) eq 1 then Xdata=[Xdata,Xdata]; added by mo on Nov 2, 2005.

    Plot, Xdata, $
        Background=backcolor, $           ; The background color of the display.
        Charsize=thisCharsize, $          ; The character size, as determined by Str_Size.
        Color=axiscolor, $                ; The color of the axes.
        XStyle=1, $                       ; Exact axis scaling. No autoscaled axes.
        ; XTickformat='(I6)', $
        Title = main_title, $
        XTitle = 'Bin' , $
        YTitle = y_title , $
        Position=chart3 , $
        /NOERASE ;, $
        ;    XTICKFORMAT='MYXTICKS'

        Xdata = local_ADataV.IWC
    if n_elements(Xdata) eq 1 then Xdata=[xdata,xdata]
    Oplot,Xdata, $
        color = redcolor


    !X.TICKNAME = ''
    !X.TICKS = 0



    XYOUTS,25,590, 'File name:  ' + strmid(!CurrentHFname,strlen(!CurrentHPname)) + '    Data from ' + plot_string + ' ' + plot_string2 ,color=bluecolor, size=1, /device
    ;XYOUTS,450,18, plot_string,color=bluecolor, size=1, /device
    ;XYOUTS,450,5, plot_string2,color=bluecolor, size=1, /device



    device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data

end
