; File:  Do_Nsecond_ultimate_archive_61binsHorV.pro
; Purpose:  (preliminary) Main functions used for 2D-S ASCII archive file generation
pro  GetM6_GoodPercent_between_t1_t2,HorV,SizesM1,sizesM2,adjsM1,adjsM2,starttime,endtime,NGoodpercent,irregular_cont
    common dataBlock, alldataH,alldataV
    if HorV eq 'H' then alldata = alldataH
    if HorV eq 'V' then alldata = alldataV

    ;get the M1 irregular particle counts.
    junk=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        ((*alldata).warn gt 0) and (*alldata).L1n le 0.0, M1irregular_cont)
    ;get the M2 irregular particle counts.
    junk=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        ((*alldata).warn gt 0) and (*alldata).L2 gt 0.0,  M2irregular_cont)
    irregular_cont = M1irregular_cont +M2irregular_cont


    ;get the good particles.   replace PartcontM1 and PartcontM2 with size range values.
    junk=where(sizesM2 le 25.0 and sizesM2 gt 0.0 and adjsM2 gt 0.0,  PartcontM2); accepted M2 particles.
    junk=where(sizesM1 gt 25.0 and adjsM1 gt 0.0,PartcontM1); accepted  M1 particles.
    Ngood = partcontM2 +partcontM1

    ; ;get the M6 total particle count.
    junk=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).L1n gt 25.0, M1_cont)
    junk=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).L2 gt 0.0 and (*alldata).L2 le 25.0,  M2_cont)
    total_N=M1_cont+M2_cont


    if total_N gt 0 then begin
        Ngoodpercent=100.0*(Ngood/float(total_N))
    endif else begin
        NgoodPercent=0.0
    endelse

end;  GetM6_GoodPercent_between_t1_t2,HorV,liqorice,SizesM2,sizesM1,starttime,endtime



pro Get_Median_Volume_Diameter_from_MPsd,Mbinhs,binwidths61,bincenters61,MedianVD

    Mass=Mbinhs*binwidths61; This is mass in each bin.

    half_mass=total(Mass)/2.0

    MedianVD=0.0
    if half_mass gt 0.0 then begin; search for the middle point.
        sum_m=0.0
        for ks=0,n_elements(Mass)-1 do begin
            sum_m=sum_m+Mass(ks)
            if (sum_m ge half_mass) and (Mass(ks) gt 0.0) then begin
                portion=(sum_m-half_mass)/Mass(ks)
                wids_portion=portion*binwidths61(ks)
                MedianVD=bincenters61(ks)+binwidths61(ks)/2.0-wids_portion
                break
            endif
        endfor

    endif; % end of if there is nonzeros PSD.

end; end of pro Get_median_Volume_Diameter_from_MPsd


pro Get_Number_Mean_Diameter_from_NPSD,Nbinhs,bincenters61,mnD

    total_N=total(Nbinhs)
    mnD=0.0

    if total_N gt 0.0 then begin
        mnD =total(Nbinhs*bincenters61)/total_N
    endif

end; end of pro Get_Number_mean_Diameter_from_NPsd

pro Get_Effective_Diameter_from_APSD_and_MPSD,Abinhs,Mbinhs,binwidths61,Deff

    project_area=total(Abinhs*binwidths61);                    ;vol=cmbIWC[k-k0]*10.0^9.0/0.917  ;(total(PMS.TWODC_M(k,temp_indx))/0.917 +fssp_LWC(k))*10.0^9.0
    total_volume=1000.0*total(Mbinhs*binwidths61);             ;project_area=0.5*extinct[k-k0]*10.0^6.0

    Deff=0.0;     V/A=r*4/3;  0.75*V/A=r.    1.5*totalV/prj_a=Diameter.

    if project_area gt 0.0 then begin
        Deff = 1.5*total_volume/project_area;  that is diameter; for sphere:   V=pi*4*r^3/3, project_area=pi*r^2
    endif

end; end of pro Get_Effective_Diameter_from_APsd_and_Mpsd

pro get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,HorV,M6TorF,L_choice,liqorice,starttime,endtime,$ ;inputs
    has_data,xpts,bincenters61,binwidths61,binwidths122,npts,mnd,mvd,efd,ypts,Apts,Ipts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,adjustmentfactor,T1_T2_data,round_flag = round_flag; outputs
Common  DataBlock,AllDataH,AllDataV
;the output sizes are in pixels.

if(not keyword_set(round_flag)) then begin
    round_flag = -1
endif


Get_JustDeadtime_between_time1_time2,HorV,starttime,endtime,Fullticks,HliveV,ThisTAS,ovldcnts,$
    StartTicks,EndTicks,DT_mask,DT_ovfl,DT_L1,DT_bad1,DT_bad2,DT_bad3,HdeadTime
T1_T2_data={Fullticks:Fullticks,$
    SampleVolume:HliveV,$
    ThisTAS:ThisTAS,$
    ovldcnts:ovldcnts,$
    StartTicks:StartTicks,$
    EndTicks: EndTicks,$
    DT_mask:DT_mask,$
    DT_ovfl: DT_ovfl,$
    DT_L1:DT_L1,$
    DT_bad1:DT_bad1,$
    DT_bad2: DT_bad2,$
    DT_bad3:DT_bad3,$
    total_AccDeadtime:HDeadtime}

if strupcase(HorV) eq 'H' then begin
    alldata = alldataH
    microns_per_pixel=!microns_per_pixelH
endif else begin
    alldata = alldataV
    microns_per_pixel=!microns_per_pixelV
endelse

if(round_flag eq 2) then begin ; show only not round particles
    not_round_index = where(not ((*alldata).Roundness1 gt !Roundness1_min and $
        (*alldata).Roundness1 lt !Roundness1_max and $
        (*alldata).Roundness1 gt !Roundness2_min and $
        (*alldata).Roundness2 lt !Roundness2_max and $
        (*alldata).Roundness3 gt !Roundness3_min and $
        (*alldata).Roundness3 lt !Roundness3_max) $
        , count)
    if(count gt 0) then begin
        (*alldata) = (*alldata)(not_round_index)
    endif else begin
        print, "No "+HorV+" particles matching Not Roundness criteria in get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2, making empty set"
        (*alldata) = replicate({_DerivedDataRev2},3)
    endelse
endif

if(round_flag eq 1) then begin ; show only round particles
    round_index = where((*alldata).Roundness1 gt !Roundness1_min and $
        (*alldata).Roundness1 lt !Roundness1_max and $
        (*alldata).Roundness1 gt !Roundness2_min and $
        (*alldata).Roundness2 lt !Roundness2_max and $
        (*alldata).Roundness3 gt !Roundness3_min and $
        (*alldata).Roundness3 lt !Roundness3_max, count)

    if(count gt 0) then begin
        (*alldata) = (*alldata)(round_index)
    endif else begin
        print, "No" +HorV+" particles matching Roundness criteria in get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2, making empty set"
        (*alldata) = replicate({_DerivedDataRev2},3)
    endelse
endif

csp=[0,0]; default values.
has_data=0
Partcont='0';strtrim(n_elements(subinxex))
sizes=[0.0]
areas=[0.0]
adjs=0.0
adjustmentfactor=0.0

if round_flag eq -1 then begin
    subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).area gt 0 and (*alldata).reject eq 0, total_accepted_N)
endif

if(round_flag eq 2) then begin ; show only not round particles
    subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).area gt 0 and (*alldata).reject eq 0 and (*alldata).round123 eq 0 , total_accepted_N)
endif

if(round_flag eq 1) then begin ; show only round particles
    subindex=where((*alldata).nanoseconds gt starttime and (*alldata).nanoseconds le endtime and $
        (*alldata).area gt 0 and (*alldata).reject eq 0 and (*alldata).round123 eq 1 , total_accepted_N)
endif

if total_accepted_N gt 0 then begin
    csp   =(*alldata)(subindex).csp

    case L_choice of
        'M1': begin
            if M6TorF eq 'M6=0' then begin
                has_data=1
                sizes = (*alldata)(subindex).L1n; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                adjs  = (*alldata)(subindex).adj1
                F1=(*alldata)(subindex).F1
                get_method1adjvalues_of_normal,HorV,sizes,F1,adjs;  ; touching or no touching the edges , does not matter.
                adjustmentfactor=1.0
                if !filter eq 1 then  adjs=adjs*adj0s
            endif ; if M6TorF eq M6False

            if M6TorF eq 'M6=1' then begin
                sizes = (*alldata)(subindex).L1n; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                alexei1 =(*alldata)(subindex).alexei1
                get_method1adjvalues_of_M6,HorV,sizes,F1,adjs
                indexacceptedF=where(adjs gt 0.0 and areas gt 0.9*alexei1,acceptedN_F)
                if acceptedN_F gt 0  then begin
                    has_data=1
                    adjustmentfactor=total_accepted_N/(acceptedN_F)
                    sizes=sizes(indexacceptedF)
                    adjs = adjs(indexacceptedF)
                    adj0s=adj0s(indexacceptedF)
                    csp  =csp(indexacceptedF)
                    if !filter eq 1 then  adjs=adjs*adj0s
                endif else   has_data=0

            endif ;  if M6TorF eq M6=1
        end; end of M1 method; wihci is not clean.

        'M2': begin ; M2 should be cleaned and in focus.
            if M6TorF eq 'M6=0' then begin
                sizes = (*alldata)(subindex).L5; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                get_method2adjvalues_of_normal,HorV,sizes,F1,adjs
                indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
                if accepted_count gt 0 then begin
                    has_data=1
                    adjustmentfactor=float(total_accepted_N)/float(accepted_count);  this
                    sizes=sizes(indexaccepted)
                    adjs = adjs(indexaccepted)
                    areas=areas(indexaccepted)
                    csp  =csp(indexaccepted)
                    adj0s=adj0s(indexaccepted)
                    if !filter eq 1 then  adjs=adjs*adj0s
                endif

            endif; end of M6TorF eq 'M6=0'

            if M6TorF eq 'M6=1' then begin
                sizes = (*alldata)(subindex).L5; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
                areas = (*alldata)(subindex).area
                adj0s = (*alldata)(subindex).adj0
                F1    = (*alldata)(subindex).F1
                alexei1 =(*alldata)(subindex).alexei1
                get_method2adjvalues_of_M6,HorV,sizes,F1,adjs
                indexacceptedF=where(adjs gt 0.0 and areas gt 0.9*alexei1,acceptedN_F)
                if acceptedN_F gt 0  then begin
                    has_data=1
                    adjustmentfactor=total_accepted_N/(acceptedN_F)
                    sizes=sizes(indexacceptedF)
                    adjs =adjs(indexacceptedF)
                    adj0s=adj0s(indexacceptedF)
                    csp  =csp(indexacceptedF)
                endif else begin
                    has_data=0
                endelse
                if !filter eq 1 then  adjs=adjs*adj0s
            endif; end of M6TorF eq 'M6=1'
        end
        'M4':begin ; should be both in-focus and out of focus and cleaned.
        sizes = (*alldata)(subindex).L7
        areas = (*alldata)(subindex).area
        adj0s   = (*alldata)(subindex).adj0
        F1      = (*alldata)(subindex).F1
        get_method4adjvalues,HorV,sizes,F1,adjs; ;input sizes has to be in unit pixels
        indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
        if accepted_count gt 0 then begin
            has_data=1
            adjustmentfactor=float(total_accepted_N)/float(accepted_count);  this
            sizes=sizes(indexaccepted)
            adjs = adjs(indexaccepted)
            areas=areas(indexaccepted)
            adj0s=adj0s(indexaccepted)
            csp  =csp(indexaccepted)
            if !filter eq 1 then  adjs=adjs*adj0s
        endif
    end; end; of M4 method


    'M5':begin ; should be both in-focus and out of focus and cleaned.
    sizes = (*alldata)(subindex).L8
    areas = (*alldata)(subindex).area
    adj0s   = (*alldata)(subindex).adj0
    F1      = (*alldata)(subindex).F1
    get_method4adjvalues,HorV,sizes,F1,adjs; ;input sizes has to be in unit pixels
    indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
    if accepted_count gt 0 then begin
        has_data=1
        adjustmentfactor=float(total_accepted_N)/float(accepted_count);  this
        sizes=sizes(indexaccepted)
        adjs =adjs(indexaccepted)
        areas=areas(indexaccepted)
        adj0s=adj0s(indexaccepted)
        csp  =csp(indexaccepted)
        if !filter eq 1 then  adjs=adjs*adj0s
    endif
end; end; of M5 method


'M7': begin
    sizes = (*alldata)(subindex).L5; unit is pixels. microns_per_pixel=0.01 ; length of particles in microns
    maxlength = (*alldata)(subindex).maxlength
    areas = (*alldata)(subindex).area
    adj0s = (*alldata)(subindex).adj0
    F1    = (*alldata)(subindex).F1
    get_method7adjvalues,HorV,sizes,maxlength,F1,adjs
    indexaccepted=where(adjs gt 0.0, accepted_count);   % all final accepted particles that are not touching the edges.
    if accepted_count gt 0 then begin
        has_data=1
        adjustmentfactor=float(total_accepted_N)/float(accepted_count);  this
        sizes=maxlength(indexaccepted)
        adjs =adjs(indexaccepted)
        areas=areas(indexaccepted)
        csp  =csp(indexaccepted)
        adj0s=adj0s(indexaccepted)
        if !filter eq 1 then  adjs=adjs*adj0s
    endif
end; end of M7
endcase
endif; end of if total_accepted_N gt 0

area_liq=!pi*(sizes^2)/4.0
area_ice=area_liq < areas

if liqorice eq 'liq' then  areas=area_liq;    in unit pixel^2
if liqorice eq 'ice' then  areas=area_ice;    in unit pixel^2

;step 2:    sizes from above is in unit pixels.
;calculate the mean psd of the parricles. since sizes, area and adjs are obtained.
SVdefault=HliveV
original_factor=1.0;  because no criteria is selected for archiving, orig_factor has to be 1.0

xpts(0)=0.001;  ;make_61_bins,nbins,nedges,xpts,dbl_binwidths
nedges=n_elements(xpts)
npts = fltarr(nedges)
ypts = fltarr(nedges)
Apts =fltarr(nedges)
Ipts =fltarr(nedges)

if has_data eq 1 then begin
    alpha = 0.115D
    beta = 1.218D
    sizes=sizes*MICRONS_PER_PIXEL
    area_factor=Microns_per_pixel*Microns_per_pixel/1000000.0;  convert_pixel_area into mm^2.

    for j=0,nedges-2,2 do begin  ;sizes should be in um in here ?????
        binwidth=binwidths122(j);  (xpts[j+1]-xpts[j]); this in uni unit of um.
        LiterTum=binwidth*SVdefault
        somarr=where(sizes lt xpts[j+1] and sizes ge xpts[j],contG) ; Handle all but last bins

        if contG gt 0 then begin;  if there is no particles, area and mass should be zero
            npts[j:j+1]=contG
            this_adj1=adjs(somarr)
            ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

            this_area=areas(somarr);       in unit pixels.
            Apts[j:j+1] =total(this_adj1*this_area*area_factor)/LiterTum; area mm^2/Liter/um. plot_area

            This_sizes=sizes(somarr)
            This_area_mm2=This_area*area_factor; change it to be mm2.
            this_csp    =csp(somarr)

            if liqorice eq 'ice' and !mass_optionIWC eq 1 then begin
                get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
                Ipts[j:j+1]=total_IWC/LiterTum ;  mg/L/um
            endif

            if liqorice eq 'ice' and !mass_optionIcsp eq 1 then begin
                get_Icsp_from_adj_n_csp,total_IWC,this_adj1,this_csp,this_sizes
                Ipts[j:j+1]=total_IWC/LiterTum;  mg/L/um
            endif

            if liqorice eq 'liq' then begin
                total_LWC=total(1.0*(0.1^9)*this_adj1*This_sizes^3)*!pi/6.0
                Ipts[j:j+1]=total_LWC/LiterTum;  mg/L/um
                ;Apts[j:j+1] =total(this_adj1*!pi*this_sizes^2)/LiterTum/4000000.0;  already done
            endif

        endif ; else ; no need to assign all ypts[j:j+1]
    endfor


    xpts(0)=microns_per_pixel/2.0   ;handle last bin;  save a lot of if statement in the for loop
    j=nedges-2
    somarr=where(sizes ge max(xpts),contG);   max(xpts)=2010.0
    binwidth=200.0; (xpts[j+1]-xpts[j]);       xpts(j+1)=2010.0 also.
    LiterTum=binwidth*SVdefault

    if contG eq 0 then begin;  there is no particles, area and mass should be zero
        ; do nothing becasue ypts(j:j+1) are already =0.
    endif else begin
        npts[j:j+1]=contG

        this_adj1=adjs(somarr)
        ypts[j:j+1] =total(this_adj1)/LiterTum; #/L/um . Plot_Size[j:j+1]

        this_area=areas(sommarr)
        Apts[j:j+1] =total(this_adj1*this_area*area_factor)/LiterTum; area mm^2/Liter/um. plot_area

        This_sizes=sizes(somarr)
        This_area_mm2=This_area*area_factor; change it to be mm2.
        this_csp=csp(sommarr)

        if liqorice eq 'ice' and !mass_optionIWC eq 1 then begin
            get_IWC_from_adj_n_sizes,total_IWC,alpha,beta,this_adj1,this_sizes,this_area_mm2
            Ipts[j:j+1]=total_IWC/LiterTum
        endif

        if liqorice eq 'ice' and !mass_optionIcsp eq 1 then begin
            get_Icsp_from_adj_n_csp,total_IWC,this_adj1,this_csp,this_sizes
            Ipts[j:j+1]=total_IWC/LiterTum;  mg/L/um
        endif

        if liqorice eq 'liq' then begin
            total_LWC=total(1.0*(0.1^9)*this_adj1*This_sizes^3)*!pi/6.0
            Ipts[j:j+1]=total_LWC/LiterTum;  mg/L/um
            ;Apts[j:j+1] =total(this_adj1*!pi*this_sizes^2)/LiterTum/4000000.0; already done.
        endif

    endelse




    ;make adjustment for M4 which is L7 ; Number/bin don't need to be adjusted.
    if L_choice eq 'M4' or L_choice eq 'M3' or L_choice eq 'M7'then begin
        ;plot_Size =adjustmentfactor*plot_Size; adjf=(L1GT0_and_criteria)/(L1NL4_criteria).
        ; ypts=ypts*adjustmentfactor
        ; Apts=Apts*adjustmentfactor
        ; Ipts=Ipts*adjustmentfactor

    endif

    ystr='#/L/um'
    ;change ypts to single value arrays
    ;if total(ypts) gt 0.0 then ;stop
    k=indgen(n_elements(ypts)/2)*2
    npts=npts(k)
    ypts=ypts(k)
    Apts=Apts(k)
    Ipts=Ipts(k)

    ;now get the mnd, mvd and efd   number mean diameter ,m medianVollume diatmeter and effective diameter.
    Get_Number_Mean_Diameter_from_NPSD,npts,bincenters61,mnD
    Get_Median_Volume_Diameter_from_MPsd,Ipts,binwidths61,bincenters61,MVD
    Get_Effective_Diameter_from_APSD_and_MPSD,APts,Ipts,binwidths61,efD


    sizes=sizes/MICRONS_PER_PIXEL;  recovered sizes to be pixels.
endif ; if has_data =1

if has_data eq 0 then begin
    npts =fltarr(n_elements(xpts)/2)
    ypts =fltarr(n_elements(xpts)/2)
    Apts =fltarr(n_elements(xpts)/2)
    Ipts =fltarr(n_elements(xpts)/2)
    mnd=0.0
    MVD=0.0
    efD=0.0
endif

end;  end of get64binUltimate_Hpsd_size_area_adjs_HliveV_Hdeadtime_bewteen_t1_t2



pro make_61_bins_ultimate,microns_per_pixel, nbins, nedges, xpts, dbl_binwidths
    um_per_pixel =microns_per_pixel
    nbins   = 61
    nedges  = 2*nbins
    xpts    = dblarr(2*nbins)
    xpts(0) = um_per_pixel/2.0

    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =xpts(0)+(i+1)*um_per_pixel
    endfor

    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =xpts(0)+(20+(i-19)*2)*um_per_pixel
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =xpts(0)+(50+(i-34)*5)*um_per_pixel
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =xpts(0)+(100+(i-44)*10)*um_per_pixel
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =xpts(0)+(200+(i-54)*20)*um_per_pixel
    endfor

    xpts(121)     = xpts(120)+20.0*um_per_pixel; to make last bin-width=20.0*microns_per_pixle um
    dbl_binwidths = xpts(1:*)-xpts(0:120)
    dbl_binwidths = [dbl_binwidths,0.0]
    xpts(121)     = 10000.0*um_per_pixel;  but hin here group anything greater that 300.5*microns_per_pixel to be the last bin.
end ; end of make_61_bins_ultimate



pro get_playback_version_string, playback_N_2DSview_version_str, info
    substrsF=strsplit(info.currentFname,'\',/extract)
    up_pathnm=strjoin(substrsF(0:n_elements(substrsF)-3),'\')+'\'
    short_filename=substrsF(n_elements(substrsF)-1)
    datestamp = strmid(Short_filename,5,strlen(Short_filename)-9)
    fname =up_pathnm+ 'SORTED' + datestamp+ '.2DSCPI
    OpenR, lun,fname, /Get_Lun
    fileheader = bytarr(256)
    ReadU, lun, fileheader
    playback_N_2dsview_version_str=strtrim(string(fileheader),2)+ '---3vcpiview-version: '+!SPEC_VERSION
    close,lun
    free_lun, lun
end



pro Do_Nsecond_ultimate_archive_61binsHorV, info=info, AllorKps, liqorice, HorV,round_flag = round_flag
Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
    FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV
common TASBlock, extTime,extTas

if(not keyword_set(round_flag)) then begin
    round_flag = -1
endif

Nseconds=1LL;   change this value to 1 to 10 or to 30 for N seconds psd archiving
bad_data=-9.99;    change to -9.99 on Aprile 2008.     9.999*1E+30
H_has_bad=0; if H_bad eq 0 then do it. if H_bad eq 1 then do not it and assign bad value for output.

T1_T2_data_bad = {Fullticks:-9.99,$
    SampleVolume:-9.99,$
    ThisTAS:-9.99,$
    ovldcnts:-9.99,$
    StartTicks:-9.99,$
    EndTicks: -9.99,$
    DT_mask:-9.99,$
    DT_ovfl: -9.99,$
    DT_L1:-9.99,$
    DT_bad1:-9.99,$
    DT_bad2: -9.99,$
    DT_bad3:-9.99,$
    total_AccDeadtime:-9.99}

alpha = 0.115D ; this hsould be changed to 0.115 according to brad' paper
beta = 1.218D   ;this should be changed to 1.218  june 8, 2005.

if strupcase(HorV) eq 'H' then begin
    microns_per_pixel=!MICRONS_PER_PIXELH
    alldata = alldataH
endif else begin
    microns_per_pixel=!MICRONS_PER_PIXELV
    alldata = alldataV
endelse

get_playback_version_string,playback_N_2DSview_version_str,info

subfile_str=strsplit(!currentHFname,'\',/extract)
binfilename=strtrim(subfile_str(n_elements(subfile_str)-1),2)
datetimestring=strmid(binfilename,5,strlen(binfilename)-9); =yymmddhhmmss_hhmmss_hhmmss_000x
junk=findfile(!currentHPname+'ascii\*.*')

if strlen(junk(0)) eq 0 then FILE_MKDIR,!currentHPname + "ascii\"
;************************************************************************************
if AllorKps eq 'All' then begin
    if(round_flag eq 2) then begin ; not round
        Houtputfilename=!currentHPname+'ascii\'+HorV+'_Archive_2DS_PSD_NOT_ROUND_'+datetimestring+'_'+!autoarchive_method+liqorice+'.txt'
    endif else if(round_flag eq 1) then begin ; round
        Houtputfilename=!currentHPname+'ascii\'+HorV+'_Archive_2DS_PSD_ROUND_'+datetimestring+'_'+!autoarchive_method+liqorice+'.txt'
    endif else begin ; don't care about roundness criteria
        Houtputfilename=!currentHPname+'ascii\'+HorV+'_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'.txt'
    endelse
endif

if AllorKps eq 'KeepSplashes' then begin
    Houtputfilename=!currentHPname+'ascii\'+HorV+'_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'WS.txt'
endif

if AllorKps eq 'NoClean' then begin
    Houtputfilename=!currentHPname+'ascii\'+HorV+'_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'NC.txt'
endif

;open a file to record deadTime, how many events, how-many fake particle, how-many  area>0.0 particle and how may accepted particles.
if !autoarchive_method eq 'M1' then begin
    HoutQCfilename=!currentHPname+'ascii\'+HorV+'_Archive_3V2DS_PSD_'+datetimestring+'_'+!autoarchive_method+liqorice+'QC.txt'
    openw,23,HoutQCfilename
    ;overlaod deadtime, total_deadTime, Sample,volume, adjfactor, TAS, H_particle, rejected, accepted--MO.
    printf,23,'Time, ovld Overld   maskdead  badtype1 badtype2 badtype3 Total   SampleV SV.adj TAS Total  Fake.N Part.N rejct# accpt# Concentration overld_dead total_Dead  Dead_L1'
    printf,23,'secs,  #/s DeadTime  seconds   seconds  seconds seconds DeadTime (Liter) factor m/s events area<0 area>0 counts counts    (#/L)        (ticks)     (ticks)   (ticks) '
endif

openw,21,Houtputfilename

MN=!autoarchive_method;   MN can be M1, M2, M4,M5, M6 M7 ect.
if liqorice eq 'ice' then LiqIceLabel='I'
if liqorice eq 'liq' then LiqIcelabel='L'

;**********************************
header_strM11=' %accept is the percentage of images accepted by M1.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
    ' M-column unit is  g/m3/um  N-column is counts/bin.   Mass OptionIWC='+ strtrim(string(!mass_optionIwc),2)+' Option_Icsp='+strtrim(string(!mass_optionIcsp),2) + $
    '---software version: '+playback_N_2dsview_version_str +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'
header_strM12='Time %Accept #_irreg   SVolume(L)  conc(#/L)   extn(1/km)   '+LiqIceLabel+'WC(g/m3)  NumbMean.D  MedianVolD  EffectiveD  '+$
    'C:5-15      C:15-25     C:25-35     C:35-45     C:45-55     C:55-65     C:65-75     C:75-85     C:85-95     C:95-105    C:105-115   C:115-125   '+ $
    'C:125-135   C:135-145   C:145-155   C:155-165   C:165-175   C:175-185   C:185-195   C:195-205   C:205-225   C:225-245   C:245-265   C:265-285   '+ $
    'C:285-305   C:305-325   C:325-345   C:345-365   C:365-385   C:385-405   C:405-425   C:425-445   C:445-465   C:465-485   C:485-505   C:505-555   '+ $
    'C:555-605   C:605-655   C:655-705   C:705-755   C:755-805   C:805-855   C:855-905   C:905-955   C:955-1005  C:1005-1105 C:1105-1205 C:1205-1305 '+ $
    'C:1305-1405 C:1405-1505 C:1505-1605 C:1605-1705 C:1705-1805 C:1805-1905 C:1905-2005 C:2005-2205 C:2205-2405 C:2405-2605 C:2605-2805 C:2805-3005 '+ $
    'C:3005-inf  ' +$
    'A:5-15      A:15-25     A:25-35     A:35-45     A:45-55     A:55-65     A:65-75     A:75-85     A:85-95     A:95-105    A:105-115   A:115-125   '+ $
    'A:125-135   A:135-145   A:145-155   A:155-165   A:165-175   A:175-185   A:185-195   A:195-205   A:205-225   A:225-245   A:245-265   A:265-285   '+ $
    'A:285-305   A:305-325   A:325-345   A:345-365   A:365-385   A:385-405   A:405-425   A:425-445   A:445-465   A:465-485   A:485-505   A:505-555   '+ $
    'A:555-605   A:605-655   A:655-705   A:705-755   A:755-805   A:805-855   A:855-905   A:905-955   A:955-1005  A:1005-1105 A:1105-1205 A:1205-1305 '+ $
    'A:1305-1405 A:1405-1505 A:1505-1605 A:1605-1705 A:1705-1805 A:1805-1905 A:1905-2005 A:2005-2205 A:2205-2405 A:2405-2605 A:2605-2805 A:2805-3005 '+ $
    'A:3005-inf  ' +$
    'M:5-15      M:15-25     M:25-35     M:35-45     M:45-55     M:55-65     M:65-75     M:75-85     M:85-95     M:95-105    M:105-115   M:115-125   '+ $
    'M:125-135   M:135-145   M:145-155   M:155-165   M:165-175   M:175-185   M:185-195   M:195-205   M:205-225   M:225-245   M:245-265   M:265-285   '+ $
    'M:285-305   M:305-325   M:325-345   M:345-365   M:365-385   M:385-405   M:405-425   M:425-445   M:445-465   M:465-485   M:485-505   M:505-555   '+ $
    'M:555-605   M:605-655   M:655-705   M:705-755   M:755-805   M:805-855   M:855-905   M:905-955   M:955-1005  M:1005-1105 M:1105-1205 M:1205-1305 '+ $
    'M:1305-1405 M:1405-1505 M:1505-1605 M:1605-1705 M:1705-1805 M:1805-1905 M:1905-2005 M:2005-2205 M:2205-2405 M:2405-2605 M:2605-2805 M:2805-3005 '+ $
    'M:3005-inf  '+$
    'N:5-15      N:15-25     N:25-35     N:35-45     N:45-55     N:55-65     N:65-75     N:75-85     N:85-95     N:95-105    N:105-115   N:115-125   '+ $
    'N:125-135   N:135-145   N:145-155   N:155-165   N:165-175   N:175-185   N:185-195   N:195-205   N:205-225   N:225-245   N:245-265   N:265-285   '+ $
    'N:285-305   N:305-325   N:325-345   N:345-365   N:365-385   N:385-405   N:405-425   N:425-445   N:445-465   N:465-485   N:485-505   N:505-555   '+ $
    'N:555-605   N:605-655   N:655-705   N:705-755   N:755-805   N:805-855   N:855-905   N:905-955   N:955-1005  N:1005-1105 N:1105-1205 N:1205-1305 '+ $
    'N:1305-1405 N:1405-1505 N:1505-1605 N:1605-1705 N:1705-1805 N:1805-1905 N:1905-2005 N:2005-2205 N:2205-2405 N:2405-2605 N:2605-2805 N:2805-3005 '+ $
    'N:3005-inf  TotalCounts '
if Liqorice eq 'ice' then begin
    header_strM21=' %accept is the percentage of images accepted by M2.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        strtrim(string(!mass_optionIwc),2)+' Option_Icsp='+strtrim(string(!mass_optionIcsp),2)+'---software version: '+playback_N_2dsview_version_str  +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

    header_strM41=' %accept is the percentage of images accepted by M4.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        strtrim(string(!mass_optionIwc),2)+' Option_Icsp='+strtrim(string(!mass_optionIcsp),2) +'---software version: '+playback_N_2dsview_version_str +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

    header_strM51=' %accept is the percentage of images accepted by M5.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        strtrim(string(!mass_optionIwc),2)+' Option_Icsp='+strtrim(string(!mass_optionIcsp),2) +'---software version: '+playback_N_2dsview_version_str  +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

    header_strM61=' %accept is the percentage of images accepted by M6. #N_0-50 #N_50-250 are accepted M2 particles in the size range, #N_>250 are '+$
        ' accepted M1 particle >250um  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        strtrim(string(!mass_optionIwc),2)+' Option_Icsp='+strtrim(string(!mass_optionIcsp),2) +'---software version: '+playback_N_2dsview_version_str +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'
    header_strM71=' %accept is the percentage of images accepted by M7.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        strtrim(string(!mass_optionIwc),2)+' Option_Icsp='+strtrim(string(!mass_optionIcsp),2)+'---software version: '+playback_N_2dsview_version_str   +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

endif;  endif of if liqorice eq 'ice'

if liqorice eq 'liq' then begin
    ;**********************************
    header_strM21=' %accept is the percentage of images accepted by M2.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        'Assume it is liquid sphere '+ ' Option_Icsp= assume liquid sphere'+'---software version: '+playback_N_2dsview_version_str  +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

    header_strM41=' %accept is the percentage of images accepted by M4.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        'Assume it is liquid sphere '+ ' Option_Icsp= assume liquid sphere '+'---software version: '+playback_N_2dsview_version_str +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

    header_strM51=' %accept is the percentage of images accepted by M5.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        'Assume it is liquid sphere '+ ' Option_Icsp= assume liquid sphere'+'---software version: '+playback_N_2dsview_version_str  +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'

    header_strM61=' %accept is the percentage of images accepted by M6. #N_0-50 #N_50-250 are accepted M2 particles in the size range, #N_>250 are '+$
        ' accepted M1 particle >250um  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        'Assume it is liquid sphere '+ ' Option_Icsp= assume liquid sphere'+'---software version: '+playback_N_2dsview_version_str +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'
    header_strM71=' %accept is the percentage of images accepted by M7.  #_irreg is the number of timing irregularities that occured during that second. C-column unit is #/L/um, A-column unit is mm2/L/um'+$
        ' M-column unit is  g/m3/um  N-column is counts/bin. Mass OptionIWC='+$
        'Assume it is liquid sphere '+ ' Option_Icsp= assume liquid sphere '+'---software version: '+playback_N_2dsview_version_str   +'     Microns_per_pixel='+strtrim(string(microns_per_pixel),2)+'um'
endif

case !autoarchive_method of
    'M1': printf,21,header_strM11
    'M2': printf,21,header_strM21
    'M4': printf,21,header_strM41
    'M5': printf,21,header_strM51
    'M6': printf,21,header_strM61
    'M7': printf,21,header_strM71
endcase
printf,21,header_strM12

nnnH=n_elements((*alldataH).area)
nnnV=n_elements((*alldataV).area)
data_starttime=min([(*alldataH)(0).nanoseconds,(*alldataV)(0).nanoseconds]);  common H and V starttime
data_startseconds=round(data_starttime/1000000000.0); start earlier; no trouble hope.

HlastTime=(*alldataH)(nnnH-1LL).nanoseconds
VlastTime=(*alldataV)(nnnV-1LL).nanoseconds
data_endtime  =max([HlastTime,VlastTime]);take the max of  H avd V endtime.


; added this on June 5, 2007 to avoid archiving from 0 second to 20-hours  that takes days to do.

;calculate the file_name-start_time from the datetimestring
if strlen(datetimestring) lt 20 then begin
    filename_startTime1=strmid(datetimestring,6,6)
    filename_startsec=(strmid(filename_starttime1,0,2)*3600LL+strmid(filename_starttime1,2,2)*60LL+$
        strmid(filename_starttime1,4,2)*1LL)
    fileName_endsec  =(data_endtime/1000000000LL-1LL)

    if fileName_endsec lt filename_startsec then begin
        fileName_endSec=86400000000000LL;  to teh time 24:00:00 seconds.
        rrr=dialog_message('End_time less than start time, archive to midnight!!',/information)
        ;stop
    endif
endif

if strlen(datetimestring) ge 20 then begin ; for this kind:070808202239_202306_0000
    filename_startTime2=strmid(datetimestring,13,6);   ;that is 20:23:06
    filename_startsec=(strmid(filename_starttime2,0,2)*3600LL+strmid(filename_starttime2,2,2)*60LL+$
        strmid(filename_starttime2,4,2)*1LL)
    fileName_endsec  =(data_endtime/1000000000LL) ;  >  fileName_startSec

    if fileName_endsec lt filename_startsec then begin
        fileName_endSec=86400000000000LL;  to teh time 24:00:00 seconds.
        rrr=dialog_message(['End_time less than start time, archive to midnight!!'],/information)
        print,!currentHFname
        ;stop
    endif
endif

if strlen(datetimestring) ge 30 then begin
    filename_endTime1=strmid(datetimestring,20,6)
    filename_Endsec=(strmid(filename_endtime1,0,2)*3600LL+strmid(filename_endtime1,2,2)*60LL+$
        strmid(filename_endtime1,4,2)*1LL)
    if fileName_endsec lt filename_startsec then begin
        fileName_endSec=86400LL;  to teh time 24:00:00 seconds.
        rrr=dialog_message('End_time less than start time, archive to midnight!!',/information)
        print,!currentHFname
        ;stop
    endif
endif else begin
    filename_Endsec= (round(data_endtime/1000000000.0)) ;> fileName_startSec

    if fileName_endsec lt filename_startsec then begin
        fileName_endSec=86400LL;  to the time 24:00:00 seconds.
        rrr=dialog_message('End_time less than start time, archive to midnight!!',/information)
        print,!currentHFname
        ;stop
    endif
endelse

;*************************************************************************************
; changed to following line for namma data , because it is very odd in the namma data
; if data_startseconds eq 0LL then begin
; data_startseconds=(firstdata.nanoseconds/1000000000LL +0LL); start earlier; no trouble hope.
; endif

data_endseconds  =floor(data_endtime/1000000000LL +0LL);  changed from +1LL to +0LL on Oct23,2007.
nnn=(data_endseconds-data_startseconds) > 2; make at least 2 points for 1 second.

ferry1=0
;make aaccount of ferry flight the wrong time.
if ferry1 eq 1 then begin ; 3V2DS time is 7 hours ahhead of CPIview time.
    seconds_offset=17LL*3600LL;  00:25:00  to 17:25:00
endif else seconds_offset=0LL

starttime_insec=filename_startSec >data_startseconds;   data_startseconds

if strlen(datetimestring) eq 12 then  starttime_insec=filename_startSec > data_startseconds

;added this part in June 5 2007 to avoid archiving from 0 seconds to 20-hourse
;*********************************************************************************
; if abs(long64(starttime_insec)-long64(filename_startsec)) gt 1 then begin
if data_startseconds eq 0 then begin
    print,'data_start_time=',starttime_insec
    print,'filename_start_time =',filename_startsec
    print,'data_startseconds eq 0, use filename_start_time_to start_archiving___, Warning ****** !!!!'
    ; rrr=dialog_message('Looks like data start_time is too much off setted, use file_name-start_time ?',/question)
    ; if rrr eq 'Yes' then starttime_insec=filename_startsec else stop
    starttime_insec=filename_startsec

endif
;*********************************************************************************

;Get 1Hz bin file end second time. fixed that after sorted there is some time spikes in the sorted file
; max_seconds=1LL+(lastData.nanoseconds > lastdataV.nanoseconds)/1000000000LL
; data_endseconds= (data_endseconds < max_seconds);56040LL
; comment above to line and added below one line on oct 23, 2007.
data_endseconds= (data_endseconds < filename_endsec )

total_seconds=(data_endseconds-data_startseconds) > 2;  for calculation the percentage done.
Five_percent=(total_seconds/20LL) > 1
Done_count=0

; ******************************************************
make_61_bins_ultimate,microns_per_pixel,nbins,nedges,xpts,binwidths122; xptsjunk(0)=5; xptsjunk(1)=15 IN HERE.
um_per_pixel=microns_per_pixel
binwidths61=binwidths122(0:n_elements(binwidths122)-1:2)
bincenters61=fltarr(61)
for i=0,60 do bincenters61(i)=(xpts(2*i)+xpts(2*i+1))/2.0
bincenters61(60)=xpts(59)+10.0*um_per_pixel;  % last bin's bin_width is 20.0*microns_per_pixels.
;*******************************************************



while starttime_insec Le (filename_endSEc-1LL) do begin

    endtime_insec=starttime_insec+Nseconds
    starttime=starttime_insec*1000000000LL; nanoseconds

    endtime  =  endtime_insec*1000000000LL;  nanoseconds


    Are_there_non_monotonic_data,startTime,endTime,H_has_bad,V_has_bad

    if HorV eq 'H' then H_Has_bad=H_Has_bad else H_has_bad=V_has_bad

    ;*************************************************************************************************
    if H_has_bad eq 0 then begin
        if !autoarchive_method eq 'M6' then begin
            get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,HorV,'M6=1','M1',liqorice,starttime,endtime,$ ;inputs
                has_dataM1,xpts,bincenters61,binwidths61,binwidths122,nptsM1,mndM1,mvdM1,efdM1,yptsM1,AptsM1,Iptsm1,ystrM1,sizesM1,areasM1,adjsM1,HliveV,Hdeadtime,adjustmentfactorM1,T1_T2_data,round_flag = round_flag; outputs
            get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,HorV,'M6=1','M2',liqorice,starttime,endtime,$ ;inputs
                has_dataM2,xpts,bincenters61,binwidths61,binwidths122,nptsM2,mndM2,mvdM2,efdM2,yptsM2,AptsM2,IptsM2,ystrM2,sizesM2,areasM2,adjsM2,HliveV,Hdeadtime,adjustmentfactorM2,T1_T2_data,round_flag = round_flag; outputs
            ;make the combined 64 bins data and the time series of the M1 M2 methods.

            Make_M1M2_64bins_data,xpts,nptsM1,nptsM2,$ ; input
                HnptsM1M2,Hnbin1,Hnbin2,Hbin3; output; also PartcontM1, partcontM2
            Make_M1M2_64bins_data,xpts,yptsM1,yptsM2,$ ; input
                HyptsM1M2,Hbin1,Hbin2,Hbin3; output; also PartcontM1, partcontM2
            Make_M1M2_64bins_data,xpts,AptsM1,AptsM2,$ ; input
                HAptsM1M2,Hbin1b,Hbin2b,Hbin3b; output; also PartcontM1, partcontM2
            Make_M1M2_64bins_data,xpts,IptsM1,IptsM2,$ ; input;  I means ice
                HIptsM1M2,Hbin1c,Hbin2c,Hbin3c; output; also PartcontM1, partcontM2
            adjustmentfactor=adjustmentfactorM1;  ???????????????????????
            adjustmentfactorH=adjustmentfactor

            has_data=has_dataM1 or has_dataM2
            ;replace PartcontM1 and PartcontM2 with size range values.
            ;junk=where(sizesM2 le 26.50 and sizesM2 gt 0.0,HPartcontM2); accepted M2 particles.
            ;junk=where(sizesM1 gt 32.50,HPartcontM1); accepted  M1 particles.
            GetM6_GoodPercent_between_t1_t2,HorV,SizesM1,sizesM2,adjsM1,adjsM2,starttime,endtime,HNGoodpercent,Hirregular_cont
            ;**********************************************************************
            Hconc =total(HyptsM1M2*binwidths61) ; #/L
            Hextn = 2.0*total(HAptsM1M2*binwidths61);  mm^2/L
            HIWC =total(HIptsM1M2*binwidths61);    mg/L

            Hnpts=HnPtsM1M2
            HApts=HAPtsM1M2
            HIPts=HIPtsM1M2
            HYpts=HyptsM1M2
            Hlt=1.0-Hdeadtime
            if HliveV le 0.13 then goto, has_bad_data_h
            if adjustmentfactor eq 0.0 then begin
                Hsv=HliveV >0.00000001
            endif else begin
                Hsv=(HliveV >0.00000001)/adjustmentfactor
                if HliveV gt 4.0*microns_per_pixel then begin
                    mymessage='Sample volume too big '+HorV+'liveV='+string(HliveV)+'At time:' + string(startTime)+'--'+string(endtime)
                    print,mymessage;  ;open a file to write the problematic time periods.
                    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
                    openw,8,outputfilename,/append
                    printf,8,mymessage
                    close,8
                    goto,has_bad_data_h
                endif
            endelse
            ;*********************************************************************
            ;now get the mnd, mvd and efd   number mean diameter ,m medianVollume diatmeter and effective diameter.
            Get_Number_Mean_Diameter_from_NPSD,Hnpts,bincenters61,mnD
            Get_Median_Volume_Diameter_from_MPsd,HIpts,binwidths61,bincenters61,MVD
            Get_Effective_Diameter_from_APSD_and_MPSD,HAPts,HIpts,binwidths61,efD

        endif else begin;  here is M1, M2, M4
            ;get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,'M4',starttime,endtime,$ ;inputs
            ;has_data,xpts,Hypts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,Partcont,adjustmentfactor; outputs
            get64binUltimate_Hpsd_Size_Area_Adjs_HliveV_Hdeadtime_between_t1_t2,HorV,'M6=0',!autoarchive_method,liqorice,starttime,endtime,$ ;inputs
                has_data,xpts,bincenters61,binwidths61,binwidths122,Hnpts,mnd,mvd,efd,Hypts,HApts,HIpts,ystr,sizes,areas,adjs,HliveV,Hdeadtime,adjustmentfactor,T1_T2_data,round_flag = round_flag; outputs

            Get61bin_Hpsd_N_Ngood_NgoodPercent_PerBin_between_t1_t2,HorV,sizes,starttime,endtime,HNGoodpercent,Hirregular_cont


            ;print,HliveV,'  ',Hdeadtime,'toatl_adjs=',total(adjs),' ',partcont,' time=',starttime, 'factor=',adjustmentfactor
            ;print,'Hypts=',Hypts(0:3)
            ;if starttime eq 56770000000000LL then stop
            adjustmentfactorH=adjustmentfactor
            Hlt=1.0-Hdeadtime
            if HliveV le 0.13 then goto, has_bad_data_h
            if adjustmentfactor eq 0.0 then begin
                Hsv=HliveV >0.00000001
            endif else begin
                Hsv=(HliveV >0.00000001)/adjustmentfactor
                if HliveV gt 4.0*microns_per_pixel then begin
                    mymessage='Sample volume too big HliveV='+string(HliveV)+'At time:' + string(startTime)+'--'+string(endtime)
                    print,mymessage;  ;open a file to write the problematic time periods.
                    outputfilename=strmid(!currentHFname,0,strlen(!currentHFname)-4)+'PopUpMessages.txt'
                    openw,8,outputfilename,/append
                    printf,8,mymessage
                    close,8
                    goto,has_bad_data_h
                endif
            endelse

            Hconc=total(Hypts*binwidths61); #/L
            Hextn=2.0*total(HApts*binwidths61); 1/km.
            HIWC =total(HIpts*binwidths61); g/M3.
        endelse


        ; get the  TAS mean values during this seconds and the Correct TAS values to correct the HliveV.
        ;Added flowing to correct for maCpex because TAS is not correct.

        ;if !use_nav_tas_correct_L1n eq 1  then begin

        if !use_external_TAS eq 1  then begin

            indexCor=where(extTime ge StartTime_insec and extTime le EndTime_insec,contGcor)
            if contGcor gt 0 then begin
                TAS_correct =mean( extTAS(indexCor))
            endif else begin
                indexCor=where(abs(extTime-StartTime_insec) eq min(abs(extTime-Starttime_insec)))
                TAS_correct=extTAS(indexCor(0))
            endelse

            indexTAS=where((*alldata).nanoseconds ge StartTime and (*alldata).nanoseconds le EndTime, contTas)
            if contTAS gt 0 then begin
                This_mean_TAS=mean((*alldata)(indexTAS).tas)
            endif else begin
                indexB=where((*alldata).nanoseconds ge startTime, contB)
                indexA=where((*alldata).nanoseconds le EndTime, contA)
                if contB gt 0 then TASB=(*alldata)(indexB(0)).tas else TASB=(*alldata)(n_elements((*alldata).tas)-1).tas
                if contA gt 0 then TASA=(*alldata)(max(indexA)).tas else TASA=(*alldata)(0).tas
                This_mean_TAS=(TASA+TASB)/2.0
            endelse

            factor_tas= TAS_correct/This_mean_TAS
            Hsv=Hsv*Factor_tas
            HApts=HApts/Factor_tas
            Hypts=Hypts/Factor_tas
            HIpts=HIpts/Factor_tas
            Hconc=Hconc/Factor_tas
            Hextn=Hextn/Factor_tas
            HIWC =Hiwc/Factor_tas
            Get_Number_Mean_Diameter_from_NPSD,Hnpts,bincenters61,mnD
            Get_Median_Volume_Diameter_from_MPsd,HIpts,binwidths61,bincenters61,MVD
            Get_Effective_Diameter_from_APSD_and_MPSD,HAPts,HIpts,binwidths61,efD

        endif

        ;********************************************************************
        total_ns=total(Hnpts)
        if total_ns lt 0.0 then total_ns = -999

        printf,21,format='(I5,1x,I3,1x,8(E11.3,1x),245(E11.3,1x))',$
            starttime_insec+seconds_offset, HNgoodpercent,Hirregular_cont,Hsv,Hconc,Hextn,HIWC,mnD,mvD,efD, $;  Time + 9 numbers
            Hypts,HApts,HIpts, Hnpts, total_ns; ( 4x61bins + 1) values values.

        ;**************************************************************************

        ;check to see if conts 0to50 and 50to250 and gt250 are the same as npts
        ;if Hcont0to50 ne total(Hnpts(0:4)) then begin
        ;     stop
        ;endif

        ;if Hcont50to250 ne total(Hnpts(5:21)) then begin
        ;     stop
        ;endif

        ;if Hcontgt250 ne total(Hnpts(22:60)) then begin
        ;      stop
        ; endif




        ;**************************************************************************
    endif else begin;  H_has_bad =1 there is bad time in the time interval.
        has_bad_data_h:

        Hconc=bad_data
        T1_T2_data=T1_T2_data_bad
        adjustmentfactorH=-0.999

        ;********************************************************************
        printf,21,format='(I5,1x,I3,1x,8(E11.3,1x),245(E11.3,1x))', starttime_insec+seconds_offset,0.0,(fltarr(253)+bad_data)
        ;**************************************************************************

    endelse

    done_count=done_count+1LL

    if done_count mod five_percent eq 0 and n_elements(info) gt 0  then begin
        percentage=100.0*float(done_count)/float(total_seconds)
        Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value=$
            string( format = '("Archiving Done:" , F5.0,"%")',percentage)
    endif
    ;*************************************************************
    ;printf,23,'Time,  Overload,   Total,   Sample.V,  SV.adj  TAS    Total  Fake.Events  Particles  rejected#  accepted#  Conc

    if !autoarchive_method eq 'M1' then begin
        indexQc=where((*alldata).nanoseconds ge Starttime and (*alldata).nanoseconds lt endtime and (*alldata).area le 0.0,HNareaLe0)
        indexQc=where((*alldata).nanoseconds ge Starttime and (*alldata).nanoseconds lt endtime and (*alldata).area gt 0.0,HNareaGT0)
        indexQc=where((*alldata).nanoseconds ge Starttime and (*alldata).nanoseconds lt endtime and (*alldata).reject gt 0.0,HNrejected)
        indexQc=where((*alldata).nanoseconds ge Starttime and (*alldata).nanoseconds lt endtime and (*alldata).reject eq 0.0,HNaccepted)

        indexQc=where((*alldata).nanoseconds ge Starttime and (*alldata).nanoseconds lt endtime,Htot_event)

        totalDeadtime =-0.999; float(total_AccDeadTime)*10.0*10.0^(-6)/thisTAS;  seconds.
        ovfl_deadTime =-0.999;  float(DT_ovfl)*10.0*10.0^(-6)/thisTAS;  seconds.
        maskDeadtime  =-0.999;float(DT_mask)*10.0*10.0^(-6)/ThisTAS
        Bad1DeadTime  =-0.999;float(DT_bad1)*10.0*10.0^(-6)/ThisTAS
        Bad2DeadTime  =-0.999;float(DT_bad2)*10.0*10.0^(-6)/ThisTAS
        Bad3DeadTime  =-0.999;float(DT_bad3)*10.0*10.0^(-6)/ThisTAS

        if H_has_bad eq 0 then begin
            if T1_T2_data.sampleVolume gt 0.0 and T1_T2_data.total_accdeadTime ge 0 then begin
                totalDeadtime =float(T1_T2_data.total_AccDeadTime)*10.0*10.0^(-6)/(T1_T2_data.thisTAS);  seconds.
                ovfl_deadTime =float(T1_T2_data.DT_ovfl)*10.0*10.0^(-6)/T1_T2_data.thisTAS;  seconds.
                maskDeadtime  =float(T1_T2_data.DT_mask)*10.0*10.0^(-6)/T1_T2_data.ThisTAS
                Bad1DeadTime  =float(T1_T2_data.DT_bad1)*10.0*10.0^(-6)/T1_T2_data.ThisTAS
                Bad2DeadTime  =float(T1_T2_data.DT_bad2)*10.0*10.0^(-6)/T1_T2_data.ThisTAS
                Bad3DeadTime  =float(T1_T2_data.DT_bad3)*10.0*10.0^(-6)/T1_T2_data.ThisTAS
            endif
        endif

        if 1 eq 2 then begin;       this just for looking at the headers.
            printf,23,'Time, ovld Overld   maskdead  badtype1 badtype2 badtype3 Total   SampleV SV.adj TAS Total  Fake.N Part.N rejct# accpt# Concentration overld_dead total_Dead  Dead_L1'
            printf,23,'secs,  #/s DeadTime  seconds   seconds  seconds seconds DeadTime (Liter) factor m/s events area<0 area>0 counts counts    (#/L)        (ticks)     (ticks)   (ticks) '
        endif
        printf,23,format='(I5,1x,I4,1x, 6(F8.5,1x), F7.4,1x, F6.3,1x,I3,1x, 5(I6,1x),                    E13.3,   1x,   I11,1x,  I10,1x,I8)',$
            starttime_insec+seconds_offset,T1_T2_data.ovldcnts, ovfl_deadtime, maskdeadtime, Bad1Deadtime,Bad2Deadtime, Bad3deadtime,$
            totaldeadTime,T1_T2_data.sampleVolume,adjustmentfactorH,T1_T2_data.ThisTAS,Htot_event, HNareaLe0, HNareaGT0,HNrejected, HNaccepted, Hconc,T1_T2_data.DT_ovfl, T1_T2_data.total_accDeadTime,T1_T2_data.DT_L1
    endif; endif of if !autoarchive_method eq 'M1'.

    ;****************************************************************
    starttime_insec=endtime_insec

endwhile
close,21,23
print,'Finished 1 seconds ultimate psd archive processing !!   '+HorV+' '+!autoarchive_method +'  ****' + !currentHFname

; Plot out the 1Hz data in  a few png pages.
if HorV eq 'H' then begin;   look for H  file  only and plot.
    plot_current_1Hz_ascii_file_data, Houtputfilename
    psd2d_mo,Houtputfilename

endif

if HorV eq 'V' then begin;   look for both H file and V 1hz fiel and load both files.  if H fine is not available, then just do the V 1Hz file.
    plot_current_1Hz_ascii_file_data, Houtputfilename
    psd2d_mo,Houtputfilename
endif
free_all
end ; do_Nsecond_ultimate_archive_61bins, HorV


