
; File: Do_manual_habit_change
; Author:  Mo Qixu SPEC Inc. <mo@specinc.com>
; Purpose:  part of CPI and 3V-CPI View image analysis, the proceedures in this file set up a GUI widget that displays
;           multiple CPI images, and allows the user to scroll through the file and manually edit the assigned crystal phase of the images
;1.1.28 Version update on 2014-09-24  ---fix crashes when no criteria is input and when sph or ice is selected.


PRO habit_view_event, event
    ; this routine handle only motion and mouse button events on the draw area
    ;   XSection  true means draw cross section lines
    forward_function Get_manual_page_ROI

    err=0
    catch,err
    if(err ne 0)then begin
        return
    endif


    WIDGET_CONTROL, event.top, GET_UVALUE=localstate

    pstateinfo=localstate.pstateinfo

    if(size(*pStateInfo,/type) ne 8)then return ; avoid cases where this struture is not defined

    CASE event.TYPE OF

        0: BEGIN   ; Mouse button was pressed
            ; now handle which button was pressed

            case event.press of

                1: BEGIN ;left mouse button
                    if localstate.sort_page eq 1 then begin
                        r=dialog_message([['Can not do habit correction in this mode !'],$
                            [' click all/sph/ice and fresh to continue !']],/information)
                        return
                    endif

                    x = event.x
                    y = event.y

                    ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
                    info = Get_manual_page_ROI(localstate, x, y)
                    RoiNum=info(0)
                    k=info(1)
                    oX=info(2)
                    oY=info(3)
                    dx=info(4)
                    dy=info(5)
                    Imgfrmct=0


                    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0);  and not (*(*pStateInfo).pFileScan).badframe )
                    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
                    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.


                    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)
                    frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
                    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
                    Time.hour  =framedata.FrameHeader.hour
                    Time.minute=framedata.FrameHeader.minute
                    Time.sec   =framedata.FrameHeader.sec
                    Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
                    pROIArray = FrameData.pFrame

                    getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;     ;in processTime_lib2.pro; objdata.pframe is the imagehdear31 of crsytal,cutoff
                    if n_tags(objdata) lt 3 then return
                    objheaders=(*(objdata.pframe))
                    objheader =objheaders(roinum).imageheader
                    fpos=(*objdata.PimHDfpos)[Roinum]

                    ;objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[imgFrmCt].fPos)
                    ;objheader get from get_obj_header is PimgHdpos number in it. so it it easy to modify the header and put it back in the file.
                    ; objheader={FrameHeader:FrameHeader,pFrame:pFrame,pImHDfPos:ptr_new(imageHeaderFPOS)}
                    ; ROIArray is an array of pointers for each particle in the frame
                    ;may need to decide which roi it is in here.

                    ROIArray = *frameData.pFrame;  RoiArray are n_img rois.

                    (*pStateInfo).manual = !true

                    ; first test for Reject, if positive, cancel reject and set Sphere
                    if (*objData.pFrame)[roinum].imageheader.crystal ne 0B then begin ; set reject
                        (*objData.pFrame)[roinum].imageheader.crystal = 0B ; set reject
                        objheader.crystal=0B
                        ; objheader.area=float(0.0);  for area=0.0
                        wset,localstate.MviewID1
                        img = *ROIArray[Roinum].pROI
                        tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
                        Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
                        Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)
                        xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
                        xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device
                        xyouts,x,y,'reject',color=[255,255,255],/device
                        (*objData.pFrame)[roinum].imageheader.P1 = 1.0 ; set P1, which seems to be update GUI

                        (*pStateInfo).UpdateFile = !true

                        ; update the .obj file with the new values
                        ; make sure the obj file position is correct.  That is determined by imgfrmct.
                        ;update_obj_header1,(*pStateInfo).ObjLUN, (*(*(*pStateInfo).pObjData).pImHDfPos)[index], (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                        update_obj_header1,(*pStateInfo).ObjLUN, fpos, objheader
                        if (*pStateInfo).UpdateFile then UpdateBlock, pStateInfo

                    endif;  if particle is water of ice, reject it  if reject button is clicked.  Otherwise, leave it alone.
                    ;I need to updata the objlist too to make it effective right after the click.
                    ;(*(*pStateInfo).pObjList)[imgFrmCt] Objlist is the number of valid frames ==FrameNumber slider's number.



                END   ;----------  end of right mouse press  case 4 ---------------------------------------------------------------
                4: BEGIN ;right mouse button
                    if localstate.sort_page eq 1 then begin
                        r=dialog_message([['Can not do habit correction in this mode !'],$
                            [' click all/sph/ice and fresh to continue !']],/information)
                        return
                    endif

                    x = event.x
                    y = event.y

                    ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
                    info = Get_manual_page_ROI(localstate, x, y)
                    RoiNum=info(0)
                    k=info(1)
                    oX=info(2)
                    oY=info(3)
                    dx=info(4)
                    dy=info(5)
                    Imgfrmct=0

                    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 );  and not (*(*pStateInfo).pFileScan).badframe )
                    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
                    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.


                    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)
                    frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
                    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
                    Time.hour  =framedata.FrameHeader.hour
                    Time.minute=framedata.FrameHeader.minute
                    Time.sec   =framedata.FrameHeader.sec
                    Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
                    pROIArray = FrameData.pFrame

                    getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;     ;in processTime_lib2.pro; objdata.pframe is the imagehdear31 of crsytal,cutoff
                    if n_tags(objdata) lt 3 then return
                    objheaders=(*(objdata.pframe))
                    objheader =objheaders(roinum).imageheader
                    fpos=(*objdata.PimHDfpos)[Roinum]

                    ;objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[imgFrmCt].fPos)
                    ;objheader get from get_obj_header is PimgHdpos number in it. so it it easy to modify the header and put it back in the file.
                    ; objheader={FrameHeader:FrameHeader,pFrame:pFrame,pImHDfPos:ptr_new(imageHeaderFPOS)}
                    ; ROIArray is an array of pointers for each particle in the frame
                    ;may need to decide which roi it is in here.

                    ROIArray = *frameData.pFrame;  RoiArray are n_img rois.

                    (*pStateInfo).manual = !true
                    ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1

                    ; On Right Click, cycle through 3 states:
                    ; 1) Crystal Habit = Sphere
                    ; 2) Crystal Habit = ice
                    ; 3) Reject Image

                    ; first test for Reject, if positive, cancel reject and set Sphere

                    if ((*objData.pFrame)[roinum].imageheader.crystal eq 15B) then begin
                        (*objData.pFrame)[roinum].imageheader.crystal = 1B ; set sphere
                        objheader.crystal=1B
                        wset,localstate.MviewID1
                        ;********************************************
                        img = *ROIArray[Roinum].pROI
                        tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
                        Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
                        Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)
                        xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
                        xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device
                        xyouts,x,y,'sph',color=[255,255,255],/device

                        ; ensure GUI display flag is set so that it will be unset with next command (likely a better way of doing these two lines, but not a time crunch here)
                    endif else begin
                        if  ((*objData.pFrame)[Roinum].imageheader.crystal eq 1B) then begin ; if Sphere, set ice
                            (*objData.pFrame)[Roinum].imageheader.crystal = 15B ; set ice
                            objheader.crystal=15B
                            wset,localstate.MviewID1
                            ;********************************************
                            img = *ROIArray[roinum].pROI
                            tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
                            Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
                            Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)
                            xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
                            xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device
                            xyouts,x,y,'ice',color=[255,255,255],/device
                            ;ensure GUI display flag is set so that it will be unset with next command (likely a better way of doing these two lines, but not a time crunch here)
                        endif   else begin
                            if  ((*objData.pFrame)[Roinum].imageheader.crystal eq 0B) then begin ; if 0, set sphere
                                (*objData.pFrame)[Roinum].imageheader.crystal = 1B ; set ice
                                objheader.crystal=1B
                                wset,localstate.MviewID1
                                ;********************************************
                                img = *ROIArray[roinum].pROI
                                tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
                                Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
                                Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)
                                xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
                                xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device
                                xyouts,x,y,'sph',color=[255,255,255],/device
                            endif
                        endelse

                    endelse

                    (*objData.pFrame)[roinum].imageheader.P1 = 1.0 ; set P1, which seems to be update GUI

                    (*pStateInfo).UpdateFile = !true

                    ; update the .obj file with the new values
                    ; make sure the obj file position is correct.  That is determined by imgfrmct.
                    ;update_obj_header1,(*pStateInfo).ObjLUN, (*(*(*pStateInfo).pObjData).pImHDfPos)[index], (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                    update_obj_header1,(*pStateInfo).ObjLUN, fpos, objheader

                    if (*pStateInfo).UpdateFile then UpdateBlock, pStateInfo

                    ;I need to updata the objlist too to make it effective right after the click.
                    ;(*(*pStateInfo).pObjList)[imgFrmCt] Objlist is the number of valid frames ==FrameNumber slider's number.

                END   ;----------  end of right mouse press  case 4 ---------------------------------------------------------------

                else:   ;do nothing for event.press
            endcase  ; end of event.press case statement
        END; end of CASE  0

        1: ;button pressed no action

        2: BEGIN ; Mouse moving - no buttons clicked
            return
        END    ; ******************************************************************** END OF MOTION EVENT ******************
        ELSE:begin ; called for button press and exposure
        message = 'error in view_event... mising case type: '+ string(event.type)
        r=dialog_message(message)
    END
ENDCASE ;( event.type )

END





PRO Do_manual_habit_change_event, event

    WIDGET_CONTROL, event.top, GET_UVALUE= LocalState,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of
        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        ; I should clean up in here. and release it to go back to zoom window.
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin

    ; Handle a sizing request
    'WIDGET_BASE':begin
    ; WIDGET_CONTROL, event.top, XSIZE =1000, YSIZE =800  ; added by mo sept 9,2004
    ; WIDGET_CONTROL, LocalState.MViewID1, XSIZE = 780, YSIZE =560
    ;Plot_fast_fssp, LocalState
    WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
    return
end

else: begin

    ; a normal event

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval
    CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
        'Help_notes':begin
        messages=[['Note:by Spec Inc  Qixu Mo--moqixu@yahoo.com'],$
            ['                                         '],$
            ['                                         '],$
            ['1. Click the left mouse button to reject an image.'],$
            [' '],$
            ['2. Click the right mouse button to toggle the image habit classification between ice and sphere.'],$
            ['                           '],$
            ['3  Click on one of the buttons at the top of the page (detailed below) to save changes.'],$
            ['                        '],$
            ['4. "Prev Page" fills the page with the previous (earlier time) set of images.'],$
            ['                                     '],$
            ['5. "Next Page" fills the page with the next (later in time) set of images.'],$
            ['                                     '],$
            ['                       '],$
            ['6. "Refresh" refreshes the current page with the change applied.'],$
            ['                                                              '],$
            ['7. "Sort" sorts the current page of images, displaying first those classified as "sph", followed by "ice".'],$
            ['                                                              '],$
            ['8.  "Fill" fills the page beginning at the earliest image following the entered Start Time, with the selected habit classification type.'],$
            ['                                                                             '],$
            ['9.  "Make all sphere" changes the classification of all images in the current page to sphere.'],$
            ['                                          '],$
            ['10. "Make all ice" changes the classification of all images in the current page to ice.']]
        rrr=dialog_message(messages,/information)
    end

    ;*******************************


    'Habit':  begin
        if event.value eq 0 then localstate.crystal=0
        if event.value eq 1 then localstate.crystal=1
        if event.value eq 2 then localstate.crystal=15
    end

    'startDay':begin
    if event.value gt 31 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.startDay=1
    endif else localstate.startDay=event.value
end

'starthh':begin
if event.value gt 24 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.starthh=24
endif else localstate.starthh=event.value
StartTime=localstate.StartTime
StartTime.hour=localstate.starthh
localstate.StartTime=StartTime
end

'startmm':begin
if event.value gt 59 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.startmm=59
endif else localstate.startmm=event.value
StartTime=localstate.StartTime
StartTime.minute=localstate.startmm
localstate.StartTime=StartTime
end
'startss':begin
if event.value gt 59 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.startss=59
endif else       localstate.startss=event.value
StartTime=localstate.StartTime
StartTime.sec=localstate.startss
localstate.StartTime=StartTime
end

'startms': begin
    if event.value gt 999 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.startms=999
    endif else  localstate.startms=event.value
    StartTime=localstate.StartTime
    StartTime.msec=localstate.startms
    localstate.StartTime=StartTime
end

'EndDay':begin
if event.value gt 31 then begin
    rr9=dialog_message('value too large, try again',/information)
    localstate.startDay=1
endif else localstate.stopDay=event.value
end

'Endhh': begin
    if event.value gt 24 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stophh=24
    endif else localstate.stophh=event.value
    EndTime=localstate.EndTime
    EndTime.hour=localstate.stophh
    localstate.EndTime=EndTime
end
'Endmm': begin
    if event.value gt 59 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stopmm=59
    endif else       localstate.stopmm=event.value
    EndTime=localstate.EndTime
    EndTime.minute=localstate.stopmm
    localstate.EndTime=EndTime
end
'Endss': begin
    if event.value gt 59 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stopss=59
    endif else  localstate.stopss=event.value
    EndTime=localstate.EndTime
    EndTime.sec=localstate.stopss
    localstate.EndTime=EndTime

end

'Endms': begin
    if event.value gt 999 then begin
        rr9=dialog_message('value too large, try again',/information)
        localstate.stopms=999
    endif else  localstate.stopms=event.value
    EndTime=localstate.EndTime
    EndTime.msec=localstate.stopms
    localstate.EndTime=EndTime
end

'Prev_page': begin
    ;Change StartTime to be a new Time=last EndTime of the current page and then fill a new page.
    localstate.prev_page=1
    wset,localstate.MViewID1
    Erase
    disp_habit_frame,LocalState,0
    localstate.prev_page=0
    ;refresh  it to make the time order correct.
    wset,localstate.MViewID1
    Erase
    localstate.sort_page=0
    disp_habit_frame, LocalState,1
end

'Next_page': begin
    ;Change StartTime to be a new Time=last EndTime of the current page and then fill a new page.
    StartTime=localstate.EndTime
    localstate.StartTime=StartTime
    wset,localstate.MViewID1
    Erase
    disp_habit_frame,LocalState,0
end

'Refresh_page': begin
    ;input and load the data;;group data;assign data to teh localstate
    wset,localstate.MViewID1
    Erase
    localstate.sort_page=0
    disp_habit_frame, LocalState,1
end

'Sort_page': begin
    ;input and load the data;;group data;assign data to teh localstate
    sort_the_local_states_bounds,localstate
    localstate.sort_page=1
    wset,localstate.MViewID1
    Erase
    disp_habit_frame_sorted,LocalState
end

'Fill_page': begin
    ;start filling the page with current StartTime
    wset,localstate.MViewID1
    Erase
    localstate.sort_page=0
    disp_habit_frame,LocalState,0
end

'ForceAllSphere':  begin
    localstate.sort_page=0
    make_all_in_the_current_page_as_sphere_or_ice,Localstate,'water'
    wset,localstate.MViewID1
    Erase
    disp_habit_frame,LocalState,1
end

'ForceAllice':  begin
    localstate.sort_page=0
    make_all_in_the_current_page_as_sphere_or_ice,Localstate,'ice'
    wset,localstate.MViewID1
    Erase
    disp_habit_frame,LocalState,1
end
'criteria': begin
    widget_control, localstate.criteriaID,get_value=cmd
    localstate.criteria = cmd[0]
end


'QUITfile': BEGIN
    WIDGET_CONTROL, event.top, /DESTROY
    RETURN
END ;endof quit
ELSE:
ENDCASE ; end of event.id case
end
endcase ; end of sname case
WIDGET_CONTROL, event.top, SET_UVALUE=LocalState,/no_copy
END ; Do_manual_habit_change_event



pro disp_habit_frame, LocalState, refresh_page
    ;   This routine displays a set of ROI particle
    ;   Input
    ;     pStateInfo:   main structure holding all info

    ; Keyword
    ;   frameData     Input  structure of frame data, if not present, use currently stored frame

    ; results
    ;   the frame is drawn to the display taking into acount all GUI settings

    ;return
    ;   the bounds of each particle are returned in the bounds array

    Pstateinfo=localstate.Pstateinfo

    wset,localstate.MViewID1

    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 );  and not (*(*pStateInfo).pFileScan).badframe )
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    nnnn=n_elements(imglist)

    ;**********************************************
    if 1 eq 2 then begin
        ; find out of obj time has same numbers.
        nnnnn=n_elements( (*(*pStateInfo).pObjList).fPos );  ; correct should be objtimes=(*(*pStateInfo).pObjList).time
        objtime=fltarr(nnnnn)
        for iii=0L,nnnnn-1L do begin
            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[iii].fPos)
            objtime(iii)= float(objData.frameHeader.time)
        endfor
    endif ; edn of if 1 eq 2
    ;******************************************


    frame_numbers= (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
    ;frameTimes=frame_numbers.hour*3600.0 +frame_numbers.minute*60.0 +frame_numbers.sec*1.0+frame_numbers.msec/1000.0D
    frametimes=localstate.frametimes

    oX=0
    oY=localstate.scr_ysize
    maxdy =0

    ;update image time for later display image.
    widget_control,localstate.Sstrday,set_value=(localstate.startTime).day
    widget_control,localstate.Sstrhr,set_value=(localstate.startTime).hour
    widget_control,localstate.Sstrmin,set_value=(localstate.startTime).minute
    widget_control,localstate.Sstrsec,set_value=(localstate.startTime).sec
    widget_control,localstate.Sstrmsec,set_value=(localstate.startTime).msec

    Time0=localstate.StartTime
    starttime =double(time0.hour)*3600.0+double(time0.minute)*60.0+double(time0.sec)*1.0 + double(time0.msec)/1000.0

    index=where(FrameTimes ge starttime,contG)
    if contG gt 0 then begin
        start_k =index(0); changed from index(0) -1 >0.
    endif else begin
        start_k=0
    endelse

    end_K=nnnn-1LL

    if refresh_page eq 1 then begin
        Time1=localstate.EndTime
        stoptime =double(time1.hour)*3600.0+double(time1.minute)*60.0+double(time1.sec)*1.0 + double(time1.msec)/1000.0

        index=where(FrameTimes ge stoptime,contG)
        if contG gt 0 then begin
            end_k =index(0) < n_elements(FrameTimes)-1LL
        endif else begin
            end_k=n_elements(FrameTimes)-1LL
        endelse
    end
    if localstate.prev_page eq 1 then begin
        End_K=0
        step_K=-1
        ;update_disp_time's last time to be the StartTime before invoking
        widget_control,localstate.Estrday,set_value=Time0.day
        widget_control,localstate.Estrhr,set_value=Time0.hour
        widget_control,localstate.Estrmin,set_value=Time0.minute
        widget_control,localstate.Estrsec,set_value=Time0.sec
        widget_control,localstate.Estrmsec,set_value=Time0.msec
        localstate.EndTime=Time0
    endif else begin
        step_K=1
    endelse

    ith_roi=0
    last_time=0.0D;  added this to compare with current Time so as not to show the same Time of a frame.
    bounds = intarr(1000,7)

    for k =start_K, End_K , step_K do begin;   nnnn-1LL

        ; must read the image data if any roi display or output is required
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)

        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        ; added this Part on August 6, 2010 by mooooooooooooo
        Time.day   =framedata.FrameHeader.day   ; Time is uint of 6 numbers.
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        frameTime = Time.hour*3600.0D + time.minute*60.0D + time.sec*1.0D + time.msec/1000.0D;  Changed to this August 6, 2010

        ;***************************************
        ;objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[imgFrmCt].fPos)

        ; need to get calcStrobe time working for 3V-CPI
        ;objTime = float(objData.frameHeader.time) + calcStrobeTime(objData.frameHeader.arrivalT1,objData.frameHeader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
        ;roiTime = float(framedata.frameheader.time) + calcStrobeTime(framedata.frameheader.arrivalT1,framedata.frameheader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
        ; objTime = float(objData.frameHeader.time)
        ; roiTime = float(framedata.frameheader.time)

        imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )
        ;ROIArray is an array of pointers for each particle in the frame; imgtype=2 is background.----here alway k=0 frame is bad, no know why.

        pROIArray = FrameData.pFrame

        if(size(frameData,/type) eq 8) and ptr_valid(Proiarray) then begin ; skip if this is not a valid frame


            ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
            imgfrmct=0
            if imgframe then getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData

            ;getobjdata input is imgframe and framedata, returned values is pRoiArray and objdata.
            if n_tags(objdata) lt 3 then goto, next_k
            if ptr_valid((objdata.pframe)) eq 0 then goto,next_k

            objheaders=(*(objdata.pframe))

            ; How many ROIs?
            n_imgs = n_elements( *pROIArray )
            ; loop through all the particles in the frame and accumulate into the histogram array by size

            ROIArray = *frameData.pFrame

            FOR RoiNum=0, n_imgs-1 DO begin

                objheader = objheaders(roinum).imageheader
                crystal   = objheader.crystal
                cutoff    = objheader.cutoff
                focus     = objheader.focus
                len       = objheader.len
                wid       = objheader.wid
                area      = objheader.area
                perim     = objheader.perim

                if localstate.crystal eq 1 then begin
                    ;acceptFlag = (focus gt 20 and cutoff lt 6 and crystal eq 1B)
                    rrrr=execute('criteria_out='+localstate.criteria)
                    if rrrr eq 0 then acceptFlag=1 else acceptFlag = (criteria_out and crystal eq 1B)
                endif

                if localstate.crystal eq 15 then begin
                    rrrr=execute('criteria_out='+localstate.criteria)
                    if rrrr eq 0 then acceptFlag=1 else  acceptFlag = (criteria_out and crystal eq 15B)
                endif

                if localstate.crystal eq 0 then begin
                    rrrr=execute('criteria_out='+localstate.criteria)
                    if rrrr eq 0 then acceptFlag=1 else  acceptFlag = (criteria_out)
                endif

                ; Need to handle skipping of seconds here Not sure if this is not already being done!
                if(acceptFlag)then begin
                    ;determine size of image including zoom factor
                    dx = ROIArray[Roinum].ImageHeader.ex - ROIArray[Roinum].ImageHeader.sx + 1
                    dy = ROIArray[Roinum].ImageHeader.ey - ROIArray[Roinum].ImageHeader.sy + 1
                    if dx gt 500.0 or  dy gt 500.0 then begin
                        rrr=dialog_message('image too large, can not dislay, skip over!',/information)
                        update_Start_or_end_time, localstate, Time, refresh_page
                        goto,next_n_imgs;return,0
                    endif

                    ;if accepted(i) ne !true then begin
                    ;goto,next_n_imgs;return,0
                    ;endif

                    if OY lt (dy+20) then begin
                        ;rrr=dialog_message('image too large, can not display, please change time to skip over !',/information)
                        update_Start_or_end_time, localstate, Time, refresh_page
                        delete_obj_header,objData
                        goto,End_display
                    endif
                    ; need to see if image will be off the screen.
                    if(oX + dx GT localstate.scr_xsize*.97)then begin ; image off screen
                        oX = 0
                        OY =Oy-maxdy-20
                        maxdy=dy
                        if OY lt (dy+20) then begin
                            ;rrr=dialog_message('image too large, can not display, please change time to skip over!',/information)
                            update_Start_or_end_time, localstate, Time, refresh_page
                            delete_obj_header,objData
                            goto,End_display
                        endif
                    endif

                    maxdy = maxdy > dy
                    img = *ROIArray[Roinum].pROI

                    tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
                    ; store bounding box coords for checking is mouse is in box

                    Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
                    Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)
                    if last_time ne frametime then begin
                        xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
                        xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device
                        last_time=frametime
                    endif


                    objheaders=(*(objdata.pframe))
                    objheader =objheaders(roinum).imageheader

                    if objheader.crystal  eq 1 then habit_str='sph'
                    if objheader.crystal  eq 0 then habit_str='reject'
                    if objheader.crystal  eq 15 then habit_str='ice'
                    xyouts,oX,(Oy-7),habit_str,color=[255,255,255],/device

                    bounds(ith_roi,*)=[oX,oY-dy-1,oX+dx-1,oY,Roinum,k,objheader.crystal];(bounds(0),bounds(1)+1 is the coordinate to tv-image.
                    ;print, 'roinum=',Roinum, 'k=',k,'imgfrmct=',imgfrmct-1

                    if(oX + dx GT localstate.scr_xsize*.97)then begin ; image off screen
                        oX = 0
                        oY =  oY - maxdy - 20
                        maxdy =0
                    endif else begin
                        oX = oX + dx + 2
                        oY = oY
                    endelse

                    ith_roi=ith_roi+1LL
                    update_Start_or_end_time, localstate, Time, refresh_page
                endif;  end of if the particle is accepted.
                next_n_imgs:
                ;update localstate  store value for the ith_roi  matrix
            endFOR
            ;localstate.oX=oX;  new furture location to put images.
            ;localstate.oY=oY
            delete_obj_header,objData
            next_k:
            ;*******************************************************************
            if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
        endif ; end of IF for valid frameData----if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

    endfor   ; end of k loop
    End_display:
    localstate.bounds=bounds
    ;mark the Time series
    wset,localstate.MviewId2
    erase
    CPI_conc=*(*Pstateinfo).pConc
    CPI_hour=localstate.CPI_Hour
    CPI_min =localstate.CPI_min
    CPI_sec =localstate.CPI_sec
    plot,CPI_conc,color=255,xstyle=1,ystyle=4,psym=10,xmargin=[0.3,0.3],ymargin=[2,0]
    nnnn=n_elements(CPI_conc)
    for i=1,10 do begin
        index=0L+(i-1)*nnnn/10L
        if CPI_hour(index) lt 10 then hh_str='0'+strtrim(string(CPI_hour(index)),2) else hh_str=strtrim(string(CPI_hour(index)),2)
        if CPI_min(index)  lt 10 then mm_str='0'+strtrim(string(CPI_min(index)),2)  else mm_str=strtrim(string(CPI_min(index)),2)
        if CPI_sec(index)  lt 10 then ss_str='0'+strtrim(string(CPI_sec(index)),2)  else ss_str=strtrim(string(CPI_sec(index)),2)
        time_str=hh_str+':'+mm_str+':'+ss_str
        xyouts,0+1220*(i-1)/10L,40,time_str,color=[240,255,255],/device
    endfor
    oplot,[start_K,start_K],[0,10],color=200
    oplot,[k,k],[0,10],color=200

end

;===============================================================================
pro disp_habit_frame_sorted,LocalState

    Pstateinfo=localstate.Pstateinfo
    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 ); and not (*(*pStateInfo).pFileScan).badframe)
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    wset,localstate.MviewID1
    erase
    bounds_sort=localstate.bounds_sort
    maxdy=0
    oX=0
    oY=localstate.scr_ysize
    imgfrmct=0
    last_time=0.0

    for i=0,999 do begin
        RoiNum=bounds_sort(i,4)
        k     =bounds_sort(i,5)
        if i gt 0 and total(bounds_sort(i,*)) eq 0 then begin
            goto,End_display
        end
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)
        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        frameTime = Time.hour*3600.0 + time.minute*60.0 + time.sec + time.msec/1000.0D;  Changed to this August 6, 2010

        pROIArray = FrameData.pFrame
        ROIArray = *frameData.pFrame;  RoiArray are n_img rois.

        getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;     ;in processTime_lib2.pro; objdata.pframe is the imagehdear31 of crsytal,cutoff
        objheaders=(*(objdata.pframe))
        objheader =objheaders(roinum).imageheader

        img = *ROIArray[Roinum].pROI
        dx = ROIArray[roinum].ImageHeader.ex - ROIArray[roinum].ImageHeader.sx + 1
        dy = ROIArray[roinum].ImageHeader.ey - ROIArray[roinum].ImageHeader.sy + 1
        if dx gt 500.0 or dy gt 500.0 then begin
            ;rrr=dialog_message('image too large, can not dislay, skip over !',/information)
            update_Start_or_end_time, localstate, Time,1
            goto,next_n_imgs;return,0
        endif
        maxdy = maxdy > dy
        if OY lt (dy+20) then begin
            update_Start_or_end_time, localstate, Time, 1
            goto,End_display
        endif

        tv,congrid(bytscl(img,min = scaleMin,max = scaleMax,top=255),dx,dy,/interp),oX, oY-dy
        Timestr1=strtrim(string(time.hour),2)+':'+strtrim(string(Time.minute),2)
        Timestr2=strtrim(string(time.sec),2)+':'+strtrim(string(Time.msec),2)
        if last_time ne frametime then begin
            xyouts,oX,Oy-dy-5,Timestr1,color=[255,255,255],/device
            xyouts,oX,Oy-dy-15,Timestr2,color=[255,255,255],/device
            last_time=frametime
        endif

        if objheader.crystal  eq 1 then habit_str='sph'
        if objheader.crystal  eq 0 then habit_str='reject'
        if objheader.crystal  eq 15 then habit_str='ice'
        xyouts,oX,(Oy-7),habit_str,color=[255,255,255],/device

        if(oX + dx GT localstate.scr_xsize*.9)then begin ; image off screen
            oX = 0
            oY =  oY - maxdy - 20
            maxdy =0
        endif else begin
            oX = oX + dx + 2
            oY = oY
        endelse
        next_n_imgs:
        if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
    endFOR

    End_display: begin
    end

end; end of disp_frame_sort


;===============================================================================
FUNCTION Get_manual_page_ROI, localstate, x, y

    ; purpose:  this routine determine if the mouse is over a particle, and if so which one
    ;   PARAMETERs
    ;     pStateInfo:  main info structure
    ;     x:      x location of mouse in pixel coord
    ;     y:      y location of mouse in pixel coord

    ;   return
    ;     if over a particle , return index of particle and offset into particle in pixel-coords , else [-1,-1,-1]

    ; How many ROIs?
    pstateinfo=localstate.pstateinfo
    bounds=localstate.bounds
    sizes=size(bounds,/dimension);    ;bounds = *(*pStateInfo).pBounds

    FOR i=0,999 DO begin
        x0 = bounds[i,0];  x0 =OX,  y0=OY-dy-1
        y0 = bounds[i,1]
        x1 = bounds[i,2];  x1y1= oX+dx-1,oY
        y1 = bounds[i,3]
        Roinum=bounds(i,4)
        framenum=bounds(i,5)
        if ( x gt x0-1 and x lt x1+1 and y gt y0-1 and y lt y1+1 )then return,[Roinum,framenum, x0,y1,x1-x0+1,y1-y0-1]; that is oX,oY,dx,dy.
    endFOR

    ; Not inside any ROI
    return, [-1,-1,-1,-1,-1,-1]
end


pro  make_all_in_the_current_page_as_sphere_or_ice,Localstate,waterOrice

    pstateinfo=localstate.pstateinfo
    bounds=localstate.bounds
    sizes=size(bounds,/dimension);    ;bounds = *(*pStateInfo).pBounds


    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0  );   and not (*(*pStateInfo).pFileScan).badframe )
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]

    ;above two lines changed to following two lines in August 26, 2014--by Mo  to match the inly frae that have obj data that show on the qui.frame# slider.

    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    if waterOrice eq 'water' then begin
        crystal=1B
    endif


    if waterOrice eq 'ice' then begin
        crystal=15B
    endif
    Imgfrmct=0

    FOR i=0,999 DO begin
        Roinum=bounds(i,4)
        framenum=bounds(i,5)

        if roinum lt 0 then break

        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[framenum].fpos,date=(*pStateInfo).date, TSBlanked = imglist[framenum].TSBlanked)
        pROIArray = FrameData.pFrame

        getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData;     ;in processTime_lib2.pro; objdata.pframe is the imagehdear31 of crsytal,cutoff
        objheaders=(*(objdata.pframe))
        objheader =objheaders(roinum).imageheader
        fpos=(*objdata.PimHDfpos)[Roinum]
        objheader.crystal=crystal
        (*objData.pFrame)[roinum].imageheader.P1 = 1.0 ; set P1, which seems to be update GUI
        (*pStateInfo).UpdateFile = !true
        update_obj_header1,(*pStateInfo).ObjLUN, fpos, objheader
    endFOR


end



;===============================================================================
pro sort_the_local_states_bounds,localstate

    ; purpose:  this routine sorted the localstate bounds by water and ice.

    bounds=localstate.bounds
    sizes=size(bounds,/dimension);    ;bounds = *(*pStateInfo).pBounds
    bounds_sort=bounds*0


    FOR i=0,999 DO begin
        sum=total(bounds[i,*])
        if sum eq 0 then break
    endFOR
    kkk=i-1
    crystal=bounds(0:kkk,6)
    index=sort(crystal)

    FOR i=0,kkk DO begin
        bounds_sort(i,*) = bounds[index(i),*];  x0 =OX,  y0=OY-dy-1
    endFOR
    localstate.bounds_sort=bounds_sort
end



pro getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData

    hour   = framedata.FrameHeader.hour
    minute = framedata.FrameHeader.minute
    sec    = framedata.FrameHeader.sec
    msec   = framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    roiTime = hour*3600.0+minute*60.0 +sec*1.0+msec/1000.0D;   ; roitime=framedata.frameheader.time)
    indexOBJ = where(roiTime eq (*(*pStateInfo).pObjList).time, cntOBJ)
    if(cntOBJ gt 0)then begin
        ; read a frame of info from the obj file
        objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[indexOBJ[0]].fPos)
        ; store obj info
        if n_tags(objdata) lt 3 then return
        pROIArray = objData.pFrame
    endif else begin
        ;r = dialog_message('Error: obj frame not found---- in do_manual_habits_change.pro ')
        print, 'Error: obj frame not found---- in do_manual_habits_change.pro '
    endelse
end ; getObjData_mo




PRO Do_manual_habit_change, PstateInfo, GROUP=GROUP

    if(ptr_valid((*pStateInfo).pFileScan) eq 0) then begin
        r = dialog_message('Error: No CPI ROI file data available. Open a CPI data file first.')


        return
    endif


    tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, /TLB_SIZE_EVENTS, /col, TITLE='CPI manual habit change program',mbar=menuBase)
    ;-----------------------------------------------------
    button_bar = widget_base(tlb,/row)
    ; Menu
    box_size = 3
    b311 = widget_base(button_bar,/row)
    SStrDay = cw_field(b311,title='From:Day',value=0,/int,xsize=2,uvalue ='startDay',/all)
    SStrHr  = cw_field(b311,title='Time',value=0,/int,xsize=2,uvalue ='starthh',/all)
    SStrMin = cw_field(b311,title=':',value=0,/int,xsize=2,uvalue ='startmm',/all)
    SStrSec = cw_field(b311,title=':',value=0,/int,xsize=2,uvalue ='startss',/all)
    SStrmSec = cw_field(b311,title='.',value=0,/int,xsize=box_size,uvalue ='startms',/all)

    EStrDay = cw_field(b311,title='To:Day',value=0,/int,xsize=2,uvalue ='EndDay',/all)
    EStrHr  = cw_field(b311,title='Time',value=0,/int,xsize=2,uvalue ='Endhh',/all)
    EStrMin = cw_field(b311,title=':',value=0,/int,xsize=2,uvalue ='Endmm',/all)
    EStrSec = cw_field(b311,title=':',value=0,/int,xsize=2,uvalue ='Endss',/all)
    EStrmSec = cw_field(b311,title='.',value=0,/int,xsize=box_size,uvalue ='Endms',/all)
    ;*********************************************************
    ;butns = ['sph','ice','rosset','needle','plate','irr']
    ;HabitSel = CW_BGroup(b311,butns,/exclusive,/row, label_left='Habits:',$
    ;            /no_release,button_uvalue=[0,1,2,3,4,5],uvalue = 'Habit')

    butns = ['all','sph','ice']
    HabitSel = CW_BGroup(b311,butns,/exclusive,/row, label_left='Type:',$
        /no_release,button_uvalue=[0,1,2],uvalue = 'Habit')
    widget_control,HabitSel,set_value =0

    PrevID = widget_button(b311, value = 'Prev Page',       uvalue = 'Prev_page')
    doneID = widget_button(b311, value = 'Next Page',       uvalue = 'Next_page')
    FreshID = widget_button(b311, value = 'Refresh',         uvalue = 'Refresh_page')
    SortID = widget_button(b311, value = ' Sort ',          uvalue = 'Sort_page')
    FillID = widget_button(b311, value = ' Fill  ',         uvalue = 'Fill_page')
    ForceWID = widget_button(b311, value = 'Make all sphere', uvalue = 'ForceAllSphere')
    ForceIID = widget_button(b311, value = 'Make all ice',    uvalue = 'ForceAllice')
    FillID = widget_button(b311, value = 'Help notes',      uvalue = 'Help_notes')

    b312 = widget_base(tlb,/row)
    b34 = widget_base(b312,/col,/frame);, sensitive = (*pStateInfo).AUTOEXTRACT
    baccept2 = widget_base(b34,/row)
    label = widget_label(baccept2,value = 'Criteria:',ysize = 30)
    criteriaID = widget_text(baccept2,value='focus gt 20 and cutoff lt 6',/editable,/all,uvalue='criteria',xsize = 90,/scroll)
    label = widget_label(b312,value = 'Note:   Time displayed is original Time, no offset are added.',font='Times-Bold')
    ;*****************************************************
    ; button bar   add options label
    pageX=1220
    pageY=570
    MAINBase = widget_base(tlb,/row)

    ; Image View and image-related labels
    ViewBase = WIDGET_BASE(MAINBase, /COL,TITLE='ImgView', UVALUE=' ',event_pro = 'habit_view_event')

    ;*****************************************************
    MainView1 = WIDGET_DRAW(viewBase, UVALUE='MAIN_VIEW1',/BUTTON_EVENTS, /FRAME, /MOTION_EVENTS, $$
        XSIZE=pageX, YSIZE=pageY); X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004

    ;*****************************************************
    MainView2 = WIDGET_DRAW(viewBase, UVALUE='MAIN_VIEW2', $
        XSIZE=pageX, YSIZE=50); X_SCROLL_SIZE=800, Y_SCROLL_SIZE=800);  ; this is added by mo spet9, 2004
    ;***************************************************************************************
    FileName =' ';Filenm

    WIDGET_CONTROL, MAINBase, /REALIZE
    ; Get drawable window index
    WIDGET_CONTROL, MainView1, GET_VALUE=MViewID1
    WIDGET_CONTROL, MainView2, GET_VALUE=MViewID2

    ;begin to fill in all the images in the mainview.
    ;****************************************************************
    ; first get the start Time and assume the crystal habits are water.
    ; choose to output only good frame images.

    frame_numbers= (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
    frameTimes=frame_numbers.hour*3600.0 +frame_numbers.minute*60.0 +frame_numbers.sec*1.0+frame_numbers.msec/1000.0D
    ii=n_elements(frame_numbers)-1LL


    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0); these include bad frames.
    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 );  and not (*(*pStateInfo).pFileScan).badframe)
    ;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.


    ;find imglist Time in one time
    nnnn=n_elements(imglist)
    frametimes=fltarr(nnnn)+0.0D
    for k=0L,nnnn-1L do begin
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)
        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        frameTimes(k) = Time.hour*3600.0D + time.minute*60.0D + time.sec*1.0D + time.msec/1000.0D;  Changed to this August 6, 2010
    endfor

    CPI_conc=*(*Pstateinfo).pConc
    CPI_hour=1*Frame_numbers.Hour
    CPI_min =1*Frame_numbers.minute
    CPI_sec =1*Frame_numbers.sec

    if (fstat((*Pstateinfo).objlun)).write eq 0 then begin
        close,(*Pstateinfo).objlun
        free_lun,(*Pstateinfo).objlun
        openu,(*Pstateinfo).objlun,(*Pstateinfo).objfile
    endif


    ;make 9 Time labels.
    wset,MViewID2
    plot,CPI_conc,color=255,xstyle=1,ystyle=4,psym=10,xmargin=[0.3,0.3],ymargin=[2,0]

    nnnn=n_elements(CPI_conc)
    for i=1,10 do begin
        index=0L+(i-1)*nnnn/10L
        if CPI_hour(index) lt 10 then hh_str='0'+strtrim(string(CPI_hour(index)),2) else hh_str=strtrim(string(CPI_hour(index)),2)
        if CPI_min(index)  lt 10 then mm_str='0'+strtrim(string(CPI_min(index)),2)  else mm_str=strtrim(string(CPI_min(index)),2)
        if CPI_sec(index)  lt 10 then ss_str='0'+strtrim(string(CPI_sec(index)),2)  else ss_str=strtrim(string(CPI_sec(index)),2)
        time_str=hh_str+':'+mm_str+':'+ss_str
        xyouts,0+1220*(i-1)/10L,40,time_str,color=[240,255,255],/device
    endfor


    StartTime={Month:0U, Day:(frame_numbers(0).day)*1U, hour:(frame_numbers(0).hour)*1U, minute:(frame_numbers(0).minute)*1U, sec:(frame_numbers(0).sec)*1U,msec:uint(frame_numbers(0).msec)}
    EndTime  ={Month:0U, Day:(frame_numbers(ii).day)*1U, hour:(frame_numbers(ii).hour)*1U, minute:(frame_numbers(ii).minute)*1U, sec:(frame_numbers(ii).sec)*1U,msec:uint(frame_numbers(ii).msec)}

    Timeinfo={first_time:0,$
        last_time:0,$
        current_time:0,$
        next_time:0,$
        prev_time:0,$
        pcurrent_link: ptr_new()$
        }
    LocalState = {MViewID1:MViewID1,$
        MViewID2:MViewID2,$
        pstateinfo:pstateinfo,$
        Timeinfo:ptr_new(Time_info),$
        prev_page:0,$
        sort_page:0,$
        crystal:0,$
        StartDay:0,$
        starthh:0,$;shh,$
        startmm:0,$;smm,$
        startss:0,$;sss,$
        startms:0,$;sms,$
        stopDay:0,$;ehh,$
        stophh:0,$;ehh,$
        stopmm:0,$;emm,$
        stopss:0,$;ess,$
        stopms:0,$;ems,$
        SStrDay:SStrDay,$
        Sstrhr:SStrhr,$;shh,$
        SStrmin:SStrmin,$;smm,$
        Sstrsec:SStrsec,$;sss,$
        Sstrmsec:SStrmsec,$;sss,$
        EStrDay:EStrDay,$
        Estrhr:EStrhr,$;shh,$
        EStrmin:EStrmin,$;smm,$
        Estrsec:EStrsec,$;sss,$
        Estrmsec:EStrmsec,$;sss,$
        pathnm:' ',$;pathnm,$
        scr_xsize:pageX,$
        scr_ysize:pageY,$
        oX:0,$
        oY:pageY,$,
    maxdy:0,$
        StartTime:Starttime,$
        EndTime:Endtime,$
        frameTimes:frametimes,$;  valid frame's imglist time in seconds.xxx format.
        bounds:lonarr(1000,8),$
        bounds_sort:lonarr(1000,8),$
        ith_roi:0,$
        CPI_hour:CPI_hour,$
        CPI_min:CPI_min,$
        CPI_sec:CPI_sec,$
        criteriaID:criteriaID,$
        criteria:'focus gt 20 and cutoff lt 6' $
        };******added august 19,2005
    disp_habit_frame,LocalState,0

    ; Save state
    WIDGET_CONTROL, tlb, SET_UVALUE=LocalState,/no_copy

    ; Hand off control of the widget to the XMANAGER:
    XMANAGER, 'Do_manual_habit_change', tlb, /NO_BLOCK
    ;XMANAGER, 'Do_manual_habit_change', tlb, /JUST_REG;   change above to this on June 3,2005.
END ; Do_manual_habit_change

pro update_Start_or_end_time, localstate, Time, refresh_page

    if refresh_page eq 0 and localstate.prev_page eq 0 then begin
        ;update image time for last display image.
        widget_control,localstate.Estrday,set_value=Time.day
        widget_control,localstate.Estrhr,set_value=Time.hour
        widget_control,localstate.Estrmin,set_value=Time.minute
        widget_control,localstate.Estrsec,set_value=Time.sec
        widget_control,localstate.Estrmsec,set_value=Time.msec
        localstate.EndTime=Time
    endif

    if localstate.prev_page eq 1 then begin
        ;update image time for last display image.
        widget_control,localstate.Sstrday,set_value=Time.day
        widget_control,localstate.Sstrhr,set_value=Time.hour
        widget_control,localstate.Sstrmin,set_value=Time.minute
        widget_control,localstate.Sstrsec,set_value=Time.sec
        widget_control,localstate.Sstrmsec,set_value=Time.msec
        localstate.StartTime=Time
    endif
end; update_Start_or_end_time, localstate, refresh_page
