
; File:  Do_overnight_auto_archiving_works_tc4.pro
; Purpose:  runs batch archiving for the 2DS, going from SORTED files to png or ascii outputs, based on
;           the system variable flag !autoarchive_png_only

; Added Roundness criteria output for Archive_multi_by_Roundness to output separate png files for sphere and non sphere
; particles.


pro  get_all_sorted_2DS_data_filenames,filenames,file_count
    ;output is filenames,file_count
    dirn=dialog_pickfile(filter='Sort*.2DSCPI',get_path=pathnm)
    do_loop=1
    file_count=0
    WHILE (do_loop eq 1) do begin    ;repeatedly selecting files until
        filter_str=pathnm+'Sort*.2DSCPI';   ;user comfirms
        filenames=findfile(filter_str,COUNT=file_count)

        ; display the files in the screen for user to review
        print,'***********************************************************'
        print,'********  Here are all Sorted*.2DSCPI data files with '
        print,'*** found in current directory for overnight processing ***'
        print,'************************************************************'

        for j=0, (file_count-1)  do begin
            print, filenames(j)
        endfor

        print,'*********************************************'

        ; print the message to ask user to confirm
        ; define answer to be a string
        ;answer=' '

        ;print,'Are you sure to do above files ? yes/no'
        ;print, 'Enter y or n:'
        ;read,answer

        ;if strcmp(answer,'y') then  do_loop=0
        do_loop=0

    ENDWHILE           ; end of initial start up.

    print,'                            '
    print,' done,get the files,.....Processing,  please wait ! '
    print,'
end; endof get_all_data_filenames,filter_str,filenames,pathnm
;****************************************************************************

; load the bin files.

;***************************************************************************
;==================================================================
pro SPEC_Toolbar_Load_archive,info

    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,FirstDataV,$
        LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV,SHstripdata,SVstripdata,Mstripdata

    forward_function  CalcNumBins

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Loading Processed Data" ; tell user what we're up to

    struct = {_DerivedData, $
        Nanosecsold:0ULL , $
        NanoSeconds:0ULL , $
        ImageOffset: 0UL , $
        ImageWords: 0 , $
        Area: 0.0 , $
        Nslice: 0 , $
        L2: 0 , $
        F1: 0 , $
        Adj1: 0.0, $
        Pc1: 0.0, $
        TAS: 0.0 ,$
        L1n:0.0,$
        largest_satellite_area: 0.0, $    ;added dec19,2007
        alexei1old: 0.0, $ ;added dec19,2007
        TASold: 0.0 $    ; added dec19,2007
        }

    struct = {_DerivedDataRev2, $
        PartID: 0 , $
        Nanosecsold:0ULL , $
        NanoSeconds:0ULL , $
        ImageOffset: 0UL , $
        ImageWords: 0 , $
        Area: 0.0 , $
        Nslice: 0 , $
        L2: 0 , $
        F1: 0 , $
        Adj1: 0.0, $
        Pc1: 0.0, $
        TAS: 0.0, $
        ProbeCounter:0ULL, $
        L3: 0.0, $
        L4: 0, $
        L5: 0, $
        PC3x: 0.0, $
        PC3y: 0.0, $
        PC4x: 0.0, $
        PC4y: 0.0, $
        A3: 0.0, $
        Alexei1: 0.0, $
        Alexei2: 0L, $
        reject: byte(0), $
        w8_t: 0LL, $
        L7: 0.0, $
        L8: 0.0, $
        roundness: 0.0, $
        focus: 0.0, $
        warn: 0.0, $  ; some day we will change this to byte value to svae memory.
        adj0: 1.0, $  ;added on May 8-2007 for w8_t cleaning.
        noisebyte:byte(0),$;; added in June 2007.
        AccDTtick:0ULL,$   ; added on oct5 2007
        w8_t_clean:0LL, $; added on oct5,2007.
        L1n: 0.0, $;    ; added on nov 9, 2007.
        largest_satellite_area: 0.0, $    ;added dec19,2007
        alexei1old: 0.0, $ ;added dec19,2007
        TASold: 0.0, $    ; added dec19,2007
        Roundness1: 0.0, $
        Roundness2: 0.0, $
        Roundness3: 0.0, $
        L1r: 0.0, $
        maxLength: 0.0, $
        maxWidth: 0.0, $
        perimeter: 0, $
        crystal_type: 0, $
        perimeterum: 0.0, $
        csp: 0.0, $
        num_satellites: 0.0, $
        round123: 0.0, $
        spare5: 0.0, $
        CPI_trigger: 0}

    struct = {_AverageData, $
        Concentration:0.0D, $
        Extinction:0.0D, $
        IWC:0.0D, $
        LWC:0.0D,$;  added this on Dec 5, 2005 by mo.
        PSize:0.0D, $
        PArea:0.0D, $
        PMass:0.0D, $
        FileOffset:0UL, $
        NSOffset:0ULL, $
        N:0UL, $
        ImageOffset: 0UL , $
        ImageWords: 0 , $
        Area: 0.0D , $
        Nslice: 0.0D , $
        L2: 0.0D , $
        F1: 0.0D , $
        Adj1: 0.0D, $
        Pc1: 0.0D ,$
        L1n:0.0}

    struct = {_AverageHzData, $
        Concentration:0.0D, $
        Extinction:0.0D, $
        IWC:0.0D, $
        Bins: DINDGEN(24), $  ; 23 PSD bins for #/L/micron
        FileOffset:0UL, $
        NSOffset:0ULL, $
        N:0UL, $
        TAS: 0.0, $
        Nslice: 0.0D , $
        Adj1: 0.0D, $
        Pc1: 0.0D, $
        Deadtime: 0.0D,$
        L1n:0.0 }

    ;=================================================
    ; Let user pick which .BIN file to open
    ;=================================================

    ; filename = dialog_pickfile(filter='*.BIN',  /Read)

    currentPath=info.currentPname
    filter_str='Horiz'+info.datestamp+'.Bin';';   ;user comfirms
    filename=file_search(currentpath,filter_str,COUNT=file_count);*.Bin';   ;user comfirms

    if file_count eq 0 then begin
        return
    endif
    filename=filename(0);  added on july 20, sunday --2008.

    info.currentFname=filename

    end_of_path = STRPOS(filename, '\', /REVERSE_SEARCH)
    info.currentPname =  STRMID(filename,0,end_of_path+1)
    !CurrentHPname=info.currentPname

    prefix =  STRMID(filename,0,end_of_path+1)

    ; Figure out which file they clicked on and generate the suffix for the creation of all 4 filenames

    if (strpos(filename,'horiz') NE -1) then begin
        suffix = strmid(filename,strpos(filename,'horiz')+5)
    end else begin
        if (strpos(filename,'vert') NE -1) then begin
            suffix = strmid(filename,strpos(filename,'vert')+4)
        end else begin
            if (strpos(filename,'onehz') NE -1) then begin
                suffix = strmid(filename,strpos(filename,'onehz')+5)
            end else begin
                suffix = strmid(filename,strpos(filename,'mask')+4)
            endelse
        endelse
    endelse

    horiz_filename = prefix + 'horiz' + suffix
    vert_filename  = prefix + 'vert'  + suffix
    onehz_filename = prefix + 'onehz' + suffix
    mask_filename  = prefix + 'mask'  + suffix
    oneHz_filename = strmid(onehz_filename,0,strlen(onehz_filename)-3) + '1hz'

    all_files_here = 1
    IF  SPEC_TestForFile(horiz_filename) NE 0 then all_files_here = 0
    IF  SPEC_TestForFile(vert_filename) NE 0 then all_files_here = 0
    ;IF  SPEC_TestForFile(onehz_filename) NE 0 then all_files_here = 0
    IF  SPEC_TestForFile(mask_filename) NE 0 then all_files_here = 0

    onehz_file_present =   SPEC_TestForFile(oneHz_filename) ; return -1 if file not found, 0 if it is found

    ;--------------------------------------------------------
    ; Added for version 0.30. As the files got bigger, it
    ; was important to clear out the previously loaded common
    ; data before you can start to load new data. This even
    ; happens when you exit the program, so shrinking the
    ; size of these two large arrays helps to avoid lack of memory problems.
    ;----------------------------------------------------
    if n_elements(alldataH) ge 1 then (*alldataH) = (*alldataH)(0)
    if n_elements(alldataV) ge 1 then (*alldataV) = (*alldataV)(0)
    ;==========================================
    ; READ HORIZONTAL DATA FILE
    ;==========================================
    OpenR, lun, horiz_filename, /Get_Lun
    ;=============================================
    ; New for REV 2, the .BIN files have 256 byte
    ;  text headers on them to show what REV they are.
    ; Since REV1 did not have the header, we read
    ;  in the first 256 bytes, if we see 2.00 then
    ;  it is REV 2, if not, then it is REV 1
    ;  and we need to reposition our file pointer
    ;  back to the start to begin processing.
    ;=============================================
    fileheader = bytarr(256)
    ReadU, lun, fileheader
    v_string = strmid(string(fileheader),4,4)
    if (v_string eq '3.00') then begin
        OD = {_DerivedDataRev2}
        !CURRENT_VERSION = 3.0
    endif else begin
        OD = {_DerivedData}
        POINT_LUN, lun, 0   ; rewind file pointer to start if version 1.0 (we didn't have the header then)
        !CURRENT_VERSION = 1.0
    endelse



    ; TAF 2013-10-03 it appears that this is not needed here, as the resolutions will always have been defined by now
    ; below is a debug test, which can be removed once I am sure

    ; TAF update:  apparently it gets here directly if the .bin files are already defined???


    ; Test the binary file for the 50 micron H channel flag, vs the 10 micron H channel
    ; this section is called during Archiving ASCII

    ; The binary file header currently looks like this (Ver string below, annotated):

    ;                            27th character
    ;                            |                 45th character
    ;                            |                 |
    ; Ver 3.00 BIN PARTICLE DATA H50Micron = False 1.1.0 TAF

    ; Thus strmid(string(fileheader), 27, 17) will extract: "H50Micron = False", "H50Micron = True"
    ; and strmid(string(fileheader), 45, 15) will extract: 1.1.0 TAF

    ; However, switching to tokenizing the string will be more robust to changes in character length, position


    if(!H_res_set eq 0) then begin ; test to ensure the pixel resolution is set only once, may consider moving this into the function, though unneeded function calls are logic errors, not sure
        if(!manual_override_H50vs10micron eq 0) then begin

            print, ""
            print, "determine pixel resolution automatically from .bin files, or fail here"

            binary_50_micron_flag = strmid(string(fileheader), 27, 17)
            binary_version_string = strmid(string(fileheader), 45, 15)

            print, ""
            print, " 3V-CPI View Version from binary file: ", binary_version_string ; TAF note the space at the start of the print string is needed due to some weird IDL print bug!
            print, binary_50_micron_flag

            if(strcmp(binary_50_micron_flag, "H50Micron = True ")) then begin
                print, "H 50 Micron detected in binary file"
                !H_resolution_microns = 50
            endif else if(strcmp(binary_50_micron_flag, "H50Micron = False")) then begin
                print, "H 10 Micron detected in binary file"
                !H_resolution_microns = 10
            endif else begin
                print, ""
                print, "H50Micron flag not detected in binary file, switching to manual H 10 vs 50 micron selection"
                print, ""

                H50micron_pop_up
            endelse
        endif

        define_Pixel_resolutions
    endif



    ;end_of_path = STRPOS(horiz_filename, '\', /REVERSE_SEARCH)
    ;info.currentPname =  STRMID(filename,0,end_of_path+1)  ; save this path to locate the SORTEDdatastamp.2DSCPI file one directory up
    info.currentFname = horiz_filename                      ; save full filename for access when we click on the graph
    !CurrentHPname = info.currentPname
    !CurrentHFname = horiz_filename
    ;info.datestamp = strmid(horiz_filename,strpos(horiz_filename,"horiz")+5,12)  ; save this datestamp for locating the SORTEDdatestamp.2DSCPI one directory above this
    substrsF=strsplit(horiz_filename,'\',/extract)
    short_filename=substrsF(n_elements(substrsF)-1)

    info.datestamp = strmid(Short_filename,5,strlen(Short_filename)-9);  take way 9 letters,(horiz and .txt)

    ; one path up will be: strmid(info.currentPname,0,strlen(info.CurrentPname)-5)
    fdata = FSTAT(lun)
    StructSize = N_TAGS( OD , /DATA_LENGTH )

    ;==========================================
    ; READ VERTICAL DATA FILE
    ;==========================================
    OpenR, lunV, vert_filename, /Get_Lun
    if (v_string eq '3.00') then    ReadU, lunV, fileheader  ; for REV2 pull off the 256 byte header
    fdataV = FSTAT(lunV)
    info.currentFnameV = vert_filename                      ; save full filename for access when we click on the graph
    !CurrentVPname = info.currentPname
    !CurrentVFname = vert_filename
    ;==========================================
    ; If we already have previously created the
    ;  1Hz data file, then skip the next code.
    ;  We'll have to check for version numbers
    ;  on the 1Hz file if it's already made.
    ; 1) Look for existing .1HZ file
    ; 2) Confirm version of 1HZ file is the most recent
    ;==========================================

    ;---------------------------------------------
    ; Look at the first and last particles in this
    ;  file for the range of timestamps.
    ;---------------------------------------------

    if (v_string eq '3.00') then begin
        FirstData = ({_DerivedDataRev2})
        num_data_points = long64( (fdata.Size-256) /StructSize)
    endif else if(v_string eq '3.00D') then begin
        print, 'SORTED file generated with Debug information, rerun Playback without Tools->Include particle offset in output checked'
        return
    endif else begin
        FirstData = ({_DerivedData})
        num_data_points = long64(fdata.Size/StructSize)
    endelse
    ReadU, lun, FirstData
    no_string_in_H=0
    ; Sometimes the first data structure may not be a particle but a flag for a deadtime event
    ;  so read ahead until we get an actual particle
    if (FirstData.Area lt 0) then begin
        ptr = 1L
        flag = 1
        while (flag eq 1) do begin
            if EOF(lun) eq 0 then begin
                ReadU, lun, FirstData
                if (FirstData.Area gt 0) and (FirstData.Nanoseconds gt 0) then begin
                    flag = 0  ; get us out of the loop
                endif else begin
                    ptr++
                    if (ptr ge num_data_points) then begin
                        ; r = dialog_message(['Error, cannot find a string timestamp in this data file!','Plese select a different data file".'],TITLE = 'Program is being stopped',/Cancel)
                        no_string_in_H=1
                    endif
                endelse
            endif else flag=0
        endwhile
    endif

    if (v_string eq '3.00') then begin
        LastData = ({_DerivedDataRev2})
        POINT_LUN, lun, ((num_data_points-1LL) * StructSize) + 256  ; include the header
    endif else begin
        LastData = ({_DerivedData})
        POINT_LUN, lun, (num_data_points-1LL) * StructSize
    endelse

    ReadU, lun, LastData

    ;---------------------------------------------
    ; Look at the first and last particles in this
    ;  file for the range of timestamps.
    ;---------------------------------------------
    if (v_string eq '3.00') then begin
        FirstDataV = ({_DerivedDataRev2})
        num_data_pointsV = long64( (fdataV.Size-256) /StructSize)

    endif else begin
        FirstDataV = ({_DerivedData})
        num_data_pointsV = long64(fdataV.Size/StructSize)
    endelse

    ReadU, lunV, FirstDataV
    ; Sometimes the first data structure may not be a particle but a flag for a deadtime event
    ;  so read ahead until we get an actual particle
    if (FirstDataV.Area lt 0) then begin
        ptr = 1L
        flag = 1
        while (flag eq 1) do begin
            if EOF(lunV) eq 0 then begin
                ReadU, lunV, FirstDataV
                if (FirstDataV.Area gt 0) and (FirstDataV.Nanoseconds gt 0) then begin
                    flag = 0  ; get us out of the loop
                endif else begin
                    ptr++
                    if (ptr ge num_data_pointsV) then begin
                        if no_string_in_H eq 1 then begin
                            ;r = dialog_message(['Error, cannot find a string timestamp in both H and V channel !','Plese select a different data file".'],TITLE = 'Program is being stopped',/Cancel)
                            print, 'Error, cannot find a string timestamp in both H and V channel !'
                        endif
                    endif
                endelse
            endif else flag =0
        endwhile
    endif

    if (v_string eq '3.00') then begin
        LastDataV = ({_DerivedDataRev2})
        POINT_LUN, lunV, (num_data_pointsV-1LL) * StructSize   + 256  ; include the header
        ;structsize=162;  num_data_pointsV=819718, 804538 ???
    endif else begin
        LastDataV = ({_DerivedData})
        POINT_LUN, lunV, (num_data_pointsV-1LL) * StructSize

    endelse
    ReadU, lunV, LastDataV


    ;------------------------------------------------
    ; Using the earlist and latest times from H and V
    ;  determine the full range of the data.
    ;------------------------------------------------
    if (FirstData.NanoSeconds gt FirstDataV.Nanoseconds) then min_time = FirstDataV.NanoSeconds else min_time = FirstData.NanoSeconds
    if ( LastData.NanoSeconds gt  LastDataV.Nanoseconds) then max_time =   LastData.NanoSeconds else max_time = LastDataV.NanoSeconds
    ;----------------------------------------------------------------------
    ; Now that we've got the timestamps from the first and last particles
    ; (may be from H or V stream), lets round those timestamps down at the
    ;  start, and up at the end so that we start and stop at exactly the
    ;  "top" of the second. This permits us to match our data more easily
    ;  to the other instruments collecting data at the same time.
    ;----------------------------------------------------------------------
    NanosecondsPerSecond = 1000000000.0D  ; use double for some calculations
    NPS = 1000000000ULL
    min_time = min_time - (min_time mod NPS)  ; Round down to time with milli,micro, and nano seconds = 0

    temp = max_time - (max_time mod NPS)      ; Round down to time with milli, micro and nano seconds = 0
    ;  If the upper limit happened to already be at exactly one second, don't bother to round up to next second

    if (temp NE max_time) then temp = temp + NPS  ; Round up to next full second
    max_time = temp

    full_time = max_time - min_time
    Seconds = long(ceil(full_time/NPS))


    FirstData.NanoSeconds = min_time
    FirstDataV.NanoSeconds = min_time
    LastData.NanoSeconds = max_time
    LastDataV.NanoSeconds = max_time

    ; TAF 2013-09-26 apparently I need to re-re-reimplement the pointers in 3V-CPI again, as it is once again using straight array copys
    ; After pointers are reimplemented, the following lines will free memory before (re)allocating arrays, thus preventing the
    ; memory allocation crash bug.  Since the section tests for valid pointers, it does no harm having it implemented here before the full pointer
    ; system is back in place

    ; Free memory from previous iterations through archiving, before allocating new arrays

    if(ptr_valid(alldataH)) then begin
        print, "Freeing alldataH"

        ptr_free, alldataH
    endif

    if(ptr_valid(alldataV)) then begin
        print, "Freeing alldataV"

        ptr_free, alldataV
    endif

    ;=========================================
    ; Before we generate the 1 Hz bins, create
    ;  and populate the complete contents of
    ;  the H & V particle file that we use
    ;  throughout the program..
    ;=========================================

    print, "Loading Raw Data (Horizontal) "

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Loading Raw Data (Horizontal) " ; tell user what we're up to

    if (v_string eq '3.00') then begin
        alldataH = REPLICATE({_DerivedDataRev2},num_data_points)
        POINT_LUN, lun, 256  ; point back to start of file but past the header
    endif else begin
        alldataH = REPLICATE({_DerivedData},num_data_points)
        POINT_LUN, lun, 0   ; point back to start of file
    endelse
    ReadU, lun, alldataH
    alldataH = ptr_new(temporary(alldataH))

    print, "Loading Raw Data (Vertical) "

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Loading Raw Data (Vertical) " ; tell user what we're up to

    if (v_string eq '3.00') then begin
        alldataV = REPLICATE({_DerivedDataRev2},num_data_pointsV)

        POINT_LUN, lunV, 256  ; point back to start of file but past the header
    endif else begin
        alldataV = REPLICATE({_DerivedData},num_data_pointsV)
        POINT_LUN, lunV, 0   ; point back to start of file
    endelse
    ReadU, lunV, alldataV
    alldataV = ptr_new(temporary(alldataV))

    print, "Done loading all data"

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Done Loading Raw Data" ; tell user what we're up to

    ; close the data files.---added by mo Feb 16, 2006.
    Free_lun,lun
    Free_lun,lunv

    ;**********************************************************************************
    ; this part should be replace to be the same as in the a2DSCPIview.pro part up to the bottom line
    ;********************************************************************************************
    ; store the old values to keep them in the commond data block.
    (*alldataH).alexei1old =(*alldataH).alexei1

    (*alldataV).alexei1old =(*alldataV).alexei1

    ;***************************************************

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="correct_HV_first_last_particles_ticks" ; tell user what we're up to
    print, "correct_HV_first_last_particles_ticks"
    correct_HV_first_last_particles_ticks

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Plot_unsorted_particles_nanotimes_and_ticks_and_tas, H" ; tell user what we're up to
    print, "Plot_unsorted_particles_nanotimes_and_ticks_and_tas, H"
    Plot_unsorted_particles_nanotimes_and_ticks_and_tas,'H'

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Plot_unsorted_particles_nanotimes_and_ticks_and_tas, V" ; tell user what we're up to
    print, "Plot_unsorted_particles_nanotimes_and_ticks_and_tas, V"
    Plot_unsorted_particles_nanotimes_and_ticks_and_tas,'V'

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="correct_tas_of_HV_particles" ; tell user what we're up to
    print, "correct_tas_of_HV_particles" ; TAF this is a serious hang and needs to be fixed!!!! crashes IDL without being able to debug



    if !use_external_tas eq 0 then begin
        correct_tas_of_HV_particles; including fake particles.
    endif

    ;calculate the w8_t for each partiles with deadtime removed.

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Label_all_saw_tooth_events" ; tell user what we're up to
    print, "Label_all_saw_tooth_events"
    Label_all_saw_tooth_events,'H';  added on March 31, 2008.
    Label_all_saw_tooth_events,'V'

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="calculate_wait_time_of_all_HVparticles" ; tell user what we're up to
    print, "calculate_wait_time_of_all_HVparticles"
    calculate_wait_time_of_all_HVparticles,'H'; assigne warn=warn+10 and reject particles if w8_tless than 0.
    calculate_wait_time_of_all_HVparticles,'V'; f w8_t less than 0, it mean time is non-monotonic.

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100" ; tell user what we're up to
    print,"Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100"
    Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100,'H';  just assign warn=warn+100.
    Reject_Particles_btw_SE_Mkpair_N_assign_irregular_Value100,'V'

    ;Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="correct_HV_particles_nanotimes" ; tell user what we're up to
    ;print,"correct_HV_particles_nanotimes"  ; these screw up the nanoseconds field!!!!!
    ;correct_HV_particles_nanotimes,'H';  assigned warn=warn+1000; to time can not recovered particles.
    ;correct_HV_particles_nanotimes,'V'; ; comment time correction  for bead testing

    ;************************************************************
    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="calculate_L7_of_all_H_andV_particles" ; tell user what we're up to
    print,"calculate_L7_of_all_H_andV_particles"
    calculate_L7_of_all_H_andV_particles
    calculate_L8_of_all_H_andV_particles
    calculate_AccDeadtime_of_all_H_andV_particles; added on March 4, 2008

    ; TAF commenting out unresolved for making .sav files
    if !use_nav_tas_correct_L1n eq 1 then begin; Not a legal system variable: !USE_NAV_TAS_CORRECT_L1N.
        stop
        ;correct_L1n_area_alexei1_adj1_for_macpex_project,'2DS','H'
        ;correct_L1n_area_alexei1_adj1_for_macpex_project,'2DS','V'
    endif

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="end of spec_toolar_load_archive" ; tell user what we're up to
    print, "end of spec_toolar_load_archive"
end; end of spec_toolar_load_archive, info



Pro Do_overnight_auto_archiving_works_tc4,info,AllOrKps,liqorice,my_selection,basescanfiles=basescanfiles,criteria_text=criteria_text;  ;added AllorKps on Auguts 13th, 2008.
    Common  DataBlock,alldataH,alldataV
    forward_function archive_ice_pop_up
    ; This program load a bunch of sorted files,
    ; then make bin-files and generated the archived files, overNight.

    ;first get all the roi files.
    if keyword_set(basescanfiles) eq 0 then begin
        if !autoarchive_png_only eq 1 then begin
            kkk = create_output_png_criteria(value=1)
            criteria_text = (*(*kkk).localstate).text
        endif

        get_all_sorted_2DS_data_filenames,filenames,file_count
    endif else begin
        filenames=basescanfiles
        file_count=n_elements(filenames)
        ;if keyword_set(options) eq 1 then begin
        ;my_selection=*((*options).localstate);  ; criteria_txt is already in place with options.
        ;endif

    endelse

    if file_count eq 0 then begin
        return
    endif

    startnanoseconds = ulong64(0)
    endnanoseconds = ulong64(0)
    ;Then use a loop to process each file.

    previous_endnanoseconds = 0L ; define for first iteration for debug printouts

    for i=0, file_count-1 do begin
        Kth=i+1

        ;if i eq 0 and !autoarchive_png_only eq 1 then begin
        ; TAF moved from below up higher to do this step earlier in the png generation process
        ; create_output_png_criteria now sets the system variable !roundness_criteria_checked
        ; which is used below to run Get_allindexs_and_boolean_subsetindexs_CLEAN with or without Roundness criteria

        ; kkk = create_output_png_criteria(value=1)
        ; criteria_text = (*(*kkk).localstate).text
        ;endif
        filename = filenames(i);  dialog_pickfile(filter='SORTED*.2DSCPI',  /Read)
        info.currentFname=filename


        substrsF=strsplit(filename,'\',/extract)
        short_filename=substrsF(n_elements(substrsF)-1)
        ;info.datestamp = strmid(filename,strpos(filename,"SORTED")+6,24); changed to 24 from 12.
        ;info.datestamp = strmid(Short_filename,6,strlen(Short_filename)-10)
        info.datestamp = strmid(Short_filename,6,strlen(Short_filename)-13); ; for 3VCPI filenames
        end_of_path = STRPOS(filename, '\', /REVERSE_SEARCH)
        info.currentPname =  STRMID(filename,0,end_of_path+1)

        ; following line loads the sorted filed and generate the bin files.
        ; it can be comment out if the bin files have been generated before.
        ; look for dataKth directory in "info.currentPname\data\"  or info.currentPname\dataKth\ to see
        ; if there is data files in there. if no, there make new ones.

        currentPath=info.currentPname
        filter_str='Horiz'+info.datestamp+'.Bin';';   ;user comfirms
        filename=file_search(currentpath,filter_str,COUNT=file_count2)

        if !use_external_TAS eq 1 then begin
            SPEC_Toolbar_Save, info,i;   generate new bin files.
        endif

        if file_count2 eq 0 and !use_external_TAS eq 0  then begin; ; if in the past bin file are already generated, then skip this part.
            SPEC_Toolbar_Save, info,i; change to this line on Nov. 14, 2007.
        endif
        ;now the bin files are generated, we need to load and open the bin-files do do the processing.
        ; in the next block.
        ;********************************************************************************
        ;Now open the BIN file and begin doing all of the processing
        SPEC_Toolbar_Load_archive,info
        ;********************************************************************************

        if !mass_optionLiq eq 1 then begin
            liqorice ='liq'
        endif else begin;    for !mass_optionIWC = 1 or !mass_optioncsp =1  do ice archiving option
            liqorice ='ice'
        endelse


        case !clean_option of
            0:        AllOrKps='All'
            1:        AllorKps='KeepSplashes'
            2:        AllorKps='NoClean'
        endcase


        if AllOrKps ne 'NoClean' then begin
            Auto_clean_oneParticle_by_oneParticle,'H',info,AllOrKps,liqorice;  This is for cleaning all both ice or liq
            Auto_clean_oneParticle_by_oneParticle,'V',info,AllorKps,liqorice
        endif

        ; now do the auto archiving
        ; the !currentFname has to be assign for processing the data file.

        if !autoarchive eq 1 then begin

            !filter=1;  added this on july 27, 2009.

            if my_selection.M6 eq 1 then begin
                !autoarchive_method='M6'
                if(!roundness_criteria_checked) then begin ; do the archiving twice, once for NOT ROUND, and once for ROUND
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H', round_flag = 2;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V', round_flag = 2;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H',round_flag = 1
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V',round_flag = 1
                endif else begin ; do the normal archiving, without regard to roundness criteria
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H' ;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V' ;  This has extinction, mass psds with it.
                endelse
            endif
            if my_selection.M5 eq 1 then begin
                !autoarchive_method='M5'

                if(!roundness_criteria_checked) then begin ; do the archiving twice, once for NOT ROUND, and once for ROUND
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 1;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 1;;  This has extinction, mass psds with it.
                endif else begin ; do the normal archiving, without regard to roundness criteria
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H';;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V';;  This has extinction, mass psds with it.
                endelse
            endif

            if my_selection.M4 eq 1 then begin
                !autoarchive_method='M4'

                if(!roundness_criteria_checked) then begin ; do the archiving twice, once for NOT ROUND, and once for ROUND
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 1;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 1;;  This has extinction, mass psds with it.
                endif else begin ; do the normal archiving, without regard to roundness criteria
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H';;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V';;  This has extinction, mass psds with it.
                endelse
            endif

            if my_selection.M2 eq 1 then begin
                !autoarchive_method='M2'

                if(!roundness_criteria_checked) then begin ; do the archiving twice, once for NOT ROUND, and once for ROUND
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 1;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 1;;  This has extinction, mass psds with it.
                endif else begin ; do the normal archiving, without regard to roundness criteria
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H';;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V';;  This has extinction, mass psds with it.
                endelse
            endif

            if my_selection.M1 eq 1 then begin
                !autoarchive_method='M1'

                if(!roundness_criteria_checked) then begin ; do the archiving twice, once for NOT ROUND, and once for ROUND
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 1;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 1;;  This has extinction, mass psds with it.
                endif else begin ; do the normal archiving, without regard to roundness criteria
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H';;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V';;  This has extinction, mass psds with it.
                endelse
            endif

            if my_selection.M7 eq 1 then begin
                !autoarchive_method='M7'

                if(!roundness_criteria_checked) then begin ; do the archiving twice, once for NOT ROUND, and once for ROUND
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 2;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'H',round_flag = 1;;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice, 'V',round_flag = 1;;  This has extinction, mass psds with it.
                endif else begin ; do the normal archiving, without regard to roundness criteria
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'H';;  This has extinction, mass psds with it.
                    Do_Nsecond_Ultimate_archive_61binsHorV,info=info,AllorKps,liqorice,'V';;  This has extinction, mass psds with it.
                    if !Do_M7_area_ratio then begin
                        Do_Nsecond_61binsHorV_M7aspec_ratio,info=info,liqorice, 'H'
                        Do_Nsecond_61binsHorV_M7aspec_ratio,info=info,liqorice, 'V'
                    endif
                endelse
            endif

            !autoarchive_method='M6';  return to default values.
            !filter=0;  added this on july 27, 2009.
            ;*****************************************************************************
        endif; end of if !autorachive eq 1




        if !autoarchive_png_only eq 1 then begin
            ; get all accepted indexs
            ;Hsubindex=where((*alldataH).reject eq 0 and (*alldataH).L1n gt 0.0,contG)
            ;ave_info={Hsubindex:ptr_new(),$
            ;         Vsubindex:ptr_new()}
            ;**************************************************************************************************

            ; TAF moving up higher to do this step earlier in the png generation process
            ;        if i eq 0 then begin
            ;            ; create_output_png_criteria now sets the system variable !roundness_criteria_checked
            ;            ; which is used below to run Get_allindexs_and_boolean_subsetindexs_CLEAN with or without Roundness criteria

            ;            kkk=create_output_png_criteria(value=1)
            ;            criteria_text=(*(*kkk).localstate).text
            ;        endif

            criteria = {on:1, text:criteria_text(0), Hfactor:1, Vfactor:1, label:' '}

            prev_startnanoseconds = startnanoseconds
            prev___endnanoseconds =   endnanoseconds

            startnanoseconds = min([min((*alldataH).nanoseconds), min((*alldataV).nanoseconds)])
            endnanoseconds = max([max((*alldataH).nanoseconds), max((*alldataV).nanoseconds)])


            ; TAF 2013-11-15 modifying start and end times so that there are no png overlaps

            print, 'File ', Kth
            print, 'startnanoseconds = ', startnanoseconds
            print, 'endnanoseconds o = ', endnanoseconds

            if(Kth gt 1) then begin ; modify the startnanoseconds to start with the last file's endnanoseconds
                startnanoseconds = prev___endnanoseconds

                ;print, 'endnanoseconds m = ', endnanoseconds
                print, ''
                print, 'startnanoseconds m = ', startnanoseconds
                print, '  endnanoseconds m = ',   endnanoseconds
                print, ''
            endif

            if(!roundness_criteria_checked) then begin
                ; not round
                ave_info = {criteria:criteria,                 $
                    startnanoseconds:startnanoseconds, $
                    endnanoseconds:endnanoseconds,     $
                    Hallindex:ptr_new(),               $
                    Hsubindex:ptr_new(),               $
                    Vallindex:ptr_new(),               $
                    Vsubindex:ptr_new()}

                Get_allindexs_and_boolean_subsetindexs_CLEAN,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor, round_flag = 2
                ;****************************************************************************************************************

                if Hsubindex(0) ge 0 then begin ;makes sure there are particles.
                    ave_info.Hsubindex=ptr_new(Hsubindex)
                    output_png_images_page,ave_info,'H', round_flag = 2
                endif

                ;Vsubindex=where((*alldataV).reject eq 0 and (*alldataV).L1n gt 0,contG); comment out on August 26, 2009.
                if Vsubindex(0) ge 0 then begin;  makes sure there are particles.
                    ave_info.Vsubindex=ptr_new(Vsubindex)
                    output_png_images_page,ave_info,'V', round_flag = 2
                endif

                ; round
                ave_info = {criteria:criteria,                 $
                    startnanoseconds:startnanoseconds, $
                    endnanoseconds:endnanoseconds,     $
                    Hallindex:ptr_new(),               $
                    Hsubindex:ptr_new(),               $
                    Vallindex:ptr_new(),               $
                    Vsubindex:ptr_new()}

                Get_allindexs_and_boolean_subsetindexs_CLEAN,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor, round_flag = 1
                ;****************************************************************************************************************

                if Hsubindex(0) ge 0 then begin ;makes sure there are particles.
                    ave_info.Hsubindex=ptr_new(Hsubindex)
                    output_png_images_page,ave_info,'H', round_flag = 1
                endif

                ;Vsubindex=where((*alldataV).reject eq 0 and (*alldataV).L1n gt 0,contG); comment out on August 26, 2009.
                if Vsubindex(0) ge 0 then begin;  makes sure there are particles.
                    ave_info.Vsubindex=ptr_new(Vsubindex)
                    output_png_images_page,ave_info,'V', round_flag = 1
                endif
            endif else begin ; generate png pages of mixed roundness values
                ave_info = {criteria:criteria,                 $
                    startnanoseconds:startnanoseconds, $
                    endnanoseconds:endnanoseconds,     $
                    Hallindex:ptr_new(),               $
                    Hsubindex:ptr_new(),               $
                    Vallindex:ptr_new(),               $
                    Vsubindex:ptr_new()}

                Get_allindexs_and_boolean_subsetindexs_CLEAN,ave_info,Hallindex,Hsubindex,Hfactor,Vallindex,VsubIndex,Vfactor
                ;****************************************************************************************************************

                if Hsubindex(0) ge 0 then begin ;makes sure there are particles.
                    ave_info.Hsubindex=ptr_new(Hsubindex)
                    output_png_images_page,ave_info,'H'
                endif

                ;Vsubindex=where((*alldataV).reject eq 0 and (*alldataV).L1n gt 0,contG); comment out on August 26, 2009.
                if Vsubindex(0) ge 0 then begin;  makes sure there are particles.
                    ave_info.Vsubindex=ptr_new(Vsubindex)
                    output_png_images_page,ave_info,'V'
                endif
            endelse

            print, 'Auto archiving pngs done for file ', Kth, '   out of ', file_count
            print, ''
        endif; end of !autoarchive_png_only eq 1 then begin
        ;********************************************************************************
    endfor



    if !autoarchive eq 1 then begin
        print, 'Batch processing finished ', file_count, ' SORTED files'
        print, ''

        ;concatenaet all M1 files, M2 files, M3 file, M4 file M5, Mx files.
        substrsF=strsplit(!currentHFname,'\',/extract)
        up_pathnm=strjoin(substrsF(0:n_elements(substrsF)-3),'\')+'\'

        for jjj=1, 7 do begin
            Mjjj=strtrim(string(jjj),2)
            This_folder_name=up_pathnm+'all_M'+Mjjj+'_files\'

            filenames=file_search(This_folder_name,'H_archive_*2DS*_PSD*'+Mjjj+'ice.txt',Count=file_count)
            if file_count ge 1 then begin
                concate_all_2ds_Mxice_txt_files,pathnm,filenames,file_count,Mjjj
            endif

            filenames=file_search(This_folder_name,'V_archive_*2DS*_PSD*'+Mjjj+'ice.txt',Count=file_count)
            if file_count ge 1 then begin
                concate_all_2ds_Mxice_txt_files,pathnm,filenames,file_count,Mjjj
            endif

        endfor


        for jjj=1, 7 do begin
            Mjjj=strtrim(string(jjj),2)
            This_folder_name=up_pathnm+'all_M'+Mjjj+'_files\'

            filenames=file_search(This_folder_name,'H_archive_*2DS*_PSD*'+Mjjj+'liq.txt',Count=file_count)
            if file_count ge 1 then begin
                concate_all_2ds_Mxice_txt_files,pathnm,filenames,file_count,Mjjj
            endif

            filenames=file_search(This_folder_name,'V_archive_*2DS*_PSD*'+Mjjj+'liq.txt',Count=file_count)
            if file_count ge 1 then begin
                concate_all_2ds_Mxice_txt_files,pathnm,filenames,file_count,Mjjj
            endif

        endfor
    endif;  if !autoarchive eq 1

end ; end of Do_overnight_works_Tc4.
;************************************************************
