
; File:  Do_Overnight_works.pro
; Purpose:  The "Do_overnight_works" proceedure gets called when Batch ROI Processing is selected -- it will
;    process every roi file in the directory,
;    generate .obj files, png pages using default (need better place to store the defaults) parameters,
;    and csv files of particle information

; It appears that the defaults used are adjustable below, within the proceedure, in particular, the criteria string:

; (*pLink).criteria ='focus gt 20 and cutoff lt 6'




Pro Do_overnight_works, pStateInfo
    ; This program load a bunch of roi files, them make the objs and ascii files in one night.

    ;first get all the roi files.
    get_all_roi_data_filenames,filenames,file_count,pathnm
    (*Pstateinfo).path=pathnm

    if file_count eq 0 then begin
        return
    endif

    ;Then use a loop to process each file.

    for i=0, file_count-1 do begin
        loadfile,PstateInfo,filename=filenames(i)

        ;make the obj files.
        if i eq 0 then begin; get the parameters for extracting the objs
            parameters = extractgui(pStateInfo)

            ; mo modified this on April 25  to added change Time  to the png pages to sync with 2DS images and other images.
            ;if !DT_CPI eq (-99999L) then begin

            if(!disable_time_popups eq 1) then begin
                !Time_synced = 1
            endif else begin
                !Time_synced=(moqixu_input_single_number_pop_up(title='If Time is synced enter 1 else 0: ',label='Time synced:',value='0'))*1L

                if !Time_synced eq 1 then begin
                    !DT_CPI=(moqixu_input_single_number_pop_up(title='For relabeling CPI png page image only',label='CPI_Time_offset:',value='0'))*1L
                endif else begin
                    !DT_CPI=0
                endelse
            endelse
            ;endif

        endif


        ;if((*pStateInfo).objLUN ne -1)then begin;   if there is obj file, loadfile already loaded it.
        ;  free_lun,(*pStateInfo).objLUN
        ;  (*pStateInfo).objLUN = -1;                discard the old obj file.  for next to do a new obj file.
        ;endif

        fdata=fstat((*pstateinfo).infilelun)
        if fdata.size le 2000000 then begin
            ;rrr=dialog_message(' File less than 2M, probably no images in it, it may crash, do another file !',/info)
            goto, NextI
        end

        initpTimeInfo, pStateInfo,multiple = 0

        if(*pStateInfo).objLUN  eq -1  then begin
            process_frames , parameters,pStateInfo;   : this call makes a new obj file.  May 20, 2011.
        endif


        ; update pStateInfo with current objData
        if(ptr_valid((*pStateInfo).pObjList))then begin
            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
            ; store obj info
            (*pStateInfo).pObjData = ptr_new(objData)
        endif

        ;do the ascii files
        ; first do particle log file
        pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link
        (*pLink).sendASCII = 1
        (*pLink).output = 1


        (*pLink).sendASCII = 4
        select = bytarr(50) + 1B
        select[47]=0   ; skip boundary
        (*pLink).pSelect = ptr_new(select)

        ; then do frame log
        if 1 eq 2 then begin
            (*pLink).Format = 'frame'
            (*pLink).sendASCII = 1;    this must to be 1 for writing the frame.txt file.
            index = Process_timeSeries( pStateInfo)
            close_ascii,pStateInfo
        endif

        ; finally  do hertz log
        if 1 eq 2 then begin
            (*pLink).sendASCII = 4
            (*pLink).Format = 'hertz'
            index = Process_timeSeries( pStateInfo)
            close_ascii,pStateInfo
        endif

        if 1 eq 1 then begin
            (*pLink).Format = 'spec1'   ; this is for making combined.csv file.
            ; call processing
            ; index = Process_timeSeries( pStateInfo)
            index=Make_combined_dot_csv_file(pStateInfo)
            close_ascii,pStateInfo
        endif

        ;  make sure .csv file is closed

        if 1 eq 1 then begin;  to make png pages.

            (*pLink).Format = ''; so that it would not do it again in next call.
            (*pLink).sendASCII = 0;  so that it won't open teh ascii files while doing the png pages.
            ;**********************************************************************************
            ; now generate all png images files and put it in a image_directory.
            ; first make a directory and then make the pngs files and save it to the directory.
            ;  get directory name
            substrs=strsplit(filenames(i),'\',/extract)
            short_name=substrs(n_elements(substrs)-1)
            pathnm=strmid(filenames(i),0,strlen(filenames(i))-strlen(short_name))
            sub_dir_path=pathnm+'images_of_'+strmid(short_name,0,strlen(short_name)-4)+'_roi\'
            ;make the directory first, or else it can not write the png page images to it.
            FILE_MKDIR,sub_dir_path

            (*pstateinfo).TIFFPATH=sub_dir_path;   the tiff path to store the png pages by savewndtoFile.
            ; test if there is already such a directory, if not, make such a directory.

            ;********************************

            ; note that three button has to be click to process the png pages.
            (*pLink).addtime =255;   event.select=1 for addtime label.
            (*pLink).sendTiff =1;  event.select=1 for send_png
            (*plink).display1=1;   event.select=1 for showing te png pages on screen.
            (*pStateInfo).PrintROI.Flags = 0; equal 1 will send the png page to a printer.
            (*pStateInfo).PrintROI.Flags =(*pStateInfo).PrintROI.Flags OR 2;  show the png page.
            (*pStateInfo).PrintROI.Flags =(*pStateInfo).PrintROI.Flags OR 4;  save the png page to file.
            (*pStateInfo).PrintROI.Flags =(*pStateInfo).PrintROI.Flags OR 256;  ; this is for addtime label.
            (*pStateInfo).PrintROI.Doit =!true
            if i eq 0 then begin

                (*pLink).criteria ='focus gt 20 and cutoff lt 6'

                if(!disable_time_popups ne 1) then begin ; PLEASE, SERIOUSLY, PLEASE NO MORE POPUPS IN PROGRAMS!!!  THEY INTERUPT PROCESSING AND MAKE PEOPLE HAVE TO BABYSIT THE PROGRAM.
                    rrrm=dialog_message('Do you want to use criteria "focus gt 20 and cuff lt 6" ?  if no, then you will have to load the ascii criteria file like CPI_plt.txt in subfolder common_criteria',/question)

                    if rrrm ne 'Yes' then begin
                        file = dialog_pickfile(title='Select a file to load from.',filter='*.txt')
                        if(file ne '')then begin
                            openr,lun,file,/get
                            cmd = ''
                            readf,lun,cmd
                            (*pLink).criteria = cmd
                            (*pstateinfo).batch_png_criteria=cmd
                        endif
                    endif
                endif
            endif

            if i gt 0 and (*pstateinfo).batch_png_criteria ne '' then begin

                (*pLink).criteria = (*pstateinfo).batch_png_criteria
            endif


            ;we have to set (*plink).accept =1  to make the png make accept the critera
            ;  if((*pLink).sendASCII eq 4 and (*pLink).output)then begin
            ;   if((*pLink).accept) THEN criteria = (*pLink).criteria else criteria = 'none'
            ;   request = open_ascii_spec1(pStateInfo,criteria)
            ;   sendASCII = !true
            ; endif
            (*plink).accept =!true

            (*plink).addtime =255


            ; TAF 2013-09-07 for print classification sph/ice on png pages from batch processing,
            ; change !Add_Classification_to_pngs in a3VCPIView.pro to 'Y'

            if(!Add_Classification_to_pngs eq 'Y') then begin
                (*plink).addtype =255
                (*pStateInfo).PrintROI.Flags =(*pStateInfo).PrintROI.Flags OR 128; add crystal type to image.
            endif else begin
                (*plink).addtype =!false;     ;255  255 is to add type.
            endelse


            ; I have to assign  the *Plink  into  the Pstaeinfo  to pass it to the following functions call.
            ; first to make it work.

            ; index = Process_timeSeries( pStateInfo)
            ; index = Process_time_Series_png_pages_only( pStateInfo)
            index = Process_timeSeries_png_pages_only_3VCPI(pStateInfo)
            (*plink).accept =!false
            (*pStateInfo).PrintROI.Doit =!false
            (*pStateInfo).PrintROI.Flags = 0
            (*pLink).sendTiff =0 ;  event.select=1 for send_png
            (*plink).display1=0
            (*pStateInfo).PrintROI.PageDx=0
            (*pStateInfo).PrintROI.PageDy=0
            (*pStateInfo).PrintROI.Pagex=0
            (*pStateInfo).PrintROI.Pagey=0
        endif;  ; end of if 1 eq 2  to make png pages.
        nextI:    ; jump to here if  the ith file is too small a file, with no images.
        ;after we done one file; we need to clean up pstateinfo for loading a new file.
        ; remove old file info; purpose: to clean up memory when a new file is loaded or at program end
        clean_up_namma,pStateInfo
    endfor

end ; end of Do_overnight_works.



pro  get_all_roi_data_filenames, filenames, file_count, pathnm
    dirn=dialog_pickfile(filter='*.roi',get_path=pathnm)

    filter_str=pathnm+'*.roi';   ;user comfirms
    filenames=findfile(filter_str,COUNT=file_count)

    ; display the filenames
    print,'****************************************'
    print,'*****  Here are all roi data files *****'
    print,'*****  in current directory        *****'
    print,'*****  for Batch ROI Processing    *****'
    print,'****************************************'

    for j=0, (file_count-1)  do begin
        print, filenames(j)
    endfor

    print,'****************************************'
end ; get_all_data_filenames
;****************************************************************************
pro clean_up_namma, pStateInfo, processing=processing

    ; purpose : to clean up memory when a new file is loaded or at program end
    ; keyword
    ; processing  if set, then graph processing is happening and the ptime Info should no be deleted

    if ptr_valid((*pStateInfo).pObjList) then PTR_FREE, (*pStateInfo).pObjlist
    if(ptr_valid((*pStateInfo).pObjData)) then begin
        ptr_free,(*(*pStateInfo).pObjData).pFrame
        ptr_free,(*(*pStateInfo).pObjData).pImHDfPos
        ptr_free,(*pStateInfo).pObjData
    endif
    if((*pStateInfo).ObjLUN ne -1)then begin
        free_lun,(*pStateInfo).ObjLUN
        (*pStateInfo).ObjFile = ''
        (*pStateInfo).ObjLUN = -1
    endif

    if (*pStateInfo).InFileLun GT 0 then FREE_LUN, (*pStateInfo).InFileLun

    if(not keyword_set(processing))then processing = !false
    ; cleanup the linked list from generate/view plots
    if(ptr_valid((*pStateInfo).pTimeInfo) and not processing)then begin
        if(ptr_valid((*(*pStateInfo).pTimeInfo).pCurrent_link))then begin
            pLink = find_last_link( (*(*pStateInfo).pTimeInfo).pCurrent_link )
            while ( ptr_valid(pLink)) do pLink = delete_link(pLink)
        endif
    endif
    if ptr_valid((*pStateInfo).pFileScan) then PTR_FREE, (*pStateInfo).pFileScan
    if(ptr_valid((*pStateInfo).pBounds))then ptr_free,(*pStateInfo).pBounds
    if ptr_valid((*pStateInfo).pFrameData)then delete_frame,(*pStateInfo).pFrameData
    if(ptr_valid((*pStateInfo).pConc))then ptr_free,(*pStateInfo).pConc
    if(ptr_valid((*pStateInfo).pImgPosIndx))then ptr_free,(*pStateInfo).pImgPosIndx

    if ptr_valid((*pStateInfo).BackFrame) then begin
        ptr_free,(*(*pStateInfo).BackFrame).pBackImg
        ptr_free,(*pStateInfo).BackFrame
    endif

    if(ptr_valid((*pStateInfo).pTimeInfo) and not processing)then begin
        ptr_free,(*pStateInfo).pTimeInfo
        (*pStateInfo).pTimeInfo = ptr_new()
    endif
    if ptr_valid((*pStateInfo).pBackPosIndx) then ptr_free, (*pStateInfo).pBackPosIndx
    (*pStateInfo).pBackPosIndx = ptr_new()

end; end of clean_up_namma
