pro objectheader0__Define

    d = {objectheader0,BlockMark:0U,    $
        ROIInfoSize:0UL,$  ; this is variable because of the last two fields in the header and the data size
        ROIVer:31U,       $ ; should be 31
        sx:0U,        $ ; upper left corner X of image in full frame co-ords
        sy:0U,        $ ; upper left corner Y of image in full frame co-ords
        ex:0U,        $ ; lower right corner X of image in full frame co-ords
        ey:0U}          ; lower right corner Y of image in full frame co-ords
end

pro objectHeader1__Define

    d = {objectHeader1, BlockMark:0U,   $
        ROIInfoSize:0UL,   $ ; this is variable because of the last two fields in the header and the data size
        ROIVer:30U,       $ ; should be 30
        sx:0U,        $ ; upper left corner X of image in full frame co-ords
        sy:0U,        $ ; upper left corner Y of image in full frame co-ords
        ex:0U,        $ ; lower right corner X of image in full frame co-ords
        ey:0U,        $ ; lower right corner Y of image in full frame co-ords
        PixBytes:0U,   $    ; if this is zero, no image data is included!
        Flags:0U,   $   ; contains info about crstal type, focus, reject and manual parameters
        Len:0.0,     $    ; length of major axis in pixels
        SLen:0UL,   $   ; 1D index of length vector start point in Sub-array coords
        ELen:0UL,   $   ; 1D index of length vector stop point in Sub-array coords
        Wid:0.0,     $    ; lenght of axis perpendicular to major axis in pixels
        SWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        EWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        Dark:0,         $    ; this field is called usROIDepth in header, contains depth and cutoff info
        Area:0.0,   $   ; computed area   in pixels
        Perim:0.0,     $  ; computed perimeter in pixels
        Centroid:[0.,0.],$ ; Centroid of particle ( 2 elements )
        Roundness1:0.0, $   ; Measure of particle roundness
        X_Moment:0.0,  $    ; 1/2 area on each side of vert line
        Y_moment:0.0,  $    ; 1/2 area on each side of horiz line
        Rubber_Band:0.0,$  ; Measure of boundary roughness
        Fractal_dim:0.0,$  ; Fractal dimension
        Harmonic_len:0UL,  $    ; Number of elements in Harmonic array
        Bound_len:0UL, $   ; Number of elements in Boundary array
        Sample_period:0.0,$    ; Sample period of harmonic array in pixels
        Focus:0B,   $   ; % focus 0-100. This is the average focus value for multiple samples along the particle boundary
        FocusMin:0B,   $ ; Min % focus of samples taken
        FocusMax:0B,   $ ; Max % focus of samples taken
        FocusStdDev:0.0,$  ; Standard deviation of focus samples taken
        FocusGoodSamples:0B,$; Percent of samples which yielded valid focus values: 0 - 100
        CutOff:0B,     $  ; % particle is cut-off 0 - 100
        Crystal:0B,       $ ; Scalar type index meaning TBD
        Confidence:0B, $   ; Factor assessing confidence in particle use 0-10
        P1:0.0,         $    ; Place holder
        Roundness2:0.0,         $    ; Place holder
        Roundness3:0.0,         $    ; Place holder
        P4:0.0}          ; Place holder
end

pro objectheader2__Define

    d = {objectHeader2,BlockMark:0U,    $
        ROIInfoSize:0UL,$  ; this is variable because of the last two fields in the header and the data size
        ROIVer:31U,       $ ; should be 31
        sx:0U,        $ ; upper left corner X of image in full frame co-ords
        sy:0U,        $ ; upper left corner Y of image in full frame co-ords
        ex:0U,        $ ; lower right corner X of image in full frame co-ords
        ey:0U,        $ ; lower right corner Y of image in full frame co-ords
        PixBytes:0U,   $    ; if this is zero, no image data is included!
        Flags:0U,   $   ; contains info about crstal type, focus, reject and manual parameters
        Len:0.0,     $    ;Xlength of major axis in pixels
        SLen:0UL,   $   ; 1D index of length vector start point in Sub-array coords
        ELen:0UL,   $   ; 1D index of length vector stop point in Sub-array coords
        Wid:0.0,     $    ;Xlenght of axis perpendicular to major axis in pixels
        SWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        EWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        Dark:0U,     $    ;Xthis field is called usROIDepth in header, contains depth and cutoff info
        Area:0.0,   $   ;Xcomputed area   in pixels
        Perim:0.0,     $  ;Xcomputed perimeter in pixels
        Centroid:[0.,0.],$ ;XCentroid of particle ( 2 elements )
        Roundness1:0.0, $   ;XMeasure of particle roundness
        X_Moment:0.0,  $    ;X1/2 area on each side of vert line
        Y_Moment:0.0,  $    ;X1/2 area on each side of horiz line
        Rubber_Band:0.0,$  ;XMeasure of boundary roughness
        Fractal_dim:0.0,$  ;XFractal dimension
        Harmonic_len:0U,$  ; Number of elements in Harmonic array
        Bound_len:0U,  $    ; Number of elements in Boundary array
        Sample_period:0.0,$    ;XSample period of harmonic array in pixels
        Focus:0B,   $   ;X% focus 0-100. This is the average focus value for multiple samples along the particle boundary
        FocusMin:0B,   $ ;XMin % focus of samples taken
        FocusMax:0B,   $ ;XMax % focus of samples taken
        FocusStdDev:0.0,$  ;XStandard deviation of focus samples taken
        FocusGoodSamples:0B,$;XPercent of samples which yielded valid focus values: 0 - 100
        CutOff:0B,     $  ;X% particle is cut-off 0 - 100
        Crystal:0B,       $ ;XScalar type index meaning TBD
        Confidence:0B, $   ; Factor assessing confidence in particle use 0-10
        P1:0.0,         $    ; used in manualFeature as input of status of manual setting, sent by view_event
        Roundness2:0.0,         $     ; Roundness 2, stddev of distances to centroid
        Roundness3:0.0,         $     ; Roundness 3, ratio of perimeter angles total to expected
        P4:0.0,         $    ;XPlace holder
        Radii_len:0U,  $    ; Number of elements in the radii array below
        Curvature_len:0U,$ ; Number of elements in the radius of curvature array below
        Curvature_Window:0U,$;XNumber of points used in the local radius of curvature measurement
        ; For the stats arrays that follow, the elements are:
        ; N: number of data points used,
        ; Min, Max, Mean, Median, Mode, Standard Deviation, Skewness, Kurtosis
        Focus_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        Intensity_HoleLess_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],    $
        Gradient_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],  $
        Radii_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        ; Local radius of curvature stats
        Curvature_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        ; Below are stats computed for holes within the particle
        Hole_Count:0U, $   ; Number of holes found1
        ; Stats including all holes
        Hole_Area_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        ; Values for the biggest 3 holes
        Hole1_Area:0.0,    $
        Hole1_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole1_Perim:0.0,   $
        Hole1_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole2_Area:0.0,    $
        Hole2_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole2_Perim:0.0,   $
        Hole2_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole3_Area:0.0,    $
        Hole3_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole3_Perim:0.0,   $
        Hole3_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]}
end

pro imageheader31__Define

    d = {imageHeader31,BlockMark:0U, $
        ROIInfoSize:0UL,$  ; this is variable because of the last two fields in the header and the data size
        ROIVer:31U,       $ ; should be 31
        sx:0U,        $ ; upper left corner X of image in full frame co-ords
        sy:0U,        $ ; upper left corner Y of image in full frame co-ords
        ex:0U,        $ ; lower right corner X of image in full frame co-ords
        ey:0U,        $ ; lower right corner Y of image in full frame co-ords
        PixBytes:0U,   $    ; if this is zero, no image data is included!
        Flags:0U,   $   ; contains info about crstal type, focus, reject and manual parameters
        Len:0.0,     $    ; length of major axis in pixels
        SLen:0UL,   $   ; 1D index of length vector start point in Sub-array coords
        ELen:0UL,   $   ; 1D index of length vector stop point in Sub-array coords
        Wid:0.0,     $    ; lenght of axis perpendicular to major axis in pixels
        SWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        EWid:0UL,   $   ; 1D index of width vector start point in Sub-array coords
        Dark:0U,     $    ; this field is called usROIDepth in header, contains depth and cutoff info
        Area:0.0,   $   ; computed area   in pixels
        Perim:0.0,     $  ; computed perimeter in pixels
        Centroid:[0.,0.],$ ; Centroid of particle ( 2 elements )
        Roundness1:0.0, $   ; Measure of particle roundness [using method 1, area vs circular area for diameter]
        X_Moment:0.0,  $    ; 1/2 area on each side of vert line
        Y_Moment:0.0,  $    ; 1/2 area on each side of horiz line
        Rubber_Band:0.0,$  ; Measure of boundary roughness
        Fractal_dim:0.0,$  ; Fractal dimension
        Harmonic_len:0U,$  ; Number of elements in Harmonic array
        Bound_len:0U,  $    ; Number of elements in Boundary array
        Sample_period:0.0,$    ; Sample period of harmonic array in pixels
        Focus:0B,   $   ; % focus 0-100. This is the average focus value for multiple samples along the particle boundary
        FocusMin:0B,   $ ; Min % focus of samples taken
        FocusMax:0B,   $ ; Max % focus of samples taken
        FocusStdDev:0.0,$  ; Standard deviation of focus samples taken
        FocusGoodSamples:0B,$; Percent of samples which yielded valid focus values: 0 - 100
        CutOff:0B,     $  ; % particle is cut-off 0 - 100
        Crystal:0B,       $ ; Scalar type index meaning TBD
        Confidence:0B, $   ; Factor assessing confidence in particle use 0-10
        P1:0.0,         $    ; used in manualFeature as input of status of manual setting, sent by view_event
        Roundness2:0.0,         $    ; Roundness 2, stddev of distances to centroid
        Roundness3:0.0,         $    ; Roundness 3, ratio of perimeter angles total to expected
        P4:0.0,         $    ; Place holder

        Radii_len:0U,  $    ; Number of elements in the radii array below
        Curvature_len:0U,$ ; Number of elements in the radius of curvature array below
        Curvature_Window:0U,$; Number of points used in the local radius of curvature measurement
        ; For the stats arrays that follow, the elements are:
        ; N: number of data points used,
        ; Min, Max, Mean, Median, Mode, Standard Deviation, Skewness, Kurtosis
        Focus_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        Intensity_HoleLess_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],    $
        Gradient_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],  $
        Radii_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        ; Local radius of curvature stats
        Curvature_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], $
        ; Below are stats computed for holes within the particle
        Hole_Count:0U, $   ; Number of holes found1
        ; Stats including all holes
        Hole_Area_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        ; Values for the biggest 3 holes
        Hole1_Area:0.0,    $
        Hole1_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole1_Perim:0.0,   $
        Hole1_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole2_Area:0.0,    $
        Hole2_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole2_Perim:0.0,   $
        Hole2_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole3_Area:0.0,    $
        Hole3_Intensity_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$
        Hole3_Perim:0.0,   $
        Hole3_Other_Stats:[0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0],$

        Harmonics:ptr_new(),$; Circular harmonics (float) of boundary(var. len)
        Boundary:ptr_new(),    $; Location (long) of boundary pixels in ROI array ( 1D indicies) (var. len)
        Radii:ptr_new(), $  ; Radial distance (float) from the centroid to the perimeter of the particle measured in Sample_period pixel steps
        Curvature:ptr_new()} ; Local radius of curvature (float) of the particle boundary, in pixels
end
;=======================================================================================================================
; Object file creation code
;=======================================================================================================================

pro init_obj_file, pStateInfo, roi=roi
    ;Purpose: To open an object file and write a SPEC file header

    ; Parameter
    ;   pStateInfo    Input uses fields minFile for file name and ObjFile for Logical unit number

    ; Keyword
    ;   roi          I   if true, write images


    ; use existing file name with new extention
    if((*pStateInfo).objFile eq '')then begin
        ;if(roi)then begin
        ; (*pStateInfo).objFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + 'A.roi'
        ;endif else begin
        (*pStateInfo).objFile = strmid((*pStateInfo).InFileName, 0,rstrpos((*pStateInfo).InFileName,'.')) + '.obj'
        ;endelse
    endif

    err = 0
    openW,lun,(*pStateInfo).ObjFile,/get,/swap_if_big_endian,error = err
    if( err ne 0)then begin
        r = dialog_message('Error opening obj file.  Check to see if file has read/write permission set')
        (*pStateInfo).ObjLUN = -1
    endif else (*pStateInfo).ObjLUN = lun

    if((*pStateInfo).ObjLUN gt 0)then begin
        txt = 'from: '+(*pStateInfo).infilename
        len = strlen(txt) < 70
        (*pStateInfo).filehead.text[0:len-1] = (byte(txt))[0:len-1]

        ; now write the header
        writeu,(*pStateInfo).ObjLUN,(*pStateInfo).fileHead
    endif
end

function init_obj_frame, pStateInfo, frame, FrameHeader
    ;Purpose: To write a frameheader

    ; Parameter
    ;   pStateInfo    Input  uses fields minFile and pObjList
    ;   frame     Input  frame to init
    ;   FrameHeader   Input original frame header
    ; returns file position

    ; set the list to point at the start of the frame being written, this is for use in the current session
    fpos = (fstat((*pStateInfo).ObjLUN)).cur_ptr
    ;(*(*pStateInfo).pObjList)[frame].fpos = fpos

    ;update the version number
    ;frameheader.ver = 30
    frameheader.ver = 31

    ; write the frameheader
    writeu,(*pStateInfo).ObjLun,FrameHeader

    ; need to get calcStrobe time working for 3V-CPI
    ;objTime = float(frameHeader.time) + calcStrobeTime(frameHeader.arrivalT1,frameHeader.arrivalT2,frameHeader.Ver)/1000.0D
    objTime = float(frameHeader.time)

    ;print,frame,objTime,format='(i3,x,f15.5)'
    ;print,'start of block',fpos, ' end of frameheader',(fstat((*pStateInfo).ObjLUN)).cur_ptr

    return,fpos

end


pro write_obj_frame, particleInfo, Imageheader, roiImg, lun, valid, totROIsSize, roi = roi
;Purpose: To output the informtion for one frame that is computed via FindParticles

; Parameters
;   particleInfo  I       structure with computed particle properties
;   Imageheader     I       old header for common info
;   LUN          I   File LUN
;   valid        I     validity flag for particles
;   totROIsSize     I/O   running count of size of write

; Keyword
;   roi          I   if true, write images

; Note: this routine always write a header1 structure, and optionally writes 1 or more header2 strucutres.
;     This is based on the field valid in pObjList[frame], which signal the validity of the particle


header_start_FPOS = (fstat(LUN)).cur_ptr



;print,'start of header',header_start_FPOS
; Output common header fields
;Imageheader.ROIver = 30
Imageheader.ROIver = 31

if(valid)then begin
    for i =0,6 do writeU,LUN,ImageHeader.(i)

    ;PER PAUL LAWSON 4/15/99, Ignore multiple objects

    ;if(roi)then begin
    ; type = size(roiIMG,/type)
    ; case type of
    ; 1:type=1 ; byte array
    ; 2:type=2 ; integer array
    ; 3:type=4 ; long array
    ; endcase
    ; particleInfo[0].PixBytes = type
    ;endif

    ; Output Computed header fields
    ;for i =7,38 do writeU,LUN,particleInfo[0].(i)
    for i =7,63 do writeU,LUN,particleInfo[0].(i)

    ; bytes written so far
    ;length = 121UL
    length = 689UL

    ;print,particleInfo[0].harmonic_len,particleInfo[0].bound_len
    ; write last two variable length arrays
    ;     print,(fstat(lun)).cur_ptr
    if(particleInfo[0].harmonic_len ne 0)then begin
        writeu,LUN,*(particleInfo[0].Harmonics)
        length = length + 4UL*Ulong(particleInfo[0].harmonic_len)  ; add in actual length arrays
    endif
    ;print,(fstat(lun)).cur_ptr
    if(particleInfo[0].bound_len ne 0)then begin
        writeu,LUN,*particleInfo[0].Boundary
        length = length + 4UL*Ulong(particleInfo[0].bound_len) ; add in actual length arrays
    endif
    ;print,(fstat(lun)).cur_ptr
    ;     print, 'radii len= ',particleInfo[0].Radii_len
    if(particleInfo[0].Radii_len ne 0)then begin
        writeu,LUN,*particleInfo[0].Radii
        length = length + 4UL*Ulong(particleInfo[0].Radii_len) ; add in actual length arrays
    endif
    ;print,(fstat(lun)).cur_ptr
    ;if(roi)then begin
    ;write roi images
    ; writeU,LUN,roiIMG
    ;endif

endif else begin
    ;output a blank header
    Imageheader.ROIInfoSize = 16UL
    for i =0,6 do writeU,LUN,ImageHeader.(i)
    ;ImageHeader = {ImageHeader30}
    ;for i =7,38 do writeU,LUN,ImageHeader.(i)
    ;for i =7,60 do writeU,LUN,ImageHeader.(i)
    ;length = 121UL
    length = 16UL
endelse

; update ROIInfoSize field
header_end_FPOS = (fstat(LUN)).cur_ptr
point_LUN,LUN,header_start_FPOS + 2
;   if(length gt 65536)then begin
;     print,'Error, length field overflow'
;     print,length
;     plot,length
;   end
writeU,LUN,length
point_LUN,LUN,header_end_FPOS
;   print,'end of roi header',header_end_FPOS,' length in obj_lib:',length

; update the size variable
totROIsSize = totROIsSize + length

end

pro finish_obj_frame, LUN, fpos1, totROIsSize
    ;Purpose: To complete the output of a frame of information

    ; Parameter
    ;   Lun      I     LUN of file
    ;   fpos1     I   location in file of start of frame being completed
    ;   totROIsSize   I     size of frame just written in bytes


    ; record where file pointer is
    fpos = (fstat(LUN)).cur_ptr

    ; go back and update fields
    point_lun,LUN,fpos1 + 10
    writeU,LUN,totROIsSize
    ;print,'end of block',fpos,  ' totroisize ', totROIsSize

    ; reposition to end of frame
    point_lun,LUN,fpos


end

;=======================================================================================================================


;=======================================================================================================================
; Scan obj file code for locating frames
;=======================================================================================================================

Function scanOBJ,LUN,roiversion_num
    ;Purpose To scan an obj file and return a list of file positions for each frame

    ;Parameters
    ;   lun     INPUT    File lun to read from

    ;   An OBJ file consists of a SPEC fileheader, followed by frames. The frames are version 3 frameheaders and special Imageheaders

    ; return    array list of form {fpos:0L,valid:0B}


    filehead = {SPECHead}
    ; always start at beginning of file
    point_lun,lun,0
    readu,lun,filehead


    print,string(filehead.text)
    fpos = n_tags(filehead,/length)

    frame = 0L
    listLen = 200L
    objscanList = replicate({fpos:0L,valid:0B,time:0.0D},listLen)

    frameheader = {frameheader25}
    offset0 = 104L
    ;objheader = {objectHeader1}
    ;offset1 = 121L
    ;objheader = {objectHeader2}
    ;offset1 = 689L

    while(not eof(lun)) do begin
        ;fpos =long((fstat(lun)).cur_ptr)
        ; record start of frame position
        objscanList[frame].fpos = fpos
        ;print,'Start of block',fpos

        ; Read critical block info
        READU, Lun, frameHeader

        ; need to get calcStrobe time working for 3V-CPI
        ;objscanList[frame].time = float(frameheader.time) + calcStrobeTime(frameheader.arrivalT1,frameheader.arrivalT2,roiversion_num)/1000.0D
        ;objscanList[frame].time = float(frameheader.time)
        objscanList[frame].time = frameheader.hour*3600.0+frameheader.minute*60.0+frameheader.sec*1.0+frameheader.msec/1000.0D

        ;above gets all frame times. frame 1's time, frame 2, 45, 1000, ect.
        ;note that in the obj-file the frameheader.ver is always 31.  added by mo in jnauray 8, 2004.
        ;print,frame,fpos,objscanList[frame].time,format='(i3,x,I10,x,f15.5)'
        ;print,frame,frameHeader.blockNum,frameHeader.ver,frameHeader.roiscount
        ;print,'Start of frame#',frame,' at ',objscanList[frame].fpos,' ROIs:',frameheader.ROIsCount
        fpos = fpos + frameheader.TotROIsSize
        ;print,frame,frameheader.TotROIsSize,frameheader.blocknum
        ;print,frame,' after frameheader ',long((fstat(lun)).cur_ptr),fpos,frameheader.TotROIsSize
        point_lun,lun,fpos

        ;print,'Frm#:',frame,' cnt=',frameheader.ROIsCount,' fpos',objscanList[frame].fpos
        ;     for ROINum = 0,frameheader.ROIsCount-1 do begin

        ;      ; read the fixed length fields first
        ;      readu,lun, objheader

        ;      ;print,'Start of Header1',roiNum,fpos,objheader.area
        ;      fpos = fpos + offset1

        ;      ; base validity on existance of objects
        ;      ;objscanList[frame].valid = (objheader.area ne 0) ? !true : !false
        ;      print,roinum,fpos,objheader.harmonic_len,objheader.bound_len

        ;      ; advance to next frame
        ;      fpos = fpos + objheader.harmonic_len*4 + objheader.bound_len*4 ; note: these len terms might be 0!
        ;      point_lun,lun,fpos

        ;     endfor

        frame = frame + 1
        if(frame ge listLen)then begin
            ; increase size
            temp = objScanList
            listLen = listLen + 100
            objscanList = replicate({fpos:0L,valid:0B,time:0.0D},listLen)
            for k = 0UL,listlen-101 do begin
                objscanList[k].fpos = temp[k].fpos
                objscanList[k].valid = temp[k].valid
                objscanList[k].time = temp[k].time
            endfor
        endif
    endwhile

    ; leave file open for later use

    return,objScanList[0:frame-1]

end

;=======================================================================================================================
; reading of OBJ file code
;=======================================================================================================================

function get_obj_header, FileUnit, fPos

    ; routine to read Object headers
    ; Parameters
    ;   fileunit: Input      open and valid logical file unit to read from
    ;   fPos:     Input       position of header in file

    ;   Return value
    ;     structure of form {FrameHeader:FrameHeader,pFrame:pFrame}
    ;     where
    ;      FrameHeader is a structure containing the frame header information. See above definitions
    ;      pFrame is a pointer to a array of structures containing the particle information.  the form is
    ;      {ImageHeader:ImageHeader}
    ;      where
    ;          ObjHeader


    ; set file pointer to the correct location from the info in scanList for the first frame
    point_lun,FileUnit,fPos

    ;create data structure for roi image

    ; only format support so far!
    ImgDataVer = 25

    CASE ImgDataVer OF
        25:frameheader = {frameheader25}
        else:begin
        r=dialog_message('Unsupported Version... Exiting')
        return,-1
    end
endcase

; read the frame header
readu,FileUnit,FrameHeader

case FrameHeader.Ver of
    30:begin
    header0 = {objectHeader0} ; first 7 fields of object header always present
    header = {objectHeader1}  ; fields 0 - 38
    lastField = 38
    ImageHeader = {ImageHeader31}     ; note  we use imageheader31 even though in this case, there is no data
    blankImageHeader = {ImageHeader31}    ;       for most of the fields.  THis is needed for other places in the code
end
31:begin
header0 = {objectHeader0} ; first 7 fields of object header always present
header = {objectHeader2}  ; fields 0 - 63
lastField = 63
ImageHeader = {ImageHeader31}
blankImageHeader = {ImageHeader31}
end
else:begin
;r = dialog_message('Error in object header, skipping...')
print, 'Error in object header, skipping... in obj_lib.pro '

return,-1
end
endcase

; create output pointer array
pFrame = ptr_new(replicate({imageheader:imageheader},FrameHeader.ROIsCount))

; create array for storing location of file pointer at start of imageheaders
imageHeaderFPOS = lonarr(FrameHeader.ROIsCount)

;Read the ROI headers
for roiNum = 0,FrameHeader.ROIsCount-1 do begin

    imageHeaderFPOS[roiNum] = (fstat(fileUnit)).cur_ptr
    ;print,roinum,imageHeaderFPOS[roiNum]

    ;print,'start of roinum ',roinum, ' fpos=',imageHeaderFPOS[roiNum]
    ; read the beginning of the header
    readu,FileUnit,header0

    if(header0.ROIInfoSize gt 16)then begin
        ; data is present
        ;move file pointer back to start of this image block
        point_lun,FileUnit,imageHeaderFPOS[roiNum]

        ; read the entire header (except variable length fields)
        readu,FileUnit,header

        ; transfer to output structure
        for i=0,lastField do ImageHeader.(i) = header.(i)

        if(header.harmonic_len gt 0)then begin
            harmonics = fltarr(header.harmonic_len)
            readu,FileUnit,harmonics
            imageheader.harmonics = ptr_new(harmonics,/no_copy)
        endif else begin
            harmonics = -1
            imageheader.harmonics = ptr_new()
        endelse

        if(header.bound_len gt 0)then begin
            boundary = lonarr(header.bound_len)
            readu,FileUnit,boundary
            imageheader.boundary = ptr_new(boundary,/no_copy)
        endif else begin
            boundary = -1
            imageheader.boundary = ptr_new()
        endelse

        if(FrameHeader.Ver ge 31)then begin
            if(header.radii_len gt 0)then begin
                radii = fltarr(header.radii_len)
                readu,FileUnit,radii
                imageheader.radii = ptr_new(radii,/no_copy)
            endif else begin
                radii = -1
                imageheader.radii = ptr_new()
            endelse
        endif
    endif else begin

        ; init imageheader variable to all zeros
        imageHeader = blankImageHeader

        ; transfer to output structure
        for i=0,6 do ImageHeader.(i) = header0.(i)

    endelse

    ; correct for the change from water = 0 to water = 1 in extraction process
    ; TAF commenting out for 3V-CPI, no older obj files with this "problem"
    ;if(imageheader.crystal eq 0 and (imageheader.area ne 0 or imageheader.len ne 0))then imageheader.crystal = 1

    ; copy to output Frame pointer
    (*pFrame)[roiNum].imageheader = imageheader
endfor

return,{FrameHeader:FrameHeader,pFrame:pFrame,pImHDfPos:ptr_new(imageHeaderFPOS)}

end

; unused code
; Create a pointer to an array of structures to hold the data for this frame
;pROI_Info = ptr_new(replicate(create_struct(header1,'pObjLink',Ptr_new()),FrameHeader.ROIsCount))

; transfer to output linked list
;pObjLink = ptr_new(create_struct(header2,'harmonics',ptr_new(harmonics),'boundary', ptr_new(boundary),'next',ptr_new()))
;if(objNum ge 1)then (*(*pROI_Info)[roiNum].pObjLink).next = pObjLink else (*pROI_Info)[roiNum].pObjLink = pObjLink

pro update_obj_header,LUN, fPos, field, value
    ;Purpose- to update the .obj file

    ;Parameters
    ;   LUN     Input       Open file LUN
    ;   fpos  Input       position of frame to update
    ;   field Input     Name of field to update
    ;   value Input     Value to add to field

    case field of
        'focus':begin
        fpos = fpos + 90
        value = byte(value)
    end
    'cutoff':begin
    fpos = fpos + 98
    value = byte(value)
end
'crystal':begin
fpos = fpos + 99
value = byte(value)
end
'confidence':begin
fpos = fpos + 100
value = byte(value)
end
'P1':begin
fpos = fpos + 101
value = float(value)
end
endcase

;position to field
point_lun,LUN,fpos
;print,"Writing value at ",fpos, " value = ", value

writeU,LUN,value

end

pro update_obj_header1,LUN, fPos, objHeader
    ;Purpose- to update the .obj file header
    ;stop
    ;Parameters
    ;   LUN      Input   Open file LUN
    ;   fpos   Input   position of frame to update
    ;   objHeader Input   Object header information


    ;position to field
    point_lun,LUN,fpos

    ; write the fields that might have changed
    for i = 0, 38 do writeU, LUN, objHeader.(i)
    objfile = (fstat(LUN)).name
    close, lun
    openu, lun, objfile

    ; write last two variable length arrays
    ;if(particleInfo[0].harmonic_len ne 0)then begin
    ;  writeu,LUN,*(particleInfo[0].Harmonics)
    ;  length = length + 4*particleInfo[0].harmonic_len  ; add in actual length arrays
    ;endif

    ;if(particleInfo[0].bound_len ne 0)then begin
    ;  writeu,LUN,*particleInfo[0].Boundary
    ;  length = length + 4*particleInfo[0].bound_len ; add in actual length arrays
    ;endif

end

pro update_obj_header2,LUN, fPos, objHeader
    ;Purpose- to update the .obj file header

    ;Parameters
    ;   LUN      Input   Open file LUN
    ;   fpos   Input   position of frame to update
    ;   objHeader Input   Object header information


    ;position to field
    point_lun,LUN,fpos

    ; write the fields that might have changed
    for i =0,60 do writeU,LUN,objHeader.(i)

    ; write last two variable length arrays
    ;if(particleInfo[0].harmonic_len ne 0)then begin
    ;  writeu,LUN,*(particleInfo[0].Harmonics)
    ;  length = length + 4*particleInfo[0].harmonic_len  ; add in actual length arrays
    ;endif

    ;if(particleInfo[0].bound_len ne 0)then begin
    ;  writeu,LUN,*particleInfo[0].Boundary
    ;  length = length + 4*particleInfo[0].bound_len ; add in actual length arrays
    ;endif

end


pro delete_obj_header, objData
    ;Purpose- to free pointer memory
    if N_tags(objdata) eq 0 then return ;  Mo added 2014-02-18.

    ptr_free,objData.pFrame
end

pro Load_Object_file,pStateInfo, get_filename = get_filename
;Purpose to read an object file based on the name of the input file and generate a scanlist

;Keyword
;   get_filename  I   Flag to determine if user selects file, or it is based on  the ROI file name

if(keyword_set(get_filename))then begin
    (*pStateInfo).objFile = dialog_pickfile(filter='*.obj', title='Select an Object file to import')
    if((*pStateInfo).objFile eq '')then return
endif else begin
    ; create filename base on input file
    dotloc = rstrpos((*pStateInfo).InFileName,'.')
    (*pStateInfo).ObjFile = strmid((*pStateInfo).InFileName,0,dotloc[0]) + '.obj'
endelse

; open file and test for error
OpenU,ObjLUN,(*pStateInfo).ObjFile,/get, ERROR = err
if(err ne 0)then begin
    ;r = dialog_message('No object file found... Search for a different name?',/question)
    ;if(r eq 'Yes')then begin
    ; (*pStateInfo).ObjFile = dialog_pickfile(filter='*.obj')
    ; if((*pStateInfo).ObjFile ne '')then begin
    ;     OpenU,ObjLUN,(*pStateInfo).ObjFile,/get, ERROR = err
    ;     (*pStateInfo).ObjLUN = ObjLUN
    ;     ; clear ptr
    ;     if(ptr_valid((*pStateInfo).pOBJList))then PTR_FREE, (*pStateInfo).pOBJList
    ;     ; scan file. Note if this is valid, other code will use it
    ;     (*pStateInfo).pOBJList=ptr_new(scanOBJ(ObjLUN))
    ; endif else r = dialog_message('Use the Extract Feature to generate object information')
    ;endif else r = dialog_message('Use the Extract Feature to generate object information')
    (*pStateInfo).ObjFile = ''
endif else begin
    ; ok to scan file
    (*pStateInfo).ObjLUN = ObjLUN
    ;stop;     added by mo   (*pstateinfo).infilename=12121808.roi

    roiversion_num=(*pStateInfo).roi_frameheader_version
    ;when there is an obj file, it comes to here first, before gui_lib.

    if roiversion_num eq 31 then roiversion_num=40;   ;this is added on July 18 2005 to
    ;fix Rico Roi-files strange behavor. it the first
    ; frameheder.ver is assigned 31 and then later it is assigned 40.  Qixu Mo

    ; clear ptr
    if(ptr_valid((*pStateInfo).pOBJList))then PTR_FREE, (*pStateInfo).pOBJList
    ; scan file. If this is valid, other code will use it
    (*pStateInfo).pOBJList=ptr_new(scanOBJ(ObjLUN,roiversion_num))
endelse

end
