;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output Bit 2; set = display image Bit 4, set = display sizes
FUNCTION PrintROIs, pStateInfo, accepted, frameData, OutPutFlags=OutPutFlags, objData=objData, confidence = confidence, criteria = criteria,time=time, sizeType=sizeType
(*pStateInfo).waittime = 0.02

print_time=((OutPutFlags AND 256)/256)   ; default=0 added by mo at Dec 3, 2003

; Default is to send ouput to printer
if N_ELEMENTS(OutPutFlags) EQ 0 then OutPutFlags = 1
if OutPutFlags EQ 0 then OutPutFlags = 1
;loadct,1,/silent

pFrame = frameData.pFrame
;stop
set_min_max, pStateInfo  ; add this on march 21 to keep the color as in qui_lib.pro display image.

; How many ROIs?
if n_tags(objdata) eq 0 then return,1 ;  add this on 2014-02-18.

if(keyword_set(objData))then begin
    if(ptr_valid(objData.pFrame)) then begin
        ListLen = n_elements(*objData.pFrame)
    endif else begin
        print, 'ptr_valid(objData.pFrame) returns: ', ptr_valid(objData.pFrame)

        ;stop

        return, 1
    endelse
endif else begin
    ListLen = n_elements(*pFrame)
endelse

OutPut2 = OBJ_NEW()
Palette = OBJ_NEW()

; Prepare fonts
if not obj_valid((*pStateInfo).PrintROI.Font1) then (*pStateInfo).PrintROI.Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=12)

; Get Page dimensions, if not already done
if((*pStateInfo).PrintROI.PageDX LT 100 OR (*pStateInfo).PrintROI.PageDY LT 100)then begin; at begining a new page, pageDy=pageDX=-1
    ; then pageDX is always 792, pageDy=1024 pixles. that is the szie of the png page.
    ; Get sizing from the printer info    ; it only comes into this block for one time. just to set up the png pages.
    if(not obj_valid(OutPut))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255 ; change this to from 255 to 0 on march 17 2005
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
        OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
        OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res  ; I may change this to set instead of get.
    endif

    dims=[792,1024];      added by mo at March 21, 2005
    res= [0.025,0.025]
    (*pStateInfo).PrintROI.PageDX = Dims[0]
    (*pStateInfo).PrintROI.PageDY = Dims[1]

    ; Create new view
    if(not obj_valid((*pStateInfo).PrintROI.View))then begin
        create_a_new_IDLgrview, pstateinfo, outputflags
    endif; new view created.

    ;set text dims in pixels
    TextDims = ([265, 33]*(0.00704861/Res[0]))*1.7    ; added by JS to enlarge font

    (*pStateInfo).PrintROI.LeftMargin = [TextDims[0], TextDims[1]]

    ; Want 40 pixs = 1 cm
    (*pStateInfo).PrintROI.PageZoom = 1/(Res[0]*40)

endif; end of geting page information or generating an new page.

;change zoom to integer on March 17, 2005.
zoom =1; (*pStateInfo).PrintROI.PageZoom*1.0;      (*pStateInfo).zoom  for png zoom=1.0
LeftMargin = ((*pStateInfo).PrintROI.LeftMargin)[0]*1.05*0.36;  added 0.36 by mo here =47.68
; Get scaling
WIDGET_CONTROL, (*pStateInfo).ScaleMinID, GET_VALUE=ScaleMin
WIDGET_CONTROL, (*pStateInfo).ScaleMaxID, GET_VALUE=ScaleMax

maxdy = (*pStateInfo).PrintROI.MaxDY   ; maxdy is current line of rois max-height. every line of images has its own maxdy.
DateGap = 1.8 * ((*pStateInfo).PrintROI.LeftMargin)[1]
(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY > DateGap
Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]


if(keyword_set(time))then begin  ; time is from frameheader.time;    frameData = read_frame(); time=framedate.header.day; **.hour, **.minute,*.sec

    month =((*pStateInfo).date.month);  added this on Dec. 6, 2011.

    day    = time.day
    hour   = time.hour
    minute = time.minute
    second = time.sec
    msec   = time.msec


    ; for debugging grayscale in 20140821233145.roi
    ;        if(hour eq 23 and minute eq 31 and second eq 46 and msec eq 495) then begin
    ;            !stop_from_here_on = 1
    ;        endif

    ;        if(!stop_from_here_on eq 1) then begin
    ;            stop
    ;        endif


    ; mo modified this on April 25  to added change Time  to the png pages to sync with 2DS images and other images.
    if !DT_CPI eq (-99999L) then begin
        ; TAF need a better method than this popup to prevent execution halt

        if(!disable_time_popups eq 1) then begin
            !Time_synced = 1
        endif else begin
            !Time_synced=(moqixu_input_single_number_pop_up(title='If Time is synced enter 1 else 0: ',label='Time synced:',value='0'))*1L

            !DT_CPI=(moqixu_input_single_number_pop_up(title='For relabeling CPI png page image only',label='CPI_Time_offset:',value='0'))*1L
        endelse
    endif
    total_seconds =day*24LL*3600LL +hour*3600LL+minute*60LL+second + !DT_CPI
    day=total_seconds/(86400LL);    (24*3600LL=86400LL); with this , day can become 32 or 29 for February.
    hour= (total_seconds mod 86400LL)/3600LL
    minute=(total_seconds mod 3600LL)/60LL
    second =(total_seconds mod 60LL)
    ;***********************************************************************************************

    if (month lt 10)then begin
        monthstring = string('0'+strtrim(month,2))
    endif else monthstring = strtrim(month,2)

    if (day lt 10)then begin
        daystring = string('0'+strtrim(day,2))
    endif else daystring = strtrim(day,2)

    if (hour lt 10) then begin
        hourstring = string('0'+strtrim(hour,2))
    endif else hourstring = strtrim(hour,2)

    if (minute lt 10) then begin
        minstring = string('0'+strtrim(minute,2))
    endif else minstring = strtrim(minute,2)

    if (second lt 10) then begin
        secstring = string('0'+strtrim(second,2))
    endif else secstring = strtrim(second,2)

    if msec lt 10                 then  msecstring = string('00'+strtrim(msec,2))
    if msec ge 10 and msec lt 100 then  msecstring = string( '0'+strtrim(msec,2))
    if msec ge 100                then  msecstring = string(     strtrim(msec,2))

    (*pStateInfo).printROI.timeline =monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring
    ;above is just to calucate the Timeline string for filename use.
endif;  end of in keyword_set (time)

if(ListLen GT 0 AND (*pStateInfo).PrintROI.PageY LE DateGap)then begin

    ; New Page? If so, we need a new view and model
    if not obj_valid((*pStateInfo).PrintROI.View) then begin
        create_a_new_IDLgrview, pstateinfo, outputflags
    endif

    if (*pStateInfo).PrintRoi.pageY le dateGap and (*pStateInfo).printRoi.pageX le leftmargin then begin
        ;print out the begining line of the png page.
        print_png_page_header_lines, pstateinfo, outputFlags, hourstring,minstring,secstring,leftmargin,dateGap,Month,day,offset,criteria
        ;now add the image scale  with 200um 50um 25um images.
        make_cpi_size_scale, image=imgsc
        dxdy=size(imgsc,/dimension)
        dxMs=dxdy(0)
        dyMs=dxdy(1)
        DispSizeMs = [dxMs,dyMs]

        imagesc = OBJ_NEW('IDLgrImage', imgsc, /NO_COPY, DIMENSIONS=DispSizeMs, LOCATION=[(*pStateInfo).PrintROI.PageDx-dxMs,$
            (*pStateInfo).PrintROI.PageDY-0.75*dateGap,0], ORDER=1);,interpolate=1);  place it higher.
        (*pStateInfo).PrintROI.Model->Add, imagesc

        Text200 = OBJ_NEW('IDLgrText', '200um', LOCATION=[(*pStateInfo).PrintROI.PageDx-0.75*dxMs+2, $
            (*pStateInfo).PrintROI.PageDY -0.75*DateGap-2], COLOR=[0,0,0],FONT=(*pStateInfo).PrintROI.Font1)
        (*pStateInfo).PrintROI.Model->Add, Text200;   ;that mean if it is starting of a page, add the text to the top line.
    endif; end of if there is roi and pageY position is less than dataGap. that is new view and nmodel are generated.

endif; end of if (ListLen GT 0 AND

PrintCount = 0

for i=0, ListLen-1 DO begin;   if one frame has more particle, need to fix to make new start flushed with left margin.

    if(accepted[i])then begin

        ImgSize = size(*(*pFrame)[i].pROI)
        dx = zoom*(*pStateInfo).Settings.YXAspect*ImgSize[1] ;here YXaspect=1.00, zoom=2.95275
        dy = zoom*ImgSize[2]                                 ; it is very odd.--mo_March 17,2005.
        DispSize = [dx,dy]

        ; Reached right margin?
        if(Offset[0] NE LeftMargin AND Offset[0] + dx GT (*pStateInfo).PrintROI.PageDX)then begin
            ;start a new line of images.
            Offset[0]=leftMargin; else offset[0] = LeftMargin  ;above line changed by mo to take off the space_for_time
            ;above is that if there are many images of the same time. other images will be put to leftest.
            Offset[1] =  Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400 + print_time*22; added +65 by mo
            (*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy + 2 +print_time*22; added +65 by mo
            maxdy = dy
        endif else maxdy = maxdy > dy

        ; Is there enough  vertical  space left in the page?
        if((*pStateInfo).PrintROI.PageY GT DateGap AND (*pStateInfo).PrintROI.PageY + dy + 22 GT (*pStateInfo).PrintROI.PageDY)then begin
            ;added above 20 for time label.
            show_to_screen_and_save_png_page_to_file, pStateInfo,outputflags,output2,output3,Palette,output

            ; Start new page And create a new one
            create_a_new_IDLgrview, pstateinfo, outputflags

            ; Need a little room at the bottom for the date
            (*pStateInfo).PrintROI.PageY = DateGap
            (*pStateInfo).PrintROI.PageX = LeftMargin
            Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

            ;print out the png page header-lines.
            print_png_page_header_lines, pstateinfo, outputFlags, hourstring,minstring,secstring,leftmargin,dateGap,Month,day,offset,criteria


            ;now add the image scale  with 200um 50um 25um images.
            make_cpi_size_scale, image=imgsc
            dxdy=size(imgsc,/dimension)
            dxMs=dxdy(0)
            dyMs=dxdy(1)
            DispSizeMs = [dxMs,dyMs]

            imagesc = OBJ_NEW('IDLgrImage', imgsc, /NO_COPY, DIMENSIONS=DispSizeMs, LOCATION=[(*pStateInfo).PrintROI.PageDx-dxMs,$
                (*pStateInfo).PrintROI.PageDY-0.75*dateGap,0], ORDER=1);,interpolate=1);  place it higher.
            (*pStateInfo).PrintROI.Model->Add, imagesc

            Text200 = OBJ_NEW('IDLgrText', '200um', LOCATION=[(*pStateInfo).PrintROI.PageDx-0.75*dxMs+2, $
                (*pStateInfo).PrintROI.PageDY -0.75*DateGap-2], COLOR=[0,0,0],FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model->Add, Text200;   ;that mean if it is starting of a page, add the text to the top line.

            if obj_valid(output3) then obj_destroy,output3

        endif ; end enough vertical  space left ???

        day = ((*pStateInfo).date.day) ; This day maybe different from day calculated earlier in the above. ??????

        oldhour = (*pStateInfo).printROI.oldhour

        if (hour lt oldhour) then begin
            (*pStateInfo).printROI.dayflag = (*pStateInfo).printROI.dayflag+1
        endif

        (*pStateInfo).printROI.oldhour = hour
        oldhour = hour
        day = day + (*pStateInfo).printROI.dayflag
        if (day lt 10)then begin
            daystring = string('0'+strtrim(day,2))
        endif else daystring = strtrim(day,2)

        ;the following line makes the filename a function of time rather than roiname.  The filename is :MMDD-HHMMSS_msec
        if ((*pStateInfo).printROI.pageno gt (*pStateInfo).printROI.oldpageno)then begin
            (*pStateInfo).printROI.timeline = monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring
        endif

        (*pStateInfo).printROI.oldpageno = (*pStateInfo).printROI.pageno
        ; To print times, make times = 1.  To not print times, anything but 1

        if(print_time eq 1) then begin

            if(PrintCount EQ 0 OR Offset[0] EQ LeftMargin)then begin
                ;;modified by mo on oct 29th 2003
                ;NewString = STRING(FORM='(I2,":",I2,":",I2,":",I3)', hour, minute, Second, msec); this goes between the ''
                NewString  = hourstring+':'+minstring;     STRING(FORM='(I2,":",I2,":")', hour, minute); this goes between the ''
                NewString2 =  secstring+'.'+msecstring;     STRING(FORM='(I2,":",I3)', Second, msec);  added by mo for ss.mmm time line

                (*pStateInfo).PrintROI.TimeText->GetProperty, STRINGS=Strings, LOCATIONS=TxtPos
                (*pStateInfo).PrintROI.TimeText2->GetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2

                if Offset[0] LE LeftMargin then Offset[0] = leftMargin
                ;print, (*pStateInfo).printroi.timeline
                if Strings[0] NE -1 then begin
                    TxtPos = [[TxtPos], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]]  ;added -0 by mo
                    Strings = [Strings, NewString]
                    (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=Strings, LOCATIONS=TxtPos,recompute_dimensions=0
                endif else (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=NewString,recompute_dimensions=0,$
                    LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]   ;added -0 by mo
                ;added another time line strings
                if Strings2[0] NE -1 then begin
                    TxtPos2 = [[TxtPos2], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-10]]          ;added by mo
                    Strings2 = [Strings2, NewString2]
                    (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2,recompute_dimensions=0
                endif else (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=NewString2,recompute_dimensions=0,$
                    LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-10]

            endif   ;end of if offset[0] LE leftMarcgin
        endif   ; end of i PrintCount=0 or offset=LeftMargin


        if(ptr_valid((*pStateInfo).BackFrame))then begin
            pBackImg = (*(*pStateInfo).BackFrame).pBackImg
            backROI = (*pBackImg)[(*pFrame)[i].ImageHeader.sx:(*pFrame)[i].ImageHeader.ex,(*pFrame)[i].ImageHeader.sy:(*pFrame)[i].ImageHeader.ey]
            ; save this back into the data array
            temp = *(*pFrame)[i].pROI - fix(backROI)
            ; dimg = BYTSCL(temp, top=253) + 1B ;MIN=ScaleMin, MAX=ScaleMax,
            dimg = congrid(BYTSCL(temp,top=255),dispsize(0),dispsize(1),/interp) ; change above to this on March 17, 2005
        endif else dimg = congrid(BYTSCL(*(*pFrame)[i].pROI,top=255),dispsize(0),dispsize(1),/interp)
        ;stop;  here temp is array[56,61]

        ;if(keyword_set(objdata))then if((*objData.pFrame)[i].imageheader.confidence eq 0)then dimg[*,*] = 0

        image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[Offset[0],$
            (*pStateInfo).PrintROI.PageDY -Offset[1] - dy,0], ORDER=1);,interpolate=1)

        (*pStateInfo).PrintROI.Model->Add, image

        if((OutPutFlags And 8)/8)then begin
            ;add size line
            (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=size_string, LOCATIONS=imgloc
            case sizeType of
                'mean':begin
                if(keyword_set(objdata))then begin
                    mean_size = 2.0* sqrt((*objData.pFrame)[i].imageheader.area/!dpi) * (*pStateInfo).Settings.PixSize
                endif else begin
                    mean_size = round(sqrt((*pFrame)[i].imageHeader.Wid * (*pFrame)[i].imageHeader.Len)* (*pStateInfo).Settings.PixSize )
                endelse

            end
            'max':begin
            if(keyword_set(objdata))then begin
                mean_size = max([(*objData.pFrame)[i].imageheader.len,(*objData.pFrame)[i].imageheader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
            endif else begin
                mean_size = max([(*pFrame)[i].imageHeader.Len,(*pFrame)[i].imageHeader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
            endelse
        end
    endcase

    if(size_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        size_string = [size_string,strtrim(round(mean_size),2)]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=size_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(mean_size),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 8

if((OutPutFlags And 16)/16)then begin
    ; add focus line
    if(keyword_set(objdata))then begin
        focusStr =strtrim(fix((*objdata.pFrame)[i].imageHeader.focus),2)
    endif else begin
        ;  out of focus is in imageheader.flags (bits 0-7 of flags)
        focusStr = strtrim((*pFrame)[i].imageHeader.Flags AND '00FF'X,2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    if(focus_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        focus_string = [focus_string,focusStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focusStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;edn of if 16

if((OutPutFlags And 32)/32)then begin
    ; add cutoff line
    if(keyword_set(objdata))then begin
        cutoffStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.cutoff),2)
    endif else begin
        ; cutoff is in imageheader.dark ( bits 8 - 12)
        cutoffStr = strtrim(fix(100 * (ISHFT((*pFrame)[i].imageHeader.Dark,-8) AND '1F'X)/31.0),2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    if(cutoff_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        cutoff_string = [cutoff_string,cutoffStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoffStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif ;end of if 32
if((OutPutFlags And 64)/64)then begin
    ; add roundness line
    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=round_string, LOCATIONS=imgloc
    if(round_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        round_string = [round_string,strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2)]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=round_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 64

if((OutPutFlags And 128)/128)then begin
    ;stop; : TAF 2013-09-07 commented out extra stop line that shouldn't be here
    ; add cyrstal type line
    if(keyword_set(objdata))then begin
        ; next line write number for crystal habit
        ;habitStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.crystal),2)
        ; this line writes cytsal habit name
        habitStr = (*pStateInfo).crystalName[(*objdata.pFrame)[i].imageHeader.crystal]
    endif else begin
        ; crystal is in imageheader.flags (bits 8 - 12)
        ; next line write number for crystal habit
        ;habitStr = strtrim( (ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X),2)
        ; this line writes cytsal habit name
        habitStr =   (*pStateInfo).crystalName[(ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X)]
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=type_string, LOCATIONS=imgloc
    if(size(type_string, /TYPE) EQ 7)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        type_string = [type_string,habitStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=type_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=habitStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 128

;mo changed teh following two lines.   make enought space for writing the time label.
if dx gt leftmargin then Offset[0] = Offset[0] + dx + (*pStateInfo).PrintROI.PageDX/400
if dx lt leftmargin then Offset[0] = Offset[0] + leftmargin + (*pStateInfo).PrintROI.PageDX/400

PrintCount = PrintCount + 1
endif

ENDFOR ; bottom of loop for i= 0, listLen-1  for roi's

(*pStateInfo).PrintROI.PageX = Offset[0]


; Start a new line, if necessary
if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT LeftMargin)then begin  ;changed to 0.2 by mo

    (*pStateInfo).PrintROI.PageX = LeftMargin
    (*pStateInfo).PrintROI.PageY = Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400+print_time*22; add +65 by mo

endif

; Start new page when needed
; Is there enough space left in the page?
if((*pStateInfo).PrintROI.PageY +22 GT 0.95*(*pStateInfo).PrintROI.PageDY)then begin
    ;added above 76 for time label

    show_to_screen_and_save_png_page_to_file, pStateInfo, outputflags,output2,output3,Palette,output

    ; Start new page
    (*pStateInfo).PrintROI.View  = OBJ_NEW()
    (*pStateInfo).PrintROI.Model = OBJ_NEW()

    (*pStateInfo).PrintROI.PageX = LeftMargin
    (*pStateInfo).PrintROI.PageY = DateGap

endif; end of start new page.



; Remember maxdy if we didn't start a new line
if((*pStateInfo).PrintROI.PageX GT LeftMargin)then (*pStateInfo).PrintROI.MaxDY = maxdy else (*pStateInfo).PrintROI.MaxDY = 0

; Clean up objects
if(obj_valid(OutPut) )then OBJ_DESTROY, OutPut
if(obj_valid(OutPut2))then OBJ_DESTROY, OutPut2
if(obj_valid(Palette))then OBJ_DESTROY, Palette
if(obj_valid(output3))then obj_destroy,output3
;if(obj_valid(text))then obj_destroy,text
;if(obj_valid(type))then obj_destroy,type

RETURN, 0
end;   End of PRintROis  Function.
;****************************************************************************

pro print_png_page_header_lines, pstateinfo, outputFlags, hourstring,minstring,secstring,leftmargin,dateGap,Month,day,offset,criteria

    case 1 of
        (OutPutFlags And 8 )/ 8:begin
        if(sizeType eq 'max')then msg='Max Size,'
        if(sizeType eq 'mean')then msg='Mean Size,'
    end
    (OutPutFlags And 16)/16:  msg='Focus,'
    (OutPutFlags And 32)/32:  msg='CutOff,'
    (OutPutFlags And 64)/64:  msg='Roundness1,'
    (OutPutFlags And 128)/128:msg='';  dec7th,2011. comment out the string: 'Crystal'; no need for this.  sph, ice are obvious.
    else:                     msg = ''
endcase

if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
if(not keyword_set(criteria))then criteria = 'No criteria applied';criteria_test
; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
scale =''; '<----------->'+'200um'

hhmmss_string=hourstring+minstring+secstring
Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
    (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
    LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
    FONT=(*pStateInfo).PrintROI.Font1)

(*pStateInfo).PrintROI.Model->Add, Text;   ;that mean if it is starting of a page, add the text to the top line.
(*pStateInfo).PrintRoi.pageY=dateGap+1;    ; otherwise, not text is added to the top line.

if !disable_time_popups eq 0 then begin

    if !time_synced eq 1 then begin
        Time_offset_str='Version: '+!SPEC_VERSION+'  Time has been synced.   '+strtrim(string(!DT_CPI),2)+' seconds are added to CPI"s  original Time'
    endif else begin
        Time_offset_str='Version: '+!SPEC_VERSION+' Time is not synced.   Time is CPI"s  original Time'
    endelse

endif else begin
    Time_offset_str='Version: '+!SPEC_VERSION+' Time is CPI"s  original Time'
endelse


Text_sync = OBJ_NEW('IDLgrText', Time_offset_str, $
    LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap-18], COLOR=[0,0,0],$   ;added this on May 16, 2012
    FONT=(*pStateInfo).PrintROI.Font1)

(*pStateInfo).PrintROI.Model->Add, Text_sync;   ;that mean if it is starting of a page, add the text to the top line.
(*pStateInfo).PrintRoi.pageY=0.75*DateGap+20;  added this on May 16, 2012.
(*pStateInfo).PrintRoi.pageX=leftmargin
Offset[1] = 40; Offset[1] +0.75*DateGap+18; offset[1] changes from 0 from top of page to larger number at bottom.
; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.

end; print_png_page_header_lines, pstateinfo, outputFlags, hourstring,minstring,secsting,leftmargin,dateGap,Month,day,offset

pro  create_a_new_IDLgrview, pstateinfo, outputflags

    (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
    (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
    (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
    (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
    ;timetext2 added by mo on oct 29/2003

    (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
    (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2 ;added by mo
    (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model


    if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
        (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
        (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
    endif
end;   create_a_new_IDLgrview, pstateinfo, outflags


pro  show_to_screen_and_save_png_page_to_file, pStateInfo, outputflags,output2,output3,Palette,output

    if(not obj_valid(Palette))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    endif

    ;if requested, add the size model
    if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
        (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
    endif
    ;waittime = 2

    ; show the image if requested
    if((OutPutFlags AND 4)/4)then begin
        Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
        OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
        OutPut3->Draw, (*pStateInfo).PrintROI.View
        wait,(*pStateInfo).waittime
    endif

    ; Image to file?
    if((OutPutFlags AND 2)/2)then begin
        Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
        OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)

        OutPut2->Draw, (*pStateInfo).PrintROI.View
        (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
        page_percent=1.0;FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
        ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
        SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;added above 76 to proevent time label being chop off.
    endif

    ; Destroy current view
    OBJ_DESTROY, (*pStateInfo).PrintROI.View
end; show_to_screen_and_save_png_page_to_file

;**********************************************************************************************************



FUNCTION PrintROIs_notimelabel, pStateInfo, accepted, frameData, OutPutFlags=OutPutFlags, objData=objData, confidence = confidence, criteria = criteria,time=time, sizeType=sizeType
(*pStateInfo).waittime = 0.02

print_time=((OutPutFlags AND 256)/256)   ; default=0 added by mo at Dec 3, 2003

; Default is to send ouput to printer
if N_ELEMENTS(OutPutFlags) EQ 0 then OutPutFlags = 1
if OutPutFlags EQ 0 then OutPutFlags = 1
;loadct,1,/silent

pFrame = frameData.pFrame
;stop
set_min_max, pStateInfo  ; add this on march 21 to keep the color as in qui_lib.pro display image.

; How many ROIs?
if(keyword_set(objData))then ListLen = n_elements(*objData.pFrame) else ListLen = n_elements(*pFrame)

Palette=obj_new()

; Prepare fonts
if not obj_valid((*pStateInfo).PrintROI.Font1) then (*pStateInfo).PrintROI.Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', size=11)

; Get Page dimensions, if not already done
if((*pStateInfo).PrintROI.PageDX LT 100 OR (*pStateInfo).PrintROI.PageDY LT 100)then begin

    ; Get sizing from the printer info
    if(not obj_valid(Palette))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255 ; change this to from 255 to 0 on march 17 2005
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
        OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)

        OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res  ; I may change this to set instead of get.
        dims=[792,1024];      added by mo at March 21, 2005
        res= [0.025,0.025]

        (*pStateInfo).PrintROI.PageDX = Dims[0]
        (*pStateInfo).PrintROI.PageDY = Dims[1]

    endif

    ; Create new view
    if(not obj_valid((*pStateInfo).PrintROI.View))then begin

        ; create a view
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ;timetext2 added by mo on oct 29/2003
        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
        endif

        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2 ;added by mo
        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model

    endif

    ;set text dims in pixels
    TextDims = ([265, 33]*(0.00704861/Res[0]))*1.7    ; added by JS to enlarge font

    (*pStateInfo).PrintROI.LeftMargin = [TextDims[0], TextDims[1]]

    ; Want 40 pixs = 1 cm
    (*pStateInfo).PrintROI.PageZoom = 1/(Res[0]*40)

endif
;change zoom to integer on March 17, 2005.
zoom =1; (*pStateInfo).PrintROI.PageZoom*1.0;      (*pStateInfo).zoom  for png zoom=1.0
LeftMargin = ((*pStateInfo).PrintROI.LeftMargin)[0]*1.05*0.36;  added 0.36 by mo here =47.68
; Get scaling
WIDGET_CONTROL, (*pStateInfo).ScaleMinID, GET_VALUE=ScaleMin
WIDGET_CONTROL, (*pStateInfo).ScaleMaxID, GET_VALUE=ScaleMax

maxdy = (*pStateInfo).PrintROI.MaxDY
DateGap = 1.8 * ((*pStateInfo).PrintROI.LeftMargin)[1]
(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY > DateGap
Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

if(keyword_set(time))then begin
    month =((*pStateInfo).date.month);  added this on Dec. 6, 2011.

    day = time.day
    hour = time.hour
    minute = time.minute
    second = time.sec
    msec = time.msec

    ; mo modified this on April 25  to added change Time  to the png pages to sync with 2DS images and other images.
    if !DT_CPI eq (-99999L) then begin
        ; TAF need a better method than this popup to prevent execution halt
        !Time_synced=(moqixu_input_single_number_pop_up(title='If Time is synced enter 1 else 0: ',label='Time synced:',value='0'))*1L

        !DT_CPI=(moqixu_input_single_number_pop_up(title='For relabeling CPI png page image only',label='CPI_Time_offset:',value='0'))*1L
    endif
    total_seconds =day*24LL*3600LL +hour*3600LL+minute*60LL+second + !DT_CPI
    day=total_seconds/(86400LL);    (24*3600LL=86400LL)
    hour= (total_seconds mod 86400LL)/3600LL
    minute=(total_seconds mod 3600LL)/60LL
    second =(total_seconds mod 60LL)
    ;***********************************************************************************************

    if (month lt 10)then begin
        monthstring = string('0'+strtrim(month,2))
    endif else monthstring = strtrim(month,2)

    if (day lt 10)then begin
        daystring = string('0'+strtrim(day,2))
    endif else daystring = strtrim(day,2)

    if (hour lt 10) then begin
        hourstring = string('0'+strtrim(hour,2))
    endif else hourstring = strtrim(hour,2)

    if (minute lt 10) then begin
        minstring = string('0'+strtrim(minute,2))
    endif else minstring = strtrim(minute,2)

    if (second lt 10) then begin
        secstring = string('0'+strtrim(second,2))
    endif else secstring = strtrim(second,2)

    if msec lt 10                 then  msecstring = string('00'+strtrim(msec,2))
    if msec ge 10 and msec lt 100 then  msecstring = string( '0'+strtrim(msec,2))
    if msec ge 100                then  msecstring = string(     strtrim(msec,2))

    ;(*pStateInfo).printROI.timeline = monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring
    (*pStateInfo).printROI.timeline = monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+strtrim(msec,2)
endif

if(ListLen GT 0 AND (*pStateInfo).PrintROI.PageY LE DateGap)then begin

    ; New Page? If so, we need a new view and model
    if not obj_valid((*pStateInfo).PrintROI.View) then begin
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ;Timetext2 added by moqixu

        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2; added by moqixu
        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
        endif
    endif

    ; Print-out date per page
    case 1 of
        (OutPutFlags And 8 )/ 8:begin
        if(sizeType eq 'max')then msg='Max Size,'
        if(sizeType eq 'mean')then msg='Mean Size,'
    end
    (OutPutFlags And 16)/16:  msg='Focus,'
    (OutPutFlags And 32)/32:  msg='CutOff,'
    (OutPutFlags And 64)/64:  msg='Roundness1,'
    (OutPutFlags And 128)/128:msg='';  dec7th,2011. comment out the string: 'Crystal'; no need for this.  sph, ice are obvious.
    else:                     msg = ''
endcase

if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
if(not keyword_set(criteria))then criteria = 'No criteria applied';criteria_test
; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
scale =''; '<----------->'+'200um'

hhmmss_string=hourstring+minstring+secstring
Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
    (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
    LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
    FONT=(*pStateInfo).PrintROI.Font1)

if (*pStateInfo).PrintRoi.pageY le dateGap and (*pStateInfo).printRoi.pageX le leftmargin then begin
    (*pStateInfo).PrintROI.Model->Add, Text;   ;that mean if it is starting of a page, add the text to the top line.
    (*pStateInfo).PrintRoi.pageY=dateGap+1;    ; otherwise, not text is added to the top line.
    if !time_synced eq 1 then begin
        Time_offset_str='Version: '+!SPEC_VERSION+' Time has been synced.   '+strtrim(string(!DT_CPI),2)+' seconds are added to CPI"s  original Time'
        Text_sync = OBJ_NEW('IDLgrText', Time_offset_str, $
            LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap-18], COLOR=[0,0,0],$   ;added this on May 16, 2012
            FONT=(*pStateInfo).PrintROI.Font1)
        (*pStateInfo).PrintROI.Model->Add, Text_sync;   ;that mean if it is starting of a page, add the text to the top line.
        (*pStateInfo).PrintRoi.pageY=0.75*DateGap+20;  added this on May 16, 2012.
        Offset[1] = 40; Offset[1] +0.75*DateGap+18; offset[1] changes from 0 from top of page to larger number at bottom.
    endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.
    if !time_synced eq 0 then begin
        Time_offset_str='Version: '+!SPEC_VERSION+' Time is not synced.   Time is CPI"s  original Time'
        Text_sync = OBJ_NEW('IDLgrText', Time_offset_str, $
            LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap-18], COLOR=[0,0,0],$   ;added this on May 16, 2012
            FONT=(*pStateInfo).PrintROI.Font1)
        (*pStateInfo).PrintROI.Model->Add, Text_sync;   ;that mean if it is starting of a page, add the text to the top line.
        (*pStateInfo).PrintRoi.pageY=0.75*DateGap+20;  added this on May 16, 2012.
        Offset[1] = 40; Offset[1] +0.75*DateGap+18; offset[1] changes from 0 from top of page to larger number at bottom.
    endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.
endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.

endif


PrintCount = 0

for i=0, ListLen-1 DO begin;   if one frame has more particle, need to fix to make new start flushed with left margin.

    if(accepted[i])then begin

        ImgSize = size(*(*pFrame)[i].pROI)
        dx = zoom*(*pStateInfo).Settings.YXAspect*ImgSize[1] ;here YXaspect=1.00, zoom=2.95275
        dy = zoom*ImgSize[2]                                 ; it is very odd.--mo_March 17,2005.
        DispSize = [dx,dy]

        ; Reached right margin?
        if(Offset[0] NE LeftMargin AND Offset[0] + dx GT (*pStateInfo).PrintROI.PageDX)then begin
            ;start a new line of images.
            ;   if i ge 1 then Offset[0]=0;   ; comment following out on dec. 5th 2011; leftMargin else offset[0] = LeftMargin  ;above line changed by mo to take off the space_for_time
            ;above is that if there are many images of the same time. other images will be put to leftest.
            Offset[0]=leftMargin
            ;Offset[1] =  Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400 + print_time*22; added +65 by mo
            ;(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy + 2 +print_time*22; added +65 by mo

            Offset[1] =  Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400
            (*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy

            maxdy = dy
        endif else maxdy = maxdy > dy

        ; Is there enough  vertical  space left in the page?
        if((*pStateInfo).PrintROI.PageY GT DateGap AND (*pStateInfo).PrintROI.PageY + dy + 22 GT (*pStateInfo).PrintROI.PageDY)then begin
            ;added above 20 for time label.
            ; Start new page
            ;Offset[0]=0;  start from the very leftest  place. which is assigned alter.
            if(not obj_valid(Palette))then begin
                ; Get current color table
                TVLCT, r, g, b, /GET
                r[0] = 0;255
                g[0] = 0;255
                b[0] = 0
                Palette = OBJ_NEW('IDLgrPalette', r, g, b)
            endif

            ;if requested, add the size model
            if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
                (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
            endif
            ;waittime = 2


            ; show the image if requested
            if((OutPutFlags AND 4)/4)then begin
                Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
                if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
                OutPut3->Draw, (*pStateInfo).PrintROI.View
                wait,(*pStateInfo).waittime
            endif

            ; Image to file?
            if((OutPutFlags AND 2)/2)then begin
                if(not obj_valid(OutPut2))then begin
                    Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
                    OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
                endif

                OutPut2->Draw, (*pStateInfo).PrintROI.View
                (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
                page_percent=1.0;FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
                ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
                SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
                ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
                ;added above 76 to proevent time label being chop off.
            endif

            ; Image to printer?
            if(OutPutFlags AND 1)then begin
                if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
                if not obj_valid(OutPut) then OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
                ;(*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
                ;if     (*pStateInfo).skipPage then begin
                ;  if PrintCount mod 10 eq 0 then print, "print page(skipping):", PrintCount    ;OutPut->Draw, (*pStateInfo).PrintROI.View
                ;endif else print, "print page:", PrintCount    ;OutPut->Draw, (*pStateInfo).PrintROI.View
                OutPut->Draw, (*pStateInfo).PrintROI.View
                OutPut->NewDocument
            endif

            ; Destroy current view
            OBJ_DESTROY, (*pStateInfo).PrintROI.View

            ; And create a new one
            (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
            (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
            (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
            ;timetext2 added by moqixu
            if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
                (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
                (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
                (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
            endif

            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2   ;added by moqixu
            (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
            (*pStateInfo).PrintROI.PageX =0; changed this to 0 on Dec. 7th, 2011;  LeftMargin

            ; Need a little room at the bottom for the date
            (*pStateInfo).PrintROI.PageY = DateGap
            Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

            ; Print-out date per page
            case 1 of
                (OutPutFlags And 8 )/ 8:begin
                if(sizeType eq 'max')then msg='Max Size,'
                if(sizeType eq 'mean')then msg='Mean Size,'
            end
            (OutPutFlags And 16)/16:msg='Focus,'
            (OutPutFlags And 32)/32:msg='CutOff,'
            (OutPutFlags And 64)/64:msg='Roundness1,'
            (OutPutFlags And 128)/128:msg=''; dec 7th 2011, comment this out to save space on page top. 'Crystal,'
            else:                     msg = ''
        endcase

        if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
        if(not keyword_set(criteria))then criteria = 'No criteria applied'
        ; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
        scale =''; '<----------->200um'

        hhmmss_string=hourstring+minstring+secstring
        Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
            (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
            LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
            FONT=(*pStateInfo).PrintROI.Font1)

        (*pStateInfo).PrintROI.Model->Add, Text
        (*pStateInfo).PrintROI.PageY=DateGap+1
        ;  ******************************  this block added on 2010-05-16
        if !time_synced eq 1 then begin
            Time_offset_str='Version: '+!SPEC_VERSION+' Time has been synced.    '+strtrim(string(!DT_CPI),2)+' seconds are added to CPI"s  original Time'
            Text_sync = OBJ_NEW('IDLgrText', Time_offset_str, $
                LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap-18], COLOR=[0,0,0],$   ;added this on May 16, 2012
                FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model->Add, Text_sync;   ;that mean if it is starting of a page, add the text to the top line.
            (*pStateInfo).PrintRoi.pageY=0.75*DateGap+20;  added this on May 16, 2012.
            Offset[1] = 40; Offset[1] +0.75*DateGap+18; offset[1] changes from 0 from top of page to larger number at bottom.
        endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.

        if !time_synced eq 0 then begin
            Time_offset_str='Version: '+!SPEC_VERSION+' Time is not synced.   Time is CPI"s  original Time'
            Text_sync = OBJ_NEW('IDLgrText', Time_offset_str, $
                LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap-18], COLOR=[0,0,0],$   ;added this on May 16, 2012
                FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model->Add, Text_sync;   ;that mean if it is starting of a page, add the text to the top line.
            (*pStateInfo).PrintRoi.pageY=0.75*DateGap+20;  added this on May 16, 2012.
            Offset[1] = 40; Offset[1] +0.75*DateGap+18; offset[1] changes from 0 from top of page to larger number at bottom.
        endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.
        ;**********************************************************************************************************
        if obj_valid(output3) then obj_destroy,output3

    endif ; end enough vertical  space left ???

    ;the following line makes the filename a function of time rather than roiname.  The filename is :MMDD-HHMMSS_msec
    if ((*pStateInfo).printROI.pageno gt (*pStateInfo).printROI.oldpageno)then begin

        month = ((*pStateInfo).date.month); added dec. 7th, 2011.
        if (month lt 10)then begin
            monthstring = string('0'+strtrim(month,2))
        endif else monthstring = strtrim(month,2)

        if (minute lt 10) then begin
            minstring = string('0'+strtrim(minute,2))
        endif else minstring = strtrim(minute,2)

        if (hour lt 10) then begin
            hourstring = string('0'+strtrim(hour,2))
        endif else hourstring = strtrim(hour,2)

        day = ((*pStateInfo).date.day)

        oldhour = (*pStateInfo).printROI.oldhour

        if (hour lt oldhour) then begin
            (*pStateInfo).printROI.dayflag = (*pStateInfo).printROI.dayflag+1

        endif
        (*pStateInfo).printROI.oldhour = hour
        oldhour = hour
        day = day + (*pStateInfo).printROI.dayflag
        if (day lt 10)then begin
            daystring = string('0'+strtrim(day,2))
        endif else daystring = strtrim(day,2)

        if (second lt 10) then begin
            secstring = string('0'+strtrim(second,2))
        endif else secstring = strtrim(second,2)

        if msec lt 10                 then  msecstring = string('00'+strtrim(msec,2))
        if msec ge 10 and msec lt 100 then  msecstring = string( '0'+strtrim(msec,2))
        if msec ge 100                then  msecstring = string(     strtrim(msec,2))
        ;msecstring = strtrim(msec,2)

        (*pStateInfo).printROI.timeline =monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring

    endif
    (*pStateInfo).printROI.oldpageno = (*pStateInfo).printROI.pageno
    ; To print times, make times = 1.  To not print times, anything but 1
    ;print_time = 1
    if(print_time eq 1) then begin
        ;print, times_check
        if(PrintCount EQ 0 OR Offset[0] EQ LeftMargin)then begin
            ;;modified by mo on oct 29th 2003
            ;NewString = STRING(FORM='(I2,":",I2,":",I2,":",I3)', hour, minute, Second, msec); this goes between the ''
            NewString  =hourstring+':'+minstring;      ; STRING(FORM='(I2,":",I2,":")', hour, minute); this goes between the ''
            NewString2 = secstring+'.'+msecstring;    ;STRING(FORM='(I2,":",I3)', Second, msec);  added by mo for ss.mmm time line

            (*pStateInfo).PrintROI.TimeText->GetProperty, STRINGS=Strings, LOCATIONS=TxtPos
            (*pStateInfo).PrintROI.TimeText2->GetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2

            if Offset[0] LE LeftMargin then Offset[0] =leftMargin;  else Offset[0] = Offset[0] + .05*LeftMargin
            ;print, (*pStateInfo).printroi.timeline
            if Strings[0] NE -1 then begin
                TxtPos = [[TxtPos], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]]  ;added -0 by mo
                Strings = [Strings, NewString]
                (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=Strings, LOCATIONS=TxtPos,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=NewString,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]   ;added -0 by mo
            ;added another time line strings
            if Strings2[0] NE -1 then begin
                TxtPos2 = [[TxtPos2], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-10]]          ;added by mo
                Strings2 = [Strings2, NewString2]
                (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=NewString2,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-10]
        endif   ;end of if offset[0] LE leftMarcgin
    endif   ; end of i PrintCount=0 or offset=LeftMargin


    if(ptr_valid((*pStateInfo).BackFrame))then begin
        pBackImg = (*(*pStateInfo).BackFrame).pBackImg
        backROI = (*pBackImg)[(*pFrame)[i].ImageHeader.sx:(*pFrame)[i].ImageHeader.ex,(*pFrame)[i].ImageHeader.sy:(*pFrame)[i].ImageHeader.ey]
        ; save this back into the data array
        temp = *(*pFrame)[i].pROI - fix(backROI)
        ; dimg = BYTSCL(temp, top=253) + 1B ;MIN=ScaleMin, MAX=ScaleMax,
        dimg = congrid(BYTSCL(temp,top=255),dispsize(0),dispsize(1),/interp) ; change above to this on March 17, 2005
    endif else dimg = congrid(BYTSCL(*(*pFrame)[i].pROI,top=255),dispsize(0),dispsize(1),/interp)
    ;stop;  here temp is array[56,61]

    ;if(keyword_set(objdata))then if((*objData.pFrame)[i].imageheader.confidence eq 0)then dimg[*,*] = 0

    image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[Offset[0],$
        (*pStateInfo).PrintROI.PageDY -Offset[1] - dy,0], ORDER=1);,interpolate=1)

    (*pStateInfo).PrintROI.Model->Add, image

    if((OutPutFlags And 8)/8)then begin
        ;add size line
        (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=size_string, LOCATIONS=imgloc
        case sizeType of
            'mean':begin
            if(keyword_set(objdata))then begin
                mean_size = 2.0* sqrt((*objData.pFrame)[i].imageheader.area/!dpi) * (*pStateInfo).Settings.PixSize
            endif else begin
                mean_size = round(sqrt((*pFrame)[i].imageHeader.Wid * (*pFrame)[i].imageHeader.Len)* (*pStateInfo).Settings.PixSize )
            endelse

        end
        'max':begin
        if(keyword_set(objdata))then begin
            mean_size = max([(*objData.pFrame)[i].imageheader.len,(*objData.pFrame)[i].imageheader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
        endif else begin
            mean_size = max([(*pFrame)[i].imageHeader.Len,(*pFrame)[i].imageHeader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
        endelse
    end
endcase

if(size_string[0] ne -1)then begin
    imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
    size_string = [size_string,strtrim(round(mean_size),2)]
    (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=size_string, LOCATIONS=imgloc
endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(mean_size),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 8

if((OutPutFlags And 16)/16)then begin
    ; add focus line
    if(keyword_set(objdata))then begin
        focusStr =strtrim(fix((*objdata.pFrame)[i].imageHeader.focus),2)
    endif else begin
        ;  out of focus is in imageheader.flags (bits 0-7 of flags)
        focusStr = strtrim((*pFrame)[i].imageHeader.Flags AND '00FF'X,2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    if(focus_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        focus_string = [focus_string,focusStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focusStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;edn of if 16

if((OutPutFlags And 32)/32)then begin
    ; add cutoff line
    if(keyword_set(objdata))then begin
        cutoffStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.cutoff),2)
    endif else begin
        ; cutoff is in imageheader.dark ( bits 8 - 12)
        cutoffStr = strtrim(fix(100 * (ISHFT((*pFrame)[i].imageHeader.Dark,-8) AND '1F'X)/31.0),2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    if(cutoff_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        cutoff_string = [cutoff_string,cutoffStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoffStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif ;end of if 32
if((OutPutFlags And 64)/64)then begin
    ; add roundness line
    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=round_string, LOCATIONS=imgloc
    if(round_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        round_string = [round_string,strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2)]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=round_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 64

if((OutPutFlags And 128)/128)then begin
    ; add cyrstal type line
    if(keyword_set(objdata))then begin
        ; next line write number for crystal habit
        ;habitStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.crystal),2)
        ; this line writes cytsal habit name
        habitStr = (*pStateInfo).crystalName[(*objdata.pFrame)[i].imageHeader.crystal]
    endif else begin
        ; crystal is in imageheader.flags (bits 8 - 12)
        ; next line write number for crystal habit
        ;habitStr = strtrim( (ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X),2)
        ; this line writes cytsal habit name
        habitStr =   (*pStateInfo).crystalName[(ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X)]
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=type_string, LOCATIONS=imgloc
    if(size(type_string, /TYPE) EQ 7)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        type_string = [type_string,habitStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=type_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=habitStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 128
;mo changed teh following two lines.   make enought space for writing the time label.
if dx gt leftmargin then Offset[0] = Offset[0] + dx + (*pStateInfo).PrintROI.PageDX/400
if dx lt leftmargin then Offset[0] = Offset[0] + leftmargin + (*pStateInfo).PrintROI.PageDX/400

PrintCount = PrintCount + 1
endif

ENDFOR ; bottom of loop for i= 0, listLen-1  for roi's

(*pStateInfo).PrintROI.PageX = Offset[0]

; Start a new line, if necessary
;if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT 2*LeftMargin)then begin
if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT LeftMargin)then begin  ;changed to 0.2 by mo
    (*pStateInfo).PrintROI.PageX = LeftMargin
    (*pStateInfo).PrintROI.PageY = Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400+print_time*22; add +65 by mo

endif

; Start new page when needed
; Is there enough space left in the page?
if((*pStateInfo).PrintROI.PageY +22 GT 0.95*(*pStateInfo).PrintROI.PageDY)then begin
    ;added above 76 for time label

    ; Start new page
    ;  (*pStateInfo).PrintROI.PageX=leftmargin

    if(not obj_valid(Palette))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255
        g[0] = 0; 255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    endif

    ;if requested, add the size model
    if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
        (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
    endif

    ;***************************************************************************************************

    ; show the image if requested
    if((OutPutFlags AND 4)/4)then begin
        Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
        if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
        OutPut3->Draw, (*pStateInfo).PrintROI.View
        wait,(*pStateInfo).waittime
        ;added by mo to save image in png file for high resolution
    endif

    ; Image to file?
    if((OutPutFlags AND 2)/2)then begin
        if not obj_valid(OutPut2) then begin
            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
            ; OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[760*Aspect,760], COLOR_MODEL=1, PALETTE=Palette)
        endif

        OutPut2->Draw, (*pStateInfo).PrintROI.View
        (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
        page_percent=1.0; FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
        ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
        SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;added above 76 to proevent time label being chop off.

    endif

    ; Image to printer?
    if((OutPutFlags AND 1))then begin
        if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
        if not obj_valid(OutPut) then OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
        ;(*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
        OutPut->Draw, (*pStateInfo).PrintROI.View
        OutPut->NewDocument
    endif

    ; Destroy current view
    OBJ_DESTROY, (*pStateInfo).PrintROI.View
    (*pStateInfo).PrintROI.View = OBJ_NEW()
    (*pStateInfo).PrintROI.Model = OBJ_NEW()

    (*pStateInfo).PrintROI.PageX = LeftMargin
    (*pStateInfo).PrintROI.PageY = DateGap

endif; end of start new page.

; Remember maxdy if we didn't start a new line
if((*pStateInfo).PrintROI.PageX GT LeftMargin)then (*pStateInfo).PrintROI.MaxDY = maxdy else (*pStateInfo).PrintROI.MaxDY = 0

; Clean up objects
if(obj_valid(OutPut) )then OBJ_DESTROY, OutPut
if(obj_valid(OutPut2))then OBJ_DESTROY, OutPut2
if(obj_valid(Palette))then OBJ_DESTROY, Palette
if(obj_valid(output3))then obj_destroy,output3
;if(obj_valid(text))then obj_destroy,text
;if(obj_valid(type))then obj_destroy,type

RETURN, 0
end;   End of PRintROIs_notimelabel  Function.
;****************************************************************************


;*************************************************************************************

;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output Bit 2; set = display image Bit 4, set = display sizes
FUNCTION PrintROIs_keep, pStateInfo, accepted, frameData, OutPutFlags=OutPutFlags, objData=objData, confidence = confidence, criteria = criteria,time=time, sizeType=sizeType
(*pStateInfo).waittime = 0.5

stop;   This part is no longer used now.   It can be deleted.----as of Nov. 14th, 2011.

print_time=((OutPutFlags AND 256)/256)   ; default=0 added by mo at Dec 3, 2003;  Print_time=0 or 1.

;added these on Sept2. 2009  to show the three new Time stamp words of the CPI images  Htime and ArrivalT1 and ArrivalT2.
; added following lines.
;**********************************************************************************************
word1=strtrim(string(format='(Z4)',frameData.frameheader.Time),2)
word2=strtrim(string(format='(Z4)',frameData.frameheader.arrivalT1),2)
word3=strtrim(string(format='(Z4)',frameData.frameheader.arrivalT2),2)
if strlen(word1) eq 3 then word1='0'+word1
if strlen(word1) eq 2 then word1='00'+word1
if strlen(word1) eq 1 then word1='000'+word1

if strlen(word2) eq 3 then word2='0'+word2
if strlen(word2) eq 2 then word2='00'+word2
if strlen(word2) eq 1 then word2='000'+word2

if strlen(word3) eq 3 then word3='0'+word3
if strlen(word3) eq 2 then word3='00'+word3
if strlen(word3) eq 1 then word3='000'+word3

word1_a=strmid(word1,0,2)
word1_b=strmid(word1,2,2)
word2_a=strmid(word2,0,2)
word2_b=strmid(word2,2,2)
word3_a=strmid(word3,0,2)
word3_b=strmid(word3,2,2)
timeLsW=word1_a+word1_b
TimeIsW=word2_a+word2_b
TimeMSW=word3_a+word3_b


word4=strtrim(string(format='(Z4)',frameData.frameheader.Pheight1),2);  ; added on April 19.2010
word5=strtrim(string(format='(Z4)',frameData.frameheader.Pheight2),2)
if strlen(word4) eq 3 then word4='0'+word4
if strlen(word4) eq 2 then word4='00'+word4
if strlen(word4) eq 1 then word4='000'+word4

if strlen(word5) eq 3 then word5='0'+word5
if strlen(word5) eq 2 then word5='00'+word5
if strlen(word5) eq 1 then word5='000'+word5

;print, timeLSW
;print, word4
;print,word5
;stop

;*****************************************************************************
; Default is to send ouput to printer
if N_ELEMENTS(OutPutFlags) EQ 0 then OutPutFlags = 1
if OutPutFlags EQ 0 then OutPutFlags = 1
;loadct,1,/silent

pFrame = frameData.pFrame
; stop
set_min_max, pStateInfo  ; add this on march 21 to keep the color as in qui_lib.pro display image.

; How many ROIs?
if(keyword_set(objData))then ListLen = n_elements(*objData.pFrame) else ListLen = n_elements(*pFrame)

OutPut = OBJ_NEW()
OutPut2 = OBJ_NEW()
Palette = OBJ_NEW()

; Prepare fonts
if not obj_valid((*pStateInfo).PrintROI.Font1) then (*pStateInfo).PrintROI.Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', size=11)

; Get Page dimensions, if not already done
if((*pStateInfo).PrintROI.PageDX LT 100 OR (*pStateInfo).PrintROI.PageDY LT 100)then begin

    ; Get sizing from the printer info
    if(not obj_valid(OutPut))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255 ; change this to from 255 to 0 on march 17 2005
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
        OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)

    endif
    IF obj_valid(OutPut) THEN $
        OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res  ; I may change this to set instead of get.
    dims=[792,1024];      added by mo at March 21, 2005
    res= [0.025,0.025]
    (*pStateInfo).PrintROI.PageDX = Dims[0]
    (*pStateInfo).PrintROI.PageDY = Dims[1]

    ; Create new view
    if(not obj_valid((*pStateInfo).PrintROI.View))then begin

        ; create a view
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ;timetext2 added by mo on oct 29/2003
        (*pStateInfo).PrintROI.TimeText3 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)

        ; added following on April 19, 2010.
        (*pStateInfo).PrintROI.TimeText4 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText5 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)


        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
        endif

        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2 ;added by mo
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText3 ;added by mo  on sept2, 2009.
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText4 ;added by mo  on April19, 2010.
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText5 ;added by mo  on Aril119, 2010.
        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model

    endif

    ;set text dims in pixels
    TextDims = ([265, 33]*(0.00704861/Res[0]))*1.7    ; added by JS to enlarge font

    (*pStateInfo).PrintROI.LeftMargin = [TextDims[0], TextDims[1]]

    ; Want 40 pixs = 1 cm
    (*pStateInfo).PrintROI.PageZoom = 1/(Res[0]*40)

endif
;change zoom to integer on March 17, 2005.
zoom =1; (*pStateInfo).PrintROI.PageZoom*1.0;      (*pStateInfo).zoom  for png zoom=1.0
LeftMargin = ((*pStateInfo).PrintROI.LeftMargin)[0]*1.05*0.36;  added 0.36 by mo here =47.68
; Get scaling
WIDGET_CONTROL, (*pStateInfo).ScaleMinID, GET_VALUE=ScaleMin
WIDGET_CONTROL, (*pStateInfo).ScaleMaxID, GET_VALUE=ScaleMax

maxdy = (*pStateInfo).PrintROI.MaxDY
DateGap = 1.8 * ((*pStateInfo).PrintROI.LeftMargin)[1]
(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY > DateGap
Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

if(keyword_set(time))then begin
    month =(*Pstateinfo).Date.month; time.month
    day   =(*Pstateinfo).Date.day;   ; time.day
    hour  =time.hour
    minute=time.minute
    second=time.sec
    msec  =time.msec;   note that in here framedata's time by Htime, ArrivalT1,T2 is teh same as Time's time.


    if (month lt 10)then begin
        monthstring = string('0'+strtrim(month,2))
    endif else monthstring = strtrim(month,2)

    if (day lt 10)then begin
        daystring = string('0'+strtrim(day,2))
    endif else daystring = strtrim(day,2)

    if (hour lt 10) then begin
        hourstring = string('0'+strtrim(hour,2))
    endif else hourstring = strtrim(hour,2)

    if (minute lt 10) then begin
        minstring = string('0'+strtrim(minute,2))
    endif else minstring = strtrim(minute,2)

    if (second lt 10) then begin
        secstring = string('0'+strtrim(second,2))
    endif else secstring = strtrim(second,2)

    if msec lt 10                 then  msecstring = string('00'+strtrim(msec,2))
    if msec ge 10 and msec lt 100 then  msecstring = string( '0'+strtrim(msec,2))
    if msec ge 100                then  msecstring = string(     strtrim(msec,2))

    (*pStateInfo).printROI.timeline =monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring
    ;(*pStateInfo).printROI.timeline = monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+strtrim(msec,2)

    ; need to change these strings to be word1, word2, word3.  added septembe 2, 2009.
endif

if(ListLen GT 0 AND (*pStateInfo).PrintROI.PageY LE DateGap)then begin

    ; New Page? If so, we need a new view and model
    if not obj_valid((*pStateInfo).PrintROI.View) then begin
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ;Timetext2 added by moqixu
        (*pStateInfo).PrintROI.TimeText3 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ; added following on April 19, 2010.
        (*pStateInfo).PrintROI.TimeText4 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText5 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)



        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2; added by moqixu
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText3; added by moqixu  on sept2, 2009.
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText4; added by moqixu
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText5; added by moqixu  on April, 2010.


        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
        endif
    endif

    ; Print-out date per page
    case 1 of
        (OutPutFlags And 8 )/ 8:begin
        if(sizeType eq 'max')then msg='Max Size,'
        if(sizeType eq 'mean')then msg='Mean Size,'
    end
    (OutPutFlags And 16)/16:  msg='Focus,'
    (OutPutFlags And 32)/32:  msg='CutOff,'
    (OutPutFlags And 64)/64:  msg='Roundness1,'
    (OutPutFlags And 128)/128:msg='Crystal,'
    else:                     msg = ''
endcase

if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
if(not keyword_set(criteria))then criteria = 'No criteria applied';criteria_test
; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
scale =''; '<----------->200um'

hhmmss_string=hourstring+minstring+secstring
Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
    (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
    LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
    FONT=(*pStateInfo).PrintROI.Font1)

if (*pStateInfo).PrintRoi.pageY le dateGap and (*pStateInfo).printRoi.pageX le leftmargin then begin
    (*pStateInfo).PrintROI.Model->Add, Text;   ;that mean if it is starting of a page, add the text to the top line.
    (*pStateInfo).PrintRoi.pageY=dateGap+1;    ; otherwise, not text is added to the top line.
endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.

endif

PrintCount = 0

for i=0, ListLen-1 DO begin

    ;if(keyword_set(objData))then begin
    ; if(confidence[i] eq 10)then acceptflag = !true else acceptFlag = !false
    ;endif else begin
    ; acceptflag = !true
    ;;    ;Reject as artifact?
    ; if((*pStateInfo).Settings.ArtifactReject)then acceptflag = not ishft(((*pFrame)[i]).ImageHeader.flags,-14)
    ;endelse


    if(accepted[i])then begin

        ImgSize = size(*(*pFrame)[i].pROI)
        dx = zoom*(*pStateInfo).Settings.YXAspect*ImgSize[1] ;here YXaspect=1.00, zoom=2.95275
        dy = zoom*ImgSize[2]                                 ; it is very odd.--mo_March 17,2005.
        DispSize = [dx,dy]
        ; stop
        ; Reached right margin?
        if(Offset[0] NE LeftMargin AND Offset[0] + dx GT (*pStateInfo).PrintROI.PageDX)then begin
            ;start a new line of images.
            Offset[0]=leftMargin;  else offset[0] = LeftMargin  ;above line changed by mo to take off the space_for_time
            ;above is that if there are many images of the same time. other images will be put to leftest.
            Offset[1] =  Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400 + print_time*70; added +65 by mo
            ;(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy + 2 +print_time*22; added +65 by mo
            (*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy + 76 +print_time*70; added +34 by Mo on sept2,2009
            maxdy = dy;                                        ; changed to 66 for txet4 and text5 ; becuase add a thrid line to lable Time.
        endif else maxdy = maxdy > dy

        ; Is there enough space left in the page?
        if((*pStateInfo).PrintROI.PageY GT DateGap AND (*pStateInfo).PrintROI.PageY + dy + 76 GT (*pStateInfo).PrintROI.PageDY)then begin
            ;added above 54 for time label.  of 5 lines
            ; Start new page
            if(not obj_valid(Palette))then begin
                ; Get current color table
                TVLCT, r, g, b, /GET
                r[0] = 0;255
                g[0] = 0;255
                b[0] = 0
                Palette = OBJ_NEW('IDLgrPalette', r, g, b)
            endif

            ;if requested, add the size model
            if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
                (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
            endif
            (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model2
            ;waittime = 2

            ; show the image if requested
            if((OutPutFlags AND 4)/4)then begin
                Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
                if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
                OutPut3->Draw, (*pStateInfo).PrintROI.View
                wait,(*pStateInfo).waittime
            endif

            ; Image to file?
            if((OutPutFlags AND 2)/2)then begin
                if(not obj_valid(OutPut2))then begin
                    Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
                    OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
                endif

                OutPut2->Draw, (*pStateInfo).PrintROI.View
                (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
                page_percent=1.0;FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
                ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
                SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
                ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
                ;added above 76 to proevent time label being chop off.
            endif


            ; Destroy current view
            OBJ_DESTROY, (*pStateInfo).PrintROI.View

            ; And create a new one
            (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
            (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
            (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
            ;timetext2 added by moqixu
            (*pStateInfo).PrintROI.TimeText3 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)

            (*pStateInfo).PrintROI.TimeText4 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)

            (*pStateInfo).PrintROI.TimeText5 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)


            if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
                (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
                (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
                (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
            endif

            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2   ;added by moqixu
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText3   ;added by moqixu

            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText4   ;added by moqixu
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText5   ;added by moqixu


            (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
            (*pStateInfo).PrintROI.PageX = LeftMargin

            ; Need a little room at the bottom for the date
            (*pStateInfo).PrintROI.PageY = DateGap
            Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

            ; Print-out date per page
            case 1 of
                (OutPutFlags And 8 )/ 8:begin
                if(sizeType eq 'max')then msg='Max Size,'
                if(sizeType eq 'mean')then msg='Mean Size,'
            end
            (OutPutFlags And 16)/16:msg='Focus,'
            (OutPutFlags And 32)/32:msg='CutOff,'
            (OutPutFlags And 64)/64:msg='Roundness1,'
            (OutPutFlags And 128)/128:msg='Crystal,'
            else:                     msg = ''
        endcase

        if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
        if(not keyword_set(criteria))then criteria = 'No criteria applied'
        ; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
        scale =''; '<----------->'+strtrim(string(round(200.0/float(1.0))),2)+'microns'

        hhmmss_string=hourstring+minstring+secstring
        Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
            (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
            LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
            FONT=(*pStateInfo).PrintROI.Font1)

        (*pStateInfo).PrintROI.Model->Add, Text
        (*pStateInfo).PrintROI.PageY=DateGap+1

        if obj_valid(output3) then obj_destroy,output3
    endif ; end enough space left ???

    ;the following line makes the filename a function of time rather than roiname.  The filename is :MMDD-HHMMSS_msec
    if ((*pStateInfo).printROI.pageno gt (*pStateInfo).printROI.oldpageno)then begin

        month = ((*pStateInfo).date.month)
        if (month lt 10)then begin
            monthstring = string('0'+strtrim(month,2))
        endif else monthstring = strtrim(month,2)

        if (minute lt 10) then begin
            minstring = string('0'+strtrim(minute,2))
        endif else minstring = strtrim(minute,2)

        if (hour lt 10) then begin
            hourstring = string('0'+strtrim(hour,2))
        endif else hourstring = strtrim(hour,2)

        day = ((*pStateInfo).date.day)
        oldhour = (*pStateInfo).printROI.oldhour

        if (hour lt oldhour) then begin
            (*pStateInfo).printROI.dayflag = (*pStateInfo).printROI.dayflag+1

        endif
        (*pStateInfo).printROI.oldhour = hour
        oldhour = hour
        day = day + (*pStateInfo).printROI.dayflag
        if (day lt 10)then begin
            daystring = string('0'+strtrim(day,2))
        endif else daystring = strtrim(day,2)

        if (second lt 10) then begin
            secstring = string('0'+strtrim(second,2))
        endif else secstring = strtrim(second,2)

        ;msecstring = strtrim(msec,2)
        if msec lt 10                 then  msecstring = string('00'+strtrim(msec,2))
        if msec ge 10 and msec lt 100 then  msecstring = string( '0'+strtrim(msec,2))
        if msec ge 100                then  msecstring = string(     strtrim(msec,2))

        (*pStateInfo).printROI.timeline =monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring

    endif
    (*pStateInfo).printROI.oldpageno = (*pStateInfo).printROI.pageno
    ; To print times, make times = 1.  To not print times, anything but 1
    ;print_time = 1
    if(print_time eq 1) then begin
        ;print, times_check
        if(PrintCount EQ 0 OR Offset[0] EQ LeftMargin)then begin
            ;;modified by mo on oct 29th 2003
            ;NewString = STRING(FORM='(I2,":",I2,":",I2,":",I3)', hour, minute, Second, msec); this goes between the ''
            NewString  =hourstring+':'+minstring;   STRING(FORM='(I2,":",I2,":")', hour, minute); this goes between the ''
            NewString2 =secstring+'.'+msecstring;  ; STRING(FORM='(I2,":",I3)', Second, msec);  added by mo for ss.mmm time line

            ;change this string to be word 1 and word 2 of new 3VCPI.
            ;***********************************************************************************
            NewString =timeLSW
            NewString2=TimeISW
            NewString3=TimeMSW
            NewString4=word4
            NewString5=word5


            ;***********************************************************************************


            (*pStateInfo).PrintROI.TimeText->GetProperty, STRINGS=Strings, LOCATIONS=TxtPos
            (*pStateInfo).PrintROI.TimeText2->GetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2
            (*pStateInfo).PrintROI.TimeText3->GetProperty, STRINGS=Strings3, LOCATIONS=TxtPos3
            (*pStateInfo).PrintROI.TimeText4->GetProperty, STRINGS=Strings4, LOCATIONS=TxtPos4
            (*pStateInfo).PrintROI.TimeText5->GetProperty, STRINGS=Strings5, LOCATIONS=TxtPos5

            if Offset[0] LE LeftMargin then Offset[0] =LeftMargin
            ;print, (*pStateInfo).printroi.timeline
            if Strings[0] NE -1 then begin
                TxtPos = [[TxtPos], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]]  ;added -0 by mo
                Strings = [Strings, NewString]
                (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=Strings, LOCATIONS=TxtPos,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=NewString,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]   ;added -0 by mo
            ;added another time line strings
            if Strings2[0] NE -1 then begin
                TxtPos2 = [[TxtPos2], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-15]]          ;added by mo
                Strings2 = [Strings2, NewString2]
                (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=NewString2,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-15]


            ;added another time line strings
            if Strings3[0] NE -1 then begin
                TxtPos3 = [[TxtPos3], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-32]]          ;added by mo
                Strings3 = [Strings3, NewString3]
                (*pStateInfo).PrintROI.TimeText3->SetProperty, STRINGS=Strings3, LOCATIONS=TxtPos3,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText3->SetProperty, STRINGS=NewString3,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-32]


            ;added another time line strings  for word 4
            if Strings4[0] NE -1 then begin
                TxtPos4 = [[TxtPos4], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-50]]          ;added by mo
                Strings4 = [Strings4, NewString4]
                (*pStateInfo).PrintROI.TimeText4->SetProperty, STRINGS=Strings4, LOCATIONS=TxtPos4,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText4->SetProperty, STRINGS=NewString4,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-50]


            ;added another time line strings  for word 5
            if Strings5[0] NE -1 then begin
                TxtPos5 = [[TxtPos5], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-68]]          ;added by mo
                Strings5 = [Strings5, NewString5]
                (*pStateInfo).PrintROI.TimeText5->SetProperty, STRINGS=Strings5, LOCATIONS=TxtPos5,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText5->SetProperty, STRINGS=NewString5,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-68]
        endif   ;end of if offset[0] LE leftMarcgin
    endif   ; end of i PrintCount=0 or offset=LeftMargin


    if(ptr_valid((*pStateInfo).BackFrame))then begin
        pBackImg = (*(*pStateInfo).BackFrame).pBackImg
        backROI = (*pBackImg)[(*pFrame)[i].ImageHeader.sx:(*pFrame)[i].ImageHeader.ex,(*pFrame)[i].ImageHeader.sy:(*pFrame)[i].ImageHeader.ey]
        ; save this back into the data array
        temp = *(*pFrame)[i].pROI - fix(backROI)
        ; dimg = BYTSCL(temp, top=253) + 1B ;MIN=ScaleMin, MAX=ScaleMax,
        dimg = congrid(BYTSCL(temp,top=255),dispsize(0),dispsize(1),/interp) ; change above to this on March 17, 2005
    endif else dimg = congrid(BYTSCL(*(*pFrame)[i].pROI,top=255),dispsize(0),dispsize(1),/interp)
    ;stop;  here temp is array[56,61]

    ;if(keyword_set(objdata))then if((*objData.pFrame)[i].imageheader.confidence eq 0)then dimg[*,*] = 0

    image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[Offset[0],$
        (*pStateInfo).PrintROI.PageDY -Offset[1] - dy,0], ORDER=1);,interpolate=1)

    (*pStateInfo).PrintROI.Model->Add, image

    if((OutPutFlags And 8)/8)then begin
        ;add size line
        (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=size_string, LOCATIONS=imgloc
        case sizeType of
            'mean':begin
            if(keyword_set(objdata))then begin
                mean_size = 2.0* sqrt((*objData.pFrame)[i].imageheader.area/!dpi) * (*pStateInfo).Settings.PixSize
            endif else begin
                mean_size = round(sqrt((*pFrame)[i].imageHeader.Wid * (*pFrame)[i].imageHeader.Len)* (*pStateInfo).Settings.PixSize )
            endelse

        end
        'max':begin
        if(keyword_set(objdata))then begin
            mean_size = max([(*objData.pFrame)[i].imageheader.len,(*objData.pFrame)[i].imageheader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
        endif else begin
            mean_size = max([(*pFrame)[i].imageHeader.Len,(*pFrame)[i].imageHeader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
        endelse
    end
endcase

if(size_string[0] ne -1)then begin
    imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
    size_string = [size_string,strtrim(round(mean_size),2)]
    (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=size_string, LOCATIONS=imgloc
endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(mean_size),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 8

if((OutPutFlags And 16)/16)then begin
    ; add focus line
    if(keyword_set(objdata))then begin
        focusStr =strtrim(fix((*objdata.pFrame)[i].imageHeader.focus),2)
    endif else begin
        ;  out of focus is in imageheader.flags (bits 0-7 of flags)
        focusStr = strtrim((*pFrame)[i].imageHeader.Flags AND '00FF'X,2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    if(focus_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        focus_string = [focus_string,focusStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focusStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;edn of if 16

if((OutPutFlags And 32)/32)then begin
    ; add cutoff line
    if(keyword_set(objdata))then begin
        cutoffStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.cutoff),2)
    endif else begin
        ; cutoff is in imageheader.dark ( bits 8 - 12)
        cutoffStr = strtrim(fix(100 * (ISHFT((*pFrame)[i].imageHeader.Dark,-8) AND '1F'X)/31.0),2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    if(cutoff_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        cutoff_string = [cutoff_string,cutoffStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoffStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif ;end of if 32
if((OutPutFlags And 64)/64)then begin
    ; add roundness line
    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=round_string, LOCATIONS=imgloc
    if(round_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        round_string = [round_string,strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2)]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=round_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 64

if((OutPutFlags And 128)/128)then begin
    ; add cyrstal type line
    if(keyword_set(objdata))then begin
        ; next line write number for crystal habit
        ;habitStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.crystal),2)
        ; this line writes cytsal habit name
        habitStr = (*pStateInfo).crystalName[(*objdata.pFrame)[i].imageHeader.crystal]
    endif else begin
        ; crystal is in imageheader.flags (bits 8 - 12)
        ; next line write number for crystal habit
        ;habitStr = strtrim( (ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X),2)
        ; this line writes cytsal habit name
        habitStr =   (*pStateInfo).crystalName[(ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X)]
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=type_string, LOCATIONS=imgloc
    if(size(type_string, /TYPE) EQ 7)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        type_string = [type_string,habitStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=type_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=habitStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 128
;mo changed teh following two lines.   make enought space for writing the time label.
if dx gt leftmargin then Offset[0] = Offset[0] + dx + (*pStateInfo).PrintROI.PageDX/400
if dx lt leftmargin then Offset[0] = Offset[0] + leftmargin + (*pStateInfo).PrintROI.PageDX/400

PrintCount = PrintCount + 1
endif

ENDFOR ; bottom of loop for roi's

(*pStateInfo).PrintROI.PageX = Offset[0]

; Start a new line, if necessary
;if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT 2*LeftMargin)then begin
if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT LeftMargin)then begin  ;changed to 0.2 by mo
    (*pStateInfo).PrintROI.PageX = LeftMargin
    ;(*pStateInfo).PrintROI.PageY = Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400+print_time*22; add +65 by mo
    (*pStateInfo).PrintROI.PageY = Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400+print_time*70 +76; added 24 on sept2, 2009.

endif

; Start new page when needed
; Is there enough space left in the page?
if((*pStateInfo).PrintROI.PageY +22 GT 0.95*(*pStateInfo).PrintROI.PageDY)then begin
    ;added above 76 for time label

    ; Start new page
    ;  (*pStateInfo).PrintROI.PageX=leftmargin

    if(not obj_valid(Palette))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255
        g[0] = 0; 255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    endif

    ;if requested, add the size model
    if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
        (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
    endif

    ; show the image if requested
    if((OutPutFlags AND 4)/4)then begin
        Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
        if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
        OutPut3->Draw, (*pStateInfo).PrintROI.View
        wait,(*pStateInfo).waittime
        ;added by mo to save image in png file for high resolution
    endif

    ; Image to file?
    if((OutPutFlags AND 2)/2)then begin
        if not obj_valid(OutPut2) then begin
            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
            ; OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[760*Aspect,760], COLOR_MODEL=1, PALETTE=Palette)
        endif

        OutPut2->Draw, (*pStateInfo).PrintROI.View
        (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
        page_percent=1.0; FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
        ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
        SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;added above 76 to proevent time label being chop off.

    endif

    ; Image to printer?
    if((OutPutFlags AND 1))then begin
        if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
        if not obj_valid(OutPut) then OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
        ;(*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
        OutPut->Draw, (*pStateInfo).PrintROI.View
        OutPut->NewDocument
    endif

    ; Destroy current view
    OBJ_DESTROY, (*pStateInfo).PrintROI.View
    (*pStateInfo).PrintROI.View = OBJ_NEW()
    (*pStateInfo).PrintROI.Model = OBJ_NEW()

    (*pStateInfo).PrintROI.PageX = LeftMargin
    (*pStateInfo).PrintROI.PageY = DateGap

endif

; Remember maxdy if we didn't start a new line
if((*pStateInfo).PrintROI.PageX GT LeftMargin)then (*pStateInfo).PrintROI.MaxDY = maxdy else (*pStateInfo).PrintROI.MaxDY = 0

; Clean up objects
if(obj_valid(OutPut) )then OBJ_DESTROY, OutPut
if(obj_valid(OutPut2))then OBJ_DESTROY, OutPut2
if(obj_valid(Palette))then OBJ_DESTROY, Palette
if(obj_valid(output3))then obj_destroy,output3
;if(obj_valid(text))then obj_destroy,text
;if(obj_valid(type))then obj_destroy,type

RETURN, 0
end;  end of Print_Rois_keep  function

;  **********************

pro sendToPrinter , pStateInfo
    forward_function find_first_link

    pLink = find_first_link((*(*pStateInfo).pTimeInfo).pCurrent_link)
    ; Send FF to printer
    IF((*pLink).sendPrint OR (*pLink).sendTIFF OR  (*pLink).display1)THEN BEGIN

        (*pStateInfo).PrintROI.Flags = 0

        IF (*pLink).sendPrint THEN (*pStateInfo).PrintROI.Flags = 1
        IF (*plink).sendTiff THEN (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 2
        if((*plink).display1  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 4
        if((*plink).addsize1 or (*plink).addsize2)then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 8
        if((*plink).addfocus  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 16
        if((*plink).addcutoff  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 32
        if((*plink).addround  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 64
        if((*plink).addtype  )then (*pStateInfo).PrintROI.Flags = (*pStateInfo).PrintROI.Flags OR 128

        ;if((*pStateInfo).skipPage) then begin
        ; Send every 10th page to printer
        ; if( (*pStateInfo).pageCount MOD 10 eq 0) then begin
        ;     PrintPageSoFar, pStateInfo, OutPutFlags=(*pStateInfo).PrintROI.Flags
        ; endif
        ;  (*pStateInfo).pageCount  =  (*pStateInfo).pageCount  + 1
        ;endif else begin
        ;  send every page to printer
        if (*Plink).addtime eq 255 then begin
            PrintPageSoFar, pStateInfo, OutPutFlags=(*pStateInfo).PrintROI.Flags
        endif

        if (*Plink).addHextime eq 255 then begin
            PrintPageSoFarHex, pStateInfo, OutPutFlags=(*pStateInfo).PrintROI.Flags
        endif
        ;endelse

    ENDIF

    ; Turn off printing
    (*pStateInfo).PrintROI.Flags = 0
    (*pStateInfo).PrintROI.DoIt = 0
    ;WIDGET_CONTROL,(*pStateInfo).PrintROI.PrintID, SET_VALUE=0

end


pro output_ascii,pStateInfo,header,frame,fail
    ;Purpose, to output the image header to an ascii file
    ;   Paramters
    ;   pStateInfo    input
    ;   header       Input Imageheader
    ;   frame     Input  frame number
    ;   fail   input   false means write a line

    if(not fail)then begin
        printf,(*pStateInfo).AsciiLUN,$
            frame,$
            header.Flags,         $    ; contains info about crstal type, focus, reject and manual parameters
            header.Len,          $ ; length of major axis in pixels
            header.Wid,          $ ; lenght of axis perpendicular to major axis in pixels
            header.Dark,        $ ; this field is called usROIDepth in header, contains depth and cutoff info
            header.Area,        $ ; computed area in pixels
            header.Perim,         $    ; computed perimeter in pixels
            header.Centroid,     $  ; Centroid of particle ( 2 elements )
            header.Roundness1,       $ ; Measure of particle roundness
            header.X_Moment,     $  ; 1/2 area on each side of vert line
            header.Y_moment,     $  ; 1/2 area on each side of horiz line
            header.Rubber_Band,   $   ; Measure of boundary roughness
            header.Fractal_dim,   $   ; Fractal dimension
            header.Focus,         $    ; % focus 0-100. This is the average focus value for multiple samples along the particle boundary
            header.CutOff,      $   ; % particle is cut-off 0 - 100
            header.Crystal,       $  ; Scalar type index meaning TBD
            header.Confidence,     $    ; Factor assessing confidence in particle use 0-10
            format='(I4,x,i6,x,f8.2,x,f8.2,x,i6,x,f8.2,x,f8.2,x,f6.2,x,f6.2,x,f6.2,x,f6.2,x,f6.2,x,f6.2,x,f6.2,x,i3,x,i3,x,i3,x,i3,x)'
    endif else printf,(*pStateInfo).AsciiLUN,frame,'Failed',format='(I4, 3x, a6)'

end

;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output

PRO PrintPageSoFar, pStateInfo, OutPutFlags=OutPutFlags

    ; Default is to send ouput to printer
    if(N_ELEMENTS(OutPutFlags) EQ 0)then OutPutFlags = 1
    if(OutPutFlags EQ 0)then OutPutFlags = 1

    if(obj_valid((*pStateInfo).PrintROI.View))then begin

        ;**************************************************************
        ;move from most beginning to to here
        ;************ added following block to add end time to parictle image png file and page *********
        ;the end time existed in the file-names timeline information.
        end_time_str=(*pStateInfo).printROI.timeline;;=monthstring+daystring+'-'+hourstring+minstring+secstring+'_'+strtrim(msec,2)
        end_time_str=strmid(end_time_str,5,10);       ;mmdd-hhmmss_msec=0302-451433_985
        hhstr=strmid(end_time_str,0,2)
        mmstr=strmid(end_time_str,2,2)
        ssstr=strmid(end_time_str,4,2)
        if end_time_str eq '' then begin
            hhstr='no_image'
            mmstr='--page'
        endif

        WIDGET_CONTROL, (*pStateInfo).widgets.tlb, /HOURGLASS
        ; Print current page
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)

        ;if requested, add the size model
        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
        endif
        (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model2
        ; if selected, put up a display
        if((OutPutFlags AND 4)/4)then begin
            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            if(not obj_valid(output3))then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette, retain=2)
            OutPut3->Draw, (*pStateInfo).PrintROI.View
            wait,(*pStateInfo).waittime
        endif

        ; File output?
        if((OutPutFlags AND 2)/2)then begin

            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
            ; OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[760*Aspect,760], COLOR_MODEL=1, PALETTE=Palette)
            OutPut2->Draw, (*pStateInfo).PrintROI.View
            (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
            page_percent=1.0; FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
            ;if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0

            SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
            ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY + 76.0+(*pStateInfo).PrintROI.MaxDY)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
            ;added above 76 to proevent time label being chop off.
            OBJ_DESTROY, OutPut2
        endif

        ; Printer output?
        if(OutPutFlags AND 1)then begin
            if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
            OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
            ;if(not (*pStateInfo).PrintROI.View->IsContained((*pStateInfo).PrintROI.Model1))then (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
            OutPut->Draw, (*pStateInfo).PrintROI.View
            OutPut->NewDocument
            OBJ_DESTROY, OutPut
        endif

        ; Destroy current view
        OBJ_DESTROY, (*pStateInfo).PrintROI.View
        OBJ_DESTROY, Palette

        if(obj_valid(output3))then OBJ_DESTROY, OutPut3

        (*pStateInfo).PrintROI.View = OBJ_NEW()
        (*pStateInfo).PrintROI.Model = OBJ_NEW()
        ; Reset page positions
        (*pStateInfo).PrintROI.PageDX = 0
        (*pStateInfo).PrintROI.PageX = 0+12.0
        (*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageDY/200
    endif
end  ; end of Print_rio_png_pages_only_3VCPI



;===============================================================================
PRO SaveWndToFile, pStateInfo, OutPutWnd, YPercent, r, g, b, pageNo
    ; Create a filename

    lastslashloc = rstrpos((*pStateInfo).InFileName,'\')
    FileName = strmid((*pStateInfo).InFileName,lastslashloc+1)
    lastdotloc = rstrpos(FileName,'.')
    FileName = strmid(Filename,0,lastdotloc)
    ;espo_str='CP'+strtrim(string(((*pStateInfo).date).year),2); added this on july 29, 2007.
    ;FileName = (*pStateInfo).tiffpath +espo_str+(*pStateInfo).printroi.timeline + '.png';'_' + STRTRIM(STRING(pageNo),2) +
    ;(*pStateInfo).printroi.timeline = ''
    ;carl is messing with things here
    ;******************************************** added 2012-05-16  for DC3
    ;espo_str=strtrim(!project_name)+'Hawkeye-3VCPI_'+strtrim(!platform,2)+'-'+strtrim(string(((*pStateInfo).date).year),2);+ month_str+day_str; added this on 2012-05-08.
    espo_str=strtrim(!project_name)+'-3VCPI_'+strtrim(!platform,2)+'_'+strtrim(string(((*pStateInfo).date).year),2);+ month_str+day_str; added this on 2012-05-08.
    FileName = (*pStateInfo).tiffpath +espo_str+(*pStateInfo).printroi.timeline + '_'+strtrim(!Revision_X,2)+'.png';'_' + STRTRIM(STRING(pageNo),2) +
    (*pStateInfo).printroi.timeline = ''
    ;************************************************************************************************************************

    ; Get window image
    Img = OutPutWnd->Read()

    ; Get the actual buffer
    Img->GetProperty, Data=Buf; , /NO_COPY
    ;Buf = ROTATE (TEMPORARY(Buf), 7)
    YPercent = 1.0;   YPercent < 1.0   changed on March 2005 by Qixu to fixed the scale--
    y = (size(Buf))[2]
    dy = round(y * YPercent)

    ;WRITE_TIFF, FileName, Buf[*,0:dy-1], 1, RED=r, GREEN=g, BLUE=b
    write_png,filename, Buf[*,y-dy:*], r,g,b

    OBJ_DESTROY, Img

end


PRO PrintPageSoFarHex, pStateInfo, OutPutFlags=OutPutFlags

    ; Default is to send ouput to printer
    if(N_ELEMENTS(OutPutFlags) EQ 0)then OutPutFlags = 1
    if(OutPutFlags EQ 0)then OutPutFlags = 1

    if(obj_valid((*pStateInfo).PrintROI.View))then begin

        ;**************************************************************
        ;move from most beginning to to here
        ;************ added following block to add end time to parictle image png file and page *********
        ;the end time existed in the file-names timeline information.
        end_time_str=(*pStateInfo).printROI.timeline;;=monthstring+daystring+'-'+hourstring+minstring+secstring+'_'+strtrim(msec,2)
        end_time_str=strmid(end_time_str,5,10);       ;mmdd-hhmmss_msec=0302-451433_985
        hhstr=strmid(end_time_str,0,2)
        mmstr=strmid(end_time_str,2,2)
        ssstr=strmid(end_time_str,4,2)
        if end_time_str eq '' then begin
            hhstr='no_image'
            mmstr='--page'
        endif

        WIDGET_CONTROL, (*pStateInfo).widgets.tlb, /HOURGLASS
        ; Print current page
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)

        ;if requested, add the size model
        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
        endif

        ; if selected, put up a display
        if((OutPutFlags AND 4)/4)then begin
            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            if(not obj_valid(output3))then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette, retain=2)
            OutPut3->Draw, (*pStateInfo).PrintROI.View
            wait,(*pStateInfo).waittime
        endif

        ; File output?
        if((OutPutFlags AND 2)/2)then begin

            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
            ; OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[760*Aspect,760], COLOR_MODEL=1, PALETTE=Palette)
            OutPut2->Draw, (*pStateInfo).PrintROI.View
            (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
            page_percent=1.0; FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
            ;if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
            SaveWndToFileHex, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
            ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY + 76.0+(*pStateInfo).PrintROI.MaxDY)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
            ;added above 76 to proevent time label being chop off.
            OBJ_DESTROY, OutPut2
        endif

        ; Printer output?
        if(OutPutFlags AND 1)then begin
            if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
            OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
            ;if(not (*pStateInfo).PrintROI.View->IsContained((*pStateInfo).PrintROI.Model1))then (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
            OutPut->Draw, (*pStateInfo).PrintROI.View
            OutPut->NewDocument
            OBJ_DESTROY, OutPut
        endif

        ; Destroy current view
        OBJ_DESTROY, (*pStateInfo).PrintROI.View
        OBJ_DESTROY, Palette

        if(obj_valid(output3))then OBJ_DESTROY, OutPut3

        (*pStateInfo).PrintROI.View = OBJ_NEW()
        (*pStateInfo).PrintROI.Model = OBJ_NEW()
        ; Reset page positions
        (*pStateInfo).PrintROI.PageDX = 0
        (*pStateInfo).PrintROI.PageX = 0+12.0
        (*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageDY/200
    endif
end ; sofarHex.


PRO SaveWndToFileHex, pStateInfo, OutPutWnd, YPercent, r, g, b, pageNo
    ; Create a filename

    lastslashloc = rstrpos((*pStateInfo).InFileName,'\')
    FileName = strmid((*pStateInfo).InFileName,lastslashloc+1)
    lastdotloc = rstrpos(FileName,'.')
    FileName = strmid(Filename,0,lastdotloc)
    espo_str='CPHex'+strtrim(string(((*pStateInfo).date).year),2); added this on july 29, 2007.
    FileName = (*pStateInfo).tiffpath +espo_str+(*pStateInfo).printroi.timeline + '.png';'_' + STRTRIM(STRING(pageNo),2) +
    (*pStateInfo).printroi.timeline = ''
    ;carl is messing with things here

    ; Get window image
    Img = OutPutWnd->Read()

    ; Get the actual buffer
    Img->GetProperty, Data=Buf; , /NO_COPY
    ;Buf = ROTATE (TEMPORARY(Buf), 7)
    YPercent = 1.0;   YPercent < 1.0   changed on March 2005 by Qixu to fixed the scale--
    y = (size(Buf))[2]
    dy = round(y * YPercent)

    ;WRITE_TIFF, FileName, Buf[*,0:dy-1], 1, RED=r, GREEN=g, BLUE=b
    write_png,filename, Buf[*,y-dy:*], r,g,b

    OBJ_DESTROY, Img

end




;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output Bit 2; set = display image Bit 4, set = display sizes
FUNCTION PrintROIs_HexTime, pStateInfo, accepted, frameData, OutPutFlags=OutPutFlags, objData=objData, confidence = confidence, criteria = criteria,time=time, sizeType=sizeType
(*pStateInfo).waittime = 0.5

print_time=((OutPutFlags AND 512)/512)   ; default=0 added by mo at August 6, 2010;  Print_Hextime=0 or 1.

;added these on Sept2. 2009  to show the three new Time stamp words of the CPI images  Htime and ArrivalT1 and ArrivalT2.
; added following lines.
;**********************************************************************************************
word1=strtrim(string(format='(Z4)',frameData.frameheader.Time),2)
word2=strtrim(string(format='(Z4)',frameData.frameheader.arrivalT1),2)
word3=strtrim(string(format='(Z4)',frameData.frameheader.arrivalT2),2)
if strlen(word1) eq 3 then word1='0'+word1
if strlen(word1) eq 2 then word1='00'+word1
if strlen(word1) eq 1 then word1='000'+word1

if strlen(word2) eq 3 then word2='0'+word2
if strlen(word2) eq 2 then word2='00'+word2
if strlen(word2) eq 1 then word2='000'+word2

if strlen(word3) eq 3 then word3='0'+word3
if strlen(word3) eq 2 then word3='00'+word3
if strlen(word3) eq 1 then word3='000'+word3

word1_a=strmid(word1,0,2)
word1_b=strmid(word1,2,2)
word2_a=strmid(word2,0,2)
word2_b=strmid(word2,2,2)
word3_a=strmid(word3,0,2)
word3_b=strmid(word3,2,2)
timeLsW=word1_a+word1_b
TimeIsW=word2_a+word2_b
TimeMSW=word3_a+word3_b


word4=strtrim(string(format='(Z4)',frameData.frameheader.Pheight1),2);  ; added on April 19.2010
word5=strtrim(string(format='(Z4)',frameData.frameheader.Pheight2),2)
if strlen(word4) eq 3 then word4='0'+word4
if strlen(word4) eq 2 then word4='00'+word4
if strlen(word4) eq 1 then word4='000'+word4

if strlen(word5) eq 3 then word5='0'+word5
if strlen(word5) eq 2 then word5='00'+word5
if strlen(word5) eq 1 then word5='000'+word5

;print, timeLSW
;print, word4
;print,word5
;stop

;*****************************************************************************
; Default is to send ouput to printer
if N_ELEMENTS(OutPutFlags) EQ 0 then OutPutFlags = 1
if OutPutFlags EQ 0 then OutPutFlags = 1
;loadct,1,/silent

pFrame = frameData.pFrame
; stop
set_min_max, pStateInfo  ; add this on march 21 to keep the color as in qui_lib.pro display image.

; How many ROIs?
if(keyword_set(objData))then ListLen = n_elements(*objData.pFrame) else ListLen = n_elements(*pFrame)

OutPut = OBJ_NEW()
OutPut2 = OBJ_NEW()
Palette = OBJ_NEW()

; Prepare fonts
if not obj_valid((*pStateInfo).PrintROI.Font1) then (*pStateInfo).PrintROI.Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', size=11)

; Get Page dimensions, if not already done
if((*pStateInfo).PrintROI.PageDX LT 100 OR (*pStateInfo).PrintROI.PageDY LT 100)then begin

    ; Get sizing from the printer info
    if(not obj_valid(OutPut))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255 ; change this to from 255 to 0 on march 17 2005
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
        OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)

    endif
    IF obj_valid(OutPut) THEN $
        OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res  ; I may change this to set instead of get.
    dims=[792,1024];      added by mo at March 21, 2005
    res= [0.025,0.025]
    (*pStateInfo).PrintROI.PageDX = Dims[0]
    (*pStateInfo).PrintROI.PageDY = Dims[1]

    ; Create new view
    if(not obj_valid((*pStateInfo).PrintROI.View))then begin

        ; create a view
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ;timetext2 added by mo on oct 29/2003
        (*pStateInfo).PrintROI.TimeText3 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)

        ; added following on April 19, 2010.
        (*pStateInfo).PrintROI.TimeText4 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText5 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)


        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
        endif

        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2 ;added by mo
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText3 ;added by mo  on sept2, 2009.
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText4 ;added by mo  on April19, 2010.
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText5 ;added by mo  on Aril119, 2010.
        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model

    endif

    ;set text dims in pixels
    TextDims = ([265, 33]*(0.00704861/Res[0]))*1.7    ; added by JS to enlarge font

    (*pStateInfo).PrintROI.LeftMargin = [TextDims[0], TextDims[1]]

    ; Want 40 pixs = 1 cm
    (*pStateInfo).PrintROI.PageZoom = 1/(Res[0]*40)

endif
;change zoom to integer on March 17, 2005.
zoom =1; (*pStateInfo).PrintROI.PageZoom*1.0;      (*pStateInfo).zoom  for png zoom=1.0
LeftMargin = ((*pStateInfo).PrintROI.LeftMargin)[0]*1.05*0.36;  added 0.36 by mo here =47.68
; Get scaling
WIDGET_CONTROL, (*pStateInfo).ScaleMinID, GET_VALUE=ScaleMin
WIDGET_CONTROL, (*pStateInfo).ScaleMaxID, GET_VALUE=ScaleMax

maxdy = (*pStateInfo).PrintROI.MaxDY
DateGap = 1.8 * ((*pStateInfo).PrintROI.LeftMargin)[1]
(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY > DateGap
Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

if(keyword_set(time))then begin
    month =(*Pstateinfo).Date.month; time.month
    day   =(*Pstateinfo).Date.day;   ; time.day
    hour  =time.hour
    minute=time.minute
    second=time.sec
    msec  =time.msec;   note that in here framedata's time by Htime, ArrivalT1,T2 is teh same as Time's time.


    if (month lt 10)then begin
        monthstring = string('0'+strtrim(month,2))
    endif else monthstring = strtrim(month,2)

    if (day lt 10)then begin
        daystring = string('0'+strtrim(day,2))
    endif else daystring = strtrim(day,2)

    if (hour lt 10) then begin
        hourstring = string('0'+strtrim(hour,2))
    endif else hourstring = strtrim(hour,2)

    if (minute lt 10) then begin
        minstring = string('0'+strtrim(minute,2))
    endif else minstring = strtrim(minute,2)

    if (second lt 10) then begin
        secstring = string('0'+strtrim(second,2))
    endif else secstring = strtrim(second,2)

    (*pStateInfo).printROI.timeline = monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+strtrim(msec,2)

    ; need to change these strings to be word1, word2, word3.  added septembe 2, 2009.
endif

if(ListLen GT 0 AND (*pStateInfo).PrintROI.PageY LE DateGap)then begin

    ; New Page? If so, we need a new view and model
    if not obj_valid((*pStateInfo).PrintROI.View) then begin
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ;Timetext2 added by moqixu
        (*pStateInfo).PrintROI.TimeText3 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        ; added following on April 19, 2010.
        (*pStateInfo).PrintROI.TimeText4 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText5 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)



        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2; added by moqixu
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText3; added by moqixu  on sept2, 2009.
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText4; added by moqixu
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText5; added by moqixu  on April, 2010.


        if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
            (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font1)
            (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
        endif
    endif

    ; Print-out date per page
    case 1 of
        (OutPutFlags And 8 )/ 8:begin
        if(sizeType eq 'max')then msg='Max Size,'
        if(sizeType eq 'mean')then msg='Mean Size,'
    end
    (OutPutFlags And 16)/16:  msg='Focus,'
    (OutPutFlags And 32)/32:  msg='CutOff,'
    (OutPutFlags And 64)/64:  msg='Roundness1,'
    (OutPutFlags And 128)/128:msg='Crystal,'
    else:                     msg = ''
endcase

if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
if(not keyword_set(criteria))then criteria = 'No criteria applied';criteria_test
; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
scale =''; '<----------->'+'200microns'

hhmmss_string=hourstring+minstring+secstring
Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
    (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
    LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
    FONT=(*pStateInfo).PrintROI.Font1)

if (*pStateInfo).PrintRoi.pageY le dateGap and (*pStateInfo).printRoi.pageX le leftmargin then begin
    (*pStateInfo).PrintROI.Model->Add, Text;   ;that mean if it is starting of a page, add the text to the top line.
    (*pStateInfo).PrintRoi.pageY=dateGap+1;    ; otherwise, not text is added to the top line.
endif;    ; do this just one time.  modify by mo on dec 8 2003 in first call pageX and pageY equal 0.

endif

PrintCount = 0

for i=0, ListLen-1 DO begin

    ;if(keyword_set(objData))then begin
    ; if(confidence[i] eq 10)then acceptflag = !true else acceptFlag = !false
    ;endif else begin
    ; acceptflag = !true
    ;;    ;Reject as artifact?
    ; if((*pStateInfo).Settings.ArtifactReject)then acceptflag = not ishft(((*pFrame)[i]).ImageHeader.flags,-14)
    ;endelse


    if(accepted[i])then begin

        ImgSize = size(*(*pFrame)[i].pROI)
        dx = zoom*(*pStateInfo).Settings.YXAspect*ImgSize[1] ;here YXaspect=1.00, zoom=2.95275
        dy = zoom*ImgSize[2]                                 ; it is very odd.--mo_March 17,2005.
        DispSize = [dx,dy]
        ; stop
        if(PrintCount EQ 0 AND Offset[0] NE LeftMargin)then Space4Time = 1.3*LeftMargin else Space4Time = 0

        ; Reached right margin?
        ;if(Offset[0] NE LeftMargin AND Offset[0] + dx + Space4Time GT (*pStateInfo).PrintROI.PageDX)then begin
        if(Offset[0] NE LeftMargin AND Offset[0] + dx GT (*pStateInfo).PrintROI.PageDX)then begin
            ;start a new line of images.
            Offset[0]=leftMargin; else offset[0] = LeftMargin  ;above line changed by mo to take off the space_for_time
            ;above is that if there are many images of the same time. other images will be put to leftest.
            Offset[1] =  Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400 + print_time*70; added +65 by mo
            ;(*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy + 2 +print_time*22; added +65 by mo
            (*pStateInfo).PrintROI.PageY = (*pStateInfo).PrintROI.PageY + maxdy + 76 +print_time*70; added +34 by Mo on sept2,2009
            maxdy = dy;                                        ; changed to 66 for txet4 and text5 ; becuase add a thrid line to lable Time.
        endif else maxdy = maxdy > dy

        ; Is there enough space left in the page?
        if((*pStateInfo).PrintROI.PageY GT DateGap AND (*pStateInfo).PrintROI.PageY + dy + 76 GT (*pStateInfo).PrintROI.PageDY)then begin
            ;added above 54 for time label.  of 5 lines
            ; Start new page
            if(not obj_valid(Palette))then begin
                ; Get current color table
                TVLCT, r, g, b, /GET
                r[0] = 0;255
                g[0] = 0;255
                b[0] = 0
                Palette = OBJ_NEW('IDLgrPalette', r, g, b)
            endif

            ;if requested, add the size model
            if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
                (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
            endif
            ;waittime = 2

            ; show the image if requested
            if((OutPutFlags AND 4)/4)then begin
                Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
                if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
                OutPut3->Draw, (*pStateInfo).PrintROI.View
                wait,(*pStateInfo).waittime
            endif

            ; Image to file?
            if((OutPutFlags AND 2)/2)then begin
                if(not obj_valid(OutPut2))then begin
                    Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
                    OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
                endif

                OutPut2->Draw, (*pStateInfo).PrintROI.View
                (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
                page_percent=1.0;FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
                ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
                ;stop
                SaveWndToFileHex, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
                ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
                ;added above 76 to proevent time label being chop off.
                ;stop
            endif

            ; Image to printer?
            if(OutPutFlags AND 1)then begin
                if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
                if not obj_valid(OutPut) then OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
                ;(*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
                ;if     (*pStateInfo).skipPage then begin
                ;  if PrintCount mod 10 eq 0 then print, "print page(skipping):", PrintCount    ;OutPut->Draw, (*pStateInfo).PrintROI.View
                ;endif else print, "print page:", PrintCount    ;OutPut->Draw, (*pStateInfo).PrintROI.View
                OutPut->Draw, (*pStateInfo).PrintROI.View
                OutPut->NewDocument
            endif

            ; Destroy current view
            OBJ_DESTROY, (*pStateInfo).PrintROI.View

            ; And create a new one
            (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
            (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
            (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
            (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)
            ;timetext2 added by moqixu
            (*pStateInfo).PrintROI.TimeText3 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)

            (*pStateInfo).PrintROI.TimeText4 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)

            (*pStateInfo).PrintROI.TimeText5 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font1,recompute_dimensions=0)







            if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
                (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
                (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font3)
                (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText
            endif

            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2   ;added by moqixu
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText3   ;added by moqixu

            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText4   ;added by moqixu
            (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText5   ;added by moqixu


            (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
            (*pStateInfo).PrintROI.PageX = LeftMargin

            ; Need a little room at the bottom for the date
            (*pStateInfo).PrintROI.PageY = DateGap
            Offset = [(*pStateInfo).PrintROI.PageX,(*pStateInfo).PrintROI.PageY]

            ; Print-out date per page
            case 1 of
                (OutPutFlags And 8 )/ 8:begin
                if(sizeType eq 'max')then msg='Max Size,'
                if(sizeType eq 'mean')then msg='Mean Size,'
            end
            (OutPutFlags And 16)/16:msg='Focus,'
            (OutPutFlags And 32)/32:msg='CutOff,'
            (OutPutFlags And 64)/64:msg='Roundness1,'
            (OutPutFlags And 128)/128:msg='Crystal,'
            else:                     msg = ''
        endcase

        if((*pstateinfo).acceptflag = !false) then criteria = 'No criteria applied'
        if(not keyword_set(criteria))then criteria = 'No criteria applied'
        ; scale = '<---------->'+strtrim(string(round(200.0/float((*pStateInfo).zoom))),2)+'microns'
        scale =''; '<----------->'+strtrim(string(round(200.0/float(1.0))),2)+'microns'

        hhmmss_string=hourstring+minstring+secstring
        Text = OBJ_NEW('IDLgrText', STRING(FORM='(I2,"/",I2,"/",I4,1x,a,"-",1x,a,x,a,x,a)',Month,day,$
            (*pStateInfo).FileHead.Year,hhmmss_string,msg,scale,criteria), $
            LOCATION=[2.0,(*pStateInfo).PrintROI.PageDY -0.75*DateGap], COLOR=[0,0,0],$   ;change 0 t 2.0
            FONT=(*pStateInfo).PrintROI.Font1)

        (*pStateInfo).PrintROI.Model->Add, Text
        (*pStateInfo).PrintROI.PageY=DateGap+1

        if obj_valid(output3) then obj_destroy,output3
    endif ; end enough space left ???

    ;the following line makes the filename a function of time rather than roiname.  The filename is :MMDD-HHMMSS_msec
    if ((*pStateInfo).printROI.pageno gt (*pStateInfo).printROI.oldpageno)then begin

        month = ((*pStateInfo).date.month)
        if (month lt 10)then begin
            monthstring = string('0'+strtrim(month,2))
        endif else monthstring = strtrim(month,2)

        if (minute lt 10) then begin
            minstring = string('0'+strtrim(minute,2))
        endif else minstring = strtrim(minute,2)

        if (hour lt 10) then begin
            hourstring = string('0'+strtrim(hour,2))
        endif else hourstring = strtrim(hour,2)

        day = ((*pStateInfo).date.day)
        oldhour = (*pStateInfo).printROI.oldhour

        if (hour lt oldhour) then begin
            (*pStateInfo).printROI.dayflag = (*pStateInfo).printROI.dayflag+1

        endif
        (*pStateInfo).printROI.oldhour = hour
        oldhour = hour
        day = day + (*pStateInfo).printROI.dayflag
        if (day lt 10)then begin
            daystring = string('0'+strtrim(day,2))
        endif else daystring = strtrim(day,2)

        if (second lt 10) then begin
            secstring = string('0'+strtrim(second,2))
        endif else secstring = strtrim(second,2)

        ;msecstring = strtrim(msec,2)
        if msec lt 10                 then  msecstring = string('00'+strtrim(msec,2))
        if msec ge 10 and msec lt 100 then  msecstring = string( '0'+strtrim(msec,2))
        if msec ge 100                then  msecstring = string(     strtrim(msec,2))
        (*pStateInfo).printROI.timeline = string(monthstring+daystring+'_'+hourstring+minstring+secstring+'_'+msecstring)

    endif
    (*pStateInfo).printROI.oldpageno = (*pStateInfo).printROI.pageno
    ; To print times, make times = 1.  To not print times, anything but 1
    ;print_time = 1
    if(print_time eq 1) then begin
        ;print, times_check
        if(PrintCount EQ 0 OR Offset[0] EQ LeftMargin)then begin
            ;;modified by mo on oct 29th 2003
            ;NewString = STRING(FORM='(I2,":",I2,":",I2,":",I3)', hour, minute, Second, msec); this goes between the ''
            NewString =  hourstring+':'+minstring;  STRING(FORM='(I2,":",I2,":")', hour, minute); this goes between the ''
            NewString2 = secstring+'.'+msecstring;  STRING(FORM='(I2,":",I3)', Second, msec);  added by mo for ss.mmm time line

            ;change this string to be word 1 and word 2 of new 3VCPI.
            ;***********************************************************************************
            NewString =timeLSW
            NewString2=TimeISW
            NewString3=TimeMSW
            NewString4=word4
            NewString5=word5


            ;***********************************************************************************


            (*pStateInfo).PrintROI.TimeText->GetProperty, STRINGS=Strings, LOCATIONS=TxtPos
            (*pStateInfo).PrintROI.TimeText2->GetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2
            (*pStateInfo).PrintROI.TimeText3->GetProperty, STRINGS=Strings3, LOCATIONS=TxtPos3
            (*pStateInfo).PrintROI.TimeText4->GetProperty, STRINGS=Strings4, LOCATIONS=TxtPos4
            (*pStateInfo).PrintROI.TimeText5->GetProperty, STRINGS=Strings5, LOCATIONS=TxtPos5

            if Offset[0] LE LeftMargin then Offset[0] =LeftMargin
            ;print, (*pStateInfo).printroi.timeline


            if((size(Strings[0]))[1] eq 7) then begin
                ;if Strings[0] NE -1 then begin
                TxtPos = [[TxtPos], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]]  ;added -0 by mo
                Strings = [Strings, NewString]
                (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=Strings, LOCATIONS=TxtPos,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText->SetProperty, STRINGS=NewString,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]+2]   ;added -0 by mo

            ;added another time line strings
            if((size(Strings[0]))[1] eq 7) then begin
                ;if Strings2[0] NE -1 then begin
                TxtPos2 = [[TxtPos2], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-15]]          ;added by mo
                Strings2 = [Strings2, NewString2]
                (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=Strings2, LOCATIONS=TxtPos2,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText2->SetProperty, STRINGS=NewString2,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-15]

            ;added another time line strings
            if((size(Strings[0]))[1] eq 7) then begin
                ;if Strings3[0] NE -1 then begin
                TxtPos3 = [[TxtPos3], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-32]]          ;added by mo
                Strings3 = [Strings3, NewString3]
                (*pStateInfo).PrintROI.TimeText3->SetProperty, STRINGS=Strings3, LOCATIONS=TxtPos3,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText3->SetProperty, STRINGS=NewString3,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-32]

            ;added another time line strings  for word 4
            if((size(Strings[0]))[1] eq 7) then begin
                ;if Strings4[0] NE -1 then begin
                TxtPos4 = [[TxtPos4], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-50]]          ;added by mo
                Strings4 = [Strings4, NewString4]
                (*pStateInfo).PrintROI.TimeText4->SetProperty, STRINGS=Strings4, LOCATIONS=TxtPos4,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText4->SetProperty, STRINGS=NewString4,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-50]

            ;added another time line strings  for word 5
            if((size(Strings[0]))[1] eq 7) then begin
                ;if Strings5[0] NE -1 then begin
                TxtPos5 = [[TxtPos5], [Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-68]]          ;added by mo
                Strings5 = [Strings5, NewString5]
                (*pStateInfo).PrintROI.TimeText5->SetProperty, STRINGS=Strings5, LOCATIONS=TxtPos5,recompute_dimensions=0
            endif else (*pStateInfo).PrintROI.TimeText5->SetProperty, STRINGS=NewString5,recompute_dimensions=0,$
                LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1]-dy-(*pStateInfo).PrintROI.LeftMargin[1]-68]
        endif   ;end of if offset[0] LE leftMarcgin
    endif   ; end of i PrintCount=0 or offset=LeftMargin


    if(ptr_valid((*pStateInfo).BackFrame))then begin
        pBackImg = (*(*pStateInfo).BackFrame).pBackImg
        backROI = (*pBackImg)[(*pFrame)[i].ImageHeader.sx:(*pFrame)[i].ImageHeader.ex,(*pFrame)[i].ImageHeader.sy:(*pFrame)[i].ImageHeader.ey]
        ; save this back into the data array
        temp = *(*pFrame)[i].pROI - fix(backROI)
        ; dimg = BYTSCL(temp, top=253) + 1B ;MIN=ScaleMin, MAX=ScaleMax,
        dimg = congrid(BYTSCL(temp,top=255),dispsize(0),dispsize(1),/interp) ; change above to this on March 17, 2005
    endif else dimg = congrid(BYTSCL(*(*pFrame)[i].pROI,top=255),dispsize(0),dispsize(1),/interp)
    ;stop;  here temp is array[56,61]

    ;if(keyword_set(objdata))then if((*objData.pFrame)[i].imageheader.confidence eq 0)then dimg[*,*] = 0

    image = OBJ_NEW('IDLgrImage', dimg, /NO_COPY, DIMENSIONS=DispSize, LOCATION=[Offset[0],$
        (*pStateInfo).PrintROI.PageDY -Offset[1] - dy,0], ORDER=1);,interpolate=1)

    (*pStateInfo).PrintROI.Model->Add, image

    if((OutPutFlags And 8)/8)then begin
        ;add size line
        (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=size_string, LOCATIONS=imgloc
        case sizeType of
            'mean':begin
            if(keyword_set(objdata))then begin
                mean_size = 2.0* sqrt((*objData.pFrame)[i].imageheader.area/!dpi) * (*pStateInfo).Settings.PixSize
            endif else begin
                mean_size = round(sqrt((*pFrame)[i].imageHeader.Wid * (*pFrame)[i].imageHeader.Len)* (*pStateInfo).Settings.PixSize )
            endelse

        end
        'max':begin
        if(keyword_set(objdata))then begin
            mean_size = max([(*objData.pFrame)[i].imageheader.len,(*objData.pFrame)[i].imageheader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
        endif else begin
            mean_size = max([(*pFrame)[i].imageHeader.Len,(*pFrame)[i].imageHeader.wid]) * (*pStateInfo).Settings.PixSize  ; microns
        endelse
    end
endcase

if(size_string[0] ne -1)then begin
    imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
    size_string = [size_string,strtrim(round(mean_size),2)]
    (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=size_string, LOCATIONS=imgloc
endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(mean_size),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 8

if((OutPutFlags And 16)/16)then begin
    ; add focus line
    if(keyword_set(objdata))then begin
        focusStr =strtrim(fix((*objdata.pFrame)[i].imageHeader.focus),2)
    endif else begin
        ;  out of focus is in imageheader.flags (bits 0-7 of flags)
        focusStr = strtrim((*pFrame)[i].imageHeader.Flags AND '00FF'X,2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    if(focus_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        focus_string = [focus_string,focusStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focus_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=focusStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;edn of if 16

if((OutPutFlags And 32)/32)then begin
    ; add cutoff line
    if(keyword_set(objdata))then begin
        cutoffStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.cutoff),2)
    endif else begin
        ; cutoff is in imageheader.dark ( bits 8 - 12)
        cutoffStr = strtrim(fix(100 * (ISHFT((*pFrame)[i].imageHeader.Dark,-8) AND '1F'X)/31.0),2)
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    if(cutoff_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        cutoff_string = [cutoff_string,cutoffStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoff_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=cutoffStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif ;end of if 32
if((OutPutFlags And 64)/64)then begin
    ; add roundness line
    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=round_string, LOCATIONS=imgloc
    if(round_string[0] ne -1)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        round_string = [round_string,strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2)]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=round_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=strtrim(round(100.*(*objdata.pFrame)[i].imageHeader.roundness1),2), LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 64

if((OutPutFlags And 128)/128)then begin
    ; add cyrstal type line
    if(keyword_set(objdata))then begin
        ; next line write number for crystal habit
        ;habitStr = strtrim(fix((*objdata.pFrame)[i].imageHeader.crystal),2)
        ; this line writes cytsal habit name
        habitStr = (*pStateInfo).crystalName[(*objdata.pFrame)[i].imageHeader.crystal]
    endif else begin
        ; crystal is in imageheader.flags (bits 8 - 12)
        ; next line write number for crystal habit
        ;habitStr = strtrim( (ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X),2)
        ; this line writes cytsal habit name
        habitStr =   (*pStateInfo).crystalName[(ISHFT( (*pFrame)[i].imageHeader.Flags, -8) AND '001F'X)]
    endelse

    (*pStateInfo).PrintROI.valueText->GetProperty, STRINGS=type_string, LOCATIONS=imgloc
    if(size(type_string, /TYPE) EQ 7)then begin
        imgloc=[[imgloc],[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]]
        type_string = [type_string,habitStr]
        (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=type_string, LOCATIONS=imgloc
    endif else (*pStateInfo).PrintROI.valueText->SetProperty, STRINGS=habitStr, LOCATIONS=[Offset[0], (*pStateInfo).PrintROI.PageDY - Offset[1] - dy,.5]
endif  ;end of if 128
;mo changed teh following two lines.   make enought space for writing the time label.
if dx gt leftmargin then Offset[0] = Offset[0] + dx + (*pStateInfo).PrintROI.PageDX/400
if dx lt leftmargin then Offset[0] = Offset[0] + leftmargin + (*pStateInfo).PrintROI.PageDX/400

PrintCount = PrintCount + 1
endif

ENDFOR ; bottom of loop for roi's

(*pStateInfo).PrintROI.PageX = Offset[0]

; Start a new line, if necessary
;if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT 2*LeftMargin)then begin
if((*pStateInfo).PrintROI.PageDX - (*pStateInfo).PrintROI.PageX LT LeftMargin)then begin  ;changed to 0.2 by mo
    (*pStateInfo).PrintROI.PageX = LeftMargin
    ;(*pStateInfo).PrintROI.PageY = Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400+print_time*22; add +65 by mo
    (*pStateInfo).PrintROI.PageY = Offset[1] + maxdy + (*pStateInfo).PrintROI.PageDY/400+print_time*70 +76; added 24 on sept2, 2009.

endif

; Start new page when needed
; Is there enough space left in the page?
if((*pStateInfo).PrintROI.PageY +22 GT 0.95*(*pStateInfo).PrintROI.PageDY)then begin
    ;added above 76 for time label

    ; Start new page
    ;  (*pStateInfo).PrintROI.PageX=leftmargin

    if(not obj_valid(Palette))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255
        g[0] = 0; 255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    endif

    ;if requested, add the size model
    if((OutPutFlags And 8)/8 or (OutPutFlags And 16)/16 or (OutPutFlags And 32)/32 or (OutPutFlags And 64)/64 or (OutPutFlags And 128)/128)then begin
        (*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
    endif

    ;***************************************************************************************************

    ; show the image if requested
    if((OutPutFlags AND 4)/4)then begin
        Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
        if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
        OutPut3->Draw, (*pStateInfo).PrintROI.View
        wait,(*pStateInfo).waittime
        ;added by mo to save image in png file for high resolution
    endif

    ; Image to file?
    if((OutPutFlags AND 2)/2)then begin
        if not obj_valid(OutPut2) then begin
            Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
            OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
            ; OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[760*Aspect,760], COLOR_MODEL=1, PALETTE=Palette)
        endif

        OutPut2->Draw, (*pStateInfo).PrintROI.View
        (*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
        page_percent=1.0; FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
        ; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
        ;stop
        SaveWndToFileHex, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo
        ;added above 76 to proevent time label being chop off.
        ;stop

    endif

    ; Image to printer?
    if((OutPutFlags AND 1))then begin
        if(not (*pStateInfo).PrintROI.printer)then IF(DIALOG_PRINTERSETUP()) THEN (*pStateInfo).PrintROI.printer = !true
        if not obj_valid(OutPut) then OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
        ;(*pStateInfo).PrintROI.View->add,(*pStateInfo).PrintROI.Model1
        OutPut->Draw, (*pStateInfo).PrintROI.View
        OutPut->NewDocument
    endif

    ; Destroy current view
    OBJ_DESTROY, (*pStateInfo).PrintROI.View
    (*pStateInfo).PrintROI.View = OBJ_NEW()
    (*pStateInfo).PrintROI.Model = OBJ_NEW()

    (*pStateInfo).PrintROI.PageX = LeftMargin
    (*pStateInfo).PrintROI.PageY = DateGap

endif

; Remember maxdy if we didn't start a new line
if((*pStateInfo).PrintROI.PageX GT LeftMargin)then (*pStateInfo).PrintROI.MaxDY = maxdy else (*pStateInfo).PrintROI.MaxDY = 0

; Clean up objects
if(obj_valid(OutPut) )then OBJ_DESTROY, OutPut
if(obj_valid(OutPut2))then OBJ_DESTROY, OutPut2
if(obj_valid(Palette))then OBJ_DESTROY, Palette
if(obj_valid(output3))then obj_destroy,output3
;if(obj_valid(text))then obj_destroy,text
;if(obj_valid(type))then obj_destroy,type

RETURN, 0
end  ; end of Printrois_HexTime_function

;*******************************************************



pro make_cpi_size_scale, image=image, scale_length=scale_length, endbar_length=endbar_length, $
    microns_per_pixel=microns_per_pixel, background_color=background_color, bar_color=bar_color, $
    draw_vertical=draw_vertical

; define the dimensions of the scale image
xsize = 115
ysize = 25

; scale length to display in microns
if(not keyword_set(scale_length)) then begin
    scale_length = 200
endif

; height of the end bars on the scale bar
if(not keyword_set(endbar_length)) then begin
    endbar_length = 6 ; length (height) of the end bars for the length scale
endif

if(not keyword_set(microns_per_pixel)) then begin
    ; make sure the microns per pixel system variable is defined
    defsysv, '!CONST_CPI_MICRONS_PER_PIXEL', exists=exists

    if(~exists) then begin
        defsysv, '!CONST_CPI_MICRONS_PER_PIXEL', 2.2 ; microns per pixel
    endif

    microns_per_pixel = !CONST_CPI_MICRONS_PER_PIXEL
endif

if(not keyword_set(background_color)) then begin
    background_color = 255 ; white using color table 39
endif

if(not keyword_set(bar_color)) then begin
    bar_color =   0 ; black using color table 39
endif

if(not keyword_set(draw_vertical)) then begin
    draw_vertical = 0
endif


xcenter = floor(xsize/2.)
ycenter = floor(ysize/2.)


; determine the length of the scale bar in pixels and calculate end points in image
bar_length = fix(scale_length / microns_per_pixel)

left_end_pix = fix((xsize - bar_length) / 2.)
right_end_pix = left_end_pix + bar_length

; determine the length of the endbars in pixels and calculate end points in image
barlo = fix((ysize - endbar_length) / 2.)
barhi = barlo + endbar_length


; draw the scale bar in the image
image = bytarr(xsize, ysize)

image[*] = background_color

image[left_end_pix:right_end_pix, ycenter] = bar_color

image[ left_end_pix, barlo:barhi] = bar_color
image[right_end_pix, barlo:barhi] = bar_color

; draw the minor scale center ticks
image[xcenter,barlo+1:barhi-1]  =bar_color

; draw the 50um tick.
left50_pix = left_end_pix + bar_length/4
right50pix = left50_pix   + bar_length/2
image[left50_pix,barlo+1:barhi-1]  =bar_color
image[right50pix,barlo+1:barhi-1]  =bar_color


if(draw_vertical) then begin
    image = transpose(image)
endif
end ; make_cpi_size_scale
