

FUNCTION process_3vcpi_spectral_only, pStateInfo, volume = volume
; Purpose To accumulate the sizes of particles into CPI bins
; this routines assumes that an obj header exists


Forward_function find_first_link

;make sure an obj file is exist, then people can continue process time series
my_message=['No obj file is found,please use EXTRACTION TOOLS to make an obj file first,then you can continue.']
if (*pstateInfo).objlun eq -1 then begin
    abcdefgh=dialog_message(my_message)
    return,0
endif
;**********************************************************************************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

;imgList = (*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]
; Note: badframes have a time stamp that is wrong. It was not monotonically increasing
imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0) ;  and not (*(*pStateInfo).pFileScan).badframe)
imgList = (*(*pStateInfo).pFileScan)[imgListIndx]


firstPass = !true
newInt = !false
timeflag=0

if((*pLink).spectra)then begin ; flag from GUI
    ; initialize for histogram
    groupCnt = 1
    partCnt = 0
    intMax = 40   ; initial size of array

    (*pStateInfo).spectra.pGroup = ptr_new({groupLink})
    pGroup = (*pStateInfo).spectra.pGroup
    ;print,'Group #',groupCnt, ' pointer#',pGroup
    (*pGroup).pData = ptr_new(fltarr(intMax))
    (*pgroup).pAdj  = ptr_new(fltarr(intMax)) ;  added august 24, 2004.
    (*pGroup).pDataA = ptr_new(fltarr(intMax))
    (*pGroup).pDataM = ptr_new(fltarr(intMax))
    (*pGroup).pDataH = ptr_new(fltarr(intMax))
    spectra=!true
    SumInt = (*pLink).SumInt
    roiFrmCnt = 0L
    TotFrmCnt = 0L
    totImgPart = 0L
    acceptPart = 0L
    nonRejPart = 0L
    spectTotSav2 = 0L
    earlier_frdeadtime=0.0D ;added sept 24.0
    fcs_max=0.0;   added august 24, 2004
    meanlenarr_sav=0.0; added august 24, 2004.
    meanadjarr_sav=0.0
    meanAcorarr_sav=0.0
    meanMcorarr_sav=0.0
    meanHcorarr_sav=0.0;    Dec 7 2004 ---moqixu
    spec_accumpartcnt_mo=0.0
    spec_particle_cnt_msav=0.0

    wmeanLenarr=0.0; added october 7, 2004
    wmeanAcorarr=0.0; added october 7, 2004
    wmeanMcorarr=0.0; added october 7, 2004
    wmeanHcorarr=0.0; added Dec 7, 2004
    wmeanadjarr=0.0; added october 7, 2004

    dmeanLenarr=0.0; added october 7, 2004
    dmeanAcorarr=0.0; added october 7, 2004
    dmeanMcorarr=0.0; added october 7, 2004
    dmeanadjarr=0.0; added october 7, 2004

endif ; end of if spectra

if (*plink).condspectra then begin
    Zfrmcont=0;    added oct 25 for condictional spectra.
    Dvect =fltarr(1);   its size will increase as particles is added more and more
    Wvect =fltarr(1)
    Nvect =fltarr(1);   its size will increase as particles is added more and more
    cond_wmeanlenarr=0.0
    cond_wmeanadjarr=0.0
    (*plink).addfssp2dc=!false
endif

output = !false

; get the first frame based on start time from GUI
start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)

StartFrm = GetFrameByTime_3VCPI(pStateInfo,start_time,/absolute, type='start')
StopFrm = GetFrameByTime_3VCPI(pStateInfo,stop_time,/absolute, type='start')


; loop through the frames
imgFrmCt = 0L
tComplete = !false
spectraComplete = !false
spectraAccept = !false
TlastFrameSec = 0UL
SlastFrameSec = 0UL
SlastFrameSec2 = 0UL
objheader_start = 0UL

current_file = (*pStateInfo).infilename
first_file = (*pStateInfo).infilename

; following line added by mo sept 17, 2004.
frametime_mooo=imglist.htime+imglist.msec/1000.0; ;all frame times; more than those in *combined.csv
frametime_moooR=floor(frametime_mooo)

for frame = StartFrm, StopFrm do begin

    ; skip bad frames
    if(not imgList[frame].badframe)then begin
        ; track frames for spectra
        ; must read the image data if any roi display or output is required
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

        imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )


        if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

            ;if(frame eq startFrm)then print,'Actual Start Frame time =',framedata.frameheader.time
            ;if(frame eq stopFrm)then print,'Actual Stop Frame time =',framedata.frameheader.time

            frameTime = frameData.FrameHeader.time

            time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ; change to 4/19/19:20:00.00 format.
            ; time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))
            ; added this Part on August 6, 2010 by mooooooooooooo
            time.month=((*pStateInfo).date.month);  added this on August, 2014.
            Time.day   =framedata.FrameHeader.day
            Time.hour  =framedata.FrameHeader.hour
            Time.minute=framedata.FrameHeader.minute
            Time.sec   =framedata.FrameHeader.sec
            Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.

            ; time of frame in seconds
            ; frameTime = frameTime + time.msec/1000.0D
            ; frameTime = Time.hour*3600.0 + time.minute*60.0 + time.sec + time.msec/1000.0D;  Changed to this August 6, 2010
            ; time of frame in seconds
            frameTime = frameTime + time.msec/1000.0D

            ; ROIArray is an array of pointers for each particle in the frame
            pROIArray = FrameData.pFrame

            ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
            if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
                getObjData,pStateInfo,framedata,pROIArray,imgFrmCt,objData


            if(imgFrame)then imgFrmCt = imgFrmCt + 1

            ; How many ROIs?
            if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0
            if(imgframe)then if( n_imgs gt n_elements(*pROIArray))then print,'Error, obj data out of sync with frame'

            if(FirstPass)then begin
                DoFirstPass_Psd,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
                    Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup
                firstPass = !false
            endif

            ; create array for tracking confidence
            if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

            if(n_imgs gt 0)then begin
                meanLenArr = fltarr(n_imgs)
                mnSizes = fltarr(n_imgs)
                mxSizes = fltarr(n_imgs)
                ; create accepted array for min file output
                accepted = bytarr(n_imgs)
            endif
            acceptedParticles = 0L
            nonRejectCnt = 0L
            AllReject = !true

            ; loop through all the particles in the frame and accumulate into the histogram array by size
            FOR ROINum=0, n_imgs-1 DO begin

                acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness,focus,focusMin,$
                    focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)

                ;help,*(*(*pStateInfo).ptimeInfo).pcurrent_link,/struct
                if  (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit ge 1 and acceptFlag then begin
                    ; Update new habit number into our OBJ data structure
                    (*pROIArray)[ROINum].imageHeader.crystal = (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit
                    ; write new habit number to obj file
                    update_obj_header, (*pStateInfo).ObjLUN,(*(objdata).pimhdfpos)[ROINum], "crystal", (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit

                endif


                if(acceptFlag eq -1)then return,0 ; bail on error

                if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

                if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1

                ; Need to handle skipping of seconds here Not sure if this is not already being done!
                if(acceptFlag)then begin

                    ; mark roi image as accepted
                    accepted[roiNum] = !true

                    if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                    acceptedParticles = acceptedParticles + 1

                    ; check each processing option for this time period
                    ;if((*pLink).spectra)then begin
                    if((*plink).Hmissed or (*pLink).Hwysiwyg) then begin
                        makeSpectValues, pROIArray, pStateInfo, pLink, ROINum, frameData.frameheader.ver,$
                            spectraAccept, meanLenArr,meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,$
                            spec_particle_cnt_msav,meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav,$
                            wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;;for wysisyg_r all particles. Octoner7, 2004
                            dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; for wysisyg_com particles. Octoner7, 2004
                            meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.
                    endif

                    if ((*plink).condspectra) then begin
                        make_cond_SpectValues, pROIArray, pStateInfo, pLink, ROINum, ver,cond_wmeanLenArr,cond_wmeanadjarr
                    endif;    added on oct 25 2004.
                endif


            endFOR ; end of roi loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

            ;**********************oct 23 2004 add this block for condition spectro calculations.
            ;see pro sum_condtional_spectra_values
            ;************************************************************************************

            framesec = ulong(frametime)

            ; accumulate spectral data
            if ((*plink).Hmissed or (*pLink).Hwysiwyg) then begin
                if(frameTime lt IntEnd)then begin

                    SumSpectraValues,acceptedParticles, meanLenArr, n_imgs, FrameData.frameheader.Missed, nonRejectCnt, acceptedParticles, $
                        imgList[frame].Deadtime, partCnt, intMax, pGroup, roiFrmCnt, TotFrmCnt, $
                        SlastFrameSec, frameSec, totImgPart,acceptPart,nonRejPart,spectTotSav2,meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,$
                        spec_accumpartcnt_mo,spec_particle_cnt_msav,meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav, $
                        wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;;for wysisyg_r all particles. Octoner7, 2004
                        dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; for wysisyg_com particles. Octoner7, 2004
                        meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.
                endif else begin

                    ; get the correct deadtime for the first time interval

                    Tspec=(*pLink).SumInt
                    if frametime-Tspec gt start_time and frametime-(1.0+Tspec) lt start_time then begin
                        index_mmm=where(frametime_mooo ge start_time-1.0+Tspec and frametime_mooo lt start_time+Tspec,cntmo)
                        if cntmo gt 0 then begin
                            imglist_frame_deadtime=imglist[index_mmm(0)].deadtime
                            earlier_frdeadtime=imglist_frame_deadTime
                        endif else imglist_frame_deadtime=imglist[frame].deadtime
                    endif; end of if frametime-Tspec gt start_time and frametime-(1.0+Tspec) lt start_time then begin
                    timeA=floor(frametime-Tspec-1.0)
                    timeB=ceil(frametime-2.0);  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second
                    get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new
                    (*pgroup).deadtime=deadtime_new

                    ; finish current group
                    finishSpectra,spectraAccept, roiFrmCnt, totImgPart, nonRejPart, acceptPart, TotFrmCnt, partCnt, spectTotSav2,$
                        spec_accumpartcnt_mo, pGroup, groupCnt
                    ;frameI_cont,Dcormatrix,ADj_matrix; added this part for conditional spectra

                    ; determine if there are time gaps to fill
                    if((ceil(frametime)-intEnd) gt (*pLink).SumInt)then begin
                        ; skipped intervals
                        ;determine how many intervals were skipped, create empty groups with the correct times
                        PadFrmCnt = (ceil(frametime)-intEnd)/(*pLink).SumInt
                        PadSpectralGroups,PadFrmCnt,pGroup,groupCnt,(*pLink).SumInt
                        intEnd = intEnd + PadFrmCnt * (*pLink).SumInt
                    endif
                    if frametime gt start_time+1.0+Tspec then imglist_frame_deadtime=imglist[frame].deadtime; ;added sept4, 2004

                    ;InitSpectraGroup,frameTime, TotFrmCnt, n_imgs, meanLenArr, imgList[frame].deadtime, nonRejectCnt, $
                    InitSpectraGroup,frameTime, TotFrmCnt, n_imgs, meanLenArr, imgList_frame_deadtime, nonRejectCnt, $
                        frameData.frameheader.missed, pLink, acceptedParticles, pGroup, intMax, roiFrmCnt, totImgPart, $
                        acceptPart, spectraAccept, SlastFrameSec,spec_accumpartcnt_mo,partCnt, IntEnd ,spectTotSav2,nonRejPart,$
                        meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,earlier_frdeadtime,spec_particle_cnt_msav,$
                        meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav,$
                        wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;;for wysisyg_r all particles. Octoner7, 2004
                        dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; for wysisyg_com particles. Octoner7, 2004
                        meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.
                endelse
            endif ; end of if (*plink).spectra Spectra processing

            if ((*plink).condspectra) then begin  ;added this part on oct 25 , 2004
                if(frameTime lt IntEnd)then begin
                    sum_conditional_Spectra_values,n_imgs,cond_wMeanLenarr,cond_wmeanAdjarr,Pgroup,Zfrmcont,Dvect,Wvect,Nvect
                endif else begin
                    finish_cond_Spectra,pGroup, groupCnt
                    Init_cond_SpectraGroup,frameTime, n_imgs, pLink, pGroup, SlastFrameSec,$
                        IntEnd, cond_wmeanLenarr,cond_wmeanAdjarr,Zfrmcont,Dvect,Wvect,Nvect
                endelse
            endif;    added on oct 25 2004.

            if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
            if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData

        endif ; end of IF for valid frameData

    endif ; end of good frame condition

endfor   ; end of Frame loop

; let this time period be displayed!
(*pLink).process = !true

skip:

; complete all calculations
if(spectra)then begin
    ;**************added by mo on september 16, 2004  -----
    ; frametime_mooo=double(imglist.htime)+double(imglist.msec/1000.0);    This is all of the frame time in combines.csv file.
    timeA=floor(frametime-(*pLink).SumInt-1.0)+1LL
    timeB=ceil(frametime-2.0)+1LL;  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second
    get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new
    (*pgroup).deadtime=deadtime_new
    ;************************************************************************

    ;**************************************************************************
    ;print,frame,floor(frametime)-start_time,intend-start_time
    ; finish current group
    finishSpectra,spectraAccept, roiFrmCnt, totImgPart, nonRejPart, acceptPart, TotFrmCnt, partCnt,$
        spectTotSav2,spec_accumpartcnt_mo, pGroup, groupCnt

    ; determine if there are time gaps to fill
    if((stop_time-intEnd) gt SumInt)then begin
        ; skipped intervals
        ;determine how many intervals were skipped, create empty groups with the correct times
        PadFrmCnt = (stop_time-intEnd)/SumInt - 1
        PadSpectralGroups,PadFrmCnt,pGroup,groupCnt,SumInt
        ; set start of current time group
        (*pGroup).startTime = (*(*pGroup).prev_link).startTime + SumInt
        (*pStateInfo).spectra.groupCnt = groupCnt
        stop
    endif else begin

        if(not spectraComplete)then begin
            pPrevGroup = (*pGroup).prev_link
            if(ptr_valid(pPrevGroup))then begin
                ; remove an incomplete group
                (*pPrevGroup).next_link = ptr_new()
                deleteGroup,pGroup
                groupCnt = groupCnt-1
                pGroup = pPrevGroup
            endif
        endif

        pPrevGroup = (*pGroup).prev_link
        if(ptr_valid(pPrevGroup))then begin
            ; remove the last group
            (*pPrevGroup).next_link = ptr_new()
            deleteGroup,pGroup
            ;update spectra info
            (*pStateInfo).spectra.groupCnt = groupCnt-1
        endif else begin
            ; no valid data at all
            (*pStateInfo).spectra.groupCnt = 0
            deleteGroup,pGroup
        endelse
    endelse

endif   ;end of if(spectra) the begin

heap_gc
return,1

end;   end of function  process_time_series
;*************************************************
