FUNCTION Process_N_timeSeries_only, pStateInfo, volume = volume
; Purpose To accumulate the sizes of particles into CPI bins
; this routines assumes that an obj header exists


Forward_function find_first_link

;make sure an obj file is exist, then people can continue process time series
my_message=['No obj file is found,please use EXTRACTION TOOLS to make an obj file first,then you can continue.']
if (*pstateInfo).objlun eq -1 then begin
    abcdefgh=dialog_message(my_message)
    return,0
endif

;**********************************************************************************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)

imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
imgList = (*(*pStateInfo).pFileScan)[imgListIndx]

firstPass = !true
newInt = !false
spectra=!false

timeFlag = !false
if( (*pLink).time)then begin
    ; count requested plots
    numPlots = 0
    tOperation = bytarr(18)

    for i = 0,17 do begin
        if((*pLink).(i))then begin
            tOperation[i] = !true;(*pLink).(i)
            numPlots = numPlots + 1   ; number of plot. Maximum is 17, 17 curves of time series.
        endif
    endfor

    if(numPlots gt 0)then begin
        ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
        ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

        ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
        SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1)  ; Liters/sec
        ;it only stop here one time.  and tas is 10.00m/s of user defined value in here.

        tGroupCnt = 200
        timePlot = dblarr(numPlots,tGroupCnt) ;+ !values.f_nan  200 points, can be 200 seconds of time.

        ;assigned those radar values to be -99.0
        ;****************************************************************
        mooo_plots=0
        for i = 0,17 do begin
            if((*pLink).(i))then begin
                tOperation[i] = !true;(*pLink).(i)
                mooo_Plots = mooo_Plots + 1
                if(((*pLink).(i)) eq (*plink).Tmean) and (*plink).Tmean then timeplot(mooo_plots-1,*)=-99.0
                if(((*pLink).(i)) eq (*plink).Tpaul) and (*plink).Tpaul then timeplot(mooo_plots-1,*)=-99.0
                if(((*pLink).(i)) eq (*plink).tRate3) and (*plink).tRate3 then timeplot(mooo_plots-1,*)=-99.0
            endif
        endfor     ; thsi has to be in the finishgroup also.
        ;******************************************************************
        tGroup = 0
        plotNum = 0
        timeFlag = (*pLink).time

        ; init accumulators
        totSav = 0L
        totSav2 = 0L
        totSav3 = 0L
        totFrm = 0L
        missed = 0L
        AccumConc = 0L
        AccumCubicSize = 0.0D
        AccumMass = 0.0D
        accumAcor_area=0.0D; added by mo July 27, 2004
        Accumsphmass=0.0D;   added by mo August18/04
        Accumicemass=0.0D

        ParticleCnt = 0L
        deadtime = 0.0D
        earlier_frdeadtime=0.0D;  added by mo 8/8/04 asumme first interval, frdeadtime=0.0
        TMean = 0.0D
        TmeanCnt = 0L
        TMax = 0.0D
        AccMeanLen = 0.0D

        maxLength = 0.0D
        max_to_Save = 0.0D
        allParticles = 0UL
        ParticleCntPerInterval = 0L
        specialCase = !false
        newROI = !true

        AccMaxLen = 0.0D
        cubicSize = 0.0D
        mass = 0.0D
        Acor_area=0.0;  added by mo July 27 2004.
        Acor_area_sav=0.0;  added by mo August 4, 2004.
        accumpartcnt_mo=0.0
        particle_cnt_msav=0.0
        sphmass_sav=0.0D;  added August 18/04.
        icemass_sav=0.0D

        ; added this for wysiwyg
        Waccumpartcnt_mo=0.0
        WaccumAcor_area=0.0D
        WAccumsphmass=0.0D
        WAccumicemass=0.0D
        WAcor_area_sav=0.0;  added by mo oct11, 2004.
        Wparticle_cnt_msav=0.0
        Wsphmass_sav=0.0D;  added oct11/04.
        Wicemass_sav=0.0D

        AccumradarvolD6I=0.0
        radarvolD6_savI =0.0
        WAccumradarvolD6I=0.0
        WradarvolD6_savI=0.0 ; added oct 22 for dBz
        AccumradarvolD6L=0.0
        radarvolD6_savL =0.0
        WAccumradarvolD6L=0.0
        WradarvolD6_savL=0.0 ; added oct 22 for dBz

        fcs_max=0.0
        ImgMean = 0L
    endif else (*pLink).time = !false

endif   ; end of if( (*pLink).time)

; get the first frame based on start time from GUI

start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year); that is seconds since begining of the year  !!!!
stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)

StartFrm = GetFrameByTime_3VCPI(pStateInfo,start_time,/absolute, type='start')
StopFrm = GetFrameByTime_3VCPI(pStateInfo,stop_time,/absolute,   type='stop')

; loop through the frames
imgFrmCt = 0L
tComplete = !false
TlastFrameSec = 0UL
SlastFrameSec = 0UL
SlastFrameSec2 = 0UL
objheader_start = 0UL

current_file = (*pStateInfo).infilename
first_file = (*pStateInfo).infilename

frametime_mooo=imglist.htime+imglist.msec/1000.0; ;all frame times; more than those in *combined.csv
frametime_moooR=floor(frametime_mooo)

for frame = StartFrm, StopFrm-1LL do begin

    ; skip bad frames
    if(not imgList[frame].badframe)then begin
        ; must read the image data if any roi display or output is required
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

        imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )

        if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

            frameTime = frameData.FrameHeader.time; this time is wrong.

            time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ; change to 4/19/19:20:00.00 format.
            ;time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))
            time.month=((*pStateInfo).date.month);  added this on August, 2014.
            Time.day   =framedata.FrameHeader.day
            Time.hour  =framedata.FrameHeader.hour
            Time.minute=framedata.FrameHeader.minute
            Time.sec   =framedata.FrameHeader.sec
            Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
            ; time of frame in seconds
            ; frameTime = frameTime + time.msec/1000.0D
            frameTime= convertToseconds(Time,(*pStateInfo).FileHead.year); that is seconds since begining of the year  !!!!
            ;frameTime = Time.hour*3600.0 + Time.minute*60.0 + time.sec; + time.msec/1000.0D;  Changed to this August 6, 2010

            ; ROIArray is an array of pointers for each particle in the frame
            pROIArray = FrameData.pFrame

            ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
            if (imgframe and ptr_valid((*pStateInfo).pObjList)) then  getObjData,pStateInfo,framedata,pROIArray,imgFrmCt,objData
            if(imgFrame)then imgFrmCt = imgFrmCt + 1

            ; How many ROIs?
            if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0

            if(imgframe)then if( n_imgs gt n_elements(*pROIArray))then print,'Error, obj data out of sync with frame'

            if(FirstPass)then begin
                DoFirstPass_time,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
                    Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup
                firstPass = !false
            endif

            if(frame eq startFrm and (*pLink).time)then begin
                (*pLink).timeStr =strtrim(fix((*pLink).start.hour),2) + ':' + strtrim(fix((*pLink).start.minute),2) + ':'+  strtrim(fix((*pLink).start.sec),2); + ':'+  strtrim(fix(time.msec),2)
                if(ceil(frameTime) - avgIntEnd gt SumSecs)then tgroup = (ceil(frameTime) - avgIntEnd)/SumSecs
                deadtime0=0.0
            endif

            ; create array for tracking confidence
            if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

            if(n_imgs gt 0)then begin
                meanLenArr = fltarr(n_imgs)
                mnSizes = fltarr(n_imgs)
                mxSizes = fltarr(n_imgs)
                ; create accepted array for min file output
                accepted = bytarr(n_imgs)
            endif

            acceptedParticles = 0L
            nonRejectCnt = 0L
            AllReject = !true

            ; loop through all the particles in the frame and accumulate into the histogram array by size
            FOR ROINum=0, n_imgs-1 DO begin

                acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness,focus,focusMin,$
                    focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)

                if  (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit ge 1 and acceptFlag then begin
                    ; Update new habit number into our OBJ data structure
                    (*pROIArray)[ROINum].imageHeader.crystal = (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit
                    ; write new habit number to obj file
                    update_obj_header, (*pStateInfo).ObjLUN,(*(objdata).pimhdfpos)[ROINum], "crystal", (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit
                endif


                if(acceptFlag eq -1)then return,0 ; bail on error

                if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

                if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1


                ; Need to handle skipping of seconds here Not sure if this is not already being done!
                if(acceptFlag)then begin

                    ; mark roi image as accepted
                    accepted[roiNum] = !true

                    if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                    acceptedParticles = acceptedParticles + 1


                    if((*pLink).time) then begin

                        doTimeSums, pLink,pROIArray, pStateInfo, frameTime, avgIntEnd, crystal, $
                            frameData.FrameHeader.ver, roiNum, max_to_Save, newROI, specialCase, $
                            ParticleCntPerInterval, MaxLength, AccmeanLen, AccmaxLen, cubicSize, mass, $
                            ParticleCnt,Acor_area,Acor_area_sav,fcs_max,particle_cnt_msav,$
                            sphmass_sav,icemass_sav,$;before sept, 2004
                            WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
                            radarvolD6_savI,wradarvolD6_savI,radarvolD6_savL,wradarvolD6_savL; added this for radar dbz time serices.

                    endif

                endif ; end of acceptFlag block


            endFOR ; end of roiNUm loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

            ;**********************oct 23 2004 add this block for condition spectro calculations.

            framesec = ulong(frametime)


            ; accumulate time series data
            if( (*pLink).time)then begin

                if(frameTime lt AvgIntEnd)then begin
                    SumTimeValues, n_imgs, acceptedParticles, AllReject,nonRejectCnt, Framedata.frameheader.Missed, frameSec, imglist[frame], imgMean,$
                        frameData.frameHeader.ImgMean,crystal, totSav,totSav2,totSav3,totFrm,allParticles,missed,AccumConc,ParticleCnt,$
                        AccumCubicSize, cubicSize,AccumMass, mass, TlastFrameSec, deadtime, tMean, AccMeanLen,$
                        TmeanCnt,Tmax,AccMaxLen,Acor_area,Acor_area_sav, AccumAcor_area,fcs_max,accumpartcnt_mo,particle_cnt_msav,$
                        Accumsphmass,sphmass_sav,Accumicemass,icemass_sav,$;   this line added August 18/04
                        WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
                        WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
                        AccumradarvolD6I,radarvolD6_savI,WaccumradarvolD6I,WradarvolD6_savI,$; added oct 21 2004.
                        AccumradarvolD6L,radarvolD6_savL,WaccumradarvolD6L,WradarvolD6_savL; added oct 21 2004.
                endif else begin
                    ; get the correct deadtime for the first time interval  note that there is 1second different
                    ; in the do_aloneTime and combined.csv time offset.   use (1.0+sumsecs) instead of 2.0*sumsecs
                    if frametime-sumsecs gt start_time and frametime-(1.0+sumsecs) lt start_time then begin
                        index_mmm=where(frametime_mooo ge start_time-1.0+Sumsecs and frametime_mooo lt start_time+sumsecs,cntmo)
                        if cntmo gt 0 then begin
                            imglist_frame_deadtime=imglist[index_mmm(0)].deadtime
                            earlier_frdeadtime=imglist_frame_deadTime
                        endif else imglist_frame_deadtime=imglist[frame].deadtime
                    endif;endof if frametime-sumsecs gt start_time and frametime-(1.0+sumsecs) lt start_time then begin

                    ; use subroutine to get the deadtime_new

                    timeA=floor(frametime-sumsecs-1.0)
                    timeB=ceil(frametime-2.0);  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second
                    get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new
                    deadtime=deadtime_new

                    ; interval complete find start a new interval
                    FinishTimeGroup,frameTime, AvgIntEnd, SumSecs, numPlots, missed, SampleVolume, AccumConc, $
                        acceptedParticles, pLink, deadtime, totFrm, tMeanCnt, Tmax, tgroup, AccumCubicSize, AccumMass,AccumAcor_area, $
                        accumpartcnt_mo, Tmean,totsav, totsav2, totsav3, ImgMean, accumsphmass,accumicemass, indexStep, timePlot, $
                        tGroupCnt, allParticles, tstep, $
                        ParticleCntPerInterval, specialCase, max_to_save,MaxLength ,nonRejectCnt,$
                        WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
                        AccumradarvolD6I,WAccumradarvolD6I,AccumradarvolD6L,WAccumradarvolD6L; added oct 22 2004.
                    ;print,'finished time group #',tgroup

                    if frametime gt start_time+1.0+sumsecs then imglist_frame_deadtime=imglist[frame].deadtime

                    InitTimeGroup, tStep, indexStep, Framedata.frameheader.Missed, frameTime, acceptedParticles,n_imgs,AllReject, $
                        cubicSize, mass,Acor_area,Acor_area_sav, imglist_frame_deadtime, Framedata.frameheader.ImgMean, sumSecs,$
                        MaxTGroup, crystal, missed, deadtime, TLastFrameSec, totsav, totsav2, totsav3, totFrm, AccumConc, $
                        AccumCubicSize, AccumMass,AccumAcor_area, TMean, TMeanCnt, TMax, ImgMean,accumpartcnt_mo,$
                        accumsphmass,accumicemass, AvgIntEnd, tGroup, $
                        ParticleCnt, AccMaxLen, AccMeanLen,fcs_max,earlier_frdeadtime,particle_cnt_msav,$
                        sphmass_sav,icemass_sav,$;   before sept 2004
                        WAcor_area_sav,Wparticle_cnt_msav,Wsphmass_sav,Wicemass_sav,$; added fow wysiwyg_r on oct11 2004
                        WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
                        AccumradarvolD6I,radarvolD6_savI, WAccumradarvolD6I,WradarvolD6_savI,$; added oct 22 for dBz
                        AccumradarvolD6L,radarvolD6_savL, WAccumradarvolD6L,WradarvolD6_savL; added oct 22 for dBz
                    earlier_frdeadtime=imglist[frame].deadtime; deadtime
                endelse
            endif ; end of time series processing

            if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
            if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData

        endif ; end of IF for valid frameData

    endif ; end of good frame condition

endfor   ; end of Frame loop

; let this time period be displayed!
(*pLink).process = !true
skip:


; complete all calculations

timeA=floor(frametime-sumsecs-1.0)+1LL
timeB=ceil(frametime-2.0)+1LL;  ; note that -1.0 is 1sec offset, another -1 is frametime has passed the second

get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime_new

deadtime=deadtime_new
;************************************************************************
; complete last group ( skip last data point because it is not a complete interval)
FinishTimeGroup,frameTime, AvgIntEnd, SumSecs, numPlots, missed, SampleVolume, AccumConc, $
    acceptedParticles, pLink, deadtime, totFrm, tMeanCnt, Tmax, tgroup, AccumCubicSize, AccumMass,AccumAcor_area, $
    Accumpartcnt_mo,Tmean, totsav,totSav2, totSav3, ImgMean, accumsphmass,accumicemass,indexStep, timePlot,$
    tGroupCnt, allParticles, tstep, $
    ParticleCntPerInterval, specialCase, max_to_save,MaxLength,nonRejectCnt,$ ;before sept 2004
    WAccumsphmass,WAccumicemass,Waccumpartcnt_mo,WAccumAcor_area,$;added fow wysiwyg_r on oct11 2004
    AccumradarvolD6I,WAccumradarvolD6I,AccumradarvolD6L,WAccumradarvolD6L; added oct 22 2004.

if((stop_time-AvgintEnd) ge SumSecs)then tGroup = (tGroup + (stop_time-AvgIntEnd)/SumSecs + 1) < maxTGroup
plotNum = 0
labels = strarr(numplots)

for i = 0,n_elements(tOperation)-1LL do begin
    if(tOperation[i])then begin
        case i of
            0: labels[plotNum] = 'Concntratn:#/L'
            1: labels[plotNum] = 'Extinction:1/km'
            2: labels[plotNum] = 'Radar(all) dBz'
            3: labels[plotNum] = 'Ave. Max Length um'
            4: labels[plotNum] = 'Max length um'
            5: labels[plotNum] = 'Total Frms'
            6: labels[plotNum] = 'Saved Frms'
            7: labels[plotNum] = 'Liq.dBz'    ;done in oct 22, 2004
            8: labels[plotNum] = 'Total Strobes'
            9: labels[plotNum] = 'Imaged Particles'
            10: labels[plotNum] = 'ImgdParts/TotStrbs'
            11: labels[plotNum] = 'ImgMean dn'
            12: labels[plotNum] = 'LWC:g/cu.m'   ;as nglib
            13: labels[plotNum] = 'TWC:g/cu.m';   as nglib
            14: labels[plotNum] = 'IWC:g/cu.m';   as nglib is the sum of above two.oct 21,2004.
            15: labels[plotNum] = 'IWC (TS) g/cu. m'
            16: labels[plotNum] = 'Ice.dBz' ;done oct 22 2004.
            17: labels[plotNum] = 'WYSIWYG #/L'
            else:
        endcase
        plotNum = plotNum + 1
    endif
endfor

if(Stop_time eq AvgIntEnd)then tGroup = tGroup + 1

if(tgroup gt 0)then begin
    length = n_elements(timePlot[0,*])
    if(tGroup lt length)then begin
        (*pStateInfo).pTimeSeries = ptr_new({timeData:timePlot[*,0:tGroup-1],labels:labels,StartTime:TframeStart})
    endif else begin
        temp = timePlot
        timePlot = fltarr(numPlots,tGroup)
        timePlot[*,0:length-1] = temp
        (*pStateInfo).pTimeSeries = ptr_new({timeData:timePlot,labels:labels,StartTime:TframeStart})
    endelse
endif else r = dialog_message('Error: no data in time series plots')


heap_gc
RETURN,[StartFrm,StopFrm]

end;   end of function  process_N_time_series_only
;*************************************************
