; Code used in the procesing of time periods
pro groupLink__define
    ; structure used in Histogram calculations

    group = {groupLink,$
        missed:0L,$            ; missed strobes per group
        deadtime:0.0,$          ; deadtime of group
        startTime:0L,$          ; time of the start of this group in seconds of year less than actual
        totFrmCnt:0L,$          ; total number of frames considered in this group
        ROIFrmCnt:0L,$          ; number of frames with images
        totImgPart:0L,$          ; total number of particles in this group
        wysiwyg:0.0,$            ; wysiwyg scale factor
        nonRejPart:0L,$          ; total number of non-rejected particles due to auto extraction process
        acceptPart:0L,$          ; total number of accpeted particles due to auto extraction process
        spec_accumpartcnt:0L,$   ; tot_count of particles in this time period.
        pData:ptr_new(),$         ; the actual data to be evaluated, in microns acrose diagaonal, average
        pDataA:ptr_new(),$        ; added for Area PSD
        pDataM:ptr_new(),$        ; added for Mass PSD
        pDataH:ptr_new(),$        ;added for Habits.
        next_link:ptr_new(),$       ; next link
        prev_link:ptr_new(),$     ; previous link
        pAdj: ptr_new(),$      ;     added august 24, 2004.
        Nbinedges:ptr_new(),$; ;  added august 24, 2004.
        Nbinheights: ptr_new(),$
        Lbinheights: ptr_new(),$
        Abinheights: ptr_new(),$
        Mbinheights: ptr_new(),$  ;added august 24, 2004.
        pDataC:ptr_new(),$         ; added for dfj wysiwyg1  october 5, 2004
        pDataCA:ptr_new(),$        ; added for Area PSD
        pDataCM:ptr_new(),$
        pdfj: ptr_new(),$
        pDataW:ptr_new(),$         ; added for wfj wysiwyg_r  october 5, 2004
        pDataWA:ptr_new(),$        ; added for Area PSD
        pDataWM:ptr_new(),$
        pdatawH:ptr_new(),$        ;added dec 7 2004 for habits.
        pwfj: ptr_new(),$          ;  added for wfj wysiwyg_r  october 5, 2004
        pZFrmcont:ptr_new(),$  ; for conditional frame0_conts
        pDvect:ptr_new(),$   ;   for storing Dcor values
        pWvect:ptr_new(),$   ;   for storing WFJ values
        pNvect:ptr_new(),$   ;}    ;   for storing N_imgs values.
        pfssp:ptr_new(),$   ;       added nov 5 2004.
        ptwoDC:ptr_new(),$
        ptwoDCA:ptr_new(),$,
    ptwoDCM:ptr_new()}

end  ; end of group_define

pro deleteGroup, pGroup
    ptr_free,(*pGroup).pData
    ptr_free,(*pgroup).pAdj;  added august 24, 2004
    ptr_free,(*pGroup).pDataA
    ptr_free,(*pGroup).pDataM
    ptr_free,pGroup

end

pro doLogFile, plink,imglist,frame, framedata, pROIArray,request,pStateInfo,imgfrmct,roiNum,time
    case (*pLink).format of
        'old':begin
        if(ROINum eq 0)then begin
            deadtime = imgList[frame].deadtime
            PDSThresh45 = imgList[frame].PDSThresh45
            PDSThresh90 = imgList[frame].PDSThresh90
        endif else begin
            deadtime = 0.0
            PDSThresh45 = 0.0
            PDSThresh90 = 0.0
        endelse
        write_line_old,pStateInfo, frame, frameData.frameheader, (*pROIArray)[ROINum].imageHeader,time,(*pLink).TAS,deadtime,PDSThresh45,PDSThresh90
    end
    'frame':begin

end
'hertz':begin
end
'spec1':begin
ProbeTime = 1000UL*CalcStrobeTime(framedata.frameHeader.ArrivalT1, framedata.frameHeader.ArrivalT2,framedata.frameHeader.Ver)
if(ROINum eq 0)then begin
    deadtime = imgList[frame].deadtime
    PDSThresh45 = imgList[frame].PDSThresh45
    PDSThresh90 = imgList[frame].PDSThresh90
endif else begin
    deadtime = 0.0
    PDSThresh45 = 0.0
    PDSThresh90 = 0.0
endelse
write_line_spec1,pStateInfo, Request,(*pROIArray)[ROINum].imageHeader,ROINum,(*pStateInfo).FileHead.year,time,ProbeTime,$
    framedata.frameheader.missed,deadtime,(*pStateInfo).Settings.pixsize,(*pLink).format,imgFrmCt,PDSThresh45,PDSThresh90
end


else:begin
ProbeTime = 1000UL*CalcStrobeTime(framedata.frameHeader.ArrivalT1, framedata.frameHeader.ArrivalT2,framedata.frameHeader.Ver)
if(ROINum eq 0)then begin
    deadtime = imgList[frame].deadtime
    PDSThresh45 = imgList[frame].PDSThresh45
    PDSThresh90 = imgList[frame].PDSThresh90
endif else begin
    deadtime = 0.0
    PDSThresh45 = 0.0
    PDSThresh90 = 0.0
endelse
;Brad comments next line out to try and stop pngs c not ascii bug, but that causes stats and combined not to be written properly.
write_line,pStateInfo, Request,*(*pLink).pSelect,(*pROIArray)[ROINum].imageHeader,ROINum,(*pStateInfo).FileHead.year,time,ProbeTime,$
    framedata.frameheader.missed,deadtime,(*pStateInfo).Settings.pixsize,(*pLink).format,imgFrmCt,PDSThresh45,PDSThresh90
end
endcase
end

function AcceptanceCriteria,pROIArray,pStateInfo,len,wid,area,perim,roundness1,focus,focusMin,focusMax,$;**********
    focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,pLink,pState

;valuecarl = (*pROIArray)[ROINum].ImageHeader.intensity_holeless_stats[0]
;print,valuecarl

; look in header from frame
headerType = tag_names((*pROIArray)[ROINum].ImageHeader,/structure_name)
if(headerType eq 'IMAGEHEADER30' or headerType eq 'IMAGEHEADER31')then begin

    len        = (*pROIArray)[ROINum].ImageHeader.len   * !CPI_MICRONS_PER_PIXEL
    wid        = (*pROIArray)[ROINum].ImageHeader.wid   * !CPI_MICRONS_PER_PIXEL
    area       = (*pROIArray)[ROINum].ImageHeader.area  * !CPI_MICRONS_PER_PIXEL * !CPI_MICRONS_PER_PIXEL
    perim      = (*pROIArray)[ROINum].ImageHeader.perim * !CPI_MICRONS_PER_PIXEL
    roundness1 = (*pROIArray)[ROINum].ImageHeader.roundness1
    focus = (*pROIArray)[ROINum].ImageHeader.focus
    ;if(focus eq 255)then focus = -1
    focusMin = (*pROIArray)[ROINum].ImageHeader.focusMin
    focusMax = (*pROIArray)[ROINum].ImageHeader.focusMax
    focusSTD = (*pROIArray)[ROINum].ImageHeader.focusSTDDEV
    CutOff = (*pROIArray)[ROINum].ImageHeader.CutOff
    Crystal = (*pROIArray)[ROINum].ImageHeader.Crystal

    ;if(Crystal eq 0 and len gt 0)then Crystal = 1 ; TAF flagging this as reassigning crystal to sphere from reject.  Should be removed, but might have been introduced to fix some bug...
    ;stop

    P1 = (*pROIArray)[ROINum].ImageHeader.P1
    ;the following code calculates the holearea for each particle as a percentage of size. CS
    holearea = (area - ((*pROIArray)[ROINum].ImageHeader.intensity_holeless_stats[0])*5.29)/area
    if (holearea eq 1.0) then holearea = 0
    holearea=holearea*100
    ;the following is used to make a focus value adjusted length: len2
    pos=(1.57547 -0.0614464 *focus + 0.000838895 *focus^2d -3.82540e-006 *focus^3d)
    ratio=1.1031377 + 1.2314287 *pos - 0.34444972 *pos^2d
    len2=len/ratio
    ;The following is how I set up the harmonics for acceptance criteria use.
    if ((*pROIArray)[ROINum].imageheader.harmonic_len gt 7) then begin
        h1 = (*(*pROIArray)[ROINum].imageheader.harmonics)[1]
        h2 = (*(*pROIArray)[ROINum].imageheader.harmonics)[2]
        h3 = (*(*pROIArray)[ROINum].imageheader.harmonics)[3]
        h4 = (*(*pROIArray)[ROINum].imageheader.harmonics)[4]
        h5 = (*(*pROIArray)[ROINum].imageheader.harmonics)[5]
        h6 = (*(*pROIArray)[ROINum].imageheader.harmonics)[6]
        HH1 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-1]
        HH2 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-2]
        HH3 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-3]
        HH4 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-4]
        HH5 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-5]
        HH6 = (*(*pROIArray)[ROINum].imageheader.harmonics)[(*pROIArray)[ROINum].imageheader.harmonic_len-6]
        middleharmonic=(*pROIArray)[ROINum].imageheader.harmonic_len/2-3
        mh1 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic]
        mh2 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+1]
        mh3 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+2]
        mh4 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+3]
        mh5 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+4]
        mh6 = (*(*pROIArray)[ROINum].imageheader.harmonics)[middleharmonic+5]


    endif else begin
        h1=0
        h2=0
        h3=0
        h4=0
        h5=0
        h6=0
        HH1=0
        HH2=0
        HH3=0
        HH4=0
        HH5=0
        HH6=0
        mh1=0
        mh2=0
        mh3=0
        mh4=0
        mh5=0
        mh6=0
    endelse

    reject = ((*pROIArray)[ROINum].imageheader.flags and '4000'X)/'4000'X
endif else begin

    len = (*pROIArray)[ROINum].imageHeader.len*(*pStateInfo).Settings.PixSize
    wid = (*pROIArray)[ROINum].imageHeader.wid*(*pStateInfo).Settings.PixSize

    ;  out of focus is in imageheader.flags (bits 0-7 of flags)
    focus = 100 - ((*pROIArray)[ROINum].imageHeader.Flags AND '00FF'X)  ; convert to in Focus

    ; cutoff is in imageheader.dark ( bits 8 - 12)
    cutoff = fix(100 * (ISHFT((*pROIArray)[ROINum].imageHeader.Dark,-8) AND '1F'X)/31.0)

    ; crystal is in imageheader.flags (bits 8 - 12)
    crystal = ISHFT((*pROIArray)[ROINum].imageHeader.Flags, -8) AND '001F'X

    ; manually corrected is in imageheader.flags (bit 14)
    corrected =((*pROIArray)[ROINum].imageheader.flags and '2000'X)/'2000'X

    ;manual reject is in imageheader.flags (bit 15)
    reject = ((*pROIArray)[ROINum].imageheader.flags and '4000'X)/'4000'X
    ; mo added  on 2015-01-23. following statements to prevent 3VCPiview wfrom crashing when the headertype is not correct the desired type.
    holearea=0
    h1=0
    h2=0
    h3=0
    h4=0
    h5=0
    h6=0
    HH1=0
    HH2=0
    HH3=0
    HH4=0
    HH5=0
    HH6=0
    mh1=0
    mh2=0
    mh3=0
    mh4=0
    mh5=0
    mh6=0
    ;****************************** added on 2015-01-23.
endelse

; Determine if this ROI should be accepted?

if((*pLink).accept and (*pLink).criteria ne '') THEN begin     ; this flag means "Are we looking for accepted particles?"
    cmd = 'if('+(*pLink).criteria+') then acceptflag = !true else acceptFlag = !false'
    compile = execute(cmd)

    if(not compile)then begin
        r = dialog_message('Error in acceptance string, aborting',/info)
        return,-1
    endif
endif else acceptFlag = !true ;if((*pROIArray)[ROINum].imageHeader.len ne 0)then acceptFlag = !true else acceptFlag = !false
; note: if the obj files exist and a particle is not processed, then len = 0 and was rejected.  now all are accepted
return,acceptFlag

end

pro DoFirstPass,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
    Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup

if((*pLink).spectra)then begin
    ;note mods force start time to be from the gui
    frameStart = start_time ;frameTime
    ; end of first interval
    ;IntEnd = (*pLink).SumInt + floor(frameStart)  ;changed to 1 group only DEc7 2004 moqixu

    IntEnd = floor(stop_time)  ;changed to 1 group only

    ;print,'first interval end',IntEnd
    rem = 0.0;      float(stop_time-start_time) mod (*pLink).SumInt ;changed Dec 7; 2004
    if(rem eq 0)then spectraComplete = !true

    (*pGroup).startTime = frameStart
endif

if(timeFlag)then begin
    ;note mods force start time to be from the gui
    TframeStart =  start_time ;frameTime
    SumSecs = (*pLink).sample
    AvgIntEnd = SumSecs + floor(TframeStart)
    rem = float(stop_time-start_time) mod SumSecs
    if(rem eq 0)then begin
        tcomplete=!true
        MaxTGroup = fix(float(stop_time-start_time) / sumSecs)
    endif else MaxTGroup = (stop_time-start_time)/SumSecs
    ;print,maxTgroup
endif
IntEnd2 = floor(frameTime) + 1

end

pro DoFirstPass_psd,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
    Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup

if((*pLink).spectra)then begin
    ;note mods force start time to be from the gui
    frameStart = start_time ;frameTime
    ; end of first interval
    ;IntEnd = (*pLink).SumInt + floor(frameStart)  ;changed to 1 group only DEc7 2004 moqixu

    IntEnd = floor(stop_time)  ;changed to 1 group only

    ;print,'first interval end',IntEnd
    rem = 0.0;      float(stop_time-start_time) mod (*pLink).SumInt ;changed Dec 7; 2004
    if(rem eq 0)then spectraComplete = !true

    (*pGroup).startTime = frameStart
endif

IntEnd2 = floor(frameTime) + 1

end  ; end of dofirstPass_psd

pro DoFirstPass_time,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
    Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup

if(timeFlag)then begin
    ;note mods force start time to be from the gui
    TframeStart =  start_time ;frameTime
    SumSecs = (*pLink).sample
    AvgIntEnd = SumSecs + floor(TframeStart)
    rem = float(stop_time-start_time) mod SumSecs
    if(rem eq 0)then begin
        tcomplete=!true
        MaxTGroup = fix(float(stop_time-start_time) / sumSecs)
    endif else MaxTGroup = (stop_time-start_time)/SumSecs
    ;print,maxTgroup
endif
IntEnd2 = floor(frameTime) + 1

end  ; end of dofirstpass_time



pro getObjData,pStateInfo,framedata,pROIArray,imgFrmCt,objData

    objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[imgFrmCt].fPos)

    if N_Tags(objdata) eq 0 then return

    ; need to get calcStrobe time working for 3V-CPI
    ;objTime = float(objData.frameHeader.time) + calcStrobeTime(objData.frameHeader.arrivalT1,objData.frameHeader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
    ;roiTime = float(framedata.frameheader.time) + calcStrobeTime(framedata.frameheader.arrivalT1,framedata.frameheader.arrivalT2,framedata.frameHeader.Ver)/1000.0D
    objTime = float(objData.frameHeader.time)
    ; roiTime = float(framedata.frameheader.time)

    hour  =framedata.FrameHeader.hour
    minute=framedata.FrameHeader.minute
    sec   =framedata.FrameHeader.sec
    msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    roiTime = hour*3600.0+minute*60.0 +sec*1.0+msec/1000.0D;   ; roitime=framedata.frameheader.time)


    indexOBJ = where(roiTime eq (*(*pStateInfo).pObjList).time, cntOBJ)

    if(objTime ne roiTime)then begin
        indexOBJ = where(roiTime eq (*(*pStateInfo).pObjList).time, cntOBJ)
        if(cntOBJ gt 0)then begin
            ; read a frame of info from the obj file
            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[indexOBJ[0]].fPos)
            ; store obj info
            pROIArray = objData.pFrame
        endif else begin
            r = dialog_message('Error: obj frame not found')
        endelse
    endif else pROIArray = objData.pFrame
end





FUNCTION Process_timeSeries, pStateInfo, volume = volume
; Purpose To accumulate the sizes of particles into CPI bins
; this routines assumes that an obj header exists


Forward_function printROIs, find_first_link


;make sure an obj file is exist, then people can continue process time series
my_message=['No obj file is found,please use EXTRACTION TOOLS to make an obj file first,then you can continue.']
if (*pstateInfo).objlun eq -1 then begin
    abcdefgh=dialog_message(my_message)
    return,0
endif
;**********************************************************************************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)
num_time_periods = 1; (*(*pStateInfo).pTimeInfo).periods

;imgList = (*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]
; Note: badframes have a time stamp that is wrong. It was not monotonically increasing
;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 and not (*(*pStateInfo).pFileScan).badframe)
imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
HKListIndx = where((*(*pStateInfo).pFileScan).imgtype eq -1)
HKlistIndx=0; added thsi HKlistindx=0; on septembet, 2009.
HKList = (*(*pStateInfo).pFileScan)[HKListIndx]



;open an ascii file if requested
sendASCII = !false
if((*pLink).sendASCII gt 0  and (*pLink).sendASCII lt 4 and (*pLink).output)then begin
    if((*pLink).accept) THEN criteria = (*pLink).criteria else criteria = 'none'
    request = open_ascii(pStateInfo,(*pLink).format,*((*pLink).pSelect),criteria)
    sendASCII = !true
endif

if((*pLink).sendASCII eq 4 and (*pLink).output)then begin
    if((*pLink).accept) THEN criteria = (*pLink).criteria else criteria = 'none'
    request = open_ascii_spec1(pStateInfo,criteria)
    sendASCII = !true
endif


(*pStateInfo).PrintROI.pageNo = 0


for k = 0,num_time_periods-1 do begin

    firstPass = !true
    newInt = !false
    spectra=!false

    if((*pLink).spectra)then begin ; flag from GUI
        ; initialize for histogram
        groupCnt = 1
        partCnt = 0
        intMax = 40   ; initial size of array

        (*pStateInfo).spectra.pGroup = ptr_new({groupLink})
        pGroup = (*pStateInfo).spectra.pGroup
        ;print,'Group #',groupCnt, ' pointer#',pGroup
        (*pGroup).pData = ptr_new(fltarr(intMax))
        (*pgroup).pAdj  = ptr_new(fltarr(intMax)) ;  added august 24, 2004.
        (*pGroup).pDataA = ptr_new(fltarr(intMax))
        (*pGroup).pDataM = ptr_new(fltarr(intMax))
        (*pGroup).pDataH = ptr_new(fltarr(intMax))
        spectra=!true
        SumInt = (*pLink).SumInt
        roiFrmCnt = 0L
        TotFrmCnt = 0L
        totImgPart = 0L
        acceptPart = 0L
        nonRejPart = 0L
        spectTotSav2 = 0L
        earlier_frdeadtime=0.0D ;added sept 24.0
        fcs_max=0.0;   added august 24, 2004
        meanlenarr_sav=0.0; added august 24, 2004.
        meanadjarr_sav=0.0
        meanAcorarr_sav=0.0
        meanMcorarr_sav=0.0
        meanHcorarr_sav=0.0;    Dec 7 2004 ---moqixu
        spec_accumpartcnt_mo=0.0
        spec_particle_cnt_msav=0.0

        wmeanLenarr=0.0; added october 7, 2004
        wmeanAcorarr=0.0; added october 7, 2004
        wmeanMcorarr=0.0; added october 7, 2004
        wmeanHcorarr=0.0; added Dec 7, 2004
        wmeanadjarr=0.0; added october 7, 2004

        dmeanLenarr=0.0; added october 7, 2004
        dmeanAcorarr=0.0; added october 7, 2004
        dmeanMcorarr=0.0; added october 7, 2004
        dmeanadjarr=0.0; added october 7, 2004

    endif

    if (*plink).condspectra then begin
        Zfrmcont=0;    added oct 25 for condictional spectra.
        Dvect =fltarr(1);   its size will increase as particles is added more and more
        Wvect =fltarr(1)
        Nvect =fltarr(1);   its size will increase as particles is added more and more
        cond_wmeanlenarr=0.0
        cond_wmeanadjarr=0.0
        (*plink).addfssp2dc=!false
    endif

    if (*plink).addfssp2dc then begin
        load_fssp_2dc_files,pstateinfo     ; store the data in the pstateinfo one time.
        ;(*pLink).HspectraType = 'adj'      ;make adj option true.  (*pLink).HspectraType = 'adj'
        (*plink).condspectra=!false
        ;bail out if user cancel doing addfssp2dc
        if (*pstateinfo).fsspdata.filename eq ' ' then (*plink).addfssp2dc=!false
    end

    timeFlag = !false
    if( (*pLink).time)then begin
        ; count requested plots
        numPlots = 0
        tOperation = bytarr(18)

        for i = 0,17 do begin
            if((*pLink).(i))then begin
                tOperation[i] = !true;(*pLink).(i)
                numPlots = numPlots + 1   ; number of plot. Maximum is 17, 17 curves of time series.
            endif
        endfor

        if(numPlots gt 0)then begin
            ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
            ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

            ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
            SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1)  ; Liters/sec
            ;it only stop here one time.  and tas is 10.00m/s of user defined value in here.

            tGroupCnt = 200
            timePlot = dblarr(numPlots,tGroupCnt) ;+ !values.f_nan
            ;assigned those radar values to be -99.0
            ;****************************************************************
            mooo_plots=0
            for i = 0,17 do begin
                if((*pLink).(i))then begin
                    tOperation[i] = !true;(*pLink).(i)
                    mooo_Plots = mooo_Plots + 1
                    if(((*pLink).(i)) eq (*plink).Tmean) and (*plink).Tmean then timeplot(mooo_plots-1,*)=-99.0
                    if(((*pLink).(i)) eq (*plink).Tpaul) and (*plink).Tpaul then timeplot(mooo_plots-1,*)=-99.0
                    if(((*pLink).(i)) eq (*plink).tRate3) and (*plink).tRate3 then timeplot(mooo_plots-1,*)=-99.0
                endif
            endfor     ; thsi has to be in the finishgroup also.
            ;******************************************************************
            tGroup = 0
            plotNum = 0
            timeFlag = (*pLink).time

            ; init accumulators
            totSav = 0L
            totSav2 = 0L
            totSav3 = 0L
            totFrm = 0L
            missed = 0L
            AccumConc = 0L
            AccumCubicSize = 0.0D
            AccumMass = 0.0D
            accumAcor_area=0.0D; added by mo July 27, 2004
            Accumsphmass=0.0D;   added by mo August18/04
            Accumicemass=0.0D

            ParticleCnt = 0L
            deadtime = 0.0D
            earlier_frdeadtime=0.0D;  added by mo 8/8/04 asumme first interval, frdeadtime=0.0
            TMean = 0.0D
            TmeanCnt = 0L
            TMax = 0.0D
            AccMeanLen = 0.0D

            maxLength = 0.0D
            max_to_Save = 0.0D
            allParticles = 0UL
            ParticleCntPerInterval = 0L
            specialCase = !false
            newROI = !true

            AccMaxLen = 0.0D
            cubicSize = 0.0D
            mass = 0.0D
            Acor_area=0.0;  added by mo July 27 2004.
            Acor_area_sav=0.0;  added by mo August 4, 2004.
            accumpartcnt_mo=0.0
            particle_cnt_msav=0.0
            sphmass_sav=0.0D;  added August 18/04.
            icemass_sav=0.0D

            ; added this for wysiwyg
            Waccumpartcnt_mo=0.0
            WaccumAcor_area=0.0D
            WAccumsphmass=0.0D
            WAccumicemass=0.0D
            WAcor_area_sav=0.0;  added by mo oct11, 2004.
            Wparticle_cnt_msav=0.0
            Wsphmass_sav=0.0D;  added oct11/04.
            Wicemass_sav=0.0D

            AccumradarvolD6I=0.0
            radarvolD6_savI =0.0
            WAccumradarvolD6I=0.0
            WradarvolD6_savI=0.0 ; added oct 22 for dBz
            AccumradarvolD6L=0.0
            radarvolD6_savL =0.0
            WAccumradarvolD6L=0.0
            WradarvolD6_savL=0.0 ; added oct 22 for dBz

            fcs_max=0.0
            ImgMean = 0L
        endif else (*pLink).time = !false

    endif


    output = !false

    ; get the first frame based on start time from GUI
    return_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
    stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)
    Start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
    ;print,'Requested start time=',start_time
    ;print,'Requested stop time=',stop_time
    ;stop
    if(stop_time le start_time)then begin
        r = dialog_message('Error: Stop time before Start time ...time period skipped')
        (*pLink).spectra = !false
        timeFlag = !false
        (*pLink).sendASCII = !false
        spectra = !false
        timeFlag = !false
        sendASCII = !false
        StartFrm = -1
        StopFrm = -1
        (*pLink).spectra = !false
        (*pLink).time = !false
        ;stop
        goto,skip
    endif
    stop
    StartFrm = GetFrameByTime(pStateInfo, (*pLink).start,/absolute, type='start')
    if(StartFrm eq -1)then begin
        r = dialog_message('Error: start frame not found...time period skipped')
        (*pLink).spectra = !false
        (*pLink).timeFlag = !false
        (*pLink).sendASCII = !false
        spectra = !false
        timeFlag = !false
        sendASCII = !false
        StartFrm = -1
        StopFrm = -1
        (*pLink).spectra = !false
        (*pLink).time = !false
        goto,skip
    endif
    ; stop
    ; check to see if end time is beyond this file
    add_files = 0
    guiTime = convertToSeconds((*pLink).stop,(*pStateInfo).filehead.year)
    ;stop
    dumIndx = where((*(*pStateInfo).pFileScan).imgtype eq 1 and not (*(*pStateInfo).pFileScan).badframe ,ImgCnt)
    lastTime = (*(*pStateInfo).pFileScan)[dumIndx[ImgCnt-1]].HTime
    if(guiTime gt lastTime)then begin
        ; stop
        ; construct file name
        ;filename = strtrim(time.month,2)+strtrim(time.day,2)+strtrim(time.hr,2)+strtrim(time.minute,2)
        files = findFile((*pStateInfo).path+'*.roi',count=count)
        ; put in order
        files = files[sort(files)]
        if count eq 0 then begin;  Mo added this ius on 2015 to fix the bug.
            files=(*pstateinfo).infilename
            count=1
        endif
        ; convert filenames into time ( seconds of year )
        filetimesSTR = replicate({times},count)

        for i=0,count-1 do begin
            ; parse names
            basefile=file_basename(files(i))

            if strlen(basefile) eq 12 then begin
                filetimesSTR[i].month =  strmid(files[i],rstrpos(files[i],'\')+1  ,2)
                filetimesSTR[i].day =    strmid(files[i],rstrpos(files[i],'\')+3,2)
                filetimesSTR[i].hour =   strmid(files[i],rstrpos(files[i],'\')+5,2)
                filetimesSTR[i].minute = strmid(files[i],rstrpos(files[i],'\')+7,2)
            endif

            if strlen(basefile) eq 18 then begin

                filetimesSTR[i].month =  strmid(basefile,4,2)
                filetimesSTR[i].day =    strmid(basefile,6,2)
                filetimesSTR[i].hour =   strmid(basefile,8,2)
                filetimesSTR[i].minute = strmid(basefile,10,2)
            endif


            if strlen(basefile) ne 18 and  strlen(basefile) ne 12  then begin
                rrr=dialog_message(' File name not supported, should be mmddhhmm.roi or yyyymmddhhmmss.roi',/info)
                return,0
            endif


        endfor
        ;create numerical list of times
        filetimes = convertToseconds(filetimesSTR,(*pStateInfo).filehead.year)
        tIndex = where(filetimes lt guiTime ,cnt)

        cnt=1;  added this on sept1.2009
        tIndex=0

        if(cnt gt 0)then begin
            currentFile = where(strlowcase(files) eq strlowcase((*pStateInfo).inFileName))
            ;filesToProcess = files[currentFile[0]:tIndex[cnt-1]]
            ;add_files=n_elements(filesToProcess)-1
            filesToProcess =   files[0];  currentFile[0]:tIndex[cnt-1]]
            add_files=n_elements(filesToProcess)-1

            StopFrm= n_elements(imglist) - 1 ; use last frame in image list
            stop
        endif else begin
            print,'Error in file name retrieval'
            stopfrm = startfrm
        endelse

    endif else begin
        ; get last frame based on time
        StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')
        stop
        if(StopFrm eq -1)then StopFrm= n_elements(imglist) - 1 ; use last frame in image list
        if(StopFrm le StartFrm)then begin
            r = dialog_message('Error: Stop frame less than or equal Start frame ...time period skipped')
            spectra = !false
            timeFlag = !false
            sendASCII = !false
            StartFrm = -1
            StopFrm = -1
            (*pLink).spectra = !false
            (*pLink).time = !false
            return,1
        endif
    endelse



    ; loop through the frames
    imgFrmCt = 0L
    tComplete = !false
    spectraComplete = !false
    spectraAccept = !false
    TlastFrameSec = 0UL
    SlastFrameSec = 0UL
    SlastFrameSec2 = 0UL
    objheader_start = 0UL

    print,'Processing file ',(*pStateInfo).infilename, ' additional files to process',add_files

    current_file = (*pStateInfo).infilename
    first_file = (*pStateInfo).infilename
    ;stop
    if((*pStateInfo).productNum eq 3)then begin
        netpath = 'H:\SPECFiles\cpiview\Nshell2.dll'
        ;r = call_external(netpath,'opennet')
    endif


    for fileNum = 0, add_files do begin
        ; first pass uses the file currently loaded
        if(fileNum gt 0)then begin
            print,'Processing file #',filenum, ' named ',filesToProcess[fileNum]
            ;open next file if needed
            LoadFile, pStateInfo , filename = filesToProcess[fileNum]
            current_file = filesToProcess[fileNum]
            ; get last frame based on time
            StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')
            StartFrm = 0UL
            if(StopFrm eq -1)then StopFrm= n_elements(imglist) - 1 ; use last frame in image list
            imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
            imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
            imgFrmCt = 0L
        endif
        ; following line added by mo sept 17, 2004.
        frametime_mooo=imglist.htime+imglist.msec/1000.0; ;all frame times; more than those in *combined.csv
        frametime_moooR=floor(frametime_mooo)

        ; for frame = StartFrm, StopFrm do begin comment this out; use imglist list to process every images.
        ;ImgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]; This is from NUMSlider of left_vent.pro

        imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
        imgList = (*(*pStateInfo).pFileScan)[imgListIndx]

        kkkimages=n_elements(Imglist)

        for frame=0LL, kkkimages-1LL  do begin



            ; skip bad frames
            ; if(not imgList[frame].badframe)then begin
            ; track frames for spectra
            ; must read the image data if any roi display or output is required
            frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

            imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )
            stop
            ;print, 'frame=',frame
            ;print, 'badFram=',imgList_kk[frame].badframe
            ;print,'imgframe=',imgframe
            ;print,'validframe=',(size(frameData,/type) eq 8)
            ;print,'RoisCount=',frameData.Frameheader.ROIsCount
            if frameData.Frameheader.ROIsCount eq 1 then begin
                ;print,'imgtype=',not((frameData.Frameheader.ImgType and 2)/2)
                word1=strtrim(string(format='(Z4)',frameData.frameheader.Time),2)
                word2=strtrim(string(format='(Z4)',frameData.frameheader.arrivalT1),2)
                word3=strtrim(string(format='(Z4)',frameData.frameheader.arrivalT2),2)
                if strlen(word1) eq 3 then word1='0'  +word1
                if strlen(word1) eq 2 then word1='00' +word1
                if strlen(word1) eq 1 then word1='000'+word1

                if strlen(word2) eq 3 then word2='0'  +word2
                if strlen(word2) eq 2 then word2='00' +word2
                if strlen(word2) eq 1 then word2='000'+word2

                if strlen(word3) eq 3 then word3='0'  +word3
                if strlen(word3) eq 2 then word3='00' +word3
                if strlen(word3) eq 1 then word3='000'+word3

                pframe=*(framedata.pframe)

                rois=pframe.proi
                roi1=*rois(0)
                sizexy=size(roi1,/dimension)
                window,1,xs=3*sizexy(1),ys=3*sizexy(0)
                ;Tv,roi1

                tvlct,255,255,0,255
                Tv,roi1
                bounds = DispFrame(pStateInfo)
                print,word1,' ',word2,' ',word3

            endif



            if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

                ;if(frame eq startFrm)then print,'Actual Start Frame time =',framedata.frameheader.time
                ;if(frame eq stopFrm)then print,'Actual Stop Frame time =',framedata.frameheader.time

                frameTime = frameData.FrameHeader.time

                time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ; change to 4/19/19:20:00.00 format.
                time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))

                ; time of frame in seconds
                frameTime = frameTime + time.msec/1000.0D

                ; ROIArray is an array of pointers for each particle in the frame
                pROIArray = FrameData.pFrame

                ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
                if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
                    getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData


                if(imgFrame)then imgFrmCt = imgFrmCt + 1

                ; How many ROIs?
                if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0
                if(imgframe)then if( n_imgs gt n_elements(*pROIArray))then print,'Error, obj data out of sync with frame'

                ;if(FirstPass)then begin
                ;  DoFirstPass,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
                ;   Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup
                ;  firstPass = !false
                ;endif

                ; create array for tracking confidence
                if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

                if(n_imgs gt 0)then begin
                    meanLenArr = fltarr(n_imgs)
                    mnSizes = fltarr(n_imgs)
                    mxSizes = fltarr(n_imgs)
                    ; create accepted array for min file output
                    accepted = bytarr(n_imgs)
                endif
                acceptedParticles = 0L
                nonRejectCnt = 0L
                AllReject = !true

                FOR ROINum=0, n_imgs-1 DO begin
                    accepted[roiNum] = !true
                    confidence[roiNum]=1
                endfor

                if((*pStateInfo).PrintROI.DoIt and imgFrame and (*pLink).output) THEN begin
                    ;if(n_elements(confidence) le n_elements(*frameData.pFrame))then begin
                    Ret = PrintROIs(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                        objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time,sizeType = sizeType)
                    ;endif

                endif
                if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
                if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData

                ; endif ; end of IF for valid frameData

            endif ; end of good frame condition

        endfor   ; end of Frame loop

        ; let this time period be displayed!
        (*pLink).process = !true

    endfor ; end of multiple file loop

    skip:

    ; advance to next time period
    ;pLastLink = pLink
    ;pLink = (*pLink).next_link

endfor ; end time periods loop



if(current_file ne first_file)then LoadFile, pStateInfo , filename = first_file
(*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit=0
heap_gc
RETURN,[StartFrm,StopFrm]
end;   end of function  process_time_series
;*************************************************

pro display_Histograms, pStateInfo, pLink

    ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
    ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

    ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
    SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1) ; Liters/sec
    ; stop

    ; convert to Liters/ avg interval
    SampleVolume = SampleVolume * (*pLink).SumInt  ; Liters/interval

    ; added this for conditional spectra display. oct 24 2004.
    if( (*pLink).condspectra)then begin

        Flags = 0
        IF (*pLink).Hprint THEN Flags = Flags OR 1
        IF (*pLink).HTiff THEN Flags = Flags OR 2
        IF (*pLink).HASCII THEN Flags = Flags OR 4
        heap_gc
        if((*pLink).Hmissed)then typescaling = 1
        if((*pLink).Hdeadtime)then typescaling = 2
        if((*pLink).Hwysiwyg)then typescaling = 3
        ShowHistograms_condspectra, pStateInfo, (*pLink).SumInt, GROUP=(*pStateInfo).widgets.tlb, $
            OutPutFlags=Flags, SAMPLEVOLUME=SampleVolume, typeSCALING=typescaling,sizeType=(*pLink).HSPECTRATYPE
        heap_gc

    ENDIF

    ; Show Histogram Plots

    if( (*pLink).addfssp2dc)then begin

        Flags = 0
        IF (*pLink).Hprint THEN Flags = Flags OR 1
        IF (*pLink).HTiff THEN Flags = Flags OR 2
        IF (*pLink).HASCII THEN Flags = Flags OR 4

        heap_gc
        if((*pLink).Hmissed)then typescaling = 1
        if((*pLink).Hdeadtime)then typescaling = 2
        if((*pLink).Hwysiwyg)then typescaling = 3
        if n_elements(typescaling) eq 0 then typescaling=3;  added this on Dec 29, 2004.
        ShowHistograms_addfssp2dc, pStateInfo, (*pLink).SumInt, GROUP=(*pStateInfo).widgets.tlb, $
            OutPutFlags=Flags, SAMPLEVOLUME=SampleVolume, typeSCALING=typescaling,sizeType=(*pLink).HSPECTRATYPE
        heap_gc
    endif

    ; if( (*pLink).spectra)then begin    ; replace this with following on oct 25, 2004
    if( (*plink).Hwysiwyg or (*plink).Hmissed ) and not((*pLink).addfssp2dc) then begin

        Flags = 0
        IF (*pLink).Hprint THEN Flags = Flags OR 1
        IF (*pLink).HTiff THEN Flags = Flags OR 2
        IF (*pLink).HASCII THEN Flags = Flags OR 4

        heap_gc
        if((*pLink).Hmissed)then typescaling = 1
        if((*pLink).Hdeadtime)then typescaling = 2
        if((*pLink).Hwysiwyg)then typescaling = 3
        ShowHistograms, pStateInfo, (*pLink).SumInt, GROUP=(*pStateInfo).widgets.tlb, $
            OutPutFlags=Flags, SAMPLEVOLUME=SampleVolume, typeSCALING=typescaling,sizeType=(*pLink).HSPECTRATYPE
        heap_gc

    ENDIF


end

pro display_timeSeries, pStateInfo, pLink
    ; Show Time Series Plots
    ; Time series process options

    ; ArrayArea in cm^2 ( with tilt factor from instument ) ( 1.e-8 for microns^2 -> cm^2 )
    ;ArrayArea = DOUBLE((*pStateInfo).FileHead.DX)*(*pStateInfo).FileHead.DY*((*pStateInfo).Settings.PixSize)^2*(1.e-8)*(sqrt(2.0)/2.0)

    ; Airspeed is in m/sec, (1.e2 for m -> cm and 1.e-3 for cc -> Liter)
    ;SampleVolume = ArrayArea * ((*pLink).TAS * 1.0e-1)    ; Liters/sec

    ; convert to Liters/ avg interval
    ;SampleVolume = SampleVolume * (*pLink).sample ; Liters/interval

    pLink =(*(*pStateInfo).pTimeInfo).pCurrent_Link

    ; Output options
    Flags = 0
    IF((*pLink).TPlotPrint)THEN Flags = Flags OR 1
    IF((*pLink).TplotTiff )THEN Flags = Flags OR 2
    IF((*pLink).TplotASCII)THEN Flags = Flags OR 4

    ;heap_gc
    TimeSeriesWidget, pStateInfo, pLink, OutPutFlags=Flags
    ;heap_gc
    (*plink).time=0;    resett it to be zero after the a time-series is processed.
end



;************************************************************
pro get_deadtime_btwAB,timeA,timeB,frametime_mooo,frametime_moooR,imglist,deadtime
    ; input: timeA, timeB, frametime_mooo,Frametime_moooR,imglist
    ; ouput: deadtime
    deadtime=0.0

    for i=timeA,timeB-1LL do begin
        indxT=where(imglist.Htime eq i,contG)
        if contG gt 0 then thisDT=max((imglist.deadtime)(indxT)) else thisDT=0.0
        deadtime=deadtime+thisDT
    endfor
    ; print,timeA, deadtime

end
;************************************************************

;added this following in July 31, 2007.
FUNCTION Process_time_Series_png_pages_only, pStateInfo, volume = volume

Forward_function printROIs, find_first_link

;*******it is assume that obj is always exist  *********************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)
num_time_periods = (*(*pStateInfo).pTimeInfo).periods


;imgList = (*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]
; Note: badframes have a time stamp that is wrong. It was not monotonically increasing
; imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 and not (*(*pStateInfo).pFileScan).badframe)
imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 )

imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
HKListIndx = where((*(*pStateInfo).pFileScan).imgtype eq -1)
HKList = (*(*pStateInfo).pFileScan)[HKListIndx]

(*pStateInfo).PrintROI.pageNo = 0



for k = 0,num_time_periods-1 do begin

    firstPass = !true
    timeFlag = !false
    output = !false

    ; get the first frame based on start time from GUI
    start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
    stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)
    ;print,'Requested start time=',start_time
    ;print,'Requested stop time=',stop_time

    StartFrm = GetFrameByTime(pStateInfo, (*pLink).start,/absolute, type='start')

    ; check to see if end time is beyond this file
    add_files = 0
    guiTime = convertToSeconds((*pLink).stop,(*pStateInfo).filehead.year)
    ;stop
    ; dumIndx = where((*(*pStateInfo).pFileScan).imgtype eq 1 and not (*(*pStateInfo).pFileScan).badframe ,ImgCnt)
    dumIndx = where((*(*pStateInfo).pFileScan).imgtype eq 1,ImgCnt)

    lastTime = (*(*pStateInfo).pFileScan)[dumIndx[ImgCnt-1]].HTime

    StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')

    ; loop through the frames
    imgFrmCt = 0L
    tComplete = !false
    spectraComplete = !false
    spectraAccept = !false
    TlastFrameSec = 0UL
    SlastFrameSec = 0UL
    SlastFrameSec2 = 0UL
    objheader_start = 0UL

    print,'Processing file ',(*pStateInfo).infilename, ' additional files to process',add_files

    current_file = (*pStateInfo).infilename
    first_file = (*pStateInfo).infilename

    for fileNum = 0, add_files do begin
        ; first pass uses the file currently loaded
        if(fileNum gt 0)then begin
            print,'Processing file #',filenum, ' named ',filesToProcess[fileNum]
            ;open next file if needed
            LoadFile, pStateInfo , filename = filesToProcess[fileNum]
            current_file = filesToProcess[fileNum]
            ; get last frame based on time
            StopFrm = GetFrameByTime(pStateInfo, (*pLink).stop,/absolute, type='stop')
            StartFrm = 0UL
            if(StopFrm eq -1)then StopFrm= n_elements(imglist) - 1 ; use last frame in image list
            imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0)
            imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
            imgFrmCt = 0L
        endif
        ; following line added by mo sept 17, 2004.
        frametime_mooo=imglist.htime+imglist.msec/1000.0; ;all frame times; more than those in *combined.csv
        frametime_moooR=floor(frametime_mooo)
        ;last_frametime=ulong(frametime_mooo(0)); added this on july31, for archive png page. to cout 5 images for
        ; each second.
        ;this_secs_frame_count=0LL
        last_frametime=frametime_mooo(0)

        for frame = StartFrm, StopFrm do begin

            ; skip bad frames
            if(not imgList[frame].badframe)then begin
                ; track frames for spectra
                ; must read the image data if any roi display or output is required
                frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

                imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )

                if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

                    ;if(frame eq startFrm)then print,'Actual Start Frame time =',framedata.frameheader.time
                    ;if(frame eq stopFrm)then print,'Actual Stop Frame time =',framedata.frameheader.time

                    frameTime = frameData.FrameHeader.time

                    time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ; change to 4/19/19:20:00.00 format.
                    time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))

                    ; time of frame in seconds
                    frameTime = frameTime + time.msec/1000.0D

                    ; ROIArray is an array of pointers for each particle in the frame
                    pROIArray = FrameData.pFrame

                    ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
                    if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
                        getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData


                    if(imgFrame)then imgFrmCt = imgFrmCt + 1

                    ; How many ROIs?
                    if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0
                    if(imgframe)then if( n_imgs gt n_elements(*pROIArray))then print,'Error, obj data out of sync with frame'

                    if(FirstPass)then begin
                        DoFirstPass,pLink,frameStart,start_time,IntEnd,spectraComplete,timeFlag,SumSecs,AvgIntEnd,$
                            Stop_time,tComplete,IntEnd2,frameTime,TframeStart,pGroup,MaxTGroup
                        firstPass = !false
                    endif

                    if(frame eq startFrm and (*pLink).time and fileNum eq 0)then begin
                        (*pLink).timeStr =strtrim(fix((*pLink).start.hour),2) + ':' + strtrim(fix((*pLink).start.minute),2) + ':'+  strtrim(fix((*pLink).start.sec),2); + ':'+  strtrim(fix(time.msec),2)
                        if(ceil(frameTime) - avgIntEnd gt SumSecs)then tgroup = (ceil(frameTime) - avgIntEnd)/SumSecs
                        deadtime0=0.0
                    endif

                    ; create array for tracking confidence
                    if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

                    if(n_imgs gt 0)then begin
                        meanLenArr = fltarr(n_imgs)
                        mnSizes = fltarr(n_imgs)
                        mxSizes = fltarr(n_imgs)
                        ; create accepted array for min file output
                        accepted = bytarr(n_imgs)
                    endif
                    acceptedParticles = 0L
                    nonRejectCnt = 0L
                    AllReject = !true

                    ; loop through all the particles in the frame and accumulate into the histogram array by size
                    FOR ROINum=0, n_imgs-1 DO begin

                        acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness1,focus,focusMin,$
                            focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)

                        ;help,*(*(*pStateInfo).ptimeInfo).pcurrent_link,/struct
                        if  (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit ge 1 and acceptFlag then begin
                            ; Update new habit number into our OBJ data structure
                            (*pROIArray)[ROINum].imageHeader.crystal = (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit
                            ; write new habit number to obj file
                            update_obj_header, (*pStateInfo).ObjLUN,(*(objdata).pimhdfpos)[ROINum], "crystal", (*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit

                        endif


                        if(acceptFlag eq -1)then return,0 ; bail on error

                        if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

                        if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1

                        ; Need to handle skipping of seconds here Not sure if this is not already being done!
                        if(acceptFlag)then begin

                            ; mark roi image as accepted
                            accepted[roiNum] = !true

                            if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                            acceptedParticles = acceptedParticles + 1
                        endif ; end of acceptFlag block

                    endFOR ; end of roi loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

                    ;**********************oct 23 2004 add this block for condition spectro calculations.
                    ;see pro sum_condtional_spectra_values
                    ;************************************************************************************

                    framesec = ulong(frametime)

                    ; accumulate spectral data
                    ;if((*pLink).spectra)then begin

                    ; Are we printing images?
                    if((*pStateInfo).PrintROI.DoIt and imgFrame and (*pLink).output) THEN begin
                        stop
                        if(n_elements(confidence) le n_elements(*frameData.pFrame))then begin

                            ; added this part on july 31 2007 to limit archive output iamges counts.
                            ; every second we just output 5 frames of images at most.
                            ;******************************************************************
                            ;if framesec eq last_frametime then begin
                            ;this_secs_frame_count=this_secs_frame_count+1LL
                            ; endif else begin
                            ;     this_secs_frame_count=0LL
                            ;     last_frametime=framesec
                            ;     endelse

                            ;******************************************************************
                            stop
                            ;if frametime -last_frametime gt 0.4 then begin
                            Ret = PrintROIs(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                                objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time,sizeType = sizeType)
                            last_frametime=frametime
                            ;endif
                            ;*********************************************************************
                        endif

                    endif
                    if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
                    if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData

                endif ; end of IF for valid frameData

            endif ; end of good frame condition
            ; print,'frame loop: ',frame

        endfor   ; end of Frame loop

        ; let this time period be displayed!
        (*pLink).process = !true

    endfor ; end of multiple file loop
endfor ; end time periods loop

if(current_file ne first_file)then LoadFile, pStateInfo , filename = first_file
(*(*(*pStateInfo).ptimeInfo).pcurrent_link).habit=0
heap_gc
RETURN,[StartFrm,StopFrm]
end;   end of function  process_time_series
;*************************************************


;added this following in August  6, 2007.
FUNCTION Process_timeSeries_png_pages_only_3VCPI, pStateInfo, volume = volume

Forward_function printROIs, find_first_link,PrintROIs_HexTime, PrintROIs_notimelabel

;*******it is assume that obj is always exist  *********************************************
widget_control,/hourglass

; get linked list info
pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link


if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)

; choose to output only good frame images.
;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 ); and not (*(*pStateInfo).pFileScan).badframe)
;imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
;above two line are replaced by following line on August 26. 2014 by Mo.

imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

ImgFrmCt=0L

nnnn=n_elements(imglist)

(*pStateInfo).PrintROI.pageNo = 0


frame_numbers= (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
frameTimes=frame_numbers.hour*3600.0 +frame_numbers.minute*60.0 +frame_numbers.sec*1.0+frame_numbers.msec/1000.0D
;15:25:42-15:26:05
;15:29:09-15:29:51
;16:07:10-16:08:26

for k =0LL, nnnn-1LL  do begin

    ; must read the image data if any roi display or output is required
    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[k].fpos,date=(*pStateInfo).date, TSBlanked = imglist[k].TSBlanked)

    imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )

    if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame


        frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
        ; frameTime = FrameTime*16LL^8 + (frameData.frameHeader.ArrivalT1)*16LL^4 + (frameData.frameHeader.ArrivalT2)*1LL

        time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
        ; time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))

        ; added this Part on August 6, 2010 by mooooooooooooo
        Time.day   =framedata.FrameHeader.day
        Time.hour  =framedata.FrameHeader.hour
        Time.minute=framedata.FrameHeader.minute
        Time.sec   =framedata.FrameHeader.sec
        Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.

        ; time of frame in seconds
        ; frameTime = frameTime + time.msec/1000.0D
        frameTime = Time.hour*3600.0 + time.minute*60.0 + time.sec + time.msec/1000.0D;  Changed to this August 6, 2010

        index=where(frameTimes eq FrameTime,contG)
        if contG gt 0 then begin
            frame_this=index(0)+1LL
        endif else begin
            frame_this=99999LL
        endelse
        ; above Time is no good---checked on dec. 6, 2011.

        ; ROIArray is an array of pointers for each particle in the frame
        pROIArray = FrameData.pFrame

        ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
        if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
            getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData

        if imgframe then ImgFrmCt=ImgFrmCt+1L


        ; How many ROIs?
        if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0

        ; create array for tracking confidence
        if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and

        if(n_imgs gt 0)then  accepted = bytarr(n_imgs)

        acceptedParticles = 0L
        nonRejectCnt = 0L
        AllReject = !true

        ; loop through all the particles in the frame and accumulate into the histogram array by size
        FOR ROINum=0, n_imgs-1 DO begin
            defsysv,'!frame', frame_this
            defsysv,'!n_imgs', RoiNum
            acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness1,focus,focusMin,$
                focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)


            if(acceptFlag eq -1)then return,0 ; bail on error

            if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

            if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1

            ; Need to handle skipping of seconds here Not sure if this is not already being done!
            if(acceptFlag)then begin
                ; mark roi image as accepted
                accepted[roiNum] = !true

                if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                acceptedParticles = acceptedParticles + 1
            endif ; end of acceptFlag block

        endFOR ; end of roi loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

        ; Are we printing images?
        if((*pStateInfo).PrintROI.DoIt and imgFrame and (*pLink).output) THEN begin

            if(n_elements(confidence) le n_elements(*frameData.pFrame))then begin

                ; added this part on july 31 2007 to limit archive output iamges counts.
                ; every second we just output 5 frames of images at most.
                ;******************************************************************
                ;if framesec eq last_frametime then begin
                ;this_secs_frame_count=this_secs_frame_count+1LL
                ; endif else begin
                ;     this_secs_frame_count=0LL
                ;     last_frametime=framesec
                ;     endelse
                ;******************************************************************

                if (*plink).addtime eq 255 then begin

                    ;if frametime -last_frametime gt 0.4 then begin

                    ; accepted is a vector to tell if the roi is accepted or not.

                    Ret = PrintROIs(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                        objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time,sizeType = sizeType)

                endif else if (*plink).addHextime eq 255 then begin
                    ;if frametime -last_frametime gt 0.4 then begin
                    Ret = PrintROIs_HexTime(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                        objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time,sizeType = sizeType)
                endif else begin
                    ;stop
                    Ret = PrintROIs_notimelabel(pStateInfo, accepted, frameData, OutPutFlags=(*pStateInfo).PrintROI.Flags, $
                        objData=objData, confidence=confidence, criteria = (*pLink).criteria,time=time, sizeType = sizeType)
                endelse

                last_frametime=frametime
                ;endif
                ;*********************************************************************
            endif
        endif
        if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
        if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData
    endif ; end of IF for valid frameData
    next_K:
endfor   ; end of k loop
;***********************************************************
; Get sizing from the printer info
if(not obj_valid(Palette))then begin
    ; Get current color table
    TVLCT, r, g, b, /GET
    r[0] = 0;255 ; change this to from 255 to 0 on march 17 2005
    g[0] = 0;255
    b[0] = 0
    Palette = OBJ_NEW('IDLgrPalette', r, g, b)
    ;OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
endif


; show the image if requested
Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
if not obj_valid(output3)then OutPut3 = OBJ_NEW('IDLgrWindow', DIMENSIONS=[800*Aspect,800], COLOR_MODEL=1, PALETTE=Palette)
if not obj_valid((*pStateInfo).PrintROI.View) then  $
    (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
;above mo added on 2015-05-22.


OutPut3->Draw, (*pStateInfo).PrintROI.View
wait,(*pStateInfo).waittime

; save last page  Image to file?
if(not obj_valid(OutPut2))then begin
    Aspect = FLOAT((*pStateInfo).PrintROI.PageDX)/(*pStateInfo).PrintROI.PageDY
    OutPut2 = OBJ_NEW('IDLgrBuffer', DIMENSIONS=[1024*Aspect,1024], COLOR_MODEL=1, PALETTE=Palette)
endif

OutPut2->Draw, (*pStateInfo).PrintROI.View
(*pStateInfo).PrintROI.pageNo = (*pStateInfo).PrintROI.pageNo + 1
page_percent=1.0;FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY; temporary percentage to print
; if page_percent lt 0.8 then page_percent=page_percent+0.2 else page_percent=1.0
SaveWndToFile, pStateInfo, OutPut2, page_percent, r, g, b,(*pStateInfo).PrintROI.pageNo
;SaveWndToFile, pStateInfo, OutPut2, FLOAT((*pStateInfo).PrintROI.PageY+76.0)/(*pStateInfo).PrintROI.PageDY, r, g, b,(*pStateInfo).PrintROI.pageNo

; Destroy current view
OBJ_DESTROY, (*pStateInfo).PrintROI.View

;*************************************************************
; let this time period be displayed!
(*pLink).process = !true
(*pStateInfo).PrintROI.pagey=0
(*pStateInfo).PrintROI.pagex=0

heap_gc
RETURN,[0,1]
end;   end of function  process_time_series_3VCPI_png_pages_only
;*************************************************

FUNCTION Make_combined_dot_csv_file, pStateInfo
    ; just make the combined.csv file
    ; this routines assumes that an obj header exists

    Forward_function find_first_link

    ;make sure an obj file is exist, then people can continue process time series
    my_message=['No obj file is found,please use EXTRACTION TOOLS to make an obj file first,then you can continue.']
    if (*pstateInfo).objlun eq -1 then begin
        abcdefgh=dialog_message(my_message)
        return,0
    endif
    ;**********************************************************************************************************
    widget_control,/hourglass

    ; get linked list info
    pLink = (*(*pStateInfo).pTimeInfo).pCurrent_link

    if((*(*pStateInfo).pTimeInfo).cur_per ne 1)then    pLink = find_first_link(pLink)

    ;choose to output only good frame images.
    ;imgListIndx = where((*(*pStateInfo).pFileScan).imgtype ge 0 );  and not (*(*pStateInfo).pFileScan).badframe)
    ; imgList = (*(*pStateInfo).pFileScan)[imgListIndx]
    imgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx];  pfilescan is pointer, to each file that has been scanned.

    ImgFrmCt=0L

    nnnn=n_elements(imglist)

    if((*pLink).sendASCII eq 4 and (*pLink).output)then begin
        if((*pLink).accept) THEN criteria = (*pLink).criteria else criteria = 'none'
        request = open_ascii_spec1(pStateInfo,criteria)
        sendASCII = !true
    endif

    frame_numbers= (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
    frameTimes=frame_numbers.hour*3600.0 +frame_numbers.minute*60.0 +frame_numbers.sec*1.0+frame_numbers.msec/1000.0D

    for frame =0LL, nnnn-1LL  do begin

        ; must read the image data if any roi display or output is required
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[frame].TSBlanked)

        imgFrame = (not((frameData.Frameheader.ImgType and 2)/2) and frameData.Frameheader.ROIsCount ge 1 )

        if(size(frameData,/type) eq 8)then begin ; skip if this is not a valid frame

            frameTime = frameData.FrameHeader.time  ;  This time should be  corrected to = Htime*16^8+ ArivelaT1*16^4 + ArriveT2  August 6, 2010.
            ; frameTime = FrameTime*16LL^8 + (frameData.frameHeader.ArrivalT1)*16LL^4 + (frameData.frameHeader.ArrivalT2)*1LL

            time = convertFromSeconds(frameTime , (*pStateInfo).FileHead.year) ;  Time={month, day, hh, mm, ss, msec} ; change to 4/19/19:20:00.00 format.
            ; time.msec  = ROUND(CalcStrobeTime(frameData.frameHeader.ArrivalT1, frameData.frameHeader.ArrivalT2,framedata.frameHeader.Ver))

            ; added this Part on August 6, 2010 by mooooooooooooo
            Time.day   =framedata.FrameHeader.day
            Time.hour  =framedata.FrameHeader.hour
            Time.minute=framedata.FrameHeader.minute
            Time.sec   =framedata.FrameHeader.sec
            Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.


            ; time of frame in seconds
            ; frameTime = frameTime + time.msec/1000.0D
            frameTime = Time.hour*3600.0 + time.minute*60.0 + time.sec + time.msec/1000.0D;  Changed to this August 6, 2010

            index=where(frameTimes eq FrameTime,contG)
            if contG gt 0 then begin
                frame_this=index(0)+1LL
            endif else begin
                frame_this=99999LL
            endelse
            ; above Time is no good---checked on dec. 6, 2011.

            ; ROIArray is an array of pointers for each particle in the frame
            pROIArray = FrameData.pFrame

            ; if an Object file exists, then use it NOTE pROIArray is reassigned here to the OBJ data
            if (imgframe and ptr_valid((*pStateInfo).pObjList)) then $
                getObjData_mo,pStateInfo,framedata,pROIArray,imgFrmCt,objData


            if(imgFrame)then imgFrmCt = imgFrmCt + 1

            ; How many ROIs?
            if(ptr_valid(pROIArray) and imgFrame)then n_imgs = n_elements( *pROIArray ) else n_imgs = 0

            ; create array for tracking confidence
            if(n_imgs gt 0) THEN confidence = bytarr(n_imgs) ;(*pLink).accept and
            if(n_imgs gt 0) then   accepted = bytarr(n_imgs)

            acceptedParticles = 0L
            nonRejectCnt = 0L
            AllReject = !true

            ; loop through all the particles in the frame and accumulate into the histogram array by size
            FOR ROINum=0, n_imgs-1 DO begin
                acceptFlag = AcceptanceCriteria(pROIArray,pStateInfo,len,wid,area,perim,roundness1,focus,focusMin,$
                    focusMax,focusSTD,CutOff,Crystal,P1,corrected,reject,ROINum,plink)

                ;  may need to update the objdata header

                if(acceptFlag eq -1)then return,0 ; bail on error

                if((*pROIArray)[ROINum].imageHeader.len gt 0 and AllReject)then AllReject = !false

                if((*pROIArray)[ROINum].imageHeader.len ne 0)then nonRejectCnt = nonRejectCnt + 1

                ; Need to handle skipping of seconds here Not sure if this is not already being done!
                if(acceptFlag)then begin
                    ; mark roi image as accepted
                    accepted[roiNum] = !true

                    if(n_imgs gt 0)then confidence[ROINum] = 10  ;10 means accept,0 means reject(*pLink).accept and
                    acceptedParticles = acceptedParticles + 1
                endif ; end of acceptFlag block

                if imgFrame then doLogFile_3VCPI, plink,imglist,frame, framedata, $
                    pROIArray,request,pStateInfo,imgFrmCt,roiNum,time
                ; the Proiarry [roinum] is written to the combined.csv file.


            endFOR ; end of roi loop, This finish for 1 frame. roinum=0, 1, 2,,3, 4,if there are many rois in one frame.

            if(ptr_valid(FrameData.pFrame))then delete_frame,FrameData
            if(ptr_valid((*pStateInfo).pObjList) and imgFrame)then delete_obj_header,objData
        endif ; end of good frame condition
    endfor   ; end of Frame loop
    heap_gc
end;   end of function making_combined_do_csv_file.
;*************************************************

pro doLogFile_3VCPI, plink,imglist,frame, framedata, pROIArray,request,pStateInfo,imgfrmct,roiNum,time
    case (*pLink).format of
        'frame':begin
    end
    'hertz':begin
end
'spec1':begin
ProbeTime = 1000UL*CalcStrobeTime(framedata.frameHeader.ArrivalT1, framedata.frameHeader.ArrivalT2,framedata.frameHeader.Ver)
if(ROINum eq 0)then begin
    deadtime = imgList[frame].deadtime
    PDSThresh45 = imgList[frame].PDSThresh45
    PDSThresh90 = imgList[frame].PDSThresh90
endif else begin
    deadtime = 0.0
    PDSThresh45 = 0.0
    PDSThresh90 = 0.0
endelse

write_line_spec1_3VCPI,pStateInfo, Request,(*pROIArray)[ROINum].imageHeader,ROINum,(*pStateInfo).FileHead.year,time,ProbeTime,$
    framedata,deadtime,(*pStateInfo).Settings.pixsize,(*pLink).format,imgFrmCt,PDSThresh45,PDSThresh90

end
else:begin
end
endcase
end


;********************************************************** added this on 2013-05.30

;create  a new view for png pages.

pro create_a_new_view_for_png_page, PstateInfo

    ;Mo added this subroutine on 2013-01-29  to moduleizing

    OutPut = OBJ_NEW()
    OutPut2 = OBJ_NEW()
    Palette = OBJ_NEW()

    ; Prepare fonts
    if not obj_valid((*pStateInfo).PrintROI.Font1) then (*pStateInfo).PrintROI.Font1 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=12)
    if not obj_valid((*pStateInfo).PrintROI.Font2) then (*pStateInfo).PrintROI.Font2 = OBJ_NEW('IDLgrFont', 'Helvetica', SIZE=14)
    if not obj_valid((*pStateInfo).PrintROI.Font3) then (*pStateInfo).PrintROI.Font3 = OBJ_NEW('IDLgrFont', 'Helvetica Bold',SIZE=8)

    ; Get Page dimensions, if not already done
    ;if((*pStateInfo).PrintROI.PageDX LT 100 OR (*pStateInfo).PrintROI.PageDY LT 100)then begin
    ; Get sizing from the printer info
    if(not obj_valid(OutPut))then begin
        ; Get current color table
        TVLCT, r, g, b, /GET
        r[0] = 0;255 ; change this to from 255 to 0 on march 17 2005
        g[0] = 0;255
        b[0] = 0
        Palette = OBJ_NEW('IDLgrPalette', r, g, b)
        OutPut = OBJ_NEW('IDLgrPrinter', COLOR_MODEL=1, PALETTE=Palette)
    endif

    IF obj_valid(OutPut) THEN  OutPut->GetProperty, DIMENSIONS=Dims, RESOLUTION=Res  ; I may change this to set instead of get.
    dims=[792,1024];      added by mo at March 21, 2005
    res= [0.025,0.025]
    (*pStateInfo).PrintROI.PageDX = Dims[0]
    (*pStateInfo).PrintROI.PageDY = Dims[1]

    ;set text dims in pixels
    TextDims = ([265, 33]*(0.00704861/Res[0]))*1.7    ; added by JS to enlarge font
    (*pStateInfo).PrintROI.LeftMargin = [TextDims[0], TextDims[1]]
    ; Want 40 pixs = 1 cm
    (*pStateInfo).PrintROI.PageZoom = 1/(Res[0]*40)
    ;endif

    ; Create new view
    if(not obj_valid((*pStateInfo).PrintROI.View))then begin
        ; create a view
        (*pStateInfo).PrintROI.View = OBJ_NEW('IDLgrView', VIEW=[0,0,(*pStateInfo).PrintROI.PageDX,(*pStateInfo).PrintROI.PageDY])
        (*pStateInfo).PrintROI.Model = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.TimeText = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font3,recompute_dimensions=0)
        (*pStateInfo).PrintROI.TimeText2 = OBJ_NEW('IDLgrText', COLOR=[0,0,0], FONT=(*pStateInfo).PrintROI.Font3,recompute_dimensions=0)

        (*pStateInfo).PrintROI.Model1 = OBJ_NEW('IDLgrModel')
        (*pStateInfo).PrintROI.valueText = OBJ_NEW('IDLgrText', COLOR=0, FONT=(*pStateInfo).PrintROI.Font3)
        (*pStateInfo).PrintROI.Model1->Add, (*pStateInfo).PrintROI.valueText


        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText
        (*pStateInfo).PrintROI.Model->Add, (*pStateInfo).PrintROI.TimeText2 ;added by mo
        (*pStateInfo).PrintROI.View->Add, (*pStateInfo).PrintROI.Model
    endif

    (*pStateInfo).PrintROI.PageX = ((*pStateInfo).PrintROI.LeftMargin)[0]*1.05*0.36; ;this is leftMargin;   added 0.36 by mo here =47.68
    (*pStateInfo).PrintROI.PageY = 1.8 * ((*pStateInfo).PrintROI.LeftMargin)[1];  space btween lines. that is equal to DateGap at begining =29

end; end of create_a_new-View_for_png_page
;*****************************************************************************

