pro makeSpectValues,$
    ;Inputs
    pROIArray, pStateInfo, pLink, ROINum, ver, $
    ;outputs
    spectraAccept,$
    ; In/Out
    meanLenArr,meanAdjarr,fcs_max,meanLenarr_sav,meanadjarr_sav,spec_particle_cnt_msav,$
    meanAcorarr,meanAcorarr_sav, meanMcorarr,meanMcorarr_sav, $; this line added sept 10th, 2004
    wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;; this line for wysisyg_r all particles. Octoner7, 2004
    dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; this line for wysisyg_r all particles. Octoner7, 2004
    meanHcorArr,meanHcorarr_sav,wmeanHcorArr;          ;; for crytsal type info I or Liquid.
forward_function Kcorrection_factor


; set this flag to true if ANY roi is accepted in this frame
spectraAccept = !true

calculate_derived_parameters,pROIArray,ROINum,Lcor,Wcor,Dcor,Pcor,Acor,Mice,Mliq,adj,wfj,accepted,fcs,plink
dfj=1.0

MCor=Mliq < Mice;    that is mass;  Mcor like that of Acor_area.
HCor=(*pROIArray)[ROINum].imageHeader.crystal;    to distinguish if it is ice or sph.

;****************************************************
fcs_max=max([fcs_max,fcs]);    fcs_max is input and output.  it saves teh max fcs in current frame.

if fcs_max eq fcs and accepted eq 1 then  begin
    Acor_area_sav=Acor  ;*adj ; Acor_area_sav is the only output and always save one time.
    spec_particle_cnt_msav=1 ;*adj;    ; this is in/out needed for the final sum for ave_conc for binheights.
    meanLenarr_sav=Dcor;  ;this mean adj=1.0
    meanLenarr    =Dcor
    meanAdjarr    =adj
    meanAdjarr_sav=adj
    meanAcorarr   =Acor;Acor_area
    meanAcorarr_sav=Acor;Acor_area
    meanMcorarr    =Mcor
    meanMcorarr_sav=Mcor
    meanHcorarr    =Hcor
    meanHcorarr_sav=Hcor


    if ((*pROIArray)[ROINum].imageHeader.crystal eq 1) then begin ;if crystal is liquid water.
        sphmass_sav=Mliq/0.917;     *adj/0.917
        icemass_sav=icemass_sav
    endif  else begin
        sphmass_sav=sphmass_sav
        icemass_sav=Mice        ;*adj
    endelse


endif else begin
    Acor_area_sav=Acor_area_sav
    spec_particle_cnt_msav=spec_particle_cnt_msav;  ;same as time series particle_cnt_msav
    sphmass_sav=sphmass_sav;    only save one particle's mass for one frame. one frame has many rois.
    icemass_sav=icemass_sav
    meanLenarr    =meanLenarr_sav
    meanLenarr_sav=meanLenarr_sav
    meanadjarr    =meanadjarr_sav
    meanadjarr_sav=meanadjarr_sav
    meanAcorarr    =meanAcorarr_sav
    meanAcorarr_sav=meanAcorarr_sav
    meanMcorarr    =meanMcorarr_sav
    meanMcorarr_sav=meanMcorarr_sav
    meanHcorarr    =meanHcorarr_sav
    meanHcorarr_sav=meanHcorarr_sav

endelse


if accepted eq 1 and dfj ne 0.0 then begin ;output the wysiwyg1 data
    ; if there are total 3 particles in this frame and 2 particles has dfj ne 0 then
    ; the output in here should be two values Acor1,Acor2, Dcor1,Dcor2, Lcor1, Locor2, Mcor1,Mcor2
    dmeanLenarr    =[dmeanLenarr,Dcor];[dmeanLenarr_sav,meanLenarr]
    ; dmeanLenarr_sav=[dmeanLenarr_sav,meanLenarr]
    dmeanadjarr    =[dmeanadjarr,dfj];[dmeanadjarr_sav,meanadjarr]
    ; dmeanadjarr_sav=[dmeanadjarr_sav,meanadjarr]
    dmeanAcorarr    =[dmeanAcorarr,Acor];[dmeanAcorarr_sav,meanAcorarr];   Acor=Acor_area
    ; dmeanAcorarr_sav=[dmeanAcorarr_sav,meanAcorarr]
    dmeanMcorarr    =[dmeanMcorarr,Mcor];[dmeanMcorarr_sav,meanMcorarr]
    ; dmeanMcorarr_sav=ddmeanMcorarr_sav,meanMcorarr]
endif


if accepted eq 1 and wfj ne 0.0 then begin ;output the wysiwyg2 data---all data for calculations.
    wmeanLenarr     =[wmeanLenarr,DCor]
    wmeanadjarr     =[wmeanadjarr,wfj]
    wmeanAcorarr    =[wmeanAcorarr,Acor];Acor_area
    wmeanMcorarr    =[wmeanMcorarr,Mcor]
    wmeanHcorarr    =[wmeanHcorarr,Hcor]
endif; else wmeanLenarr=wmeanLenarr ; no need for this else line.

;*************************************************************************************************************

end

pro SumSpectraValues,$   ;note Validparticles equals acceptedparticles.
    ;In
    validParticles, meanLenArr, n_imgs, FrMissed, nonRejectCnt, acceptedParticles, FrDeadtime, $
    ;In/Out
    partCnt, intMax, pGroup, roiFrmCnt, TotFrmCnt, SlastFrameSec, frameSec, totImgPart,acceptPart,nonRejPart,spectTotSav2,$
    meanAdjarr,fcs_max,meanlenarr_sav,meanADjarr_sav,spec_accumpartcnt_mo,spec_particle_cnt_msav,$
    meanAcorarr,meanAcorarr_sav,meanMcorarr,meanMcorarr_sav, $; added sept10 2004 for A&M_PSD
    wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;; this line for wysisyg_r all particles. Octoner7, 2004
    dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$;; this line for dfj  all particles. Octoner7, 2004
    meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.



if(validParticles gt 0)then begin

    PartIndex = where(meanLenArr ne 0,PCnt)
    spectTotSav2 = spectTotSav2 + 1

    if(partCnt + validParticles ge intMax)then begin

        ;increase size of array
        currentSize = IntMax
        while(partCnt+validParticles ge intMax) do intMax = intMax + 50
        intMax = intMax + 50
        if(ptr_valid((*pGroup).pData))then begin ; non-valid pointer means we have yet to have a roi frame
            temp = *(*pGroup).pData
            ptr_free,(*pGroup).pData
            (*pGroup).pData = ptr_new(fltarr(intMax))
            (*(*pGroup).pData)[0:currentSize-1] = temp
        endif else (*pGroup).pData = ptr_new(fltarr(intMax))

        if(ptr_valid((*pGroup).pDataA))then begin ; non-valid pointer means we have yet to have a roi frame
            temp = *(*pGroup).pDataA
            ptr_free,(*pGroup).pDataA
            (*pGroup).pDataA = ptr_new(fltarr(intMax))
            (*(*pGroup).pDataA)[0:currentSize-1] = temp
        endif else (*pGroup).pDataA = ptr_new(fltarr(intMax))

        if(ptr_valid((*pGroup).pDataM))then begin ; non-valid pointer means we have yet to have a roi frame
            temp = *(*pGroup).pDataM
            ptr_free,(*pGroup).pDataM
            (*pGroup).pDataM = ptr_new(fltarr(intMax))
            (*(*pGroup).pDataM)[0:currentSize-1] = temp
        endif else (*pGroup).pDataM = ptr_new(fltarr(intMax))

        if(ptr_valid((*pGroup).pDataH))then begin ; non-valid pointer means we have yet to have a roi frame
            temp = *(*pGroup).pDataH
            ptr_free,(*pGroup).pDataH
            (*pGroup).pDataH = ptr_new(fltarr(intMax))
            (*(*pGroup).pDataH)[0:currentSize-1] = temp
        endif else (*pGroup).pDataH = ptr_new(fltarr(intMax))

        ;added following part for adj values
        ;***********************************************************************************************
        if(ptr_valid((*pGroup).pAdj ))then begin ; non-valid pointer means we have yet to have a roi frame
            tempadj = *(*pGroup).pAdj
            ptr_free,(*pGroup).pAdj
            (*pGroup).pAdj = ptr_new(fltarr(intMax))
            (*(*pGroup).pAdj)[0:currentSize-1] = tempadj
        endif else (*pGroup).pAdj = ptr_new(fltarr(intMax))
        ;***************************************************************
    endif  ; end of if (partCnt + validParticles ge intMax) then begin

    ;continue adding sizes
    IF(PCnt gt 0)then begin
        (*(*pGroup).pData)[partCnt:partCnt+PCnt-1] = meanLenArr[PartIndex]
        (*(*pGroup).padj )[partCnt:partCnt+PCnt-1] = meanAdjArr[PartIndex];   added august 24,200
        (*(*pGroup).pDataA)[partCnt:partCnt+PCnt-1] = meanAcorArr[PartIndex]
        (*(*pGroup).pDataM)[partCnt:partCnt+PCnt-1] = meanMcorArr[PartIndex]
        (*(*pGroup).pDataH)[partCnt:partCnt+PCnt-1] = meanHcorArr[PartIndex]
        partCnt = partCnt + PCnt
    endif

endif  ;end of first if validparticles gt 0 then begin

;************************************************************************************
;needed to add counts for dfj and wfj pointer and particles count to store the values
;need .pdataC .pdfj, pdataCA, pdataCM  and pdataW,pwfj, pdataWA,pdataWM
if(validParticles gt 0)then begin
    dPartIndex=where(dmeanlenarr gt 0.0,dPCnt)
    if(ptr_valid((*pGroup).pDataC))then begin
        temp_pdataC =*(*pGroup).pdataC
        temp_pdfj   =*(*pGroup).pdfj
        temp_pdataCA=*(*pGroup).pdataCA
        temp_pdataCM=*(*pGroup).pdataCM
        dcurrentsize=n_elements(temp_pdfj)
        newsize=dcurrentsize+dPCnt
        ptr_free,(*pGroup).pdfj
        ptr_free,(*pGroup).pdataC
        ptr_free,(*pGroup).pdataCA
        ptr_free,(*pGroup).pdataCM
        (*pGroup).pdfj    = ptr_new(fltarr(newsize))
        (*pGroup).pdataC  = ptr_new(fltarr(newsize))
        (*pGroup).pdataCA = ptr_new(fltarr(newsize))
        (*pGroup).pdataCM = ptr_new(fltarr(newsize))
        (*(*pGroup).pdFj)[0:dcurrentSize-1]    = temp_pdfj
        (*(*pGroup).pdataC)[0:dcurrentSize-1]  = temp_pdataC
        (*(*pGroup).pdataCA)[0:dcurrentSize-1] = temp_pdataCA
        (*(*pGroup).pdataCM)[0:dcurrentSize-1] = temp_pdataCM
        IF(dPCnt gt 0)then begin
            (*(*pGroup).pdFj)[dcurrentSize:newsize-1]    = dmeanAdjArr[dPartIndex]
            (*(*pGroup).pdataC)[dcurrentSize:newsize-1]  = dmeanLenArr[dPartIndex]
            (*(*pGroup).pdataCA)[dcurrentSize:newsize-1] = dmeanAcorArr[dPartIndex]
            (*(*pGroup).pdataCM)[dcurrentSize:newsize-1] = dmeanMcorArr[dPartIndex]
        endif
    endif else begin
        (*pGroup).pdfj    = ptr_new(fltarr(50))
        (*pGroup).pdataC  = ptr_new(fltarr(50))
        (*pGroup).pdataCA = ptr_new(fltarr(50))
        (*pGroup).pdataCM = ptr_new(fltarr(50))
    endelse

endif;  endof second  if(validParticles gt 0)then begin
;**********************************************************************************
if(validParticles gt 0)then begin
    wPartIndex=where(wmeanlenarr gt 0.0,wPCnt)
    if(ptr_valid((*pGroup).pDataW))then begin
        temp_pdataW =*(*pGroup).pdataW
        temp_pwfj   =*(*pGroup).pwfj
        temp_pdataWA=*(*pGroup).pdataWA
        temp_pdataWM=*(*pGroup).pdataWM
        temp_pdataWH=*(*pGroup).pdataWH
        wcurrentsize=n_elements(temp_pwfj)
        newsize=wcurrentsize+wPCnt
        ptr_free,(*pGroup).pwfj
        ptr_free,(*pGroup).pdataW
        ptr_free,(*pGroup).pdataWA
        ptr_free,(*pGroup).pdataWM
        ptr_free,(*pGroup).pdataWH
        (*pGroup).pwfj    = ptr_new(fltarr(newsize))
        (*pGroup).pdataW  = ptr_new(fltarr(newsize))
        (*pGroup).pdataWA = ptr_new(fltarr(newsize))
        (*pGroup).pdataWM = ptr_new(fltarr(newsize))
        (*pGroup).pdataWH = ptr_new(fltarr(newsize))
        (*(*pGroup).pwFj)[0:wcurrentSize-1]    = temp_pwfj
        (*(*pGroup).pdataW)[0:wcurrentSize-1]  = temp_pdataW
        (*(*pGroup).pdataWA)[0:wcurrentSize-1] = temp_pdataWA
        (*(*pGroup).pdataWM)[0:wcurrentSize-1] = temp_pdataWM
        (*(*pGroup).pdataWH)[0:wcurrentSize-1] = temp_pdataWH
        IF(wPCnt gt 0)then begin
            (*(*pGroup).pwFj)[wcurrentSize:newsize-1]    = wmeanAdjArr[wPartIndex]
            (*(*pGroup).pdataW)[wcurrentSize:newsize-1]  = wmeanLenArr[wPartIndex]
            (*(*pGroup).pdataWA)[wcurrentSize:newsize-1] = wmeanAcorArr[wPartIndex]
            (*(*pGroup).pdataWM)[wcurrentSize:newsize-1] = wmeanMcorArr[wPartIndex]
            (*(*pGroup).pdataWH)[wcurrentSize:newsize-1] = wmeanHcorArr[wPartIndex]
        endif
    endif else begin
        IF(wPCnt gt 0)then begin
            (*pGroup).pwfj    = ptr_new(fltarr(wPCnt))
            (*pGroup).pdataW  = ptr_new(fltarr(wPCnt))
            (*pGroup).pdataWA = ptr_new(fltarr(wPCnt))
            (*pGroup).pdataWM = ptr_new(fltarr(wPCnt))
            (*pGroup).pdataWH = ptr_new(fltarr(wPCnt))
            (*(*pGroup).pwFj)[0:wPCnt-1]    = wmeanAdjArr[wPartIndex]
            (*(*pGroup).pdataW)[0:wPCnt-1]  = wmeanLenArr[wPartIndex]
            (*(*pGroup).pdataWA)[0:wPCnt-1] = wmeanAcorArr[wPartIndex]
            (*(*pGroup).pdataWM)[0:wPCnt-1] = wmeanMcorArr[wPartIndex]
            (*(*pGroup).pdataWH)[0:wPCnt-1] = wmeanHcorArr[wPartIndex]
        endif else begin
            (*pGroup).pwfj    = ptr_new(fltarr(50))
            (*pGroup).pdataW  = ptr_new(fltarr(50))
            (*pGroup).pdataWA = ptr_new(fltarr(50))
            (*pGroup).pdataWM = ptr_new(fltarr(50))
            (*pGroup).pdataWH = ptr_new(fltarr(50))
        endelse
    endelse

endif;  endof second  if(validParticles gt 0)then begin  **for wysiwyg_r  all particles

;****************************************************************

;****************************************************************************
if(n_imgs gt 0)then roiFrmCnt = roiFrmCnt + 1
TotFrmCnt = TotFrmCnt + 1
(*pGroup).missed =  (*pGroup).missed + FrMissed
totImgPart = totImgPart + n_imgs
acceptPart = acceptPart + acceptedParticles
nonRejPart = nonRejPart + nonRejectCnt
;print,acceptPart,acceptedParticles,nonRejPart,nonRejectCnt,totImgPart,n_imgs

;*****************************************  added sept 8 2004
spec_accumpartcnt_mo= spec_accumpartcnt_mo+spec_particle_cnt_msav
spec_particle_cnt_msav=0.0;   reset it to zero.
;********************************************************************

if(frameSec ne SlastFrameSec)then begin
    (*pGroup).deadtime = (*pGroup).deadtime + FrDeadtime
    SlastFrameSec = frameSec
endif     ; deadtime has to be consistant with time series of nglib !!!

;added following for fcs_max and meanLenarr_sav; on august 24, 2004
fcs_max=0.0
meanLenarr_sav=0.0
meanAdjarr_sav=0.0
meanAcorarr_sav=0.0
meanMcorarr_sav=0.0
meanHcorarr_sav=0.0
;print,'meanlenarr  partcnt, pcnt , partindex, meanlenarr(partindex) '
; print,meanlenarr,  partcnt, pcnt , partindex, meanlenarr(partindex)
;print,' (*(*pgroup).pData[****]'
; print,(*(*pGroup).pData)[*],(*(*pGroup).pData)[partCnt:partCnt+PCnt-1]
; stop
wmeanLenArr=0.0
wmeanadjarr=0.0
wmeanAcorarr=0.0
wmeanMcorarr=0.0;  this line for wysisyg_r all particles. Octoner7, 2004
wmeanHcorarr=0.0;  this line for wysisyg_r Habits. Dec 7, 2004
dmeanLenArr=0.0
dmeanadjarr=0.0
dmeanAcorarr=0.0
dmeanMcorarr=0.0;  this line for wysisygold all particles. Octoner7, 2004
end  ; end of sumspectravalues

pro finishSpectra,$
    ;In
    spectraAccept, roiFrmCnt, totImgPart, nonRejPart, acceptPart, TotFrmCnt, partCnt, spectTotSav2, $
    spec_accumpartcnt_mo,$
    ;In/out
    pGroup, groupCnt
; note upon return, pGroup points to the next intervals link

; complete current group
(*pGroup).ROIFrmCnt = roiFrmCnt
if(totImgPart ne 0)then (*pGroup).TotImgPart = totImgPart ;else (*pGroup).TotImgPart = partCnt
if(acceptPart ne 0)then (*pGroup).acceptPart = acceptPart
if(nonRejPart ne 0)then (*pGroup).nonRejPart = nonRejPart
(*pgroup).spec_accumpartcnt=spec_accumpartcnt_mo

;Attention need to assigne spec_accumpartcnt_mo  to the pgroup to the ave_conc used for conc_norm.

(*pGroup).TotFrmCnt = TotFrmCnt
if(spectTotSav2 gt 0)then (*pGroup).wysiwyg = (double(acceptPart)/(double(spectTotSav2)*.0002) - 5000.0) else (*pGroup).wysiwyg = 0.0

PCnt = 0
if(ptr_valid((*pGroup).pData))then partIndex = where(*(*pGroup).pData ne 0,PCnt)
if(pCnt gt 0)then (*(*pGroup).pData) = (*(*pGroup).pData)[partIndex]
if(pCnt gt 0)then (*(*pGroup).pAdj)  = (*(*pGroup).pAdj)[partIndex]
if(pCnt gt 0)then (*(*pGroup).pDataA) = (*(*pGroup).pDataA)[partIndex]
if(pCnt gt 0)then (*(*pGroup).pDataM) = (*(*pGroup).pDataM)[partIndex]
if(pCnt gt 0)then (*(*pGroup).pDataH) = (*(*pGroup).pDataH)[partIndex]
; print,*(*pgroup).Pdata
; print,*(*pgroup).PAdj ;   maybe I need to do unihist_adj in here
;stop;  ; in here *(*pgroup).pdata has 6 particles' Dcor=211/307/204/14.6/197/283.0
; it appears that only particles of fcs_max is selected in here.

wPCnt = 0
if(ptr_valid((*pGroup).pDataW))then wpartIndex = where(*(*pGroup).pDataW ne 0,wPCnt)
if(wpCnt gt 0)then (*(*pGroup).pDataW)  = (*(*pGroup).pDataW)[wpartIndex]
if(wpCnt gt 0)then (*(*pGroup).pwfj)    = (*(*pGroup).pwfj)[wpartIndex]
if(wpCnt gt 0)then (*(*pGroup).pDataWA) = (*(*pGroup).pDataWA)[wpartIndex]
if(wpCnt gt 0)then (*(*pGroup).pDataWM) = (*(*pGroup).pDataWM)[wpartIndex]
if(wpCnt gt 0)then (*(*pGroup).pDataWH) = (*(*pGroup).pDataWH)[wpartIndex]
;************************************************************************
dPCnt = 0
if(ptr_valid((*pGroup).pDataC))then dpartIndex = where(*(*pGroup).pDataC ne 0,dPCnt)
if(dpCnt gt 0)then (*(*pGroup).pDataC)  = (*(*pGroup).pDataC)[dpartIndex]
if(dpCnt gt 0)then (*(*pGroup).pdfj)    = (*(*pGroup).pdfj)[dpartIndex]
if(dpCnt gt 0)then (*(*pGroup).pDataCA) = (*(*pGroup).pDataCA)[dpartIndex]
if(dpCnt gt 0)then (*(*pGroup).pDataCM) = (*(*pGroup).pDataCM)[dpartIndex]
prev_link = pGroup          ; store old link for next

; create a new link and assign to this links next field
(*pGroup).next_link = ptr_new({groupLink});  everythink in here is 0.0 or null point.

; next group
groupCnt = groupCnt + 1
;stop;    for addfssp2dc We hope don't do more than 1 group.
; set pGroup to the new link pointer
pGroup = (*pGroup).next_link;  everythink in here is still  0.0 or null point.

; connect chain backwards
(*pGroup).prev_link = prev_link ; This prev_link has something in there.

end

pro InitSpectraGroup,$
    ;In
    frameTime, TotFrmCnt, n_imgs, meanLenArr, Frdeadtime, nonRejectCnt, FrMissed, pLink,acceptedParticles, $
    ;Out
    pGroup, intMax, roiFrmCnt, totImgPart, acceptPart, spectraAccept, SlastFrameSec,spec_accumpartcnt_mo, $
    ;In/Out
    partCnt, IntEnd,spectTotSav2,nonRejPart,meanAdjarr,fcs_max,meanlenarr_sav,meanadjarr_sav,earlier_frdeadtime,$
    spec_particle_cnt_msav,meanAcorarr,meanAcorarr_sav,meanMcorarr,meanMcorarr_sav,$
    wmeanLenArr,wmeanadjarr,wmeanAcorarr,wmeanMcorarr,$;; this line for wysisyg_r all particles. Octoner7, 2004
    dmeanLenArr,dmeanadjarr,dmeanAcorarr,dmeanMcorarr,$; ; this line for wysisyg_r all particles. Octoner7, 2004
    meanHcorArr,meanHcorarr_sav,wmeanHcorArr;            ; for crytsal type info I or Liquid.


;Note: this routine assumes pGroup is pointing at the link we are about to initialize

; start of new time group set initial values
(*pGroup).startTime = (*(*pGroup).prev_link).startTime + (*pLink).SumInt

if(acceptedParticles gt 0)then spectTotSav2 = 1L else spectTotSav2 = 0L
TotFrmCnt = 1L
totImgPart = n_imgs
acceptPart = acceptedParticles
nonRejPart = nonRejectCnt
;print,'I am here damn it',nonRejPart

; load first value
if(n_imgs gt 0)then begin
    PartIndex = where(meanLenArr ne 0,PCnt)
    IF(PCnt gt 0)then begin
        intMax = n_elements(meanlenArr)  ; initial size of array
        (*pGroup).pData = ptr_new(fltarr(intMax))
        (*(*pGroup).pData)[0:PCnt-1] = meanLenArr[PartIndex]
        (*pGroup).pDataA = ptr_new(fltarr(intMax))
        (*(*pGroup).pDataA)[0:PCnt-1] = meanAcorArr[PartIndex]
        (*pGroup).pDataM = ptr_new(fltarr(intMax))
        (*(*pGroup).pDataM)[0:PCnt-1] = meanMcorArr[PartIndex]
        (*pGroup).pDataH = ptr_new(fltarr(intMax))
        (*(*pGroup).pDataH)[0:PCnt-1] = meanHcorArr[PartIndex]
        (*pGroup).pAdj = ptr_new(fltarr(intMax))
        (*(*pGroup).pAdj)[0:PCnt-1] = meanAdjArr[PartIndex]


        partCnt = PCnt
    endif else begin
        spectraAccept = !false
        intMax = 1 ; minimum array size
    endelse
    roiFrmCnt = 1L
endif else begin
    partCnt = 0
    roiFrmCnt = 0L
    intMax = 1 ; minimum array size
endelse
;end of if n_img gt 0 then begin ; ; load first value


;***********************************************************************************************
if(n_imgs gt 0)then begin
    wPartIndex = where(wmeanLenArr ne 0,wPCnt)
    IF(wPCnt gt 0)then begin
        wintMax = n_elements(wmeanlenArr)  ; initial size of array
        (*pGroup).pDataW  = ptr_new(fltarr(wintMax))
        (*pGroup).pDataWA = ptr_new(fltarr(wintMax))
        (*pGroup).pDataWM = ptr_new(fltarr(wintMax))
        (*pGroup).pDataWH = ptr_new(fltarr(wintMax))
        (*pGroup).pwfj    = ptr_new(fltarr(wintMax))
        (*(*pGroup).pDataW)[0:wPCnt-1]  = wmeanLenArr[wPartIndex]
        (*(*pGroup).pDataWA)[0:wPCnt-1] = wmeanAcorArr[wPartIndex]
        (*(*pGroup).pDataWM)[0:wPCnt-1] = wmeanMcorArr[wPartIndex]
        (*(*pGroup).pDataWH)[0:wPCnt-1] = wmeanHcorArr[wPartIndex]
        (*(*pGroup).pwfj)[0:wPCnt-1]    = wmeanAdjArr[wPartIndex]
    endif

endif; endif for wysiwyg_r all, liquid, ice
;************************************************************************************************
if(n_imgs gt 0)then begin
    dPartIndex = where(dmeanLenArr ne 0,dPCnt)
    IF(dPCnt gt 0)then begin
        dintMax = n_elements(dmeanlenArr)  ; initial size of array
        (*pGroup).pDataC  = ptr_new(fltarr(dintMax))
        (*pGroup).pDataCA = ptr_new(fltarr(dintMax))
        (*pGroup).pDataCM = ptr_new(fltarr(dintMax))
        (*pGroup).pwfj    = ptr_new(fltarr(dintMax))
        (*(*pGroup).pDataC)[0:dPCnt-1]  = dmeanLenArr[dPartIndex]
        (*(*pGroup).pDataCA)[0:dPCnt-1] = dmeanAcorArr[dPartIndex]
        (*(*pGroup).pDataCM)[0:dPCnt-1] = dmeanMcorArr[dPartIndex]
        (*(*pGroup).pdfj)[0:dPCnt-1]    = dmeanAdjArr[dPartIndex]
    endif
endif

;************************************************************************************************
(*pGroup).missed =  FrMissed

if n_elements(Frdeadtime) eq 0 then Frdeadtime=0.0;  added dec 14, 2004.
; (*pGroup).deadtime = Frdeadtime   ; mo changed this on sept 5, 2004
(*pGroup).deadtime = earlier_Frdeadtime  ;added by mo sept5 2004
earlier_frdeadtime=frdeadtime;           ;added by mo sept5 2004
SlastFrameSec = ulong(frameTime)
spec_accumpartcnt_mo=spec_particle_cnt_msav
;stop

; set end of next interval
Hstep = (*pLink).SumInt
IntEnd = IntEnd + HStep
fcs_max=0.0;   added august 24 2004
meanlenarr_sav=meanlenarr_sav;   ?????
meanadjarr_sav=meanadjarr_sav
meanAcorarr_sav=meanAcorarr_sav
meanMcorarr_sav=meanMcorarr_sav
meanHcorarr_sav=meanHcorarr_sav

spec_particle_cnt_msav=0.0

wmeanLenArr=wmeanLenArr;0.0
wmeanadjarr=wmeanadjarr;0.0
wmeanAcorarr=wmeanAcorarr;0.0
wmeanMcorarr=wmeanMcorarr;0.0;  this line for wysisyg_r all particles. Octoner7, 2004
wmeanHcorarr=wmeanHcorarr;0.0

dmeanLenArr=dmeanLenArr;0.0
dmeanadjarr=dmeanadjarr;0.0
dmeanAcorarr=dmeanAcorarr;0.0
dmeanMcorarr=dmeanMcorarr;0.0;  this line for wysisygold all particles. Octoner7, 2004


end

pro PadSpectralGroups,PadCnt,pGroup,groupCnt,SumInt

    for i = 0,padCnt-1 do begin

        prev_link = pGroup          ; store old link for next

        ; set start of current time group
        (*pGroup).startTime = (*(*pGroup).prev_link).startTime + SumInt

        ;create a new link and store in the current links next field
        (*pGroup).next_link = ptr_new({groupLink})

        ; next group
        groupCnt = groupCnt + 1
        ; stop;  for addfssp2dc ; we hope don't pad it.
        ; get pointer to the new link
        pGroup = (*pGroup).next_link   ; new link

        ; update the backward link
        (*pGroup).prev_link = prev_link

    endfor

end

pro calculate_derived_parameters,pROIArray,ROINum,Lcor,Wcor,Dcor,Pcor,Acor,Mice,Mliq,adj,wfj,accepted,fcs,plink
    ;input is pRoiArray, RoiNum,  output are derived parameters, Lcor, Wcor .......; June 9, 2009.

    ;rrr=dialog_message('Continue_in_calculate_derived_pa;;;;Specrtal_lib.pro ',/information)

    cutoff=(*pROIArray)[ROINum].imageHeader.cutoff
    fcs=(*pROIArray)[ROINum].imageHeader.focus < 100.0;  caps fcs to be 100 at maximum
    focus =fcs

    pixsize = !CPI_MICRONS_PER_PIXEL

    Lob=(*pROIArray)[ROINum].imageHeader.len  * pixsize           ; in microns   ob = observed size.
    Wob=(*pROIArray)[ROINum].imageHeader.wid  * pixsize           ; in microns
    Pob=(*pROIArray)[ROINum].imageHeader.perim* pixsize           ; in microns
    Aob=(*pROIArray)[ROINum].imageHeader.area * pixsize * pixsize ; in micron_square

    if lob le 0.0 or wob le 0.0 or pob le 0.0 then begin
        Lcor=0.0
        Wcor=0.0
        Dcor=0.0
        Pcor=0.0
        Acor=0.0
        Mice=0.0
        Mliq=0.0
        adj=0.0
        wfj=0.0
        accepted=0
        return
    endif
    ; There are case of la and lob  less than zero !!!!!!!   even Wob pop is negative.
    La=Lob-0.25*(100.0-fcs)
    Wa=Wob-0.25*(100.0-fcs)

    count=0LL

    while La  le 0.0 do begin; if La gt 140.0 then stop
        La=(La+Lob)/2.0
        count=count+1LL
        if count gt 100LL then stop
    endwhile
    Kcor_l=Kcorrection_factor(La); ==(-2.32*La*La*0.00001+0.00153*La+0.241)

    count=0LL
    while Wa  le 0.0 do begin
        Wa=(Wa+Wob)/2.0
        count=count+1LL
        if count gt 100LL then stop
    endwhile
    Kcor_w=Kcorrection_factor(Wa); ==(-2.32*Wa*Wa*0.00001+0.00153*Wa+0.241)

    if La gt 140.0 then begin
        Lcor=La
    endif else begin
        Lcor=La+fcs*Kcor_l;             microns
        if Lcor le 0.0 then Lcor=La
    endelse

    if Wa gt 140.0 then begin
        Wcor=Wa
    endif else begin
        Wcor=Wa+fcs*Kcor_w;   microns
        if Wcor le 0.0 then Wcor=Wa
    endelse


    if ((*pROIArray)[ROINum].imageHeader.crystal eq 1) then Dcor=(Lcor+Wcor)/2.0 else Dcor=Lcor

    Pcor=!pi*(Lob+Wob-Lcor-Wcor)/2.0;                  ; microns
    Acor=0.25*!pi*(Lcor*(Wob-Wcor)+Wcor*(Lob-Lcor));   ; microns^2
    Mliq=(4.0*!pi/3.0)*(Dcor/2000.0)^3.0;              ; mg
    Mice=(0.917*Mliq) < (0.115*(Acor/1000000.0)^1.218) ; mg

    ;accepted= (fcs ge 50 ) and (cutoff le 6.0)

    if( (*pLink).criteria ne '') THEN begin     ; this flag means "Are we looking for accepted particles?"
        cmd = 'if('+(*pLink).criteria+') then accepted = 1 else accepted = 0'
        compile = execute(cmd)

        if(not compile)then begin
            r = dialog_message('Error in acceptance string, aborting',/info)
            exit
        endif

    endif else accepted = 1 ;if((*pROIArray)[ROINum].imageH

    if accepted eq 1 then begin
        adj=1.0
        wfj=1.0 > (23379.167/(Dcor*Dcor)); take the maximum of the two values.      ;endif
    endif else begin
        adj=0.0
        wfj=0.0
    endelse

end; calculate_derived_parameters,pROIArray,ROINum,Lcor,Wcor,Dcor,Pcor,Acor,Mice,Mliq,adj,wfj
