pro set_frame_times,pTimeInfo, settings = type, pStateInfo, current=current
; purpose, to use frame time and set start and stop times
; parameters
; pointer to time info structure

;Keywords
;   settings choose which gui elements to update
;   current   if set, use current frame time

wid = *(*pTimeInfo).pWID
pLink = (*pTimeInfo).pCurrent_link

if(type eq 'both' or type eq 'start')then begin
    if(keyword_Set(current))then begin
        time = (*pTimeInfo).current ; use current frame time
    endif else begin
        time = (*pTimeInfo).first
    endelse
    widget_control,wid.start[0],set_value=time.month
    widget_control,wid.start[1],set_value=time.day
    widget_control,wid.start[2],set_value=time.hour
    widget_control,wid.start[3],set_value=time.minute
    widget_control,wid.start[4],set_value=time.sec
    ;widget_control,wid.start[5],set_value=time.msec
    (*pLink).start.month = time.month
    (*pLink).start.day = time.day
    (*pLink).start.hour = time.hour
    (*pLink).start.minute = time.minute
    (*pLink).start.sec = time.sec
    ;(*pLink).start.msec = 0;time.msec
endif

if(type eq 'both' or type eq 'stop')then begin
    if(keyword_Set(current))then begin
        time = (*pTimeInfo).current ; use current frame time
    endif else begin
        ;get last frame time
        time = (*pTimeInfo).last
    endelse
    widget_control,wid.stop[0],set_value=time.month
    widget_control,wid.stop[1],set_value=time.day
    widget_control,wid.stop[2],set_value=time.hour
    widget_control,wid.stop[3],set_value=time.minute
    widget_control,wid.stop[4],set_value=time.sec
    ;widget_control,wid.stop[5],set_value=0;time.msec
    (*pLink).stop.month = time.month
    (*pLink).stop.day = time.day
    (*pLink).stop.hour = time.hour
    (*pLink).stop.minute = time.minute
    (*pLink).stop.sec = time.sec
    ;(*pLink).stop.msec = time.msec
endif
end

function create_link
    ;Purpose : To create an initialized values node
    dummy = {values}
    ; set default values
    dummy.focus = 100
    dummy.cutOff = 0
    dummy.Crystaltype = 0
    dummy.sumInt = 60;    1  ; TIME INTERVAL 60 SECONDS.
    dummy.spectra = !false
    dummy.condspectra=!false;     added this on oct 24 2004 for conditional spectra
    dummy.addfssp2dc=!false;      moqixu  nov. 4 2004.
    ;dummy.Hconc = !true
    dummy.Hmissed = !false    ; changed to be default false on oct 27.
    dummy.Hdeadtime = !false
    dummy.Hwysiwyg = !false
    dummy.HspectraType = 'adj'   ;'max'
    dummy.Hprint = !false
    dummy.HTiff = !false
    dummy.HASCII = !false
    dummy.output = !false
    dummy.display1 = !false

    dummy.habit = 0   ; added 7/31/2001 for habit write to obj file

    dummy.display2 = !false
    dummy.sendPrint = !false
    dummy.sendTiff = !false
    dummy.show = !false
    dummy.addSize1 = !false
    dummy.addSize2 = !false
    dummy.addfocus = !false
    dummy.addcutoff = !false
    dummy.addround = !false
    dummy.addtype = !false
    dummy.addtime = !false     ;added on April 13 2004 for time-lable on png files.
    dummy.addHextime = !false     ;added on April 13 2004 for time-lable on png files.
    dummy.skip = 0
    dummy.time = !false
    dummy.Hextime = !false
    dummy.TplotPrint = !false
    dummy.TplotASCII = !false
    dummy.TplotTiff = !false
    dummy.sample = 1;   60   time interval eq 60 seconds.
    dummy.TAS = 150.0   ; THIS IS FOR FIRST SETUP THE WIGET DISPLAYS OR DEFAULT VALUE.
    ;dummy.waittime = 1
    dummy.Tconc1 = !false
    dummy.Tconc2 = !false
    dummy.TLWC1 = !false
    dummy.TLWC2 = !false
    dummy.TIWC1 = !false
    dummy.TIWC2 = !false
    dummy.TPaul = !false
    dummy.TBrad = !false
    dummy.Tmean = !false
    dummy.Tmax = !false
    dummy.TmaxLen = !false
    dummy.Trate1 = !false
    dummy.Trate2 = !false
    dummy.Trate3 = !false
    dummy.Trate4 = !false
    dummy.Trate5 = !false
    dummy.Trate6 = !false
    dummy.Tpds45 = !false
    dummy.Tpds90 = !false
    dummy.Ttransit = !false
    dummy.Tdepth = !false
    dummy.Timgmn = !false
    dummy.Tback = !false

    dummy.ADJ_sel=0   ; added this back on aug 11,2004. adj_sel=0 mean no_adjustment.

    dummy.process = !false
    dummy.next_link = ptr_new()    ; points to next node
    dummy.prev_link = ptr_new() ; points to previous link

    return,ptr_new(dummy)  ; return pointer to current node
end

;Custom linked list code

pro add_link,pCurrent_link

    pNew_link = create_link()   ; create a new link
    (*pCurrent_link).next_link = pNew_link ; connect this new link to the current one
    (*pNew_link).prev_link = pCurrent_link ; update pointer
    ;return,pNew_link          ; return new link

end

function delete_link,pLast_link
    prev_link = (*pLast_link).prev_link    ; save the pointer to the previous link
    ;print,'Prev Link =',prev_link
    ptr_free,(*pLast_link).pSelect
    ptr_free,pLast_link              ; delete this one
    if(ptr_valid(prev_link))then (*prev_link).next_link = ptr_new()    ; update previous link to be last
    return,prev_link             ; return pointer to prev link
end

function find_last_link,pLink

    ; search for last link
    while(ptr_valid((*pLink).next_link)) do pLink = (*pLink).next_link
    return,pLink

end

function find_first_link,pLink
    ; search for fist link
    while(ptr_valid((*pLink).prev_link)) do pLink = (*pLink).prev_link
    return,pLink
end

pro values__define

    ; define the values structure for the linked list

    ; define the times structure
    start={times}
    request = {request,pFormat:ptr_new(),pData:ptr_new()}

    ; define the values structure
    ;NOTE THE ORDER of this structure is critical  any changes must be dealt with in  process_time_periods, escpecially the first 18 fields
    dummy = {values,$
        Tconc1:0B,$
        Tconc2:0B,$
        Tmean:0B,$
        Tmax:0B,$
        TmaxLen:0B,$
        Trate1:0B,$
        Trate2:0B,$
        Trate3:0B,$
        Trate4:0B,$
        Trate5:0B,$
        Trate6:0B,$
        Timgmn:0B,$
        TLWC1:0B,$
        TLWC2:0B,$
        TIWC1:0B,$
        TIWC2:0B,$
        TPaul:0B,$
        TBrad:0B,$

        ADJ_sel:0B,$

        Start:{times},$
        stop:{times},$
        accept:0B,$
        criteria:'',$
        focus:0B,$
        cutOff:0B,$
        Crystaltype:0B,$
        sumInt:0,$
        spectra:0B,$
        condspectra:0B,$     ;added this on oct 24 2004 for conditional spectra
        addfssp2dc:0B,$
        ;Hconc:0B,$
        Hmissed:0B,$
        Hdeadtime:0B,$
        Hwysiwyg:0B,$
        HspectraType:' ',$
        Hprint:0B,$
        HTiff:0B,$
        HASCII:0B,$
        output:0B,$
        display1:0B,$

        display2:0B,$
        sendPrint:0B,$
        sendTiff:0B,$
        sendASCII:0B,$
        pSelect:ptr_new(),$
        show:!false,$
        addSize1:0B,$
        addSize2:0B,$
        addFocus:0B,$
        addCutoff:0B,$
        addRound:0B,$
        addtype:0B,$
        addtime:0B,$                     ;added on april 13 2004--by moooo
        addHextime:0B,$                     ;added on August 6 2008--by moooo
        skip:0,$
        TplotPrint:0B,$
        TplotASCII:0B,$
        TplotTiff:0B,$
        sample:0,$
        TAS:0.0,$
        time:0B,$
        Hextime:0B,$
        ;waittime:0,$
        Tpds45:0B,$
        Tpds90:0B,$
        Ttransit:0B,$
        Tdepth:0B,$
        Tback:0B,$

        process:0,$
        request:request,$
        Format:'new',$
        timeStr:'',$
        next_link:ptr_new(),$
        prev_link:ptr_new(),$
        habit:0B}
end

pro update,pLink,wID,mode = mode
; pLink contains the pointer to the link to use for updating
; wID is a structure holding all the widget ID's
;   wID={ t:{perCnt:perCnt,perNum:perNum},start:[StrMon,StrDay,StrHr,StrMin,StrSec,StrMSec],stop:[StpMon,StpDay,StpHr,StpMin,StpSec,StpMSec],$
;   f:{sumInt:sumInt,SecSkip:SecSkip,sample:sample,tas:tas,criteria:criteria},$
;   b:{ off:off,on:on,conc:conc,missed:missed,compute:compute,print:print,tiff:tiff,ascii:ascii,$
;       display:display,toPrint:toPrint,ToTiff:ToTiff,addSizes:addSizes,addfocus:addfocus,addcutoff:addcutoff,$
;       addround:addround,plotPrint:plotPrint,plotASCII:plotASCII,plotTiff:plotTiff,$
;       tConc:tConc,area:area,tMean:tMean,tpart:tpart,tMissed:tMissed},$
;   base:{b1:b1,b2:b2}}

if(not keyword_Set(mode))then mode = !false
widget_control,wID.f.sumInt, set_value = (*pLink).sumInt
;widget_control,wID.f.SecSkip, set_value = (*pLink).skip
widget_control,wID.f.sample, set_value = (*pLink).sample
widget_control,wID.f.tas, set_value = (*pLink).TAS
widget_control,wID.f.criteria, set_value = (*pLink).criteria
;widget_control,wID.f.waittime, set_value = (*pLink).waittime
if((*pLink).accept = !false) then (*pstateinfo).acceptflag = !false;CS

if((*pLink).accept)then begin
    widget_control,wID.b.off, set_button = !false
    widget_control,wID.b.on, set_button = !true
    widget_control,wid.f.criteria, sensitive = !true
    widget_control,wid.base.baccept1, sensitive = !true
    widget_control,wid.base.baccept2, sensitive = !true
endif else begin
    widget_control,wID.b.off, set_button = !true
    widget_control,wID.b.on, set_button = !false
    widget_control,wID.b.clear, set_button = !false     ;moadded september 2004
    widget_control,wid.f.criteria, sensitive = !true;false
    widget_control,wid.base.baccept1, sensitive = !false
    widget_control,wid.base.baccept2, sensitive = !false
endelse
if((*pLink).spectra)then begin
    widget_control,wID.b.spectraSelect, set_value = 1
    widget_control,wid.b.spectra1, sensitive = !true
    widget_control,wid.b.spectra2, sensitive = !true
endif else begin
    widget_control,wID.b.spectraSelect, set_value = 0
    widget_control,wid.b.spectra1, sensitive = !false
    widget_control,wid.b.spectra2, sensitive = !false
endelse

if((*pLink).output)then begin
    widget_control,wID.b.outputSelect, set_value = 1
    widget_control,wid.base.output, sensitive = !true
    widget_control,wid.base.baseHide,sensitive = (*pLink).show
endif else begin
    widget_control,wID.b.outputSelect, set_value = 0
    widget_control,wid.base.output, sensitive = !false
    widget_control,wid.base.baseHide,sensitive = !false
endelse

if((*pLink).time)then begin
    widget_control,wID.b.timeSelect, set_value = 1
    widget_control,wid.b.time, sensitive = !true
endif else begin
    widget_control,wID.b.timeSelect, set_value = 0
    widget_control,wid.b.time, sensitive = !false
endelse

if((*pLink).Hmissed)then widget_control,wID.b.type, set_value = 0   ;set as 1 at button value
if((*pLink).Hdeadtime)then widget_control,wID.b.type, set_value = 1 ; set as 2 at button value
if((*pLink).Hwysiwyg)then widget_control,wID.b.type, set_value = 2  ; set as 3 at button value oct 25, 2004.
if((*pLink).HspectraType eq 'adj')then widget_control,wID.b.sizetype, set_value = 1 else widget_control,wID.b.sizeType, set_value = 0
widget_control,wID.b.print, set_button = (*pLink).Hprint
widget_control,wID.b.tiff, set_button = (*pLink).HTiff
widget_control,wID.b.ascii, set_button = (*pLink).HASCII
widget_control,wID.b.display1, set_button = (*pLink).display1

;widget_control,wID.b.display2, set_button = (*pLink).display2
widget_control,wID.b.toPrint, set_button = (*pLink).sendPrint
widget_control,wID.b.ToTiff, set_button = (*pLink).sendTiff
case (*pLink).format of
    'new':begin
    widget_control,wID.b.ToLOG1, set_button = 1
    widget_control,wID.b.ToLOG2, set_button = 0
    widget_control,wID.b.ToLOG3, set_button = 0
    widget_control,wID.b.ToLOG4, set_button = 0
end
'frame':begin
widget_control,wID.b.ToLOG1, set_button = 0
widget_control,wID.b.ToLOG2, set_button = 1
widget_control,wID.b.ToLOG3, set_button = 0
widget_control,wID.b.ToLOG4, set_button = 0
end
'hertz':begin
widget_control,wID.b.ToLOG1, set_button = 0
widget_control,wID.b.ToLOG2, set_button = 0
widget_control,wID.b.ToLOG3, set_button = 1
widget_control,wID.b.ToLOG4, set_button = 0
end
'spec1':begin
widget_control,wID.b.ToLOG1, set_button = 0
widget_control,wID.b.ToLOG2, set_button = 0
widget_control,wID.b.ToLOG3, set_button = 0
widget_control,wID.b.ToLOG4, set_button = 1
end
'old':begin
widget_control,wID.b.ToLOG1, set_button = 0
widget_control,wID.b.ToLOG2, set_button = 1
widget_control,wID.b.ToLOG3, set_button = 0
widget_control,wID.b.ToLOG4, set_button = 0
end
'custom':begin
widget_control,wID.b.ToLOG1, set_button = 0
widget_control,wID.b.ToLOG2, set_button = 0
widget_control,wID.b.ToLOG3, set_button = 1
widget_control,wID.b.ToLOG4, set_button = 0
end
'':begin
widget_control,wID.b.ToLOG1, set_button = 0
widget_control,wID.b.ToLOG2, set_button = 0
widget_control,wID.b.ToLOG3, set_button = 0
widget_control,wID.b.ToLOG4, set_button = 0
end
endcase
;widget_control,wID.b.addSize1, set_button = (*pLink).addSize1
;widget_control,wID.b.addSize2, set_button = (*pLink).addSize2
widget_control,wID.b.addfocus, set_button = (*pLink).addfocus
;widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
;widget_control,wID.b.addround, set_button = (*pLink).addround
;widget_control,wID.b.addtype, set_button = (*pLink).addtype
widget_control,wID.b.addtime, set_button = (*pLink).addtime ; add by mo, april 13/04
;widget_control,wID.b.addHextime, set_button = (*pLink).addHextime ; add by mo, August 6/2010

widget_control,wID.b.plotPrint, set_button = (*pLink).TplotPrint
widget_control,wID.b.plotASCII, set_button = (*pLink).TplotASCII
widget_control,wID.b.plotTiff, set_button = (*pLink).TplotTiff
widget_control,wID.b.tConc1, set_button = (*pLink).Tconc2
widget_control,wID.b.tConc2, set_button = (*pLink).Tconc1

; if(mode)then begin
widget_control,wID.b.tLWC1, set_button = (*pLink).TLWC1
widget_control,wID.b.tLWC2, set_button = (*pLink).TLWC2
widget_control,wID.b.tIWC1, set_button = (*pLink).TIWC1
widget_control,wID.b.tIWC2, set_button = (*pLink).TIWC2
;  endif

widget_control,wID.b.tPaul, set_button = (*pLink).TPaul
widget_control,wID.b.tBrad, set_button = (*pLink).TBrad
widget_control,wID.b.tmean, set_button = (*pLink).Tmean
widget_control,wID.b.tmax, set_button = (*pLink).Tmax
widget_control,wID.b.tmaxLen, set_button = (*pLink).TmaxLen
widget_control,wID.b.trate1, set_button = (*pLink).Trate1
widget_control,wID.b.trate2, set_button = (*pLink).Trate2
widget_control,wID.b.trate3, set_button = (*pLink).Trate3
widget_control,wID.b.trate4, set_button = (*pLink).Trate4
widget_control,wID.b.trate5, set_button = (*pLink).Trate5
widget_control,wID.b.trate6, set_button = (*pLink).Trate6
;widget_control,wID.b.tpds45, set_button = (*pLink).Tpds45
;widget_control,wID.b.tpds90, set_button = (*pLink).Tpds90
;widget_control,wID.b.ttransit, set_button = (*pLink).Ttransit
;widget_control,wID.b.tdepth, set_button = (*pLink).Tdepth
widget_control,wID.b.timgmn, set_button = (*pLink).Timgmn
;widget_control,wID.b.tback, set_button = (*pLink).Tback

; now set times
widget_control,wid.start[0],set_value=(*pLink).start.month
widget_control,wid.start[1],set_value=(*pLink).start.day
widget_control,wid.start[2],set_value=(*pLink).start.hour
widget_control,wid.start[3],set_value=(*pLink).start.minute
widget_control,wid.start[4],set_value=(*pLink).start.sec
;widget_control,wid.start[5],set_value=(*pLink).start.msec

widget_control,wid.stop[0],set_value=(*pLink).stop.month
widget_control,wid.stop[1],set_value=(*pLink).stop.day
widget_control,wid.stop[2],set_value=(*pLink).stop.hour
widget_control,wid.stop[3],set_value=(*pLink).stop.minute
widget_control,wid.stop[4],set_value=(*pLink).stop.sec
;widget_control,wid.stop[5],set_value=(*pLink).stop.msec
end

pro TimePeriodGUI_event,event
    ; stop
    widget_control,event.top,get_uvalue=pTimeInfo
    widget_control,event.id,get_uvalue = uval

    wid = *(*pTimeInfo).pWID
    pLink = (*pTimeInfo).pCurrent_link

    case uval of
        'decrease':begin
        if((*pTimeInfo).periods gt 1)then begin

            (*pTimeInfo).periods = (*pTimeInfo).periods - 1

            ; set value in gui
            if((*pTimeInfo).periods gt 1)then ext = "'s" else ext = ''
            cnt = strtrim((*pTimeInfo).periods,2) + ' Time Period' + ext
            widget_control,wid.t.perCnt,set_value = cnt
            text = 'Time Period ' + strtrim((*pTimeInfo).cur_per,2) + ' of ' + strtrim((*pTimeInfo).periods,2)
            widget_control,wid.t.perNum,set_value = text

            if((*pTimeInfo).periods ge 1)then begin
                ; update linked list
                null = delete_link(find_last_link(pLink))
            endif
        endif
    end
    'increase':begin
    ; increase the counter
    (*pTimeInfo).periods = (*pTimeInfo).periods + 1

    ; update the GUI
    if((*pTimeInfo).periods gt 1)then ext = "'s" else ext = ''
    cnt = strtrim((*pTimeInfo).periods,2) + ' Time Period' + ext
    widget_control,wid.t.perCnt,set_value = cnt
    text = 'Time Period ' + strtrim((*pTimeInfo).cur_per,2) + ' of ' + strtrim((*pTimeInfo).periods,2)
    widget_control,wid.t.perNum,set_value = text

    ; update linked list
    add_link, find_last_link(pLink)
    ;print,'Add Link ',strtrim((*pTimeInfo).periods,2),(*pTimeInfo).pLast_link
end
'process':begin
widget_control,wid.f.criteria,get_value=cmd,/update;  added update by mo august 2004.
if strtrim(cmd,2) eq '' then begin
    (*pLink).accept = !false
    print, "No Acceptance Criteria Used"
endif else begin
    (*pLink).criteria = cmd
    print, "Acceptance Criteria Used = ", cmd
endelse

if((*pLink).start.day ne 0)then  (*pTimeInfo).process = !true

widget_control,wid.b.project_ID,get_value=cmd,/update;  added update by mo august 2004.
!project_name=cmd
widget_control,wid.b.platform_ID,get_value=cmd,/update;  added update by mo august 2004.
!platform=cmd
widget_control,wid.b.Revision_ID,get_value=cmd,/update;  added update by mo august 2004.
!Revision_X=cmd

widget_control,event.top,/destroy

end


'close':begin
(*pTimeInfo).process = !false
widget_control,event.top,/destroy
end
'previous':begin
if((*pTimeInfo).cur_per gt 1)then begin

    (*pTimeInfo).cur_per = (*pTimeInfo).cur_per - 1
    (*pTimeInfo).pCurrent_link = (*pLink).prev_link

    ;update GUI
    text = 'Time Period ' + strtrim((*pTimeInfo).cur_per,2) + ' of ' + strtrim((*pTimeInfo).periods,2)
    widget_control,wid.t.perNum,set_value = text

    if(ptr_valid((*pLink).prev_link))then update,(*pLink).prev_link,wid,mode =(*pTimeInfo).mode
endif
end
'next':begin
if((*pTimeInfo).cur_per lt (*pTimeInfo).periods)then begin
    (*pTimeInfo).cur_per = (*pTimeInfo).cur_per + 1

    (*pTimeInfo).pCurrent_link = (*pLink).next_link
    ;update GUI
    text = 'Time Period ' + strtrim((*pTimeInfo).cur_per,2) + ' of ' + strtrim((*pTimeInfo).periods,2)
    widget_control,wid.t.perNum,set_value = text

    if(ptr_valid((*pLink).next_link))then update,(*pLink).next_link,wid,mode =(*pTimeInfo).mode
endif
end
;'use_time':  set_frame_times,pTimeInfo, setting='both'
'start':begin
widget_control,wid.start[0],Get_value=temp1
widget_control,wid.start[1],Get_value=temp2
widget_control,wid.start[2],Get_value=temp3
widget_control,wid.start[3],Get_value=temp4
widget_control,wid.start[4],Get_value=temp5
;widget_control,wid.start[5],Get_value=temp6
(*pLink).start.month = temp1
(*pLink).start.day = temp2
(*pLink).start.hour = temp3
(*pLink).start.minute = temp4
(*pLink).start.sec = temp5
;(*pLink).start.msec = temp6
end
'first':set_frame_times,pTimeInfo, setting='start'
'current1':set_frame_times,pTimeInfo, setting='start',/current
'stop': begin
    widget_control,wid.stop[0],Get_value=temp1
    widget_control,wid.stop[1],Get_value=temp2
    widget_control,wid.stop[2],Get_value=temp3
    widget_control,wid.stop[3],Get_value=temp4
    widget_control,wid.stop[4],Get_value=temp5
    ;widget_control,wid.stop[5],Get_value=temp6
    (*pLink).stop.month = temp1
    (*pLink).stop.day = temp2
    (*pLink).stop.hour = temp3
    (*pLink).stop.minute = temp4
    (*pLink).stop.sec = temp5
    ;(*pLink).stop.msec = temp6
end
'current2':set_frame_times,pTimeInfo, setting='stop',/current
'last':set_frame_times,pTimeInfo, setting='stop'
'acceptanceOn':begin
(*pLink).accept = !true

widget_control,wid.base.baccept1, sensitive = !true
widget_control,wid.base.baccept2, sensitive = !true
;widget_control,wid.f.criteria, sensitive = !true

;widget_control,wid.f.criteria,get_value=cmd;,/update;  added update by mo august 2004.
;if strtrim(cmd,2) eq '' then (*pLink).accept = !false else (*pLink).criteria = cmd

end
'acceptanceOff':begin
(*pLink).accept = !false
;widget_control,wid.f.criteria, sensitive = !false
widget_control,wid.base.baccept1, sensitive = !false
widget_control,wid.base.baccept2, sensitive = !false
end
'acceptanceClear':begin  ; Moadded sept 24, 2004.
(*pLink).accept = !false
;widget_control,wid.f.criteria, sensitive = !false
widget_control,wid.base.baccept1, sensitive = !false
widget_control,wid.base.baccept2, sensitive = !false
(*plink).criteria=''; moadded sept22 2004
end

'habitNum':begin
(*pLink).habit = event.index
end

'habitOn':begin
widget_control,wid.base.bhabit, sensitive = !true
end

'habitOff':begin
widget_control,wid.base.bhabit, sensitive = !false
(*pLink).habit = !false
end

'criteria':begin
; TAF 2012-04-06 Criteria is saved when Process button is pressed
;widget_control,wid.f.criteria,get_value=cmd;,/update;  added update by mo august 2004.
;if strtrim(cmd,2) eq '' then (*pLink).accept = !false else (*pLink).criteria = cmd
end

'ProjectName':begin
widget_control,wid.b.project_ID,get_value=cmd,/update;  added update by mo august 2004.
!project_name=cmd
end
'Platform':begin
widget_control,wid.b.platform_ID,get_value=cmd,/update;  added update by mo august 2004.
!platform=cmd
end

'Revision_X':begin
widget_control,wid.b.revision_ID,get_value=cmd,/update;  added update by mo august 2004.
!Revision_X=cmd
end

'dl':begin
;variables = ['len','wid','area','perim','roundness','focus','focusMin','focusMax','focusSTDDEV','CutOff','Crystal','P1','holearea']
cmd = strtrim((*pLink).criteria,2)+' '+ strtrim((*pTimeInfo).variables[event.index],2)
widget_control,wid.f.criteria,set_value=cmd;,/update; added update by mo august.2004.
(*pLink).criteria = cmd
print,(*pTimeInfo).variables[event.index]
end

'save':begin
file = dialog_pickfile(title='Select (or enter) a filename for saving to.',filter='*.txt')
if(file ne '')then begin
    file = file + '.txt'
    openw,lun,file,/get
    printf,lun,(*pLink).criteria
    free_lun,lun
endif
end
'load':begin
file = dialog_pickfile(title='Select a file to load from.',filter='*.txt')
if(file ne '')then begin
    openr,lun,file,/get
    cmd = ''
    readf,lun,cmd
    (*pLink).criteria = cmd
    widget_control,wid.f.criteria,set_value=cmd  ;/update; added update by mo 2004/08
    free_lun,lun
endif
end ; end of load
'type':(*pLink).Crystaltype = event.index
'sum_int':begin
widget_control,wid.f.sumInt,get_value = temp
(*pLink).sumInt = temp > 1
end
'spectra':begin
if(event.value eq 1)then begin
    (*pLink).spectra = !true
    widget_control,wid.b.spectra1, sensitive = !true
    widget_control,wid.b.spectra2, sensitive = !true
endif else begin
    (*pLink).spectra = !false
    (*plink).addfssp2dc = !false;  add this on dec 15 2004
    (*plink).condspectra= !false;   ;0
    (*plink).Hmissed =!false
    (*plink).Hwysiwyg=!false
    (*plink).Hdeadtime = !true;   for do not use. ok.
    widget_control,wid.b.spectra1, sensitive = !false
    widget_control,wid.b.spectra2, sensitive = !false
endelse
end
'condspectra': begin
    (*plink).condspectra=event.value; added oct 24 2004.
    if (*plink).condspectra then begin
        (*plink).Hmissed =!false;  ;normal triiger mode
        (*plink).Hwysiwyg=!false;  ;this is wysiwyg_r
        (*plink).Hdeadtime = !true;   ;for do_not_use
        (*plink).addfssp2dc =!false   ;added this to avoid conflict
    endif
end
'addfssp2dc': begin
    (*plink).addfssp2dc=event.value; added nov 4 2004.
    ; I can make (*plink).adj_sel be adj option alway in here.
    if (*plink).addfssp2dc then begin
        (*plink).condspectra=!false;    Dec,2, moqixu
        ;(*pLink).Hmissed = !true    ; set the normal triiger mode. psd_nglib.

        (*plink).Hwysiwyg=!true;  ;this is wysiwyg_r
        widget_control,wid.b.type,set_value=3; set the wysiwyg_r mode button
    endif

end

'SizeType':begin
case event.value of
    1:(*pLink).HspectraType = 'adj'       ; for psd nglib.psd
    0:(*pLink).HspectraType = 'no_adj'
    else:
endcase
end
'Conctype':begin     ; I think this is for PSD_as_nglib  and wysisyg_r
case event.value of
    1: begin
        (*pLink).Hmissed = !true    ;  1 is for normal nglib psd or PSD_nglib
        (*pLink).Hdeadtime = !false
        (*pLink).Hwysiwyg = !false
        (*plink).condspectra = !false; added on oct 27 to avoid unneeded work.
    end
    2:begin      ; this is for not_use
    (*pLink).Hmissed = !false
    (*pLink).Hdeadtime = !true
    (*pLink).Hwysiwyg = !false
    (*plink).condspectra = !false; added on oct 27 to avoid unneeded work.
end
3:begin        ; this is for wysiwyg_r
(*pLink).Hmissed =   !false  ;october 7, 2004 to add wysisyg_r
(*pLink).Hdeadtime = !false
(*pLink).Hwysiwyg =  !true
(*plink).condspectra= !false ; added on oct 27 to avoid unneeded work.
end
endcase
end
;'compute':(*pLink).Hcompute = event.select
'output':begin
if(event.value eq 1)then begin
    (*pLink).output = !true
    widget_control,wid.base.output, sensitive = !true
    widget_control,wid.base.baseHide,sensitive = (*pLink).show
endif else begin
    (*pLink).output = !false
    (*pLink).show   = !false; added dec 15 2004.
    widget_control,wid.base.output, sensitive = !false
endelse
end
'print':(*pLink).Hprint = event.select
'tiff':(*pLink).HTiff = event.select
'ASCII':(*pLink).HASCII = event.select
'display2':(*pLink).display2 = event.select





'display1':begin
(*pLink).display1 = event.select; show png page on screen.
(*pLink).show = !true
widget_control,wid.base.baseHide,sensitive = (*pLink).show
end

'snd_png':begin; save png page to find.
(*pLink).sendTiff = event.select
if((*pLink).sendPrint or (*pLink).sendTiff)then (*pLink).show = !true else (*pLink).show = !false
widget_control,wid.base.baseHide,sensitive = (*pLink).show
end

'snd_print':begin; print png page to printer.
(*pLink).sendPrint = event.select
if((*pLink).sendPrint or (*pLink).sendTiff)then (*pLink).show = !true else (*pLink).show = !false
widget_control,wid.base.baseHide,sensitive = (*pLink).show
end


'snd_log':begin
(*pLink).sendASCII = event.select
if(event.select eq 1)then begin
    (*pLink).Format = 'new'
    if((*pTimeInfo).objData)then begin
        select = bytarr(50) + 1B
        select[47]=0   ; skip boundary
    endif else begin
        select = bytarr(50)
    endelse
    (*pLink).pSelect = ptr_new(select)
    widget_control,wID.b.ToLOG1, set_button = 1
    widget_control,wID.b.ToLOG2, set_button = 0
    widget_control,wID.b.ToLOG3, set_button = 0
endif else (*pLink).Format = ''
end
'frame_log':begin
(*pLink).sendASCII = 0
if event.select then (*pLink).sendASCII = 2
if(event.select eq 1)then begin
    (*pLink).Format = 'frame'
    widget_control,wID.b.ToLOG1, set_button = 0
    widget_control,wID.b.ToLOG2, set_button = 1
    widget_control,wID.b.ToLOG3, set_button = 0
    widget_control,wID.b.ToLOG4, set_button = 0
endif else (*pLink).Format = ''
end
'Combined_log':begin
(*pLink).sendASCII = 0
if event.select then (*pLink).sendASCII = 4

if(event.select eq 1)then begin
    (*pLink).Format = 'spec1'
    widget_control,wID.b.ToLOG1, set_button = 0
    widget_control,wID.b.ToLOG2, set_button = 0
    widget_control,wID.b.ToLOG3, set_button = 0
    widget_control,wID.b.ToLOG4, set_button = 1
endif else (*pLink).Format = ''

end

'hertz_log':begin
(*pLink).sendASCII = event.select
if(event.select eq 1)then begin
    (*pLink).Format = 'hertz'
    widget_control,wID.b.ToLOG1, set_button = 0
    widget_control,wID.b.ToLOG2, set_button = 0
    widget_control,wID.b.ToLOG3, set_button = 1
    widget_control,wID.b.ToLOG4, set_button = 0
endif else (*pLink).Format = ''
end
'snd_log_old':begin
(*pLink).sendASCII = event.select
if(event.select eq 1)then begin
    (*pLink).Format = 'old'
    widget_control,wID.b.ToLOG1, set_button = 0
    widget_control,wID.b.ToLOG2, set_button = 1
    widget_control,wID.b.ToLOG3, set_button = 0
    widget_control,wID.b.ToLOG4, set_button = 0
endif else (*pLink).Format = ''
end
'custom_log':begin
(*pLink).sendASCII = event.select
if(event.select eq 1)then begin
    ; this routine will allow the user to customize the ascii output
    (*pLink).Format = 'custom'
    ok= custom_log((*pLink).pSelect,event.top)
    (*pLink).sendASCII = ok
    widget_control,wID.b.ToLOG1, set_button = 0
    widget_control,wID.b.ToLOG2, set_button = 0
    widget_control,wID.b.ToLOG3, set_button = 1
endif else (*pLink).Format = ''
end
'addsize1':begin
(*pLink).addSize1 = not (*pLink).addSize1 ;!true
(*pLink).addSize2 = !false
(*pLink).addFocus = !false
(*pLink).addCutoff = !false
(*pLink).addRound = !false
(*pLink).addtype = !false
widget_control,wID.b.addSize1, set_button = (*pLink).addSize1
widget_control,wID.b.addSize2, set_button = (*pLink).addSize2
widget_control,wID.b.addfocus, set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
widget_control,wID.b.addround, set_button = (*pLink).addround
widget_control,wID.b.addtype, set_button = (*pLink).addtype
widget_control,wID.b.addtime, set_button = (*pLink).addtime
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end
'addsize2':begin
(*pLink).addSize1 = !false
(*pLink).addSize2 = not (*pLink).addSize2 ;!true
(*pLink).addFocus = !false
(*pLink).addCutoff = !false
(*pLink).addRound = !false
(*pLink).addtype = !false
widget_control,wID.b.addSize1, set_button = (*pLink).addSize1
widget_control,wID.b.addSize2, set_button = (*pLink).addSize2
widget_control,wID.b.addfocus, set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
widget_control,wID.b.addround, set_button = (*pLink).addround
widget_control,wID.b.addtype, set_button = (*pLink).addtype
widget_control,wID.b.addtime, set_button = (*pLink).addtime
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end
'addfocus':begin
(*pLink).addSize1 = !false
(*pLink).addSize2 = !false
(*pLink).addFocus = not (*pLink).addFocus ;!true
(*pLink).addCutoff = !false
(*pLink).addRound = !false
(*pLink).addtype = !false
widget_control,wID.b.addSize1, set_button = (*pLink).addSize1
widget_control,wID.b.addSize2, set_button = (*pLink).addSize2
widget_control,wID.b.addfocus, set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
widget_control,wID.b.addround, set_button = (*pLink).addround
widget_control,wID.b.addtype, set_button = (*pLink).addtype
widget_control,wID.b.addtime, set_button = (*pLink).addtime
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end
'addcutoff':begin
(*pLink).addSize1 = !false
(*pLink).addSize2 = !false
(*pLink).addFocus = !false
(*pLink).addCutoff = not (*pLink).addCutoff ;!true
(*pLink).addRound = !false
(*pLink).addtype = !false
widget_control,wID.b.addSize1, set_button = (*pLink).addSize1
widget_control,wID.b.addSize2, set_button = (*pLink).addSize2
widget_control,wID.b.addfocus, set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
widget_control,wID.b.addround, set_button = (*pLink).addround
widget_control,wID.b.addtype, set_button = (*pLink).addtype
widget_control,wID.b.addtime, set_button = (*pLink).addtime
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end
'addround':begin
(*pLink).addSize1 = !false
(*pLink).addSize2 = !false
(*pLink).addFocus = !false
(*pLink).addCutoff = !false
(*pLink).addRound = not (*pLink).addRound ;!true
(*pLink).addtype = !false
widget_control,wID.b.addSize1, set_button = (*pLink).addSize1
widget_control,wID.b.addSize2, set_button = (*pLink).addSize2
widget_control,wID.b.addfocus, set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
widget_control,wID.b.addround, set_button = (*pLink).addround
widget_control,wID.b.addtype, set_button = (*pLink).addtype
widget_control,wID.b.addtime, set_button = (*pLink).addtime
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end
'addcrystal':begin
(*pLink).addSize1 = !false
(*pLink).addSize2 = !false
(*pLink).addFocus = !false
(*pLink).addCutoff = !false
(*pLink).addRound = !false
(*pLink).addtype = not (*pLink).addtype ;!true
widget_control,wID.b.addSize1,    set_button = (*pLink).addSize1
widget_control,wID.b.addSize2,    set_button = (*pLink).addSize2
widget_control,wID.b.addfocus,    set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff,   set_button = (*pLink).addcutoff
widget_control,wID.b.addround,    set_button = (*pLink).addround
widget_control,wID.b.addtype,     set_button = (*pLink).addtype
widget_control,wID.b.addtime,     set_button = (*pLink).addtime
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end
'addtimelabel':begin
(*pLink).addtime = not (*pLink).addtime ;!true
widget_control,wID.b.addSize1,  set_button = (*pLink).addSize1
widget_control,wID.b.addSize2,  set_button = (*pLink).addSize2
widget_control,wID.b.addfocus,  set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff, set_button = (*pLink).addcutoff
widget_control,wID.b.addround,  set_button = (*pLink).addround
widget_control,wID.b.addtype,   set_button = (*pLink).addtype
widget_control,wID.b.addtime,   set_button = (*pLink).addtime
end

'addHexlabel':begin
;(*pLink).accept = !true ; TAF program would crash unless you checked the Particle Aceeptance Criteria button, adding this prevents crash but could be confusing if there is a string in the text field.  Not sure how to proceed.
(*pLink).addHextime = not (*pLink).addHextime ;!true
widget_control,wID.b.addSize1,   set_button = (*pLink).addSize1
widget_control,wID.b.addSize2,   set_button = (*pLink).addSize2
widget_control,wID.b.addfocus,   set_button = (*pLink).addfocus
widget_control,wID.b.addcutoff,  set_button = (*pLink).addcutoff
widget_control,wID.b.addround,   set_button = (*pLink).addround
widget_control,wID.b.addtype,    set_button = (*pLink).addtype
widget_control,wID.b.addHextime, set_button = (*pLink).addHextime
end


'skip':begin
widget_control,wid.f.SecSkip,get_value = temp
(*pLink).skip = temp
r = dialog_message('Not implemented yet!',/info)
end
'plotPrint':(*pLink).TplotPrint = event.select
'plotASCII':(*pLink).TplotASCII = event.select
'plotTiff':(*pLink).TplotTiff = event.select
'sample':begin
widget_control,wid.f.sample,get_value = temp
(*pLink).sample = temp > 1
end
'time':begin
; if(event.value eq 1)then begin   ; old way only has two buttons: off on
if(event.value gt 0)then begin   ; new way has three buttns. off, on/no_adj, on/adj
    (*pLink).time = !true           ; value is 0, 1, and 2. in pro TimePeriodGUI.
    if event.value eq 1 then (*plink).adj_sel=0; added august 11, 2004--for no_adj
    if event.value eq 2 then (*plink).adj_sel=0; added august 11, 2004--for yes_adj; changed to 0 on june 9, 2009.
    if event.value eq 3 then (*plink).adj_sel=2; added october 11, 2004 for wysisyg_r
    widget_control,wid.b.time, sensitive = !true
endif else begin
    (*pLink).time = !false
    widget_control,wid.b.time, sensitive = !false
endelse
end
'tas':begin
widget_control,wid.f.tas,get_value = temp
(*pLink).TAS = temp

end

'tConc1':(*pLink).Tconc1 = event.select
'tConc2':(*pLink).Tconc2 = event.select

'tLWC1':(*pLink).TLWC1 = event.select
'tLWC2':(*pLink).TLWC2 = event.select
'tIWC1':(*pLink).TIWC1 = event.select
'tIWC2':(*pLink).TIWC2 = event.select
'IVCTS':(*pLink).TPaul = event.select
'WYSIWYG':(*pLink).TBrad =event.select
'tMean':(*pLink).Tmean = event.select
'tMax':(*pLink).Tmax = event.select
'tMaxLen':(*pLink).TmaxLen = event.select
'trate1':(*pLink).Trate1 = event.select
'trate2':(*pLink).Trate2 = event.select
'trate3':(*pLink).Trate3 = event.select
'trate4':(*pLink).Trate4 = event.select
'trate5':(*pLink).Trate5 = event.select
'trate6':(*pLink).Trate6 = event.select
'pds45':(*pLink).Tpds45 = event.select
'pds90':(*pLink).Tpds90 = event.select
'transit':(*pLink).Ttransit = event.select
'shdDepth':(*pLink).Tdepth = event.select
'imgmn':(*pLink).Timgmn = event.select
'back':(*pLink).Tback = event.select

else:r=dialog_message('Error in time process gui handler')
endcase
;stop;  ;for every click in the tool window, the program goes to here.
end   ;end of time**gui_event

pro initpTimeInfo, pStateInfo,MULTIPLE=MULTIPLE

    forward_function  convertToseconds

    month =((*pStateInfo).date.month);  added this on Dec. 6, 2011.
    first_time = {times}
    ; get first frame time
    first_time= convertFromSeconds((*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[0]].hTime,(*pStateInfo).fileHead.year)
    first_time.msec = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[0]].msec

    ;*************************************************************************************
    ;re_do above;   mo added following in nov. 15, 2011.
    imgList = (*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]
    nnnn=n_elements(imglist);  how many frames we have.
    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[0].fpos,date=(*pStateInfo).date, TSBlanked = imglist[0].TSBlanked)
    first_Time.day   =framedata.FrameHeader.day
    first_Time.hour  =framedata.FrameHeader.hour
    first_Time.minute=framedata.FrameHeader.minute
    first_Time.sec   =framedata.FrameHeader.sec
    first_Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    first_Time.month=month
    ;**************************************************************************************************************************************

    ;get last frame time
    last_frame = n_elements((*(*pStateInfo).pImgPosIndx)) - 1
    last_time = {times}
    last_time = convertFromSeconds((*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame]].hTime,(*pStateInfo).fileHead.year)
    last_time.msec = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame]].msec

    ;*************************************************************************************
    ;*************************************************************************************
    ;re_do above;   mo added following in nov. 15, 2011.
    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[last_frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[last_frame].TSBlanked)
    last_Time.day   =framedata.FrameHeader.day
    last_Time.hour  =framedata.FrameHeader.hour
    last_Time.minute=framedata.FrameHeader.minute
    last_Time.sec   =framedata.FrameHeader.sec
    last_Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
    last_Time.month=month
    ;**************************************************************************************************************************************



    if last_frame gt 1   then begin
        nextTolast_time = {times}
        nextTolast_time = convertFromSeconds((*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame-2]].hTime,(*pStateInfo).fileHead.year)
        nextTolast_time.msec = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame-2]].msec
        ;*************************************************************************************
        ;re_do above;   mo added following in nov. 15, 2011.
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[last_frame-2].fpos,date=(*pStateInfo).date, TSBlanked = imglist[last_frame-2].TSBlanked)
        nextTolast_Time.day   =framedata.FrameHeader.day
        nextTolast_Time.hour  =framedata.FrameHeader.hour
        nextTolast_Time.minute=framedata.FrameHeader.minute
        nextTolast_Time.sec   =framedata.FrameHeader.sec
        nextTolast_Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        nextTolast_Time.month =month
        ; this correction handles the case when a background from another file is appended to the file end
        nextToLast = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame-2]].hTime;   This is seconds over the year.
        last = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame]].hTime

    endif else begin
        nextTolast_time = {times}
        if last_frame eq 0 then begin
            rrr=dialog_message('Only one Frame in this file ! may crash, do not use this file',/info)
        end
        nextTolast_time = convertFromSeconds((*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame-1]].hTime,(*pStateInfo).fileHead.year)
        nextTolast_time.msec = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame-1]].msec
        nextToLast = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame-1]].hTime
        last       = (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame]].hTime
        ;re_do above;   mo added following in nov. 15, 2011.
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[last_frame-1].fpos,date=(*pStateInfo).date, TSBlanked = imglist[last_frame-1].TSBlanked)
        nextTolast_Time.day   =framedata.FrameHeader.day
        nextTolast_Time.hour  =framedata.FrameHeader.hour
        nextTolast_Time.minute=framedata.FrameHeader.minute
        nextTolast_Time.sec   =framedata.FrameHeader.sec
        nextTolast_Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        nextTolast_Time.month =month
    endelse;   added this on January 4, 2008.  for ICeL_lear data CPI.

    if(nextToLast gt last or (*(*pStateInfo).pFileScan)[(*(*pStateInfo).pImgPosIndx)[last_frame]] .imgtype eq 2)then Last_Time = nextToLast_time

    ; set current frame time   (*Pstateinfo).PIMGPOSINDX  are imglist --from all frames.   (*Pstateinfo).imgpos is the current Frame.


    current_Time = {times}
    if not multiple then begin
        current_Time = convertFromSeconds((*(*pStateInfo).pframeData).frameheader.Time,(*pStateInfo).fileHead.year)
        current_Time.msec  = ROUND(CalcStrobeTime((*(*pStateInfo).pframeData).frameheader.ArrivalT1, (*(*pStateInfo).pframeData).frameheader.ArrivalT2,(*(*pStateInfo).pframeData).frameheader.Ver))
        ; redo- above as following.
        current_frame =(*Pstateinfo).imgpos
        frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,imgList[current_frame].fpos,date=(*pStateInfo).date, TSBlanked = imglist[current_frame].TSBlanked)
        current_Time.day   =framedata.FrameHeader.day
        current_Time.hour  =framedata.FrameHeader.hour
        current_Time.minute=framedata.FrameHeader.minute
        current_Time.sec   =framedata.FrameHeader.sec
        current_Time.msec  =framedata.FrameHeader.msec; ;   HOUR =   14;  MINUTE=0; SEC= 11;MSEC=  791  from frameHeader.
        current_Time.month =month
    endif

    if(ptr_valid((*pStateInfo).pTimeInfo))then begin
        if((*(*pStateInfo).pTimeInfo).periods gt 1)then r= dialog_message('Multiple period INIT not supported yet')
        ; linked list already defined from a previous pass, use info here
        pLink = find_first_link((*(*pStateInfo).pTimeInfo).pCurrent_link)
    endif else begin
        pLink = create_link()
        (*pLink).stop = last_time
        (*pLink).start = first_time
        (*pLink).pSelect = ptr_new(bytarr(50))
        (*pLink).habit = 0

    endelse

    start_time = convertToseconds((*pLink).start,(*pStateInfo).FileHead.year)
    stop_time = convertToseconds((*pLink).stop,(*pStateInfo).FileHead.year)
    (*Plink).sumint = (Stop_time -Start_time) >1;    added these 3 line in 2014-08-12.  Mo  for PSDs .

    if((*pStateInfo).autoextract)then begin
        variables = ['len','wid','area','perim','Roundness1','Roundness2','Roundness3','focus','focusMin','focusMax','focusSTDDEV','CutOff','Crystal','P1','holearea','Reject','h1','h2','h3','h4','h5','h6']
    endif else begin
        variables = ['len','wid','Focus','CutOff','Crystal','Reject']
    endelse

    ; use pointer to time info structure from state variable

    (*pStateInfo).pTimeInfo = ptr_new({    periods:1,$          ; number of time periods to process
        cur_per:1,$              ; which time period are we in
        variables:variables,$   ; variables used in the decision list
        last:last_time,$
        first:first_time,$
        current:current_time,$
        objData:ptr_valid((*pStateInfo).pObjList),$    ; true if obj data is avaialble
        pCurrent_link:pLink,$
        mode:(*pStateInfo).autoextract,$
        pwid:ptr_new(),$             ; widget iD only valid in GUI code
        time:current_Time,$         ; input variable from viewer
        process:!false})      ; to process or not!
end

pro TimePeriodGUI, pStateInfo
    ; purpose: to get user input for displaying data plots
    ; parameters
    ;   pStateInfo structure used for both input and output via pTimeInfo

    ;forward_function CalcStrobeTime,initpTimeInfo ; TAF commenting for .sav, also unresolved

    initpTimeInfo, pStateInfo,multiple=0
    ;defsysv, '!imglist',(*((*pStateInfo).pFileScan))[*((*pStateInfo).pImgPosIndx)]


    tlb = widget_base(title='Specify Plotting Options',/col)

    b0 = widget_base(tlb,/row,/frame)
    proc = widget_button(b0,value='Process',uvalue ='process')
    close = widget_button(b0,value='Close',uvalue ='close')

    label    = widget_label(b0,value = 'Project:',ysize = 20)
    project_ID = widget_text(b0,value=!project_name,/editable,/all,uvalue='ProjectName',xsize = 20)
    label     = widget_label(b0,value = 'Platform:',ysize = 20)
    Platform_ID=widget_text(b0,value=!platform,/editable,/all,uvalue='Platform',xsize = 20)
    label     = widget_label(b0,value = 'R#(R0,R1,ect):',ysize = 20)
    Revision_ID=widget_text(b0,value=!Revision_X,/editable,/all,uvalue='Revision_X',xsize = 20)
    ;b0a = widget_base(tlb,/row)
    ;b1 = widget_base(b0a,/row,/frame)
    ;   perCnt = widget_text(b1,value='1 Time Period')
    ;    dec = widget_button(b1,value='Decrease',uvalue ='decrease')
    ;   inc = widget_button(b1,value='Increase',uvalue ='increase')


    ;b2 = widget_base(b0a,/row,/frame)
    ;    perNum = widget_text(b2,value='Time Period 1 of 1')
    ;      prev = widget_button(b2,value='Prev',uvalue ='previous')
    ;    next = widget_button(b2,value='Next',uvalue ='next')

    b3 = widget_base(tlb,/col,/frame)
    b30 = widget_base(b3,/row)
    b31 = widget_base(b30,/col)
    label = widget_label(b31,value = '                    month        day           hour          minute       sec         Select Frame Time',/align_left)

    box_size = 5
    b311 = widget_base(b31,/row)
    StrMon = cw_field(b311,title= 'Start Time:',value = 0,/int,xsize=box_size,uvalue ='start',/all)
    StrDay = cw_field(b311,title=':',value=0,/int,xsize=box_size,uvalue ='start',/all)
    StrHr  = cw_field(b311,title=':',value=0,/int,xsize=box_size,uvalue ='start',/all)
    StrMin = cw_field(b311,title=':',value=0,/int,xsize=box_size,uvalue ='start',/all)
    StrSec = cw_field(b311,title=':',value=0,/int,xsize=box_size,uvalue ='start',/all)
    first = widget_button(b311,value='First',uvalue = 'first')
    current = widget_button(b311,value='Current',uvalue='current1')

    b312 = widget_base(b31,/row)
    StpMon = cw_field(b312,title= 'Stop Time:',value = 0,/int,xsize=box_size,uvalue ='stop',/all)
    StpDay = cw_field(b312,title=':',value=0,/int,xsize=box_size,uvalue ='stop',/all)
    StpHr  = cw_field(b312,title=':',value=0,/int,xsize=box_size,uvalue ='stop',/all)
    StpMin = cw_field(b312,title=':',value=0,/int,xsize=box_size,uvalue ='stop',/all)
    StpSec = cw_field(b312,title=':',value=0,/int,xsize=box_size,uvalue ='stop',/all)
    current = widget_button(b312,value='Current',uvalue='current2')
    last = widget_button(b312,value='Last',uvalue = 'last')
    b313 = widget_base(b30,/col,/frame)
    lab = widget_label(b313,value='Enter the airspeed for all calculations')
    tas = cw_field(b313,title='Air Speed (m/sec):',value=150.0,/float,xsize=10,uvalue ='tas',/all)
    ;waittime  = cw_field(b313,title='seconds to keep images up',value=1,/int,xsize=3,uvalue ='waittime',/all)

    ;(*pStateInfo).waittime = waittime

    b34 = widget_base(b3,/col,/frame);, sensitive = (*pStateInfo).AUTOEXTRACT
    b340 = widget_base(b34,/row)
    label = widget_label(b340,value = 'Particle Acceptance Criteria')
    b341 = widget_base(b340,/exclusive,/row)
    off = widget_button(b341,value='Off',uvalue ='acceptanceOff')
    on = widget_button(b341,value='On',uvalue ='acceptanceOn')
    Clear = widget_button(b341,value='CL',uvalue ='acceptanceClear')

    baccept1 = widget_base(b340,/row,sensitive = 0)
    if((*pStateInfo).autoextract)then begin
        variables = ['len','wid','area','perim','Roundness1','Roundness2','Roundness3','focus','focusMin','focusMax','focusSTDDEV','CutOff','Crystal','P1','holearea','Reject','h1','h2','h3','h4','h5','h6']
    endif else begin
        variables = ['len','wid','Focus','CutOff','Crystal','Reject']
    endelse
    label = widget_label(baccept1, value='Variables')
    vDList = widget_droplist(baccept1,value=variables,uvalue='dl')
    save = widget_button(baccept1,value='Save',uvalue='save')
    load = widget_button(baccept1,value='Load',uvalue='load')
    widget_control,off,set_button = !true
    label = widget_label(b340, value='Make changes to crystal habit?')
    b342 = widget_base(b340,/exclusive,/row)

    off = widget_button(b342,value='Off',uvalue ='habitOff')
    on = widget_button(b342,value='On',uvalue ='habitOn')

    ;drop = widget_droplist(b340,value =string(indgen(31)+1), uvalue = "habitNum",sensitive=0)
    drop = widget_droplist(b340,value =(*pStateInfo).crystalName, uvalue = "habitNum",sensitive=0)

    baccept2 = widget_base(b34,/row,sensitive = 0)
    label = widget_label(baccept2,value = 'If',ysize = 30)
    criteria = widget_text(baccept2,value='',/editable,/all,uvalue='criteria',xsize = 90,/scroll)
    label =  widget_label(baccept2,value='then Accept',ysize = 30)


    b35 = widget_base(b3,/col,/frame)
    b350 = widget_base(b35,/row)
    butns = ['Off','On']
    spectraSelect = CW_BGroup(b350,butns,/exclusive,/row, label_left='Particle Size Distributions',/no_release,uvalue = 'spectra')

    SPECTRA1 = widget_base(b350,/row, sensitive = !false)
    sumInt = cw_field(SPECTRA1,title = 'Summing Interval (Seconds)',value=60,/INT,xsize = 4,uvalue ='sum_int',/all)
    b3521 = widget_base(SPECTRA1,/row,/nonexclusive,/frame)
    print = widget_button(b3521,value='Send to Printer',uvalue ='print')
    tiff = widget_button(b3521,value='Create png File',uvalue ='tiff') ; png file now even though TIFF still appears
    ascii = widget_button(b3521,value='Create ASCII file',uvalue ='ASCII')
    SPECTRA2 = widget_base(b35,/row, sensitive = !false)
    butns = ['adj/no','adj/no']  ;changed from amx and mean to adj/no and adj_yes  august 23 2004.
    SizeType = CW_BGroup(SPECTRA2,butns,/row,/exclusive,/frame,button_uvalue=[1,0],/no_release,uvalue='SizeType')
    widget_control,SizeType,set_value=1;  added this line in june 9, 2009.
    ; butns = ['Tot. Stobe Scaled','Dead Time Scaled','WYSIWYG Scaled']
    ; type = CW_BGroup(SPECTRA1,butns,/row,/exclusive,/frame,button_uvalue=[1,2,3],uvalue='Conctype',/no_release)
    butns = ['PSD','wysiwyg_r','Not_Use'];    reserved for future use 'WYSIWYG Scaled']
    type = CW_BGroup(SPECTRA2,butns,/row,/exclusive,/frame,button_uvalue=[1,3,2],uvalue='Conctype',/no_release)
    widget_control,type,set_value=2

    butns=['off','on'];    ; may be above 1, 3, 2 need to changed to 0,1,2 see above 0,1,2 set when (*plink).Hmissed
    condspectra_str='Conditional PSD:'

    condspectra=CW_Bgroup(SPECTRA2,butns,/row,/exclusive,/frame,button_uvalue=[0,1],$
        uvalue='condspectra',label_left=condspectra_str)
    ;********************************************************************************
    widget_control,condspectra,set_value=0
    ;********************************************************************************


    butns=['off','on']
    addfssp2dc_str='Add_PMS_PSD:'

    addfssp2dc=CW_Bgroup(SPECTRA2,butns,/row,/exclusive,/frame,button_uvalue=[0,1],$
        uvalue='addfssp2dc',label_left=addfssp2dc_str)
    ;********************************************************************************
    widget_control,addfssp2dc,set_value=0
    ;********************************************************************************


    b36 = widget_base(b3,/col,/frame)
    ;label = widget_label(b36,value = 'Output Options',/align_left)
    butns = ['Off','On']
    outputSelect = CW_BGroup(b36,butns,/exclusive,/row, label_left='Output Options (All times (displayed, in outpout ascii files) are original, except stated offset in image png page) ',/no_release,uvalue = 'output')
    b361 = widget_base(b36,/row,sensitive = !false)
    ;display2 = widget_button(b361,value='Display Frames',uvalue ='display2')

    b3611 = widget_base(b361,/row,/frame)
    b361a = widget_base(b3611,/col)
    label = widget_label(b361a,value='Imaging options',/align_left)
    b361b = widget_base(b361a,/col,/nonexclusive)
    display1 = widget_button(b361b,value='Flash png Images when created',uvalue ='display1')
    ToTiff = widget_button(b361b,value='Send Accepted Particles to png files',uvalue ='snd_png')
    toPrint = widget_button(b361b,value='Send Accepted Particle Images To Printer',uvalue ='snd_print')


    baseHide = widget_base(b3611,sensitive = !false,/col)
    label = widget_label(baseHide,value='Parameter added to pngs',/align_left)
    outBase = widget_base(baseHide,col=2,/nonexclusive,/frame);,sensitive = ptr_valid((*pStateInfo).pObjList)
    addSize1 = 0;  widget_button(outBase,value='Max Length',uvalue ='addsize1')
    addSize2 = 0;  widget_button(outBase,value='Mean Length',uvalue ='addsize2')
    addfocus = widget_button(outBase,value='Focus',uvalue ='addfocus')
    addcutoff = widget_button(outBase,value='Cut-Off %',uvalue ='addcutoff')
    addtype = 0; widget_button(outBase,value='Crystal type',uvalue ='addcrystal')
    addround =0;  widget_button(outBase,value='Roundness',uvalue ='addround',sensitive =(*pStateInfo).autoextract )
    addtime = widget_button(outBase,value='Time label',uvalue ='addtimelabel')
    addHexTime = 0; widget_button(outBase,value='HexTime',uvalue ='addHexlabel')

    b362 = widget_base(b361,/col,/frame)
    label = widget_label(b362,value='LOG file options',/align_left)
    b362a = widget_base(b362,/col,/nonexclusive)
    toLOG1 = widget_button(b362a,value='Particle ASCII LOG file',uvalue ='snd_log')
    toLOG2 = widget_button(b362a,value='Frame ASCII LOG file',uvalue ='frame_log')
    toLOG3 = widget_button(b362a,value='Hertz Information',uvalue ='hertz_log',sensitive =(*pStateInfo).autoextract )
    toLOG4 = widget_button(b362a,value='Combined ASCII LOG file (default)',uvalue ='Combined_log')


    ;SecSkip = cw_field(b36,title = 'Seconds to Skip Between Frames:',value=0,/INT,xsize=4,uvalue ='skip',/all)


    b37 = widget_base(b3,/col,/frame)
    butns = ['Off','On/no_adj','on/no_adj','wysiwyg_r'] ;added wysiswyg_r on october 11, 2004
    TimeSelect = CW_BGroup(b37,butns,/exclusive,/row, label_left='Compute Time Series (Warning !!! Time in the output Time series file is oringinal Times.)',$
        /no_release,button_uvalue=[0,1,2,3],uvalue = 'time') ;added button_uvalue on august 11th, 2004.
    time = widget_base(b37,/col, sensitive = !false) ; then in Pro TimePeriodGUI_event, "if * eq 1 sobe change to * gt 0."

    b37a = widget_base(time,/row)

    b373 = widget_base(b37a,col=5,/nonexclusive)
    tConc2 = widget_button(b373,value = 'Concntratn',uvalue ='tConc1')
    tConc1 = widget_button(b373,value = 'Extinction',uvalue ='tConc2')
    ; above two lines modified july 15, 2004.
    tMax = widget_button(b373,value = 'Ave.Max.Length',uvalue ='tMax')
    tMaxlen = widget_button(b373,value = 'Max. Length',uvalue ='tMaxLen')
    tMean = widget_button(b373,value = 'Radar.dBz',uvalue ='tMean')
    timgmn = widget_button(b373,value = 'Image Mean',uvalue ='imgmn')

    tRate1 = widget_button(b373,value = 'Tot. Frms',uvalue ='trate1')
    tRate2 = widget_button(b373,value = 'Saved Frms',uvalue ='trate2')
    tRate3 = widget_button(b373,value = 'Liq.dBz',uvalue ='trate3')

    tRate5 = widget_button(b373,value = 'Accepted Particles',uvalue ='trate5')
    tRate4 = widget_button(b373,value = 'Tot. Strobes',uvalue ='trate4')
    tRate6 = widget_button(b373,value = 'Accepted Particles/Tot. Strobes',uvalue ='trate6')

    tPaul = widget_button(b373,value = 'Ice.dBz',uvalue ='IVCTS')
    tBrad = widget_button(b373,value = 'DonotUse',uvalue ='WYSIWYG')

    tLWC1 = widget_button(b373,value = 'LWC',uvalue ='tLWC1') ;modifed august 18/04
    tIWC1 = widget_button(b373,value = 'IWC',uvalue ='tIWC1') ;modified August18/04
    tLWC2 = widget_button(b373,value = 'TWC',uvalue ='tLWC2')  ;modified oct 21/04
    tIWC2 = widget_button(b373,value = 'DoNotUse',uvalue ='tIWC2')

    ;tback = widget_button(b373,value = 'Background locations',uvalue ='back')

    b372 = widget_base(time,/row)
    ; sample = cw_field(b372,title='Sampling Period (Secs):',value=60,/int,xsize=6,uvalue ='sample',/all)
    sample = cw_field(b372,title='Sampling Period (Secs):',value=1,/int,xsize=6,uvalue ='sample',/all)

    b371 = widget_base(time,/row,/nonexclusive)
    plotPrint = widget_button(b371,value='Plot to Printer',uvalue ='plotPrint')
    plotASCII = widget_button(b371,value='Plot to ASCII file',uvalue ='plotASCII')
    plotTiff = widget_button(b371,value='Plot to png file',uvalue ='plotTiff') ; now png file even though still use TIFF words

    widget_control,tlb,/realize


    ; save some widget ID's t:{perCnt:perCnt,perNum:perNum},start:[StrMon,StrDay,StrHr,StrMin,StrSec,StrMSec],stop:[StpMon,StpDay,StpHr,StpMin,StpSec,StpMSec],$
    if((*pStateInfo).autoextract)then begin
        wID={ start:[StrMon,StrDay,StrHr,StrMin,StrSec],stop:[StpMon,StpDay,StpHr,StpMin,StpSec],$;t:{perCnt:perCnt,perNum:perNum},
            f:{sumInt:sumInt,sample:sample,tas:tas,criteria:criteria},$;waittime:waittime},$ ;;SecSkip,
            b:{ off:off,on:on,Clear:Clear,$
            spectraSelect:spectraSelect,spectra1:spectra1,spectra2:spectra2,type:type,sizeType:sizeType,$
            outputSelect:outputSelect,print:print,tiff:tiff,ascii:ascii,$

            ;display1:display1,display2:display2,toPrint:toPrint,ToTiff:ToTiff,addSizes:addSizes,$
            display1:display1,toPrint:toPrint,ToTiff:ToTiff,toLOG1:toLOG1,toLOG2:toLOG2,toLOG3:toLOG3,toLOG4:toLOG4,$
            addSize1:addSize1,addSize2:addSize2,$ ; display2:display2,
            addfocus:addfocus,addcutoff:addcutoff,addtype:addtype,addtime:addtime,addHextime:addHextime,addround:addround,$
            plotPrint:plotPrint,plotASCII:plotASCII,plotTiff:plotTiff,$

            timeSelect:timeSelect,time:time,project_ID:project_ID,platform_Id:platform_ID,revision_ID:revision_ID,$
            tConc1:tConc1,tConc2:tConc2,tMean:tMean,tMax:tMax,tMaxLen:tMaxLen,trate1:trate1,trate2:trate2,trate3:trate3,trate4:trate4,$
            trate5:trate5,trate6:trate6,timgmn:timgmn,tLWC1:tLWC1, tIWC1:tIWC1,tLWC2:tLWC2, tIWC2:tIWC2,tPaul:tPaul,tBrad:tBrad},$

            ;trate5:trate5,trate6:trate6,adj_el:adj_sel,timgmn:timgmn,tLWC1:tLWC1, tIWC1:tIWC1,tLWC2:tLWC2, tIWC2:tIWC2,tPaul:tPaul,tBrad:tBrad},$
            ;trate5:trate5,trate6:trate6,timgmn:timgmn, tLWC1:tLWC1, tIWC1:tIWC1,tLWC2:tLWC2, tIWC2:tIWC2,tPaul:tPaul,tBrad:tBrad},$
            ;trate5:trate5,trate6:trate6,tpds45:tpds45,tpds90:tpds90,tdepth:tdepth,ttransit:ttransit,timgmn:timgmn},$  ; tback:tback},$

            base:{baccept1:baccept1,baccept2:baccept2,bhabit:drop,baseHide:baseHide,output:b361}};b1:b1,b2:b2

    endif else begin
        wID={ start:[StrMon,StrDay,StrHr,StrMin,StrSec],stop:[StpMon,StpDay,StpHr,StpMin,StpSec],$;t:{perCnt:perCnt,perNum:perNum},
            f:{sumInt:sumInt,sample:sample,tas:tas,criteria:criteria},$
            b:{ off:off,on:on,Clear:Clear,$
            spectraSelect:spectraSelect,spectra1:spectra1,spectra2:spectra2,type:type,sizeType:sizeType,$
            outputSelect:outputSelect,print:print,tiff:tiff,ascii:ascii,$
            display1:display1,toPrint:toPrint,ToTiff:ToTiff,toLOG1:toLOG1,toLOG2:toLOG2,toLOG3:toLOG3,toLOG4:toLOG4,$
            addSize1:addSize1,addSize2:addSize2,$
            addfocus:addfocus,addcutoff:addcutoff,addtype:addtype,addtime:addtime,addHextime:addHextime,addround:addround,$
            plotPrint:plotPrint,plotASCII:plotASCII,plotTiff:plotTiff,$

            timeSelect:timeSelect,time:time,project_ID:project_ID,platform_Id:platform_ID,revision_ID:revision_ID,$
            tConc1:tConc1,tConc2:tConc2,tMean:tMean,tMax:tMax,tMaxLen:tMaxLen,trate1:trate1,trate2:trate2,trate3:trate3,trate4:trate4,$
            trate5:trate5,trate6:trate6,adj_sel:adj_sel,timgmn:timgmn,tPaul:tPaul,tBrad:tBrad},$

            base:{baccept1:baccept1,baccept2:baccept2,baseHide:baseHide,output:b361}};b1:b1,b2:b2
    endelse

    (*(*pStateInfo).pTimeInfo).pwID = ptr_new(wID)

    update,(*(*pStateInfo).pTimeInfo).pCurrent_Link,wID,mode = (*pStateInfo).autoextract

    ; save into uvalue of tlb
    widget_control,tlb,set_uvalue = (*pStateInfo).pTimeInfo

    xmanager,'TimePeriodGUI',tlb

end


