PRO TimeSeriesWidget_event, ev

    FORWARD_FUNCTION WriteDataToFile

    WIDGET_CONTROL, ev.top, GET_UVALUE=LocalState, /NO_COPY

    sname = TAG_NAMES(ev, /STRUCTURE_NAME)

    case sname of
        'WIDGET_BASE':begin
        WIDGET_CONTROL, ev.top, xsize=ev.x>550, ysize=ev.y>375
        WIDGET_CONTROL, LocalState.drawarea, xsize=(ev.x - 110) > 420, ysize=(ev.y - 100) >260
        plottimeseries, LocalState
    end
    'WIDGET_KILL_REQUEST':begin
    ;restore original color table
    tvlct,LocalState.red,LocalState.green,LocalState.blue
    tvlct,255,255,0,255
    widget_control, ev.top, /destroy
    return
end
else:begin
WIDGET_CONTROL, ev.id, GET_UVALUE = eventval
case eventval of
    'savetiff': plottimeseries, LocalState, OutPutFlags=2
    'savedatatofile': Ret = WriteDataToFile(LocalState)
    'print': begin
        if (NOT LocalState.printersetup) then LocalState.printersetup = DIALOG_PRINTERSETUP()

        if (LocalState.printersetup) then plottimeseries, LocalState, OutPutFlags=1
    end
    'exit': begin
        ;restore original color table
        tvlct,LocalState.red,LocalState.green,LocalState.blue
        tvlct,255,255,0,255
        widget_control, ev.top, /destroy
        return
    end
    'tminid': begin

        plottminprev = LocalState.plotSpecs.plottmin

        widget_control, LocalState.tminid, get_value=temp
        LocalState.plotSpecs.plottmin = temp

        rem = LocalState.plotSpecs.plottmin MOD LocalState.plotSpecs.plottstep

        if (rem gt 0) then begin

            if (LocalState.plotSpecs.plottmin ge plottminprev) then $
                incr = LocalState.plotSpecs.plottstep - rem $
                else $
                incr = -rem

            LocalState.plotSpecs.plottmin = LocalState.plotSpecs.plottmin + incr
            if (LocalState.plotSpecs.plottmin lt LocalState.plotSpecs.taxismin)then LocalState.plotSpecs.plottmin = LocalState.plotSpecs.taxismin
        endif

        if (LocalState.plotSpecs.plottmin ge LocalState.plotSpecs.plottmax) then begin

            if (LocalState.plotSpecs.plottmin le (LocalState.plotSpecs.taxismax - LocalState.plotSpecs.plottstep)) then $
                LocalState.plotSpecs.plottmax = LocalState.plotSpecs.plottmin + LocalState.plotSpecs.plottstep $
                else begin
                LocalState.plotSpecs.plottmin = LocalState.plotSpecs.taxismax - LocalState.plotSpecs.plottstep
                LocalState.plotSpecs.plottmax = LocalState.plotSpecs.plottmin + LocalState.plotSpecs.plottstep
            endelse

            widget_control, LocalState.tmaxid, set_value=LocalState.plotSpecs.plottmax

        endif

        widget_control, LocalState.tminid, set_value=LocalState.plotSpecs.plottmin
        plottimeseries, LocalState


    end
    'tmaxid': begin

        plottmaxprev = LocalState.plotSpecs.plottmax

        widget_control, LocalState.tmaxid, get_value=temp
        LocalState.plotSpecs.plottmax = temp

        rem = LocalState.plotSpecs.plottmax MOD LocalState.plotSpecs.plottstep

        if (rem gt 0) then begin

            if (LocalState.plotSpecs.plottmax ge plottmaxprev) then $
                incr = LocalState.plotSpecs.plottstep - rem $
                else $
                incr = -rem

            LocalState.plotSpecs.plottmax = LocalState.plotSpecs.plottmax + incr
            if (LocalState.plotSpecs.plottmax gt LocalState.plotSpecs.taxismax) then LocalState.plotSpecs.plottmax = LocalState.plotSpecs.taxismax
        endif

        if (LocalState.plotSpecs.plottmax le LocalState.plotSpecs.plottmin) then begin

            if (LocalState.plotSpecs.plottmax ge (LocalState.plotSpecs.taxismin + LocalState.plotSpecs.plottstep)) then $
                LocalState.plotSpecs.plottmin = LocalState.plotSpecs.plottmax - LocalState.plotSpecs.plottstep $
                else begin
                LocalState.plotSpecs.plottmin = LocalState.plotSpecs.taxismin
                LocalState.plotSpecs.plottmax = LocalState.plotSpecs.plottmin + LocalState.plotSpecs.plottstep
            endelse

            widget_control, LocalState.tminid, set_value=LocalState.plotSpecs.plottmin

        endif

        widget_control, LocalState.tmaxid, set_value=LocalState.plotSpecs.plottmax
        plottimeseries, LocalState


    end
    'yminid': begin

        plotyminprev = LocalState.plotSpecs.plotymin
        LocalState.plotSpecs.plotymin = ev.value

        if(LocalState.plotSpecs.plotymin ge LocalState.plotSpecs.plotymax)then begin
            LocalState.plotSpecs.plotymin = plotyminprev
            widget_control, LocalState.yminid, set_value=plotyminprev
        endif
        plottimeseries, LocalState

    end
    'ymaxid': begin

        plotymaxprev = LocalState.plotSpecs.plotymax
        LocalState.plotSpecs.plotymax = ev.value

        if(LocalState.plotSpecs.plotymax le LocalState.plotSpecs.plotymin)then begin
            LocalState.plotSpecs.plotymax = plotymaxprev
            widget_control, LocalState.ymaxid, set_value=plotymaxprev
        endif
        plottimeseries, LocalState

    end
    'logscale': begin
        LocalState.ylogscale = ev.select
        IF(LocalState.ylogscale)THEN BEGIN
            LocalState.plotSpecs.plotymin = 10.^(fix(alog10(LocalState.plotSpecs.yaxismin))-1)
            widget_control, LocalState.yminid, set_value=LocalState.plotSpecs.plotymin
        ENDIF else begin
            widget_control, LocalState.yminid, set_value=LocalState.plotSpecs.yaxismin
        endelse
        plottimeseries, LocalState

    end

    else:
endcase
end
endcase

WIDGET_CONTROL, ev.top, SET_UVALUE=LocalState, /NO_COPY
end


;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output

pro PlotTimeSeries, LocalState, OutPutFlags=OutPutFlags

    ; Default is to send ouput to plot only
    IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

    ; Check data dims
    sz = size(LocalState.data)
    if (sz[0] lt 1) then begin
        print, 'No data in LocalState (PlotTimeSeries), Check sampling period'
        return
    endif
    ; How many dimensions: 1 or 2?
    IF sz[0] EQ 1 THEN begin
        nplots = 1
        if(sz[1] lt 2)then begin
            print,'Error, more than one data point is required'
            return
        endif
        y = LocalState.data[*]
    endif ELSE begin
        nplots = sz[1]
        if(sz[2] lt 2)then begin
            print,'Error, more than one data point is required'
            return
        endif
        y = LocalState.data[0,*]
    endelse

    nsteps = LocalState.nsteps
    Tstep = LocalState.Tstep

    x = INDGEN(nsteps)*Tstep

    file = strmid(localState.InFileName,rstrpos(localState.InFileName,'\')+1,strlen(localState.InFileName))
    titlestr = LocalState.xunits + ' (start time (h:m:s) = '+LocalState.TimeStr+ ') from:' + file

    WSET, LocalState.MViewID

    ; Do plots
    LabelStepX = (LocalState.plotSpecs.plottmax - LocalState.plotSpecs.plottmin)/100.0
    LabelStep = (LocalState.plotSpecs.plotymax - LocalState.plotSpecs.plotymin)/12

    ; load distinct colors
    tek_color
    color = 1

    xindx = where(x ge LocalState.plotSpecs.plottmin and x le LocalState.plotSpecs.plottmax,cnt)
    x = x[xindx]
    y = (reform(y))[xindx]

    plot, x, y, linestyle=0, COLOR=color, position=[.1,.1,.75,.9],$
        xtitle=titlestr, PSYM=-4,symsize=.3,$;PSYM=10, $
        title='Time Series', $
        xrange=[LocalState.plotSpecs.plottmin, LocalState.plotSpecs.plottmax], xstyle=1, $
        yrange=[LocalState.plotSpecs.plotymin, LocalState.plotSpecs.plotymax], ystyle=1, $
        ylog=LocalState.ylogscale;xlog=LocalState.tlogscale,
    ;XYOUTS, LocalState.plotSpecs.plottmax +LabelStepX, LocalState.plotSpecs.plotymax, LocalState.Labels[0], COLOR=Color, ALIGN=0.0
    XYOUTS, .76, .9, LocalState.Labels[0], COLOR=Color, ALIGN=0.0,/normal,font=0
    ;xyouts,x[0],y[0],strtrim(y[0],2),align=1.0
    ;plots,[.76,.9],[.89,.89],color=color,/normal


    ;zeroIndx=where(LocalState.data[1,*] eq 0 and LocalState.data[0,*] ne 0,cntxx)
    ;if(cntxx gt 0)then print,zeroindx,LocalState.data[0,zeroindx]

    IF (nplots gt 1) THEN BEGIN
        FOR i=1, nplots-1 DO BEGIN
            y = LocalState.data[i,*]
            y = (reform(y))[xindx]
            ;y = (y > LocalState.plotSpecs.plotymin)<LocalState.plotSpecs.plotymax
            oplot, x, y, linestyle=0, COLOR=Color+i ,PSYM=-4,symsize=.3;, PSYM=10
            XYOUTS, .76, .9 - i*.06, LocalState.Labels[i], COLOR=Color+i, ALIGN=0.0,/normal,font=0
            ;   plots,[.76,.9],[.89- i*.06,.89- i*.06],linestyle=i+1,color=color,/normal
        ENDFOR
    ENDIF

    ; Save image file?
    IF (OutPutFlags AND 2)/2 THEN BEGIN
        ; Create a filename
        ; Get Path
        NamePos = RSTRPOS(LocalState.InFileName, '.')
        IF NamePos GE 0 THEN BEGIN
            FileName = STRMID(LocalState.InFileName, 0, NamePos)
            FileName = FileName + '_' + strtrim(long(LocalState.starttime),2)
        ENDIF ELSE FileName = strtrim(long(LocalState.starttime),2)
        ;FileName = FileName + '_TS.tif'
        FileName = FileName + '_TS.png'

        ; Read in screen
        Buf = TVRD(true=1)
        ;tvlct,r,g,b,/get
        ;WRITE_TIFF, FileName, Buf;,red = r,green = g,blue = b
        buf = color_quan(buf,1,r,g,b)
        buf = rotate(temporary(buf),7)
        WRITE_png, FileName, Buf,r,g,b
    ENDIF
    ; Print it?
    IF OutPutFlags AND 1 THEN BEGIN
        IF NOT LocalState.PrinterSetup THEN LocalState.PrinterSetup = DIALOG_PRINTERSETUP()
        if(LocalState.PrinterSetup eq 1)then begin
            ; Switch to PRINTER output
            SET_PLOT, 'PRINTER'
            DEVICE, /LANDSCAPE

            ; How many dimensions: 1 or 2?
            IF sz[0] EQ 1 THEN begin
                nplots = 1
                if(sz[1] lt 2)then begin
                    print,'Error, more than one data point is required'
                    return
                endif
                y = LocalState.data[*]
            endif ELSE begin
                nplots = sz[1]
                if(sz[2] lt 2)then begin
                    print,'Error, more than one data point is required'
                    return
                endif
                y = LocalState.data[0,*]
            endelse

            color = 0

            x = (x > LocalState.plotSpecs.plottmin)<LocalState.plotSpecs.plottmax
            ;y = (y > LocalState.plotSpecs.plotymin)<LocalState.plotSpecs.plotymax
            ; Do plots
            PLOT, x, y, linestyle=1, COLOR=Color, xthick=3,ythick=3,charthick=3,$
                xtitle=titlestr, PSYM=-4,symsize=.3, thick=3,$
                title='Time Series', position=[.1,.1,.75,.9], $
                xrange=[LocalState.plotSpecs.plottmin, LocalState.plotSpecs.plottmax], xstyle=1, $
                yrange=[LocalState.plotSpecs.plotymin, LocalState.plotSpecs.plotymax], ystyle=1, $
                xlog=LocalState.tlogscale, ylog=LocalState.ylogscale
            XYOUTS, .80, .85, LocalState.Labels[0], COLOR=Color, ALIGN=0.0,/normal,charthick=3
            plots,[.80,.9],[.84,.84],linestyle=1,color=color,/normal,thick=3

            IF (nplots gt 1) THEN BEGIN
                FOR i=1, nplots-1 DO BEGIN
                    y = LocalState.data[i,*]
                    scale = ((i / 6)+1) * 2
                    ;y = (y > LocalState.plotSpecs.plotymin)<LocalState.plotSpecs.plotymax
                    oplot, x, y, linestyle=i+1, COLOR=Color+i,  PSYM=-4,symsize=.3,thick=3*scale
                    XYOUTS, .80, .85 - i*.06, LocalState.Labels[i], COLOR=Color+i, ALIGN=0.0,/normal,charthick=3
                    plots,[.80,.9],[.84- i*.06,.84- i*.06],linestyle=i+1,color=color+i,/normal,thick=3*scale
                ENDFOR
            ENDIF

            DEVICE, /CLOSE_DOCUMENT
            ; Switch back to display output
            SET_PLOT, 'WIN'
        endif
    ENDIF
END


;===============================================================================
FUNCTION WriteDataToFile, Info, FILENAME=FileName

    IF N_TAGS(Info) LT 5 THEN RETURN, -1
    ; Check data dims
    sz = size(Info.data)
    if (sz[0] lt 1) then begin
        print, 'No data to save (WriteDataToFile)'
        return, -1
    endif

    ; How many dimensions: 1 or 2?
    IF sz[0] EQ 1 THEN nplots = 1  ELSE nplots = sz[1]

    ; Get file name from user?
    IF n_elements(FileName) eq 0 THEN FileName = DIALOG_PICKFILE(FILTER='*tms.txt', TITLE="Select Time Series Data File")

    dotloc = rstrpos(filename,'.')
    if(dotloc eq -1)then filename = filename + 'tms.txt'

    Openw, DFileUnit, FileName, /Get_lun, ERROR = err
    IF (err NE 0) THEN BEGIN
        PRINT, !ERR_STRING
        return, -2
    ENDIF

    ; Write Header info
    adjOrnot=info.adj_no_adj
    nplots_mo=strtrim(n_elements(info.labels),2)+'  '
    printf,DFileunit,format='(A9,1x,A8,1x,A9,1x,A13,2x,A29)','StartTime','TimeStep','#ofParams',$
        'MethodOfNglib','EndTime = Start_time + Tstep'
    PRINTF,DFileUnit,format='(A9,1x,A8,1x,A9,1x,A13,1x,A29)',Info.Timestr,strtrim(Info.Tstep,2)+'  ',$
        nplots_mo,adjOrnot,'ValueAveragedFrmStrtT_To_EndT'

    ;FormStr = STRING(FORM='(I,"F8.2")', sz[1])
    ;FormStr = '(' + STRTRIM(FormStr,2) + ')'
    label = 'StartTime'
    ; formatStr = "(a10,6x," + strtrim(nplots,2) + "(a15,2x))"
    formatStr = "(a10,6x," + strtrim(n_elements(info.labels),2) + "(a15,2x))"
    call_procedure,'printf',dfileunit,label,info.labels,format=formatStr
    ;printf,dfileunit,label,info.labels,format=

    dim = size(info.data,/dim)
    if n_elements(dim) eq 1 then npoints=1 else   npoints = dim[1]  ; eadded by mo 2004.
    time = info.startTime
    ;formatStr = "(I10,4x," + strtrim(nplots,2) + "(f15.7,2x))"
    formatStr = "(I10,4x," + strtrim(n_elements(info.labels),2) + "(f15.7,2x))"
    for i=0,npoints-1 do begin
        ; Write the data
        PRINTF, DFileUnit, time,Info.data[*,i],format=formatstr ;'(i10,4x,(f10.5,2x))'
        time = time + info.tstep
    endfor

    FREE_LUN, DFileUnit
    close,DFileUnit
    RETURN, 0
END


;===============================================================================
; OutPutFlags: Bit 0 set = Printer; Bit 1 set = TIFF file output; Bit 2 set = ASCII file output

pro TimeSeriesWidget, pStateInfo, pLink, OutPutFlags=OutPutFlags

    ;common timeserieswidgetcommon

    ; Purpose: to plot time series data and allow display modifications
    ;  Parameters
    ;   pStateInfo   Input   pointer to Structure with all data
    ;   pLink      Input   pointer to structure with plot selection data
    ; keywords
    ; outputflags  Input    controls where output will go

    ; Default is to send ouput to plot only
    IF N_ELEMENTS(OutPutFlags) EQ 0 THEN OutPutFlags = 0

    if (n_elements(group) eq 0) then group = 0

    if (n_params() lt 1) then begin
        print, 'Usage:  PlotTimeSeries, group=gr, timeseriesparamsdata'
        print, 'Must give the timeseriesparamsdata structure'
        return
    endif

    ;make pointer local
    pTime = (*pStateInfo).pTimeSeries
    if(not ptr_valid(pTime))then begin
        print,'No data to plot, returning'
        return
    endif

    (*pStateInfo).pTimeSeries = ptr_new()
    sz = size((*pTime).timedata)
    if(sz[0] gt 1)then begin
        numPlots = sz[1]
        PlotLen = sz[2]
    endif else begin
        numPlots = 1
        PlotLen = sz[1]
    endelse


    if (PlotLen lt 1) then begin
        print, 'no data array in Timedata array... returning'
        return
    endif

    ;nsteps = sz[1]       ; number of columns in TSparamsdata.data array
    ;print,'numPlots=',numPlots
    tmin = 0
    tmax = tmin + (PlotLen * (*pLink).sample)  ;sample is the time to skip between points
    ymin = !values.f_infinity
    ymax = 0
    for i=0,numplots-1 do begin
        ymin0 = min((*pTime).timedata[i,*], MAX=ymax0)
        ;if(ymin0 eq !values.f_nan)then ymin0 = 0
        ymin = ymin0 < ymin
        ymax = ymax0 > ymax
    endfor

    taxismin = tmin
    taxismax = tmax
    plottmin = tmin
    plottmax = tmax
    plottstep = (*pLink).sample
    yaxismin = 0
    yaxismax = ymax;50000
    plotymin = ymin
    plotymax = ymax
    plotystep = ((ymax-ymin)/100.0)

    base = widget_base(GROUP_LEADER=(*pStateInfo).widgets.tlb, /TLB_SIZE_EVENTS, /col, title='Time Series Plots',$
        uvalue='timeserieswidget',mbar = menubase,/TLB_KILL_REQUEST_EVENTS)

    options = widget_button(menubase,value='Options')
    button = widget_button(options, uvalue='print', value='Print')
    button = widget_button(options, uvalue='savedatatofile', value='Save Data to File')
    button = widget_button(options, uvalue='savetiff', value='Save Plot to png')
    button = widget_button(options, uvalue='exit', value='Exit',/sep)

    buttonbase = widget_base(base, /row)
    button = widget_button(buttonbase, uvalue='print', /bitmap, value='Print1.bmp')
    button = widget_button(buttonbase, uvalue='savedatatofile', /bitmap, value='save.bmp')
    button = widget_button(buttonbase, uvalue='savetiff', /bitmap, value='freeform.bmp')
    button = widget_button(buttonbase, uvalue='exit', /bitmap, value='quit.bmp')

    if (plottmax gt taxismax) then plottmax = taxismax
    if (plottmin lt taxismin) then plottmin = taxismin

    base0 = widget_base(base,/row)
    scalebase = widget_base(base0, /column, /frame, title='Scale Axes')
    tminid = widget_slider(scalebase,min=tmin, max=tmax, title='Tmin', $
        value=plottmin, uvalue='tminid')
    tmaxid = widget_slider(scalebase,min=tmin, max=tmax, title='Tmax', $
        value=plottmax, uvalue='tmaxid')
    ;yminid = widget_slider(scalebase, min=yaxismin, max=yaxismax>1, title='Ymin', $
    ;                    value=plotymin>yaxismin, uvalue='yminid')

    ySliderMax = 100.^(fix(alog10(yaxismax))+1)
    yminid = CW_Fslider(scalebase, min=yaxismin, max=ySliderMax, title='Ymin', $
        value=plotymin>yaxismin, uvalue='yminid',/edit)

    ymaxid = CW_Fslider(scalebase, min=yaxismin, max=ySliderMax, title='Ymax', $
        value=plotymax, uvalue='ymaxid',/edit)

    logscaleid = cw_bgroup(    scalebase, ['Y Log Scale'], /col, /nonexclusive, /frame, $
        set_value=[0], button_uvalue=[1], uvalue='logscale')
    ;logscaleid = cw_bgroup(   scalebase, ['T Log scale', 'Y Log Scale'], /col, /nonexclusive, /frame, $
    ;                    set_value=[0,0], button_uvalue=[1,2], uvalue='logscale')

    drawbase = widget_base(base0, /column)
    drawarea = widget_draw(drawbase, retain=1, xsize=600, ysize=300, UVALUE='MAIN_VIEW')
    widget_control, base, /realize

    WIDGET_CONTROL, drawarea, GET_VALUE=MainViewID

    plotSpecs = {taxismin:taxismin, taxismax:taxismax, plottmin:plottmin, plottmax:plottmax, plottstep:plottstep, $
        yaxismin:yaxismin, yaxismax:yaxismax, plotymin:plotymin, plotymax:plotymax, plotystep:plotystep}


    ; get current color table
    tvlct,red,green,blue,/get


    if (*plink).adj_sel eq 0 then adj_noadj_str='None_adjusted'
    if (*plink).adj_sel eq 1 then adj_noadj_str='Adjusted_used'
    if (*plink).adj_sel eq 2 then adj_noadj_str='  Wysiwyg_r '

    xunits=strtrim((*pLink).sample,2)+' sec steps'

    LocalState = { data:(*pTime).timedata, $
        drawarea:drawarea,$
        MViewID:MainViewID, $
        nsteps:PlotLen, $
        TimeStr:(*pLink).TimeStr, $
        startTime:(*pTime).StartTime,$
        tmax:tmax, $
        tmin:tmin, $
        Tstep:(*pLink).sample, $
        tmaxid:tmaxid, $
        tminid:tminid, $
        tlogscale:0, $
        ymax:ymax, $
        ymin:ymin, $
        ymaxid:ymaxid, $
        yminid:yminid, $
        plotSpecs:plotSpecs,$
        ylogscale:0, $
        Labels:(*pTime).labels, $
        xunits:xunits, $
        printersetup:0, $
        red:red,$
        green:green,$
        blue:blue,$
        InFileName:(*pStateInfo).InFileName,$
        adj_no_adj:adj_noadj_str }

    ;clear memory
    ptr_free,pTime

    ; Print/TIFF outputs
    IF OutPutFlags AND 1 OR (OutPutFlags AND 2)/2 THEN BEGIN
        PlotTimeSeries, LocalState, OutPutFlags=OutPutFlags
    ENDIF

    ; Save ASCII file?
    IF (OutPutFlags AND 4)/4 THEN BEGIN
        ; Create a filename
        ; Get Path
        NamePos = RSTRPOS(LocalState.InFileName, '.')
        IF NamePos GE 0 THEN BEGIN
            FileName = STRMID(LocalState.InFileName, 0, NamePos)
            FileName = FileName + '_' + strtrim(long(LocalState.startTime),2)
        ENDIF ELSE FileName = strtrim(long(LocalState.startTime),2)
        FileName = FileName + '_TS.txt'
        ;stop
        Ret = WriteDataToFile(LocalState,FILENAME=FileName)
    ENDIF

    PlotTimeSeries, LocalState

    widget_control, base, set_uvalue=LocalState

    xmanager, 'TimeSeriesWidget', base, /no_block


END
