PRO Main2C_concate_all_CPI_combined_csv_for_matlab_vm
    ; This file input yymmddhhmmcombined.csv  files and and concate them together
    ; but only output a few parameters to reduce file size. Other values are not needed.

    ; input is  combined.csv
    ; output: Cloud_type series file for whole flight
    ; output: and many small data files of  61 bin ratio of each Time period.


    ;*******************************
    filename = dialog_pickfile(title='pls pick a Dir & Click a file',filter='*combined.csv',Get_path=pathnm)

    pathnm=file_dirname(filename)+'\'
    filter_str='*combined.csv'
    get_all_data_filenames,filter_str,pathnm,filenames,file_count

    outputfilename=pathnm+'iceT_all_csv_CPI2008xxxx_combined.txt'
    outputfilename2=pathnm+'iceT_all_csv_CPI2008xxxx_combined_short.txt'
    openw,88,outputfilename,/append
    openw,99,outputfilename2,/append
    ; TAF 2014-08-28 not sure which of the below is correct, using the newer one from 1.1.19 Mo
    printf,88,'year	mm dd hh mm ss	ms ROI#	ArrTime  TS	 DeadTime Length Width Area Perim Rndness Focus Cutoff Crystal P1 INStats HrmCnt h1 h2 h3 h4 h5 h6 SX SY EX EY'
    ;printf,88,'year mm dd hh mm ss  ms ROI#  ArrTime  TS   DeadTime Length Width Area Perim Rndness Focus Cutoff Crystal P1 INStats HrmCnt h1 h2 h3 h4 h5 h6 SX SY EX EY'
    printf,99,'year  mm dd hh mm ss ms    ROI#    Length      Width      Area      Perim       Rndness  Focus  Cutoff Crystal'


    sel_indx=[0,1,2,6,7,8,9,10,11,12,13]

    for k=0LL, file_count-1LL do begin

        infile=filenames(k)

        result=read_ascii(infile,count=n_lines);   ;find out how many lines in the file.

        nn=n_lines;  n_elements(aa)

        openr,2,infile

        This_line='AbcdefG'
        readf,2,This_line
        readf,2,This_line
        readf,2,This_line
        substr1=strmid(This_line,0,4)
        if substr1 eq 'Acce' then begin
            nn=nn-1
            readf,2,This_line
        endif
        if substr1 eq 'year' then begin
            ; do nothing.
        endif


        for j=0LL,nn-4LL  do begin
            readf,2,This_line
            substrsA=strsplit(This_line,'[:]',/EXTRACT);   ; The file is coma separated.
            substrsB=strsplit(This_line,',',/EXtract)

            time_str=SubstrsB(1)
            Time_substrs=strsplit(time_str,':',/EXTRACT)

            ;print, n_elements(time_substrs)
            total_4s=strjoin(Time_substrs(0:3),' ')

            last_5  =strcompress(Time_substrs(4));    : this is TS column.

            ;see if last_5 has str ***
            ss_ms =strsplit(last_5,'.',/extract)
            ss=ss_ms(0)

            ms    =ss_ms(1)
            if ms eq '***'  then ms='999'

            last_5 =' '+ss+' '+ms+' '


            Time_strF=total_4s+' '+last_5
            substrsB(1)=Time_strF

            ; check if TS string is ****
            TS_str=substrsB(4)
            if TS_str eq '****'  then substrsB(4)='999'

            DeadTime_str=substrsB(5)
            if DeadTime_str eq '*******' then substrsB(5)='999.999'


            This_line_back=strjoin(substrsB,' ')
            printf,88,This_line_back

            ; above is the whole original line.
            ; following shorten the line length.
            ; sel_indx=[0,1,2,6,7,8,9,10,11,12,13]
            This_line_short=strjoin(substrsB(sel_indx),' ');  : change to this to make file smaller and load fast by matlab.
            crys_len=substrsB(6)*1.0
            if crys_len gt 0.0 then begin;  only print out size greater than 0.0 particles.
                printf,99,This_line_short
            endif


        endfor
        close,2

        print,'Done writing ' + filenames(k)
        wait,2

    endfor;  end for i=10, file_count-1LL

    print, 'Done all files!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    close,88,99

end;  end of main program.


pro du_input_combined,filenm,stsyr,asctims,roinum,sts_us,len,wid,area,perim,rnd,$
    fcs,cutoff,crys,HOA,Hcnt,H1,H2,H3,H4,H5,H6,SX,SY,EX,EY
;subroution to input the cpi frame data    June 29 2004

result=read_ascii(filenm,count=n_lines);  ;find out how many line in the file.
;there are 3 header lines. so there are n_lines-3 data lines in the file.
;find out how many headerlines
result=read_ascii(filenm,data_start=3,header=readed_line,num_records=1)
yearline=readed_line(2)
yearline=strsplit(yearline,',',/extract)
if yearline(0) eq 'year' then headnum=3 else headnum=4

if headnum eq 3 then begin
    nnn=long(n_lines)-3L
    openR,1,filenm
    dummy='ab'
    readF,1,format='(A//)',dummy; read a and then skip 3 lines.
endif else begin
    nnn=long(n_lines)-4L
    openR,1,filenm
    dummy='ab'
    readF,1,format='(A///)',dummy; read a and then skip 3 lines.
endelse

;assign arrays for the readin parameters
stsyr  =intarr(nnn)
asctims=strarr(nnn)     ;time=mm:dd:hh:mm:ss
roinum =intarr(nnn)
sts_us= lonarr(nnn)  ;arrival-
len    =fltarr(nnn)
wid    =fltarr(nnn)
area   =fltarr(nnn)
perim  =fltarr(nnn)
rnd    =fltarr(nnn)
fcs    =fltarr(nnn)   ;focus
cutoff =intarr(nnn)   ; cutoff
crys   =intarr(nnn)   ; crystal type
HOA    =intarr(nnn)   ; hole area
Hcnt   =intarr(nnn)   ;harmonic count
H1     =fltarr(nnn)
H2     =fltarr(nnn)
H3     =fltarr(nnn)
H4     =fltarr(nnn)
H5     =fltarr(nnn)
H6     =fltarr(nnn)
SX     =fltarr(nnn)
SY     =fltarr(nnn)
EX     =fltarr(nnn)
EY     =fltarr(nnn)
for i=0L,long(nnn)-1L do begin
    ; year, mm:dd:hh:mm:ss  ROI# ArrTime TS  DeadTime Length  Width Area Perim
    ; Rndness Focus Cutoff Crystal P1 Inten_Hole HrmCnt h1 h2 h3
    ; h4 h5 h6 SX SY EX EY
    ;read one line at a time.
    thisline='abcdefg'
    readF,1,format='(1A)',thisline;   ; the line conains following parameters.
    ;year,mmddhhmmss,roinumber,arrtime,ts,deadTime,length,width,areaA,perimP,$
    ;Rndness, Focus, Cutoff, Crystal, P1, Inten_Hole, HrmCnt, h1, h2, h3,$
    ;h4, h5, h6, SX, SX, EX, EY
    S = STRSPLIT(thisline, ',', /EXTRACT)
    stsyr  (i)=S(0)
    asctims(i)=S(1);   frame time for each particle
    roinum (i)=S(2)
    sts_us (i)=S(3)
    len    (i)=S(6)
    wid    (i)=S(7)
    area   (i)=S(8)
    perim  (i)=S(9)
    rnd    (i)=S(10)
    fcs    (i)=S(11)
    cutoff (i)=S(12)
    crys   (i)=S(13)
    HOA    (i)=S(15);hole_area
    Hcnt   (i)=S(16)   ;harmonic count
    H1     (i)=S(17)
    H2     (i)=S(18)
    H3     (i)=S(19)
    H4     (i)=S(20)
    H5     (i)=S(21)
    H6     (i)=S(22)
    SX     (i)=S(23)
    SY     (i)=S(24)
    EX     (i)=S(25)
    EY     (i)=S(26)
endfor
close,1
end


FUNCTION foc_to_pos, foc

    RETURN, (1.57547 -0.0614464 *foc + 0.000838895 *foc^2d -3.82540e-006 *foc^3d)

END


pro du_ice_water_ratio_from_combinedCsv_file,TimeF,nwater,nice,filenm,this_day
    ;subroution to input the cpi frame data    Feb.22, 2011.
    ; do this for storm vex  jay mason.
    ;filenm=dialog_pickfile(title='pls pick a Dir & Click a file',filter='*.csv',Get_path=pathnm)
    ; input: this_day, it is a 2 digit number.  and filenm
    ;output: TimeF, nwater is a 1Hz  vector, nice

    result=read_ascii(filenm,count=n_lines);  ;find out how many line in the file.
    ;there are 3 header lines. so there are n_lines-3 data lines in the file.
    ;find out how many headerlines
    result=read_ascii(filenm,data_start=3,header=readed_line,num_records=1)
    yearline=readed_line(2)
    yearline=strsplit(yearline,',',/extract)
    if yearline(0) eq 'year' then headnum=3 else headnum=4

    if headnum eq 3 then begin
        nnn=long(n_lines)-3L
        openR,99,filenm
        dummy='ab'
        readF,99,format='(A//)',dummy; read a and then skip 3 lines.
    endif else begin
        nnn=long(n_lines)-4L
        openR,99,filenm
        dummy='ab'
        readF,99,format='(A///)',dummy; read a and then skip 3 lines.
    endelse

    ;assign arrays for the readin parameters
    stsyr  =intarr(nnn)
    asctims=strarr(nnn)     ;time=mm:dd:hh:mm:ss
    month=intarr(nnn)
    dd=   intarr(nnn)
    hh=   intarr(nnn)
    mm=   intarr(nnn)
    ss=   intarr(nnn)
    roinum =intarr(nnn)
    sts_us= lonarr(nnn)  ;arrival-
    len    =fltarr(nnn)
    wid    =fltarr(nnn)
    area   =fltarr(nnn)
    perim  =fltarr(nnn)
    rnd    =fltarr(nnn)
    fcs    =fltarr(nnn)   ;focus
    cutoff =intarr(nnn)   ; cutoff
    crys   =intarr(nnn)   ; crystal type
    p1     =intarr(nnn)
    HOA    =intarr(nnn)   ; hole area
    Hcnt   =intarr(nnn)   ;harmonic count
    H1     =fltarr(nnn)
    H2     =fltarr(nnn)
    H3     =fltarr(nnn)
    H4     =fltarr(nnn)
    H5     =fltarr(nnn)
    H6     =fltarr(nnn)
    SX     =fltarr(nnn)
    SY     =fltarr(nnn)
    EX     =fltarr(nnn)
    EY     =fltarr(nnn)
    for i=0L,long(nnn)-1L do begin
        ; year, mm:dd:hh:mm:ss  ROI# ArrTime TS  DeadTime Length  Width Area Perim
        ; Rndness Focus Cutoff Crystal P1 Inten_Hole HrmCnt h1 h2 h3
        ; h4 h5 h6 SX SY EX EY
        ;read one line at a time.
        thisline='abcdefg'
        readF,99,format='(1A)',thisline;   ; the line conains following parameters.
        ;year,mmddhhmmss,roinumber,arrtime,ts,deadTime,length,width,areaA,perimP,$
        ;Rndness, Focus, Cutoff, Crystal, P1, Inten_Hole, HrmCnt, h1, h2, h3,$
        ;h4, h5, h6, SX, SX, EX, EY
        S = STRSPLIT(thisline, ',', /EXTRACT)
        stsyr  (i)=S(0)
        asctims(i)=S(1);   frame time for each particle
        substrs=strsplit(S(1),':',/extract)
        month(i)=substrs(0)*1
        dd(i)   =substrs(1)*1
        hh(i)   =substrs(2)*1
        mm(i)   =substrs(3)*1
        ss(i)   =substrs(4)*1
        roinum (i)=S(2)
        sts_us (i)=S(3)
        len    (i)=S(6)
        wid    (i)=S(7)
        area   (i)=S(8)
        perim  (i)=S(9)
        rnd    (i)=S(10)
        fcs    (i)=S(11)
        cutoff (i)=S(12)
        crys   (i)=S(13)
        p1     (i)=S(14);   accepted =0; rejected =1
        HOA    (i)=S(15);hole_area
        Hcnt   (i)=S(16)   ;harmonic count
        H1     (i)=S(17)
        H2     (i)=S(18)
        H3     (i)=S(19)
        H4     (i)=S(20)
        H5     (i)=S(21)
        H6     (i)=S(22)
        SX     (i)=S(23)
        SY     (i)=S(24)
        EX     (i)=S(25)
        EY     (i)=S(26)
    endfor
    close,99

    ; calculate the counts of water and ice particles
    seconds=hh*3600LL+mm*60LL+SS*1LL;   seconds since midnight
    index=where(dd eq this_day,contGGG)
    if contGGG gt 0 then begin
        Time=seconds(index)
        crysall=crys(index)
        p1all  =p1(index)

        begin_sec=min(Time)
        end_sec  =max(Time)

        TimeF=0LL+ indgen(end_sec-begin_sec)+ begin_sec
        nwater=TimeF*0
        nice  =TimeF*0

        for jjj=0L,n_elements(TimeF)-1L do begin
            indexw=where(crysall eq 1 and Time ge TimeF(jjj) and Time lt TimeF(jjj)+1LL,contw)
            nwater(jjj)=contw
            indexi=where(crysall eq 15 and Time ge TimeF(jjj) and Time lt TimeF(jjj)+1LL,conti)
            nice(jjj)=conti
        endfor
    endif


    debug=1
    if debug eq 1 then begin
        window,11
        loadct,0
        white=!D.N_COLORS-1   ;keyword /free incase more than 32 windows are needed.
        !P.BACKGROUND=white
        !P.multi=[0,1,1]
        !P.charsize=1.0
        plot,TimeF,nwater,color=0
        oplot,TimeF,nice,color=255
    endif


end



pro make_61_bins,nbins,nedges,xpts,dbl_binwidths
    nbins=61
    nedges=2*nbins
    xpts=dblarr(2*nbins)
    xpts(0)=5.0
    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =5.0+(i+1)*10.0
    endfor
    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =205.0+(i-19)*20.0
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =505.0+(i-34)*50.0
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =1005.0+(i-44)*100.0
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =2005.0+(i-54)*200.0
    endfor
    xpts(121)=xpts(120)+200.0; to make last bin-width=200.0um
    dbl_binwidths=xpts(1:*)-xpts(0:120)
    dbl_binwidths=[dbl_binwidths,0.0]
    xpts(121)=3205.0;  100000.0;    but hin here group anything greater that 3005 to be the last bin.
    xpts(0) =5.0; 0.0001
end; end of make_61_bins


FUNCTION pos_to_Dratio, pos

    RETURN, 1.1031377 + 1.2314287 *pos - 0.34444972 *pos^2d

END
function convert_time,timeStr

    ; timestr is of form MM:DD:HH:MM:SS.MS

    colon1 = strpos(timestr,':',0)
    month = fix(strmid(timestr,0,colon1))
    colon2 = strpos(timestr,':',colon1+1)
    day = fix(strmid(timestr,colon1+1,colon2-colon1-1))
    colon3 = strpos(timestr,':',colon2+1)
    hour = fix(strmid(timestr,colon2+1,colon3-colon2-1))
    colon4 = strpos(timestr,':',colon3+1)
    min = fix(strmid(timestr,colon3+1,colon4-colon3-1))
    strend = strlen(timestr)
    sec = float(strmid(timestr,colon4+1,strend-colon4-1))
    return,{month:month,day:day,hour:hour,min:min,sec:sec}
end

;the following gets start and end dates from stats file dates and makes some display strings of times
PRO du_more_times,sts_date,sts_use_arr,strt_time,end_time,strt_date,end_date,sHH,sMM,sSS,eHH,eMM,eSS
    ; sts_date  is in vector the same length as fcs, crys, =2001-04-11
    strt_date=sts_date(sts_use_arr(0))
    end_date=sts_date( sts_use_arr( (n_elements(sts_use_arr)-1) ) )

    if 1 eq 1 then begin
        ;the following are for output file names
        colon1 = strpos(strt_time,':',0)
        sHH = (strmid(strt_time,0,colon1))
        colon2 = strpos(strt_time,':',colon1+1)
        sMM = (strmid(strt_time,colon1+1,colon2-colon1-1))
        sSS = (strmid(strt_time,colon2+1,2))
        colon1 = strpos(end_time,':',0)
        eHH = (strmid(end_time,0,colon1))
        colon2 = strpos(end_time,':',colon1+1)
        eMM = (strmid(end_time,colon1+1,colon2-colon1-1))
        eSS = (strmid(end_time,colon2+1,2))
    endif
end

;put TimeF,nwater,nice into  1 minute per point  Time series for better plot resolution
pro  make_one_minute_per_point_plots_of_TimeF_nwater_nice,$
    TimeF,nwater,nice,filenm,this_day,pathnm,$ ; inputs
    TimeF1min,nwater1min,nice1min,TimeWalt,TempRStemp,ROSIC1; outputs
; TimeF is one Hz Time.
TimeAll=TimeF
nwaterall=nwater
niceall  =nice
;**************************************************
basefilenm=file_basename(filenm)
outputfilename=pathnm+'ISDAC_all_CPI2008xxxx_water_ice_number_ascii.txt'
openw,88,outputfilename,/append
;printf,88,'Time is the Start time of That Minutes'
;printf,88,' ratio=+999.00 mean all are ice,  ratio=-999.00 means all are water.'
;printf,88,' +ve ratio means ice-dominant,      -ve ratio means water dominant !'
;printf,88,'Second hh mm ss  Water   ice  Type  ratio  temp(Deg_C)   RosIC1'


; make the plots --- N mintess one data point.
TimeS=min(TimeAll);  24*3600LL
TimeE=max(TimeAll);  0LL
; how many points in a day.
N =1 ; minutes
Nseconds=20;    % can be 60.

Npoints=(TimeE-TimeS)/(N*Nseconds)
TimeP=fltarr(Npoints)
WaterP=fltarr(Npoints)
iceP  =fltarr(Npoints)


for ip=0,Npoints-1  do begin
    Btime=TimeS+ip*N*Nseconds
    Etime=Btime +N*Nseconds
    Timep(ip)=Btime

    ; wlater Bulk data
    indexw=where(TimeWalt ge Btime and TimeWalt lt Etime,contwww)
    if contwww gt 0 then begin
        mean_temp=mean(TempRStemp(indexw))
        mean_rosic1=mean(Rosic1(indexw))
    endif else begin
        mean_temp=-88.8
        mean_rosic1=-88.8
    endelse

    indexp=where(TimeAll ge Btime and TimeAll lt Etime,contPPP)

    hh=(Btime)/3600LL
    mm=(BTime mod 3600LL)/60LL
    ss=(BTime mod 60LL)

    if contPPP gt 0 then begin
        waterP(ip)=total(nwaterall(indexp))
        iceP(ip)  =total(niceall(indexp))

        if iceP(ip) gt waterP(ip) then  begin
            if waterP(ip) gt 0 then ratio=icep(ip)/waterP(iP) else ratio=+999
            Dtype=15
            printf,88,format='(I5, 1x, I2, 1x, I2,1x,I2,1x,I5,1x,I5,1x,I4,1x,F8.2,1x,F6.1,1x,F8.2)',Btime,hh, mm,ss,waterP(ip),iceP(ip),Dtype,ratio,mean_temp,mean_rosic1
        endif

        if waterP(ip) gt iceP(ip) then  begin
            if iceP(ip) gt 0 then ratio=-waterp(ip)/iceP(iP)  else ratio=-999
            Dtype=1
            printf,88,format='(I5, 1x, I2, 1x, I2,1x,I2,1x,I5,1x,I5,1x,I4,1x,F8.2,1x,F6.1,1x,F8.2)',Btime,hh, mm,ss,waterP(ip),iceP(ip),Dtype,ratio,mean_temp,mean_rosic1
        endif

        if (iceP(ip) eq 0 and  waterP(ip) eq 0) then begin
            printf,88,format='(I5, 1x, I2, 1x, I2,1x,I2,1x,I5,1x,I5,1x,I4,1x,F8.2,1x,F6.1,1x,F8.2)',Btime,hh, mm,ss,0,            0,       0,  0,mean_temp,mean_rosic1
        endif

    endif else begin
        printf,88,format='(I5, 1x, I2, 1x, I2,1x,I2,1x,I5,1x,I5,1x,I4,1x,F8.2,1x,F6.1,1x,F8.2)',Btime,hh, mm,ss,0,            0,       0,  0,mean_temp,mean_rosic1
    endelse


    ;write data out to ascii file.



endfor

close,88

; do 1 page of plot for 1 day.
; do 6 pannels,each pannel for  4 hours.

bluecolor  =GetColor("Navy", !D.Table_Size-2)
redcolor   =GetColor("Red", !D.Table_Size-2)
whitecolor =GetColor("White", !D.Table_Size-2)
blackcolor=getcolor("black",!D.Table_Size-2)
greencolor=getcolor("Green",!D.Table_Size-2)

!P.thick=1
!P.CHARSIZE=1.0
!P.BACKGROUND=whitecolor

!P.multi=[0,1,6]

; There are npoint to be ploted in this pages, but each points is 2 minutes.
; One pannel is 2 hours,  so  one pannel is 2*60/1 = 120 points.

;calculate the ratio_all
indexR=where(waterP eq 0, contRRR)
if ContRRR gt 0 then waterP(indexR)=-1.0
ratioAll=iceP/waterP
if ContRRR gt 0 then ratioAll(indexR)=0.0
;return -1to be zero.
if ContRRR gt 0 then waterP(indexR)=0.0


vector=[waterP,iceP,ratioAll]
indexj=where(vector gt 0.0, contG)
if contG gt 0 then  ymin=min(vector(indexj)) else ymin=0.001
ymax=max(vector)
Ymin=1.0
N_hours_per_pannel=2

window,2, xs=72*8.0, ys=72*11
GetHHMMSS_from_MidNightSEconds,TimeS, HHMMSS, Shh, Smm, Sss,shhstr,smmstr,sssstr
GetHHMMSS_from_MidNightSEconds,TimeE, HHMMSS, Ehh, Emm, Ess,ehhstr,emmstr,essstr
HHMMSS_S=shhstr+smmstr+sssstr
HHMMSS_E=ehhstr+emmstr+essstr

this_pages_StartTime_str=strtrim(string(TimeS),2);  0
This_pages_EndTime_str  =strtrim(string(TimeE),2); 12*3600LL
for j=0,5 do begin
    if (j eq 0 or j eq 2  or j eq 4) then begin
        Xmin=TimeS + (j/2)*N_hours_per_pannel*3600LL
        Xmax=Xmin + N_hours_per_pannel*3600LL;  one panel 4  hours.

        fullrange =N_hours_per_pannel*3600LL
        binwidth = round(N_hours_per_pannel*3600.0/4.0);  Make 5 ticks, 4 bins.
        ;fullrange = local_LastData.Nanoseconds - local_FirstData.Nanoseconds
        curbin = Xmin
        tnames = StrArr(5)
        FOR k=0,4 DO BEGIN
            GetHHMMSS_from_MidNightSEconds,curbin, HHMMSS, hh, mm, ss,hhstr,mmstr,ssstr
            tnames(k) = HHMMSS
            curbin += binwidth
        ENDFOR
        ;-------------------------------
        ;Set up X axis tick labels.
        ;-------------------------------
        ;!X.TICKNAME = tnames
        ;!X.TICKS = 4
        x0=0.09
        y0=0.81
        deltay=0.15
        x1=0.95
        y1=0.93
        This_year='2008'
        This_month=strmid(basefilenm,0,2)
        This_day_str=strmid(basefilenm,2,2)

        ; make the panel  for  Number Time series

        PLOT, TimeP,waterP, COLOR=Blackcolor, XRANGE=[Xmin,Xmax],$;xmargin=[0.1,0.1],$
            Xstyle = 1,ylog=1,THICK=1, YRANGE=[ymin, ymax],ystyle=1,xticks=4,xtickname=tnames,$;$
            position=[x0,y0-j*deltay,x1,y1-j*deltay],/normal,$
            charsize=1.6,YTITLE='Counts/minute';  Yticks=ytikn,Ytickn=myticknames
        oplot,TimeP,waterP, color=bluecolor;   % paul water   ocean blueto mean water
        oplot,TimeP,iceP,color=greencolor
        oplot,TimeP,ratioall,color=redcolor

        if j eq 0 then begin
            xyouts,0.5,0.975,'Fig.1  ISDAC  Date: '+This_year+' '+This_month+' '+this_day_str, color=blackcolor,charsize=1.5,/normal,alignment=0.5
            xyouts,0.5,0.945,'CPI particle counts: (Water-Blue) (ice Grn)  (I/W: Red)',$
                color=blackcolor,charsize=1.1,/normal,alignment=0.5
            xyouts,0.50,0.02,'UTC Time',color=blackcolor,charsize=1.5,/normal,alignment=0.5
        endif
    endif

    ; make the panel  for  temperature  Time series
    if (j eq 1 or j eq 3  or j eq 5) then begin
        Ymin=min(tempRSTemp)
        Ymax=1.1*max(tempRSTemp)
        PLOT, Timewalt,TempRSTemp, COLOR=Blackcolor, XRANGE=[Xmin,Xmax],$;xmargin=[0.1,0.1],$
            Xstyle = 1,ylog=0,THICK=1, YRANGE=[ymin, ymax],ystyle=1,xticks=4,xtickname=tnames,$;$
            position=[x0,y0-j*deltay,x1,y1-j*deltay],/normal,$
            charsize=1.6,YTITLE='RStemP, deg C';  Yticks=ytikn,Ytickn=myticknames
        ;oplot,TimeP,waterP, color=bluecolor;   % paul water   ocean blueto mean water
        ;oplot,TimeP,iceP,color=greencolor
        ;oplot,TimeP,ratioall,color=redcolor
        ; xyouts,0.5,0.945,'Convair Bulk data temperaturee Deg-C',$
        ; color=blackcolor,charsize=1.1,/normal,alignment=0.5
        xyouts,0.50,0.02,'UTC Time',color=blackcolor,charsize=1.5,/normal,alignment=0.5
        if Xmin gt TimeE  then break
    endif
endfor;  end of for j=0, 5
write_jpeg,pathnm+'ISDAC_'+'CPI2008'+strmid(basefilenm,0,8)+'_water_ice_counts_'+This_pages_startTime_str+$
    '_'+strtrim(string(This_Pages_EndTime_str),2)+'_'+HHMMSS_S+'_'+HHMMSS_E+'.jpg',tvrd(true=1),true=1
end

pro GetHHMMSS_from_MidNightSEconds, seconds, HHMMSS, hh, mm, ss,hhstr,mmstr,ssstr
    hh=seconds/3600LL
    mm=(seconds mod 3600LL)/60LL
    SS=seconds mod 60LL
    if hh lt 10 then HHstr='0'+strtrim(string(hh),2) else HHstr=strtrim(string(hh),2)
    if mm lt 10 then MMstr='0'+strtrim(string(MM),2) else MMstr=strtrim(string(MM),2)
    if SS lt 10 then SSstr='0'+strtrim(string(ss),2) else SSstr=strtrim(string(ss),2)
    HHMMSS=HHstr+":"+MMStr+":"+SSstr
end; end of  GetHHMMSS_from_MidNightSEconds, seconds, HHMMSS, hh, mm, ss


;********************************************************

;********************************************************


;+
; NAME:
;       GETCOLOR

; PURPOSE:
;       The original purpose of this function was to enable the
;       user to specify one of the 16 colors supported by the
;       McIDAS color map by name. Over time, however, the function
;       has become a general purpose function for handling and
;       supporting drawing colors in a device-independent way.
;       In particular, I have been looking for ways to write color
;       handling code that will work transparently on both 8-bit and
;       24-bit machines. On 24-bit machines, the code should work the
;       same where color decomposition is turned on or off. The program
;       now supports 88 colors.

; AUTHOR:
;       FANNING SOFTWARE CONSULTING:
;       David Fanning, Ph.D.
;       1645 Sheely Drive
;       Fort Collins, CO 80526 USA
;       Phone: 970-221-0438
;       E-mail: davidf@dfanning.com
;       Coyote's Guide to IDL Programming: http://www.dfanning.com

; CATEGORY:
;       Graphics, Color Specification.

; CALLING SEQUENCE:
;       result = GETCOLOR(color, index)

; OPTIONAL INPUT PARAMETERS:
;       COLOR: A string with the "name" of the color. Valid names are:
;           black
;           magenta
;           cyan
;           yellow
;           green
;           red
;           blue
;           navy
;           pink
;           aqua
;           orchid
;           sky
;           beige
;           charcoal
;           gray
;           white

;           The color YELLOW is returned if the color name can't be resolved.
;           Case is unimportant.

;           If the function is called with just this single input parameter,
;           the return value is either a 1-by-3 array containing the RGB values of
;           that particular color, or a 24-bit integer that can be "decomposed" into
;           that particular color, depending upon the state of the TRUE keyword and
;           upon whether color decomposition is turned on or off. The state of color
;           decomposition can ONLY be determined if the program is being run in
;           IDL 5.2 or higher.

;       INDEX: The color table index where the specified color should be loaded.
;           If this parameter is passed, then the return value of the function is the
;           index number and not the color triple. (If color decomposition is turned
;           on AND the user specifies an index parameter, the color is loaded in the
;           color table at the proper index, but a 24-bit value is returned to the
;           user in IDL 5.2 and higher. This assumes the INDEXED keyword is NOT set.)

;       If no positional parameter is present, then the return value is either a 16-by-3
;       byte array containing the RGB values of all 16 colors or it is a 16-element
;       long integer array containing color values that can be decomposed into colors.
;       The 16-by-3 array is appropriate for loading color tables with the TVLCT command:

;           Device, Decomposed=0
;           colors = GetColor()
;           TVLCT, colors, 100


; INPUT KEYWORD PARAMETERS:

;       NAMES: If this keyword is set, the return value of the function is
;              a 88-element string array containing the names of the colors.
;              These names would be appropriate, for example, in building
;              a list widget with the names of the colors. If the NAMES
;              keyword is set, the COLOR and INDEX parameters are ignored.

;                 listID = Widget_List(baseID, Value=GetColor(/Names), YSize=16)

;       INDEXED:  If this keyword is set, the return value is always an index
;              into the color table. In the absence of a color table INDEX
;              parameter, the color is loaded at !P.COLOR < (!D.Table_Size-1).

;       LOAD:  If this keyword is set, all 88 colors are automatically loaded
;              starting at the color index specified by the START keyword.
;              Note that setting this keyword means that the return value of the
;              function will be a structure, with each field of the structure
;              corresponding to a color name. The value of each field will be
;              an index number (set by the START keyword) corresponding to the
;              associated color, or a 24-bit long integer value that creates the
;              color on a true-color device. What you have as the field values is
;              determined by the TRUE keyword or whether color decomposition is on
;              or off in the absense of the TRUE keyword. It will either be a 1-by-3
;              byte array or a long integer value.

;       START: The starting color index number if the LOAD keyword is set. This keyword
;              value is ignored unless the LOAD keyword is also set. The keyword is also
;              ignored if the TRUE keyword is set or if color decomposition in on in
;              IDL 5.2 and higher. The default value for the START keyword is
;              !D.TABLE_SIZE - 89.

;       TRUE:  If this keyword is set, the specified color triple is returned
;              as a 24-bit integer equivalent. The lowest 8 bits correspond to
;              the red value; the middle 8 bits to the green value; and the
;              highest 8 bits correspond to the blue value. In IDL 5.2 and higher,
;              if color decomposition is turned on, it is as though this keyword
;              were set.

; COMMON BLOCKS:
;       None.

; SIDE EFFECTS:
;       None.

; RESTRICTIONS:
;       The TRUE keyword causes the START keyword to be ignored.
;       The NAMES keyword causes the COLOR, INDEX, START, and TRUE parameters to be ignored.
;       The COLOR parameter is ignored if the LOAD keyword is used.
;       On systems where it is possible to tell the state of color decomposition
;       (i.e., IDL 5.2 and higher), a 24-bit value (or values) is automatically
;       returned if color decomposition is ON.

; EXAMPLE:
;       To load a yellow color in color index 100 and plot in yellow, type:

;          yellow = GETCOLOR('yellow', 100)
;          PLOT, data, COLOR=yellow

;       or,

;          PLOT, data, COLOR=GETCOLOR('yellow', 100)

;       To do the same thing on a 24-bit color system with decomposed color on, type:

;          PLOT, data, COLOR=GETCOLOR('yellow', /TRUE)

;       or in IDL 5.2 and higher,

;          DEVICE, Decomposed=1
;          PLOT, data, COLOR=GETCOLOR('yellow')

;       To load all 88 colors into the current color table, starting at
;       color index 100, type:

;          TVLCT, GETCOLOR(), 100

;       To add the color names to a list widget:

;           listID = Widget_List(baseID, Value=GetColor(/Names), YSize=16)

;       To load all 88 colors and have the color indices returned in a structure:

;           DEVICE, Decomposed=0
;           colors = GetColor(/Load, Start=1)
;           HELP, colors, /Structure
;           PLOT, data, COLOR=colors.yellow

;       To get the direct color values as 24-bit integers in color structure fields:

;           DEVICE, Decomposed=1
;           colors = GetColor(/Load)
;           PLOT, data, COLOR=colors.yellow

;       Note that the START keyword value is ignored if on a 24-bit device,
;       so it is possible to write completely device-independent code by
;       writing code like this:

;           colors = GetColor(/Load)
;           PLOT, data, Color=colors.yellow

; MODIFICATION HISTORY:
;       Written by: David Fanning, 10 February 96.
;       Fixed a bug in which N_ELEMENTS was spelled wrong. 7 Dec 96. DWF
;       Added the McIDAS colors to the program. 24 Feb 99. DWF
;       Added the INDEX parameter to the program 8 Mar 99. DWF
;       Added the NAMES keyword at insistence of Martin Schultz. 10 Mar 99. DWF
;       Reorderd the colors so black is first and white is last. 7 June 99. DWF
;       Added automatic recognition of DECOMPOSED=1 state. 7 June 99. DWF
;       Added LOAD AND START keywords. 7 June 99. DWF.
;       Replaced GOLD with CHARCOAL color. 28 Oct 99. DWF.
;       Added INDEXED keyword to force indexed color mode. 28 Oct 99. DWF.
;       Fixed problem of "aqua" and "pink" being mixed up. 18 Mar 00. DWF.
;       Changed ON_ERROR from 1 to 2, and improved error handling. 2 Aug 00. DWF.
;       Increased the known colors from 16 to 88. 19 October 2000. DWF.
;-

;###########################################################################

; LICENSE

; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.

; Copyright � 2000 Fanning Software Consulting.

; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.

; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:

; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.

; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.

; 3. This notice may not be removed or altered from any source distribution.

; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.

;###########################################################################


FUNCTION COLOR24, number

    ; This FUNCTION accepts a [red, green, blue] triple that
    ; describes a particular color and returns a 24-bit long
    ; integer that is equivalent to that color. The color is
    ; described in terms of a hexidecimal number (e.g., FF206A)
    ; where the left two digits represent the blue color, the
    ; middle two digits represent the green color, and the right
    ; two digits represent the red color.

    ; The triple can be either a row or column vector of 3 elements.

    ON_ERROR, 1

    IF N_ELEMENTS(number) NE 3 THEN $
        MESSAGE, 'Augument must be a three-element vector.'

    IF MAX(number) GT 255 OR MIN(number) LT 0 THEN $
        MESSAGE, 'Argument values must be in range of 0-255'

    base16 = [[1L, 16L], [256L, 4096L], [65536L, 1048576L]]

    num24bit = 0L

    FOR j=0,2 DO num24bit = num24bit + ((number(j) MOD 16) * base16(0,j)) + $
        (Fix(number(j)/16) * base16(1,j))

    RETURN, num24bit
END ; ************************  of COLOR24  ******************************



FUNCTION GETCOLOR, thisColor, index, TRUE=truecolor, $
    NAMES=colornames, LOAD=load, START=start, INDEXED=indexedcolor

forward_function ERROR_MESSAGE

Catch, theError
IF theError NE 0 THEN BEGIN
    Catch, /Cancel
    ok = Error_Message(Traceback=1)
    RETURN, 0
ENDIF
; Set up the color vectors.

names =  ['White']
rvalue = [ 255]
gvalue = [ 255]
bvalue = [ 255]
names  = [ names,        'Snow',     'Ivory','Light Yellow',   'Cornsilk',      'Beige',   'Seashell' ]
rvalue = [ rvalue,          255,          255,          255,          255,          245,          255 ]
gvalue = [ gvalue,          250,          255,          255,          248,          245,          245 ]
bvalue = [ bvalue,          250,          240,          224,          220,          220,          238 ]
names  = [ names,       'Linen','Antique White',    'Papaya',     'Almond',     'Bisque',  'Moccasin' ]
rvalue = [ rvalue,          250,          250,          255,          255,          255,          255 ]
gvalue = [ gvalue,          240,          235,          239,          235,          228,          228 ]
bvalue = [ bvalue,          230,          215,          213,          205,          196,          181 ]
names  = [ names,       'Wheat',  'Burlywood',        'Tan', 'Light Gray',   'Lavender','Medium Gray' ]
rvalue = [ rvalue,          245,          222,          210,          230,          230,          210 ]
gvalue = [ gvalue,          222,          184,          180,          230,          230,          210 ]
bvalue = [ bvalue,          179,          135,          140,          230,          250,          210 ]
names  = [ names,        'Gray', 'Slate Gray',  'Dark Gray',   'Charcoal',      'Black', 'Light Cyan' ]
rvalue = [ rvalue,          190,          112,          110,           70,            0,          224 ]
gvalue = [ gvalue,          190,          128,          110,           70,            0,          255 ]
bvalue = [ bvalue,          190,          144,          110,           70,            0,          255 ]
names  = [ names, 'Powder Blue',   'Sky Blue', 'Steel Blue','Dodger Blue', 'Royal Blue',       'Blue' ]
rvalue = [ rvalue,          176,          135,           70,           30,           65,            0 ]
gvalue = [ gvalue,          224,          206,          130,          144,          105,            0 ]
bvalue = [ bvalue,          230,          235,          180,          255,          225,          255 ]
names  = [ names,        'Navy',   'Honeydew', 'Pale Green','Aquamarine','Spring Green',       'Cyan' ]
rvalue = [ rvalue,            0,          240,          152,          127,            0,            0 ]
gvalue = [ gvalue,            0,          255,          251,          255,          250,          255 ]
bvalue = [ bvalue,          128,          240,          152,          212,          154,          255 ]
names  = [ names,   'Turquoise', 'Sea Green','Forest Green','Green Yellow','Chartreuse', 'Lawn Green' ]
rvalue = [ rvalue,           64,           46,           34,          173,          127,          124 ]
gvalue = [ gvalue,          224,          139,          139,          255,          255,          252 ]
bvalue = [ bvalue,          208,           87,           34,           47,            0,            0 ]
names  = [ names,       'Green', 'Lime Green', 'Olive Drab',     'Olive','Dark Green','Pale Goldenrod']
rvalue = [ rvalue,            0,           50,          107,           85,            0,          238 ]
gvalue = [ gvalue,          255,          205,          142,          107,          100,          232 ]
bvalue = [ bvalue,            0,           50,           35,           47,            0,          170 ]
names  = [ names,       'Khaki', 'Dark Khaki',     'Yellow',       'Gold','Goldenrod','Dark Goldenrod']
rvalue = [ rvalue,          240,          189,          255,          255,          218,          184 ]
gvalue = [ gvalue,          230,          183,          255,          215,          165,          134 ]
bvalue = [ bvalue,          140,          107,            0,            0,           32,           11 ]
names  = [ names,'Saddle Brown',       'Rose',       'Pink', 'Rosy Brown','Sandy Brown',       'Peru' ]
rvalue = [ rvalue,          139,          255,          255,          188,          244,          205 ]
gvalue = [ gvalue,           69,          228,          192,          143,          164,          133 ]
bvalue = [ bvalue,           19,          225,          203,          143,           96,           63 ]
names  = [ names,  'Indian Red',  'Chocolate',     'Sienna','Dark Salmon',    'Salmon','Light Salmon' ]
rvalue = [ rvalue,          205,          210,          160,          233,          250,          255 ]
gvalue = [ gvalue,           92,          105,           82,          150,          128,          160 ]
bvalue = [ bvalue,           92,           30,           45,          122,          114,          122 ]
names  = [ names,      'Orange',      'Coral', 'Light Coral',  'Firebrick',      'Brown',  'Hot Pink' ]
rvalue = [ rvalue,          255,          255,          240,          178,          165,          255 ]
gvalue = [ gvalue,          165,          127,          128,           34,           42,          105 ]
bvalue = [ bvalue,            0,           80,          128,           34,           42,          180 ]
names  = [ names,   'Deep Pink',    'Magenta',     'Tomato', 'Orange Red',        'Red', 'Violet Red' ]
rvalue = [ rvalue,          255,          255,          255,          255,          255,          208 ]
gvalue = [ gvalue,           20,            0,           99,           69,            0,           32 ]
bvalue = [ bvalue,          147,          255,           71,            0,            0,          144 ]
names  = [ names,      'Maroon',    'Thistle',       'Plum',     'Violet',    'Orchid','Medium Orchid']
rvalue = [ rvalue,          176,          216,          221,          238,          218,          186 ]
gvalue = [ gvalue,           48,          191,          160,          130,          112,           85 ]
bvalue = [ bvalue,           96,          216,          221,          238,          214,          211 ]
names  = [ names, 'Dark Orchid','Blue Violet',     'Purple' ]
rvalue = [ rvalue,          153,          138,          160 ]
gvalue = [ gvalue,           50,           43,           32 ]
bvalue = [ bvalue,          204,          226,          240 ]

; Did the user ask for a specific color? If not, return
; all the colors. If the user asked for a specific color,
; find out if a 24-bit value is required. Return to caller
; if an error occurs.

ON_Error, 2
ncolors = N_Elements(names)

np = N_Params()
IF N_Elements(start) EQ 0 THEN start = !D.TABLE_SIZE - ncolors - 1 ELSE start = start < (!D.TABLE_SIZE - ncolors - 1)

; User ask for the color names?

IF Keyword_Set(colornames) THEN RETURN, Reform(names, 1, N_Elements(names)) $
    ELSE names = StrUpCase(StrCompress(StrTrim(names,2), /Remove_All))

; If no positional parameter, return all colors.

IF np EQ 0 THEN BEGIN

    ; Did the user want a 24-bit value? If so, call COLOR24.

    IF Keyword_Set(trueColor) THEN BEGIN
        returnColor = LonArr(ncolors)
        FOR j=0,ncolors-1 DO returnColor[j] = Color24([rvalue[j], gvalue[j], bvalue[j]])

        ; If LOAD keyword set, return a color structure.

        IF Keyword_Set(load) THEN BEGIN
            returnValue = Create_Struct('white', returnColor[0])
            FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], returnColor[j])
            returnColor = returnValue
        ENDIF

        RETURN, returnColor
    ENDIF

    ; If color decomposition is ON and INDEXED is not set, return 24-bit values.

    IF Float(!Version.Release) GE 5.2 THEN BEGIN
        IF (!D.Name EQ 'X' OR !D.Name EQ 'WIN' OR !D.Name EQ 'MAC') THEN BEGIN
            Device, Get_Decomposed=decomposedState
        ENDIF ELSE decomposedState = 0
        IF Keyword_Set(indexedcolor) THEN decomposedState = 0
        IF decomposedState EQ 1 THEN BEGIN
            returnColor = LonArr(ncolors)
            FOR j=0,ncolors-1 DO returnColor[j] = Color24([rvalue[j], gvalue[j], bvalue[j]])
            IF Keyword_Set(load) THEN BEGIN
                returnValue = Create_Struct('white', returnColor[0])
                FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], returnColor[j])
                RETURN, returnValue
            ENDIF
            RETURN, returnColor
        ENDIF

        IF Keyword_Set(load) THEN BEGIN
            IF !D.NAME NE 'PRINTER' THEN BEGIN
                TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
            ENDIF ELSE BEGIN
                Set_Plot, 'Z', /Copy
                TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
                Set_Plot, 'PRINTER', /Copy
            ENDELSE
            returnValue = Create_Struct('white', start)
            FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], start+j)
            RETURN, returnValue
        ENDIF

        returnColor = REFORM([rvalue, gvalue, bvalue], ncolors, 3)
        RETURN, returnColor

    ENDIF

    IF Keyword_Set(load) THEN BEGIN
        IF !D.NAME NE 'PRINTER' THEN BEGIN
            TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
        ENDIF ELSE BEGIN
            Set_Plot, 'Z', /Copy
            TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
            Set_Plot, 'PRINTER', /Copy
        ENDELSE
        returnValue = Create_Struct('white', start)
        FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], start+j)
        RETURN, returnValue
    ENDIF

    returnColor = REFORM([rvalue, gvalue, bvalue], ncolors, 3)
    RETURN, returnColor

ENDIF

; Make sure the color parameter is an uppercase string.

varInfo = SIZE(thisColor)
IF varInfo(varInfo(0) + 1) NE 7 THEN $
    MESSAGE, 'The color name must be a string.'
thisColor = StrUpCase(StrCompress(StrTrim(thisColor,2), /Remove_All))

; Check synonyms of colors.

IF StrUpCase(thisColor) EQ 'GREY' THEN thisColor = 'GRAY'
IF StrUpCase(thisColor) EQ 'AQUA' THEN thisColor = 'AQUAMARINE'
IF StrUpCase(thisColor) EQ 'SKYBLUE' THEN thisColor = 'SKY'
IF StrUpCase(thisColor) EQ 'LIGHTGREY' THEN theColor = 'LIGHTGRAY'
IF StrUpCase(thisColor) EQ 'MEDIUMGREY' THEN theColor = 'MEDIUMGRAY'
IF StrUpCase(thisColor) EQ 'SLATEGREY' THEN theColor = 'SLATEGRAY'
IF StrUpCase(thisColor) EQ 'DARKGREY' THEN theColor = 'DARKGRAY'
IF StrUpCase(thisColor) EQ 'SKY' THEN theColor = 'SKYBLUE'
IF StrUpCase(thisColor) EQ 'NAVY BLUE' THEN theColor = 'NAVY'
IF StrUpCase(thisColor) EQ 'NAVYBLUE' THEN theColor = 'NAVY'


; Get the color triple for this color.

colorIndex = WHERE(names EQ thisColor)

; If you can't find it. Issue an informational message,
; set the index to a YELLOW color, and continue.

IF colorIndex(0) LT 0 THEN BEGIN
    MESSAGE, "Can't find color " + thisColor + ". Returning " + StrUpCase(names[0]) + ".", /INFORMATIONAL
    thisColor = names[0]
    colorIndex = 0
ENDIF

; Get the color triple.

r = rvalue(colorIndex)
g = gvalue(colorIndex)
b = bvalue(colorIndex)
returnColor = REFORM([r, g, b], 1, 3)

; Did the user want a 24-bit value? If so, call COLOR24.

IF KEYWORD_SET(trueColor) THEN BEGIN
    returnColor = COLOR24(returnColor)
    RETURN, returnColor[0]
ENDIF

; If color decomposition is ON and INDEXED is OFF,, return 24-bit value.

IF Float(!Version.Release) GE 5.2 THEN BEGIN

    IF (!D.Name EQ 'X' OR !D.Name EQ 'WIN' OR !D.Name EQ 'MAC') THEN BEGIN
        Device, Get_Decomposed=decomposedState
    ENDIF ELSE decomposedState = 0
    IF Keyword_Set(indexedcolor) THEN decomposedState = 0

    IF decomposedState EQ 1 THEN BEGIN

        ; Before you change return color, load index if requested.

        IF N_Elements(index) NE 0 THEN BEGIN
            index = 0 > index < (!D.Table_Size-1)
            IF !D.NAME NE 'PRINTER' THEN BEGIN
                TVLCT, returnColor, index
            ENDIF ELSE BEGIN
                Set_Plot, 'Z', /Copy
                TVLCT, returnColor, index
                Set_Plot, 'PRINTER', /Copy
            ENDELSE
        ENDIF

        returnColor = COLOR24(returnColor)
        RETURN, returnColor[0]
    ENDIF
ENDIF

; Did the user specify a color index? If so, load it.

IF N_Elements(index) NE 0 THEN BEGIN
    index = 0 > index < (!D.Table_Size-1)
    IF !D.NAME NE 'PRINTER' THEN BEGIN
        TVLCT, returnColor, index
    ENDIF ELSE BEGIN
        Set_Plot, 'Z', /Copy
        TVLCT, returnColor, index
        Set_Plot, 'PRINTER', /Copy
    ENDELSE
    returnColor = index
    RETURN, returnColor[0]
ENDIF

; Did the user specify INDEXED color? If so, load it.

IF Keyword_Set(indexedColor) THEN BEGIN
    IF !D.NAME NE 'PRINTER' THEN BEGIN
        TVLCT, returnColor, !P.Color
    ENDIF ELSE BEGIN
        Set_Plot, 'Z', /Copy
        TVLCT, returnColor, !P.Color
        Set_Plot, 'PRINTER', /Copy
    ENDELSE
    returnColor = !P.Color < (!D.Table_Size -1)
    RETURN, returnColor[0]
ENDIF

RETURN, returnColor
END


pro  load_isdac_walters_convair_bulk_data_file,Bulkdata, TimeWalt,TempRSTemp
    ; load the walters  data file.  version 3  archived in arm.gov

    filenmw=dialog_pickfile(title='pls pick a Dir & Click a file of walters bulk data',filter='*F*_*.txt',Get_path=pathnm)
    base_filenmw=file_basename(filenmw)

    data=read_ascii(filenmw,count=n_lines)
    nnnseconds=(n_lines-6)
    junk=strarr(6)
    openr,2,filenmw
    readf,2,junk
    Data={UTC:0L,   Seconds:0L,   ThkAlt:0.0, PreAlt:0.0,  ALT_G:0.0,  NPres:0.0,   BCPres:0.0,  KT_19:0.0,     RSTem:0.0,$
        RFTS:0.0,  EGGDew:0.0,  ReHuW:0.0,  ReHuI:0.0,   LicDew:0.0, LicFro:0.0,  BmTAS:0.0,   BmLAS:0.0,     HDG:0.0, $
        TRK:0.0,   ALPHA:0.0,   BETA:0.0,   PITCH:0.0,   ROLL:0.0,   driftA:0.0,  MastrLAT:0.0,MasterLON:0.0, PosStat:0.0,$
        Brg01:0.0, Range01:0.0, MWSpd:0.0,  MWDir:0.0,   VWND_P:0.0, NevCExt:0.0, R96:0.0,     F96CncX:0.0,   F96Ext:0.0,$
        FS96MeVD:0.0,F6LWC:0.0, R02:0.0,    F02XCnc:0.0, F02Ext:0.0, FS02MeVD:0.0,F02LWC:0.0,  CDPTot:0.0,    CDPMedVD:0.0,$
        CDPExt:0.0, CDPLWC:0.0, F300Cnc:0.0,F3Cgt2um:0.0,KSzrLW:0.0, CSI_TCWC:0.0,CSITCWzr:0.0,ROSIC1:0.0,    RIDInd:0.0, $
        TDC0ShdOr:0.0,TDP1ShdOr:0.0,PCTcon:0.0,CVIFlg:0.0, CVISamP:0.0,CVISamT:0.0,CVISampFl:0.0,CVI_Eh:0.0}; ; 64 values.
    BulkData=replicate(data,nnnseconds)
    readf,2,BulkData
    close,2

    Bulkseconds=(Bulkdata.UTC/10000L)*3600LL+((Bulkdata.UTC mod 10000L)/100LL)*60LL +(Bulkdata.UTC mod 100L)

    Bulkdata.seconds=Bulkseconds
    TimeWalt  =Bulkseconds
    TempRSTemp=bulkdata.RSTem

    filename=file_basename(filenmw)

    ;plot Time series of Altitude and temperature.

    bluecolor  =GetColor("Navy", !D.Table_Size-2)
    redcolor   =GetColor("Red", !D.Table_Size-2)
    whitecolor =GetColor("White", !D.Table_Size-2)
    blackcolor=getcolor("black",!D.Table_Size-2)
    greencolor=getcolor("Green",!D.Table_Size-2)

    !P.thick=1
    !P.CHARSIZE=1.0
    !P.BACKGROUND=whitecolor
    !P.multi=[0,1,2]

    strt_time_insec=Bulkseconds(0)
    end_time_insec=max(Bulkseconds)

    window,4, xs=72*11.0, ys=72*8.5
    GetHHMMSS_from_MidNightSEconds,Strt_Time_inSec, HHMMSS, Shh, Smm, Sss,shhstr,smmstr,sssstr
    GetHHMMSS_from_MidNightSEconds, End_Time_insec, HHMMSS, Ehh, Emm, Ess,ehhstr,emmstr,essstr
    HHMMSS_S=shhstr+smmstr+sssstr
    HHMMSS_E=ehhstr+emmstr+essstr

    this_pages_StartTime_str=strtrim(string(strt_Time_insec),2);  0
    This_pages_EndTime_str  =strtrim(string(end_Time_insec),2)
    Xmin=Strt_Time_insec
    Xmax=End_time_insec

    fullrange =(Xmax-Xmin)
    binwidth = fullrange/4;  make 5 ticks, 4 bins.
    curbin = Xmin
    tnames = StrArr(5)

    FOR k=0,4 DO BEGIN
        GetHHMMSS_from_MidNightSEconds,curbin, HHMMSS, hh, mm, ss,hhstr,mmstr,ssstr
        tnames(k) = HHMMSS
        curbin += binwidth
    ENDFOR

    ;-------------------------------
    This_year='2008'
    This_month=strmid(base_filenmw,0,2)
    This_day_str=strmid(base_filenmw,2,2)

    vector=[bulkdata.Alt_G/1000.0]
    indexj=where(vector gt 0.0, contG)
    if contG gt 0 then  ymin=min(vector(indexj)) else ymin=0.001
    ymax=max(vector)
    Ymin=1.0


    ; plot 1 of 2
    PLOT, Bulkseconds,vector, COLOR=Blackcolor, XRANGE=[Xmin,Xmax],xmargin=[8.0,5.0],$
        Xstyle = 1,ylog=0,THICK=1, YRANGE=[0.0, ymax],ystyle=1,xticks=4,$
        xtickname=tnames,/normal,ymargin=[2.0,3.0],$; ;bottom is the first number. no need x-axis able, so let it be 2.0
        charsize=1.2,YTITLE='AltGps,km';  Yticks=ytikn,Ytickn=myticknames
    ;oplot,TimeP,waterP, color=bluecolor;   % paul water   ocean blueto mean water
    ;oplot,TimeP,iceP,color=greencolor
    ;oplot,TimeP,ratioall,color=redcolor

    xyouts,0.5,0.975,'Fig.2  ISDAC  Date: '+junk(1), color=blackcolor,charsize=1.5,/normal,alignment=0.5
    xyouts,0.5,0.945,'Convair 580 GPS Altitude, km',$
        color=blackcolor,charsize=1.1,/normal,alignment=0.5
    xyouts,0.50,0.02,'UTC Time',color=blackcolor,charsize=1.2,/normal,alignment=0.5

    ; plot 2 of 2
    vector=[TempRSTemp]
    ymin=min(vector)
    ymax=max(vector)

    PLOT, Bulkseconds,vector, COLOR=Blackcolor, XRANGE=[Xmin,Xmax],xmargin=[8.0,5.0],$; margin is in unit words.
        Xstyle = 1,ylog=0,THICK=1, YRANGE=[Ymin, ymax],ystyle=1,xticks=4,$
        xtickname=tnames,/normal,title='Walter Bulk file: '+ base_filenmw,ymargin=[4.0,3.0],$; top is 3.0, botton is 4.0
        charsize=1.2,YTITLE='RSTem,DegC';  Yticks=ytikn,Ytickn=myticknames
    ;oplot,TimeP,waterP, color=bluecolor;   % paul water   ocean blueto mean water
    ;oplot,TimeP,iceP,color=greencolor
    ;oplot,TimeP,ratioall,color=redcolor
    xyouts,0.50,0.02,'UTC Time',color=blackcolor,charsize=1.2,/normal,alignment=0.5

    outfilename2=pathnm+'ISDAC_Bulkdata_'+strmid(base_filenmw,0,15)+'_'+This_pages_startTime_str+$
        '_'+strtrim(string(This_Pages_EndTime_str),2)+'_'+HHMMSS_S+'_'+HHMMSS_E+'.jpg'

    write_jpeg,outfilename2,tvrd(true=1),true=1


end


pro  get_all_data_filenames,filter_str,pathnm,filenames,file_count
    ;input is filter_str, pathnm
    ;output is filenames,file_count
    substrs=strsplit(filter_str,'.',/extract)
    extension=substrs(1)

    do_loop=1
    WHILE (do_loop eq 1) do begin    ;repeatedly selecting files until
        ;user comfirms
        whole_filter_str=pathnm+filter_str
        filenames=findfile(whole_filter_str,COUNT=file_count)
        ;find all files with filter_str and counts the number of these files

        ; display the files in the screen for user to review
        print,'***********************************************************'
        print,'********  Here are data files with ',filter_str, '   ******'
        print,'*** found in current directory for input by this program ***'
        print,'************************************************************'

        for j=0, (file_count-1)  do begin
            print, filenames(j)
        endfor

        print,'*********************************************'

        ; print the message to ask user to confirm
        ; define answer to be a string
        answer=' '

        print,'Are you sure to read above files ? yes/no'

        print,'----if no, then enter a string with wildcat (* or ?)'
        print,'           to limit the files being selected for input.'
        print,'           for example:   *lear_1749*.',extension
        print,'----Or--stop now, delete those unwanted files from  '
        print,'           the current directory, then restart '
        print,'           this program'
        print, 'Enter y or n:'
        read,answer

        if strcmp(answer,'y') then  do_loop=0
        if (strcmp(answer,'y') eq 0) then begin
            print,'  Enter the string(ie: *6*b?*.',extension,'):'
            read,answer    ; use this string for selecting input data files.
            filter_str=pathnm+answer   
        endif

    ENDWHILE           ; end of initial start up.
    print,'                            '
    print,' done,get the files,.....Processing,  please wait ! '
    print,'
end; endof get_all_data_filenames,filter_str,filenames,pathnm
;****************************************************************************
