function scan_im_1,fileUnit,filePos

    ; this routine will scan an image block and return selected data
    ; the file pointer is assumed to be pointing at the next item after the headerblock marker

    ; set variable types for reading
    day = 0B
    hour = 0B
    minute = 0B
    sec = 0B
    msec = 0U
    ImgType = 0U
    readu, fileUnit, day, hour, minute, sec, msec, ImgType
    BegPos = filePos ;- 2
    return,{FPos:BegPos, ImgType:ImgType, day:day, hour:hour, minute:minute, sec:sec, msec:msec,ROIsCount:0U}

end

function scan_im_2,fileUnit,filePos,year
    forward_function convertFromSeconds,CalcStrobeTime

    ; this routine reads critical info from the image block and returns it via a structure
    ; input parameters are assumed to be valid, and that the filePos is at the element past the block type
    ; {    FPos:BegPos,     first byte location of this block
    ;  ImgType:ImgType, image type
    ;  HTime:HTime}     number of missed particles in down time
    ; The filePos value points to the next block

    ; TAF assuming the input parameters are valid was a bad notion by the original author.
    ; This leads to errors, in particular POINT_LUN: Negative position argument not allowed. Position: -60216967, Unit: 100, File: D:\SPEC\DC3\FLIGHT_DATA\GV\tf04-may14_cpi\051417043.roi.
    ; on the 3V-CPI.

    hk1 = FIX('484B'X)
    im3 = FIX('A3D5'X)

    BegPos = filePos  - 2
    ; Read critical block info

    ImgBlockSize = 0UL  ; 8 hex digits
    ImgDataVer   = 0U   ; 4 hex digits
    ROIsCount    = 0U   ; 4 hex digits
    TotROIsSize  = 0UL  ; 8 hex digits
    day          = 0B   ; 2 hex digits
    hour         = 0B   ; 2 hex digits
    minute       = 0B   ; 2 hex digits
    sec          = 0B   ; 2 hex digits
    msec         = 0U   ; 4 hex digits
    ImgType      = 0U   ; 4 hex digits

    READU, fileUnit, ImgBlockSize, ImgDataVer, ROIsCount, TotROIsSize, day, hour, minute, sec, msec, ImgType


    ;if(totroissize eq 2859) then begin
    ;    printh, filepos

    ;    stop
    ;endif


    HTime = 0U;  Now here come the 3 words of the Time since the probe was turned on.
    ArrivalT1 = 0U;   one word is 2 byte.   (AF,CD);  This are the 3 Time words of the 3VCPI now---august5,2010.
    ArrivalT2 = 0U

    ;Read in time parameters
    if(ImgDataVer GE 23)then begin
        POINT_LUN, fileUnit, begPos + 84 ; + 82

        if(ImgDataVer GE 25)then READU, fileUnit, HTime,ArrivalT1,ArrivalT2
        ;print,HTime,ArrivalT1,ArrivalT2
    endif

    Htime_new = Htime * 16LL^8 + ArrivalT1 * 16LL^4 + ArrivalT2 * 1LL
    Htime     =Htime_new;    ; for 3VCPI
    ; Move to end of block

    ; TAF original line below leads to negative FilePos values
    ;filePos = filePos + ImgBlockSize ; - 2

    ;filePos = long(filePos)

    ;    if(filePos + ImgBlockSize le 0) then begin
    ;        stop
    ;    endif




    ;Raw file coding of Imgtype
    ;       UnSet          Set
    ;  Bit 0    image not present  image present
    ;  Bit 1    normal img        background img
    ;  Bit 2    ROI              Full Img
    ;  Bit 3    Raw              Background Subtracted
    ;  Bit 4    data transferred   new data

    ; set imgtype to a code
    ;  1 = normal frame with roi's
    ;  2 = background
    ;  0 = error type

    ;    if(ImgType and 1)then begin
    ;       case 1 of
    ;       (not(ImgType and 2)/2 and ROIsCount ge 1 ):begin

    ;        ; Move past the ROI blocks which follow
    ;        ;FilePos = FilePos + TotROIsSize

    ;        ;filePos = long(filePos)

    ;        if(filePos + ImgBlockSize le 0) then begin
    ;            stop
    ;        endif

    ;        filePos += long(ImgBlockSize)

    ;        POINT_LUN, fileUnit, FilePos
    ;        ImgType  = 1U

    ;       end
    ;       ((ImgType and 2) eq 2 ): begin
    ;         ; background image
    ;         FilePos = FilePos + TotROIsSize
    ;         POINT_LUN, fileUnit, FilePos
    ;         ImgType  = 2U

    ;       end
    ;       else:ImgType = 0U
    ;       endcase
    ;    endif else ImgType = 0U

    ;stop
    testread1 = fix(0)
    testread2 = fix(0)

    if(ImgType and 1)then begin
        if(not(ImgType and 2)/2 and ROIsCount ge 1) then begin
            ImgType  = 1U

            filePos += long(ImgBlockSize)
            filePos += long(TotROIsSize)
            ;filePos += 12L




            ;            ; test for 2 bytes shorter than specified
            ;            point_lun, fileUnit, filePos - 2L
            ;            readU, fileUnit, testread

            ;            ; test for next blockmark to determine short vs long HK
            ;            if(testread ne im3 and testread ne hk1) then begin
            ;                filePos -= 2L
            ;                ;stop
            ;            endif else begin
            ;                ; test for correct vs 10 bytes longer than specified
            ;                point_lun, fileUnit, filePos
            ;                readU, fileUnit, testread

            ;                if(testread ne im3 and testread ne hk1) then begin
            ;                    filePos += 10L
            ;                    ;stop

            ;                    point_lun, fileUnit, filePos
            ;                    readU, fileUnit, testread

            ;                    if(testread ne im3 and testread ne hk1) then begin
            ;                        filePos += 2L
            ;                        ;stop
            ;                    endif
            ;                endif
            ;            endelse

            point_lun, fileUnit, filePos


            ;stop
        endif else if((ImgType and 2) eq 2 ) then begin
            ; background image
            ImgType  = 2U

            filePos += long(ImgBlockSize)
            filePos += long(TotROIsSize)
            ;filePos += 12L

            ;point_lun, fileUnit, filePos

            ;readU, fileUnit, testread

            ; test for next blockmark to determine short vs long HK
            ;if(testread ne im3 and testread ne hk1) then begin
            ;    filePos += 12L
            ;endif

            ;point_lun, fileUnit, filePos
        endif else begin
            ImgType = 0U

            filePos += long(ImgBlockSize)
        endelse
    endif else begin
        ImgType = 0U

        filePos += long(ImgBlockSize)
        ;stop
    endelse


    tries  = 128
    offset = 16

    done = 0

    ; line up with next valid header
    if(filePos + 4L lt (fstat(fileUnit)).size) then begin
        point_lun, fileUnit, filePos
        readU, fileUnit, testread1
        readU, fileUnit, testread2

        if((testread1 eq im3 and testread2 eq '0068'X) or $
            (testread1 eq hk1 and testread2 eq '0053'X)) then begin

            done = 1
        endif else begin
            filePos -= offset

            while(not done and filePos + 4L lt (fstat(fileUnit)).size) do begin
                point_lun, fileUnit, filePos
                readU, fileUnit, testread1
                readU, fileUnit, testread2

                if((testread1 eq im3 and testread2 eq '0068'X) or $
                    (testread1 eq hk1 and testread2 eq '0053'X)) then begin

                    done = 1
                    break
                endif else begin
                    filePos += 1L
                endelse

                tries--

                if(tries le 0) then begin
                    print, 'scan_image_block could not find next block mark in quick search, dropping out and letting main scanspec search for next block'
                    printh, filepos
                    done = 1
                    break
                endif
            endwhile
        endelse
    endif

    point_lun, fileUnit, filePos

    ;    if(day eq 21 and hour eq 22 and minute eq 21 and sec eq 11 and msec eq 149) then begin
    ;        stopmark = 1

    ;        stop
    ;    endif

    ;    if(day eq 21 and hour eq 22 and minute eq 21 and sec eq 11 and msec eq 152) then begin
    ;        stopmark = 1

    ;        stop
    ;    endif

    if(hTime gt 5)then begin
        ;time = convertFromSeconds(hTime,year); added following these lines to replace CPI time wth das time
        time        = {times}
        time.month  = 0
        time.day    = day
        time.hour   = hour
        time.minute = minute
        time.sec    = sec
        ;msec  = ROUND(CalcStrobeTime(ArrivalT1, ArrivalT2,ImgDataVer))

        ; return,{FPos:BegPos, ImgType:ImgType,HTime:HTime, day:time.day, hour:time.hour, minute:time.minute, sec:time.sec, msec:msec,ROIsCount:ROIsCount}
        return,{FPos:BegPos, ImgType:ImgType,HTime:HTime, day:time.day, hour:time.hour, minute:time.minute, sec:time.sec, msec:msec,ROIsCount:ROIsCount}

    endif else begin

        return,{FPos:BegPos, ImgType:ImgType,HTime:HTime, day:0U, hour:0U, minute:0U, sec:0U, msec:0U,ROIsCount:ROIsCount}
    endelse

end

function scan_image_block, fileUnit, filePos, BlockMark, filever, year

    case 1 of
        ; Vers 1.0 ImageData Block
        (BlockMark EQ FIX('A1D5'X) AND FileVer LT 20): BEGIN
            results = scan_im_1(fileUnit, filePos)
        END

        ; Ver 2.0 ImageData Block
        (BlockMark EQ FIX('A1D5'X) AND FileVer GE 20) OR (BlockMark EQ FIX('A2D5'X)) OR (BlockMark EQ FIX('A3D5'X)): BEGIN

            results = scan_im_2(fileUnit, filePos, year)
        END
        else:r = dialog_message("Fatal Error in Read_Image: Block type not supported.")
    endcase

    return,results
end
