function checkHasp,haspFile
    ; Routine to check for a valid HASP key attached

    ; NOTE: use the seed value to generate a set of unique return values

    ;	haspFile	Input	location of the HASP DLL

    ; Return values
    ;	0		 no HASP present
    ;	1		 Quick Look Version
    ;	2		 eXtractor
    ;	3		 Classifier

    service = 3L
    LPTNum = 0L
    pass1 = 7863L
    pass2 = 30541L
    seed = 23L
    p1=0L
    p2=0L
    p3=0L
    p4=0L

    r = call_external(haspFile,'hasp',service,seed,LPTNum,pass1,pass2,p1,p2,p3,p4)

    ;for seed1 23L return codes should be:
    ;55834	65201	16107	4058

    if p3 eq -3 then return,0 ; no HASP

    case p2 of
        '1111'X:return,1 ; quicklook
        '2222'X:return,2 ; eXtractor
        '3333'X:return,3 ; Classifier
        else:return,0 ; failed
    endcase


end
