pro compare_CPI_PSDs_with_CPI_wysywygr_psd

    read_in_CPI_PSDs_data_file,xpts1,Hypts1,file1,pathname;   ; triggered data
    read_in_CPI_PSDs_data_file,xpts2,Hypts2,file2,pathname;   ;random mode data


    window,1,xs=400,ys=400
    loadct,0
    !P.thick=1
    !P.CHARSIZE=1
    !P.multi=[0,1,1]
    white=!D.N_COLORS-1
    !P.BACKGROUND=white

    vector=[hypts1,hypts2]

    index=where(vector gt 0.0,contG)
    if contG gt 0 then begin
        ymin=min(vector(index))
    endif else ymin=0.0001

    ymax=max([max(hypts1),max(hypts2)])
    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))



    PLOT, xpts1, Hypts1, COLOR=0, XRANGE=[3,300], /Xlog,$
        Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',TITLE='CPI PSDs no_adj1 and wysywyg_r',$
        THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0,$
        YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
    oplot,xpts2,hypts2,color=255
    xyouts,0.55,0.90,'no_adj',color=0,/normal
    xyouts,0.55,0.80,'wysywygr',color=255,/normal

    time1_str=  '000525';  strtrim(string(hh1),2)+'-'+strtrim(string(mm1),2)+'-'+strtrim(string(ss1),2)
    time2_str=  '000550';  strtrim(string(hh2),2)+'-'+strtrim(string(mm2),2)+'-'+strtrim(string(ss2),2)

    xyouts, 0.55,0.75,'Time:'+time1_str+'-'+time2_str,color=155,/normal

    outfile=pathname+'Compare_CPI_PSDs_1_'+time1_str+'_'+time2_str+'.jpg'
    write_jpeg,outfile,tvrd(true=1),true=1



    window,2,xs=400,ys=400

    factor =max(hypts2)/max(hypts1)
    factor_str=string(format='(F7.1)',factor)

    hypts1=hypts1*factor

    vector=[hypts1,hypts2]

    index=where(vector gt 0.0,contG)
    if contG gt 0 then begin
        ymin=min(vector(index))
    endif else ymin=0.0001

    ymax=max([max(hypts1),max(hypts2)])
    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))



    PLOT, xpts1, Hypts1, COLOR=0, XRANGE=[3,300], /Xlog,$
        Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',TITLE='CPI PSDs no_adj1 and wysywyg_r',$
        THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0,$
        YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
    oplot,xpts2,hypts2,color=255
    xyouts,0.55,0.90,['noadj*'+factor_str],color=0,/normal
    xyouts,0.55,0.80,'wysywygr',color=255,/normal

    xyouts, 0.55,0.75,'Time:'+time1_str+'-'+time2_str,color=155,/normal

    outfile=pathname+'Compare_CPI_PSDs_2_'+time1_str+'_'+time2_str+'.jpg'
    write_jpeg,outfile,tvrd(true=1),true=1

end; end of plot_2ds_1Hz_mean_psd
;*************************************************
pro read_in_CPI_PSDs_data_file, xpts,ypts,filename, pathnm
    filename=dialog_pickfile(filter='*.txt',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-7)
    junk=strarr(7)
    openr,2,filename
    readf,2,junk
    Data={xpts:0.0,ypts:0.0,Lpts:0.0,Apts:0.0,Mpts:0.0}


    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2
    xpts=TDSdata.xpts
    ypts=TDSData.ypts
end; end of read_in_2ds_data_from_1Hz_archive.

