pro compare_Crave_CPI_2DS_and_CAPS_psds

    forward_function Mo_getcolor
    ;display the progarm usage:
    message=[['  This needs a MSyyyymmdd.WB57 archive file and a TDyyyymmdd.WB57 archive file '],$
        ['  and CPyyyymmdd.WB57 which is generated from '],$
        ['  CPI ascii files:  *comb.csv,  *hzlog.txt,  *frame.txt, *WB57log.txt'],$
        ['  to run for comparing CRAVE CPI, 2DS, CAPS psds for a time period. '],$
        ['  You will be prompt for start time and end time in following format:'],$
        ['  for start time:   hh:mm:ss'],$
        ['  for   end time:   hh:mm:ss'],$
        ['  The time interval must of a nultiple of 30 seconds']]
    rrrrr=dialog_message(message,/information)

    rrr=dialog_message('Want to compare 2DS with CAPS ? ',/question)

    ;read in the whole data files:
    if rrr eq 'Yes' then begin
        read_in_2ds_data_from_1Hz_archive,TDsData,pathnm
        file1_end_time=max(TDsdata.seconds)
    endif

    read_caps_data,pathnm,caps_data,xcaps,caps_binwidths
    file2_end_time=max(Caps_data.seconds)

    read_CPI_data,pathnm,CPI_data,xcpi,cpi_binwidths


    if n_elements(file1_end_time) eq 0 then file1_end_time=file2_end_time

    max_seconds_of_the_2files=file1_end_time < file2_end_time
    min_seconds = max_seconds_of_the_2files

    caps_seconds=caps_data(0).seconds
    cap_hh=strtrim(fix(caps_seconds /3600LL),2)
    cap_mm=strtrim(fix((caps_seconds mod 3600LL)/60LL),2)
    cap_ss=strtrim(fix((caps_seconds mod 60LL)),2)
    print,'Caps data start time is:'+cap_hh+':'+cap_mm+':'+cap_ss

    com_hh=strtrim(fix(min_seconds /3600LL),2)
    com_mm=strtrim(fix((min_seconds mod 3600LL)/60LL),2)
    com_ss=strtrim(fix((min_seconds mod 60LL)),2)
    print,'The end time of the 2DS and CAPS time is:'+com_hh+':'+com_mm+':'+com_ss
    ;select time period.
    time1='16:40:29';    this matched ave_start=10, end=13 data.
    time2='18:19:29'
    print, 'Please enter start time in hh:mm:ss format:'
    read,time1
    print, 'Please enter end time in hh:mm:ss format:'
    read,time2


    ;request times
    starttime=time1;   for this periods, caps don't see anything bigger than 10um.
    endtime  =time2;  is string format hh:mm:ss

    substr=strsplit(starttime,':',/extract)
    startseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL

    substr=strsplit(endtime,':',/extract)
    endseconds=substr(0)*3600LL+substr(1)*60LL+substr(2)*1LL



    ;get CPI psd from the selectled time period only.
    ;********************************************************************
    ;get_CPI_psd_from_selected_file,xcpi,ycpi
    ;*********************************************************************

    done=0

    while done eq 0 do begin

        ;get the 2ds data from time 1 to time 2 and Caps data from time 1 to time 2
        if rrr eq 'Yes' then begin
            Get_2ds_time1totime2_TMS_mean_psd,startseconds,endseconds,TDsdata,$
                time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts
            ;Vypts=Vypts*0.0
        endif else begin
            Hconc=0.0
            Hextn=0.0
            Hiwc=0.0
            Hsv=0.0
            Hmnsz=0.0
            Vconc=0.0
            Vextn=0.0
            Viwc=0.0
            Vsv=0.0
            Vmnsz=0.0
            Hypts=0.0
            Vypts=0.0

        endelse

        if max(hypts) ne 0.0 or max(vypts) ne 0.0 then Has_2ds=1 else Has_2ds=0

        ;get caps data
        get_mean_psd_of_caps,startseconds+30,endseconds+30,Caps_data,caps_binwidths,xcaps,ycaps
        if max(ycaps) ne 0.0 then has_caps=1 else has_caps=0

        ;get cpi mean psd
        get_mean_psd_of_cpi,startseconds,endseconds,CPI_data,cpi_binwidths,xcpi,ycpi,meanTas


        ;get 2dsview saved.txt psds
        ;get_2dsview_psd_cmp_psd,x2ds,y2ds

        if has_caps eq 1 or has_2ds eq 1 then begin;  make the plot if there is data
            window,1,xs=600,ys=600;  300; 300
            bluecolor=Mo_getcolor("Blue",!D.Table_Size-2)
            greencolor=Mo_getcolor("Green",!D.Table_Size-2)
            redcolor =Mo_getcolor('Red',!D.Table_Size-2)
            white=Mo_getcolor('White',!D.Table_Size-2)
            blackcolor=Mo_getcolor('Black',!D.Table_Size-2)

            ;loadct,0
            ;!P.thick=1*2
            ;!P.CHARSIZE=0.8*2
            !P.multi=[0,1,1]
            ; white=!D.N_COLORS-1
            !P.BACKGROUND=white

            index=where(hypts gt 0.0,contG)
            if contG gt 0 then begin
                hymin=min(hypts(index))
            endif else hymin=0.1

            index=where(Vypts gt 0.0,contG)
            if contG gt 0 then begin
                vymin=min(vypts(index))
            endif else vymin=0.1

            index=where(ycaps gt 0.0,contG)
            if contG gt 0 then begin
                ymincaps=min(ycaps(index))
            endif else ymincaps=0.1


            ymin=min([hymin,vymin,ymincaps])
            ymax=max([max(hypts),max(vypts),max(ycaps)])
            ymin=10.0^floor(Alog10(ymin))
            ymax=10.0^ceil(Alog10(ymax))

            PLOT, xcaps, ycaps, COLOR=Blackcolor, XRANGE=[1,1000], /Xlog,$
                Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',$
                TITLE='CAPS, CPI & 2DS.1Hz Archive Data',$
                THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=0.8*2,$
                YTITLE='#/L/um',/nodata;  Yticks=ytikn,Ytickn=myticknames

            oplot,xcaps,ycaps,color=Redcolor
            xyouts,210*2+30,210*2+10,'Red Caps',color=Redcolor,/device

            if rrr eq 'Yes' then begin
                oplot,xpts-5,Hypts,color=Bluecolor,thick=1.3*2
                oplot,xpts-5,Vypts,color=Greencolor,thick=1.3*2
                xyouts,210*2+30,185*2,'Blue 2ds.H',color=Blueclor,/device
                xyouts,210*2+30,160*2,'Green 2ds.V',color=Greencolor,/device
            endif

            oplot,xcpi,ycpi,color=Blackcolor,thick=2.0*2
            xyouts,210*2+30,140*2,'Blck CPI',color=Blackcolor,/device


            ;label teh times
            Secs_To_Times,startseconds,Stime ; Stime is string
            Secs_To_Times,endseconds,Etime
            xyouts,125*2+30,265*2+10,Stime+' to '+Etime,color=blackcolor,/device
            str1=strjoin(strsplit(Stime,':',/extract))
            str2=strjoin(strsplit(Etime,':',/extract))
            outfilename=pathnm+'Caps_2ds_cpi_'+str1+'_'+str2+'_psd.png'
            write_png, outfilename,tvrd(true=1)

            ;output the ascii for all four curves
            ;*******************************************************
            ;print out the 3 instrument's psd into one ascii file.
            outfilename=pathnm+'Caps_2ds_cpi_'+str1+'_'+str2+'_psd.txt'
            openw,12,outfilename
            printf,12,'Caps 2dS CPI psd data for the same time periods'
            printf,12,'Caps psd: bin-edges bin_height --(#/L/um)'
            for i=0,n_elements(xcaps)-1 do begin
                printf,12,xcaps(i),ycaps(i)
            endfor

            printf,12,'2DS psd: xbin_edges  H_ybin_height V_ybin_heiht --(#/L/um)'
            for i=0,n_elements(xpts)-1 do begin
                printf,12,xpts(i)-5,Hypts(i),Vypts(i)
            endfor

            printf,12,'CPI psd: xbin_edges  ybin_height--(#/L/um)  mean-Tas=',meanTAS
            for i=0,n_elements(xcpi)-1 do begin
                printf,12,xcpi(i),ycpi(i)
            endfor
            close,12
            ;*******************************************************


            ;doing the 2ds overlay plots of each second
            if 1 eq 2 then begin
                window,2,xs=300,ys=300,xpos=300,ypos=20

                index=where(hypts gt 0.0,contG)
                if contG gt 0 then begin
                    hymin=min(hypts(index))
                endif else hymin=0.1

                index=where(Vypts gt 0.0,contG)
                if contG gt 0 then begin
                    vymin=min(vypts(index))
                endif else vymin=0.1

                index=where(ycaps gt 0.0,contG)
                if contG gt 0 then begin
                    ymincaps=min(ycaps(index))
                endif else ymincaps=0.1


                ymin=min([hymin,vymin,ymincaps])
                ymax=max([max(hypts),max(vypts),max(ycaps)])
                ymin=10.0^floor(Alog10(ymin))
                ymax=10.0^ceil(Alog10(ymax))

                PLOT, xpts-5, Hypts, COLOR=0, XRANGE=[1,1000], /Xlog,$
                    Xstyle = 1, YLOG=1,xtitle='Particle Size(um)',$
                    TITLE='PSD from CAPS & 2DS.1Hz Archive Data',thick=2.3,$
                    YRANGE=[ymin, ymax],ystyle=1, charsize=0.8,$
                    YTITLE='#/L/um';  Yticks=ytikn,Ytickn=myticknames
                oplot,xcaps,ycaps,color=255,thick=2.3
                oplot,xpts-5,Vypts,color=100,thick=2.3
                ;oplot,x2ds,y2ds,color=255
                xyouts,210,210,'Red Caps',color=255,/device
                xyouts,210,185,'Blck 2ds.H',color=0,/device
                xyouts,210,160,'Grey 2ds.V',color=100,/device
                for i=0,29 do begin
                    Stime=startseconds+i
                    Etime=Stime+1
                    get_2ds_time1totime2_TMS_mean_psd,Stime,Etime,TDsdata,$
                        time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts
                    oplot,xpts-5,Hypts,color=0
                endfor

                ;label the times
                Secs_To_Times,startseconds,Stime ; Stime is string
                Secs_To_Times,endseconds,Etime
                xyouts,125,265,Stime+' to '+Etime,color=0,/device
                str1=strjoin(strsplit(Stime,':',/extract))
                str2=strjoin(strsplit(Etime,':',/extract))
                outfilename=pathnm+'Caps_2ds_'+str1+'_'+str2+'_psd_Overlay.png'
                write_png, outfilename,tvrd(true=1)
            endif 
            if (startseconds gt 59109 and endseconds le 60309 ) or $
                (startseconds gt 65949 and endseconds le 67398 ) or $
                (startseconds gt 67929 and endseconds le 69549 ) or $
                (startseconds gt 61209 and endseconds le 61689 )  then begin
                wait_time=0.1
            endif else wait_time=2

            wait,wait_time

            ;if startseconds  eq 58929LL then stop
        endif; end of if there is data; has_caps=1 or has_2ds=1

        startseconds=endseconds
        endseconds=startseconds+30LL
        if endseconds gt max_seconds_of_the_2files then done=1
        done=1
    endwhile

    print,'Done comparing caps and 2ds !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of plot_2ds_1Hz_mean_psd
;*************************************************
pro read_in_2ds_data_from_1Hz_archive,TDsData,pathnm
    filename=dialog_pickfile(filter='TD*.WB57',get_path=pathnm)
    ;find out how many line is in the file.
    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-91)/8
    junk=strarr(91)
    openr,2,filename
    readf,2,junk
    Data={seconds:0LL,$
        Hconc:0.0,Hextn:0.0,HIWC:0.0,Hmnsz:0.0,Hsv:0.0,Vconc:0.0,Vextn:0.0,VIWC:0.0,Vmnsz:0.0,Vsv:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Vbin1:0.0,Vbin2:0.0,Vbin3:0.0,Vbin4:0.0,Vbin5:0.0,Vbin6:0.0,Vbin7:0.0,Vbin8:0.0,$
        Vbin9:0.0,Vbin10:0.0,Vbin11:0.0,Vbin12:0.0,Vbin13:0.0,Vbin14:0.0,Vbin15:0.0,Vbin16:0.0,$
        Vbin17:0.0,Vbin18:0.0,Vbin19:0.0,Vbin20:0.0,Vbin21:0.0,Vbin22:0.0,Vbin23:0.0,Vbin24:0.0 $
        }
    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2
end; end of read_in_2ds_data_from_1Hz_archive.

pro Get_2ds_time1totime2_TMS_mean_psd,startseconds,endseconds,TDsdata,$
    time,Hconc,Hextn,Hiwc,Hmnsz,Hsv,Vconc,Vextn,VIWC,Vmnsz,Vsv,xpts,Hypts,Vypts

nseconds=(endseconds-startseconds)

hypts=fltarr(24)
vypts=fltarr(24)
;bins edges and widths
nbins=24
nedges=2*nbins
xpts=dblarr(2*nbins)
ptr = 0
for i =0, 8  DO BEGIN
    xpts[ptr] = double((i+1)*10)
    xpts[ptr + 1] = double((i+2) * 10)
    ptr += 2
endfor
xpts[18:47]=[10,12,12,15,15,20,20,25,25,32,32,40,40,50,50,60,60,70,70,80,80,90,90,100,100,120,120,140,140,1001]*10
widths=xpts(1:47)-xpts(0:46)
indexw=where(widths ne 0.0)
widths=widths(indexw)*0+1.0


;original data.
seconds=Tdsdata.seconds
index=where(seconds ge startseconds and seconds lt endseconds,contG)
if contG gt 0 then begin
    time=seconds(index)
    Hconc=TDsData(index).Hconc
    Hextn=TDsdata(index).Hextn
    HIWC =TDsdata(index).Hiwc
    Hmnsz=TDsdata(index).Hmnsz
    Hsv  =TDsdata(index).Hsv;    sample volumes of each second.
    Vconc=TDsData(index).Vconc
    Vextn=TDsdata(index).Vextn
    VIWC =TDsdata(index).Viwc
    Vmnsz=TDsdata(index).Vmnsz
    Vsv  =TDsdata(index).Vsv;    sample volumes of each second.

    indexgt0=where(Hconc gt 0.0, contG)
    if contG gt 0 then  svH=total(Hsv(indexgt0)) else svH=total(Hsv)
    indexgt0=where(Vconc gt 0.0, contG)
    if contG gt 0 then  svV=total(Vsv(indexgt0)) else svV=total(Vsv)

    ; note that TDSdata.Bin is #/L/um

    Hypts(0)=total(Hsv*TDsdata(index).Hbin1)/svH
    Hypts(1)=total(Hsv*TDsdata(index).Hbin2)/svH
    Hypts(2)=total(Hsv*TDsdata(index).Hbin3)/svH
    Hypts(3)=total(Hsv*TDsdata(index).Hbin4)/svH
    Hypts(4)=total(Hsv*TDsdata(index).Hbin5)/svH
    Hypts(5)=total(Hsv*TDsdata(index).Hbin6)/svH
    Hypts(6)=total(Hsv*TDsdata(index).Hbin7)/svH
    Hypts(7)=total(Hsv*TDsdata(index).Hbin8)/svH
    Hypts(8)=total(Hsv*TDsdata(index).Hbin9)/svH
    Hypts(9)=total(Hsv*TDsdata(index).Hbin10)/svH
    Hypts(10)=total(Hsv*TDsdata(index).Hbin11)/svH
    Hypts(11)=total(Hsv*TDsdata(index).Hbin12)/svH
    Hypts(12)=total(Hsv*TDsdata(index).Hbin13)/svH
    Hypts(13)=total(Hsv*TDsdata(index).Hbin14)/svH
    Hypts(14)=total(Hsv*TDsdata(index).Hbin15)/svH
    Hypts(15)=total(Hsv*TDsdata(index).Hbin16)/svH
    Hypts(16)=total(Hsv*TDsdata(index).Hbin17)/svH
    Hypts(17)=total(Hsv*TDsdata(index).Hbin18)/svH
    Hypts(18)=total(Hsv*TDsdata(index).Hbin19)/svH
    Hypts(19)=total(Hsv*TDsdata(index).Hbin21)/svH
    Hypts(20)=total(Hsv*TDsdata(index).Hbin20)/svH
    Hypts(21)=total(Hsv*TDsdata(index).Hbin22)/svH
    Hypts(22)=total(Hsv*TDsdata(index).Hbin23)/svH
    Hypts(23)=total(Hsv*TDsdata(index).Hbin24)/svH
    Vypts(0)=total(Vsv*TDsdata(index).Vbin1)/svV
    Vypts(1)=total(Vsv*TDsdata(index).Vbin2)/svV
    Vypts(2)=total(Vsv*TDsdata(index).Vbin3)/svV
    Vypts(3)=total(Vsv*TDsdata(index).Vbin4)/svV
    Vypts(4)=total(Vsv*TDsdata(index).Vbin5)/svV
    Vypts(5)=total(Vsv*TDsdata(index).Vbin6)/svV
    Vypts(6)=total(Vsv*TDsdata(index).Vbin7)/svV
    Vypts(7)=total(Vsv*TDsdata(index).Vbin8)/svV
    Vypts(8)=total(Vsv*TDsdata(index).Vbin9)/svV
    Vypts(9)=total(Vsv*TDsdata(index).Vbin10)/svV
    Vypts(10)=total(Vsv*TDsdata(index).Vbin11)/svV
    Vypts(11)=total(Vsv*TDsdata(index).Vbin12)/svV
    Vypts(12)=total(Vsv*TDsdata(index).Vbin13)/svV
    Vypts(13)=total(Vsv*TDsdata(index).Vbin14)/svV
    Vypts(14)=total(Vsv*TDsdata(index).Vbin15)/svV
    Vypts(15)=total(Vsv*TDsdata(index).Vbin16)/svV
    Vypts(16)=total(Vsv*TDsdata(index).Vbin17)/svV
    Vypts(17)=total(Vsv*TDsdata(index).Vbin18)/svV
    Vypts(18)=total(Vsv*TDsdata(index).Vbin19)/svV
    Vypts(19)=total(Vsv*TDsdata(index).Vbin20)/svV
    Vypts(20)=total(Vsv*TDsdata(index).Vbin21)/svV
    Vypts(21)=total(Vsv*TDsdata(index).Vbin22)/svV
    Vypts(22)=total(Vsv*TDsdata(index).Vbin23)/svV
    Vypts(23)=total(Vsv*TDsdata(index).Vbin24)/svV
endif else begin
    time=0
    ;Hypts=0.0
    ;Vypts=0.0; all other values are zero.
    rrr=dialog_message(' No 2DS data from this time period', /information)
endelse

;make Hypts and Vypts into horizontal and verticals.
hyptsn=fltarr(48)
vyptsn=fltarr(48)
for i=0,23 do begin
    hyptsn(2*i:2*i+1)=hypts(i)
    vyptsn(2*i:2*i+1)=vypts(i)
endfor
hypts=hyptsn
vypts=vyptsn

end; end of get_2ds_time1totime2_total_psd_from_1Hz_archive,filename,time1,time2,xpts,ypts
;*********************************************************************

pro get_2dsview_psd_cmp_psd,x2ds,y2ds
    ;read 2ds psd data file
    filter_str='PSD_CMP*.txt'
    filename2=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a 2ds psd PSD_CMP*.txt file')

    combined_string='xbin_edges'
    find_string_pos,filename2,combined_string,pos; get the first header line position.
    ;read in the 2ds binedges and bin heights data
    records_c=400
    data=read_ascii(filename2,data_start=pos,Num_records=records_c)
    data=data.field1
    x2ds=data[0,0:records_c-1]
    y2ds=data[3,0:records_c-1]
end
;***************************************************

pro find_string_pos,filename,search_string,pos
    ;search_string='PDs =';'WYSIWYG:'
    ;filename='abcdefg.ascii'
    ; Note: the input search_tsring can be someting like this: 'abcd egfhj hhhh'
    result=read_ascii(filename,count=n_lines);   ;find out how many lines in the file.

    for i=2,n_lines-1 do begin
        result=read_ascii(filename,data_start=i-1,header=readed_line,num_records=1)
        ;skip i-1 lines, read in readed_line as header, and read 1 records.
        aa=readed_line(*,0)
        nn=n_elements(aa)
        last_line=readed_line(nn-1,*)
        last_line=strtrim(last_line,2);   ; take teh leading and tailing balnks away.

        ;print,readed_line; ;print,'aaaaaaaaaaaaa';;print,last_line;print,'*************'

        find = STRCMP(last_line, search_String, strlen(search_string), /FOLD_CASE)
        if (find eq 1) then begin
            pos=i-1
            break;   ;breakout of the for loop.
        endif else begin
            pos=0
        endelse
    endfor

    if pos eq 0 then begin
        print, 'Data line with ',search_string,' not found in file: ',filename
        ;stop
    endif;  print, pos
end; ;end of function find_string_pos.

;***********************************************************
;reading in CAPS data
pro read_caps_data,pathnm,caps_data,xcaps,caps_binwidths
    ;read CAPS data file
    filter_str='MS*.WB57'
    if n_elements(pathnm) eq 1 then begin
        filename3=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a Caps psd MS*.WB57 file')
    endif else begin
        filename3=dialog_pickfile(filter=filter_str,get_path=pathnm,title='Pick a Caps psd MS*.WB57 file')
    endelse
    data=read_ascii(filename3,count=n_lines)
    nnnseconds=(n_lines-56)/5
    junk=strarr(56)

    ;first get the bin edges and binwidths
    ;now reading in the xcaps values.
    combined_string='ice Water Content'
    find_string_pos,filename3,combined_string,pos; get the first header line position.
    data=read_ascii(filename3,header=headlines,data_start=pos,Num_records=1)
    ;there are 29 lines for bin_edges.
    xcaps=fltarr(58);  bin-edges
    widcaps=fltarr(29)
    for i=0,28 do begin
        n=(pos-30)+i
        line_N=headlines(n)
        substr1=strsplit(line_n,'(',/extract)
        substr2=strsplit(substr1(1),'um',/extract)
        substr3=strsplit(substr2(0),'-',/extract)
        xcaps(2*i)=substr3(0)*1.0
        xcaps(2*i+1)=substr3(1)*1.0
        widcaps(i)=substr3(1)*1.0-substr3(0)*1.0
    endfor
    caps_binwidths=widcaps

    ;now get the datas psd and time.
    openr,2,filename3
    readf,2,junk
    Data={seconds:0LL,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,$
        iwc:0.0,area:0.0,extn:0.0,medVD:0.0 $
        }
    CAPs_Data=replicate(data,nnnseconds)
    readf,2,Caps_Data
    close,2
end; read_caps_data
;*******************************************************************

pro get_mean_psd_of_caps,startseconds,endseconds,Caps_data,caps_binwidths,xcaps,ycaps

    ;original data.
    seconds=caps_data.seconds
    index=where(seconds ge startseconds and seconds lt endseconds,contG)

    nnn=n_elements(index)
    ycaps=fltarr(29)
    time=lon64arr(nnn)
    caps_iwc=fltarr(nnn)
    caps_extn=fltarr(nnn)
    caps_area=fltarr(nnn)
    caps_medVD=fltarr(nnn)

    if contG gt 0 then begin
        time=seconds(index)
        Caps_iwc=Caps_data(index).iwc
        caps_extn=Caps_data(index).extn
        caps_area =Caps_data(index).area
        Caps_medVD=Caps_data(index).medVD

        ycaps(0)=mean(Caps_data(index).Hbin1)
        ycaps(1)=mean(Caps_data(index).Hbin2) 
        ycaps(2)=mean(Caps_data(index).Hbin3) 
        ycaps(3)=mean(Caps_data(index).Hbin4) 
        ycaps(4)=mean(Caps_data(index).Hbin5) 
        ycaps(5)=mean(Caps_data(index).Hbin6) 
        ycaps(6)=mean(Caps_data(index).Hbin7) 
        ycaps(7)=mean(Caps_data(index).Hbin8) 
        ycaps(8)=mean(Caps_data(index).Hbin9) 
        ycaps(9)=mean(Caps_data(index).Hbin10)
        ycaps(10)=mean(Caps_data(index).Hbin11)
        ycaps(11)=mean(Caps_data(index).Hbin12)
        ycaps(12)=mean(Caps_data(index).Hbin13)
        ycaps(13)=mean(Caps_data(index).Hbin14)
        ycaps(14)=mean(Caps_data(index).Hbin15)
        ycaps(15)=mean(Caps_data(index).Hbin16)
        ycaps(16)=mean(Caps_data(index).Hbin17)
        ycaps(17)=mean(Caps_data(index).Hbin18)
        ycaps(18)=mean(Caps_data(index).Hbin19)
        ycaps(19)=mean(Caps_data(index).Hbin21)
        ycaps(20)=mean(Caps_data(index).Hbin20)
        ycaps(21)=mean(Caps_data(index).Hbin22)
        ycaps(22)=mean(Caps_data(index).Hbin23)
        ycaps(23)=mean(Caps_data(index).Hbin24)
        ycaps(24)=mean(Caps_data(index).Hbin25)
        ycaps(25)=mean(Caps_data(index).Hbin26)
        ycaps(26)=mean(Caps_data(index).Hbin27)
        ycaps(27)=mean(Caps_data(index).Hbin28)
        ycaps(28)=mean(Caps_data(index).Hbin29)
    endif else begin
        rrr=dialog_message('No caps data in this time interval',/information)
    endelse
    ycaps=ycaps/caps_binwidths
    ;make the ycaps to be double edgesvalues
    ycapsn=fltarr(58)
    for i=0,28 do begin
        ycapsn(2*i:2*i+1)=ycaps(i)
    endfor
    ycaps=ycapsn
end; get_mean_psd_of_caps,starttime,endtime,Caps_data,widcaps,xcaps,ycaps
;*****************************************************************************
pro Secs_To_Times,secs,time

    temp=floor( long(secs)/(24l*3600l) )
    temp=long(secs)-temp*(24l*3600l)
    tempHH=floor( temp/3600l )
    temp=temp-tempHH*3600L
    tempMM=floor( temp/60l )
    tempSS=temp-tempMM*60L
    time=strtrim(long(tempHH),2)+':'+strtrim(long(tempMM),2)+':'+strtrim(long(tempSS),2)
end;******************

;**************************************************************************
pro get_CPI_psd_from_selected_file,xcpi,ycpi
    ;this subrountine get the cpi psd for the file only.

    filter_str='*psd*.txt'
    CPIfile=dialog_pickfile(filter=filter_str,get_path=pathnm,title='Pick a CPI psd *.txt file')
    filename1=CPIfile

    ;combined_string='CPI bin edges      CPI bin heights'
    combined_string="bin_edges #/Liter/um"
    find_string_pos,filename1,combined_string,pos; get the first header line position.
    data=read_ascii(filename1,data_start=pos, NUM_records=1) ;skip pos+1 line and reads in 1 line of data
    ;nline_comb=data.field1  ; convert data structure in to a vector result only one elements
    ;records_c=round(nline_comb(0))
    ;read in the fssp binedges and bin heights data
    ;data=read_ascii(filename1,data_start=pos+2,Num_records=records_c)
    records_c=8
    data=read_ascii(filename1,data_start=pos,Num_records=8)
    data=data.field1
    xcpi=data[0,0:records_c-1]
    ycpi=data[1,0:records_c-1]
    ;stop
end; get_CPI_psd_from_selected_file,xcpi,ycpi
;***************************************************************************

pro read_CPI_data,pathnm,CPI_data,xcpi,cpi_binwidths
    ;read CPI data file
    filter_str='*archive_with_TAS.txt'
    filename3=dialog_pickfile(filter=filter_str,path=pathnm,title='Pick a CPI archive_with_TAS.txt file')
    data=read_ascii(filename3,count=n_lines)
    ; nnnseconds=(n_lines-56)/5;   56 is the number of header lines.
    ;junk=strarr(56)
    nnnseconds=(n_lines-0)/10

    ;first get the bin edges and binwidths
    ;now reading in the xcaps values.
    cpi_edges=[0, 6, 12, 16, 20, 24,28, 32, 36, 40, 46, 52, 58, 66, 74, 82, 90, 100,$
        120, 140, 160, 180, 200, 240, 280, 320, 360, 400, 500, 600, 700, 800, 1000,1500]
    nnn=n_elements(cpi_edges)
    cpi_binwidths=cpi_edges(1:nnn-1)-cpi_edges(0:nnn-2)

    ;make cpi bin-edges are double values
    xcpi=fltarr(2*(nnn-1))
    xcpi(0)=cpi_edges(0)
    for i=1,nnn-2 do begin
        xcpi(2*i-1:2*i)=cpi_edges(i)
    endfor
    xcpi(65)=cpi_edges(nnn-1)

    ;now get the datas psd and time.
    openr,2,filename3
    ;readf,2,junk
    Data={seconds:0LL,$
        dt:30.0,N1:1,conc1:0.0,extn1:0.0,iwc1:0.0,N2:1,conc2:0.0,extn2:0.0,iwc2:0.0,tas:0.0,$
        sphn1:0.0,coln1:0.0,pltn1:0.0,rosn1:0.0,budn1:0.0,sirn1:0.0,birn1:0.0,$
        spha1:0.0,cola1:0.0,plta1:0.0,rosa1:0.0,buda1:0.0,sira1:0.0,bira1:0.0,$
        sphm1:0.0,colm1:0.0,pltm1:0.0,rosm1:0.0,budm1:0.0,sirm1:0.0,birm1:0.0,$
        sphn2:0.0,coln2:0.0,pltn2:0.0,rosn2:0.0,budn2:0.0,sirn2:0.0,birn2:0.0,$
        spha2:0.0,cola2:0.0,plta2:0.0,rosa2:0.0,buda2:0.0,sira2:0.0,bira2:0.0,$
        sphm2:0.0,colm2:0.0,pltm2:0.0,rosm2:0.0,budm2:0.0,sirm2:0.0,birm2:0.0,$
        Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
        Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
        Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
        Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
        Hbin33:0.0 $
        }
    CPI_Data=replicate(data,nnnseconds)
    readf,2,CPI_Data
    close,2


end;read_CPI_data,pathnm,CPI_data,xcpi,cpi_binwidths
;****************************************************************************
pro get_mean_psd_of_cpi,startseconds,endseconds,CPI_data,cpi_binwidths,xcpi,ycpi,cpi_Tas

    ;original data.
    seconds=cpi_data.seconds
    index=where(seconds ge startseconds and seconds lt endseconds,contG)

    nnn=n_elements(index)
    ycpi=fltarr(33)
    time=lon64arr(nnn)
    ;cpi_iwc=fltarr(nnn)
    ;cpi_extn=fltarr(nnn)
    ;cpi_area=fltarr(nnn)
    ;cpi_medVD=fltarr(nnn)

    if contG gt 0 then begin
        time=seconds(index)
        cpi_iwc=mean(cpi_data(index).iwc1)
        cpi_extn=mean(cpi_data(index).extn1)
        ; cpi_area =cpi_data(index).area
        ; cpi_medVD=cpi_data(index).medVD
        cpi_tas  =mean(cpi_data(index).tas)

        ycpi(0)=mean(cpi_data(index).Hbin1)
        ycpi(1)=mean(cpi_data(index).Hbin2) 
        ycpi(2)=mean(cpi_data(index).Hbin3) 
        ycpi(3)=mean(cpi_data(index).Hbin4) 
        ycpi(4)=mean(cpi_data(index).Hbin5) 
        ycpi(5)=mean(cpi_data(index).Hbin6) 
        ycpi(6)=mean(cpi_data(index).Hbin7) 
        ycpi(7)=mean(cpi_data(index).Hbin8) 
        ycpi(8)=mean(cpi_data(index).Hbin9) 
        ycpi(9)=mean(cpi_data(index).Hbin10)
        ycpi(10)=mean(cpi_data(index).Hbin11)
        ycpi(11)=mean(cpi_data(index).Hbin12)
        ycpi(12)=mean(cpi_data(index).Hbin13)
        ycpi(13)=mean(cpi_data(index).Hbin14)
        ycpi(14)=mean(cpi_data(index).Hbin15)
        ycpi(15)=mean(cpi_data(index).Hbin16)
        ycpi(16)=mean(cpi_data(index).Hbin17)
        ycpi(17)=mean(cpi_data(index).Hbin18)
        ycpi(18)=mean(cpi_data(index).Hbin19)
        ycpi(19)=mean(cpi_data(index).Hbin21)
        ycpi(20)=mean(cpi_data(index).Hbin20)
        ycpi(21)=mean(cpi_data(index).Hbin22)
        ycpi(22)=mean(cpi_data(index).Hbin23)
        ycpi(23)=mean(cpi_data(index).Hbin24)
        ycpi(24)=mean(cpi_data(index).Hbin25)
        ycpi(25)=mean(cpi_data(index).Hbin26)
        ycpi(26)=mean(cpi_data(index).Hbin27)
        ycpi(27)=mean(cpi_data(index).Hbin28)
        ycpi(28)=mean(cpi_data(index).Hbin29)
        ycpi(29)=mean(cpi_data(index).Hbin30)
        ycpi(30)=mean(cpi_data(index).Hbin31)
        ycpi(31)=mean(cpi_data(index).Hbin32)
        ycpi(32)=mean(cpi_data(index).Hbin33)
    endif else begin
        rrr=dialog_message('No CPI data in this time interval',/information)
        cpi_tas=0.0
        cpi_iwc=0.0
        cpi_extn=0.0
    endelse
    ycpi=ycpi
    ;make the ycaps to be double edgesvalues
    ycpin=fltarr(66)
    for i=0,32 do begin
        ycpin(2*i:2*i+1)=ycpi(i)
    endfor
    ycpi=ycpin
end; get_mean_psd_of_cpi,starttime,endtime,Caps_data,widcaps,xcaps,ycaps
;*****************************************************************************

;###########################################################################
;usage:

;  WSet, wid
;  bluecolor = Mo_GetColor("Navy", !D.Table_Size-2)
;  whitecolor= Mo_GetColor("White", !D.Table_Size-2)

;  erase,color='ffffff'x  ; get background to white

;###########################################################################

FUNCTION Mo_GETCOLOR, thisColor, index, TRUE=truecolor, $
    NAMES=colornames, LOAD=load, START=start, INDEXED=indexedcolor

Catch, theError
IF theError NE 0 THEN BEGIN
    Catch, /Cancel
    ok = Error_Message(Traceback=1)
    RETURN, 0
ENDIF
; Set up the color vectors.

names =  ['White']
rvalue = [ 255]
gvalue = [ 255]
bvalue = [ 255]
names  = [ names,        'Snow',     'Ivory','Light Yellow',   'Cornsilk',      'Beige',   'Seashell' ]
rvalue = [ rvalue,          255,          255,          255,          255,          245,          255 ]
gvalue = [ gvalue,          250,          255,          255,          248,          245,          245 ]
bvalue = [ bvalue,          250,          240,          224,          220,          220,          238 ]
names  = [ names,       'Linen','Antique White',    'Papaya',     'Almond',     'Bisque',  'Moccasin' ]
rvalue = [ rvalue,          250,          250,          255,          255,          255,          255 ]
gvalue = [ gvalue,          240,          235,          239,          235,          228,          228 ]
bvalue = [ bvalue,          230,          215,          213,          205,          196,          181 ]
names  = [ names,       'Wheat',  'Burlywood',        'Tan', 'Light Gray',   'Lavender','Medium Gray' ]
rvalue = [ rvalue,          245,          222,          210,          230,          230,          210 ]
gvalue = [ gvalue,          222,          184,          180,          230,          230,          210 ]
bvalue = [ bvalue,          179,          135,          140,          230,          250,          210 ]
names  = [ names,        'Gray', 'Slate Gray',  'Dark Gray',   'Charcoal',      'Black', 'Light Cyan' ]
rvalue = [ rvalue,          190,          112,          110,           70,            0,          224 ]
gvalue = [ gvalue,          190,          128,          110,           70,            0,          255 ]
bvalue = [ bvalue,          190,          144,          110,           70,            0,          255 ]
names  = [ names, 'Powder Blue',   'Sky Blue', 'Steel Blue','Dodger Blue', 'Royal Blue',       'Blue' ]
rvalue = [ rvalue,          176,          135,           70,           30,           65,            0 ]
gvalue = [ gvalue,          224,          206,          130,          144,          105,            0 ]
bvalue = [ bvalue,          230,          235,          180,          255,          225,          255 ]
names  = [ names,        'Navy',   'Honeydew', 'Pale Green','Aquamarine','Spring Green',       'Cyan' ]
rvalue = [ rvalue,            0,          240,          152,          127,            0,            0 ]
gvalue = [ gvalue,            0,          255,          251,          255,          250,          255 ]
bvalue = [ bvalue,          128,          240,          152,          212,          154,          255 ]
names  = [ names,   'Turquoise', 'Sea Green','Forest Green','Green Yellow','Chartreuse', 'Lawn Green' ]
rvalue = [ rvalue,           64,           46,           34,          173,          127,          124 ]
gvalue = [ gvalue,          224,          139,          139,          255,          255,          252 ]
bvalue = [ bvalue,          208,           87,           34,           47,            0,            0 ]
names  = [ names,       'Green', 'Lime Green', 'Olive Drab',     'Olive','Dark Green','Pale Goldenrod']
rvalue = [ rvalue,            0,           50,          107,           85,            0,          238 ]
gvalue = [ gvalue,          255,          205,          142,          107,          100,          232 ]
bvalue = [ bvalue,            0,           50,           35,           47,            0,          170 ]
names  = [ names,       'Khaki', 'Dark Khaki',     'Yellow',       'Gold','Goldenrod','Dark Goldenrod']
rvalue = [ rvalue,          240,          189,          255,          255,          218,          184 ]
gvalue = [ gvalue,          230,          183,          255,          215,          165,          134 ]
bvalue = [ bvalue,          140,          107,            0,            0,           32,           11 ]
names  = [ names,'Saddle Brown',       'Rose',       'Pink', 'Rosy Brown','Sandy Brown',       'Peru' ]
rvalue = [ rvalue,          139,          255,          255,          188,          244,          205 ]
gvalue = [ gvalue,           69,          228,          192,          143,          164,          133 ]
bvalue = [ bvalue,           19,          225,          203,          143,           96,           63 ]
names  = [ names,  'Indian Red',  'Chocolate',     'Sienna','Dark Salmon',    'Salmon','Light Salmon' ]
rvalue = [ rvalue,          205,          210,          160,          233,          250,          255 ]
gvalue = [ gvalue,           92,          105,           82,          150,          128,          160 ]
bvalue = [ bvalue,           92,           30,           45,          122,          114,          122 ]
names  = [ names,      'Orange',      'Coral', 'Light Coral',  'Firebrick',      'Brown',  'Hot Pink' ]
rvalue = [ rvalue,          255,          255,          240,          178,          165,          255 ]
gvalue = [ gvalue,          165,          127,          128,           34,           42,          105 ]
bvalue = [ bvalue,            0,           80,          128,           34,           42,          180 ]
names  = [ names,   'Deep Pink',    'Magenta',     'Tomato', 'Orange Red',        'Red', 'Violet Red' ]
rvalue = [ rvalue,          255,          255,          255,          255,          255,          208 ]
gvalue = [ gvalue,           20,            0,           99,           69,            0,           32 ]
bvalue = [ bvalue,          147,          255,           71,            0,            0,          144 ]
names  = [ names,      'Maroon',    'Thistle',       'Plum',     'Violet',    'Orchid','Medium Orchid']
rvalue = [ rvalue,          176,          216,          221,          238,          218,          186 ]
gvalue = [ gvalue,           48,          191,          160,          130,          112,           85 ]
bvalue = [ bvalue,           96,          216,          221,          238,          214,          211 ]
names  = [ names, 'Dark Orchid','Blue Violet',     'Purple' ]
rvalue = [ rvalue,          153,          138,          160 ]
gvalue = [ gvalue,           50,           43,           32 ]
bvalue = [ bvalue,          204,          226,          240 ]

; Did the user ask for a specific color? If not, return
; all the colors. If the user asked for a specific color,
; find out if a 24-bit value is required. Return to caller
; if an error occurs.

ON_Error, 2
ncolors = N_Elements(names)

np = N_Params()
IF N_Elements(start) EQ 0 THEN start = !D.TABLE_SIZE - ncolors - 1 ELSE start = start < (!D.TABLE_SIZE - ncolors - 1)

; User ask for the color names?

IF Keyword_Set(colornames) THEN RETURN, Reform(names, 1, N_Elements(names)) $
    ELSE names = StrUpCase(StrCompress(StrTrim(names,2), /Remove_All))

; If no positional parameter, return all colors.

IF np EQ 0 THEN BEGIN

    ; Did the user want a 24-bit value? If so, call COLOR24.

    IF Keyword_Set(trueColor) THEN BEGIN
        returnColor = LonArr(ncolors)
        FOR j=0,ncolors-1 DO returnColor[j] = Color24([rvalue[j], gvalue[j], bvalue[j]])

        ; If LOAD keyword set, return a color structure.

        IF Keyword_Set(load) THEN BEGIN
            returnValue = Create_Struct('white', returnColor[0])
            FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], returnColor[j])
            returnColor = returnValue
        ENDIF

        RETURN, returnColor
    ENDIF

    ; If color decomposition is ON and INDEXED is not set, return 24-bit values.

    IF Float(!Version.Release) GE 5.2 THEN BEGIN
        IF (!D.Name EQ 'X' OR !D.Name EQ 'WIN' OR !D.Name EQ 'MAC') THEN BEGIN
            Device, Get_Decomposed=decomposedState
        ENDIF ELSE decomposedState = 0
        IF Keyword_Set(indexedcolor) THEN decomposedState = 0
        IF decomposedState EQ 1 THEN BEGIN
            returnColor = LonArr(ncolors)
            FOR j=0,ncolors-1 DO returnColor[j] = Color24([rvalue[j], gvalue[j], bvalue[j]])
            IF Keyword_Set(load) THEN BEGIN
                returnValue = Create_Struct('white', returnColor[0])
                FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], returnColor[j])
                RETURN, returnValue
            ENDIF
            RETURN, returnColor
        ENDIF

        IF Keyword_Set(load) THEN BEGIN
            IF !D.NAME NE 'PRINTER' THEN BEGIN
                TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
            ENDIF ELSE BEGIN
                Set_Plot, 'Z', /Copy
                TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
                Set_Plot, 'PRINTER', /Copy
            ENDELSE
            returnValue = Create_Struct('white', start)
            FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], start+j)
            RETURN, returnValue
        ENDIF

        returnColor = REFORM([rvalue, gvalue, bvalue], ncolors, 3)
        RETURN, returnColor

    ENDIF

    IF Keyword_Set(load) THEN BEGIN
        IF !D.NAME NE 'PRINTER' THEN BEGIN
            TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
        ENDIF ELSE BEGIN
            Set_Plot, 'Z', /Copy
            TVLCT, Reform([rvalue, gvalue, bvalue], ncolors, 3), start
            Set_Plot, 'PRINTER', /Copy
        ENDELSE
        returnValue = Create_Struct('white', start)
        FOR j=1,ncolors-1 DO returnValue = Create_Struct(returnValue, names[j], start+j)
        RETURN, returnValue
    ENDIF

    returnColor = REFORM([rvalue, gvalue, bvalue], ncolors, 3)
    RETURN, returnColor

ENDIF

; Make sure the color parameter is an uppercase string.

varInfo = SIZE(thisColor)
IF varInfo(varInfo(0) + 1) NE 7 THEN $
    MESSAGE, 'The color name must be a string.'
thisColor = StrUpCase(StrCompress(StrTrim(thisColor,2), /Remove_All))

; Check synonyms of colors.

IF StrUpCase(thisColor) EQ 'GREY' THEN thisColor = 'GRAY'
IF StrUpCase(thisColor) EQ 'AQUA' THEN thisColor = 'AQUAMARINE'
IF StrUpCase(thisColor) EQ 'SKYBLUE' THEN thisColor = 'SKY'
IF StrUpCase(thisColor) EQ 'LIGHTGREY' THEN theColor = 'LIGHTGRAY'
IF StrUpCase(thisColor) EQ 'MEDIUMGREY' THEN theColor = 'MEDIUMGRAY'
IF StrUpCase(thisColor) EQ 'SLATEGREY' THEN theColor = 'SLATEGRAY'
IF StrUpCase(thisColor) EQ 'DARKGREY' THEN theColor = 'DARKGRAY'
IF StrUpCase(thisColor) EQ 'SKY' THEN theColor = 'SKYBLUE'
IF StrUpCase(thisColor) EQ 'NAVY BLUE' THEN theColor = 'NAVY'
IF StrUpCase(thisColor) EQ 'NAVYBLUE' THEN theColor = 'NAVY'


; Get the color triple for this color.

colorIndex = WHERE(names EQ thisColor)

; If you can't find it. Issue an informational message,
; set the index to a YELLOW color, and continue.

IF colorIndex(0) LT 0 THEN BEGIN
    MESSAGE, "Can't find color " + thisColor + ". Returning " + StrUpCase(names[0]) + ".", /INFORMATIONAL
    thisColor = names[0]
    colorIndex = 0
ENDIF

; Get the color triple.

r = rvalue(colorIndex)
g = gvalue(colorIndex)
b = bvalue(colorIndex)
returnColor = REFORM([r, g, b], 1, 3)

; Did the user want a 24-bit value? If so, call COLOR24.

IF KEYWORD_SET(trueColor) THEN BEGIN
    returnColor = COLOR24(returnColor)
    RETURN, returnColor[0]
ENDIF

; If color decomposition is ON and INDEXED is OFF,, return 24-bit value.

IF Float(!Version.Release) GE 5.2 THEN BEGIN

    IF (!D.Name EQ 'X' OR !D.Name EQ 'WIN' OR !D.Name EQ 'MAC') THEN BEGIN
        Device, Get_Decomposed=decomposedState
    ENDIF ELSE decomposedState = 0
    IF Keyword_Set(indexedcolor) THEN decomposedState = 0

    IF decomposedState EQ 1 THEN BEGIN

        ; Before you change return color, load index if requested.

        IF N_Elements(index) NE 0 THEN BEGIN
            index = 0 > index < (!D.Table_Size-1)
            IF !D.NAME NE 'PRINTER' THEN BEGIN
                TVLCT, returnColor, index
            ENDIF ELSE BEGIN
                Set_Plot, 'Z', /Copy
                TVLCT, returnColor, index
                Set_Plot, 'PRINTER', /Copy
            ENDELSE
        ENDIF

        returnColor = COLOR24(returnColor)
        RETURN, returnColor[0]
    ENDIF
ENDIF

; Did the user specify a color index? If so, load it.

IF N_Elements(index) NE 0 THEN BEGIN
    index = 0 > index < (!D.Table_Size-1)
    IF !D.NAME NE 'PRINTER' THEN BEGIN
        TVLCT, returnColor, index
    ENDIF ELSE BEGIN
        Set_Plot, 'Z', /Copy
        TVLCT, returnColor, index
        Set_Plot, 'PRINTER', /Copy
    ENDELSE
    returnColor = index
    RETURN, returnColor[0]
ENDIF

; Did the user specify INDEXED color? If so, load it.

IF Keyword_Set(indexedColor) THEN BEGIN
    IF !D.NAME NE 'PRINTER' THEN BEGIN
        TVLCT, returnColor, !P.Color
    ENDIF ELSE BEGIN
        Set_Plot, 'Z', /Copy
        TVLCT, returnColor, !P.Color
        Set_Plot, 'PRINTER', /Copy
    ENDELSE
    returnColor = !P.Color < (!D.Table_Size -1)
    RETURN, returnColor[0]
ENDIF

RETURN, returnColor
END

FUNCTION COLOR24, number

    ; This FUNCTION accepts a [red, green, blue] triple that
    ; describes a particular color and returns a 24-bit long
    ; integer that is equivalent to that color. The color is
    ; described in terms of a hexidecimal number (e.g., FF206A)
    ; where the left two digits represent the blue color, the
    ; middle two digits represent the green color, and the right
    ; two digits represent the red color.

    ; The triple can be either a row or column vector of 3 elements.

    ON_ERROR, 1

    IF N_ELEMENTS(number) NE 3 THEN $
        MESSAGE, 'Augument must be a three-element vector.'

    IF MAX(number) GT 255 OR MIN(number) LT 0 THEN $
        MESSAGE, 'Argument values must be in range of 0-255'

    base16 = [[1L, 16L], [256L, 4096L], [65536L, 1048576L]]

    num24bit = 0L

    FOR j=0,2 DO num24bit = num24bit + ((number(j) MOD 16) * base16(0,j)) + $
        (Fix(number(j)/16) * base16(1,j))

    RETURN, num24bit
END ; ************************  of COLOR24  ******************************
