;*********************************************************************
; Create the window where we're present the zoomed time series data
;*********************************************************************
pro CreateZoom, info, ave_info


    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,OneHzH,OneHzV,avestripdata,avestripdataV


    text_box_x = 20
    text_box_y = 20

    maxheight = 37
    mypad = 1
    myoffset = 1

    base = WIDGET_BASE(GROUP_LEADER=info.wid, row=10, Title = 'Zoomed Data',SPACE=1 ,XPAD=1 ,YPAD=1)
    info.ZoomWindowID = base  ; save the ID for later access
    base_mo=widget_base(base,column=2)
    ;************************************************************************************
    top_base=widget_base(base_mo,/row)
    ;start and Endtime base
    left_base= widget_base(top_base,/col,/frame)
    b311 = widget_base(left_base,/row)
    label1=widget_label(b311,value='Stime:',FONT = 'ARIAL*BOLD*14')
    ave_info.StartHoursID        = cw_field(b311,title='hh',value=0,/int,xsize=2,uvalue ='starthh',/all)
    ave_info.StartMinutesID      = cw_field(b311,title='mm',value=0,/int,xsize=2,uvalue ='startmm',/all)
    ave_info.StartSecondsID      = cw_field(b311,title='ss',value=0,/int,xsize=2,uvalue ='startss',/all)
    ave_info.StartMillisecondsID = cw_field(b311,title='ms',value=0,/int,xsize=3,uvalue ='startms',/all)
    ;sbutton=widget_button(b311,value='|',uvalue='ST0')

    b312 = widget_base(left_base,/row)
    label2=widget_label(b312,value='Etime:',FONT = 'ARIAL*BOLD*14')
    ave_info.EndHoursID         = cw_field(b312,title='hh',value=0,/int,xsize=2,uvalue ='etarthh',/all)
    ave_info.EndMinutesID       = cw_field(b312,title='mm',value=0,/int,xsize=2,uvalue ='etartmm',/all)
    ave_info.EndSecondsID       = cw_field(b312,title='ss',value=0,/int,xsize=2,uvalue ='etartss',/all)
    ave_info.EndMillisecondsID  = cw_field(b312,title='ms',value=0,/int,xsize=3,uvalue ='etartms',/all)
    ;*************************************************************************************

    ;************************************************************************************
    b34 = widget_base(base_mo,/col,/frame);, sensitive = (*pStateInfo).AUTOEXTRACT
    b340 = widget_base(b34,/row)
    basefilter=widget_base(b340,col=1,/nonexclusive)
    filterID =widget_button(basefilter,value= 'Filter',uvalue ='Filter',event_pro='Filter_event')
    ave_info.filterID=filterID
    widget_control,filterID,set_button=0
    label = widget_label(b340,value = 'Boolean:')
    b341 = widget_base(b340,/exclusive,/row)
    ave_info.criteria.offID = widget_button(b341,value='Off',Event_pro='Crits_Off_event')
    ave_info.criteria.onID = widget_button(b341,value='On')

    ave_info.criteria.baccept1ID = widget_base(b340,/row,sensitive = 0)

    ; Variables list for dropdown in Zoom window, these variables are allowed in the boolean selection string

    variables = ['L1n','L2','L3','L4','L5','L7','PC1','PC3x','PC3y','PC4x','PC4y',$
        'Area','A3','Alexei1','w8_t','roundness','F1','H','S','T','N','D',$
        'reject eq 1','reject eq 0','S eq 0', 'D eq 0','N eq 0','T eq 0',$
        'Roundness1','Roundness2','Roundness3', $
        'L1r', 'maxLength', 'maxWidth', 'perimeter', 'perimeterum', 'csp']

    ; TAF add CPI_Trigger here???

    pvariables=ptr_new(strarr(n_elements(variables)))
    *pvariables=variables
    ave_info.criteria.variables=pvariables
    label = widget_label(ave_info.criteria.baccept1ID, value='Param')
    ave_info.criteria.vDListID = widget_droplist(ave_info.criteria.baccept1ID,value=variables,Event_Pro='crits_droplist_event')
    ;********************************************
    operators=['and','or','not','eq','ne','ge','gt','le','lt','*','+','-','(',')']
    poperators=ptr_new(strarr(n_elements(operators)))
    *poperators=operators
    ave_info.criteria.operators=poperators
    label = widget_label(ave_info.criteria.baccept1ID, value='')
    ave_info.criteria.oDListID = widget_droplist(ave_info.criteria.baccept1ID,value=operators,Event_Pro='crits_odroplist_event')
    ;********************************************

    save = widget_button(ave_info.criteria.baccept1ID,value='Save',Event_Pro='save_crits_event')
    load = widget_button(ave_info.criteria.baccept1ID,value='Load',Event_Pro='load_crits_event')
    loadSpec = widget_button(ave_info.criteria.baccept1ID,value='LoadSpec',Event_Pro='load_Spec_crits_event')
    AppToAll = widget_button(ave_info.criteria.baccept1ID,value='Apply',Event_Pro='Apply_crits_to_All_event')
    widget_control,ave_info.criteria.offID,set_button = 1; 1 means !true
    ave_info.criteria.on=0

    ; baseadjsv=widget_base(b340,col=1,/nonexclusive)
    ; adj_sv=widget_button(baseadjsv,value='AdjSV',Event_pro='Adjust_sample_Volume_event')
    widget_control,filterID,set_button=0

    GeneralHelp=widget_button(b340,value='Help',Event_pro='General_help_event')

    ave_info.criteria.baccept2ID = widget_base(b34,/row,sensitive = 0)
    label = widget_label(ave_info.criteria.baccept2ID,value = 'If',ysize = 30)
    ave_info.criteria.criteriaID = widget_text(ave_info.criteria.baccept2ID,value='',/editable,/all,Event_pro='criteria_text_event',xsize = 90,/scroll)
    label =  widget_label(ave_info.criteria.baccept2ID,value='then Accept',ysize = 30)
    ;generate a structure to hold the status of the criteria button and values

    ;************************************************************************************
    ;---------------------------
    ; PLOT SETTINGS
    ;---------------------------


    prebase = Widget_base(base, col = 2,SPACE=mypad ,XPAD=0 ,YPAD=0) ; xsize was 704

    TopControlPanel = WIDGET_BASE(prebase, $
        ROW=12, $
        MAP=1, $
        FRAME=1, $
        YSIZE = 70, $  ; 60 for only 2 rows of buttons
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        XSIZE=715)
    RowZero = WIDGET_BASE(TopControlPanel, $
        COL=12, $ ; there are 12 columns buttons in this row.
        MAP=1, $
        SPACE=mypad ,XPAD=mypad ,YPAD=mypad, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        XSIZE=715)
    RowOne = WIDGET_BASE(TopControlPanel, $
        COL=13, $
        MAP=1, $
        UVALUE='BASE_Toolbar', $
        BASE_ALIGN_LEFT=1, $
        XSIZE=715)

    ;RowTwo = WIDGET_BASE(TopControlPanel, $
    ;      COL=3, $
    ;      MAP=1, $
    ;      UVALUE='BASE_Toolbar', $
    ;      BASE_ALIGN_LEFT=1, $
    ;      XSIZE=300)


    ;-------------------------------------------------------
    ; Make some dropdowns to the right of the chart settings
    ;  for testing out new routines.
    ; Dropdown text contents may be modified below.
    ; We keep track of the current settings of the dropdowns by
    ;  storing the index of the currently displayed value in
    ;  ave_info.DropdownFunction1/2/3 respectively.
    ;  This info is updated in the event for each of the dropdowns
    ;  whenever a value is changed. Then, the current settings can
    ;  be examined in the events for the Apply buttons associated with each of the dropdowns.

    ToolBar = Widget_Base( prebase, XOFFSET=0,YOFFSET=0,SCR_XSIZE=150 ,SCR_YSIZE=70 $; 60 allow two rows.
        ,FRAME=1 ,SPACE=0 ,XPAD=0 ,YPAD=0)

    ToolTop = widget_base(ToolBar,row=1)
    ToolTopRow1 = widget_base(ToolTop,Col=2)

    Drop1 = Widget_Droplist(ToolTopRow1,Value=['M1','M2','M3','M4','M5','M6','M7'],$
        Event_Pro='ZoomDrop1_event')
    Drop1_button = WIDGET_BUTTON( ToolTopRow1, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=70, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Update", $
        VALUE="Apply", $
        Event_Pro='ZoomChartDrop1_event')
    Widget_Control, Drop1, Set_UValue=info_info
    Widget_Control, Drop1_button, Set_UValue=ave_info


    wTLB = WIDGET_BASE(base, /COLUMN, /BASE_ALIGN_TOP)

    ;sept 23 added two more buttons for comparing TMS and PSD methods.
    ; cmpbase=WIDGET_base(wTLB, /row)
    ; cmpTMs=WIDGET_Button(cmpbase, value='Compare Time Series',event_pro="compare_tms_methods_event" )
    ; cmpPsd=WIDGET_button(cmpbase, value='Compare PSD plots',event_pro="compare_psd_methods_event")


    wTab = WIDGET_TAB(wTLB, LOCATION=location)

    wT1 = WIDGET_BASE(wTab, Title='Time Series Plots', /COLUMN)

    ZoomSeriesDisplay = Widget_Draw( wT1,XSize=850, YSize=480)


    wT2 = WIDGET_BASE(wTab, Title='Particle Size Dist.Plots', /COLUMN)

    ZoomDisplay = Widget_Draw( wT2,XSize=850, YSize=480)


    ;ZoomDisplay = Widget_Draw(base,XSize=850, YSize=600)
    info.ZoomWindowDrawID = ZoomDisplay  ; save the ID for later updates

    ;---------------------------
    ; Row Zero is the Settings label
    ;---------------------------


    ; tlabel = WIDGET_LABEL(RowZero,FONT = 'ARIEL*BOLD*14', $
    ;                                  VALUE="CS", $
    ;                                  XSIZE=20, $
    ;                                  YSIZE=14)
    ;use above button for stereo_strip
    Button_STereo=WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=20, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Showing zoomed Stereo Particle strip", $
        VALUE="ST", $
        Event_Pro='ZoomChartStereo_event')

    BUTTON_HK = WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=20, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Showing zoomed Housing Keeping Data", $
        VALUE="HK", $
        Event_Pro='ZoomChartHK_event')

    BUTTON_Update = WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=70, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Update zoomed time and Criteria", $
        VALUE="UPDATE", $
        Event_Pro='ZoomChartUpdate_event')

    drop2_base    =widget_base(RowZero,row=1)
    drop2_save    = widget_droplist(drop2_base,Value=['save_png','save_ascii','Print'],$
        Event_Pro='ZoomDrop2_event')


    ;************** add this on Dec 6, 2005  **************** for V H strip-bitmap *******
    BUTTON_TIMESHIFT   = WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=50, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="H_strip_bitmap_for_the_zoom", $
        VALUE="Hstrip", $
        Event_Pro='ZoomedHstrip_event')
    BUTTON_TIMESHIFT   = WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=50, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="V_strip_bitmap_for_the_zoom", $
        VALUE="Vstrip", $
        Event_Pro='ZoomedVstrip_event')
    ;**************************************************************************************

    BUTTON_TIMESHIFT   = WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=70, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Find out H and V Channel Time-lag", $
        VALUE="Timeshift", $
        Event_Pro='ZoomChartTimeshift_event')

    BUTTON_MOROUTINE   = WIDGET_BUTTON( RowZero, $
        FONT='9x15', $
        UVALUE='', $
        XSIZE=60, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Doing the Fishing Test", $
        VALUE="Fishing", $
        Event_Pro='ZoomChartMoRoutine_event')
    cmpTMs=WIDGET_Button(Rowzero, value='CompTMS',$
        TOOLTIP="Compare Different Method's Time Series", $
        event_pro="compare_tms_methods_event" )
    cmpPsd=WIDGET_button(Rowzero, value='CompPSD',$
        TOOLTIP="Compare Different Method's PSD", $
        event_pro="compare_psd_methods_event")
    ; above is going to be deleted and replaced by following.

    drop3_base    =widget_base(RowZero,row=1)
    drop3_cmp     = widget_droplist(drop3_base,Value=['compPSD','AreaPSD','xxxxPSD'],$
        Event_Pro='ZoomDrop3_event')

    ;---------------------------
    ; Row One has 11 columns and hold the
    ;   X,Y log check boxes
    ;   Labels for the X,Y min
    ;   Text boxes for the X,Y min
    ;---------------------------
    tlb_cb = Widget_Base(RowOne, row=1, Scr_XSize=107, /NonExclusive)
    ave_info.IDAveXLog = Widget_Button(tlb_cb, Value='XLog')
    ave_info.IDAveYLog = Widget_Button(tlb_cb, Value='YLog')
    Widget_Control, ave_info.IDAveXLog, Set_Button=1
    Widget_Control, ave_info.IDAveYLog, Set_Button=1

    ;tlb_tx = Widget_Base(TopControlPanel, Column=1, xsize = 150)
    templabel = WIDGET_LABEL(rowone, VALUE="Xmin",XSIZE=25, Scr_YSize = 25, ALIGN_CENTER = 1 ,YSIZE=14)
    IDAveXMin = Widget_TEXT(rowone, EDITABLE=1, frame=30,  Scr_XSize = 40,  ALIGN_CENTER = 1, Value='10')

    templabel = WIDGET_LABEL(rowone, VALUE="Xmax",XSIZE=29, Scr_YSize = 25, ALIGN_CENTER = 1, YSIZE=14)
    IDAveXMax = Widget_TEXT(rowone, EDITABLE=1, frame=30,  Scr_XSize = 40,  ALIGN_CENTER = 1, Value='1000')

    templabel = WIDGET_LABEL(rowone, VALUE="MinBinSize",XSIZE=55, Scr_YSize = 25, ALIGN_CENTER = 1 ,YSIZE=14)
    IDAveMinBinSize = Widget_TEXT(rowone, EDITABLE=1, frame=40,  Scr_XSize = 40, ALIGN_CENTER = 1,Value='10')

    templabel = WIDGET_LABEL(rowone, VALUE="Min#PerBin",XSIZE=55, Scr_YSize = 25, ALIGN_RIGHT = 1, YSIZE=14)
    IDAveMinCountPerBin = Widget_TEXT(rowone, EDITABLE=1, frame=40,  Scr_XSize = 40, ALIGN_CENTER = 1,Value='100')
    cleanID =widget_button(rowone,$
        FONT='9x15', $
        UVALUE='', $
        XSIZE=70, $
        YSIZE=20, $
        DYNAMIC_RESIZE=1, $
        TOOLTIP="Manually label the spurious Particles as bad", $
        value='De_spur',$
        Event_pro='Clean_spurious_event')


    ;tlb_hires = Widget_Base(RowOne,COLUMN=1)
    ;BUTTON_TEMP   = WIDGET_BUTTON( tlb_hires, $
    ;                            FONT='9x15', $
    ;                            UVALUE='', $
    ;                            XSIZE=70, $
    ;                            YSIZE=20, $
    ;                            DYNAMIC_RESIZE=1, $
    ;                            TOOLTIP="Temp Button", $
    ;                            VALUE="Hi-Res", $
    ;                            Event_Pro='ZoomChartHiRes_event')

    tlb = Widget_Base(RowOne,Title=' Radio Buttons', Row=1, Scr_XSize=300, /Exclusive)
    button1 = Widget_Button(tlb, Value='Lo-Res (1Hz)', Event_Pro='ZoomChartHiRes_event')
    button2 = Widget_Button(tlb, Value='Hi-Res')

    Widget_Control, button1, Set_Button=1


    ; Widget_Control, BUTTON_TEMP, Set_UValue=ave_info

    ave_info.IDAveXMin = IDAveXMin
    ave_info.IDAveXMax = IDAveXMax
    ave_info.IDAveMinBinSize = IDAveMinBinSize
    ave_info.IDAveMinCountPerBin = IDAveMinCountPerBin

    ave_info.ZoomWindowID = info.ZoomWindowID
    ave_info.ZoomWindowDrawID = info.ZoomWindowDrawID

    ave_info.ZoomWindowSeriesDrawID = ZoomSeriesDisplay  ; save the ID for later updates

    ;BASE_Status = WIDGET_BASE(base, $
    ;      COLUMN=3, $
    ;      FRAME=1, $
    ;      MAP=1, $
    ;      UVALUE='BASE_Status', $
    ;BASE_ALIGN_CENTER=1, $
    ;ALIGN_BOTTOM=1, $
    ;      YSIZE=20      )
    ; ave_info.statusID = WIDGET_LABEL(BASE_Status,VALUE="Status bar                         ")

    WIDGET_CONTROL, base, /REALIZE

    XMANAGER, 'CreateZoom', base, /JUST_REG
end

;*******************************************************************added by mo******************
;event subroutines for the Criteria
;*******************************************************
pro crits_off_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;***********************************************************
    if ave_info.criteria.on eq 0 then ave_info.criteria.on=1 else ave_info.criteria.on=0
    if ave_info.criteria.on eq 1 then begin
        widget_control, ave_info.criteria.baccept1ID, sensitive =1
        widget_control, ave_info.criteria.baccept2ID, sensitive =1
    endif else begin
        widget_control, ave_info.criteria.baccept1ID, sensitive =0
        widget_control, ave_info.criteria.baccept2ID, sensitive =0
    endelse
    ;***********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;*******************************************************
pro Filter_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    ;***********************************************************
    if ave_info.Filter eq 0 then begin
        ave_info.filter =1
        !filter=1
    endif  else begin
        ave_info.filter=0
        !filter=0
    endelse
    widget_control,ave_info.filterID,set_button=ave_info.filter
    ;***********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;******************************************************************
pro crits_droplist_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure
    ;***********************************************************
    widget_control,ave_info.criteria.criteriaID,get_value=cmd
    thisvariable=(*ave_info.criteria.variables)[event.index]
    ave_info.criteria.text=cmd+' '+thisvariable
    widget_control,ave_info.criteria.criteriaID,set_value=ave_info.criteria.text
    ;********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;*******************************************************
;*******************************************************
pro save_crits_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure
    ;***********************************************************
    widget_control,ave_info.criteria.criteriaID,get_value=cmd
    if strlen(strtrim(cmd,2)) gt 1 then begin
        outfilename=!currentHPname+'Ascii\Criteria_2DS_boolean.txt'
        ;finf out if teh path exit, if not, make it first
        rrr=file_search(!currentHpname+'\ascii',/test_directory);  test if teh directory ascii exist.
        if strlen(rrr) eq 0 then file_mkdir,!currentHPname+'\Ascii'
        openw,5,outfilename
        printf,5,format='(A)',cmd
        printf,5,'*****************Always leave this line as it is ****************
        printf,5,'The above 2DS criteria is saved at this time: ',systime()
        printf,5,'You may put as many notes as you like after here:'
        close,5
    endif
    ;********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;*******************************************************
;*******************************************************
pro load_crits_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure
    ;***********************************************************
    pathnm=strmid(!currentHpname,0,strlen(!currentHpname)-1)+'\ascii'
    in_crits_file=dialog_pickfile(filter='*Criteria_2DS_Boolean*.txt',path=pathnm,title='Please pick a 2DS criteria file')
    if in_crits_file ne '' then begin
        openr,8,in_crits_file
        input_string='abcdf'
        readF,8,input_string;  ;input_string={ L1 H binc L1 V binc L1 ******
        close,8
        ave_info.criteria.text=input_string
        widget_control,ave_info.criteria.criteriaID,set_value=input_string
    endif
    ;********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;*******************************************************
pro General_help_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    message=[['1: Values for Variable in criteria is in unit pixels. L1n lt 2 means choose images whose L1n is less that'],$
        ['   20 microns. don"t use expression (L1n/L2 lt 5) because L2 may be zero, use (L1n lt 5*L2) instead.'],$
        ['                                                                             '],$
        ['2: when Time and criteria is changed, always click Update button first to make it effective.       '],$
        ['                                                    '],$
        ['3: We use M1, M2, M3,M4 to represent Methods for calculation the time series and PSD.'],$
        ['   M1 means calculating PSD, IWC, LWC adjustemnt factor and ect, using Sizes along TAS'],$
        ['                                                                                 '],$
        ['4: w8_t is inter-particle-time in tick, 1 tick=10micron/TAS                      ']]

    rrr=dialog_message(message,/information)
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end; end of general_help_event



pro criteria_text_event, event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval                ; get our info structure

    widget_control, ave_info.criteria.criteriaID, get_value=cmd

    if(event.type eq 0 or event.type eq 1 or event.type eq 2) then begin ; single character entry, multiple character, delete
        ave_info.criteria.text = cmd[0]
    endif

    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end ; criteria_text_event




pro Archive_ice_pop_up_roundness_check_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get info structure

    defsysv, '!roundness_criteria_checked', exists = exists

    if(not exists) then begin
        defsysv, '!roundness_criteria_checked', event.select
    endif else begin
        !roundness_criteria_checked = event.select
    endelse

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; set info structure
end ; Archive_ice_pop_up_roundness_check_event



pro Archive_ice_pop_up_roundness_text_event, event
    Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get info structure
    ;Widget_Control, event.id,  Get_UValue=uval            ; get info structure

    widget_control, info.round1min_ID, get_value = val
    !Roundness1_min = float(val)
    widget_control, info.round1max_ID, get_value = val
    !Roundness1_max = float(val)
    widget_control, info.round2min_ID, get_value = val
    !Roundness2_min = float(val)
    widget_control, info.round2max_ID, get_value = val
    !Roundness2_max = float(val)
    widget_control, info.round3min_ID, get_value = val
    !Roundness3_min = float(val)
    widget_control, info.round3max_ID, get_value = val
    !Roundness3_max = float(val)

    Widget_Control, event.top, Set_UValue=info, /No_Copy  ; set our info structure
end ; Archive_ice_pop_up_roundness_text_event




Function Archive_ice_pop_up, value=value,group=group; Added this on august 21, 2007 for 4 box of ice archive.
    ;useage is kkk=archive_ice_pop_up(value=1); my_sel=*((*kkk).localstate)={M6:1,M4:0,M2:0,M1:1}

    tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, $
        /col, TITLE='ice_archive_options',mbar=menuBase)

    M1state = 1
    M2state = 0
    M4state = 0
    M6state = 0
    M7state = 1
    M5state = 0

    Iwcstate= 1
    Icspstate=0
    liqstate =0


    MAINBase = widget_base(tlb,/col)
    McheckBase = widget_base(MAINBase, /row)
    LeftButtonsBase = WIDGET_BASE(McheckBase, /COLUMN, UVALUE='AllButtons')
    OpsBase = WIDGET_BASE(LeftButtonsBase, /COL, /FRAME, /BASE_ALIGN_CENTER, UVALUE='ProcButtons')

    b36   = widget_base(opsbase,/row)
    ;label = widget_label(b36,value='# of shaded edges',/align_center)
    b37a  = widget_base(b36,/row)
    label = widget_label(b37a,value='Archive:',/align_left)
    ;***********************************************************
    b372  = widget_base(b37a,col=3,/exclusive);    chnage This Mo  on 2016-03-08
    massopt0 = widget_button(b372,value = 'Ice:    IWC  ', uvalue ='flagIWC')
    massopt1 = widget_button(b372,value = 'Ice:    Icsp ', uvalue ='flagIcsp')
    massopt2 = widget_button(b372,value = 'Liquid: Shere', uvalue ='flagLiq')
    widget_control,massopt0,set_button = Iwcstate
    widget_control,massopt1,set_button = Icspstate
    widget_control,massopt2,set_button = Liqstate

    ;*********************************************************
    b373  = widget_base(b37a,col=4,/nonexclusive)
    flag0 = widget_button(b373,value = 'M6',uvalue ='flagM6')
    flag1 = widget_button(b373,value = 'M4',uvalue ='flagM4')
    flag2 = widget_button(b373,value = 'M2',uvalue ='flagM2')
    flag3 = widget_button(b373,value = 'M1',uvalue ='flagM1')
    flag4 = widget_button(b373,value = 'M7',uvalue ='flagM7')
    flag5 = widget_button(b373,value = 'M5',uvalue ='flagM5')

    widget_control,flag0,set_button = M6state
    widget_control,flag1,set_button = M4state
    widget_control,flag2,set_button = M2state
    widget_control,flag3,set_button = M1state
    widget_control,flag4,set_button = M7state
    widget_control,flag5,set_button = M5state

    accept_sel   =widget_button(b36,value='Accept',Uvalue='Accept')
    myptr = ptr_new({localstate:ptr_new({M6:M6state,M4:M4state,M2:M2state,M1:M1state,M7:M7state,M5:M5state,accepted:0})}) ;  this is important

    ; Add the Roundness criteria to the widget

    ; Roundness criteria defaults -- moved to a2DSView.pro with other defsysv
    ;defsysv, '!Roundness1_min',  .8
    ;defsysv, '!Roundness1_max', 2.
    ;defsysv, '!Roundness2_min', 0.
    ;defsysv, '!Roundness2_max',  .2
    ;defsysv, '!Roundness3_min',  .999
    ;defsysv, '!Roundness3_max', 1.001

    ;defsysv, '!roundness_criteria_checked', 0

    bottombase = widget_base(MAINbase, /row)

    roundness_base = widget_base(bottombase, /col, /frame)

    roundness_base_1 = widget_base(roundness_base, /row)
    roundness_base_2 = widget_base(roundness_base, /row)
    roundness_base_3 = widget_base(roundness_base, /row)
    roundness_base_4 = widget_base(roundness_base, /row)
    roundness_base_5 = widget_base(roundness_base, /row)
    roundness_base_6 = widget_base(roundness_base, /row)

    roundness_text_xsize = 5
    roundness_label_xsize = 100

    label        = widget_label(roundness_base_1, value = "Roundness1  min =", xsize = roundness_label_xsize)
    round1min_ID =  widget_text(roundness_base_1, value=strtrim(string(!Roundness1_min),2), /editable, /all, Event_pro='Archive_ice_pop_up_roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_2, value = "Roundness1  max =", xsize = roundness_label_xsize)
    round1max_ID =  widget_text(roundness_base_2, value=strtrim(string(!Roundness1_max),2), /editable, /all, Event_pro='Archive_ice_pop_up_roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_3, value = "Roundness2  min =", xsize = roundness_label_xsize)
    round2min_ID =  widget_text(roundness_base_3, value=strtrim(string(!Roundness2_min),2), /editable, /all, Event_pro='Archive_ice_pop_up_roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_4, value = "Roundness2  max =", xsize = roundness_label_xsize)
    round2max_ID =  widget_text(roundness_base_4, value=strtrim(string(!Roundness2_max),2), /editable, /all, Event_pro='Archive_ice_pop_up_roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_5, value = "Roundness3  min =", xsize = roundness_label_xsize)
    round3min_ID =  widget_text(roundness_base_5, value=strtrim(string(!Roundness3_min),2), /editable, /all, Event_pro='Archive_ice_pop_up_roundness_text_event', xsize = roundness_text_xsize)
    label        = widget_label(roundness_base_6, value = "Roundness3  max =", xsize = roundness_label_xsize)
    round3max_ID =  widget_text(roundness_base_6, value=strtrim(string(!Roundness3_max),2), /editable, /all, Event_pro='Archive_ice_pop_up_roundness_text_event', xsize = roundness_text_xsize)

    roundness_check_base = widget_base(bottombase, col=1, /nonexclusive)
    roundness_check_ID = widget_button(roundness_check_base, value = 'Use Roundness Criteria for ASCII Archives', Event_pro='Archive_ice_pop_up_roundness_check_event')
    widget_control, roundness_check_ID, set_button = !roundness_criteria_checked

    ; set up the info pointer for these events

    info = {myptr:myptr,                $
        M6:M6state,                 $
        M4:M4state,                 $
        M2:M2state,                 $
        M1:M1state,                 $
        M7:M7state,                 $
        M5:M5state,                 $
        round1min_ID:round1min_ID,  $
        round1max_ID:round1max_ID,  $
        round2min_ID:round2min_ID,  $
        round2max_ID:round2max_ID,  $
        round3min_ID:round3min_ID,  $
        round3max_ID:round3max_ID   }

    ; realize the widget, register with xmanager, and return control

    WIDGET_CONTROL, Tlb, /REALIZE
    WIDGET_CONTROL, tlb, SET_UVALUE=info,/no_copy
    XMANAGER, 'Archive_ice_pop_up', tlb
    return, myptr
end; archive_ice_pop_up



pro archive_ice_pop_up_event,event

    WIDGET_CONTROL, event.top, GET_UVALUE=info,/no_copy
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of
        ; Handle a kill request.
        'WIDGET_KILL_REQUEST':begin
        ; I should clean up in here. and release it to go back to zoom window.
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin
    else: begin
        ; a normal event

        WIDGET_CONTROL, event.id, GET_UVALUE = eventval
        CASE eventval OF    ; Note that pos  is not equal Pos, it is case_senitive
            'flagM7': info.M7=event.select
            'flagM6': info.M6=event.select
            'flagM4': info.M4=event.select
            'flagM5': begin
                info.M5=event.select
            end
            'flagM2': info.M2=event.select
            'flagM1': info.M1=event.select
            'flagIWC': begin
                defsysv, '!mass_optionIWC',1
                defsysv, '!mass_optionIcsp',0
                defsysv, '!mass_optionLiq',0
            end
            'flagIcsp':begin
            defsysv, '!mass_optionIWC',0
            defsysv, '!mass_optionIcsp',1
            defsysv, '!mass_optionLiq',0
        end

        'flagLiq':begin
        defsysv, '!mass_optionLiq',1
        defsysv, '!mass_optionIWC',0
        defsysv, '!mass_optionIcsp',0
    end
    ELSE:
ENDCASE ; end of event.id case
if eventval eq 'Accept' then begin
    myptr=info.myptr;  this is a point
    (*myptr).localstate=ptr_new({M6:info.M6,M4:info.M4,M2:info.M2,M1:info.M1,M7:info.M7,M5:info.M5})
    WIDGET_CONTROL, event.top, SET_UVALUE=info,/no_copy; set info values bfore it is destroyed.
    Widget_Control, event.top, /Destroy
    return
endif
end
endcase ; end of sname case
WIDGET_CONTROL, event.top, SET_UVALUE=info,/no_copy
end ; archive_ice_pop_up_event



; H50micron Pop Up Window Section
; contains a pop up window for handling manual H 50 vs 10 micron selection
; This window is brought up when !manual_override_H50vs10micron is set to 1,
; or when autmatic detection fails for a SORTED or .bin file.

pro H50micron_pop_up_event, event
    sname = TAG_NAMES(event, /STRUCTURE_NAME)

    case sname of
        'WIDGET_KILL_REQUEST':begin
        WIDGET_CONTROL, event.top, /DESTROY
        RETURN
    END ;end of 'widget_kill_reguest':begin
    else: begin
        WIDGET_CONTROL, event.id, GET_UVALUE = eventval

        case eventval of
            'flagH10microns': begin
                if(!H_resolution_microns ne 10) then begin ; this is sloppy, the event gets called for both checking and unchecking the radio button
                    ;print, "H 10 microns selected"
                    !H_resolution_microns = 10
                endif
            end
            'flagH50microns': begin
                if(!H_resolution_microns ne 50) then begin ; this is sloppy, the event gets called for both checking and unchecking the radio button
                    ;print, "H 50 microns selected"
                    !H_resolution_microns = 50
                endif
            end
            'Accept': begin
                Widget_Control, event.top, /Destroy
            end
        endcase

        return
    end
endcase ; end of sname case
end ; H50micron_pop_up_event



pro H50micron_pop_up
    ; pop up window for handling manual H 50 vs 10 micron selection
    ; sets global variables based on user selected state

    ; !H_resolution_microns = 50 or 10

    ; used by define_Pixel_resolutions to set !MICRONS_PER_PIXELH

    tlb = WIDGET_BASE(GROUP_LEADER=Group, /TLB_KILL_REQUEST_EVENTS, $
        /col, TITLE = 'H 10 vs 50 Micron Manual Selection', mbar=menuBase)

    !H_res_set_manually = 1 ; set the flag that the H50micron pop up window has been used -- it will use the manual selection even if closed now

    ; set up resonable defaults based on the !H_resolution_microns setting
    if(!H_resolution_microns eq 10) then begin
        H10micron_state = 1
        H50micron_state = 0
    endif else begin
        H10micron_state = 0
        H50micron_state = 1
    endelse

    MAINBase        = widget_base(tlb, /col)

    topbase = widget_base(MAINbase, /row)

    if(!manual_override_H50vs10micron eq 1) then begin
        label = widget_label(topbase, value = "Manual Selection of H Pixel Resolution", /align_center)
    endif else begin
        label = widget_label(topbase, value = "Automatic H Resolution Detection Failed, Manual Selection Forced", /align_center)
    endelse

    ; TAF note 2013-10-04: the base layout is a bit of a mess of names, but works, can clean it up at some point, but works fine

    McheckBase      = widget_base(MAINBase, /row)
    LeftButtonsBase = widget_base(McheckBase, /COLUMN, UVALUE='AllButtons')
    opsbase         = widget_base(LeftButtonsBase, /COL, /FRAME, /BASE_ALIGN_CENTER, UVALUE='ProcButtons')

    b36   = widget_base(opsbase, /row)

    b37a  = widget_base(b36, /row)
    label = widget_label(b37a, value='H Microns/Pixel:',/align_left)

    b372  = widget_base(b37a, col=2, /exclusive)

    Hresopt0 = widget_button(b372,value = 'H 10um', uvalue ='flagH10microns')
    Hresopt1 = widget_button(b372,value = 'H 50um', uvalue ='flagH50microns')

    widget_control, Hresopt0, set_button = H10micron_state
    widget_control, Hresopt1, set_button = H50micron_state

    accept_sel = widget_button(b36,value = 'Accept',Uvalue = 'Accept')

    ;info = {H10:H10micron_state, H50:H50micron_state}

    ; realize the widget, register with xmanager, and return control

    WIDGET_CONTROL, Tlb, /REALIZE
    ;WIDGET_CONTROL, tlb, SET_UVALUE=info,/no_copy
    XMANAGER, 'H50micron_pop_up', tlb

    return
end; H50micron_pop_up
; end of H50micron Pop Up Window Section



pro load_Spec_crits_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure
    ;***********************************************************
    a3vcpiviewloc = strpos(!path,'2DSVIEW')
    end_semicolonloc = strpos(!path,';',a3vcpiviewloc)
    start_semicolonloc = strpos(!path,';',a3vcpiviewloc,/reverse_search)
    length=end_semicolonloc-start_semicolonloc-1
    Pathnm = strmid(!path,start_semicolonloc+1,length)+'\Common_criteria\'
    in_crits_file=dialog_pickfile(filter='Spec_Crits_*.txt',path=pathnm,title='Please pick a SPEC_special_2DS criteria file')
    if in_crits_file ne '' then begin
        openr,8,in_crits_file
        input_string='abcdf'
        readF,8,input_string;  ;input_string={ L1 H binc L1 V binc L1 ******
        close,8
        ave_info.criteria.text=input_string
        widget_control,ave_info.criteria.criteriaID,set_value=input_string
    endif
    ;********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;*******************************************************
pro Apply_crits_to_ALL_event,event
    Widget_Control, event.top, Get_UValue=ave_info, /No_Copy  ; get our info structure
    Widget_Control, event.id,  Get_UValue=uval  ; get our info structure
    ;***********************************************************
    ;stop; will apply currect logic to all images in current loaded data file.

    ; if it stop in here, type .continue in the command line to continue.

    ; if the button is not click, it applys to only teh zoomed part of the file.
    ; needed to write to the initial setup file ?
    ;********************************************************
    Widget_Control, event.top, Set_UValue=ave_info, /No_Copy  ; get our info structure
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

pro createzoom_event, event
    ; TAF this event was causing errors, not sure why it is being called -- need to talk to Mo about it 17 Sep 2010

    ;print, "temporary createzoom_event
    ;print, event.id
end
