
; this routine handles events from the left side controls in the GUI

PRO left_event, event

    err=0
    catch,err
    if(err ne 0)then begin
        PRINT, 'Error message:', !ERR_STRING
        ;widget_control,event.top,set_uvalue=StateInfo,/no_copy
        return
    endif

    WIDGET_CONTROL, event.top, GET_UVALUE=pStateInfo

    WIDGET_CONTROL, event.id, GET_UVALUE = eventval

    CASE eventval OF

        'Filtered': begin
            (*pStateInfo).DispMode = ((*pStateInfo).DispMode eq 2 or (*pStateInfo).DispMode eq 0) ? 1 : 0
            if((*pStateInfo).DispMode eq 1)then widget_control,(*pStateInfo).widgets.gradient,set_button = !false
            ; display frame if available
            if(ptr_valid((*pStateInfo).pFrameData))then bounds = DispFrame(pStateInfo)
        end
        'Gradient': begin

            (*pStateInfo).DispMode = ((*pStateInfo).DispMode eq 1 or (*pStateInfo).DispMode eq 0) ? 2 : 0
            if((*pStateInfo).DispMode eq 2)then widget_control,(*pStateInfo).widgets.filtered,set_button = !false
            ; display frame if available

            if(ptr_valid((*pStateInfo).pFrameData))then bounds = DispFrame(pStateInfo)
        end

        'MOSAIC': begin
            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                (*pStateInfo).Settings.Mosaic = NOT (*pStateInfo).Settings.Mosaic

                if( (*pStateInfo).Settings.Mosaic )then begin
                    (*pStateInfo).oldZoom = (*pStateInfo).zoom
                    ; set a starting value to see mosaic
                    (*pStateInfo).zoom = .45
                    widget_control,(*pStateInfo).zoomLabelID,set_value = strtrim((*pStateInfo).zoom,2)
                endif else begin
                    ; set a starting value to see mosaic
                    (*pStateInfo).zoom = (*pStateInfo).oldZoom
                    widget_control,(*pStateInfo).zoomLabelID,set_value = strtrim((*pStateInfo).zoom,2)
                endelse

                ; now display frame
                if((*pStateInfo).displayPerim)then begin
                    ; if an object file exist toggle perimeter
                    if(ptr_valid((*pStateInfo).pObjList))then begin

                        objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
                        ROI_Count = objData.Frameheader.ROIsCount
                        pBoundary = ptrarr(ROI_count)

                        for index = 0,ROI_count-1 do begin
                            header = (*objData.pFrame)[index].imageheader
                            if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                        endfor

                        delete_obj_header,objData

                        ; redraw frame
                        tvlct,255,255,0,255

                        bounds = DispFrame(pStateInfo,pBoundary=pBoundary)

                    endif
                endif else begin
                    ; redraw frame
                    tvlct,255,255,255,255

                    bounds = DispFrame(pStateInfo)

                endelse

                ptr_free,(*pStateInfo).pBounds
                (*pStateInfo).pBounds =  ptr_new(bounds)


            endif
        end

        'Xsection': begin
            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue

                if((*pStateInfo).XSection)then begin

                    ; use XOR mode
                    device, set_graphics_function=6
                    ; erase old line if it exists
                    if((*pStateInfo).XS_coords[0] ne -1)then begin
                        x = [(*pStateInfo).XS_coords[0],(*pStateInfo).XS_coords[1]]
                        y = [(*pStateInfo).XS_coords[2],(*pStateInfo).XS_coords[3]]
                        plots,x,y,/device,thick = 4
                        (*pStateInfo).XS_coords = [-1,-1,-1,-1]
                    endif
                    device, set_graphics_function=3
                    (*pStateInfo).XSection = !false
                    tv,bytarr(300,300),400,170
                    ;wdelete,(*pStateInfo).ProfID
                    ;(*pStateInfo).ProfID = -1
                    ;(*pStateInfo).XFrame = -1
                endif else begin
                    (*pStateInfo).XSection = !true
                    ;(*pStateInfo).XFrame = (*pStateInfo).imgPos
                    ShowMsg, (*pStateInfo).InstLabel, 'Use left mouse button to start cross section.'
                endelse

            endif

        end


        'PixSize': (*pStateInfo).Settings.PixSize = event.Value

        'ASPECT': (*pStateInfo).Settings.YXAspect = event.Value

        'SubBkgrnd': begin
            if(ptr_valid((*pStateInfo).pFrameData))then begin
                ;(*pStateInfo).SubBkgd = True means to subtract the background frame from the image before display
                if((*pStateInfo).SubBkgd)then begin
                    ; state is changing to false, so must reload original data
                    ; get the list of frames to use ( this is set via *pImgPosIndx which may have backgrounds depending on gui setting)
                    ImgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]

                    ; get the frame indicated via position in scan list
                    frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,(ImgList[(*pStateInfo).ImgPos-1]).fpos,date=(*pStateInfo).date)

                    ; no background removed
                    (*pStateInfo).backRemoved = !false

                    ; save into state structure pFrameData always holds the current frame
                    delete_frame,(*pStateInfo).pFrameData
                    (*pStateInfo).pFrameData = ptr_new(frameData,/no_copy)
                endif

                (*pStateInfo).SubBkgd = event.select ? !true : !false

                if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                    ; set min/max to gui
                    set_min_max, pStateInfo

                    ; Show main info line
                    disp_frame_info, pStateInfo, 0

                    ; now display frame
                    if((*pStateInfo).displayPerim)then begin
                        ; if an object file exist toggle perimeter
                        if(ptr_valid((*pStateInfo).pObjList) and (*pStateInfo).SkipBkgd)then begin

                            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1].fPos)
                            ROI_Count = objData.Frameheader.ROIsCount
                            pBoundary = ptrarr(ROI_count)

                            for index = 0,ROI_count-1 do begin
                                header = (*objData.pFrame)[index].imageheader
                                if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                            endfor

                            delete_obj_header,objData

                            ; redraw frame
                            tvlct,255,255,0,255

                            bounds = DispFrame(pStateInfo,pBoundary=pBoundary)

                        endif
                    endif else begin
                        ; redraw frame
                        tvlct,255,255,255,255
                        bounds = DispFrame(pStateInfo)
                    endelse
                endif
            endif
        end
        'SkipBkgrnd': begin
            if(ptr_valid((*pStateInfo).pFrameData))then begin
                ; skip backgrounds = True means to not display backgrounds as the frame number is advanced
                (*pStateInfo).SkipBkgd = event.select ? !true : !false
            endif
        end

        'UseAsBkg': begin
            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue

                ; Check for image size.
                if(((*(*pStateInfo).pFileScan)[(*pStateInfo).imgPos]).imgtype eq 2) then begin
                    dx = (*(*pStateInfo).pFrameData).imageheader.ex - (*(*pStateInfo).pFrameData).imageheader.sx + 1
                    dy = (*(*pStateInfo).pFrameData).imageheader.ey - (*(*pStateInfo).pFrameData).imageheader.sy + 1
                    if ((*pStateInfo).FileHead.DX EQ dx AND (*pStateInfo).FileHead.DY EQ dy) then begin
                        (*pStateInfo).BackFrame = (*pStateInfo).pFrameData
                        (*pStateInfo).BkgPos = (*pStateInfo).imgPos                 ; contains the zero-based index number into scanList of the background to use
                    endif else ShowMsg, (*pStateInfo).InstLabel, 'Image must be of full size in order to be a background.'
                endif else ShowMsg, (*pStateInfo).InstLabel, 'Image must be a background type'
            endif
        end

        'IMGNUMSLIDER': BEGIN

            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                WIDGET_CONTROL, event.top, /HOURGLASS

                ; Update ROI params to file?
                IF((*pStateInfo).UpdateFile) THEN UpdateBlock, pStateInfo

                ; get the list of frames to use ( this is set via *pImgPosIndx which may have backgrounds depending on gui setting)
                ImgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]


                ; handle the case when this is a background
                background = !false
                LastPos = (*pStateInfo).ImgPos
                (*pStateInfo).ImgPos = event.value

                dir =  (*pStateInfo).ImgPos - LastPos
                if(ImgList[event.value-1].imgtype eq 2)then begin
                    ; If at end of file step back one else step over one
                    if((*pStateInfo).SkipBkgd)then begin
                        if(dir gt 0)then begin
                            (*pStateInfo).ImgPos = ((*pStateInfo).ImgPos eq (*pStateInfo).TotImgCount) ? (*pStateInfo).ImgPos-1 :(*pStateInfo).ImgPos+1
                        endif else begin
                            (*pStateInfo).ImgPos = ((*pStateInfo).ImgPos eq 1) ? (*pStateInfo).ImgPos+1 :(*pStateInfo).ImgPos-1
                        endelse
                    endif else background = !true
                endif

                ;**************************************************************
                ;****************************************************************
                do_search_by_time=0
                start_imgnumslider_part: ;do nothing, just for search to jump to here.
                if do_search_by_time eq 1 then begin
                    do_search_by_time =0
                    background = !true
                endif
                ;******************************************************************

                ;**************************************************************
                WIDGET_CONTROL, (*pStateInfo).ImgSliderID, SET_VALUE=(*pStateInfo).ImgPos


                ; delete current frame
                delete_frame,(*pStateInfo).pFrameData

                ; get the frame indicated via position in scan list

                frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,(ImgList[(*pStateInfo).ImgPos-1]).fpos,date=(*pStateInfo).date)

                ;stop;  here frame data is teh same as in process_time_lib2.pro after feamedata=read_frame. good!, March 18/05
                if(size(frameData,/type) eq 8)then begin
                    ; display frame time
                    ; comment following 4 lines out and replace it with 3 new words----september 1, 2009.
                    ;frame_time = convertFromSeconds(frameData.frameheader.Time,(*pStateInfo).fileHead.year)
                    ;frame_time.msec  = ROUND(CalcStrobeTime(frameData.frameheader.ArrivalT1, frameData.frameheader.ArrivalT2,frameData.frameheader.Ver))
                    ;msg = 'frame#:'+strtrim(fix((*pStateInfo).ImgPos),2) + ' Frame time:' + strtrim(fix(frame_time.day),2) + ':' + strtrim(fix(frame_time.hour),2) $
                    ;     + ':' + strtrim(fix(frame_time.minute),2) + ':'+  strtrim(fix(frame_time.sec),2) + ':'+  strtrim(fix(frame_time.msec),2) + $
                    ;      ' Missed Particles: ' + strtrim(FrameData.frameHeader.Missed-1,2)
                    ;ShowMsg, (*pStateInfo).InstLabel,msg
                    ;time1= 'CPI: ' + strtrim(fix(frame_time.hour),2) + ':' + strtrim(fix(frame_time.minute),2) + ':'+  strtrim(fix(frame_time.sec),2) + ':'+  strtrim(fix(frame_time.msec),2)


                    ; display the (hex) time under the slider in the CPI View left panel

                    word1 = string(format='(%"%04X")', frameData.frameheader.Time)
                    word2 = string(format='(%"%04X")', frameData.frameheader.arrivalT1)
                    word3 = string(format='(%"%04X")', frameData.frameheader.arrivalT2)

                    word1_a=strmid(word1,0,2)
                    word1_b=strmid(word1,2,2)
                    word2_a=strmid(word2,0,2)
                    word2_b=strmid(word2,2,2)
                    word3_a=strmid(word3,0,2)
                    word3_b=strmid(word3,2,2)

                    time1 = '0x' + word3_a + word3_b + word2_a + word2_b + word1_b + word1_b

                    ; TAF format this time output (put in 0's instead of empty)

                    ;time2= 'DAS: ' + strtrim(fix(frameData.frameheader.hour),2) + ':' + strtrim(fix(frameData.frameheader.minute),2) + ':'+  strtrim(fix(frameData.frameheader.sec),2) + ':'+  strtrim(fix(frameData.frameheader.msec),2)

                    time2_hour   = strtrim(fix(frameData.frameheader.hour),  2)
                    time2_minute = strtrim(fix(frameData.frameheader.minute),2)
                    time2_sec    = strtrim(fix(frameData.frameheader.sec),   2)
                    time2_msec   = strtrim(fix(frameData.frameheader.msec),  2)

                    if(strlen(time2_hour) eq 1) then begin
                        time2_hour = '0' + time2_hour
                    endif

                    if(strlen(time2_minute) eq 1) then begin
                        time2_minute = '0' + time2_minute
                    endif

                    if(strlen(time2_sec) eq 1) then begin
                        time2_sec = '0' + time2_sec
                    endif

                    if(strlen(time2_msec) eq 2) then begin
                        time2_msec = '0' + time2_msec
                    endif else if(strlen(time2_msec) eq 1) then begin
                        time2_msec = '00' + time2_msec
                    endif

                    time2 = time2_hour + ':' + time2_minute + ':'+  time2_sec + ':'+ time2_msec

                    widget_control,(*pStateInfo).widgets.time1,set_value = time1
                    widget_control,(*pStateInfo).widgets.time2,set_value = time2

                    ; initally, no background removed
                    (*pStateInfo).backRemoved = !false

                    ; save into state structure pFrameData always holds the current frame
                    (*pStateInfo).pFrameData = ptr_new(frameData, /no_copy)

                    if((*pStateInfo).Bkgs_exist and (*pStateInfo).BkgPos ge 0)then begin
                        ; determine if the current background is still the best
                        position = (*pStateInfo).ImgPos-1
                        ImgscanList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
                        backScanList = where(ImgscanList.imgtype eq 2)

                        if(ptr_valid((*pStateInfo).pBackPosIndx))then get_best_backGnd_pos,ImgscanList,backScanList,position

                        if(position ne (*pStateInfo).BkgPos)then begin

                            ShowMsg, (*pStateInfo).InstLabel,'Current Background at Frame # '+ strtrim(position+1,2)

                            BackFrame = read_backGnd((*pStateInfo).InFileLun,(*(*pStateInfo).pFrameData).frameheader.ver,imgList[position].fpos)  ; contains the structure of the background

                            (*pStateInfo).BackFrame = ptr_new(BackFrame,/no_copy)
                            (*pStateInfo).BkgPos =  position
                        endif; else print,'Current background OK'
                    endif

                    ; set min/max to gui ( this removes a background if needed )

                    set_min_max, pStateInfo

                    ; Show main info line
                    disp_frame_info, pStateInfo, 0;  That is if imagetype eq 8, display, otherwise don't display.

                    ;get Obj info if it exists
                    if(ptr_valid((*pStateInfo).pObjList) and not background)then begin
                        ;return,{FrameHeader:FrameHeader,pFrame:pFrame,pImHDfPos:ptr_new(imageHeaderFPOS)}
                        ; clean up existing obj if it exists
                        if(ptr_valid((*pStateInfo).pObjData))then begin
                            ptr_free,(*(*(*pStateInfo).pObjData).pFrame).imageheader.Harmonics
                            ptr_free,(*(*(*pStateInfo).pObjData).pFrame).imageheader.Boundary
                            ptr_free,(*(*pStateInfo).pObjData).pFrame
                            ptr_free,(*(*pStateInfo).pObjData).pImHDfPos
                            ptr_free,(*pStateInfo).pObjData
                        endif


                        ;BkgPosList = TEMPORARY(WHERE((*(*pStateInfo).pFileScan).ImgType eq 2, BkgCount))
                        ;where((*pStateInfo).ImgPos-1 gt
                        ;objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[(*pStateInfo).ImgPos-1-BkgCount].fPos)
                        ;objTime = float(objData.frameHeader.time) + calcStrobeTime(objData.frameHeader.arrivalT1,objData.frameHeader.arrivalT2)/1000.0D

                        ; need to get calcStrobe time working for 3V-CPI
                        ;roiTime = float((*(*pStateInfo).pFrameData).frameheader.time) + calcStrobeTime((*(*pStateInfo).pFrameData).frameheader.arrivalT1,(*(*pStateInfo).pFrameData).frameheader.arrivalT2,(*(*pStateInfo).pFrameData).frameheader.Ver)/1000.0D

                        roiTime = float((*(*pStateInfo).pFrameData).frameheader.time); mo change this on august 15, 2012.
                        roitime =(*(*pStateInfo).pFrameData).frameheader.hour*3600.0+(*(*pStateInfo).pFrameData).frameheader.minute*60.0 + $
                            (*(*pStateInfo).pFrameData).frameheader.sec*1.0+(*(*pStateInfo).pFrameData).frameheader.msec/1000.0D
                        ;print,roiTime,objTime,format='(2(f15.5,x))'
                        ;if(objTime ne roiTime)then begin


                        indexOBJ = where(roiTime eq (*(*pStateInfo).pObjList).time, cntOBJ)
                        ;print,roiTime,(*(*pStateInfo).pObjList)[indexOBJ[0]].time,format='(2(f15.5,x))'
                        if(cntOBJ gt 0)then begin
                            ; read a frame of info from the obj file
                            objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[indexOBJ[0]].fPos)
                            ; store obj info
                            (*pStateInfo).pObjData = ptr_new(objData,/no_copy)

                        endif else r = dialog_message('Error: obj frame not found')
                        ;endif else (*pStateInfo).pObjData = ptr_new(objData,/no_copy)

                    endif else begin
                        ; clean up existing obj if it exists
                        if(ptr_valid((*pStateInfo).pObjData))then begin
                            ptr_free,(*(*(*pStateInfo).pObjData).pFrame).imageheader.Harmonics
                            ptr_free,(*(*(*pStateInfo).pObjData).pFrame).imageheader.Boundary
                            ptr_free,(*(*pStateInfo).pObjData).pFrame
                            ptr_free,(*(*pStateInfo).pObjData).pImHDfPos
                            ptr_free,(*pStateInfo).pObjData
                        endif
                        (*pStateInfo).pObjData = ptr_new()
                    endelse

                    pBoundary = PTR_NEW()
                    tvlct,255,255,0,255

                    ; now display frame
                    if((*pStateInfo).displayPerim and not background)then begin
                        ; if an object file exist toggle perimeter
                        if(ptr_valid((*pStateInfo).pObjList))then begin

                            ROI_Count = (*(*pStateInfo).pObjData).Frameheader.ROIsCount
                            if((*(*pStateInfo).pFrameData).Frameheader.ROIsCount eq ROI_Count)then begin
                                pBoundary = ptrarr(ROI_count)

                                for index = 0,ROI_count-1 do begin
                                    header = (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                                    if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                                endfor
                            endif

                        endif
                    endif

                    ; temporary workaround for CPI and 2DS color compatibility
                    ; wset to main window here??
                    device, decomposed = 0
                    loadct, !ct_CPI, /silent

                    bounds = DispFrame(pStateInfo,pBoundary=pBoundary)



                    ; TAF 2014-03-25 little hack to cycle through the images and get the image means, and grab the raw image data

                    ; enable with !enable_image_diagnostic = 1 in a3VCPIView.pro

                    ; also note that disabling Autoscale and Background subtraction is necessary to get raw data

                    if(!enable_image_diagnostic) then begin
                        image_means = fltarr((*pStateInfo).TotImgCount)

                        images = bytarr((*pStateInfo).TotImgCount, 1280, 1024)

                        for i=0, (*pStateInfo).TotImgCount-1 do begin
                            delete_frame, (*pStateInfo).pFrameData

                            ; get the frame indicated via position in scan list
                            frameData = read_frame((*pStateInfo).InFileLun,(*pStateInfo).FileHead.Ver,(ImgList[i]).fpos,date=(*pStateInfo).date)
                            (*pStateInfo).pFrameData = ptr_new(frameData, /no_copy)

                            bounds = DispFrame(pStateInfo, pBoundary=pBoundary, image_mean=image_mean, return_image=return_image)

                            image_means[i] = image_mean

                            rix = (size(return_image))[1]
                            riy = (size(return_image))[2]

                            images[i, 0:rix-1, 0:riy-1] = return_image
                        endfor

                        window,0
                        plot, image_means

                        print, 'n: ', (*pStateInfo).TotImgCount - 1
                        print, 'mean: ', mean(image_means)
                        print, 'standard deviation: ', stddev(image_means)

                        stop
                    endif ; !enable_image_diagnostic



                    ptr_free,(*pStateInfo).pBounds
                    (*pStateInfo).pBounds =  ptr_new(bounds)

                    ; TAF should set !P.multi back to zeroes here, testing

                    !P.multi = lonarr(5)

                    ; plot line on series
                    wset,(*pStateInfo).plotID
                    plot,*((*pStateInfo).pConc),xstyle = 1,ystyle=4,psym=10,ymargin=[2,0],xmargin=[0.3,0.3],color=254
                    plots,[(*pStateInfo).ImgPos-1,(*pStateInfo).ImgPos-1],[0,100],color=220,thick=2
                    plots,[(*pStateInfo).BkgPos-1,(*pStateInfo).BkgPos-1],[0,100],color=255,thick=2
                    wset,(*pStateInfo).MViewID
                    if((ImgList[(*pStateInfo).ImgPos-1]).badframe and (ImgList[(*pStateInfo).ImgPos-1]).blockmark eq 'ffff'x)then begin
                        xyouts,.02,.6,'Frame marked bad because of timestamp error',charsize=2.0
                    endif
                    ;print,(ImgList[(*pStateInfo).ImgPos-1]).badframe , (ImgList[(*pStateInfo).ImgPos-1]).blockmark
                endif else begin
                    print,'Invalid Frame'
                endelse

            endif

        end; end of "numslider".

        ;add this for searching image by time
        'search': begin
            ;Widget_Control, info.textID, Get_Value=theText
            Widget_Control, (*pStateInfo).SchtimeID, Get_Value=theText
            timestr=strsplit(theText,':',/extract)
            hh=timestr(0)*1.0
            mm=timestr(1)*1.0
            ss=timestr(2)*1.0
            ms=timestr(3)*1.0

            if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue
                WIDGET_CONTROL, event.top, /HOURGLASS

                ; Update ROI params to file?
                IF((*pStateInfo).UpdateFile) THEN UpdateBlock, pStateInfo
            endif

            ; get the list of frames to use ( this is set via *pImgPosIndx which may have backgrounds depending on gui setting)
            ImgList = (*(*pStateInfo).pFileScan)[*(*pStateInfo).pImgPosIndx]
            indexm=where(imglist.hour eq hh and imglist.minute eq mm and imglist.sec eq ss and imglist.msec eq ms,contF)
            if contF gt 0 then begin
                (*pStateInfo).ImgPos =indexm(0)+1L;  ;image_pos=indexm(0)
                do_search_by_time =1
                goto, start_imgnumslider_part
            endif else begin
                ;search for nearest 1 second images
                indexm=where(imglist.hour eq hh and imglist.minute eq mm and imglist.sec eq ss,contF)
                if contF gt 0 then begin
                    (*pStateInfo).ImgPos =indexm(0)+1L;  ;image_pos=indexm(0)
                    ;Resp= DIALOG_MESSAGE('No exact match found, Only a close match to the second !!!', /INFORMATION )
                    do_search_by_time =1
                    goto, start_imgnumslider_part
                endif else begin
                    indexm=where(imglist.hour eq hh and imglist.minute eq mm,contF)
                    if contF gt 0 then begin
                        (*pStateInfo).ImgPos =indexm(0)+1L;  ;image_pos=indexm(0)
                        ;Resp= DIALOG_MESSAGE('No images in the second !!!, Only a close match to the minute !!!', /INFORMATION )
                        do_search_by_time =1
                        goto, start_imgnumslider_part
                    endif else begin
                        Resp= DIALOG_MESSAGE('No images even in the minute !!!, try again !', /INFORMATION )
                    endelse
                endelse
            endelse
        end


        'ZOOMSLIDER': BEGIN
            WIDGET_CONTROL, event.top, /HOURGLASS
            (*pStateInfo).zoom = event.value/10.0
            widget_control,(*pStateInfo).zoomLabelID,set_value = strtrim((*pStateInfo).zoom,2)

            if(ptr_valid((*pStateInfo).pFrameData))then begin
                ; Show main info line
                disp_frame_info, pStateInfo, 0

                pBoundary = PTR_NEW()
                tvlct,255,255,0,255

                ; now display frame
                if((*pStateInfo).displayPerim)then begin
                    ; if an object file exist toggle perimeter
                    if(ptr_valid((*pStateInfo).pObjList))then begin

                        ROI_Count = (*(*pStateInfo).pObjData).Frameheader.ROIsCount
                        pBoundary = ptrarr(ROI_count)

                        for index = 0,ROI_count-1 do begin
                            header = (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                            if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                        endfor
                    endif
                endif

                bounds = DispFrame(pStateInfo,pBoundary=pBoundary)
                ptr_free,(*pStateInfo).pBounds
                (*pStateInfo).pBounds =  ptr_new(bounds)

            endif
        END

        else:r = dialog_message('Error in left_event case statement')

    ENDCASE

end

