PRO view_event, event
    ; this routine handle only motion and mouse button events on the draw area
    ;   XSection  true means draw cross section lines


    err=0
    catch,err
    if(err ne 0)then begin
        ;   PRINT, 'Error message:', !ERR_STRING
        ;   help,/trace
        ;widget_control,event.top,set_uvalue=StateInfo,/no_copy
        return
    endif


    WIDGET_CONTROL, event.top, GET_UVALUE=pStateInfo
    if(size(*pStateInfo,/type) ne 8)then return ; avoid cases where this struture is not defined

    CASE event.TYPE OF

        0: BEGIN   ; Mouse button was pressed

            if (*pStateInfo).ROI then begin      ; ROI = true if the mouse is over an roi (set in mouse motion event block)

                x = event.x
                y = event.y
                ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
                info = GetROI(pStateInfo, x, y)

                ; ROIArray is an array of pointers for each particle in the frame
                ROIArray = *(*(*pStateInfo).pFrameData).pFrame

                ; now handle which button was pressed
                case event.press of
                    1: BEGIN ;LEFT MOUSE PRESSED

                        (*pStateInfo).displayPerim = not (*pStateInfo).displayPerim
                        if((*pStateInfo).displayPerim)then begin
                            ; if an object file exist toggle perimeter
                            if(ptr_valid((*pStateInfo).pObjList))then begin

                                ;read the frame number from the GUI
                                ;widget_control,(*pStateInfo).ImgSliderID,get_value = frame

                                ;objData = get_obj_header((*pStateInfo).ObjLUN,(*(*pStateInfo).pObjList)[frame-1].fPos)
                                ROI_Count = (*(*pStateInfo).pObjData).Frameheader.ROIsCount
                                pBoundary = ptrarr(ROI_count)

                                for index = 0,ROI_count-1 do begin
                                    header = (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                                    if(header.bound_len ne 0)then pBoundary[index] = header.boundary
                                endfor

                                ; if harmonics_flag is set then display the harmonics and radius plots
                                if((*pStateInfo).harmonics_flag)then begin
                                    header = (*(*(*pStateInfo).pObjData).pFrame)[info[0]].imageheader
                                    if(ptr_valid(header.harmonics))then begin
                                        distance = fft(*header.harmonics,1)
                                        print,*header.harmonics
                                        if((*pStateInfo).harmonicWinID eq 0)then begin
                                            window,/free,xpos = 500,ypos = 30
                                            (*pStateInfo).harmonicWinID = !d.window
                                        endif
                                        wset,(*pStateInfo).harmonicWinID
                                        wshow,(*pStateInfo).harmonicWinID
                                        !p.multi = [0,1,2]
                                        plot,*header.harmonics, title ='Radial Harmonics'/ylog,yrange=[.001,1],YTITLE='fred',psym=10;,xrange = [0,20]
                                        plot,distance,title = 'Radial Perimeter Distances'
                                        !p.multi = 0
                                    endif
                                endif

                                ; redraw frame
                                ;tvlct,255,255,0,255
                                r = DispFrame(pStateInfo,pBoundary=pBoundary)

                                if !DO_DOF_calib eq 1 then begin
                                    print, 'frame=', (*Pstateinfo).IMGPOS,' Roinum=',info(0)   ; frame number and roin number
                                    header = (*(*(*pStateInfo).pObjData).pFrame)[info[0]].imageheader
                                    !selected_frame_and_roinum=[(*Pstateinfo).IMGPOS, info(0),header.Ex,header.Ey, header.Sx, header.Sy,header.len, header.wid]
                                endif
                            endif
                        endif else begin
                            ; redraw frame
                            ;tvlct,255,255,255,255
                            r = DispFrame(pStateInfo)
                            if((*pStateInfo).harmonics_flag)then wdelete,(*pStateInfo).harmonicWinID
                            (*pStateInfo).harmonicWinID = 0
                        endelse

                        if((*pStateInfo).XSection)then begin

                            case (*pStateInfo).XStep of
                                0:begin; on first left mouse press get starting point
                                (*pStateInfo).Xarr_1 = [info[1],info[2]]
                                (*pStateInfo).XS_1 = [x,y]
                                (*pStateInfo).XS_particle = info[0]
                                (*pStateInfo).XStep = 1
                                ShowMsg, (*pStateInfo).InstLabel, 'Use left mouse button to select ending for XSection'
                            end

                            1:begin

                            if((*pStateInfo).XS_particle eq info[0])then begin
                                ; only proceed if on the same particle as first click
                                ; get the mouse co-ords
                                Xarr_2 = [info[1],info[2]]
                                XS_2 = [x,y]

                                (*pStateInfo).XS_coords = DoXSection( pStateInfo, info[0], XS_2, Xarr_2)
                                (*pStateInfo).XStep = 0
                                ShowMsg, (*pStateInfo).InstLabel, 'Use left mouse button to select starting for XSection'
                            endif else begin
                                ; use XOR mode
                                device, set_graphics_function=6
                                ; erase old line if it exists
                                if((*pStateInfo).XS_coords[0] ne -1)then begin
                                    x = [(*pStateInfo).XS_coords[0],(*pStateInfo).XS_coords[1]]
                                    y = [(*pStateInfo).XS_coords[2],(*pStateInfo).XS_coords[3]]
                                    plots,x,y,/device
                                    (*pStateInfo).XS_coords = [-1,-1,-1,-1]
                                endif
                                device, set_graphics_function=3
                                msg = 'End point must be on particle #'+strtrim((*pStateInfo).XS_particle+1,2)+', try again.'
                                ShowMsg, (*pStateInfo).InstLabel, msg
                            endelse
                            ;**************************************************************************
                            ; added this part for Norway Height_mean_size processing
                            if((*pStateInfo).XSection) and ((*pStateInfo).setting).mosaic  then begin
                                stop
                            endif
                            ;**************************************************************************
                        end
                    endcase
                endif ;else begin

                ; Assign values to actual particle
                ;set_roi_parameters,stateInfo,info[0]

                ;disp_frame_info, stateInfo, info[0] , /full

                ;endelse
            END  ;------------------------------------ end of left mouse press -----------------------------------------

            4: BEGIN ;right button

                if(not ((*(*pStateInfo).pFrameData).frameheader.imgtype and 2)/2)then begin
                    (*pStateInfo).manual = !true
                    flags = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags
                    dark = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Dark

                    ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
                    info = GetROI(pStateInfo, event.x, event.y)
                    index = info[0]

                    if(ptr_valid((*pStateInfo).pObjList) )then begin
                        p1 = (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader.P1
                    endif else p1 = 0.0

                    (*pStateInfo).manual = p1

                    ; TAF put in cycle through for Sphere, Ice, and Reject here, and get
                    ; rid of manualFeature call -- still need the handling for writing to the obj file below, though
                    ; it may need to be modified

                    ; On Right Click, cycle through 3 states:
                    ; 1) Crystal Habit = Sphere
                    ; 2) Crystal Habit = Ice
                    ; 3) Reject Image

                    objData = (*(*pStateInfo).pObjData)

                    ; first test for Reject, if positive, cancel reject and set Sphere

                    if((((*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags and '8000'X) ne 0) or ((*objData.pFrame)[index].imageheader.crystal eq 0B)) then begin
                        ;print, "reject detected, setting sphere"

                        (*objData.pFrame)[index].imageheader.crystal = 1B ; set sphere

                        ; ensure GUI display flag is set so that it will be unset with next command (likely a better way of doing these two lines, but not a time crunch here)
                        (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags  or '8000'X
                        (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags xor '8000'X ; set GUI display flag for not rejected
                    endif else if((*objData.pFrame)[index].imageheader.crystal eq 1B) then begin ; if Sphere, set Ice
                        ;print, "sphere detected, setting ice"

                        (*objData.pFrame)[index].imageheader.crystal = 15B ; set ice

                        ; ensure GUI display flag is set so that it will be unset with next command (likely a better way of doing these two lines, but not a time crunch here)
                        (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags  or '8000'X
                        (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags xor '8000'X ; set GUI display flag for not rejected
                    endif else begin ; if Ice then set reject
                        ;print, "ice assumed, setting reject"

                        (*objData.pFrame)[index].imageheader.crystal = 0B ; set reject

                        ; set GUI display flag to reject
                        (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags = (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags or '8000'X
                    endelse

                    (*objData.pFrame)[index].imageheader.P1 = 1. ; set P1, which seems to be update GUI

                    (*pStateInfo).UpdateFile = !true

                    ; update the .obj file with the new values
                    update_obj_header1,(*pStateInfo).ObjLUN, (*(*(*pStateInfo).pObjData).pImHDfPos)[index], (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader

                    ; redisplay the updated ROI info in the GUI
                    zoom = (*pStateInfo).zoom

                    ; get aspect ratio from window
                    widget_control,(*pStateInfo).AspectID,get_value = YXAspect

                    ;determine offset into actual array not displayed array
                    ;ImgSize = size(*ROIArray[info[0]].pROI,/dim)
                    dx = floor(info[1] /(zoom*YXAspect))
                    dy = floor(info[2] / zoom)

                    ; Redisplay ROI stats
                    data = {dx:dx,dy:dy,val:0}
                    disp_frame_info, pStateInfo, info[0] , /full, data=data


                    ;if(1 eq 2) then begin ; TAF temporarily disable manualFeature TAF 2014-03-28 re-enabling -- why was this disabled?
                    result = manualFeature(pStateInfo,event.x,event.y,event.top,flags,dark,p1)

                    if(result.ok)then begin

                        ; form information
                        ; set cut off percentage
                        cutoff = fix(31.0 * result.cutoff / 100.0)
                        (*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Dark = $
                            ((*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Dark and 'ff'X) + ishft(cutoff,8)

                        ; set focus percentage
                        (*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags = $
                            ((*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags and 'ff00'X) or fix(100 - result.focus)

                        ;set crystal type
                        (*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags = $
                            ((*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags AND 'e0ff'X) + ishft(fix(result.habit),8)

                        ; mark as manually corrected crystal type ( set bit 14 )
                        (*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags = $
                            (((*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags and 'dfff'x) XOR '2000'X)

                        ; unset reject bit
                        (*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags = $
                            ((*(*(*pStateInfo).pFrameData).pFrame)[index].imageheader.Flags AND '3fff'X) xor '0'x

                        (*pStateInfo).UpdateFile = !true
                        ; now update the obj file if it exists
                        if(ptr_valid((*pStateInfo).pObjList))then begin
                            (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader.focus   = byte(fix(result.focus))
                            (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader.cutoff  = byte(fix(result.cutoff))
                            (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader.crystal = byte(result.habit)
                            (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader.P1      = float(result.manual)

                            ; now write to obj file
                            ;widget_control,(*pStateInfo).ImgSliderID,get_value = frame
                            update_obj_header1,(*pStateInfo).ObjLUN, (*(*(*pStateInfo).pObjData).pImHDfPos)[index], (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                        endif


                    endif else begin
                        if(result.reject)then begin
                            (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags = $
                                (*(*(*pStateInfo).pFrameData).pFrame)[info[0]].imageheader.Flags or'8000'X

                            if(ptr_valid((*pStateInfo).pObjList))then begin
                                (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader.P1 = 1.0
                                update_obj_header1,(*pStateInfo).ObjLUN, (*(*(*pStateInfo).pObjData).pImHDfPos)[index], (*(*(*pStateInfo).pObjData).pFrame)[index].imageheader
                            endif


                            (*pStateInfo).UpdateFile = !true ; TAF look at how this is used in manualFeature.pro
                        endif
                    endelse
                    ;endif ; TAF temporarily disable manualFeature
                endif
            END   ;----------  end of right mouse press  ---------------------------------------------------------------

            else:
        endcase  ; end of event.press case statement

    endif ; (*pStateInfo).roi if block
END

1: ;button pressed no action

2: BEGIN ; Mouse moving - no buttons clicked

    if(ptr_valid((*pStateInfo).pFrameData))then begin  ; this needs to be a defined structure to continue

        ; Get ROI position and image
        x = event.x  ; these are the current mouse position
        y = event.y
        PixSize = (*pStateInfo).Settings.PixSize

        ; Increment the mouse-move counter
        (*pStateInfo).MouseCount = (*pStateInfo).MouseCount + 1

        ; the next call determines if the mouse pointer is in an ROI.  if so it returns the index of the particle, else -1
        info = GetROI(pStateInfo, x, y)



        if(info[0] eq -1)then begin
            (*pStateInfo).ROI = !false  ; indicates the mouse is NOT over an roi
            ;print,'Not over particle'
            disp_frame_info, pStateInfo, 0
            (*pStateInfo).CurrentROIIndex = -1
            ; Show the pixel coords and value
            widget_control,(*pStateInfo).infoID.ValueID,SET_VALUE = ''
            widget_control,(*pStateInfo).infoID.pixelID,SET_VALUE = ''

            ;WIDGET_CONTROL, event.top, SET_UVALUE=StateInfo, /NO_COPY
            return
        endif else begin

            ;print,'Over particle'
            (*pStateInfo).ROI = !true   ; indicates the mouse is over an roi

            ; ROIArray is an array of pointers for each particle in the frame
            ROIArray = *(*(*pStateInfo).pFrameData).pFrame

            ; get zoom factor from gui
            ;widget_control,(*pStateInfo).ZoomID,get_value = zoom
            zoom = (*pStateInfo).zoom

            ; get aspect ratio from window
            widget_control,(*pStateInfo).AspectID,get_value = YXAspect

            ;determine offset into actual array not displayed array
            ;ImgSize = size(*ROIArray[info[0]].pROI,/dim)
            dx = floor(info[1] /(zoom*YXAspect))
            dy = floor(info[2] / zoom)

            ; Redisplay ROI stats
            data = {dx:dx,dy:dy,val:0}

            ; 2014-03-28 TAF this routine errors out if no .obj file is present.  so the rest of this event handler does not get run in this case
            disp_frame_info, pStateInfo, info[0] , /full, data=data

            ; Show the pixel coords and value
            ; get value of array under cursor

            ; index of particle
            (*pStateInfo).CurrentROIIndex = info[0]

            widget_control,(*pStateInfo).infoID.ValueID, SET_VALUE = STRING(FORMAT='(i4)',data.val)
            widget_control,(*pStateInfo).infoID.pixelID, SET_VALUE = STRING(FORMAT='("(",I4,",",I4,")")', dx, dy)

            ; if harmonics_flag is set then display the harmonics and radius plots
            if((*pStateInfo).harmonics_flag and (*pStateInfo).displayPerim)then begin
                ;if(ptr_valid((*(*pStateInfo).pObjData).pFrame))then begin
                header = (*(*(*pStateInfo).pObjData).pFrame)[info[0]].imageheader
                if(ptr_valid(header.harmonics))then begin
                    distance = fft(*header.harmonics,1)
                    if((*pStateInfo).harmonicWinID eq 0)then begin
                        window,/free,xpos = 500,ypos = 30
                        (*pStateInfo).harmonicWinID = !d.window
                    endif
                    if((*pStateInfo).harmonicWinID ne 0)then begin
                        wset,(*pStateInfo).harmonicWinID
                        wshow,(*pStateInfo).harmonicWinID
                        !p.multi = [0,1,2]
                        plot,*header.harmonics, title ='Radial Harmonics',/ylog,yrange=[.01,1],psym=10,xrange=[0,20]
                        plot,distance,title = 'Radial Perimeter Distances'
                        !p.multi = 0
                        wset,(*pStateInfo).MViewID
                    endif
                endif else begin
                    if((*pStateInfo).harmonicWinID ne 0)then begin
                        wset,(*pStateInfo).harmonicWinID
                        erase
                        wset,(*pStateInfo).MViewID
                    endif
                endelse

            endif

        endelse ; particle is under mouse pointer

    endif ; valid pointer

END    ; ******************************************************************** END OF MOTION EVENT ******************

3:BEGIN; Take care of scrolling events

;ret = dialog_message('Not Reworked yet.')

END

4: ;expose event

ELSE:begin ; called for button press and exposure
message = 'error in view_event... mising case type: '+ string(event.type)
r=dialog_message(message)
END

ENDCASE ;( event.type )

END


