pro GenerateAscii, info
    ;pro SPEC_Toolbar_Save, event
    errcount = 0L


    struct_ascii = {_AsciiData, $
        AllMonths:0 , $
        NanoSeconds:0ULL , $
        Area: 0.0 , $
        Nslice: 0 , $
        L2: 0 , $
        F1: 0 , $
        Adj1: 0.0, $
        Pc1: 0.0, $
        TAS: 0.0,$    ;added more in the following on oct 14 , 2005 by mo for outputing ascii data file.
        ProbeCounter:0ULL, $
        L3: 0.0, $
        L4: 0, $
        L5: 0, $
        PC3x: 0.0, $
        PC3y: 0.0, $
        PC4x: 0.0, $
        PC4y: 0.0, $
        A3: 0.0, $
        Alexei1: 0.0, $
        Alexei2: 0L,$
        L1n:0.0   }


    struct = {_DerivedData, $
        AllMonths:0 , $
        NanoSeconds:0ULL , $
        ImageOffset: 0UL , $
        ImageWords: 0 , $
        Area: 0.0 , $
        Nslice: 0 , $
        L2: 0 , $
        F1: 0 , $
        Adj1: 0.0, $
        Pc1: 0.0, $
        TAS: 0.0,$
        L1n:0.0 }


    struct2 = {_Timestamp, $
        Year: 0, $
        Month: 0, $
        Day: 0, $
        Hours: 0, $
        Minutes: 0, $
        Seconds: 0, $
        Milliseconds: 0, $
        Microseconds: 0, $
        Nanoseconds: 0 }

    horiz_count=0
    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL
    NanosecondsPerDay    = NanosecondsPerHour * 24ULL
    ;out_array = BytArr(20000) TAF this is incorrect and should be 16L * Slices and declared before all ProcessParticles calls


    ;Widget_Control, event.top, Get_UValue=info, /No_Copy  ; get our info structure

    print, "File name is currently: ", info.currentFname
    ; Put the info structure back in its storage location.

    Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value="Opened: " + info.currentFname
    OpenR, lun, info.currentFname, /Get_Lun

    FILE_MKDIR,info.currentPname + "Data"
    OpenW, ascii_lun, info.currentPname + "Data\" + "ascii" + info.datestamp + ".txt", /Get_Lun


    DataType = 0  ; header of all record types is an integer with repeated letters
    TimingWord = UIntArr(2)
    Masks = UIntArr(16)
    HK_ints = UIntArr(48)   ; changed from 40->52 with version 5.0
    HK_timingwords = UIntArr(2)
    HK_TAS  = 0.0
    TAS = 0.0
    PartID = 0
    Slices = 0U
    WordCount =  0U
    Timestamp = { _Timestamp }
    pos = 0UL
    Area = 0UL
    Midpoint = 0
    Edges = 0
    pxs = 0.01d ; 10.0
    pxs_in_microns = 10.0D
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    strbsz = 0.01D ; 10.0

    device, CURSOR_STANDARD= !HOURGLASS_CURSOR  ; show hourglass while we process the data

    fileheader = bytarr(256)
    ReadU, lun, fileheader

    counter = 0L

    WHILE ~ EOF(lun) DO BEGIN
        counter++
        ;if counter GT 67254L then begin
        ;print, format='(Z4)',DataType
        ; print, counter
        ;end

        ReadU, lun, DataType

        CASE DataType OF
            ;----------------------------
            19789 : $
                begin
            ReadU, lun, TimingWord, Masks
            ;print , "MASK"
        end
        ;----------------------------
        16705 : $  ; TAS_HEADER_V
            BEGIN
        ReadU, lun , TAS
        ;print , "V TAS",TAS
    END
    ;----------------------------
    21588 : $  ; TAS_HEADER_H
        BEGIN
    ReadU, lun , TAS
    ;print , "H TAS", TAS
END
;----------------------------
19275 : $  ; HK_HEADER
    BEGIN
ReadU, lun , HK_ints, HK_TAS, HK_timingwords
;print , "HK", HK_TAS
END
;----------------------------
18504 : $  ; H_PARTICLE_HEADER
    BEGIN
ReadU, lun , PartID,WordCount,Slices,Timestamp

if (WordCount GE 500) then begin
    ;print, "H WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end

HImage_data = BytArr(WordCount * 2)
HSums = IntArr(Slices)
out_byte_array = BytArr(128L, Slices)

HMax  = 0
POINT_LUN, -lun, pos

ReadU, lun, HImage_data

if (Slices LT 1000) then begin
    Area = 0UL
    Err=0
    L3 = 0.0
    L4 = 0
    L5 = 0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0
    Roundness1 = 0.0
    Roundness2 = 0.0
    Roundness3 = 0.0
    L1r = 0.0
    maxLength = 0.0
    maxWidth  = 0.0
    perimeter = 0UL
    perimeterum = 0.
    csp = 0.
    num_satellites = 0.
    HorV = 'H'

    !mask_bit_filling = 0

    ProcessParticle, HImage_data, out_byte_array, Wordcount,Slices, HSums, HMax, Area, Midpoint, Edges,Err , $
        L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
        ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
        perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, HorV=HorV

    if (Err NE 0) then begin
        print, ""
    endif
    if (Err EQ 0) then begin

        Info.TotalParticles++
        ;a = string( format = '("Particles Read:" , I3)',info.TotalParticles)
        if info.TotalParticles mod 1000 EQ 0 then $
            Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value= string( format = '("Particles Read:" , I8)',info.TotalParticles)


        ;print , "H PART Slices,Max,Area",Slices,HMax,Area
        dof = 0.0D
        particle_in_microns = Slices * !MICRONS_PER_PIXELH
        dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm
        sa_actual = (127.0 +  particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])
        sa_default = 128.0 * pxs *  dww

        ; TAF note:  2014-09-23 on the 5.13 constant embedded in the code here
        ;   F_DOF = 5.13/um                              <--- Lawson 2011
        ;   2*c/lambda = 2*8/0.785um = 20.38/um <--- Lawson et al, 2006

        ;   Since the equation in the appendix of Lawson (2011) is based on
        ;   particle diameter^2, while the equation in Lawson et al (2006) is
        ;   based on particle radius^2, F_DOF needs to be multiplied by a factor
        ;   of 4 to compare directly with 2*c/lambda, which yields a difference of < 1%.




        ; dof =  (5.13 * WordCount * WordCount * strbsz * strbsz) / 1000.0D
        ; sa_actual = (127.0 + WordCount * strbsz/pxs) * pxs * min(dww,dof)
        ; sa_default = 128.0 * pxs *  dww

        ; time interval is the 32 bit tick interval times the # slices
        clock_interval = 0.000010 / TAS
        sv_default =TAS * clock_interval * sa_default
        sv_actual = TAS * clock_interval * sa_actual
        adj1 = sv_default/sv_actual

        OD = {_DerivedDataRev2}  ;OD = {_DerivedData}   changed by mo oct 14, 2005
        AD = {_AsciiData}
        AD.AllMonths = Timestamp.Year * 12 + Timestamp.Month


        AD.NanoSeconds = Timestamp.Nanoseconds + $
            (Timestamp.Microseconds * 1000ULL) + $
            (Timestamp.Milliseconds * 1000000ULL) + $
            (Timestamp.Seconds * NanosecondsPerSecond) + $
            (Timestamp.Minutes * NanosecondsPerMinute) + $
            (Timestamp.Hours * NanosecondsPerHour)


        OD.ImageOffset = pos
        OD.ImageWords = WordCount
        AD.Area = Area
        AD.Nslice = Slices
        AD.L2 = HMax
        AD.F1 = Edges
        AD.Adj1 = adj1
        AD.Pc1 = Midpoint
        AD.TAS = TAS
        AD.ProbeCounter=probeCounter
        AD.L3=L3
        AD.L4=L4
        AD.L5=L5
        AD.PC3x=PC3x
        AD.PC3y=PC3y
        AD.PC4x=PC4x
        AD.PC4y=PC4y
        AD.A3  =A3
        AD.Alexei1=Alexei1
        AD.Alexei2=0L

        OD.Roundness1 = Roundness1
        OD.Roundness2 = Roundness2
        OD.Roundness3 = Roundness3

        OD.L1r = L1r
        OD.maxLength = maxLength
        OD.maxWidth = maxWidth
        OD.perimeter = perimeter
        OD.crystal_type = crystal_type
        OD.perimeterum = perimeterum
        OD.csp = csp


        a = string(format = '(%"H %d %d %d %d %d %d %8.5g %d %8.5g %d %d %d %d %d %d %d %d %d %d %d\n")',$
            AD.AllMonths, AD.Nanoseconds, AD.Area, AD.Nslice, AD.L2, AD.F1, AD.Adj1,AD.Pc1,AD.TAS,$
            AD.ProbeCounter, 1.8*(AD.L3), AD.L4, AD.L5,AD.PC3x, AD.PC3y, AD.PC4x,AD.PC4y,AD.A3,AD.Alexei1,$
            AD.Alexei2)
        printf, ascii_lun, a

        ;         printf, ascii_lun, AD.AllMonths, AD.Nanoseconds, AD.Area, AD.Nslice, AD.L2, AD.F1, AD.Adj1, AD.Pc1, AD.TAS
        ;printf, ascii_lun, AD


        horiz_count++
        ;print, "HORIZ COUNT= " , horiz_count, "h:",Timestamp.Hours,"m:",Timestamp.Minutes, Timestamp.Seconds,Timestamp. $
        ;                        Milliseconds,Timestamp.Microseconds, Timestamp.Nanoseconds,OD.NanoSeconds, $
        ;                        "-53696508949 =",OD.NanoSeconds -  53241000000000ULL

        ;WIDGET_CONTROL ,info.statusID ,SET_VALUE="Particles Read:",TotalParticles

        ; Save the following
        ; TIMESTAMP  as [int year and 64 bit integer nanoseconds]
        ; Offset into file where image can be located    [pos]
        ; # Words in image (needed for decoding)         [WordCount]
        ; Area    (Count of all pixels)                  [HSums]
        ; Nslice      (Slice Count)                          [Slices]
        ; L2      (Widest slice)                         [HMax]
        ; F1      (Are edges set?)                       [Edges 0=none, 1=left, 2=right, 3=both]
        ; ADJ1    (Adjustment factor)                    [adj1]
        ; PC1     (midpoint of L2 slice)                 [Midpoint]
    Endif

endif else begin
    print, "Error H Slices =", Slices ,"  at ",counter
end




END
;----------------------------
22102 : $  ; V_PARTICLE_HEADER
    BEGIN
ReadU, lun , PartID,WordCount,Slices,Timestamp

if (WordCount GE 500) then begin
    ;    print, "V WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end

VImage_data = BytArr(WordCount*2)
VSums = IntArr(Slices)


out_byte_array = BytArr(128L, Slices)

VMax  = 0
POINT_LUN, -lun, pos

ReadU, lun, VImage_data
if (Slices LT 1000) then begin
    Area = 0UL
    Err=0
    L3 = 0.0
    L4 = 0
    L5 = 0
    PC3x = 0.0
    PC3y = 0.0
    PC4x = 0.0
    PC4y = 0.0
    A3 = 0.0
    Roundness1 = 0.0
    Roundness2 = 0.0
    Roundness3 = 0.0
    L1r = 0.0
    maxLength = 0.0
    maxWidth  = 0.0
    perimeter = 0UL
    perimeterum = 0.
    csp = 0.
    num_satellites = 0.
    HorV = 'V'

    !mask_bit_filling = 0

    ProcessParticle, VImage_data, out_byte_array, Wordcount,Slices, VSums, VMax, Area, Midpoint, Edges,Err , $
        L3,L4,L5,PC3x,PC3y,PC4x,PC4y,A3, Roundness1, Roundness2, Roundness3, L1r, maxLength, maxWidth, perimeter, crystal_type, perimeterum, csp, $
        ml_p1x=ml_p1x, ml_p1y=ml_p1y, ml_p2x=ml_p2x, ml_p2y=ml_p2y, mw_p1x=mw_p1x, mw_p1y=mw_p1y, mw_p2x=mw_p2x, mw_p2y=mw_p2y, $
        perimeter_points_x=perimeter_points_x, perimeter_points_y=perimeter_points_y, HorV=HorV

    Info.TotalParticles++
    if info.TotalParticles mod 1000 EQ 0 then $
        Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value= string( format = '("Particles Read:" , I8)',info.TotalParticles)

    dof = 0.0D
    particle_in_microns = Slices * !MICRONS_PER_PIXELV
    dof = (5.13 * particle_in_microns * particle_in_microns) / 1000.0D ;; convert to mm

    sa_actual = (127.0 +  particle_in_microns/pxs_in_microns) * pxs * min([dww,dof])
    sa_default = 128.0 * pxs *  dww

    ;dof = (5.13 * WordCount * WordCount * strbsz * strbsz) / 1000.0D
    ;sa_actual = (127.0 + WordCount * strbsz/pxs) * pxs * min(dww,dof)
    ;sa_default = 128.0 * pxs *  dww

    ; time interval is the 32 bit tick interval times the # slices
    clock_interval = 0.000010 / TAS
    sv_default =TAS * clock_interval * sa_default
    sv_actual = TAS * clock_interval * sa_actual
    adj1 = sv_default/sv_actual

    ; TIMESTAMP  as [int year and 64 bit integer nanoseconds]
    ; Offset into file where image can be located    [pos]
    ; # Words in image (needed for decoding)         [WordCount]
    ; Area    (Count of all pixels)                  [VSums]
    ; L1      (Slice Count)                          [Slices]
    ; L2      (Widest slice)                         [VMax]
    ; F1      (Are edges set?)                       [Edges 0=none, 1=left, 2=right, 3=both]
    ; ADJ1
    ; PC1     (midpoint of L2 slice)                 [Midpoint]
    ; TAS



    OD = {_DerivedDataRev2}   ;change by Mo Oct 14  OD = {_DerivedData}
    AD = {_AsciiData}
    AD.AllMonths = Timestamp.Year * 12 + Timestamp.Month
    AD.NanoSeconds = Timestamp.Nanoseconds + $
        Timestamp.Microseconds * 1000ULL + $
        Timestamp.Milliseconds * 1000000ULL + $
        Timestamp.Seconds * NanosecondsPerSecond + $
        Timestamp.Minutes * NanosecondsPerMinute + $
        Timestamp.Hours * NanosecondsPerHour



    OD.ImageOffset = pos
    OD.ImageWords = WordCount
    AD.Area = Area
    AD.Nslice = Slices
    AD.L2 = VMax
    AD.F1 = Edges
    AD.Adj1 = adj1
    AD.Pc1 = Midpoint
    AD.TAS = TAS
    AD.ProbeCounter=probeCounter
    AD.L3=L3
    AD.L4=L4
    AD.L5=L5
    AD.PC3x=PC3x
    AD.PC3y=PC3y
    AD.PC4x=PC4x
    AD.PC4y=PC4y
    AD.A3  =A3
    AD.Alexei1=Alexei1
    AD.Alexei2=0L

    OD.Roundness1 = Roundness1
    OD.Roundness2 = Roundness2
    OD.Roundness3 = Roundness3

    OD.L1r = L1r
    OD.maxLength = maxLength
    OD.maxWidth = maxWidth
    OD.perimeter = perimeter
    OD.crystal_type = crystal_type
    OD.perimeterum = perimeterum
    OD.csp = csp

    ;   a = string(format = '(%"V %d %d %d %d %d %d %8.5g %d %8.5g\n")', AD.AllMonths, AD.Nanoseconds, AD.Area, AD.L1, AD.L2, AD.F1, AD.Adj1,AD.Pc1,AD.TAS)
    ;   printf, ascii_lun, a
    a = string(format = '(%"V %d %d %d %d %d %d %8.5g %d %8.5g %d %d %d %d %d %d %d %d %d %d %d\n")',$
        AD.AllMonths, AD.Nanoseconds, AD.Area, AD.Nslice, AD.L2, AD.F1, AD.Adj1,AD.Pc1,AD.TAS,$
        AD.ProbeCounter, 1.8*(AD.L3), AD.L4, AD.L5,AD.PC3x, AD.PC3y, AD.PC4x,AD.PC4y,AD.A3,AD.Alexei1,$
        AD.Alexei2)
    printf, ascii_lun, a
Endif
;endif else begin
;;print, "Error, V Slices =", Slices
;endelse

END
;----------------------------
ELSE: begin
    POINT_LUN, -lun, badpos
    print , "Error, bad header in data file. Offset = ",badpos
    print, "value = ", DataType ; FLAG=0
end
ENDCASE

ENDWHILE

Close ,lun
Close ,ascii_lun




Free_Lun, lun, ascii_lun

Widget_Control, info.statusID, DYNAMIC_RESIZE=1, Set_Value= string( format = '("ASCII File Generation Completed, Particles Read:" , I8)',info.TotalParticles)

;Widget_Control, event.top, Set_UValue=info, /No_Copy


device, CURSOR_STANDARD= !ARROW_CURSOR  ; show hourglass while we process the data
end ;=========================================================================


;*****************************************************
;*****************************************************
