; File:  hexstring.pro
; Author:  Ted Fisher <ted@specinc.com> <fishnuke@gmail.com>
; Purpose:  returns a string formatted to hexidecimal, given a 32 bit or 16 bit variable
;
;
;   print, hexstring(0)
;
;   0x0000
;
;
;   print, hexstring(42)
;
;   0x002A
;
;
;   print,hexstring(-42)
;
;   0xFFD6
;
;
;
;   print,hexstring(65536)
;
;   0x00010000
;
;
;
;
;
;
; 1.0 initial version
;



function hexstring, input
    ;    if(not keyword_set(digits)) then begin
    ;        digits = 4
    ;    endif
    ;
    ;    ; determine whether to use 4, 8, or 16 digits for the output, and override with digits keyword if specified and large enough
    ;    max_value = max(input)
    ;    min_value = min(input)
    ;
    ;    if(max_value lt 65536) then begin
    ;        max_value_digits = 4
    ;    endif else if(max_value lt 4294967296) then begin
    ;        max_value_digits = 8
    ;    endif else begin
    ;        max_value_digits = 16
    ;    endelse
    ;
    ;    if(min_value lt -(2L^31-1)) then begin
    ;        min_value_digits = 16
    ;    endif else if(min_value lt -(2^15-1)) then begin
    ;        min_value_digits = 8
    ;    endif else begin
    ;        min_value_digits = 4
    ;    endelse
    ;
    ;    output_digits = max_value_digits > min_value_digits
    ;    output_digits = output_digits > digits
    ;
    ;    if(output_digits eq 4) then begin
    ;        output_format = '(%"0x%04X")'
    ;    endif else if(output_digits eq 8) then begin
    ;        output_format = '(%"0x%08X")'
    ;    endif else begin
    ;        output_format = '(%"0x%016X")'
    ;    endelse


    output_format = '(%"0x%012X")'

    retstring = string(format = output_format, input)

    ;stop

    return, retstring
end ; hexstring
