; File: ip.pro
; Author:  Ted Fisher <ted@specinc.com> <fishnuke@gmail.com>
; Purpose:  tests process_particles for specific test cases that are causing the array descriptor corrupted crash
;           when calling SPEC_2DS_process_particles.dll



pro ip, stop=stop


    for i=1, 5 do begin

        if(i eq 1) then begin
            Slices = 4
            WordCount = 4
            Image = [157, 64, 157, 64, 156, 64, 156, 64]
        endif else if(i eq 2) then begin
            Slices = 12
            WordCount = 12
            Image = [25, 65, 24, 68, 23, 69, 151, 69, 151, 69, 24, 69, 152, 68, 153, 67, 25, 67, 26, 66, 155, 65, 28, 65]
        endif else if(i eq 3) then begin
            Slices = 37
            WordCount = 27
            Image = [193,  65, 184,  64, 132,  3, 183,  70, 182,  70,  53,  71, 172,  65,   6,   7,  44,  66,   4,   8, 172,  66,   2,   8, 172,  72, 129, $
                2,  43,  73, 129,   1, 42,  75, 170,  74,  44,  67, 130,   5,  46,  66,   3,   5,  47,  66,   2,   5,  48,  66, 129,   5, 175,  72, $
                47,  72, 175,  71, 175, 71,  49,  70,  50,  69, 178,  69,  50,  69, 178,  68, 179,  67,  55,  65]
        endif else if(i eq 4) then begin
            ; (4 crashes)
            Slices = 34
            WordCount = 23
            Image = [156,  64,  28,  65, 156,  65,  25,  67, 130,   0,  25,  66,   1,   2,  24,  69,  22,  70,  20,  71,  16,  73, 143,  69,   1,   3, 142, $
                64,   2,   8, 142,  64, 129,   5, 130,   1, 142,  64, 129,   5, 130,   0, 142,  64,   1,   5, 129,   0, 142,  64,   1,   5, 143,  68, $
                143,  68, 143,  68, 143,  68, 144,  67, 144,  67,  16,  67, 145,  65]
        endif else if(i eq 5) then begin
            ; (5 crashes)
            Slices = 24
            WordCount = 13
            Image = [195,  64, 131,   0, 193,  65,   3,   1,  64,  66, 131,   1, 191,  65,   6,   1, 191,  65, 134,   1,  62,  66,   7,   1,  62,  66,   7, $
                1,  62,  66, 135,   0,  63,  66, 134,   0, 191,  66, 133,   0,  64,  66, 133,   0,  64,  66, 193,  65]


        endif

        Image = byte(Image)

        print, "i = ", i

        ;Image = BytArr(ImgWord_array(i) * 2)
        ;out_array = BytArr(20000)
        ;out_array = BytArr(20000) ; how big should this really be?  16 bytes X slices
        out_array = bytarr(16 * Slices)
        ;out_array = 0 ; TAF can get rid of out_array entirely when cleaning up?
        ;out_byte_array = BytArr(128L,L1size_array(i) + 10)
        ;out_byte_array = BytArr(128L, WordCount + 10)
        out_byte_array = BytArr(128, Slices) ; should be Slices when correct .dll addressing is going on

        ;POINT_LUN, lun, fOffsets_array(i)
        ;ReadU, lun, Image

        ;WordCount = OD.ImageWords
        ;Slices = OD.L1

        ;Slices = ImgWord_array(i)
        ;WordCount = L1size_array(i)
        ;number=imgword_array(i);  TAF can likely eliminate this as well, as it is just = Slices, after modifying HSums below
        ;HSums=intarr(number)
        HSums=intarr(Slices)
        HMax  = 0

        Sums = HSums
        Nslice = HMax

        Area = 0UL
        Midpoint = 0
        Edges = 0
        L3 = 0.0
        L4 = 0.0
        L5 = 0.0
        PC3x = 0.0
        PC3y = 0.0
        PC4x = 0.0
        PC4y = 0.0
        A3 = 0.0

        ;--------------------
        ; Wordwcount is the final length of the particle
        ; Slices is the # of integers representing the input data (will be >= Wordcount)
        ;--------------------

        Err=0

        ; assemble all variables in a big fltarr for testing communication with .dll

        n_args = 20 ; the number of arguments sent by IDL, used by the .dll as a quick sanity check

        ;expected_rettest = [n_args, Image, Sums, reform(out_byte_array, (size(out_byte_array))[4]), Wordcount, Slices, Nslice, Area, Midpoint, Edges, Err, L3, L4, L5, PC3x, PC3y, PC4x, PC4y, A3]
        ;rettest = expected_rettest
        ;rettest[*] = 0. ; initiallize and zero rettest
        ;rt_size = (size(rettest))[1]

        ;if(i eq 4 or i eq 5) then begin
        ;    stop
        ;endif

        retval = CALL_EXTERNAL('C:\fisher\SPEC\2DS\2ds_view\2dsview_ver80\SPEC_2DS_process_particles\Debug\SPEC_2DS_process_particles.dll', 'process_particles', $
            n_args,            $
            Image,          	$
            Sums,            	$
            out_array,         $
            out_byte_array, 	$
            Wordcount, 		$
            Slices,			$
            Nslice,			$
            Area,  			$
            Midpoint,			$
            Edges,		    	$
            Err,             	$
            L3,				$
            L4,				$
            L5,				$
            PC3x,			    $
            PC3y,			    $
            Pc4x,  			$
            Pc4y,	    		$
            A3,				$
            ;rt_size,           $ ; size of the rettest float array
            ;rettest,           $ ; testing .dll will copy variables to here to verify transmission
            /I_VALUE,          $
            /UNLOAD, 	        $ ; comment out /UNLOAD when not debugging
            /CDECL)

        if(retval eq -1) then begin
            print, ''
            print, "CALL_EXTERNAL on process_particles returned -1, bad number of arguments"
            print, ''
            stop
        endif

        a = out_array
        b = out_byte_array

        window, i, xs=256, ys=2*slices

        ted, b


        if(keyword_set(stop)) then begin
            stop
        endif



        ;help, Sums
        ;print, "Sums after call", Sums
        ;stop
        ;help, retval
        ;help, Slices, Nslice
        ;print, "Slices", Slices

        ;Sums = TSums2

        Catch, onError
        IF onError NE 0 THEN BEGIN
            Catch, /Cancel
            result = Error_Message(Traceback=1)
            print, "caught error in a3vcpiview call_external", onError
            ;print, "catch", HSums
            stop

            onError = 0
            ;Hsums=0
        ENDIF
    endfor

end ; ip
