;********************************************
pro  Do_Alexeis_Zd_distribution_plots, ave_info,HorV
    Common  DataBlock,alldataH,alldataV,ADataH,ADataV,FirstData,LastData,StripData,$
        FirstDataV,LastDataV,StripDataV,avestripdata,avestripdataV
    forward_function  SPEC_Nano2HMS_struct, strrepl
    ;This program finds the particle Zd distribution for Alexei size correction study.
    ;use criteria (L1 gt 10 and L4 gt 10 and L1 gt 0.65*L4 and L4 gt 0.65*L1 and reject eq 0)
    ;to select all donuts and then calculate all this particles Zd values.

    delta_s =(ave_info.endnanoseconds-ave_info.startnanoseconds)/1000000000.0
    if delta_s lt 10000.0 then  $
        delta_s ='dT='+string(delta_s,format='(F6.1)')+'s'  $
        else delta_s ='dT='+string(delta_s,format='(I6)')+'s' 

    !ZOOM_START_STRING = SPEC_Nano2HMS(ave_info.StartNanoSeconds)
    !ZOOM_END_STRING = SPEC_Nano2HMS(ave_info.EndNanoSeconds)
    plot_string =strjoin(strsplit(!ZOOM_START_STRING,':',/extract,/REGEX)) +$ ;remove ":"
        "--" + strjoin(strsplit(!ZOOM_END_STRING,':',/extract,/REGEX))

    ;start calculating the particle's Zd values.
    if HorV eq 'H' then begin
        area=(*alldataH)(*(ave_info.Hsubindex)).area
        alexei1=(*alldataH)(*(ave_info.Hsubindex)).alexei1
        DpDmRatio=sqrt(1.0-float(area)/float(alexei1))
        L1=(*alldataH)(*(ave_info.Hsubindex)).L1
        L2=(*alldataH)(*(ave_info.Hsubindex)).L2
        L4=(*alldataH)(*(ave_info.Hsubindex)).L4
        L5=(*alldataH)(*(ave_info.Hsubindex)).L5
        L7=(*alldataH)(*(ave_info.Hsubindex)).L7
        L8=(*alldataH)(*(ave_info.Hsubindex)).L8
        nanoseconds=(*alldataH)(ave_info.Hsubindex).nanoseconds
    endif
    if HorV eq 'V' then begin
        area=(*alldataV)(*(ave_info.Vsubindex)).area
        alexei1=(*alldataV)(*(ave_info.Vsubindex)).alexei1
        DpDmRatio=sqrt(1.0-float(area)/float(alexei1))
        L1=(*alldataV)(*(ave_info.Vsubindex)).L1
        L2=(*alldataV)(*(ave_info.Vsubindex)).L2
        L4=(*alldataV)(*(ave_info.Vsubindex)).L4
        L5=(*alldataV)(*(ave_info.Vsubindex)).L5
        L7=(*alldataV)(*(ave_info.Vsubindex)).L7
        L8=(*alldataV)(*(ave_info.Vsubindex)).L8
        nanoseconds=(*alldataV)(*(ave_info.Vsubindex)).nanoseconds
    endif

    outputfilename='Alexei_ZD_DpDmratio_data_'+plot_string+'_'+HorV+'.txt'
    openw,11,outputfilename
    nnn=n_elements(area)
    printf,11,'Alexei Zd Poisson spot and Dmax Ratio file of donuts particles, ',HorV,' Channel.'
    printf,11,'There are a total of ',string(nnn), ' Particles'
    printf,11,'      Time          DpDmRatio   area  Alexei1    L1      L2     L4     L5     L7     L8 '
    for i=0L, nnn-1L do begin
        time=SPEC_Nano2HMS(nanoseconds(i))
        printf,11,format='(A21,1x,F7.5,1x,F7.1,1x,F7.1,1x,6(F6.1,1x))',time,DpDmratio(i),area(i),$
            Alexei1(i),L1(i),L2(i),L4(i),L5(i),L7(i),L8(i)
    endfor
    close,11
    ;stop
end; end of Offhand_no_button_programs
;***********************************************************
