pro plot_HK_data_to_the_mainBrowse_window, ptr,marknumber
    Common HKdatablock,HKseconds,HKtas,num_hrz_dect,num_vrt_dect,pHKtimefpos,H50micron

    ;make the plots on the main window too.
    forward_function SPEC_seconds2HMS
    info=*ptr
    HKdata=*(info.pHKdata)
    Time2DS=(HKdata.nanoseconds/1000000000LL); change to seconds now.

    StartTime0=Time2DS(0)
    EndTime0  =max(Time2DS)

    my_xrange=[StartTime0, EndTime0]

    ;plot out the data and save the png files.
    fullrange =long64(EndTime0-StartTime0); delta_s; ave_info.endNanoseconds - ave_info.startNanoseconds
    binwidth = fullrange/8LL
    curbin = long64(StartTime0);  ave_info.startNanoseconds

    tnames = StrArr(9)
    FOR i=0,8 DO BEGIN
        tnames(i) =  strtrim(strmid(SPEC_seconds2HMS(curbin),0,8),2)
        curbin= curbin+binwidth
    ENDFOR
    ;-------------------------------
    ;Set up X axis tick labels.
    ;-------------------------------
    !X.TICKNAME = tnames
    !X.TICKS = 8;      !charsize=1.5
    ;********************************************************
    device, decomposed = 0
    loadct, 39, /silent

    bluecolor =120;   GetColor("Navy", !D.Table_Size-2)
    redcolor = 254; GetColor("Red", !D.Table_Size-2)
    blackcolor=10;   getColor("Black",!D.Table_Size-2)
    whitecolor =0; GetColor("White", !D.Table_Size-2)
    greencolor =170; GetColor("Green", !D.Table_Size-2)
    Purplecolor  =180;GetColor("Purple",!D.Table_Size-2)
    Pinkcolor  =230;  GetColor("Pink",!D.Table_Size-2)

    Widget_Control, info.drawidbrowse, Get_Value=wid  ; get the window ID for drawing.
    WSet, wid
    ;erase,color='ffffff'x  ; get background to white

    !P.MULTI = [0, 1,1, 0, 0]
    !X.OMARGIN = [1.5,0.0]  ;We need this because the Area plot X axis label extends off the left edge of the window

    basefile=file_basename(info.currentFname);  basefile

    index=indgen(n_elements(Time2DS)/10)*10

    PLOT, Time2DS,HKdata.hrz_pd, COLOR=bluecolor,Xrange = my_xrange,background= whitecolor,Ylog=1,YTICKFORMAT='My_yticks',yminor=9, charsize=1.0,$
        TITLE='2DS Raw Particle Event Number per Second'+'      File:  '+basefile + ' -----TAS(m/s) on Right Axis', THICK=1, $
        YRANGE=[1.,1.05*max([max(HKdata.hrz_pd),max(HKdata.vrt_pd)])], xticks=8, xminor=5,$
        pos=[0.05,0.12,0.97,0.87],xmargin=[3,0],YSTYLE=1,xstyle=1;$xtitle='time'
    oplot,Time2DS,HKdata.vrt_pd,color=redcolor

    if marknumber eq 1 then begin
        oplot,[info.StartTime,info.StartTime],[0.1,1.05*max([max(HKdata.hrz_pd),max(HKdata.vrt_pd)])],color=greencolor
    endif

    if marknumber eq 2 then begin
        oplot,[info.StartTime,info.StartTime],[0.1,1.05*max([max(HKdata.hrz_pd),max(HKdata.vrt_pd)])],color=greencolor
        oplot,[info.EndTime,info.EndTime],[0.1,1.05*max([max(HKdata.hrz_pd),max(HKdata.vrt_pd)])],color=redcolor
    endif

    xyouts,0.002,0.35,'H(#)',color=bluecolor,/normal,charsize=1.0,orient=0
    xyouts,0.002,0.55,'V(#)',color=redcolor,/normal,charsize=1.0,orient=0

    ;added TAS plot for convenient to see the status of clould penetration.
    axis, yrange=[1.0, max(HKtas+10.0)], /yst, yaxis = 1, /save, ytitle=' ',Ylog=0 ; set up the right axis for dead time
    oplot,HKseconds,HKtas, color = 180, linestyle=1

    ;******************************************************************************************************************************************


end; ;end of plot_HKdata_to_maiN_widnow,pHKdata
;*****************************************************************************************
;*****************************************************************************************
function SPEC_seconds2HMS, ns
    ; accepts ULL values of seconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    orig_ns = ns

    secondsPerMinute =60ULL
    secondsPerHour   = secondsPerMinute * 60ULL

    hours=ns/secondsPerHour
    if hours GT 0 then  ns = ns - (hours * secondsPerHour)
    minutes=ns/secondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * secondsPerMinute)
    seconds=ns

    a = string(format = '(%"%2.2d:%2.2d:%2.2d")',hours,minutes,seconds)

    ns = orig_ns

    return,a

end
;*****************************************************

;*****************************************************************************************
function SPEC_seconds2HHMMSS, ns
    ; accepts ULL values of seconds
    ; returns string of HH:MM:SS.mmm.mmm.nnn

    orig_ns = ns

    secondsPerMinute =60ULL
    secondsPerHour   = secondsPerMinute * 60ULL

    hours=ns/secondsPerHour
    if hours GT 0 then  ns = ns - (hours * secondsPerHour)
    minutes=ns/secondsPerMinute
    if minutes GT 0 then  ns = ns - (minutes * secondsPerMinute)
    seconds=ns

    a = string(format = '(%"%2.2d%2.2d%2.2d")',hours,minutes,seconds)

    ns = orig_ns

    return,a

end
;*****************************************************


;*****************************************************
function My_yticks,axis,index,value
    k=round(alog10(value))
    if k eq -1 then return, '0.10'
    if k eq -2 then return, '0.01'
    if k eq -3 then return, '.001'
    if k eq 0  then return, '1.00'
    if k ge 1  then return, '10^'+strtrim(string(k),2)

    ;return,'10^'+k;    ; use of this function is:   plot,y,ytickformat='My_yticks'
end;  end of My_yticks
