Pro plot_current_1Hz_ascii_file_data, infilename
    ;filename=dialog_pickfile(filter='*Archive_3V2DS_*.txt',get_path=pathnm)
    ;read in the data
    read_in_2ds_data_from_small_1Hz_archive_61bins,TDsData,pathnm,infilename,filename
    substrs=strsplit(filename,'_',/extract)
    yyyymmdd='20'+strmid(substrs(4),0,6);  % basename= V_Archive_2DS_PSD_100119234142_000000_001351_0000_M1.txt
    defsysv,'!yyyymmdd',yyyymmdd
    HorV=strmid(filename,0,1)
    mmm=n_elements(TDSdata.seconds)

    Seconds=TDSdata.seconds;  or not.
    SV  =TDSdata.sv
    Conc=    TDSdata.Hconc
    extn=    TDSdata.Hextn
    iwc =    TDSdata.HIWC
    acceptPcnt=  TDSdata.HtotN
    irregularN=  TDSdata.HIrrN
    numbmeanD=   TDSdata.numbmeanD
    medianVolD=  TDSdata.medianVolD
    effectiveD = TDSdata.effectiveD
    totalcount=  TDSdata.totalcounts

    EndTime  =max(TDSdata.seconds); get the last seconds of the first file.
    StartTime   =min(TDSdata.seconds)
    Get_2DS_MEAN_PSDs_from_time1_to_Time2,StartTime,EndTime,TDSdata,NPsdx,EPsdx,MPsdx

    GetHHMMSS_from_MidNightSEconds,StartTime, TimeS_str, hhj, mmj, ssj
    GetHHMMSS_from_MidNightSEconds,EndTime, TimeE_str, hhj, mmj, ssj

    make_61_bins,nbins,nedges,xpts,dbl_binwidths

    ; get the time axis labels.

    fullrange = 0ULL
    binwidth = 0ULL ; ;fullrange = local_LastData.Nanoseconds - local_FirstData.Nanoseconds
    fullrange = (EndTime - StartTime)*1000000000LL
    binwidth = fullrange/8
    curbin = StartTime*1000000000LL
    tnames = StrArr(9)
    FOR i=0,8 DO BEGIN
        tnames(i) =  strtrim(strmid(SPEC_Nano2HMS(curbin),0,12),2)
        curbin += binwidth
    ENDFOR
    ;-------------------------------
    ;Set up X axis tick labels.
    ;-------------------------------
    !X.TICKNAME = tnames
    !X.TICKS = 8
    ;********************************************************

    window,1,  xs=2*72*8.0, ys=72*10.5
    !P.multi=[0,1,7]
    bluecolor =GetColor("Navy", !D.Table_Size-2)
    redcolor =GetColor("Red", !D.Table_Size-2)
    blackcolor= getcolor('Black',!D.Table_Size-2)
    whitecolor = GetColor("White", !D.Table_Size - 2)
    erase,color='ffffff'x  ; get background to white


    vector=TDSdata.Hconc
    TDS_seconds=TDSdata.seconds

    ymax=10.0^ceil(alog10(max(vector)))
    indexno=where(vector gt 0.0,contGno)
    if contGno gt 0 then begin
        ymin=min(vector(indexno))
        ymin=10.0^floor(alog10(ymin)) 
    endif else ymin=0.01*ymax

    if n_elements(TDS_seconds) eq 1 then begin
        return
    endif

    ; Plot 1 of 7
    plot,TDS_seconds,TDSdata.Hconc,color=blackcolor,ylog=1,ytitle='#/L',ystyle=1,$
        Yrange=[ymin,ymax],charsize=2.0,position=[0.08,0.87,0.96,0.97],$
        title='Fig.1'+HorV+': 2DS Time Series for File: '+filename, background=whitecolor
    ;oplot,TDS_seconds,TDSdataV.Hconc,color=bluecolor

    ; Plot 2 of 7
    vector=[TDSdata.Hextn]
    ymax=10.0^ceil(alog10(max(vector)))
    indexno=where(vector gt 0.0,contGno)
    if contGno gt 0 then begin
        ymin=min(vector(indexno))
        ymin=10.0^floor(alog10(ymin)) 
    endif else ymin=0.01*ymax

    plot,TDS_seconds,TDSdata.Hextn,color=blackcolor,ylog=1,ytitle='1/km',ystyle=1,xtickname=replicate(' ',9),$
        Yrange=[ymin,ymax],charsize=2.0,position=[0.08,0.74,0.96,0.84], background=whitecolor
    ;oplot,TDS_seconds,TDSdataV.Hextn,color=bluecolor

    vector=[TDSdata.Hiwc]
    ymax=10.0^ceil(alog10(max(vector)))
    indexno=where(vector gt 0.0,contGno)
    if contGno gt 0 then begin
        ymin=min(vector(indexno))
        ymin=10.0^floor(alog10(ymin)) 
    endif else ymin=0.01*ymax

    ; plot 3 of 7
    plot,TDS_seconds,TDSdata.Hiwc,color=blackcolor,ylog=1,ytitle='mg/L',ystyle=1,$
        Yrange=[ymin,ymax],charsize=2.0,position=[0.08,0.61,0.96,0.71],background=whitecolor
    ;oplot,TDS_seconds,TDSdata.Hiwc,color=bluecolor
    xyouts,0.06,0.01,'StartTime:'+TimeS_str,color=Redcolor,/normal,charsize=1.0
    xyouts,0.77,0.01,'EndTime:'+TimeE_str,color=Redcolor,/normal,charsize=1.0

    ;plot 4
    vector=[sv]
    ymax=10.0^ceil(alog10(max(vector)))
    indexno=where(vector gt 0.0,contGno)
    if contGno gt 0 then begin
        ymin=min(vector(indexno))
        ymin=10.0^floor(alog10(ymin)) 
    endif else ymin=0.01*ymax

    plot,TDS_seconds,TDSdata.sv,color=blackcolor,ylog=0,ytitle='SV(L)',ystyle=1,xtickname=replicate(' ',9),$
        Yrange=[ymin,ymax],charsize=2.0,position=[0.08,0.47,0.96,0.57], background=whitecolor
    ;oplot,TDS_seconds,TDSdata.Hiwc,color=bluecolor


    ;plot 5
    vector=[NumbmeanD, MedianVolD, effectiveD]
    ymax=max(vector)

    plot,TDS_seconds,NumbmeanD,color=blackcolor,ylog=0,ytitle='Size(um)',ystyle=1,$
        Yrange=[0.0,ymax+4],charsize=2.0,position=[0.08,0.34,0.96,0.44],background=whitecolor,xtickname=''
    oplot,TDS_seconds,medianVolD,color=bluecolor
    oplot,TDS_seconds,effectiveD,color=Redcolor
    xyouts,0.13,0.45,'Number mean Diameter ', color=blackcolor, /normal
    xyouts,0.43,0.45,'Median volume Diameter ', color=bluecolor, /normal
    xyouts,0.83,0.45,'Effective Diameter ', color=Redcolor, /normal

    ;plot 6  ;acceptPcnt=  TDSdata.HtotN
    ;irregularN=  TDSdata.HIrrN
    vector=[acceptPcnt]
    ymax=10.0^ceil(alog10(max(vector)))
    indexno=where(vector gt 0.0,contGno)
    if contGno gt 0 then begin
        ymin=min(vector(indexno))
        ymin=10.0^floor(alog10(ymin)) 
    endif else ymin=0.01*ymax

    plot,TDS_seconds,acceptPCnt,color=blackcolor,ylog=0,ytitle='accept%',ystyle=1,xtickname=replicate(' ',9),$
        Yrange=[0,110.0],charsize=2.0,position=[0.08,0.21,0.96,0.31],background=whitecolor

    ;plot 7  ;irregularN=  TDSdata.HIrrN  totalcounts.
    vector=[irregularN,totalcount]
    ymax=max(vector)

    plot,TDS_seconds,irregularN,color=blackcolor,ylog=0,ytitle='totalN, irrN',ystyle=1,$
        xtitle='Time,seconds',Yrange=[0,ymax+4],charsize=2.0,position=[0.08,0.08,0.96,0.18],background=whitecolor
    oplot,TDS_seconds,totalcount,color=Redcolor
    write_jpeg,pathnm+strmid(filename,0,strlen(filename)-4)+'_tms.jpg',tvrd(true=1),true=1

    ;****************************************************************************************
    !X.TICKNAME =['1','10','100','1000','10000']
    !X.TICKS =0
    window,2, xs=10*72, ys=10*72
    !P.multi=[0,1,1]

    vector=[Npsdx,Epsdx,Mpsdx]
    indexj=where(vector gt 0.0, contG)
    if contG gt 0 then  ymin=min(vector(indexj)) else ymin=0.001

    ymax=max([Npsdx,Epsdx,MPSDX]>0.0)

    if ymax eq 0.0  then ymax=1.0

    ymin=10.0^floor(Alog10(ymin))
    ymax=10.0^ceil(Alog10(ymax))
    xpts(0)=5
    ;make Npsd double values array.
    Hyptsx=fltarr(122)
    Hyptsy=fltarr(122)
    Hyptsz=fltarr(122)
    for i=0LL,60LL do begin
        Hyptsx(2*i:2*i+1)=Npsdx(i)
        Hyptsy(2*i:2*i+1)=Epsdx(i)
        Hyptsz(2*i:2*i+1)=Mpsdx(i)
    endfor

    index=where(Hyptsx gt 0.0, contG)
    if contG gt 0 then begin
        PLOT, xpts, Hyptsx, COLOR=blackcolor, XRANGE=[1,10000], /Xlog, position=[0.10,0.1, 0.84,0.8],/normal,$
            Xstyle = 1, YLOG=1,xtitle='Particle Size(um)', $;  TITLE='Fig2 '+HorV+' 2DS Mean Psd for file:  '+filename,$
            THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0, background=whitecolor,$
            YTITLE='#/L/um,1/km/um,g/m3/um';  Yticks=ytikn,Ytickn=myticknames
        OPLOT, xpts, Hyptsy, COLOR=redcolor
        OPLOT, xpts, Hyptsz, COLOR=bluecolor
        xyouts,0.3, 0.84, 'Fig2 '+HorV+' 2DS Mean PSD ',color=blackcolor,/normal
        xyouts,0.15, 0.81, 'File: '+filename,color=blackcolor,/normal
    endif else begin
        PLOT, xpts, Hyptsx, COLOR=blackcolor, XRANGE=[1,10000], /Xlog, position=[0.10,0.1, 0.84,0.8],/normal,$
            Xstyle = 1, YLOG=1,xtitle='Particle Size(um)', $;  TITLE='Fig2 '+HorV+' 2DS Mean Psd for file:  '+filename,$
            THICK=1, YRANGE=[ymin, ymax],ystyle=1, charsize=1.0, background=whitecolor,/nodata,$
            YTITLE='#/L/um,1/km/um,g/m3/um';  Yticks=ytikn,Ytickn=myticknames
        ; OPLOT, xpts, Hyptsy, COLOR=redcolor
        ; OPLOT, xpts, Hyptsz, COLOR=bluecolor
        xyouts,0.3, 0.84, 'Fig2 '+HorV+' 2DS Mean PSD ',color=blackcolor,/normal
        xyouts,0.15, 0.81, 'File: '+filename,color=blackcolor,/normal
        xyouts,0.35,0.33,'No data',color=redcolor,/normal
    endelse



    write_jpeg,pathnm+strmid(filename,0,strlen(filename)-4)+'_psd.jpg',tvrd(true=1),true=1
    wdelete,1,2

    ;copy the current_1Hz_data fiel to teh Mx folder for later on the stitch them all together after the batch processing is done.
    substrsF=strsplit(!currentHFname,'\',/extract)
    up_pathnm=strjoin(substrsF(0:n_elements(substrsF)-3),'\')+'\'
    folder_name=up_pathnm+'all_'+!autoarchive_method+'_files'
    FILE_MKDIR,folder_name
    file_copy,infilename,folder_name+'\'+filename,/overwrite

    if !autoarchive_method eq 'M1' then begin
        QCfile =strmid(infilename,0,strlen(infilename)-4)+'QC.txt'
        QCbasefilename=file_basename(QCfile)

        if(file_test(QCfile)) then begin
            file_copy,QCfile,folder_name+'\'+QCbasefilename,/overwrite
        endif else begin
            print, 'QCfile: ', QCfile, ' does not exist, need to fix copy logic in plot_current_1Hz_ascii_file_data.pro line ~224'
        endelse
    endif


end;plot_current_1Hz_ascii_file_data, inputfile


;**********************************************************************************************
pro read_in_2ds_data_from_small_1Hz_archive_61bins,TDsData,pathnm,infilename,filename
    ;filename=dialog_pickfile(filter='Archive_2DS_*Ns.txt',get_path=pathnm)
    ;find out how many line is in the file.

    ;get the first hours to see if the file is after-midnight or before midnight.
    basefile=file_basename(infilename)
    substrs=strsplit(basefile,'_',/extract)
    yymmddhhmmss=substrs(4)
    hh=strmid(yymmddhhmmss,6,2)
    pathnm=file_dirname(infilename)+'\'

    if hh*1 ge 24.0 then begin
        print,'This file is after mindnight, ',basefile
        offset_seconds=86400LL
        stop
    endif else begin
        offset_seconds=0LL
    endelse


    data=read_ascii(infilename,count=n_lines)
    nnnseconds=(n_lines-2)
    junk=strarr(2)
    openr,2,infilename
    readf,2,junk
    ;check teh eheader line to see f it is True or False fo rthe 25 icron
    Result = STREGEX( junk(0), 'H50Micron = True',/EXTRACT)
    if strmatch(Result,'H50Micron = True')  eq 0 then Hchannel_resolution =10.0
    if strmatch(Result,'H50Micron = True')  eq 1 then Hchannel_resolution =50.0

    ;find out how many cloumns the data file has,  if it is more than 255 columns, it is files with bincounts.
    This_line_string='aaaaa'
    readf,2,This_line_string
    substrs=strsplit(This_line_string,' ',/extract)
    nnn_column=n_elements(substrs)
    if nnn_column eq 198 then begin
        close,2
        openr,2,infilename
        readf,2,junk
        Data={seconds:0LL,HtotN:0,HirrN:0.0,sv:0.0,Hconc:0.0,Hextn:0.0,HIWC:0.0,H0t50:0.0,H50t0250:0.0,Hgt250:0.0,$
            Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
            Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
            Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
            Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
            Hbin33:0.0,Hbin34:0.0,Hbin35:0.0,Hbin36:0.0,Hbin37:0.0,Hbin38:0.0,Hbin39:0.0,Hbin40:0.0,$
            Hbin41:0.0,Hbin42:0.0,Hbin43:0.0,Hbin44:0.0,Hbin45:0.0,Hbin46:0.0,Hbin47:0.0,Hbin48:0.0,$
            Hbin49:0.0,Hbin50:0.0,Hbin51:0.0,Hbin52:0.0,Hbin53:0.0,Hbin54:0.0,Hbin55:0.0,Hbin56:0.0,$
            Hbin57:0.0,Hbin58:0.0,Hbin59:0.0,Hbin60:0.0,Hbin61:0.0,$

            Hebin1:0.0,Hebin2:0.0,Hebin3:0.0,Hebin4:0.0,Hebin5:0.0,Hebin6:0.0,Hebin7:0.0,Hebin8:0.0,$
            Hebin9:0.0,Hebin10:0.0,Hebin11:0.0,Hebin12:0.0,Hebin13:0.0,Hebin14:0.0,Hebin15:0.0,Hebin16:0.0,$
            Hebin17:0.0,Hebin18:0.0,Hebin19:0.0,Hebin20:0.0,Hebin21:0.0,Hebin22:0.0,Hebin23:0.0,Hebin24:0.0,$
            Hebin25:0.0,Hebin26:0.0,Hebin27:0.0,Hebin28:0.0,Hebin29:0.0,Hebin30:0.0,Hebin31:0.0,Hebin32:0.0,$
            Hebin33:0.0,Hebin34:0.0,Hebin35:0.0,Hebin36:0.0,Hebin37:0.0,Hebin38:0.0,Hebin39:0.0,Hebin40:0.0,$
            Hebin41:0.0,Hebin42:0.0,Hebin43:0.0,Hebin44:0.0,Hebin45:0.0,Hebin46:0.0,Hebin47:0.0,Hebin48:0.0,$
            Hebin49:0.0,Hebin50:0.0,Hebin51:0.0,Hebin52:0.0,Hebin53:0.0,Hebin54:0.0,Hebin55:0.0,Hebin56:0.0,$
            Hebin57:0.0,Hebin58:0.0,Hebin59:0.0,Hebin60:0.0,Hebin61:0.0,$

            Hmbin1:0.0,Hmbin2:0.0,Hmbin3:0.0,Hmbin4:0.0,Hmbin5:0.0,Hmbin6:0.0,Hmbin7:0.0,Hmbin8:0.0,$
            Hmbin9:0.0,Hmbin10:0.0,Hmbin11:0.0,Hmbin12:0.0,Hmbin13:0.0,Hmbin14:0.0,Hmbin15:0.0,Hmbin16:0.0,$
            Hmbin17:0.0,Hmbin18:0.0,Hmbin19:0.0,Hmbin20:0.0,Hmbin21:0.0,Hmbin22:0.0,Hmbin23:0.0,Hmbin24:0.0,$
            Hmbin25:0.0,Hmbin26:0.0,Hmbin27:0.0,Hmbin28:0.0,Hmbin29:0.0,Hmbin30:0.0,Hmbin31:0.0,Hmbin32:0.0,$
            Hmbin33:0.0,Hmbin34:0.0,Hmbin35:0.0,Hmbin36:0.0,Hmbin37:0.0,Hmbin38:0.0,Hmbin39:0.0,Hmbin40:0.0,$
            Hmbin41:0.0,Hmbin42:0.0,Hmbin43:0.0,Hmbin44:0.0,Hmbin45:0.0,Hmbin46:0.0,Hmbin47:0.0,Hmbin48:0.0,$
            Hmbin49:0.0,Hmbin50:0.0,Hmbin51:0.0,Hmbin52:0.0,Hmbin53:0.0,Hmbin54:0.0,Hmbin55:0.0,Hmbin56:0.0,$
            Hmbin57:0.0,Hmbin58:0.0,Hmbin59:0.0,Hmbin60:0.0,Hmbin61:0.0,$
            HM1bin24:0.0,HM1bin25:0.0,HM1bin26:0.0,$
            HM2cnt265:0.0,VM1gt315:0.0 $
            }

        TDsData=replicate(data,nnnseconds)
        readf,2,TDsData
        close,2

        TDSdata.seconds=TDSdata.seconds+offset_seconds;   added on Jan. 22, 2010.

        ;assign teh last bin to be zero.
        TDSdata.Hbin61=fltarr(nnnseconds)
        TDSdata.Hebin61=fltarr(nnnseconds)
        TDSdata.Hmbin61=fltarr(nnnseconds)

        substrs=strsplit(infilename,'\',/extract)
        filename=substrs(n_elements(substrs)-1)
        defsysv,'!File_with_binCounts',0
    endif

    if nnn_column eq 255 then begin
        close,2
        openr,2,infilename
        readf,2,junk
        Data={seconds:0LL,HtotN:0,HirrN:0.0,sv:0.0,Hconc:0.0,Hextn:0.0,HIWC:0.0,NumbMeanD:0.0,MedianVolD:0.0,EffectiveD:0.0,$
            Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
            Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
            Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
            Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
            Hbin33:0.0,Hbin34:0.0,Hbin35:0.0,Hbin36:0.0,Hbin37:0.0,Hbin38:0.0,Hbin39:0.0,Hbin40:0.0,$
            Hbin41:0.0,Hbin42:0.0,Hbin43:0.0,Hbin44:0.0,Hbin45:0.0,Hbin46:0.0,Hbin47:0.0,Hbin48:0.0,$
            Hbin49:0.0,Hbin50:0.0,Hbin51:0.0,Hbin52:0.0,Hbin53:0.0,Hbin54:0.0,Hbin55:0.0,Hbin56:0.0,$
            Hbin57:0.0,Hbin58:0.0,Hbin59:0.0,Hbin60:0.0,Hbin61:0.0,$

            Hebin1:0.0,Hebin2:0.0,Hebin3:0.0,Hebin4:0.0,Hebin5:0.0,Hebin6:0.0,Hebin7:0.0,Hebin8:0.0,$
            Hebin9:0.0,Hebin10:0.0,Hebin11:0.0,Hebin12:0.0,Hebin13:0.0,Hebin14:0.0,Hebin15:0.0,Hebin16:0.0,$
            Hebin17:0.0,Hebin18:0.0,Hebin19:0.0,Hebin20:0.0,Hebin21:0.0,Hebin22:0.0,Hebin23:0.0,Hebin24:0.0,$
            Hebin25:0.0,Hebin26:0.0,Hebin27:0.0,Hebin28:0.0,Hebin29:0.0,Hebin30:0.0,Hebin31:0.0,Hebin32:0.0,$
            Hebin33:0.0,Hebin34:0.0,Hebin35:0.0,Hebin36:0.0,Hebin37:0.0,Hebin38:0.0,Hebin39:0.0,Hebin40:0.0,$
            Hebin41:0.0,Hebin42:0.0,Hebin43:0.0,Hebin44:0.0,Hebin45:0.0,Hebin46:0.0,Hebin47:0.0,Hebin48:0.0,$
            Hebin49:0.0,Hebin50:0.0,Hebin51:0.0,Hebin52:0.0,Hebin53:0.0,Hebin54:0.0,Hebin55:0.0,Hebin56:0.0,$
            Hebin57:0.0,Hebin58:0.0,Hebin59:0.0,Hebin60:0.0,Hebin61:0.0,$

            Hmbin1:0.0,Hmbin2:0.0,Hmbin3:0.0,Hmbin4:0.0,Hmbin5:0.0,Hmbin6:0.0,Hmbin7:0.0,Hmbin8:0.0,$
            Hmbin9:0.0,Hmbin10:0.0,Hmbin11:0.0,Hmbin12:0.0,Hmbin13:0.0,Hmbin14:0.0,Hmbin15:0.0,Hmbin16:0.0,$
            Hmbin17:0.0,Hmbin18:0.0,Hmbin19:0.0,Hmbin20:0.0,Hmbin21:0.0,Hmbin22:0.0,Hmbin23:0.0,Hmbin24:0.0,$
            Hmbin25:0.0,Hmbin26:0.0,Hmbin27:0.0,Hmbin28:0.0,Hmbin29:0.0,Hmbin30:0.0,Hmbin31:0.0,Hmbin32:0.0,$
            Hmbin33:0.0,Hmbin34:0.0,Hmbin35:0.0,Hmbin36:0.0,Hmbin37:0.0,Hmbin38:0.0,Hmbin39:0.0,Hmbin40:0.0,$
            Hmbin41:0.0,Hmbin42:0.0,Hmbin43:0.0,Hmbin44:0.0,Hmbin45:0.0,Hmbin46:0.0,Hmbin47:0.0,Hmbin48:0.0,$
            Hmbin49:0.0,Hmbin50:0.0,Hmbin51:0.0,Hmbin52:0.0,Hmbin53:0.0,Hmbin54:0.0,Hmbin55:0.0,Hmbin56:0.0,$
            Hmbin57:0.0,Hmbin58:0.0,Hmbin59:0.0,Hmbin60:0.0,Hmbin61:0.0,$

            Hnbin1:0.0,Hnbin2:0.0,Hnbin3:0.0,Hnbin4:0.0,Hnbin5:0.0,Hnbin6:0.0,Hnbin7:0.0,Hnbin8:0.0,$
            Hnbin9:0.0,Hnbin10:0.0,Hnbin11:0.0,Hnbin12:0.0,Hnbin13:0.0,Hnbin14:0.0,Hnbin15:0.0,Hnbin16:0.0,$
            Hnbin17:0.0,Hnbin18:0.0,Hnbin19:0.0,Hnbin20:0.0,Hnbin21:0.0,Hnbin22:0.0,Hnbin23:0.0,Hnbin24:0.0,$
            Hnbin25:0.0,Hnbin26:0.0,Hnbin27:0.0,Hnbin28:0.0,Hnbin29:0.0,Hnbin30:0.0,Hnbin31:0.0,Hnbin32:0.0,$
            Hnbin33:0.0,Hnbin34:0.0,Hnbin35:0.0,Hnbin36:0.0,Hnbin37:0.0,Hnbin38:0.0,Hnbin39:0.0,Hnbin40:0.0,$
            Hnbin41:0.0,Hnbin42:0.0,Hnbin43:0.0,Hnbin44:0.0,Hnbin45:0.0,Hnbin46:0.0,Hnbin47:0.0,Hnbin48:0.0,$
            Hnbin49:0.0,Hnbin50:0.0,Hnbin51:0.0,Hnbin52:0.0,Hnbin53:0.0,Hnbin54:0.0,Hnbin55:0.0,Hnbin56:0.0,$
            Hnbin57:0.0,Hnbin58:0.0,Hnbin59:0.0,Hnbin60:0.0,Hnbin61:0.0, totalcounts:0.0 $
            }

        TDsData=replicate(data,nnnseconds)
        readf,2,TDsData
        close,2

        TDSdata.seconds=TDSdata.seconds+offset_seconds;   added on Jan. 22, 2010.

        ;assign teh last bin to be zero.
        TDSdata.Hbin61=fltarr(nnnseconds)
        TDSdata.Hebin61=fltarr(nnnseconds)
        TDSdata.Hmbin61=fltarr(nnnseconds)

        substrs=strsplit(infilename,'\',/extract)
        filename=substrs(n_elements(substrs)-1)
        defsysv,'!File_with_binCounts',1
    endif


end; end of read_in_2ds_data_from_1Hz_archive_61bins.



pro Secs_To_Times,secs,time

    temp=floor( long(secs)/(24l*3600l) )
    temp=long(secs)-temp*(24l*3600l)
    tempHH=floor( temp/3600l )
    temp=temp-tempHH*3600L
    tempMM=floor( temp/60l )
    tempSS=temp-tempMM*60L
    if tempHH lt 10 then HH='0'+strtrim(long(tempHH),2) else HH=strtrim(long(tempHH),2)
    if tempMM lt 10 then MM='0'+strtrim(long(tempMM),2) else MM=strtrim(long(tempMM),2)
    if tempSS lt 10 then SS='0'+strtrim(long(tempSS),2) else SS=strtrim(long(tempSS),2)
    time=HH+':'+MM+':'+SS
end;******************
;**********************************************************



;**********************************************************************************************
pro read_in_2ds_data_from_1Hz_archive_61bins,TDsData,pathnm,filename
    ;filename=dialog_pickfile(filter='Archive_2DS_*Ns.txt',get_path=pathnm)
    ;find out how many line is in the file.
    if !file_with_bincounts eq 0 then begin
        data=read_ascii(filename,count=n_lines)
        ;nnnseconds=(n_lines-4)
        ;junk=strarr(4)
        nnnseconds=(n_lines-0LL)/19LL
        junk=strarr(4)
        openr,2,filename
        ;readf,2,junk
        Data={seconds:0LL,sv:0.0,Hconc:0.0,Hextn:0.0,HIWC:0,HirrN:0.0,H0T50:0.0,H50T0250:0.0,HGT250:0.0,$
            Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
            Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
            Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
            Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
            Hbin33:0.0,Hbin34:0.0,Hbin35:0.0,Hbin36:0.0,Hbin37:0.0,Hbin38:0.0,Hbin39:0.0,Hbin40:0.0,$
            Hbin41:0.0,Hbin42:0.0,Hbin43:0.0,Hbin44:0.0,Hbin45:0.0,Hbin46:0.0,Hbin47:0.0,Hbin48:0.0,$
            Hbin49:0.0,Hbin50:0.0,Hbin51:0.0,Hbin52:0.0,Hbin53:0.0,Hbin54:0.0,Hbin55:0.0,Hbin56:0.0,$
            Hbin57:0.0,Hbin58:0.0,Hbin59:0.0,Hbin60:0.0,Hbin61:0.0,$

            Hebin1:0.0,Hebin2:0.0,Hebin3:0.0,Hebin4:0.0,Hebin5:0.0,Hebin6:0.0,Hebin7:0.0,Hebin8:0.0,$
            Hebin9:0.0,Hebin10:0.0,Hebin11:0.0,Hebin12:0.0,Hebin13:0.0,Hebin14:0.0,Hebin15:0.0,Hebin16:0.0,$
            Hebin17:0.0,Hebin18:0.0,Hebin19:0.0,Hebin20:0.0,Hebin21:0.0,Hebin22:0.0,Hebin23:0.0,Hebin24:0.0,$
            Hebin25:0.0,Hebin26:0.0,Hebin27:0.0,Hebin28:0.0,Hebin29:0.0,Hebin30:0.0,Hebin31:0.0,Hebin32:0.0,$
            Hebin33:0.0,Hebin34:0.0,Hebin35:0.0,Hebin36:0.0,Hebin37:0.0,Hebin38:0.0,Hebin39:0.0,Hebin40:0.0,$
            Hebin41:0.0,Hebin42:0.0,Hebin43:0.0,Hebin44:0.0,Hebin45:0.0,Hebin46:0.0,Hebin47:0.0,Hebin48:0.0,$
            Hebin49:0.0,Hebin50:0.0,Hebin51:0.0,Hebin52:0.0,Hebin53:0.0,Hebin54:0.0,Hebin55:0.0,Hebin56:0.0,$
            Hebin57:0.0,Hebin58:0.0,Hebin59:0.0,Hebin60:0.0,Hebin61:0.0,$

            Hmbin1:0.0,Hmbin2:0.0,Hmbin3:0.0,Hmbin4:0.0,Hmbin5:0.0,Hmbin6:0.0,Hmbin7:0.0,Hmbin8:0.0,$
            Hmbin9:0.0,Hmbin10:0.0,Hmbin11:0.0,Hmbin12:0.0,Hmbin13:0.0,Hmbin14:0.0,Hmbin15:0.0,Hmbin16:0.0,$
            Hmbin17:0.0,Hmbin18:0.0,Hmbin19:0.0,Hmbin20:0.0,Hmbin21:0.0,Hmbin22:0.0,Hmbin23:0.0,Hmbin24:0.0,$
            Hmbin25:0.0,Hmbin26:0.0,Hmbin27:0.0,Hmbin28:0.0,Hmbin29:0.0,Hmbin30:0.0,Hmbin31:0.0,Hmbin32:0.0,$
            Hmbin33:0.0,Hmbin34:0.0,Hmbin35:0.0,Hmbin36:0.0,Hmbin37:0.0,Hmbin38:0.0,Hmbin39:0.0,Hmbin40:0.0,$
            Hmbin41:0.0,Hmbin42:0.0,Hmbin43:0.0,Hmbin44:0.0,Hmbin45:0.0,Hmbin46:0.0,Hmbin47:0.0,Hmbin48:0.0,$
            Hmbin49:0.0,Hmbin50:0.0,Hmbin51:0.0,Hmbin52:0.0,Hmbin53:0.0,Hmbin54:0.0,Hmbin55:0.0,Hmbin56:0.0,$
            Hmbin57:0.0,Hmbin58:0.0,Hmbin59:0.0,Hmbin60:0.0,Hmbin61:0.0}


        TDsData=replicate(data,nnnseconds)
        readf,2,TDsData
        close,2
        substrs=strsplit(filename,'\',/extract)
        filename=substrs(n_elements(substrs)-1)
    endif

    if !file_with_bincounts eq 1 then begin

        data=read_ascii(filename,count=n_lines)

        nnnseconds=(n_lines-0LL)/25LL
        junk=strarr(4)
        openr,2,filename
        ;readf,2,junk
        Data={seconds:0LL,sv:0.0,Hconc:0.0,Hextn:0.0,HIWC:0,HirrN:0.0,nummeanD:0.0,medianVolD:0.0,effectiveD:0.0,$
            Hbin1:0.0,Hbin2:0.0,Hbin3:0.0,Hbin4:0.0,Hbin5:0.0,Hbin6:0.0,Hbin7:0.0,Hbin8:0.0,$
            Hbin9:0.0,Hbin10:0.0,Hbin11:0.0,Hbin12:0.0,Hbin13:0.0,Hbin14:0.0,Hbin15:0.0,Hbin16:0.0,$
            Hbin17:0.0,Hbin18:0.0,Hbin19:0.0,Hbin20:0.0,Hbin21:0.0,Hbin22:0.0,Hbin23:0.0,Hbin24:0.0,$
            Hbin25:0.0,Hbin26:0.0,Hbin27:0.0,Hbin28:0.0,Hbin29:0.0,Hbin30:0.0,Hbin31:0.0,Hbin32:0.0,$
            Hbin33:0.0,Hbin34:0.0,Hbin35:0.0,Hbin36:0.0,Hbin37:0.0,Hbin38:0.0,Hbin39:0.0,Hbin40:0.0,$
            Hbin41:0.0,Hbin42:0.0,Hbin43:0.0,Hbin44:0.0,Hbin45:0.0,Hbin46:0.0,Hbin47:0.0,Hbin48:0.0,$
            Hbin49:0.0,Hbin50:0.0,Hbin51:0.0,Hbin52:0.0,Hbin53:0.0,Hbin54:0.0,Hbin55:0.0,Hbin56:0.0,$
            Hbin57:0.0,Hbin58:0.0,Hbin59:0.0,Hbin60:0.0,Hbin61:0.0,$

            Hebin1:0.0,Hebin2:0.0,Hebin3:0.0,Hebin4:0.0,Hebin5:0.0,Hebin6:0.0,Hebin7:0.0,Hebin8:0.0,$
            Hebin9:0.0,Hebin10:0.0,Hebin11:0.0,Hebin12:0.0,Hebin13:0.0,Hebin14:0.0,Hebin15:0.0,Hebin16:0.0,$
            Hebin17:0.0,Hebin18:0.0,Hebin19:0.0,Hebin20:0.0,Hebin21:0.0,Hebin22:0.0,Hebin23:0.0,Hebin24:0.0,$
            Hebin25:0.0,Hebin26:0.0,Hebin27:0.0,Hebin28:0.0,Hebin29:0.0,Hebin30:0.0,Hebin31:0.0,Hebin32:0.0,$
            Hebin33:0.0,Hebin34:0.0,Hebin35:0.0,Hebin36:0.0,Hebin37:0.0,Hebin38:0.0,Hebin39:0.0,Hebin40:0.0,$
            Hebin41:0.0,Hebin42:0.0,Hebin43:0.0,Hebin44:0.0,Hebin45:0.0,Hebin46:0.0,Hebin47:0.0,Hebin48:0.0,$
            Hebin49:0.0,Hebin50:0.0,Hebin51:0.0,Hebin52:0.0,Hebin53:0.0,Hebin54:0.0,Hebin55:0.0,Hebin56:0.0,$
            Hebin57:0.0,Hebin58:0.0,Hebin59:0.0,Hebin60:0.0,Hebin61:0.0,$

            Hmbin1:0.0,Hmbin2:0.0,Hmbin3:0.0,Hmbin4:0.0,Hmbin5:0.0,Hmbin6:0.0,Hmbin7:0.0,Hmbin8:0.0,$
            Hmbin9:0.0,Hmbin10:0.0,Hmbin11:0.0,Hmbin12:0.0,Hmbin13:0.0,Hmbin14:0.0,Hmbin15:0.0,Hmbin16:0.0,$
            Hmbin17:0.0,Hmbin18:0.0,Hmbin19:0.0,Hmbin20:0.0,Hmbin21:0.0,Hmbin22:0.0,Hmbin23:0.0,Hmbin24:0.0,$
            Hmbin25:0.0,Hmbin26:0.0,Hmbin27:0.0,Hmbin28:0.0,Hmbin29:0.0,Hmbin30:0.0,Hmbin31:0.0,Hmbin32:0.0,$
            Hmbin33:0.0,Hmbin34:0.0,Hmbin35:0.0,Hmbin36:0.0,Hmbin37:0.0,Hmbin38:0.0,Hmbin39:0.0,Hmbin40:0.0,$
            Hmbin41:0.0,Hmbin42:0.0,Hmbin43:0.0,Hmbin44:0.0,Hmbin45:0.0,Hmbin46:0.0,Hmbin47:0.0,Hmbin48:0.0,$
            Hmbin49:0.0,Hmbin50:0.0,Hmbin51:0.0,Hmbin52:0.0,Hmbin53:0.0,Hmbin54:0.0,Hmbin55:0.0,Hmbin56:0.0,$
            Hmbin57:0.0,Hmbin58:0.0,Hmbin59:0.0,Hmbin60:0.0,Hmbin61:0.0,$

            Hnbin1:0.0,Hnbin2:0.0,Hnbin3:0.0,Hnbin4:0.0,Hnbin5:0.0,Hnbin6:0.0,Hnbin7:0.0,Hnbin8:0.0,$
            Hnbin9:0.0,Hnbin10:0.0,Hnbin11:0.0,Hnbin12:0.0,Hnbin13:0.0,Hnbin14:0.0,Hnbin15:0.0,Hnbin16:0.0,$
            Hnbin17:0.0,Hnbin18:0.0,Hnbin19:0.0,Hnbin20:0.0,Hnbin21:0.0,Hnbin22:0.0,Hnbin23:0.0,Hnbin24:0.0,$
            Hnbin25:0.0,Hnbin26:0.0,Hnbin27:0.0,Hnbin28:0.0,Hnbin29:0.0,Hnbin30:0.0,Hnbin31:0.0,Hnbin32:0.0,$
            Hnbin33:0.0,Hnbin34:0.0,Hnbin35:0.0,Hnbin36:0.0,Hnbin37:0.0,Hnbin38:0.0,Hnbin39:0.0,Hnbin40:0.0,$
            Hnbin41:0.0,Hnbin42:0.0,Hnbin43:0.0,Hnbin44:0.0,Hnbin45:0.0,Hnbin46:0.0,Hnbin47:0.0,Hnbin48:0.0,$
            Hnbin49:0.0,Hnbin50:0.0,Hnbin51:0.0,Hnbin52:0.0,Hnbin53:0.0,Hnbin54:0.0,Hnbin55:0.0,Hnbin56:0.0,$
            Hnbin57:0.0,Hnbin58:0.0,Hnbin59:0.0,Hnbin60:0.0,Hnbin61:0.0,totalcounts:0.0}


        TDsData=replicate(data,nnnseconds)
        readf,2,TDsData
        close,2
        substrs=strsplit(filename,'\',/extract)
        filename=substrs(n_elements(substrs)-1)
    endif




    ;TDSdata(0).HirrN=TDSData(0).HirrN
    ;TDSdata(nnnseconds-1).HirrN=TDSData(nnnseconds-1).HirrN

end; end of read_in_2ds_data_from_1Hz_archive_61bins.


pro make_61_bins,nbins,nedges,xpts,dbl_binwidths
    nbins=61
    nedges=2*nbins
    xpts=dblarr(2*nbins)
    xpts(0)=5.0
    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =5.0+(i+1)*10.0
    endfor
    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =205.0+(i-19)*20.0
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =505.0+(i-34)*50.0
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =1005.0+(i-44)*100.0
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =2005.0+(i-54)*200.0
    endfor
    xpts(121)=xpts(120)+200.0; to make last bin-width=200.0um
    dbl_binwidths=xpts(1:*)-xpts(0:120)
    dbl_binwidths=[dbl_binwidths,0.0]
    xpts(121)=100000.0;    but hin here group anything greater that 3005 to be the last bin.
    xpts(0) =0.001
end; end of make_61_bins
;***********************************************************************

;**************************************************************
pro Get_2DS_MEAN_PSDs_from_time1_to_Time2,Time1,time2,TDSdata,NPts,EPts,MPts

    Npts=fltarr(61)
    Epts=fltarr(61)
    Mpts=fltarr(61)
    TSDdata0=TDSdata

    ;zeros those missing values of 9.9E+9 to zero before getting mean values.
    myvalues=TDSdata.Hbin1
    indexmiss=where(myvalues eq 9.999E+30 or myvalues lt 0.0 ,contmiss)
    if contMiss gt 0 then begin
        TDSdata(indexmiss).Hbin1=0.0
        TDSdata(indexmiss).Hbin2=0.0
        TDSdata(indexmiss).Hbin3=0.0
        TDSdata(indexmiss).Hbin4=0.0
        TDSdata(indexmiss).Hbin5=0.0
        TDSdata(indexmiss).Hbin6=0.0
        TDSdata(indexmiss).Hbin7=0.0
        TDSdata(indexmiss).Hbin8=0.0
        TDSdata(indexmiss).Hbin9=0.0
        TDSdata(indexmiss).Hbin10=0.0
        TDSdata(indexmiss).Hbin11=0.0
        TDSdata(indexmiss).Hbin12=0.0
        TDSdata(indexmiss).Hbin13=0.0
        TDSdata(indexmiss).Hbin14=0.0
        TDSdata(indexmiss).Hbin15=0.0
        TDSdata(indexmiss).Hbin16=0.0
        TDSdata(indexmiss).Hbin17=0.0
        TDSdata(indexmiss).Hbin18=0.0
        TDSdata(indexmiss).Hbin19=0.0
        TDSdata(indexmiss).Hbin20=0.0
        TDSdata(indexmiss).Hbin21=0.0
        TDSdata(indexmiss).Hbin22=0.0
        TDSdata(indexmiss).Hbin23=0.0
        TDSdata(indexmiss).Hbin24=0.0
        TDSdata(indexmiss).Hbin25=0.0
        TDSdata(indexmiss).Hbin26=0.0
        TDSdata(indexmiss).Hbin27=0.0
        TDSdata(indexmiss).Hbin28=0.0
        TDSdata(indexmiss).Hbin29=0.0
        TDSdata(indexmiss).Hbin30=0.0
        TDSdata(indexmiss).Hbin31=0.0
        TDSdata(indexmiss).Hbin32=0.0
        TDSdata(indexmiss).Hbin33=0.0
        TDSdata(indexmiss).Hbin34=0.0
        TDSdata(indexmiss).Hbin35=0.0
        TDSdata(indexmiss).Hbin36=0.0
        TDSdata(indexmiss).Hbin37=0.0
        TDSdata(indexmiss).Hbin38=0.0
        TDSdata(indexmiss).Hbin39=0.0
        TDSdata(indexmiss).Hbin40=0.0
        TDSdata(indexmiss).Hbin41=0.0
        TDSdata(indexmiss).Hbin42=0.0
        TDSdata(indexmiss).Hbin43=0.0
        TDSdata(indexmiss).Hbin44=0.0
        TDSdata(indexmiss).Hbin45=0.0
        TDSdata(indexmiss).Hbin46=0.0
        TDSdata(indexmiss).Hbin47=0.0
        TDSdata(indexmiss).Hbin48=0.0
        TDSdata(indexmiss).Hbin49=0.0
        TDSdata(indexmiss).Hbin50=0.0
        TDSdata(indexmiss).Hbin51=0.0
        TDSdata(indexmiss).Hbin52=0.0
        TDSdata(indexmiss).Hbin53=0.0
        TDSdata(indexmiss).Hbin54=0.0
        TDSdata(indexmiss).Hbin55=0.0
        TDSdata(indexmiss).Hbin56=0.0
        TDSdata(indexmiss).Hbin57=0.0
        TDSdata(indexmiss).Hbin58=0.0
        TDSdata(indexmiss).Hbin59=0.0
        TDSdata(indexmiss).Hbin60=0.0
        TDSdata(indexmiss).Hbin61=0.0

        TDSdata(indexmiss).Hebin1=0.0
        TDSdata(indexmiss).Hebin2=0.0
        TDSdata(indexmiss).Hebin3=0.0
        TDSdata(indexmiss).Hebin4=0.0
        TDSdata(indexmiss).Hebin5=0.0
        TDSdata(indexmiss).Hebin6=0.0
        TDSdata(indexmiss).Hebin7=0.0
        TDSdata(indexmiss).Hebin8=0.0
        TDSdata(indexmiss).Hebin9=0.0
        TDSdata(indexmiss).Hebin10=0.0
        TDSdata(indexmiss).Hebin11=0.0
        TDSdata(indexmiss).Hebin12=0.0
        TDSdata(indexmiss).Hebin13=0.0
        TDSdata(indexmiss).Hebin14=0.0
        TDSdata(indexmiss).Hebin15=0.0
        TDSdata(indexmiss).Hebin16=0.0
        TDSdata(indexmiss).Hebin17=0.0
        TDSdata(indexmiss).Hebin18=0.0
        TDSdata(indexmiss).Hebin19=0.0
        TDSdata(indexmiss).Hebin20=0.0
        TDSdata(indexmiss).Hebin21=0.0
        TDSdata(indexmiss).Hebin22=0.0
        TDSdata(indexmiss).Hebin23=0.0
        TDSdata(indexmiss).Hebin24=0.0
        TDSdata(indexmiss).Hebin25=0.0
        TDSdata(indexmiss).Hebin26=0.0
        TDSdata(indexmiss).Hebin27=0.0
        TDSdata(indexmiss).Hebin28=0.0
        TDSdata(indexmiss).Hebin29=0.0
        TDSdata(indexmiss).Hebin30=0.0
        TDSdata(indexmiss).Hebin31=0.0
        TDSdata(indexmiss).Hebin32=0.0
        TDSdata(indexmiss).Hebin33=0.0
        TDSdata(indexmiss).Hebin34=0.0
        TDSdata(indexmiss).Hebin35=0.0
        TDSdata(indexmiss).Hebin36=0.0
        TDSdata(indexmiss).Hebin37=0.0
        TDSdata(indexmiss).Hebin38=0.0
        TDSdata(indexmiss).Hebin39=0.0
        TDSdata(indexmiss).Hebin40=0.0
        TDSdata(indexmiss).Hebin41=0.0
        TDSdata(indexmiss).Hebin42=0.0
        TDSdata(indexmiss).Hebin43=0.0
        TDSdata(indexmiss).Hebin44=0.0
        TDSdata(indexmiss).Hebin45=0.0
        TDSdata(indexmiss).Hebin46=0.0
        TDSdata(indexmiss).Hebin47=0.0
        TDSdata(indexmiss).Hebin48=0.0
        TDSdata(indexmiss).Hebin49=0.0
        TDSdata(indexmiss).Hebin50=0.0
        TDSdata(indexmiss).Hebin51=0.0
        TDSdata(indexmiss).Hebin52=0.0
        TDSdata(indexmiss).Hebin53=0.0
        TDSdata(indexmiss).Hebin54=0.0
        TDSdata(indexmiss).Hebin55=0.0
        TDSdata(indexmiss).Hebin56=0.0
        TDSdata(indexmiss).Hebin57=0.0
        TDSdata(indexmiss).Hebin58=0.0
        TDSdata(indexmiss).Hebin59=0.0
        TDSdata(indexmiss).Hebin60=0.0
        TDSdata(indexmiss).Hebin61=0.0

        TDSdata(indexmiss).Hmbin1=0.0
        TDSdata(indexmiss).Hmbin2=0.0
        TDSdata(indexmiss).Hmbin3=0.0
        TDSdata(indexmiss).Hmbin4=0.0
        TDSdata(indexmiss).Hmbin5=0.0
        TDSdata(indexmiss).Hmbin6=0.0
        TDSdata(indexmiss).Hmbin7=0.0
        TDSdata(indexmiss).Hmbin8=0.0
        TDSdata(indexmiss).Hmbin9=0.0
        TDSdata(indexmiss).Hmbin10=0.0
        TDSdata(indexmiss).Hmbin11=0.0
        TDSdata(indexmiss).Hmbin12=0.0
        TDSdata(indexmiss).Hmbin13=0.0
        TDSdata(indexmiss).Hmbin14=0.0
        TDSdata(indexmiss).Hmbin15=0.0
        TDSdata(indexmiss).Hmbin16=0.0
        TDSdata(indexmiss).Hmbin17=0.0
        TDSdata(indexmiss).Hmbin18=0.0
        TDSdata(indexmiss).Hmbin19=0.0
        TDSdata(indexmiss).Hmbin20=0.0
        TDSdata(indexmiss).Hmbin21=0.0
        TDSdata(indexmiss).Hmbin22=0.0
        TDSdata(indexmiss).Hmbin23=0.0
        TDSdata(indexmiss).Hmbin24=0.0
        TDSdata(indexmiss).Hmbin25=0.0
        TDSdata(indexmiss).Hmbin26=0.0
        TDSdata(indexmiss).Hmbin27=0.0
        TDSdata(indexmiss).Hmbin28=0.0
        TDSdata(indexmiss).Hmbin29=0.0
        TDSdata(indexmiss).Hmbin30=0.0
        TDSdata(indexmiss).Hmbin31=0.0
        TDSdata(indexmiss).Hmbin32=0.0
        TDSdata(indexmiss).Hmbin33=0.0
        TDSdata(indexmiss).Hmbin34=0.0
        TDSdata(indexmiss).Hmbin35=0.0
        TDSdata(indexmiss).Hmbin36=0.0
        TDSdata(indexmiss).Hmbin37=0.0
        TDSdata(indexmiss).Hmbin38=0.0
        TDSdata(indexmiss).Hmbin39=0.0
        TDSdata(indexmiss).Hmbin40=0.0
        TDSdata(indexmiss).Hmbin41=0.0
        TDSdata(indexmiss).Hmbin42=0.0
        TDSdata(indexmiss).Hmbin43=0.0
        TDSdata(indexmiss).Hmbin44=0.0
        TDSdata(indexmiss).Hmbin45=0.0
        TDSdata(indexmiss).Hmbin46=0.0
        TDSdata(indexmiss).Hmbin47=0.0
        TDSdata(indexmiss).Hmbin48=0.0
        TDSdata(indexmiss).Hmbin49=0.0
        TDSdata(indexmiss).Hmbin50=0.0
        TDSdata(indexmiss).Hmbin51=0.0
        TDSdata(indexmiss).Hmbin52=0.0
        TDSdata(indexmiss).Hmbin53=0.0
        TDSdata(indexmiss).Hmbin54=0.0
        TDSdata(indexmiss).Hmbin55=0.0
        TDSdata(indexmiss).Hmbin56=0.0
        TDSdata(indexmiss).Hmbin57=0.0
        TDSdata(indexmiss).Hmbin58=0.0
        TDSdata(indexmiss).Hmbin59=0.0
        TDSdata(indexmiss).Hmbin60=0.0
        TDSdata(indexmiss).Hmbin61=0.0
    endif;  end if tehre is missing data .

    ;original data.
    seconds=Tdsdata.seconds
    index=where(seconds  ge time1 and seconds le time2,contG)
    if contG gt 0 then begin
        Npts(0)=mean(TDSdata(index).Hbin1>0.0)
        Npts(1)=mean(TDSdata(index).Hbin2>0.0)
        Npts(2)=mean(TDSdata(index).Hbin3>0.0)
        Npts(3)=mean(TDSdata(index).Hbin4>0.0)
        Npts(4)=mean(TDSdata(index).Hbin5>0.0)
        Npts(5)=mean(TDSdata(index).Hbin6>0.0)
        Npts(6)=mean(TDSdata(index).Hbin7>0.0)
        Npts(7)=mean(TDSdata(index).Hbin8>0.0)
        Npts(8)=mean(TDSdata(index).Hbin9>0.0)
        Npts(9)=mean(TDSdata(index).Hbin10>0.0)
        Npts(10)=mean(TDSdata(index).Hbin11>0.0)
        Npts(11)=mean(TDSdata(index).Hbin12>0.0)
        Npts(12)=mean(TDSdata(index).Hbin13>0.0)
        Npts(13)=mean(TDSdata(index).Hbin14>0.0)
        Npts(14)=mean(TDSdata(index).Hbin15>0.0)
        Npts(15)=mean(TDSdata(index).Hbin16>0.0)
        Npts(16)=mean(TDSdata(index).Hbin17>0.0)
        Npts(17)=mean(TDSdata(index).Hbin18>0.0)
        Npts(18)=mean(TDSdata(index).Hbin19>0.0)
        Npts(19)=mean(TDSdata(index).Hbin21>0.0)
        Npts(20)=mean(TDSdata(index).Hbin20>0.0)
        Npts(21)=mean(TDSdata(index).Hbin22>0.0)
        Npts(22)=mean(TDSdata(index).Hbin23>0.0)
        Npts(23)=mean(TDSdata(index).Hbin24>0.0)
        Npts(24)=mean(TDSdata(index).Hbin25>0.0)
        Npts(25)=mean(TDSdata(index).Hbin26>0.0)
        Npts(26)=mean(TDSdata(index).Hbin27>0.0)
        Npts(27)=mean(TDSdata(index).Hbin28>0.0)
        Npts(28)=mean(TDSdata(index).Hbin29>0.0)
        Npts(29)=mean(TDSdata(index).Hbin30>0.0)
        Npts(30)=mean(TDSdata(index).Hbin31>0.0)
        Npts(31)=mean(TDSdata(index).Hbin32>0.0)
        Npts(32)=mean(TDSdata(index).Hbin33>0.0)
        Npts(33)=mean(TDSdata(index).Hbin34>0.0)
        Npts(34)=mean(TDSdata(index).Hbin35>0.0)
        Npts(35)=mean(TDSdata(index).Hbin36>0.0)
        Npts(36)=mean(TDSdata(index).Hbin37>0.0)
        Npts(37)=mean(TDSdata(index).Hbin38>0.0)
        Npts(38)=mean(TDSdata(index).Hbin39>0.0)
        Npts(39)=mean(TDSdata(index).Hbin40>0.0)
        Npts(40)=mean(TDSdata(index).Hbin41>0.0)
        Npts(41)=mean(TDSdata(index).Hbin42>0.0)
        Npts(42)=mean(TDSdata(index).Hbin43>0.0)
        Npts(43)=mean(TDSdata(index).Hbin44>0.0)
        Npts(44)=mean(TDSdata(index).Hbin45>0.0)
        Npts(45)=mean(TDSdata(index).Hbin46>0.0)
        Npts(46)=mean(TDSdata(index).Hbin47>0.0)
        Npts(47)=mean(TDSdata(index).Hbin48>0.0)
        Npts(48)=mean(TDSdata(index).Hbin49>0.0)
        Npts(49)=mean(TDSdata(index).Hbin50>0.0)
        Npts(50)=mean(TDSdata(index).Hbin51>0.0)
        Npts(51)=mean(TDSdata(index).Hbin52>0.0)
        Npts(52)=mean(TDSdata(index).Hbin53>0.0)
        Npts(53)=mean(TDSdata(index).Hbin54>0.0)
        Npts(54)=mean(TDSdata(index).Hbin55>0.0)
        Npts(55)=mean(TDSdata(index).Hbin56>0.0)
        Npts(56)=mean(TDSdata(index).Hbin57>0.0)
        Npts(57)=mean(TDSdata(index).Hbin58>0.0)
        Npts(58)=mean(TDSdata(index).Hbin59>0.0)
        Npts(59)=mean(TDSdata(index).Hbin60>0.0)
        Npts(60)=mean(TDSdata(index).Hbin61>0.0)

        Epts(0)=mean(TDsdata(index).Hebin1>0.0)
        Epts(1)=mean(TDSdata(index).Hebin2>0.0)
        Epts(2)=mean(TDSdata(index).Hebin3>0.0)
        Epts(3)=mean(TDSdata(index).Hebin4>0.0)
        Epts(4)=mean(TDSdata(index).Hebin5>0.0)
        Epts(5)=mean(TDSdata(index).Hebin6>0.0)
        Epts(6)=mean(TDSdata(index).Hebin7>0.0)
        Epts(7)=mean(TDSdata(index).Hebin8>0.0)
        Epts(8)=mean(TDSdata(index).Hebin9>0.0)
        Epts(9)=mean(TDSdata(index).Hebin10>0.0)
        Epts(10)=mean(TDSdata(index).Hebin11>0.0)
        Epts(11)=mean(TDSdata(index).Hebin12>0.0)
        Epts(12)=mean(TDSdata(index).Hebin13>0.0)
        Epts(13)=mean(TDSdata(index).Hebin14>0.0)
        Epts(14)=mean(TDSdata(index).Hebin15>0.0)
        Epts(15)=mean(TDSdata(index).Hebin16>0.0)
        Epts(16)=mean(TDSdata(index).Hebin17>0.0)
        Epts(17)=mean(TDSdata(index).Hebin18>0.0)
        Epts(18)=mean(TDSdata(index).Hebin19>0.0)
        Epts(19)=mean(TDSdata(index).Hebin21>0.0)
        Epts(20)=mean(TDSdata(index).Hebin20>0.0)
        Epts(21)=mean(TDSdata(index).Hebin22>0.0)
        Epts(22)=mean(TDSdata(index).Hebin23>0.0)
        Epts(23)=mean(TDSdata(index).Hebin24>0.0)
        Epts(24)=mean(TDSdata(index).Hebin25>0.0)
        Epts(25)=mean(TDSdata(index).Hebin26>0.0)
        Epts(26)=mean(TDSdata(index).Hebin27>0.0)
        Epts(27)=mean(TDSdata(index).Hebin28>0.0)
        Epts(28)=mean(TDSdata(index).Hebin29>0.0)
        Epts(29)=mean(TDSdata(index).Hebin30>0.0)
        Epts(30)=mean(TDSdata(index).Hebin31>0.0)
        Epts(31)=mean(TDSdata(index).Hebin32>0.0)
        Epts(32)=mean(TDSdata(index).Hebin33>0.0)
        Epts(33)=mean(TDSdata(index).Hebin34>0.0)
        Epts(34)=mean(TDSdata(index).Hebin35>0.0)
        Epts(35)=mean(TDSdata(index).Hebin36>0.0)
        Epts(36)=mean(TDSdata(index).Hebin37>0.0)
        Epts(37)=mean(TDSdata(index).Hebin38>0.0)
        Epts(38)=mean(TDSdata(index).Hebin39>0.0)
        Epts(39)=mean(TDSdata(index).Hebin40>0.0)
        Epts(40)=mean(TDSdata(index).Hebin41>0.0)
        Epts(41)=mean(TDSdata(index).Hebin42>0.0)
        Epts(42)=mean(TDSdata(index).Hebin43>0.0)
        Epts(43)=mean(TDSdata(index).Hebin44>0.0)
        Epts(44)=mean(TDSdata(index).Hebin45>0.0)
        Epts(45)=mean(TDSdata(index).Hebin46>0.0)
        Epts(46)=mean(TDSdata(index).Hebin47>0.0)
        Epts(47)=mean(TDSdata(index).Hebin48>0.0)
        Epts(48)=mean(TDSdata(index).Hebin49>0.0)
        Epts(49)=mean(TDSdata(index).Hebin50>0.0)
        Epts(50)=mean(TDSdata(index).Hebin51>0.0)
        Epts(51)=mean(TDSdata(index).Hebin52>0.0)
        Epts(52)=mean(TDSdata(index).Hebin53>0.0)
        Epts(53)=mean(TDSdata(index).Hebin54>0.0)
        Epts(54)=mean(TDSdata(index).Hebin55>0.0)
        Epts(55)=mean(TDSdata(index).Hebin56>0.0)
        Epts(56)=mean(TDSdata(index).Hebin57>0.0)
        Epts(57)=mean(TDSdata(index).Hebin58>0.0)
        Epts(58)=mean(TDSdata(index).Hebin59>0.0)
        Epts(59)=mean(TDSdata(index).Hebin60>0.0)
        Epts(60)=mean(TDSdata(index).Hebin61>0.0)

        Mpts(0)=mean(TDsdata(index).Hmbin1>0.0)
        Mpts(1)=mean(TDSdata(index).Hmbin2>0.0)
        Mpts(2)=mean(TDSdata(index).Hmbin3>0.0)
        Mpts(3)=mean(TDSdata(index).Hmbin4>0.0)
        Mpts(4)=mean(TDSdata(index).Hmbin5>0.0)
        Mpts(5)=mean(TDSdata(index).Hmbin6>0.0)
        Mpts(6)=mean(TDSdata(index).Hmbin7>0.0)
        Mpts(7)=mean(TDSdata(index).Hmbin8>0.0)
        Mpts(8)=mean(TDSdata(index).Hmbin9>0.0)
        Mpts(9)=mean(TDSdata(index).Hmbin10>0.0)
        Mpts(10)=mean(TDSdata(index).Hmbin11>0.0)
        Mpts(11)=mean(TDSdata(index).Hmbin12>0.0)
        Mpts(12)=mean(TDSdata(index).Hmbin13>0.0)
        Mpts(13)=mean(TDSdata(index).Hmbin14>0.0)
        Mpts(14)=mean(TDSdata(index).Hmbin15>0.0)
        Mpts(15)=mean(TDSdata(index).Hmbin16>0.0)
        Mpts(16)=mean(TDSdata(index).Hmbin17>0.0)
        Mpts(17)=mean(TDSdata(index).Hmbin18>0.0)
        Mpts(18)=mean(TDSdata(index).Hmbin19>0.0)
        Mpts(19)=mean(TDSdata(index).Hmbin21>0.0)
        Mpts(20)=mean(TDSdata(index).Hmbin20>0.0)
        Mpts(21)=mean(TDSdata(index).Hmbin22>0.0)
        Mpts(22)=mean(TDSdata(index).Hmbin23>0.0)
        Mpts(23)=mean(TDSdata(index).Hmbin24>0.0)
        Mpts(24)=mean(TDSdata(index).Hmbin25>0.0)
        Mpts(25)=mean(TDSdata(index).Hmbin26>0.0)
        Mpts(26)=mean(TDSdata(index).Hmbin27>0.0)
        Mpts(27)=mean(TDSdata(index).Hmbin28>0.0)
        Mpts(28)=mean(TDSdata(index).Hmbin29>0.0)
        Mpts(29)=mean(TDSdata(index).Hmbin30>0.0)
        Mpts(30)=mean(TDSdata(index).Hmbin31>0.0)
        Mpts(31)=mean(TDSdata(index).Hmbin32>0.0)
        Mpts(32)=mean(TDSdata(index).Hmbin33>0.0)
        Mpts(33)=mean(TDSdata(index).Hmbin34>0.0)
        Mpts(34)=mean(TDSdata(index).Hmbin35>0.0)
        Mpts(35)=mean(TDSdata(index).Hmbin36>0.0)
        Mpts(36)=mean(TDSdata(index).Hmbin37>0.0)
        Mpts(37)=mean(TDSdata(index).Hmbin38>0.0)
        Mpts(38)=mean(TDSdata(index).Hmbin39>0.0)
        Mpts(39)=mean(TDSdata(index).Hmbin40>0.0)
        Mpts(40)=mean(TDSdata(index).Hmbin41>0.0)
        Mpts(41)=mean(TDSdata(index).Hmbin42>0.0)
        Mpts(42)=mean(TDSdata(index).Hmbin43>0.0)
        Mpts(43)=mean(TDSdata(index).Hmbin44>0.0)
        Mpts(44)=mean(TDSdata(index).Hmbin45>0.0)
        Mpts(45)=mean(TDSdata(index).Hmbin46>0.0)
        Mpts(46)=mean(TDSdata(index).Hmbin47>0.0)
        Mpts(47)=mean(TDSdata(index).Hmbin48>0.0)
        Mpts(48)=mean(TDSdata(index).Hmbin49>0.0)
        Mpts(49)=mean(TDSdata(index).Hmbin50>0.0)
        Mpts(50)=mean(TDSdata(index).Hmbin51>0.0)
        Mpts(51)=mean(TDSdata(index).Hmbin52>0.0)
        Mpts(52)=mean(TDSdata(index).Hmbin53>0.0)
        Mpts(53)=mean(TDSdata(index).Hmbin54>0.0)
        Mpts(54)=mean(TDSdata(index).Hmbin55>0.0)
        Mpts(55)=mean(TDSdata(index).Hmbin56>0.0)
        Mpts(56)=mean(TDSdata(index).Hmbin57>0.0)
        Mpts(57)=mean(TDSdata(index).Hmbin58>0.0)
        Mpts(58)=mean(TDSdata(index).Hmbin59>0.0)
        Mpts(59)=mean(TDSdata(index).Hmbin60>0.0)
        Mpts(60)=mean(TDSdata(index).Hmbin61>0.0)
    endif
    TDSdata=TSDdata0

end;  end of Get_2DS_MEAN_PSDs_from_time1_to_Time2,Time1,time2,TDSdat,NPts,EPts,MPts


pro GetHHMMSS_from_MidNightSEconds, seconds, HHMMSS, hh, mm, ss
    hh=seconds/3600LL
    mm=(seconds mod 3600LL)/60LL
    SS=seconds mod 60LL
    if hh lt 10 then HHstr='0'+strtrim(string(hh),2) else HHstr=strtrim(string(hh),2)
    if mm lt 10 then MMstr='0'+strtrim(string(MM),2) else MMstr=strtrim(string(MM),2)
    if SS lt 10 then SSstr='0'+strtrim(string(ss),2) else SSstr=strtrim(string(ss),2)
    HHMMSS=HHstr+":"+MMStr+":"+SSstr
end; end of  GetHHMMSS_from_MidNightSEconds, seconds, HHMMSS, hh, mm, ss


;+
; NAME:
;    ERROR_MESSAGE

; PURPOSE:

;    The purpose of this function  is to have a device-independent
;    error messaging function. The error message is reported
;    to the user by using DIALOG_MESSAGE if widgets are
;    supported and MESSAGE otherwise.

;    In general, the ERROR_MESSAGE function is not called directly.
;    Rather, it is used in a CATCH error handler. Errors are thrown
;    to ERROR_MESSAGE with the MESSAGE command. A typical CATCH error
;    handler is shown below.

;       Catch, theError
;       IF theError NE 0 THEN BEGIN
;          Catch, /Cancel
;          ok = Error_Message(/Traceback, /Error)
;          RETURN
;       ENDIF

;    Error messages would get into the ERROR_MESSAGE function by
;    throwing an error with the MESSAGE command, like this:

;       IF test NE 1 THEN Message, 'The test failed.'

; AUTHOR:

;   FANNING SOFTWARE CONSULTING
;   David Fanning, Ph.D.
;   1645 Sheely Drive
;   Fort Collins, CO 80526 USA
;   Phone: 970-221-0438
;   E-mail: davidf@dfanning.com
;   Coyote's Guide to IDL Programming: http://www.dfanning.com/

; CATEGORY:

;    Utility.

; CALLING SEQUENCE:

;    ok = Error_Message(the_Error_Message)

; INPUTS:

;    the_Error_Message: This is a string argument containing the error
;       message you want reported. If undefined, this variable is set
;       to the string in the !Error_State.Msg system variable.

; KEYWORDS:

;    ERROR: Set this keyword to cause Dialog_Message to use the ERROR
;       reporting dialog. Note that a bug in IDL causes the ERROR dialog
;       to be used whether this keyword is set to 0 or 1!

;    INFORMATIONAL: Set this keyword to cause Dialog_Message to use the
;       INFORMATION dialog instead of the WARNING dialog. Note that a bug
;       in IDL causes the ERROR dialog to be used if this keyword is set to 0!

;    TITLE: Set this keyword to the title of the DIALOG_MESSAGE window. By
;       default the keyword is set to 'System Error' unless !ERROR_STATE.NAME
;       equals "IDL_M_USER_ERR", in which case it is set to "Trapped Error'.

;    TRACEBACK: Setting this keyword results in an error traceback
;       being printed to standard output with the PRINT command. Set to
;       1 (ON) by default. Use TRACEBACK=0 to turn this functionality off.

; OUTPUTS:

;    Currently the only output from the function is the string "OK".

; RESTRICTIONS:

;    The WARNING Dialog_Message dialog is used by default.

; EXAMPLE:

;    To handle an undefined variable error:

;    IF N_Elements(variable) EQ 0 THEN $
;       ok = Error_Message('Variable is undefined', /Traceback)

; MODIFICATION HISTORY:

;    Written by: David W. Fanning, 27 April 1999.
;    Added the calling routine's name in the message and NoName keyword. 31 Jan 2000. DWF.
;    Added _Extra keyword. 10 February 2000. DWF.
;    Forgot to add _Extra everywhere. Fixed for MAIN errors. 8 AUG 2000. DWF.
;    Adding call routine's name to Traceback Report. 8 AUG 2000. DWF.
;    Added ERROR, INFORMATIONAL, and TITLE keywords. 19 SEP 2002. DWF.
;    Removed the requirement that you use the NONAME keyword with the MESSAGE
;      command when generating user-trapped errors. 19 SEP 2002. DWF.
;    Added distinctions between trapped errors (errors generated with the
;      MESSAGE command) and IDL system errors. Note that if you call ERROR_MESSAGE
;      directly, then the state of the !ERROR_STATE.NAME variable is set
;      to the *last* error generated. It is better to access ERROR_MESSAGE
;      indirectly in a Catch error handler from the MESSAGE command. 19 SEP 2002. DWF.
;    Change on 19 SEP 2002 to eliminate NONAME requirement did not apply to object methods.
;      Fixed program to also handle messages from object methods. 30 JULY 2003. DWF.
;-
;###########################################################################

; LICENSE

; This software is OSI Certified Open Source Software.
; OSI Certified is a certification mark of the Open Source Initiative.

; Copyright � 1999-2003 Fanning Software Consulting

; This software is provided "as-is", without any express or
; implied warranty. In no event will the authors be held liable
; for any damages arising from the use of this software.

; Permission is granted to anyone to use this software for any
; purpose, including commercial applications, and to alter it and
; redistribute it freely, subject to the following restrictions:

; 1. The origin of this software must not be misrepresented; you must
;    not claim you wrote the original software. If you use this software
;    in a product, an acknowledgment in the product documentation
;    would be appreciated, but is not required.

; 2. Altered source versions must be plainly marked as such, and must
;    not be misrepresented as being the original software.

; 3. This notice may not be removed or altered from any source distribution.

; For more information on Open Source Software, visit the Open Source
; web site: http://www.opensource.org.

;###########################################################################


FUNCTION ERROR_MESSAGE, theMessage, Error=error, Informational=information, $
    Traceback=traceback, NoName=noname, Title=title, _Extra=extra

On_Error, 2

; Check for presence and type of message.

IF N_Elements(theMessage) EQ 0 THEN theMessage = !Error_State.Msg
s = Size(theMessage)
messageType = s[s[0]+1]
IF messageType NE 7 THEN BEGIN
    Message, "The message parameter must be a string.", _Extra=extra
ENDIF

; Get the call stack and the calling routine's name.

Help, Calls=callStack
IF Float(!Version.Release) GE 5.2 THEN $
    callingRoutine = (StrSplit(StrCompress(callStack[1])," ", /Extract))[0] ELSE $
    callingRoutine = (Str_Sep(StrCompress(callStack[1])," "))[0]

; Are widgets supported?

widgetsSupported = ((!D.Flags AND 65536L) NE 0)
IF widgetsSupported THEN BEGIN

    ; If this is an error produced with the MESSAGE command, it is a trapped
    ; error and will have the name "IDL_M_USER_ERR".

    IF !ERROR_STATE.NAME EQ "IDL_M_USER_ERR" THEN BEGIN

        IF N_Elements(title) EQ 0 THEN title = 'Trapped Error'

        ; If the message has the name of the calling routine in it,
        ; it should be stripped out. Can you find a colon in the string?

        ; Is the calling routine an object method? If so, special processing
        ; is required. Object methods will have two colons together.

        doublecolon = StrPos(theMessage, "::")
        IF doublecolon NE -1 THEN BEGIN

            prefix = StrMid(theMessage, 0, doublecolon+2)
            submessage = StrMid(theMessage, doublecolon+2)
            colon = StrPos(submessage, ":")
            IF colon NE -1 THEN BEGIN

                ; Extract the text up to the colon. Is this the same as
                ; the callingRoutine? If so, strip it.

                IF StrMid(theMessage, 0, colon+StrLen(prefix)) EQ callingRoutine THEN $
                    theMessage = StrMid(theMessage, colon+1+StrLen(prefix))
            ENDIF
        ENDIF ELSE BEGIN

            colon = StrPos(theMessage, ":")
            IF colon NE -1 THEN BEGIN

                ; Extract the text up to the colon. Is this the same as
                ; the callingRoutine? If so, strip it.

                IF StrMid(theMessage, 0, colon) EQ callingRoutine THEN $
                    theMessage = StrMid(theMessage, colon+1)
            ENDIF

        ENDELSE


        ; Add the calling routine's name, unless NONAME is set.

        IF Keyword_Set(noname) THEN BEGIN
            answer = Dialog_Message(theMessage, Title=title, _Extra=extra, $
                Error=error, Information=information)
        ENDIF ELSE BEGIN
            answer = Dialog_Message(StrUpCase(callingRoutine) + ": " + $
                theMessage, Title=title, _Extra=extra, $
                Error=error, Information=information)
        ENDELSE

    ENDIF ELSE BEGIN

        ; Otherwise, this is an IDL system error.

        IF N_Elements(title) EQ 0 THEN title = 'System Error'

        IF StrUpCase(callingRoutine) EQ "$MAIN$" THEN $
            answer = Dialog_Message(theMessage, _Extra=extra, Title=title, $
            Error=error, Information=information) ELSE $
            IF Keyword_Set(noname) THEN BEGIN
            answer = Dialog_Message(theMessage, _Extra=extra, Title=title, $
                Error=error, Information=information)
        ENDIF ELSE BEGIN
            answer = Dialog_Message(StrUpCase(callingRoutine) + "--> " + $
                theMessage, _Extra=extra, Title=title, $
                Error=error, Information=information)
        ENDELSE
    ENDELSE
ENDIF ELSE BEGIN
    Message, theMessage, /Continue, /NoPrint, /NoName, /NoPrefix, _Extra=extra
    Print, '%' + callingRoutine + ': ' + theMessage
    answer = 'OK'
ENDELSE

; Provide traceback information if requested.

IF Keyword_Set(traceback) THEN BEGIN
    Help, /Last_Message, Output=traceback
    Print,''
    Print, 'Traceback Report from ' + StrUpCase(callingRoutine) + ':'
    Print, ''
    FOR j=0,N_Elements(traceback)-1 DO Print, "     " + traceback[j]
ENDIF

RETURN, answer
END ; ----------------------------------------------------------------------------


;*********************************************************************************
pro concatenate_QC_files,HorV,Method,pathnm;  this program reads in each small -
    ;2DS TC4 1Hz archived data, and make the big file to archive for Matlab program
    ; this program assume you have two data files to concatenate. if not,
    ;                       make a afke file first by copying.
    missing_data=[-9.99*1E+000]
    missing_data4=[fltarr(4)-9.99*1E+0]
    missing_data10=[fltarr(10)-9.99*1E+0]

    ;mytitle=[ ['Please input a string to choose:'],$
    ;          ['H1,H4,V1 or V4: for combine smaller H_archive_2DS_PSD*.txt files into a Big file.']]

    ;get all smaller data files.
    if method eq 'M1' then begin
        ;filenames = dialog_pickfile(title='pls pick a Dir & Click a file',filter='H_archive_2ds_PSD*M1.txt',Get_path=pathnm)
        filter_str=HorV+'_Archive_*2DS_PSD*M1*QC.txt'
        get_all_data_filenames,filter_str,pathnm,filenames,file_count
    endif


    if file_count eq 0 then return
    ; open the first data file; for appending.
    filename=filenames(0)
    read_in_2ds_data_from_small_1Hz_QC_files,TDsData,pathnm,filename
    ;assign TDSdata.irregular to be adding 0.5 for first point and last point.
    ; which is done in the read_in_2ds_from_1Hz_archive file.
    ;yyyymmdd='20'+strmid(file_basename(filename),18,6);  % basename= V_Archive_2DS_PSD_100119234142_000000_001351_0000_M1.txt


    substrs=strsplit(filename,'_',/extract)
    yyyymmdd='20'+strmid(substrs(4),0,6);  % basename= V_Archive_2DS_PSD_100119234142_000000_001351_0000_M1.txt
    defsysv,'!yyyymmdd',yyyymmdd
    ;yyyymmdd='20'+strmid(file_basename(filename),18,6);  % basename= V_Archive_2DS_PSD_100119234142_000000_001351_0000_M1.txt
    !first_file_day=yyyymmdd*1L


    last_second  =max(TDSdata.seconds); get the last seconds of the first file.
    first_time   =min(TDSdata.seconds)

    todays_date=strsplit(systime(),' ',/extract)
    archive_date=todays_date(1)+' '+todays_date(2)+' '+todays_date(4)

    outfilename=pathnm+!Project_name+'_'+!Platform+'_2DS_'+!yyyymmdd+horV+'_'+Method+'_QC.txt';  ;;  method eq  M1 or M4 in here.

    basefilename=file_basename(filename(0))
    subtrs=strsplit(basefilename,'_',/extract)
    yymmddhhmmss_str=subtrs(4)
    year_str ='20'+strmid(yymmddhhmmss_str,0,2)
    month_str=strmid(yymmddhhmmss_str,2,2)
    day_str  =strmid(yymmddhhmmss_str,4,2)
    yyyymmdd=year_str+month_str+day_str

    todays_date=strsplit(systime(),' ',/extract)
    archive_date=todays_date(1)+' '+todays_date(2)+' '+todays_date(4)

    openw,1,outfilename
    printf,1,'Project:'+!project_name+' '+!platform +'  SPEC INC  2DS  '+HorV+'-channel QC data. 3022 Sterling Circle Ste 200, Boulder, CO 80301.  Paul Lawson, plawson@specinc.com.'
    printf,1,'Flight xx.  Data Date: 2013 ' + month_str+' '+day_str+ ' Concatenate date:'+archive_date
    printf,1,'Time, ovld Overld   maskdead  badtype1 badtype2 badtype3 Total   SampleV SV.adj TAS Total  Fake.N Part.N rejct# accpt# Concentration overld_dead total_Dead  Dead_L1  '
    printf,1,'secs,  #/s DeadTime  seconds   seconds  seconds seconds DeadTime (Liter) factor m/s events area<0 area>0 counts counts    (#/L)        (ticks)     (ticks)   (ticks)  '

    mmm=n_elements(TDSdata.seconds)
    ;*************************************************************************
    ; do the following according to Brad request ***********************
    ; 1) when file1 ends at 5, 6, file2 starts at 5,6. chop file1's tail and file2's head.
    ; 2) when flie1 end at 6 and file2 starts at 6. archive the values
    ;     of the one that has greater extinction [also add 0.5 to irregularities
    ;     variable for this second].
    ; 3) when file1 end at 6, file2 starts at 7 , then, fine. but add 0.5 to
    ;    irregularities variable for the edge seconds].
    ; 4) when there is a gap between the files, archive -999s for the gap
    ;    [also add 0.5 to irregularities variable for the edge seconds].
    ; 5)  Finally when there are  more overlap than expected (2 seconds)
    ;     then stop the program and tell the user to send the case to you
    ;     and Brad. and use manual truncation method to do teh concatenation.
    ; To summary it, it is like this:
    ;          if a(0) eq b(0) then case1to5=1;  overlap 2 seconds only. a=[5,6],b=[5,6]
    ;          if a(1) eq b(0) then case1to5=2;  overlap 1 second only.  a=[5,6],b=[6,7]
    ;          if a(1)+1 eq b(0) then case1to5=3; only touch each other. a=[5,6],b=[7,8]
    ;          if b(0) gt  a(1)+1 then case1to5=4; there is a gap        a=[5,6],b=[8,9]
    ;          if b(0) le a(0)-1 then case1to5=5;  overlap too much.     a=[5,6],b=[4,5]
    ; note the the first and last points irregualer can alwasy be adding 0.5,it does not matters
    ; to the writen archive file. If it is use, it should be added 0.5.
    if file_count eq 1 then begin
        index1=0LL;    don't Truncate the first second
        index2=mmm-1LL; don't truncate last second mmm-1 and wait until later to see waht to do with it.
        write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
        close,1
        print,'Done rewriting steve gaines file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'
        return
    endif
    ;***************** do the first files writing ***********************

    Timewriten=TDSdata(0).seconds-1LL
    kkk=1
    while kkk lt file_count do begin
        FileNameNext=filenames(kkk)
        get_next_files_starttime_and_endTime_QC,fileNameNext,pathnm,startTimeNext,EndTimeNext,$
            TDsdata,TDsdataNext,case1to5,last2S, First2S

        mmm=n_elements(TDSdata.seconds)
        ;index1=1LL;    Truncate the first second
        ;index2=mmm-2LL; truncate last second mmm-1 and wait until later to see waht to do with it.
        ;write_data_to_archive_file_from_index1_to_index2,TDSData,index1,index2
        ;***************************************************************************************


        if  !first_file_day ne !this_file_day then begin
            print,'first_file_day=', !first_file_day,'   !this_file_day=',!this_file_day
        endif


        print,'file_',kkk-1,'"s endTime    last 2 seconds are:', last2S(0), '   ',last2S(1)
        print,'file_',kkk,  '"s startTime first 2 seconds are:', First2S(0), '   ',First2S(1)

        ;*****************************************************************************
        if case1to5 eq 1 then begin;kkk=1; begin writing the first file's data TDSdata until next file' begin Time.
            StartTime=(Timewriten+1LL);     -------overlap 2 seconds only. a=[5,6],b=[5,6]
            index1=min(where(TDSdata.seconds eq StartTime))
            mmm=n_elements(TDSdata.seconds)
            index2=mmm-2LL

            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
            print,'File',Kkk-1,'"s data points are writen.--------xxxxxxx--------------------',$
                TDSdata(index1).seconds,'--',TDSdata(index2).seconds
            Timewriten=TDSdata(index2).seconds

        endif
        ;**************************************************************************************
        ;          if a(0) eq b(0) then case1to5=1;  overlap 2 seconds only. a=[5,6],b=[5,6]
        ;          if a(1) eq b(0) then case1to5=2;  overlap 1 second only.  a=[5,6],b=[6,7]
        ;          if a(1)+1 eq b(0) then case1to5=3; only touch each other. a=[5,6],b=[7,8]

        ;*****************************************************************************************
        if case1to5 eq 2 then begin; there is overlap of only 1 second's data. compare which one has
            mmm=n_elements(TDSdata.seconds);;  the biggest extinction.

            StartTime=(Timewriten+1LL)
            index1=min(where(TDSdata.seconds eq StartTime))
            index2=n_elements(TDSdata.seconds)-2LL

            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
            print, 'file',kkk-1,'"s data points are writen------xxxxxxxxx-----------------',$
                TDSdata(index1).seconds,'--',TDSdata(index2).seconds
            timewriten=TDSDATA(index2).seconds

        endif
        ;**************************************************************************************

        if case1to5 eq 3 then begin;   two files just touch each other.
            ;write this files last point.           case1to5=3; only touch each other. a=[5,6],b=[7,8]
            StartTime=(Timewriten+1LL)
            index1=min(where(TDSdata.seconds eq StartTime))
            mmm=n_elements(TDSdata.seconds)
            index2=mmm-1LL

            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
            print,'file',kkk-1,'"s last point is writen',TDSdata(index2).seconds
            print,'file',kkk,'"s data first and last points are writen-----xxxxxxxxxxxxxxxxx-',$
                TDSdataNext(0).seconds,'--',max(TDSdataNext.seconds)
            timewriten=TDSDATA(index2).seconds
        endif
        ;**************************************************************************************
        ;         if b(0) gt  a(1)+1 then case1to5=4; there is a gap        a=[5,6],b=[8,9]
        if case1to5 eq 4 then begin;  there is gap between two files.
            ;1. write this files last point.
            ;2. write missing data
            ;3  write next files point 0 to near last point.
            StartTime=(Timewriten+1LL)
            index1=min(where(TDSdata.seconds eq StartTime))
            mmm=n_elements(TDSdata.seconds)
            index2=mmm-1LL

            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
            print,'file',kkk-1,'"s last point is writen',TDSdata(index2).seconds
            print,' writting missing data in the gap  tooo........'

            time1=TDSdata(index2).seconds+1LL
            time2=min(TDSdataNext.seconds)-1LL

            write_missing_data_from_time1_to_time2_QC,time1,time2
            timewriten=time2
            print,'file',kkk,'"s  data points first two points are---------',$
                TDSdataNext(0).seconds,'--',TDSdataNext(1).seconds


        endif
        ;**************************************************************************************

        ;           if b(0) le a(0)-1 then case1to5=5;  overlap too much.     a=[5,6],b=[4,5]
        if case1to5 eq 5 then begin
            print, 'Two files overlap too much. Manually delete some parts on either file,'
            print, 'and start again, or report this to Qixu Mo and Brad Baker !!!!'
            print,filenameNext
            StartTime=(Timewriten+1LL)
            index1=min(where(TDSdata.seconds eq StartTime))
            index2=min(where(TDSdata.seconds eq TDSdataNext(0).seconds))
            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
            timewriten =TDSdata(index2).seconds
        endif
        ;***************************************************************
        TDSdata=TDSdataNext;  update the data and start again
        kkk=kkk+1
    endwhile
    ; write the last file's data to the data file.
    index=where(TDSdata.seconds gt timewriten,contGG)
    if contGG gt 0 then begin
        index1=index(0)
        StartTime=TDSdata(index1).seconds

        if StartTime-timewriten eq 1 then begin
            index2=n_elements(TDSdata.seconds)-1
            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
        endif else begin
            ; write out the missing data  Starting from Timewriten+1 second  to (StartTime-1) second.
            Time1 =timewriten+1
            Time2 =StartTime-1
            write_missing_data_from_time1_to_time2,time1,time2
            ; write out the last file data from StartTime to end.
            index2=n_elements(TDSdata.seconds)-1
            write_data_to_archive_file_from_index1_to_index2_QC,TDSData,index1,index2
        endelse
    endif;  if last file's time nothing greater than Timewrite,  no need to write the last file.
    close,1
    print,'Done rewriting QC file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!'

    ;Ok, SO far the Hconc, Hypts Hextn, Hmass agrees with 2dsview comp_psd results.
end; end of combine_Rico_archive_files_of_61bins
;**********************************************************************************************


pro read_in_2ds_data_from_small_1Hz_QC_files,TDsData,pathnm,filename
    ;filename=dialog_pickfile(filter='Archive_2DS_*Ns.txt',get_path=pathnm)
    ;find out how many line is in the file.

    ;get the first hours to see if the file is after-midnight or before midnight.
    basefile=file_basename(filename)
    hh=strmid(basefile,31,2)

    if hh*1 ge 24.0 then begin
        print,'This file is after mindnight, ',basefile
        offset_seconds=86400LL
        stop
    endif else begin
        offset_seconds=0LL
    endelse


    data=read_ascii(filename,count=n_lines)
    nnnseconds=(n_lines-2)
    junk=strarr(2)
    openr,2,filename
    readf,2,junk

    Data={seconds:0LL,ovldcnts:0,ovfl_deadtime:0.0,maskdeadtime:0.0,Bad1Deadtime:0.0,bad2deadtime:0.0,Bad3deadtime:0.0,$
        totaldeadTime:0.0,sampleVolume:0.0,adjustmentfactorH:0.0,ThisTAS:0.0,  Htot_event:0.0, HNareaLe0:0.0, HNareaGT0:0.0,HNrejected:0.0, $
        HNaccepted:0.0, Hconc:0.0,DT_ovfl:0.0,total_accDeadTime:0.0,DT_L1:0.0  }

    if nnnseconds eq 0 then begin
        r=dialog_message(' Data File:'+filename+' has no data, something is wrong, fix that to start over !',/information)
        exit
    endif

    TDsData=replicate(data,nnnseconds)
    readf,2,TDsData
    close,2

    TDSdata.seconds=TDSdata.seconds+offset_seconds;   added on Jan. 22, 2010.

    substrs=strsplit(filename,'\',/extract)
    filename=substrs(n_elements(substrs)-1)

end; end of read_in_2ds_data_from_1Hz_QC_files.


pro make_61_bins,nbins,nedges,xpts,dbl_binwidths
    nbins=61
    nedges=2*nbins
    xpts=dblarr(2*nbins)
    xpts(0)=5.0
    for i =0, 19  DO BEGIN ; from 15, 15,25,25, ******205,205.
        xpts[2*i+1:2*i+2] =5.0+(i+1)*10.0
    endfor
    for i =20,34  DO BEGIN ; from 205 225, 245,265,285, *****485,485,505,505
        xpts[2*i+1:2*i+2] =205.0+(i-19)*20.0
    endfor

    for i =35,44  DO BEGIN ; from 555,555,605,606,*******1005,1005
        xpts[2*i+1:2*i+2] =505.0+(i-34)*50.0
    endfor

    for i =45,54  DO BEGIN ; from 1105,1105,*******2005,2005
        xpts[2*i+1:2*i+2] =1005.0+(i-44)*100.0
    endfor

    for i =55,59  DO BEGIN ; from 2205,2205,*******3005,3005
        xpts[2*i+1:2*i+2] =2005.0+(i-54)*200.0
    endfor
    xpts(121)=xpts(120)+200.0; to make last bin-width=200.0um
    dbl_binwidths=xpts(1:*)-xpts(0:120)
    dbl_binwidths=[dbl_binwidths,0.0]
    xpts(121)=3205.0;  100000.0;    but hin here group anything greater that 3005 to be the last bin.
    xpts(0) =5.0; 0.0001
end; end of make_61_bins


;***********

