; File:  pnger.pro
; Author:  Ted Fisher <Ted.Fisher@firestar-engineering.com>
; Purpose:  reads the current window and generates a png from it


pro pnger, filename, image=image, rotated=rotated

    if(n_params() eq 0) then begin
        print, " "
        print, "pnger, filename
        print, " "
        print, "  filename = the name of the output file to generate"
        print, "  pnger creates a png file from the active window"
        print, " "
        return
    endif

    if(not keyword_set(image)) then begin
        image = tvrd(/true)

        temp = image

    endif else begin
        temp = image
    endelse

    if(keyword_set(rotated)) then begin 
        temp[0,*,*] = rotate(reform(image[0,*,*]), 7)
        temp[1,*,*] = rotate(reform(image[1,*,*]), 7)
        temp[2,*,*] = rotate(reform(image[2,*,*]), 7)

        write_png, filename, temp  ; could maybe use temporary in the rotations above to save memory...
    endif else begin
        write_png, filename, image
    endelse

end ; pnger
