; File:  print_raw_hex_32.pro
; Author:  Ted Fisher <ted@specinc.com> <fishnuke@gmail.com>
; Purpose:  prints human readable 32 bit SPEC 2D-type timestamps in hex, in two formats


pro print_raw_hex_32, probecount_in
    ; debug utility to print the 32 bit probecounter in hex as well as in the raw file format hex, to aid finding the timestamp in the hex dump
    ; example:

    ; ulong64 value = 0x0F013445

    ; prints          01 0F 00 00

    ; byte order is swapped, but byte values are the same


    byte0 = ishft(probecount_in and ulong64('000000FF'X),   0)
    byte1 = ishft(probecount_in and ulong64('0000FF00'X),  -8)
    byte2 = ishft(probecount_in and ulong64('00FF0000'X), -16)
    byte3 = ishft(probecount_in and ulong64('FF000000'X), -24)

    print, format='(%"0x%016X    raw:    %02X %02X %02X %02X")', probecount_in, byte2, byte3, byte0, byte1
end ; print_raw_hex_32
