; File:  print_raw_hex_48.pro
; Author:  Ted Fisher <ted@specinc.com> <fishnuke@gmail.com>
; Purpose:  prints human readable 48 bit SPEC 3V-type timestamps in hex, in two formats


pro print_raw_hex_48, probecount_in
    ; debug utility to print the 48 bit probecounter in hex as well as in the raw file format hex, to aid finding the timestamp in the hex dump
    ; example:

    ; ulong64 value = 0x00000F013445

    ; prints         45 34 01 0F 00 00

    ; byte order is swapped, but byte values are the same


    byte0 = ishft(probecount_in and ulong64('0000000000FF'X),   0)
    byte1 = ishft(probecount_in and ulong64('00000000FF00'X),  -8)
    byte2 = ishft(probecount_in and ulong64('000000FF0000'X), -16)
    byte3 = ishft(probecount_in and ulong64('0000FF000000'X), -24)
    byte4 = ishft(probecount_in and ulong64('00FF00000000'X), -32)
    byte5 = ishft(probecount_in and ulong64('FF0000000000'X), -40)

    print, format='(%"0x%016X    raw:    %02X %02X %02X %02X %02X %02X")', probecount_in, byte0, byte1, byte2, byte3, byte4, byte5
end ; print_raw_hex_48
