; File:  printh.pro
; Author:  Ted Fisher <ted@specinc.com> <fishnuke@gmail.com>
; Purpose:  prints out a variable as a 4 digit hex string, with a leading 0x

;   printh, 0

;   prints:  0x0000


;   printh, 42

;   prints: 0x002A

; wishlist:  make this function behave more like print



; 1.1 2014-09-21 updated with scaling the number of digits of output to the magnitude of the input, or an optional argument
; 1.0 initial version




pro printh, input, digits=digits

    ;    if(input lt 65535 and input gt -32767) then begin
    ;        print, format = '(%"0x%04X")', input
    ;    endif else begin
    ;        print, format = '(%"0x%08X")', input
    ;    endelse

    if(not keyword_set(digits)) then begin
        digits = 4
    endif

    count = n_elements(input)

    if(count eq 0) then begin
        print, 'empty input'
        ;endif else if(count eq 1) then begin
        ;    print, format = '(%"0x%016X")', input
    endif else begin
        ; determine whether to use 4, 8, or 16 digits for the output, and override with digits keyword if specified and large enough
        max_value = max(input)
        min_value = min(input)

        if(max_value lt 65536) then begin
            max_value_digits = 4
        endif else if(max_value lt 4294967296) then begin
            max_value_digits = 8
        endif else begin
            max_value_digits = 16
        endelse

        if(min_value lt -(2L^31-1)) then begin
            min_value_digits = 16
        endif else if(min_value lt -(2^15-1)) then begin
            min_value_digits = 8
        endif else begin
            min_value_digits = 4
        endelse

        output_digits = max_value_digits > min_value_digits
        output_digits = output_digits > digits

        if(output_digits eq 4) then begin
            output_format = '(%"0x%04X")'
        endif else if(output_digits eq 8) then begin
            output_format = '(%"0x%08X")'
        endif else begin
            output_format = '(%"0x%016X")'
        endelse

        for i=0, count-1 do begin
            print, format = output_format, input[i]
        endfor
    endelse

end ; printh


