pro Read_sorted_file;  by Mo Dec 26, 2006   just reading the sorted data file.

    inputfile=dialog_pickfile(filter='*sorted*.2ds')

    OpenR, lun, inputfile, /Get_Lun

    fileheader = bytarr(256)
    ReadU, lun, fileheader
    v_string = strmid(string(fileheader),4,4)
    reads, v_string, FORMAT='(%"%f")',cur_version
    if (cur_version ne 3.0) then begin
        ;stop
    endif

    struct2 = {_Timestamp, $
        Year: 0, $
        Month: 0, $
        Day: 0, $
        Hours: 0, $
        Minutes: 0, $
        Seconds: 0, $
        Milliseconds: 0, $
        Microseconds: 0, $
        Nanoseconds: 0 }

    NanosecondsPerSecond = 1000000000ULL
    NanosecondsPerMinute = NanosecondsPerSecond * 60ULL
    NanosecondsPerHour   = NanosecondsPerMinute * 60ULL

    DataType = 0  ; header of all record types is an integer with repeated letters
    TimingWord = UIntArr(2)
    StartTimingWord = UIntArr(2)
    EndTimingWord = UIntArr(2)
    Masks = UIntArr(16)
    HK_ints = UIntArr(48)   ; changed from 40->52 with version 5.0
    HK_timingwords = UIntArr(2)
    HK_TAS  = 0.0
    TAS = 0.0
    Tas_H=0.0
    Tas_V=0.0
    PartID = 0
    Slices = 0U
    WordCount =  0U
    Timestamp = { _Timestamp }
    HTimestamp = { _Timestamp }
    VTimestamp = { _Timestamp }
    StartTimestamp = { _Timestamp }
    EndTimestamp = { _Timestamp }
    pos = 0UL
    Area = 0UL
    Midpoint = 0
    Edges = 0
    pxs = 0.01
    pxs_in_microns = 10.0
    dww = !DWW_main; 63.0mm in 2D-S, 50.8 mm in 3V-CPI adjust in a3VCPIView.pro
    strbsz = 0.01
    Rollover = 0 ; 16 bit integer
    Rollover2= 0;  16 bit integer
    ProbeCount = 0uL ; 32 bit unsigned
    ProbeCount2 = 0uL ; 32 bit unsigned
    temp_64 = 0ULL ; 32 bit result
    OneRollover = 4294967296ULL  ; 2^32
    onebyte = 33B
    counter = 0L
    horiz_count=0LL

    WHILE ~ EOF(lun) DO BEGIN
        counter++
        ReadU, lun, DataType


        SWITCH DataType OF
            5156: $    ;this way all dummy_dead_times are assigned as mask_flags.
                print , "H Dummmy_deadtime_header"
            6425: $;   H_streaker_deadTime_header; no mre backup type anymore.
                begin
            if datatype eq 6425 then  print, 'H_streaker_DEADTIME_HEADER'
            ReadU, lun, StartTimestamp,EndTimestamp
            ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2

            AllMonths = StartTimestamp.Year * 12 + StartTimestamp.Month
            NanoSeconds = StartTimestamp.Nanoseconds + $
                (StartTimestamp.Microseconds * 1000ULL) + $
                (StartTimestamp.Milliseconds * 1000000ULL) + $
                (StartTimestamp.Seconds * NanosecondsPerSecond) + $
                (StartTimestamp.Minutes * NanosecondsPerMinute) + $
                (StartTimestamp.Hours * NanosecondsPerHour)
            break
        end  ; end of H-backup-deadtime particles.
        ;***********************************************************************************

        27756 :$   ; H_DEADTIME (0x6C6C)
            print , "H DEADTIME"
        7196 : $   ; H_MASK (0x1C1C)
            begin
        ReadU, lun, StartTimestamp,EndTimestamp
        ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
        AllMonths = StartTimestamp.Year * 12 + StartTimestamp.Month
        NanoSeconds = StartTimestamp.Nanoseconds + $
            (StartTimestamp.Microseconds * 1000ULL) + $
            (StartTimestamp.Milliseconds * 1000000ULL) + $
            (StartTimestamp.Seconds * NanosecondsPerSecond) + $
            (StartTimestamp.Minutes * NanosecondsPerMinute) + $
            (StartTimestamp.Hours * NanosecondsPerHour)
        if nanoseconds gt 74554000000000LL and nanoseconds le 74558000000000LL then begin
            print,'nanoseconds=', nanoseconds
            print,'datatype=',DataType
            ;stop
        endif
        break
    end ; end of H-dead_time and H-mask

    5140: $   ; V_DUMMY_DEADTIME_HEADER = &H1414 ' 5140 decimal
        print, 'V_DUMMY_DEADTIME_HEADER'
    6168: $;   H_streaker_deadTime_header; no mre backup type anymore.
        begin
    ReadU, lun,  StartTimestamp,EndTimestamp
    ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
    AllMonths = StartTimestamp.Year * 12 + StartTimestamp.Month
    NanoSeconds = StartTimestamp.Nanoseconds + $
        (StartTimestamp.Microseconds * 1000ULL) + $
        (StartTimestamp.Milliseconds * 1000000ULL) + $
        (StartTimestamp.Seconds * NanosecondsPerSecond) + $
        (StartTimestamp.Minutes * NanosecondsPerMinute) + $
        (StartTimestamp.Hours * NanosecondsPerHour)
    if nanoseconds gt 74554000000000LL and nanoseconds le 74558000000000LL then begin
        print,'nanoseconds=', nanoseconds
        print,'datatype=',DataType
        ;stop
    endif

    break
end; end of type1 and type1 V Bad Particles.
;----------------------------

31868 : $   ; V_DEADTIME (0x7C7C)
    if datatype eq 31868 then print, "V DEADTIME"  ; won't compile without some statement here
11308 : $   ; V_MASK (0x2C2C)
    begin
ReadU, lun,  StartTimestamp,EndTimestamp
ReadU, lun, Rollover,ProbeCount,ProbeCount2,rollover2
AllMonths = StartTimestamp.Year * 12 + StartTimestamp.Month
NanoSeconds = StartTimestamp.Nanoseconds + $
    (StartTimestamp.Microseconds * 1000ULL) + $
    (StartTimestamp.Milliseconds * 1000000ULL) + $
    (StartTimestamp.Seconds * NanosecondsPerSecond) + $
    (StartTimestamp.Minutes * NanosecondsPerMinute) + $
    (StartTimestamp.Hours * NanosecondsPerHour)
if nanoseconds gt 74554000000000LL and nanoseconds le 74558000000000LL then begin
    print,'nanoseconds=', nanoseconds
    print,'datatype=',DataType
    ;stop
endif

break
end

;----------------------------
19789 : $
    begin
ReadU, lun, TimingWord, Masks ; ;print , "MASK"
break
end

;----------------------------
16705 : $  ; TAS_HEADER_V
    print , "V TAS",TAS
;----------------------------
21588 : $  ; TAS_HEADER_H;  chris, is this the TAS change fake particle ? -104 ?
    BEGIN
ReadU, lun , TAS
ReadU, lun, StartTimestamp, Rollover,ProbeCount
AllMonths = StartTimestamp.Year * 12 + StartTimestamp.Month
NanoSeconds = StartTimestamp.Nanoseconds + $
    (StartTimestamp.Microseconds * 1000ULL) + $
    (StartTimestamp.Milliseconds * 1000000ULL) + $
    (StartTimestamp.Seconds * NanosecondsPerSecond) + $
    (StartTimestamp.Minutes * NanosecondsPerMinute) + $
    (StartTimestamp.Hours * NanosecondsPerHour)

if timestamp.hours eq 20 and timestamp.minutes eq 42 and timestamp.seconds eq 37 then begin
    print,'nanoseconds=', nanoseconds
    print,'datatype=',DataType
    ;stop
endif

break
END


;----------------------------
19275 : $  ; HK_HEADER
    BEGIN
ReadU, lun , HK_ints, HK_TAS, HK_timingwords
ReadU, lun, Rollover,ProbeCount
break
END

;----------------------------
18504 : $  ; H_PARTICLE_HEADER
    BEGIN
print, "2012-07-11 Mo said this was not used code in read_sorted_file.pro"
print, "the slices and words are read incorrectly, and bad fudge factors are assumed here"
print, "it needs to be fixed if it is in use, and deleted if not"
stop
ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount


; Slices is the number of words making up the image (can be more than the WordCount)
; WordCount is the true number of image slices
HTimestamp = Timestamp
if (WordCount GE 500) then begin
    ;print, "H WC=",Wordcount, info.TotalParticles
    WordCount = WordCount and 32767U
end

if (Wordcount gt 0 and Slices gt 0) then begin
    HImage = BytArr(WordCount * 2)
    HSums = IntArr(Slices)
    out_array = BytArr(16L * Slices)
    out_byte_array = BytArr(128L, Slices)
    HMax  = 0
endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, HImage

if (Slices LT 1000) then begin
    horiz_count++
endif else begin  ; endif of if slices Lt 1000.
    print, "Error H Slices =", Slices ,"  at ",counter
endelse

if timestamp.hours eq 10 and timestamp.minutes eq 42 and timestamp.seconds eq 33 then begin
    print,slices
    print,Himage
    print,timestamp.milliseconds
    ;stop
endif

break


END

;----------------------------
22102 : $  ; V_PARTICLE_HEADER
    BEGIN
ReadU, lun , PartID,WordCount,Slices,Timestamp
ReadU, lun, Rollover,ProbeCount

; Slices is the number of words making up the image (can be more than the WordCount)
; WordCount is the true number of image slices
VTimestamp = Timestamp
if (WordCount GE 500) then begin
    WordCount = WordCount and 32767U
end

;--------------------------------------------------------------------------------------
; We'd like (in 2DS executable) to trap all goofy particles before they are placed into the SORTED
;  file but as new DSP error or data transmission errors occur, we may miss some. So
;  we are forced to double check here. If the particle slice count or integer data word
;  couint is zero, we clearly cannot proceed to create zero length arrays. However,
;  we still need to read the image, if there is one. So we force Slices =1000 to avoid
;  doing processing that would crash this program, and we ignore this particle.
;--------------------------------------------------------------------------------------
if (Wordcount gt 0 and Slices gt 0) then begin
    VImage = BytArr(WordCount*2)
    VSums = IntArr(Slices)
    out_array = BytArr(16L * Slices)
    out_byte_array = BytArr(128L, Slices)
    VMax  = 0
endif else begin
    Slices = 1000
endelse

POINT_LUN, -lun, pos
ReadU, lun, VImage

if (Slices LT 1000) then begin

Endif

break

END ; end of V-header block.

;----------------------------
ELSE: begin ; if datatye of other than the above.  It should never reach here.
    POINT_LUN, -lun, badpos
    print , "Error, bad header in data file. Offset = ",badpos
    print, "value = ", DataType ; FLAG=0
    ;stop;   Chris said on Dec 22 that it will never be able to come to this point.
end
ENDSWITCH
if timestamp.hours eq 20 and timestamp.minutes eq 42 and timestamp.seconds eq 35 then begin
    NanoSeconds = Timestamp.Nanoseconds + $
        (Timestamp.Microseconds * 1000ULL) + $
        (Timestamp.Milliseconds * 1000000ULL) + $
        (Timestamp.Seconds * NanosecondsPerSecond) + $
        (Timestamp.Minutes * NanosecondsPerMinute) + $
        (Timestamp.Hours * NanosecondsPerHour)
    print,'nanoseconds=', nanoseconds
    print,'datatype=',DataType
    ;stop
endif

ENDWHILE

Close ,lun
Free_Lun, lun

end; Read_sorted_file
